/* Yet Another Forum.NET
 * Copyright (C) 2003-2005 Bjørnar Henden
 * Copyright (C) 2006-2013 Jaben Cargman
 * Copyright (C) 2014-2015 Ingo Herbote
 * http://www.yetanotherforum.net/
 * 
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at

 * http://www.apache.org/licenses/LICENSE-2.0

 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

using System.Collections.Concurrent;

namespace YAF.Utils.Helpers.StringUtils
{
	using System;
	using System.Collections.Concurrent;

	public static partial class Unidecoder
		{
        
        static ConcurrentDictionary<int, string[]> characters = new ConcurrentDictionary<int, string[]>(3,256);
        
				static Unidecoder()
				{
                        characters.TryAdd(0 /*0 00*/, new string[] {
				"\u0000" /*0000*/, "\u0001" /*0001*/, "\u0002" /*0002*/, "\u0003" /*0003*/, "\u0004" /*0004*/, "\u0005" /*0005*/, "\u0006" /*0006*/, "\u0007" /*0007*/, "\u0008" /*0008*/, "\u0009" /*0009*/, "\u000a" /*000a*/, "\u000b" /*000b*/, "\u000c" /*000c*/, "\u000d" /*000d*/, "\u000e" /*000e*/, "\u000f" /*000f*/, "\u0010" /*0010*/, "\u0011" /*0011*/, "\u0012" /*0012*/, "\u0013" /*0013*/, "\u0014" /*0014*/, "\u0015" /*0015*/, "\u0016" /*0016*/, "\u0017" /*0017*/, "\u0018" /*0018*/, "\u0019" /*0019*/, "\u001a" /*001a*/, "\u001b" /*001b*/, "\u001c" /*001c*/, "\u001d" /*001d*/, "\u001e" /*001e*/, "\u001f" /*001f*/, " " /*0020*/, "!" /*0021*/, "\"" /*0022*/, "#" /*0023*/, "$" /*0024*/, "%" /*0025*/, "&" /*0026*/, "'" /*0027*/, "(" /*0028*/, ")" /*0029*/, "*" /*002a*/, "+" /*002b*/, "," /*002c*/, "-" /*002d*/, "." /*002e*/, "/" /*002f*/, "0" /*0030*/, "1" /*0031*/, "2" /*0032*/, "3" /*0033*/, "4" /*0034*/, "5" /*0035*/, "6" /*0036*/, "7" /*0037*/, "8" /*0038*/, "9" /*0039*/, ":" /*003a*/, ";" /*003b*/, "<" /*003c*/, "=" /*003d*/, ">" /*003e*/, "?" /*003f*/, "@" /*0040*/, "A" /*0041*/, "B" /*0042*/, "C" /*0043*/, "D" /*0044*/, "E" /*0045*/, "F" /*0046*/, "G" /*0047*/, "H" /*0048*/, "I" /*0049*/, "J" /*004a*/, "K" /*004b*/, "L" /*004c*/, "M" /*004d*/, "N" /*004e*/, "O" /*004f*/, "P" /*0050*/, "Q" /*0051*/, "R" /*0052*/, "S" /*0053*/, "T" /*0054*/, "U" /*0055*/, "V" /*0056*/, "W" /*0057*/, "X" /*0058*/, "Y" /*0059*/, "Z" /*005a*/, "]" /*005b*/, "\\" /*005c*/, "]" /*005d*/, "^" /*005e*/, "_" /*005f*/, "`" /*0060*/, "a" /*0061*/, "b" /*0062*/, "c" /*0063*/, "d" /*0064*/, "e" /*0065*/, "f" /*0066*/, "g" /*0067*/, "h" /*0068*/, "i" /*0069*/, "j" /*006a*/, "k" /*006b*/, "l" /*006c*/, "m" /*006d*/, "n" /*006e*/, "o" /*006f*/, "p" /*0070*/, "q" /*0071*/, "r" /*0072*/, "s" /*0073*/, "t" /*0074*/, "u" /*0075*/, "v" /*0076*/, "w" /*0077*/, "x" /*0078*/, "y" /*0079*/, "z" /*007a*/, "{" /*007b*/, "|" /*007c*/, "}" /*007d*/, "~" /*007e*/, "" /*007f*/, "" /*0080*/, "" /*0081*/, "" /*0082*/, "" /*0083*/, "" /*0084*/, "" /*0085*/, "" /*0086*/, "" /*0087*/, "" /*0088*/, "" /*0089*/, "" /*008a*/, "" /*008b*/, "" /*008c*/, "" /*008d*/, "" /*008e*/, "" /*008f*/, "" /*0090*/, "" /*0091*/, "" /*0092*/, "" /*0093*/, "" /*0094*/, "" /*0095*/, "" /*0096*/, "" /*0097*/, "" /*0098*/, "" /*0099*/, "" /*009a*/, "" /*009b*/, "" /*009c*/, "" /*009d*/, "" /*009e*/, "" /*009f*/, " " /*00a0*/, "!" /*00a1*/, "C/" /*00a2*/, "PS" /*00a3*/, "$?" /*00a4*/, "Y=" /*00a5*/, "|" /*00a6*/, "SS" /*00a7*/, "\"" /*00a8*/, "(c)" /*00a9*/, "a" /*00aa*/, "<<" /*00ab*/, "!" /*00ac*/, "" /*00ad*/, "(r)" /*00ae*/, "-" /*00af*/, "deg" /*00b0*/, "+-" /*00b1*/, "2" /*00b2*/, "3" /*00b3*/, "'" /*00b4*/, "u" /*00b5*/, "P" /*00b6*/, "*" /*00b7*/, "," /*00b8*/, "1" /*00b9*/, "o" /*00ba*/, ">>" /*00bb*/, "1/4" /*00bc*/, "1/2" /*00bd*/, "3/4" /*00be*/, "?" /*00bf*/, "A" /*00c0*/, "A" /*00c1*/, "A" /*00c2*/, "A" /*00c3*/, "A" /*00c4*/, "A" /*00c5*/, "AE" /*00c6*/, "C" /*00c7*/, "E" /*00c8*/, "E" /*00c9*/, "E" /*00ca*/, "E" /*00cb*/, "I" /*00cc*/, "I" /*00cd*/, "I" /*00ce*/, "I" /*00cf*/, "D" /*00d0*/, "N" /*00d1*/, "O" /*00d2*/, "O" /*00d3*/, "O" /*00d4*/, "O" /*00d5*/, "O" /*00d6*/, "x" /*00d7*/, "O" /*00d8*/, "U" /*00d9*/, "U" /*00da*/, "U" /*00db*/, "U" /*00dc*/, "U" /*00dd*/, "Th" /*00de*/, "ss" /*00df*/, "a" /*00e0*/, "a" /*00e1*/, "a" /*00e2*/, "a" /*00e3*/, "a" /*00e4*/, "a" /*00e5*/, "ae" /*00e6*/, "c" /*00e7*/, "e" /*00e8*/, "e" /*00e9*/, "e" /*00ea*/, "e" /*00eb*/, "i" /*00ec*/, "i" /*00ed*/, "i" /*00ee*/, "i" /*00ef*/, "d" /*00f0*/, "n" /*00f1*/, "o" /*00f2*/, "o" /*00f3*/, "o" /*00f4*/, "o" /*00f5*/, "o" /*00f6*/, "/" /*00f7*/, "o" /*00f8*/, "u" /*00f9*/, "u" /*00fa*/, "u" /*00fb*/, "u" /*00fc*/, "y" /*00fd*/, "th" /*00fe*/, "y" /*00ff*/ 
			});
						characters.TryAdd(1 /*256 01*/, new string[] {
				"A" /*0100*/, "a" /*0101*/, "A" /*0102*/, "a" /*0103*/, "A" /*0104*/, "a" /*0105*/, "C" /*0106*/, "c" /*0107*/, "C" /*0108*/, "c" /*0109*/, "C" /*010a*/, "c" /*010b*/, "C" /*010c*/, "c" /*010d*/, "D" /*010e*/, "d" /*010f*/, "D" /*0110*/, "d" /*0111*/, "E" /*0112*/, "e" /*0113*/, "E" /*0114*/, "e" /*0115*/, "E" /*0116*/, "e" /*0117*/, "E" /*0118*/, "e" /*0119*/, "E" /*011a*/, "e" /*011b*/, "G" /*011c*/, "g" /*011d*/, "G" /*011e*/, "g" /*011f*/, "G" /*0120*/, "g" /*0121*/, "G" /*0122*/, "g" /*0123*/, "H" /*0124*/, "h" /*0125*/, "H" /*0126*/, "h" /*0127*/, "I" /*0128*/, "i" /*0129*/, "I" /*012a*/, "i" /*012b*/, "I" /*012c*/, "i" /*012d*/, "I" /*012e*/, "i" /*012f*/, "I" /*0130*/, "i" /*0131*/, "IJ" /*0132*/, "" /*0133*/, "J" /*0134*/, "j" /*0135*/, "K" /*0136*/, "k" /*0137*/, "k" /*0138*/, "L" /*0139*/, "l" /*013a*/, "L" /*013b*/, "l" /*013c*/, "L" /*013d*/, "l" /*013e*/, "L" /*013f*/, "l" /*0140*/, "L" /*0141*/, "l" /*0142*/, "N" /*0143*/, "n" /*0144*/, "N" /*0145*/, "n" /*0146*/, "N" /*0147*/, "n" /*0148*/, "'n" /*0149*/, "ng" /*014a*/, "NG" /*014b*/, "O" /*014c*/, "o" /*014d*/, "O" /*014e*/, "o" /*014f*/, "O" /*0150*/, "o" /*0151*/, "OE" /*0152*/, "oe" /*0153*/, "R" /*0154*/, "r" /*0155*/, "R" /*0156*/, "r" /*0157*/, "R" /*0158*/, "r" /*0159*/, "S" /*015a*/, "s" /*015b*/, "S" /*015c*/, "s" /*015d*/, "S" /*015e*/, "s" /*015f*/, "S" /*0160*/, "s" /*0161*/, "T" /*0162*/, "t" /*0163*/, "T" /*0164*/, "t" /*0165*/, "T" /*0166*/, "t" /*0167*/, "U" /*0168*/, "u" /*0169*/, "U" /*016a*/, "u" /*016b*/, "U" /*016c*/, "u" /*016d*/, "U" /*016e*/, "u" /*016f*/, "U" /*0170*/, "u" /*0171*/, "U" /*0172*/, "u" /*0173*/, "W" /*0174*/, "w" /*0175*/, "Y" /*0176*/, "y" /*0177*/, "Y" /*0178*/, "Z" /*0179*/, "z" /*017a*/, "Z" /*017b*/, "z" /*017c*/, "Z" /*017d*/, "z" /*017e*/, "s" /*017f*/, "b" /*0180*/, "B" /*0181*/, "B" /*0182*/, "b" /*0183*/, "6" /*0184*/, "6" /*0185*/, "O" /*0186*/, "C" /*0187*/, "c" /*0188*/, "D" /*0189*/, "D" /*018a*/, "D" /*018b*/, "d" /*018c*/, "d" /*018d*/, "3" /*018e*/, "@" /*018f*/, "E" /*0190*/, "F" /*0191*/, "f" /*0192*/, "G" /*0193*/, "G" /*0194*/, "hv" /*0195*/, "I" /*0196*/, "I" /*0197*/, "K" /*0198*/, "k" /*0199*/, "l" /*019a*/, "l" /*019b*/, "W" /*019c*/, "N" /*019d*/, "n" /*019e*/, "O" /*019f*/, "O" /*01a0*/, "o" /*01a1*/, "OI" /*01a2*/, "oi" /*01a3*/, "P" /*01a4*/, "p" /*01a5*/, "YR" /*01a6*/, "2" /*01a7*/, "2" /*01a8*/, "SH" /*01a9*/, "sh" /*01aa*/, "t" /*01ab*/, "T" /*01ac*/, "t" /*01ad*/, "T" /*01ae*/, "U" /*01af*/, "u" /*01b0*/, "Y" /*01b1*/, "V" /*01b2*/, "Y" /*01b3*/, "y" /*01b4*/, "Z" /*01b5*/, "z" /*01b6*/, "ZH" /*01b7*/, "ZH" /*01b8*/, "zh" /*01b9*/, "zh" /*01ba*/, "2" /*01bb*/, "5" /*01bc*/, "5" /*01bd*/, "ts" /*01be*/, "w" /*01bf*/, "|" /*01c0*/, "||" /*01c1*/, "|=" /*01c2*/, "!" /*01c3*/, "DZ" /*01c4*/, "Dz" /*01c5*/, "dz" /*01c6*/, "LJ" /*01c7*/, "Lj" /*01c8*/, "lj" /*01c9*/, "NJ" /*01ca*/, "Nj" /*01cb*/, "nj" /*01cc*/, "A" /*01cd*/, "a" /*01ce*/, "I" /*01cf*/, "i" /*01d0*/, "O" /*01d1*/, "o" /*01d2*/, "U" /*01d3*/, "u" /*01d4*/, "U" /*01d5*/, "u" /*01d6*/, "U" /*01d7*/, "u" /*01d8*/, "U" /*01d9*/, "u" /*01da*/, "U" /*01db*/, "u" /*01dc*/, "@" /*01dd*/, "A" /*01de*/, "a" /*01df*/, "A" /*01e0*/, "a" /*01e1*/, "AE" /*01e2*/, "ae" /*01e3*/, "G" /*01e4*/, "g" /*01e5*/, "G" /*01e6*/, "g" /*01e7*/, "K" /*01e8*/, "k" /*01e9*/, "O" /*01ea*/, "o" /*01eb*/, "O" /*01ec*/, "o" /*01ed*/, "ZH" /*01ee*/, "zh" /*01ef*/, "j" /*01f0*/, "DZ" /*01f1*/, "D" /*01f2*/, "dz" /*01f3*/, "G" /*01f4*/, "g" /*01f5*/, "HV" /*01f6*/, "W" /*01f7*/, "N" /*01f8*/, "n" /*01f9*/, "A" /*01fa*/, "a" /*01fb*/, "AE" /*01fc*/, "ae" /*01fd*/, "O" /*01fe*/, "o" /*01ff*/ 
			});
						characters.TryAdd(2 /*512 02*/, new string[] {
				"A" /*0200*/, "a" /*0201*/, "A" /*0202*/, "a" /*0203*/, "E" /*0204*/, "e" /*0205*/, "E" /*0206*/, "e" /*0207*/, "I" /*0208*/, "i" /*0209*/, "I" /*020a*/, "i" /*020b*/, "O" /*020c*/, "o" /*020d*/, "O" /*020e*/, "o" /*020f*/, "R" /*0210*/, "r" /*0211*/, "R" /*0212*/, "r" /*0213*/, "U" /*0214*/, "u" /*0215*/, "U" /*0216*/, "u" /*0217*/, "S" /*0218*/, "s" /*0219*/, "T" /*021a*/, "t" /*021b*/, "Y" /*021c*/, "y" /*021d*/, "H" /*021e*/, "h" /*021f*/, "[?]" /*0220*/, "[?]" /*0221*/, "OU" /*0222*/, "ou" /*0223*/, "Z" /*0224*/, "z" /*0225*/, "A" /*0226*/, "a" /*0227*/, "E" /*0228*/, "e" /*0229*/, "O" /*022a*/, "o" /*022b*/, "O" /*022c*/, "o" /*022d*/, "O" /*022e*/, "o" /*022f*/, "O" /*0230*/, "o" /*0231*/, "Y" /*0232*/, "y" /*0233*/, "[?]" /*0234*/, "[?]" /*0235*/, "[?]" /*0236*/, "[?]" /*0237*/, "[?]" /*0238*/, "[?]" /*0239*/, "[?]" /*023a*/, "[?]" /*023b*/, "[?]" /*023c*/, "[?]" /*023d*/, "[?]" /*023e*/, "[?]" /*023f*/, "[?]" /*0240*/, "[?]" /*0241*/, "[?]" /*0242*/, "[?]" /*0243*/, "[?]" /*0244*/, "[?]" /*0245*/, "[?]" /*0246*/, "[?]" /*0247*/, "[?]" /*0248*/, "[?]" /*0249*/, "[?]" /*024a*/, "[?]" /*024b*/, "[?]" /*024c*/, "[?]" /*024d*/, "[?]" /*024e*/, "[?]" /*024f*/, "a" /*0250*/, "a" /*0251*/, "a" /*0252*/, "b" /*0253*/, "o" /*0254*/, "c" /*0255*/, "d" /*0256*/, "d" /*0257*/, "e" /*0258*/, "@" /*0259*/, "@" /*025a*/, "e" /*025b*/, "e" /*025c*/, "e" /*025d*/, "e" /*025e*/, "j" /*025f*/, "g" /*0260*/, "g" /*0261*/, "g" /*0262*/, "g" /*0263*/, "u" /*0264*/, "Y" /*0265*/, "h" /*0266*/, "h" /*0267*/, "i" /*0268*/, "i" /*0269*/, "I" /*026a*/, "l" /*026b*/, "l" /*026c*/, "l" /*026d*/, "lZ" /*026e*/, "W" /*026f*/, "W" /*0270*/, "m" /*0271*/, "n" /*0272*/, "n" /*0273*/, "n" /*0274*/, "o" /*0275*/, "OE" /*0276*/, "O" /*0277*/, "F" /*0278*/, "R" /*0279*/, "R" /*027a*/, "R" /*027b*/, "R" /*027c*/, "r" /*027d*/, "r" /*027e*/, "R" /*027f*/, "R" /*0280*/, "R" /*0281*/, "s" /*0282*/, "S" /*0283*/, "j" /*0284*/, "S" /*0285*/, "S" /*0286*/, "t" /*0287*/, "t" /*0288*/, "U" /*0289*/, "U" /*028a*/, "v" /*028b*/, "^" /*028c*/, "W" /*028d*/, "Y" /*028e*/, "Y" /*028f*/, "z" /*0290*/, "z" /*0291*/, "Z" /*0292*/, "Z" /*0293*/, "?" /*0294*/, "?" /*0295*/, "?" /*0296*/, "C" /*0297*/, "@" /*0298*/, "B" /*0299*/, "E" /*029a*/, "G" /*029b*/, "H" /*029c*/, "j" /*029d*/, "k" /*029e*/, "L" /*029f*/, "q" /*02a0*/, "?" /*02a1*/, "?" /*02a2*/, "dz" /*02a3*/, "dZ" /*02a4*/, "dz" /*02a5*/, "ts" /*02a6*/, "tS" /*02a7*/, "tC" /*02a8*/, "fN" /*02a9*/, "ls" /*02aa*/, "lz" /*02ab*/, "WW" /*02ac*/, "]]" /*02ad*/, "[?]" /*02ae*/, "[?]" /*02af*/, "k" /*02b0*/, "h" /*02b1*/, "j" /*02b2*/, "r" /*02b3*/, "r" /*02b4*/, "r" /*02b5*/, "r" /*02b6*/, "w" /*02b7*/, "y" /*02b8*/, "'" /*02b9*/, "\"" /*02ba*/, "`" /*02bb*/, "'" /*02bc*/, "`" /*02bd*/, "`" /*02be*/, "'" /*02bf*/, "?" /*02c0*/, "?" /*02c1*/, "<" /*02c2*/, ">" /*02c3*/, "^" /*02c4*/, "V" /*02c5*/, "^" /*02c6*/, "V" /*02c7*/, "'" /*02c8*/, "-" /*02c9*/, "/" /*02ca*/, "\\" /*02cb*/, "," /*02cc*/, "_" /*02cd*/, "\\" /*02ce*/, "/" /*02cf*/, ":" /*02d0*/, "." /*02d1*/, "`" /*02d2*/, "'" /*02d3*/, "^" /*02d4*/, "V" /*02d5*/, "+" /*02d6*/, "-" /*02d7*/, "V" /*02d8*/, "." /*02d9*/, "@" /*02da*/, "," /*02db*/, "~" /*02dc*/, "\"" /*02dd*/, "R" /*02de*/, "X" /*02df*/, "G" /*02e0*/, "l" /*02e1*/, "s" /*02e2*/, "x" /*02e3*/, "?" /*02e4*/, "" /*02e5*/, "" /*02e6*/, "" /*02e7*/, "" /*02e8*/, "" /*02e9*/, "" /*02ea*/, "" /*02eb*/, "V" /*02ec*/, "=" /*02ed*/, "\"" /*02ee*/, "[?]" /*02ef*/, "[?]" /*02f0*/, "[?]" /*02f1*/, "[?]" /*02f2*/, "[?]" /*02f3*/, "[?]" /*02f4*/, "[?]" /*02f5*/, "[?]" /*02f6*/, "[?]" /*02f7*/, "[?]" /*02f8*/, "[?]" /*02f9*/, "[?]" /*02fa*/, "[?]" /*02fb*/, "[?]" /*02fc*/, "[?]" /*02fd*/, "[?]" /*02fe*/, 
			});
						characters.TryAdd(3 /*768 03*/, new string[] {
				"" /*0300*/, "" /*0301*/, "" /*0302*/, "" /*0303*/, "" /*0304*/, "" /*0305*/, "" /*0306*/, "" /*0307*/, "" /*0308*/, "" /*0309*/, "" /*030a*/, "" /*030b*/, "" /*030c*/, "" /*030d*/, "" /*030e*/, "" /*030f*/, "" /*0310*/, "" /*0311*/, "" /*0312*/, "" /*0313*/, "" /*0314*/, "" /*0315*/, "" /*0316*/, "" /*0317*/, "" /*0318*/, "" /*0319*/, "" /*031a*/, "" /*031b*/, "" /*031c*/, "" /*031d*/, "" /*031e*/, "" /*031f*/, "" /*0320*/, "" /*0321*/, "" /*0322*/, "" /*0323*/, "" /*0324*/, "" /*0325*/, "" /*0326*/, "" /*0327*/, "" /*0328*/, "" /*0329*/, "" /*032a*/, "" /*032b*/, "" /*032c*/, "" /*032d*/, "" /*032e*/, "" /*032f*/, "" /*0330*/, "" /*0331*/, "" /*0332*/, "" /*0333*/, "" /*0334*/, "" /*0335*/, "" /*0336*/, "" /*0337*/, "" /*0338*/, "" /*0339*/, "" /*033a*/, "" /*033b*/, "" /*033c*/, "" /*033d*/, "" /*033e*/, "" /*033f*/, "" /*0340*/, "" /*0341*/, "" /*0342*/, "" /*0343*/, "" /*0344*/, "" /*0345*/, "" /*0346*/, "" /*0347*/, "" /*0348*/, "" /*0349*/, "" /*034a*/, "" /*034b*/, "" /*034c*/, "" /*034d*/, "" /*034e*/, "[?]" /*034f*/, "[?]" /*0350*/, "[?]" /*0351*/, "[?]" /*0352*/, "[?]" /*0353*/, "[?]" /*0354*/, "[?]" /*0355*/, "[?]" /*0356*/, "[?]" /*0357*/, "[?]" /*0358*/, "[?]" /*0359*/, "[?]" /*035a*/, "[?]" /*035b*/, "[?]" /*035c*/, "[?]" /*035d*/, "[?]" /*035e*/, "[?]" /*035f*/, "" /*0360*/, "" /*0361*/, "" /*0362*/, "[?]" /*0363*/, "[?]" /*0364*/, "[?]" /*0365*/, "[?]" /*0366*/, "[?]" /*0367*/, "[?]" /*0368*/, "[?]" /*0369*/, "[?]" /*036a*/, "[?]" /*036b*/, "[?]" /*036c*/, "[?]" /*036d*/, "[?]" /*036e*/, "[?]" /*036f*/, "[?]" /*0370*/, "[?]" /*0371*/, "[?]" /*0372*/, "[?]" /*0373*/, "'" /*0374*/, "," /*0375*/, "[?]" /*0376*/, "[?]" /*0377*/, "[?]" /*0378*/, "[?]" /*0379*/, "" /*037a*/, "[?]" /*037b*/, "[?]" /*037c*/, "[?]" /*037d*/, "?" /*037e*/, "[?]" /*037f*/, "[?]" /*0380*/, "[?]" /*0381*/, "[?]" /*0382*/, "[?]" /*0383*/, "" /*0384*/, "" /*0385*/, "A" /*0386*/, ";" /*0387*/, "E" /*0388*/, "E" /*0389*/, "I" /*038a*/, "[?]" /*038b*/, "O" /*038c*/, "[?]" /*038d*/, "U" /*038e*/, "O" /*038f*/, "I" /*0390*/, "A" /*0391*/, "B" /*0392*/, "G" /*0393*/, "D" /*0394*/, "E" /*0395*/, "Z" /*0396*/, "E" /*0397*/, "Th" /*0398*/, "I" /*0399*/, "K" /*039a*/, "L" /*039b*/, "M" /*039c*/, "N" /*039d*/, "Ks" /*039e*/, "O" /*039f*/, "P" /*03a0*/, "R" /*03a1*/, "[?]" /*03a2*/, "S" /*03a3*/, "T" /*03a4*/, "U" /*03a5*/, "Ph" /*03a6*/, "Kh" /*03a7*/, "Ps" /*03a8*/, "O" /*03a9*/, "I" /*03aa*/, "U" /*03ab*/, "a" /*03ac*/, "e" /*03ad*/, "e" /*03ae*/, "i" /*03af*/, "u" /*03b0*/, "a" /*03b1*/, "b" /*03b2*/, "g" /*03b3*/, "d" /*03b4*/, "e" /*03b5*/, "z" /*03b6*/, "e" /*03b7*/, "th" /*03b8*/, "i" /*03b9*/, "k" /*03ba*/, "l" /*03bb*/, "m" /*03bc*/, "n" /*03bd*/, "x" /*03be*/, "o" /*03bf*/, "p" /*03c0*/, "r" /*03c1*/, "s" /*03c2*/, "s" /*03c3*/, "t" /*03c4*/, "u" /*03c5*/, "ph" /*03c6*/, "kh" /*03c7*/, "ps" /*03c8*/, "o" /*03c9*/, "i" /*03ca*/, "u" /*03cb*/, "o" /*03cc*/, "u" /*03cd*/, "o" /*03ce*/, "[?]" /*03cf*/, "b" /*03d0*/, "th" /*03d1*/, "U" /*03d2*/, "U" /*03d3*/, "U" /*03d4*/, "ph" /*03d5*/, "p" /*03d6*/, "&" /*03d7*/, "[?]" /*03d8*/, "[?]" /*03d9*/, "St" /*03da*/, "st" /*03db*/, "W" /*03dc*/, "w" /*03dd*/, "Q" /*03de*/, "q" /*03df*/, "Sp" /*03e0*/, "sp" /*03e1*/, "Sh" /*03e2*/, "sh" /*03e3*/, "F" /*03e4*/, "f" /*03e5*/, "Kh" /*03e6*/, "kh" /*03e7*/, "H" /*03e8*/, "h" /*03e9*/, "G" /*03ea*/, "g" /*03eb*/, "CH" /*03ec*/, "ch" /*03ed*/, "Ti" /*03ee*/, "ti" /*03ef*/, "k" /*03f0*/, "r" /*03f1*/, "c" /*03f2*/, "j" /*03f3*/, "[?]" /*03f4*/, "[?]" /*03f5*/, "[?]" /*03f6*/, "[?]" /*03f7*/, "[?]" /*03f8*/, "[?]" /*03f9*/, "[?]" /*03fa*/, "[?]" /*03fb*/, "[?]" /*03fc*/, "[?]" /*03fd*/, "[?]" /*03fe*/, 
			});
                        characters.TryAdd(4 /*1024 04*/, new string[] {
				"Ie" /*0400*/, "Jo" /*0401*/, "Dj" /*0402*/, "Gj" /*0403*/, "Ie" /*0404*/, "Dz" /*0405*/, "I" /*0406*/, "Yi" /*0407*/, "J" /*0408*/, "Lj" /*0409*/, "Nj" /*040a*/, "Tsh" /*040b*/, "Kj" /*040c*/, "I" /*040d*/, "U" /*040e*/, "Dzh" /*040f*/, "A" /*0410*/, "B" /*0411*/, "V" /*0412*/, "G" /*0413*/, "D" /*0414*/, "E" /*0415*/, "Zh" /*0416*/, "Z" /*0417*/, "I" /*0418*/, "Jj" /*0419*/, "K" /*041a*/, "L" /*041b*/, "M" /*041c*/, "N" /*041d*/, "O" /*041e*/, "P" /*041f*/, "R" /*0420*/, "S" /*0421*/, "T" /*0422*/, "U" /*0423*/, "F" /*0424*/, "Kh" /*0425*/, "C" /*0426*/, "Ch" /*0427*/, "Sh" /*0428*/, "Shh" /*0429*/, "" /*042a*/, "Y" /*042b*/, "'" /*042c*/, "Eh" /*042d*/, "Ju" /*042e*/, "Ja" /*042f*/, "a" /*0430*/, "b" /*0431*/, "v" /*0432*/, "g" /*0433*/, "d" /*0434*/, "e" /*0435*/, "zh" /*0436*/, "z" /*0437*/, "i" /*0438*/, "jj" /*0439*/, "k" /*043a*/, "l" /*043b*/, "m" /*043c*/, "n" /*043d*/, "o" /*043e*/, "p" /*043f*/, "r" /*0440*/, "s" /*0441*/, "t" /*0442*/, "u" /*0443*/, "f" /*0444*/, "kh" /*0445*/, "c" /*0446*/, "ch" /*0447*/, "sh" /*0448*/, "shch" /*0449*/, "" /*044a*/, "y" /*044b*/, "'" /*044c*/, "eh" /*044d*/, "ju" /*044e*/, "ja" /*044f*/, "e" /*0450*/, "jo" /*0451*/, "dj" /*0452*/, "gj" /*0453*/, "ie" /*0454*/, "dz" /*0455*/, "i" /*0456*/, "yi" /*0457*/, "j" /*0458*/, "lj" /*0459*/, "nj" /*045a*/, "tsh" /*045b*/, "kj" /*045c*/, "i" /*045d*/, "u" /*045e*/, "dzh" /*045f*/, "O" /*0460*/, "o" /*0461*/, "E" /*0462*/, "e" /*0463*/, "Ie" /*0464*/, "ie" /*0465*/, "E" /*0466*/, "e" /*0467*/, "Ie" /*0468*/, "ie" /*0469*/, "O" /*046a*/, "o" /*046b*/, "Io" /*046c*/, "io" /*046d*/, "Ks" /*046e*/, "ks" /*046f*/, "Ps" /*0470*/, "ps" /*0471*/, "F" /*0472*/, "f" /*0473*/, "Y" /*0474*/, "y" /*0475*/, "Y" /*0476*/, "y" /*0477*/, "u" /*0478*/, "u" /*0479*/, "O" /*047a*/, "o" /*047b*/, "O" /*047c*/, "o" /*047d*/, "Ot" /*047e*/, "ot" /*047f*/, "Q" /*0480*/, "q" /*0481*/, "*1000*" /*0482*/, "" /*0483*/, "" /*0484*/, "" /*0485*/, "" /*0486*/, "[?]" /*0487*/, "*100.000*" /*0488*/, "*1.000.000*" /*0489*/, "[?]" /*048a*/, "[?]" /*048b*/, "\"" /*048c*/, "\"" /*048d*/, "R'" /*048e*/, "r'" /*048f*/, "G'" /*0490*/, "g'" /*0491*/, "G'" /*0492*/, "g'" /*0493*/, "G'" /*0494*/, "g'" /*0495*/, "Zh'" /*0496*/, "zh'" /*0497*/, "Z'" /*0498*/, "z'" /*0499*/, "K'" /*049a*/, "k'" /*049b*/, "K'" /*049c*/, "k'" /*049d*/, "K'" /*049e*/, "k'" /*049f*/, "K'" /*04a0*/, "k'" /*04a1*/, "N'" /*04a2*/, "n'" /*04a3*/, "Ng" /*04a4*/, "ng" /*04a5*/, "P'" /*04a6*/, "p'" /*04a7*/, "Kh" /*04a8*/, "kh" /*04a9*/, "S'" /*04aa*/, "s'" /*04ab*/, "T'" /*04ac*/, "t'" /*04ad*/, "U" /*04ae*/, "u" /*04af*/, "U'" /*04b0*/, "u'" /*04b1*/, "Kh'" /*04b2*/, "kh'" /*04b3*/, "Tts" /*04b4*/, "tts" /*04b5*/, "Ch'" /*04b6*/, "ch'" /*04b7*/, "Ch'" /*04b8*/, "ch'" /*04b9*/, "H" /*04ba*/, "h" /*04bb*/, "Ch" /*04bc*/, "ch" /*04bd*/, "Ch'" /*04be*/, "ch'" /*04bf*/, "`" /*04c0*/, "Zh" /*04c1*/, "zh" /*04c2*/, "K'" /*04c3*/, "k'" /*04c4*/, "[?]" /*04c5*/, "[?]" /*04c6*/, "N'" /*04c7*/, "n'" /*04c8*/, "[?]" /*04c9*/, "[?]" /*04ca*/, "Ch" /*04cb*/, "ch" /*04cc*/, "[?]" /*04cd*/, "[?]" /*04ce*/, "[?]" /*04cf*/, "a" /*04d0*/, "a" /*04d1*/, "A" /*04d2*/, "a" /*04d3*/, "Ae" /*04d4*/, "ae" /*04d5*/, "Ie" /*04d6*/, "ie" /*04d7*/, "@" /*04d8*/, "@" /*04d9*/, "@" /*04da*/, "@" /*04db*/, "Zh" /*04dc*/, "zh" /*04dd*/, "Z" /*04de*/, "z" /*04df*/, "Dz" /*04e0*/, "dz" /*04e1*/, "I" /*04e2*/, "i" /*04e3*/, "I" /*04e4*/, "i" /*04e5*/, "O" /*04e6*/, "o" /*04e7*/, "O" /*04e8*/, "o" /*04e9*/, "O" /*04ea*/, "o" /*04eb*/, "E" /*04ec*/, "e" /*04ed*/, "U" /*04ee*/, "u" /*04ef*/, "U" /*04f0*/, "u" /*04f1*/, "U" /*04f2*/, "u" /*04f3*/, "Ch" /*04f4*/, "ch" /*04f5*/, "[?]" /*04f6*/, "[?]" /*04f7*/, "Y" /*04f8*/, "y" /*04f9*/, "[?]" /*04fa*/, "[?]" /*04fb*/, "[?]" /*04fc*/, "[?]" /*04fd*/, "[?]" /*04fe*/, 
			});
						characters.TryAdd(5 /*1280 05*/, new string[] {
				"[?]" /*0500*/, "[?]" /*0501*/, "[?]" /*0502*/, "[?]" /*0503*/, "[?]" /*0504*/, "[?]" /*0505*/, "[?]" /*0506*/, "[?]" /*0507*/, "[?]" /*0508*/, "[?]" /*0509*/, "[?]" /*050a*/, "[?]" /*050b*/, "[?]" /*050c*/, "[?]" /*050d*/, "[?]" /*050e*/, "[?]" /*050f*/, "[?]" /*0510*/, "[?]" /*0511*/, "[?]" /*0512*/, "[?]" /*0513*/, "[?]" /*0514*/, "[?]" /*0515*/, "[?]" /*0516*/, "[?]" /*0517*/, "[?]" /*0518*/, "[?]" /*0519*/, "[?]" /*051a*/, "[?]" /*051b*/, "[?]" /*051c*/, "[?]" /*051d*/, "[?]" /*051e*/, "[?]" /*051f*/, "[?]" /*0520*/, "[?]" /*0521*/, "[?]" /*0522*/, "[?]" /*0523*/, "[?]" /*0524*/, "[?]" /*0525*/, "[?]" /*0526*/, "[?]" /*0527*/, "[?]" /*0528*/, "[?]" /*0529*/, "[?]" /*052a*/, "[?]" /*052b*/, "[?]" /*052c*/, "[?]" /*052d*/, "[?]" /*052e*/, "[?]" /*052f*/, "[?]" /*0530*/, "A" /*0531*/, "B" /*0532*/, "G" /*0533*/, "D" /*0534*/, "E" /*0535*/, "Z" /*0536*/, "E" /*0537*/, "E" /*0538*/, "T`" /*0539*/, "Zh" /*053a*/, "I" /*053b*/, "L" /*053c*/, "Kh" /*053d*/, "Ts" /*053e*/, "K" /*053f*/, "H" /*0540*/, "Dz" /*0541*/, "Gh" /*0542*/, "Ch" /*0543*/, "M" /*0544*/, "Y" /*0545*/, "N" /*0546*/, "Sh" /*0547*/, "O" /*0548*/, "Ch`" /*0549*/, "P" /*054a*/, "J" /*054b*/, "Rh" /*054c*/, "S" /*054d*/, "V" /*054e*/, "T" /*054f*/, "R" /*0550*/, "Ts`" /*0551*/, "W" /*0552*/, "P`" /*0553*/, "K`" /*0554*/, "O" /*0555*/, "F" /*0556*/, "[?]" /*0557*/, "[?]" /*0558*/, "<" /*0559*/, "'" /*055a*/, "/" /*055b*/, "!" /*055c*/, "," /*055d*/, "?" /*055e*/, "." /*055f*/, "[?]" /*0560*/, "a" /*0561*/, "b" /*0562*/, "g" /*0563*/, "d" /*0564*/, "e" /*0565*/, "z" /*0566*/, "e" /*0567*/, "e" /*0568*/, "t`" /*0569*/, "zh" /*056a*/, "i" /*056b*/, "l" /*056c*/, "kh" /*056d*/, "ts" /*056e*/, "k" /*056f*/, "h" /*0570*/, "dz" /*0571*/, "gh" /*0572*/, "ch" /*0573*/, "m" /*0574*/, "y" /*0575*/, "n" /*0576*/, "sh" /*0577*/, "o" /*0578*/, "ch`" /*0579*/, "p" /*057a*/, "j" /*057b*/, "rh" /*057c*/, "s" /*057d*/, "v" /*057e*/, "t" /*057f*/, "r" /*0580*/, "ts`" /*0581*/, "w" /*0582*/, "p`" /*0583*/, "k`" /*0584*/, "o" /*0585*/, "f" /*0586*/, "ew" /*0587*/, "[?]" /*0588*/, "." /*0589*/, "-" /*058a*/, "[?]" /*058b*/, "[?]" /*058c*/, "[?]" /*058d*/, "[?]" /*058e*/, "[?]" /*058f*/, "[?]" /*0590*/, "" /*0591*/, "" /*0592*/, "" /*0593*/, "" /*0594*/, "" /*0595*/, "" /*0596*/, "" /*0597*/, "" /*0598*/, "" /*0599*/, "" /*059a*/, "" /*059b*/, "" /*059c*/, "" /*059d*/, "" /*059e*/, "" /*059f*/, "" /*05a0*/, "" /*05a1*/, "[?]" /*05a2*/, "" /*05a3*/, "" /*05a4*/, "" /*05a5*/, "" /*05a6*/, "" /*05a7*/, "" /*05a8*/, "" /*05a9*/, "" /*05aa*/, "" /*05ab*/, "" /*05ac*/, "" /*05ad*/, "" /*05ae*/, "" /*05af*/, "@" /*05b0*/, "e" /*05b1*/, "a" /*05b2*/, "o" /*05b3*/, "i" /*05b4*/, "e" /*05b5*/, "e" /*05b6*/, "a" /*05b7*/, "a" /*05b8*/, "o" /*05b9*/, "[?]" /*05ba*/, "u" /*05bb*/, "'" /*05bc*/, "" /*05bd*/, "" /*05be*/, "" /*05bf*/, "" /*05c0*/, "" /*05c1*/, "" /*05c2*/, ":" /*05c3*/, "" /*05c4*/, "[?]" /*05c5*/, "[?]" /*05c6*/, "[?]" /*05c7*/, "[?]" /*05c8*/, "[?]" /*05c9*/, "[?]" /*05ca*/, "[?]" /*05cb*/, "[?]" /*05cc*/, "[?]" /*05cd*/, "[?]" /*05ce*/, "[?]" /*05cf*/, "" /*05d0*/, "b" /*05d1*/, "g" /*05d2*/, "d" /*05d3*/, "h" /*05d4*/, "v" /*05d5*/, "z" /*05d6*/, "kh" /*05d7*/, "t" /*05d8*/, "y" /*05d9*/, "k" /*05da*/, "k" /*05db*/, "l" /*05dc*/, "m" /*05dd*/, "m" /*05de*/, "n" /*05df*/, "n" /*05e0*/, "s" /*05e1*/, "`" /*05e2*/, "p" /*05e3*/, "p" /*05e4*/, "ts" /*05e5*/, "ts" /*05e6*/, "q" /*05e7*/, "r" /*05e8*/, "sh" /*05e9*/, "t" /*05ea*/, "[?]" /*05eb*/, "[?]" /*05ec*/, "[?]" /*05ed*/, "[?]" /*05ee*/, "[?]" /*05ef*/, "V" /*05f0*/, "oy" /*05f1*/, "i" /*05f2*/, "'" /*05f3*/, "\"" /*05f4*/, "[?]" /*05f5*/, "[?]" /*05f6*/, "[?]" /*05f7*/, "[?]" /*05f8*/, "[?]" /*05f9*/, "[?]" /*05fa*/, "[?]" /*05fb*/, "[?]" /*05fc*/, "[?]" /*05fd*/, "[?]" /*05fe*/, 
			});
						characters.TryAdd(6 /*1536 06*/, new string[] {
				"[?]" /*0600*/, "[?]" /*0601*/, "[?]" /*0602*/, "[?]" /*0603*/, "[?]" /*0604*/, "[?]" /*0605*/, "[?]" /*0606*/, "[?]" /*0607*/, "[?]" /*0608*/, "[?]" /*0609*/, "[?]" /*060a*/, "[?]" /*060b*/, "," /*060c*/, "[?]" /*060d*/, "[?]" /*060e*/, "[?]" /*060f*/, "[?]" /*0610*/, "[?]" /*0611*/, "[?]" /*0612*/, "[?]" /*0613*/, "[?]" /*0614*/, "[?]" /*0615*/, "[?]" /*0616*/, "[?]" /*0617*/, "[?]" /*0618*/, "[?]" /*0619*/, "[?]" /*061a*/, ";" /*061b*/, "[?]" /*061c*/, "[?]" /*061d*/, "[?]" /*061e*/, "?" /*061f*/, "[?]" /*0620*/, "" /*0621*/, "a" /*0622*/, "'" /*0623*/, "w'" /*0624*/, "" /*0625*/, "y'" /*0626*/, "" /*0627*/, "b" /*0628*/, "@" /*0629*/, "t" /*062a*/, "th" /*062b*/, "j" /*062c*/, "H" /*062d*/, "kh" /*062e*/, "d" /*062f*/, "dh" /*0630*/, "r" /*0631*/, "z" /*0632*/, "s" /*0633*/, "sh" /*0634*/, "S" /*0635*/, "D" /*0636*/, "T" /*0637*/, "Z" /*0638*/, "`" /*0639*/, "G" /*063a*/, "[?]" /*063b*/, "[?]" /*063c*/, "[?]" /*063d*/, "[?]" /*063e*/, "[?]" /*063f*/, "" /*0640*/, "f" /*0641*/, "q" /*0642*/, "k" /*0643*/, "l" /*0644*/, "m" /*0645*/, "n" /*0646*/, "h" /*0647*/, "w" /*0648*/, "~" /*0649*/, "y" /*064a*/, "an" /*064b*/, "un" /*064c*/, "in" /*064d*/, "a" /*064e*/, "u" /*064f*/, "i" /*0650*/, "W" /*0651*/, "" /*0652*/, "" /*0653*/, "'" /*0654*/, "'" /*0655*/, "[?]" /*0656*/, "[?]" /*0657*/, "[?]" /*0658*/, "[?]" /*0659*/, "[?]" /*065a*/, "[?]" /*065b*/, "[?]" /*065c*/, "[?]" /*065d*/, "[?]" /*065e*/, "[?]" /*065f*/, "0" /*0660*/, "1" /*0661*/, "2" /*0662*/, "3" /*0663*/, "4" /*0664*/, "5" /*0665*/, "6" /*0666*/, "7" /*0667*/, "8" /*0668*/, "9" /*0669*/, "%" /*066a*/, "." /*066b*/, "," /*066c*/, "*" /*066d*/, "[?]" /*066e*/, "[?]" /*066f*/, "" /*0670*/, "'" /*0671*/, "'" /*0672*/, "'" /*0673*/, "" /*0674*/, "'" /*0675*/, "'w" /*0676*/, "'u" /*0677*/, "'y" /*0678*/, "tt" /*0679*/, "tth" /*067a*/, "b" /*067b*/, "t" /*067c*/, "T" /*067d*/, "p" /*067e*/, "th" /*067f*/, "bh" /*0680*/, "'h" /*0681*/, "H" /*0682*/, "ny" /*0683*/, "dy" /*0684*/, "H" /*0685*/, "ch" /*0686*/, "cch" /*0687*/, "dd" /*0688*/, "D" /*0689*/, "D" /*068a*/, "Dt" /*068b*/, "dh" /*068c*/, "ddh" /*068d*/, "d" /*068e*/, "D" /*068f*/, "D" /*0690*/, "rr" /*0691*/, "R" /*0692*/, "R" /*0693*/, "R" /*0694*/, "R" /*0695*/, "R" /*0696*/, "R" /*0697*/, "j" /*0698*/, "R" /*0699*/, "S" /*069a*/, "S" /*069b*/, "S" /*069c*/, "S" /*069d*/, "S" /*069e*/, "T" /*069f*/, "GH" /*06a0*/, "F" /*06a1*/, "F" /*06a2*/, "F" /*06a3*/, "v" /*06a4*/, "f" /*06a5*/, "ph" /*06a6*/, "Q" /*06a7*/, "Q" /*06a8*/, "kh" /*06a9*/, "k" /*06aa*/, "K" /*06ab*/, "K" /*06ac*/, "ng" /*06ad*/, "K" /*06ae*/, "g" /*06af*/, "G" /*06b0*/, "N" /*06b1*/, "G" /*06b2*/, "G" /*06b3*/, "G" /*06b4*/, "L" /*06b5*/, "L" /*06b6*/, "L" /*06b7*/, "L" /*06b8*/, "N" /*06b9*/, "N" /*06ba*/, "N" /*06bb*/, "N" /*06bc*/, "N" /*06bd*/, "h" /*06be*/, "Ch" /*06bf*/, "hy" /*06c0*/, "h" /*06c1*/, "H" /*06c2*/, "@" /*06c3*/, "W" /*06c4*/, "oe" /*06c5*/, "oe" /*06c6*/, "u" /*06c7*/, "yu" /*06c8*/, "yu" /*06c9*/, "W" /*06ca*/, "v" /*06cb*/, "y" /*06cc*/, "Y" /*06cd*/, "Y" /*06ce*/, "W" /*06cf*/, "" /*06d0*/, "" /*06d1*/, "y" /*06d2*/, "y'" /*06d3*/, "." /*06d4*/, "ae" /*06d5*/, "" /*06d6*/, "" /*06d7*/, "" /*06d8*/, "" /*06d9*/, "" /*06da*/, "" /*06db*/, "" /*06dc*/, "@" /*06dd*/, "#" /*06de*/, "" /*06df*/, "" /*06e0*/, "" /*06e1*/, "" /*06e2*/, "" /*06e3*/, "" /*06e4*/, "" /*06e5*/, "" /*06e6*/, "" /*06e7*/, "" /*06e8*/, "^" /*06e9*/, "" /*06ea*/, "" /*06eb*/, "" /*06ec*/, "" /*06ed*/, "[?]" /*06ee*/, "[?]" /*06ef*/, "0" /*06f0*/, "1" /*06f1*/, "2" /*06f2*/, "3" /*06f3*/, "4" /*06f4*/, "5" /*06f5*/, "6" /*06f6*/, "7" /*06f7*/, "8" /*06f8*/, "9" /*06f9*/, "Sh" /*06fa*/, "D" /*06fb*/, "Gh" /*06fc*/, "&" /*06fd*/, "+m" /*06fe*/, 
			});
						characters.TryAdd(7 /*1792 07*/, new string[] {
				"//" /*0700*/, "/" /*0701*/, "," /*0702*/, "!" /*0703*/, "!" /*0704*/, "-" /*0705*/, "," /*0706*/, "," /*0707*/, ";" /*0708*/, "?" /*0709*/, "~" /*070a*/, "{" /*070b*/, "}" /*070c*/, "*" /*070d*/, "[?]" /*070e*/, "" /*070f*/, "'" /*0710*/, "" /*0711*/, "b" /*0712*/, "g" /*0713*/, "g" /*0714*/, "d" /*0715*/, "d" /*0716*/, "h" /*0717*/, "w" /*0718*/, "z" /*0719*/, "H" /*071a*/, "t" /*071b*/, "t" /*071c*/, "y" /*071d*/, "yh" /*071e*/, "k" /*071f*/, "l" /*0720*/, "m" /*0721*/, "n" /*0722*/, "s" /*0723*/, "s" /*0724*/, "`" /*0725*/, "p" /*0726*/, "p" /*0727*/, "S" /*0728*/, "q" /*0729*/, "r" /*072a*/, "sh" /*072b*/, "t" /*072c*/, "[?]" /*072d*/, "[?]" /*072e*/, "[?]" /*072f*/, "a" /*0730*/, "a" /*0731*/, "a" /*0732*/, "A" /*0733*/, "A" /*0734*/, "A" /*0735*/, "e" /*0736*/, "e" /*0737*/, "e" /*0738*/, "E" /*0739*/, "i" /*073a*/, "i" /*073b*/, "u" /*073c*/, "u" /*073d*/, "u" /*073e*/, "o" /*073f*/, "" /*0740*/, "`" /*0741*/, "'" /*0742*/, "" /*0743*/, "" /*0744*/, "X" /*0745*/, "Q" /*0746*/, "@" /*0747*/, "@" /*0748*/, "|" /*0749*/, "+" /*074a*/, "[?]" /*074b*/, "[?]" /*074c*/, "[?]" /*074d*/, "[?]" /*074e*/, "[?]" /*074f*/, "[?]" /*0750*/, "[?]" /*0751*/, "[?]" /*0752*/, "[?]" /*0753*/, "[?]" /*0754*/, "[?]" /*0755*/, "[?]" /*0756*/, "[?]" /*0757*/, "[?]" /*0758*/, "[?]" /*0759*/, "[?]" /*075a*/, "[?]" /*075b*/, "[?]" /*075c*/, "[?]" /*075d*/, "[?]" /*075e*/, "[?]" /*075f*/, "[?]" /*0760*/, "[?]" /*0761*/, "[?]" /*0762*/, "[?]" /*0763*/, "[?]" /*0764*/, "[?]" /*0765*/, "[?]" /*0766*/, "[?]" /*0767*/, "[?]" /*0768*/, "[?]" /*0769*/, "[?]" /*076a*/, "[?]" /*076b*/, "[?]" /*076c*/, "[?]" /*076d*/, "[?]" /*076e*/, "[?]" /*076f*/, "[?]" /*0770*/, "[?]" /*0771*/, "[?]" /*0772*/, "[?]" /*0773*/, "[?]" /*0774*/, "[?]" /*0775*/, "[?]" /*0776*/, "[?]" /*0777*/, "[?]" /*0778*/, "[?]" /*0779*/, "[?]" /*077a*/, "[?]" /*077b*/, "[?]" /*077c*/, "[?]" /*077d*/, "[?]" /*077e*/, "[?]" /*077f*/, "h" /*0780*/, "sh" /*0781*/, "n" /*0782*/, "r" /*0783*/, "b" /*0784*/, "L" /*0785*/, "k" /*0786*/, "'" /*0787*/, "v" /*0788*/, "m" /*0789*/, "f" /*078a*/, "dh" /*078b*/, "th" /*078c*/, "l" /*078d*/, "g" /*078e*/, "ny" /*078f*/, "s" /*0790*/, "d" /*0791*/, "z" /*0792*/, "t" /*0793*/, "y" /*0794*/, "p" /*0795*/, "j" /*0796*/, "ch" /*0797*/, "tt" /*0798*/, "hh" /*0799*/, "kh" /*079a*/, "th" /*079b*/, "z" /*079c*/, "sh" /*079d*/, "s" /*079e*/, "d" /*079f*/, "t" /*07a0*/, "z" /*07a1*/, "`" /*07a2*/, "gh" /*07a3*/, "q" /*07a4*/, "w" /*07a5*/, "a" /*07a6*/, "aa" /*07a7*/, "i" /*07a8*/, "ee" /*07a9*/, "u" /*07aa*/, "oo" /*07ab*/, "e" /*07ac*/, "ey" /*07ad*/, "o" /*07ae*/, "oa" /*07af*/, "" /*07b0*/, "[?]" /*07b1*/, "[?]" /*07b2*/, "[?]" /*07b3*/, "[?]" /*07b4*/, "[?]" /*07b5*/, "[?]" /*07b6*/, "[?]" /*07b7*/, "[?]" /*07b8*/, "[?]" /*07b9*/, "[?]" /*07ba*/, "[?]" /*07bb*/, "[?]" /*07bc*/, "[?]" /*07bd*/, "[?]" /*07be*/, "[?]" /*07bf*/, "[?]" /*07c0*/, "[?]" /*07c1*/, "[?]" /*07c2*/, "[?]" /*07c3*/, "[?]" /*07c4*/, "[?]" /*07c5*/, "[?]" /*07c6*/, "[?]" /*07c7*/, "[?]" /*07c8*/, "[?]" /*07c9*/, "[?]" /*07ca*/, "[?]" /*07cb*/, "[?]" /*07cc*/, "[?]" /*07cd*/, "[?]" /*07ce*/, "[?]" /*07cf*/, "[?]" /*07d0*/, "[?]" /*07d1*/, "[?]" /*07d2*/, "[?]" /*07d3*/, "[?]" /*07d4*/, "[?]" /*07d5*/, "[?]" /*07d6*/, "[?]" /*07d7*/, "[?]" /*07d8*/, "[?]" /*07d9*/, "[?]" /*07da*/, "[?]" /*07db*/, "[?]" /*07dc*/, "[?]" /*07dd*/, "[?]" /*07de*/, "[?]" /*07df*/, "[?]" /*07e0*/, "[?]" /*07e1*/, "[?]" /*07e2*/, "[?]" /*07e3*/, "[?]" /*07e4*/, "[?]" /*07e5*/, "[?]" /*07e6*/, "[?]" /*07e7*/, "[?]" /*07e8*/, "[?]" /*07e9*/, "[?]" /*07ea*/, "[?]" /*07eb*/, "[?]" /*07ec*/, "[?]" /*07ed*/, "[?]" /*07ee*/, "[?]" /*07ef*/, "[?]" /*07f0*/, "[?]" /*07f1*/, "[?]" /*07f2*/, "[?]" /*07f3*/, "[?]" /*07f4*/, "[?]" /*07f5*/, "[?]" /*07f6*/, "[?]" /*07f7*/, "[?]" /*07f8*/, "[?]" /*07f9*/, "[?]" /*07fa*/, "[?]" /*07fb*/, "[?]" /*07fc*/, "[?]" /*07fd*/, "[?]" /*07fe*/, 
			});
						characters.TryAdd(9 /*2304 09*/, new string[] {
				"[?]" /*0900*/, "N" /*0901*/, "N" /*0902*/, "H" /*0903*/, "[?]" /*0904*/, "a" /*0905*/, "aa" /*0906*/, "i" /*0907*/, "ii" /*0908*/, "u" /*0909*/, "uu" /*090a*/, "R" /*090b*/, "L" /*090c*/, "eN" /*090d*/, "e" /*090e*/, "e" /*090f*/, "ai" /*0910*/, "oN" /*0911*/, "o" /*0912*/, "o" /*0913*/, "au" /*0914*/, "k" /*0915*/, "kh" /*0916*/, "g" /*0917*/, "gh" /*0918*/, "ng" /*0919*/, "c" /*091a*/, "ch" /*091b*/, "j" /*091c*/, "jh" /*091d*/, "ny" /*091e*/, "tt" /*091f*/, "tth" /*0920*/, "dd" /*0921*/, "ddh" /*0922*/, "nn" /*0923*/, "t" /*0924*/, "th" /*0925*/, "d" /*0926*/, "dh" /*0927*/, "n" /*0928*/, "nnn" /*0929*/, "p" /*092a*/, "ph" /*092b*/, "b" /*092c*/, "bh" /*092d*/, "m" /*092e*/, "y" /*092f*/, "r" /*0930*/, "rr" /*0931*/, "l" /*0932*/, "l" /*0933*/, "lll" /*0934*/, "v" /*0935*/, "sh" /*0936*/, "ss" /*0937*/, "s" /*0938*/, "h" /*0939*/, "[?]" /*093a*/, "[?]" /*093b*/, "'" /*093c*/, "'" /*093d*/, "aa" /*093e*/, "i" /*093f*/, "ii" /*0940*/, "u" /*0941*/, "uu" /*0942*/, "R" /*0943*/, "RR" /*0944*/, "eN" /*0945*/, "e" /*0946*/, "e" /*0947*/, "ai" /*0948*/, "oN" /*0949*/, "o" /*094a*/, "o" /*094b*/, "au" /*094c*/, "" /*094d*/, "[?]" /*094e*/, "[?]" /*094f*/, "AUM" /*0950*/, "'" /*0951*/, "'" /*0952*/, "`" /*0953*/, "'" /*0954*/, "[?]" /*0955*/, "[?]" /*0956*/, "[?]" /*0957*/, "q" /*0958*/, "khh" /*0959*/, "ghh" /*095a*/, "z" /*095b*/, "dddh" /*095c*/, "rh" /*095d*/, "f" /*095e*/, "yy" /*095f*/, "RR" /*0960*/, "LL" /*0961*/, "L" /*0962*/, "LL" /*0963*/, " / " /*0964*/, " // " /*0965*/, "0" /*0966*/, "1" /*0967*/, "2" /*0968*/, "3" /*0969*/, "4" /*096a*/, "5" /*096b*/, "6" /*096c*/, "7" /*096d*/, "8" /*096e*/, "9" /*096f*/, "." /*0970*/, "[?]" /*0971*/, "[?]" /*0972*/, "[?]" /*0973*/, "[?]" /*0974*/, "[?]" /*0975*/, "[?]" /*0976*/, "[?]" /*0977*/, "[?]" /*0978*/, "[?]" /*0979*/, "[?]" /*097a*/, "[?]" /*097b*/, "[?]" /*097c*/, "[?]" /*097d*/, "[?]" /*097e*/, "[?]" /*097f*/, "[?]" /*0980*/, "N" /*0981*/, "N" /*0982*/, "H" /*0983*/, "[?]" /*0984*/, "a" /*0985*/, "aa" /*0986*/, "i" /*0987*/, "ii" /*0988*/, "u" /*0989*/, "uu" /*098a*/, "R" /*098b*/, "RR" /*098c*/, "[?]" /*098d*/, "[?]" /*098e*/, "e" /*098f*/, "ai" /*0990*/, "[?]" /*0991*/, "[?]" /*0992*/, "o" /*0993*/, "au" /*0994*/, "k" /*0995*/, "kh" /*0996*/, "g" /*0997*/, "gh" /*0998*/, "ng" /*0999*/, "c" /*099a*/, "ch" /*099b*/, "j" /*099c*/, "jh" /*099d*/, "ny" /*099e*/, "tt" /*099f*/, "tth" /*09a0*/, "dd" /*09a1*/, "ddh" /*09a2*/, "nn" /*09a3*/, "t" /*09a4*/, "th" /*09a5*/, "d" /*09a6*/, "dh" /*09a7*/, "n" /*09a8*/, "[?]" /*09a9*/, "p" /*09aa*/, "ph" /*09ab*/, "b" /*09ac*/, "bh" /*09ad*/, "m" /*09ae*/, "y" /*09af*/, "r" /*09b0*/, "[?]" /*09b1*/, "l" /*09b2*/, "[?]" /*09b3*/, "[?]" /*09b4*/, "[?]" /*09b5*/, "sh" /*09b6*/, "ss" /*09b7*/, "s" /*09b8*/, "h" /*09b9*/, "[?]" /*09ba*/, "[?]" /*09bb*/, "'" /*09bc*/, "[?]" /*09bd*/, "aa" /*09be*/, "i" /*09bf*/, "ii" /*09c0*/, "u" /*09c1*/, "uu" /*09c2*/, "R" /*09c3*/, "RR" /*09c4*/, "[?]" /*09c5*/, "[?]" /*09c6*/, "e" /*09c7*/, "ai" /*09c8*/, "[?]" /*09c9*/, "[?]" /*09ca*/, "o" /*09cb*/, "au" /*09cc*/, "" /*09cd*/, "[?]" /*09ce*/, "[?]" /*09cf*/, "[?]" /*09d0*/, "[?]" /*09d1*/, "[?]" /*09d2*/, "[?]" /*09d3*/, "[?]" /*09d4*/, "[?]" /*09d5*/, "[?]" /*09d6*/, "+" /*09d7*/, "[?]" /*09d8*/, "[?]" /*09d9*/, "[?]" /*09da*/, "[?]" /*09db*/, "rr" /*09dc*/, "rh" /*09dd*/, "[?]" /*09de*/, "yy" /*09df*/, "RR" /*09e0*/, "LL" /*09e1*/, "L" /*09e2*/, "LL" /*09e3*/, "[?]" /*09e4*/, "[?]" /*09e5*/, "0" /*09e6*/, "1" /*09e7*/, "2" /*09e8*/, "3" /*09e9*/, "4" /*09ea*/, "5" /*09eb*/, "6" /*09ec*/, "7" /*09ed*/, "8" /*09ee*/, "9" /*09ef*/, "r'" /*09f0*/, "r`" /*09f1*/, "Rs" /*09f2*/, "Rs" /*09f3*/, "1/" /*09f4*/, "2/" /*09f5*/, "3/" /*09f6*/, "4/" /*09f7*/, " 1 - 1/" /*09f8*/, "/16" /*09f9*/, "" /*09fa*/, "[?]" /*09fb*/, "[?]" /*09fc*/, "[?]" /*09fd*/, "[?]" /*09fe*/, 
			});
						characters.TryAdd(10 /*2560 0a*/, new string[] {
				"[?]" /*0a00*/, "[?]" /*0a01*/, "N" /*0a02*/, "[?]" /*0a03*/, "[?]" /*0a04*/, "a" /*0a05*/, "aa" /*0a06*/, "i" /*0a07*/, "ii" /*0a08*/, "u" /*0a09*/, "uu" /*0a0a*/, "[?]" /*0a0b*/, "[?]" /*0a0c*/, "[?]" /*0a0d*/, "[?]" /*0a0e*/, "ee" /*0a0f*/, "ai" /*0a10*/, "[?]" /*0a11*/, "[?]" /*0a12*/, "oo" /*0a13*/, "au" /*0a14*/, "k" /*0a15*/, "kh" /*0a16*/, "g" /*0a17*/, "gh" /*0a18*/, "ng" /*0a19*/, "c" /*0a1a*/, "ch" /*0a1b*/, "j" /*0a1c*/, "jh" /*0a1d*/, "ny" /*0a1e*/, "tt" /*0a1f*/, "tth" /*0a20*/, "dd" /*0a21*/, "ddh" /*0a22*/, "nn" /*0a23*/, "t" /*0a24*/, "th" /*0a25*/, "d" /*0a26*/, "dh" /*0a27*/, "n" /*0a28*/, "[?]" /*0a29*/, "p" /*0a2a*/, "ph" /*0a2b*/, "b" /*0a2c*/, "bb" /*0a2d*/, "m" /*0a2e*/, "y" /*0a2f*/, "r" /*0a30*/, "[?]" /*0a31*/, "l" /*0a32*/, "ll" /*0a33*/, "[?]" /*0a34*/, "v" /*0a35*/, "sh" /*0a36*/, "[?]" /*0a37*/, "s" /*0a38*/, "h" /*0a39*/, "[?]" /*0a3a*/, "[?]" /*0a3b*/, "'" /*0a3c*/, "[?]" /*0a3d*/, "aa" /*0a3e*/, "i" /*0a3f*/, "ii" /*0a40*/, "u" /*0a41*/, "uu" /*0a42*/, "[?]" /*0a43*/, "[?]" /*0a44*/, "[?]" /*0a45*/, "[?]" /*0a46*/, "ee" /*0a47*/, "ai" /*0a48*/, "[?]" /*0a49*/, "[?]" /*0a4a*/, "oo" /*0a4b*/, "au" /*0a4c*/, "" /*0a4d*/, "[?]" /*0a4e*/, "[?]" /*0a4f*/, "[?]" /*0a50*/, "[?]" /*0a51*/, "[?]" /*0a52*/, "[?]" /*0a53*/, "[?]" /*0a54*/, "[?]" /*0a55*/, "[?]" /*0a56*/, "[?]" /*0a57*/, "[?]" /*0a58*/, "khh" /*0a59*/, "ghh" /*0a5a*/, "z" /*0a5b*/, "rr" /*0a5c*/, "[?]" /*0a5d*/, "f" /*0a5e*/, "[?]" /*0a5f*/, "[?]" /*0a60*/, "[?]" /*0a61*/, "[?]" /*0a62*/, "[?]" /*0a63*/, "[?]" /*0a64*/, "[?]" /*0a65*/, "0" /*0a66*/, "1" /*0a67*/, "2" /*0a68*/, "3" /*0a69*/, "4" /*0a6a*/, "5" /*0a6b*/, "6" /*0a6c*/, "7" /*0a6d*/, "8" /*0a6e*/, "9" /*0a6f*/, "N" /*0a70*/, "H" /*0a71*/, "" /*0a72*/, "" /*0a73*/, "G.E.O." /*0a74*/, "[?]" /*0a75*/, "[?]" /*0a76*/, "[?]" /*0a77*/, "[?]" /*0a78*/, "[?]" /*0a79*/, "[?]" /*0a7a*/, "[?]" /*0a7b*/, "[?]" /*0a7c*/, "[?]" /*0a7d*/, "[?]" /*0a7e*/, "[?]" /*0a7f*/, "[?]" /*0a80*/, "N" /*0a81*/, "N" /*0a82*/, "H" /*0a83*/, "[?]" /*0a84*/, "a" /*0a85*/, "aa" /*0a86*/, "i" /*0a87*/, "ii" /*0a88*/, "u" /*0a89*/, "uu" /*0a8a*/, "R" /*0a8b*/, "[?]" /*0a8c*/, "eN" /*0a8d*/, "[?]" /*0a8e*/, "e" /*0a8f*/, "ai" /*0a90*/, "oN" /*0a91*/, "[?]" /*0a92*/, "o" /*0a93*/, "au" /*0a94*/, "k" /*0a95*/, "kh" /*0a96*/, "g" /*0a97*/, "gh" /*0a98*/, "ng" /*0a99*/, "c" /*0a9a*/, "ch" /*0a9b*/, "j" /*0a9c*/, "jh" /*0a9d*/, "ny" /*0a9e*/, "tt" /*0a9f*/, "tth" /*0aa0*/, "dd" /*0aa1*/, "ddh" /*0aa2*/, "nn" /*0aa3*/, "t" /*0aa4*/, "th" /*0aa5*/, "d" /*0aa6*/, "dh" /*0aa7*/, "n" /*0aa8*/, "[?]" /*0aa9*/, "p" /*0aaa*/, "ph" /*0aab*/, "b" /*0aac*/, "bh" /*0aad*/, "m" /*0aae*/, "ya" /*0aaf*/, "r" /*0ab0*/, "[?]" /*0ab1*/, "l" /*0ab2*/, "ll" /*0ab3*/, "[?]" /*0ab4*/, "v" /*0ab5*/, "sh" /*0ab6*/, "ss" /*0ab7*/, "s" /*0ab8*/, "h" /*0ab9*/, "[?]" /*0aba*/, "[?]" /*0abb*/, "'" /*0abc*/, "'" /*0abd*/, "aa" /*0abe*/, "i" /*0abf*/, "ii" /*0ac0*/, "u" /*0ac1*/, "uu" /*0ac2*/, "R" /*0ac3*/, "RR" /*0ac4*/, "eN" /*0ac5*/, "[?]" /*0ac6*/, "e" /*0ac7*/, "ai" /*0ac8*/, "oN" /*0ac9*/, "[?]" /*0aca*/, "o" /*0acb*/, "au" /*0acc*/, "" /*0acd*/, "[?]" /*0ace*/, "[?]" /*0acf*/, "AUM" /*0ad0*/, "[?]" /*0ad1*/, "[?]" /*0ad2*/, "[?]" /*0ad3*/, "[?]" /*0ad4*/, "[?]" /*0ad5*/, "[?]" /*0ad6*/, "[?]" /*0ad7*/, "[?]" /*0ad8*/, "[?]" /*0ad9*/, "[?]" /*0ada*/, "[?]" /*0adb*/, "[?]" /*0adc*/, "[?]" /*0add*/, "[?]" /*0ade*/, "[?]" /*0adf*/, "RR" /*0ae0*/, "[?]" /*0ae1*/, "[?]" /*0ae2*/, "[?]" /*0ae3*/, "[?]" /*0ae4*/, "[?]" /*0ae5*/, "0" /*0ae6*/, "1" /*0ae7*/, "2" /*0ae8*/, "3" /*0ae9*/, "4" /*0aea*/, "5" /*0aeb*/, "6" /*0aec*/, "7" /*0aed*/, "8" /*0aee*/, "9" /*0aef*/, "[?]" /*0af0*/, "[?]" /*0af1*/, "[?]" /*0af2*/, "[?]" /*0af3*/, "[?]" /*0af4*/, "[?]" /*0af5*/, "[?]" /*0af6*/, "[?]" /*0af7*/, "[?]" /*0af8*/, "[?]" /*0af9*/, "[?]" /*0afa*/, "[?]" /*0afb*/, "[?]" /*0afc*/, "[?]" /*0afd*/, "[?]" /*0afe*/, 
			});
						characters.TryAdd(11 /*2816 0b*/, new string[] {
				"[?]" /*0b00*/, "N" /*0b01*/, "N" /*0b02*/, "H" /*0b03*/, "[?]" /*0b04*/, "a" /*0b05*/, "aa" /*0b06*/, "i" /*0b07*/, "ii" /*0b08*/, "u" /*0b09*/, "uu" /*0b0a*/, "R" /*0b0b*/, "L" /*0b0c*/, "[?]" /*0b0d*/, "[?]" /*0b0e*/, "e" /*0b0f*/, "ai" /*0b10*/, "[?]" /*0b11*/, "[?]" /*0b12*/, "o" /*0b13*/, "au" /*0b14*/, "k" /*0b15*/, "kh" /*0b16*/, "g" /*0b17*/, "gh" /*0b18*/, "ng" /*0b19*/, "c" /*0b1a*/, "ch" /*0b1b*/, "j" /*0b1c*/, "jh" /*0b1d*/, "ny" /*0b1e*/, "tt" /*0b1f*/, "tth" /*0b20*/, "dd" /*0b21*/, "ddh" /*0b22*/, "nn" /*0b23*/, "t" /*0b24*/, "th" /*0b25*/, "d" /*0b26*/, "dh" /*0b27*/, "n" /*0b28*/, "[?]" /*0b29*/, "p" /*0b2a*/, "ph" /*0b2b*/, "b" /*0b2c*/, "bh" /*0b2d*/, "m" /*0b2e*/, "y" /*0b2f*/, "r" /*0b30*/, "[?]" /*0b31*/, "l" /*0b32*/, "ll" /*0b33*/, "[?]" /*0b34*/, "" /*0b35*/, "sh" /*0b36*/, "ss" /*0b37*/, "s" /*0b38*/, "h" /*0b39*/, "[?]" /*0b3a*/, "[?]" /*0b3b*/, "'" /*0b3c*/, "'" /*0b3d*/, "aa" /*0b3e*/, "i" /*0b3f*/, "ii" /*0b40*/, "u" /*0b41*/, "uu" /*0b42*/, "R" /*0b43*/, "[?]" /*0b44*/, "[?]" /*0b45*/, "[?]" /*0b46*/, "e" /*0b47*/, "ai" /*0b48*/, "[?]" /*0b49*/, "[?]" /*0b4a*/, "o" /*0b4b*/, "au" /*0b4c*/, "" /*0b4d*/, "[?]" /*0b4e*/, "[?]" /*0b4f*/, "[?]" /*0b50*/, "[?]" /*0b51*/, "[?]" /*0b52*/, "[?]" /*0b53*/, "[?]" /*0b54*/, "[?]" /*0b55*/, "+" /*0b56*/, "+" /*0b57*/, "[?]" /*0b58*/, "[?]" /*0b59*/, "[?]" /*0b5a*/, "[?]" /*0b5b*/, "rr" /*0b5c*/, "rh" /*0b5d*/, "[?]" /*0b5e*/, "yy" /*0b5f*/, "RR" /*0b60*/, "LL" /*0b61*/, "[?]" /*0b62*/, "[?]" /*0b63*/, "[?]" /*0b64*/, "[?]" /*0b65*/, "0" /*0b66*/, "1" /*0b67*/, "2" /*0b68*/, "3" /*0b69*/, "4" /*0b6a*/, "5" /*0b6b*/, "6" /*0b6c*/, "7" /*0b6d*/, "8" /*0b6e*/, "9" /*0b6f*/, "" /*0b70*/, "[?]" /*0b71*/, "[?]" /*0b72*/, "[?]" /*0b73*/, "[?]" /*0b74*/, "[?]" /*0b75*/, "[?]" /*0b76*/, "[?]" /*0b77*/, "[?]" /*0b78*/, "[?]" /*0b79*/, "[?]" /*0b7a*/, "[?]" /*0b7b*/, "[?]" /*0b7c*/, "[?]" /*0b7d*/, "[?]" /*0b7e*/, "[?]" /*0b7f*/, "[?]" /*0b80*/, "[?]" /*0b81*/, "N" /*0b82*/, "H" /*0b83*/, "[?]" /*0b84*/, "a" /*0b85*/, "aa" /*0b86*/, "i" /*0b87*/, "ii" /*0b88*/, "u" /*0b89*/, "uu" /*0b8a*/, "[?]" /*0b8b*/, "[?]" /*0b8c*/, "[?]" /*0b8d*/, "e" /*0b8e*/, "ee" /*0b8f*/, "ai" /*0b90*/, "[?]" /*0b91*/, "o" /*0b92*/, "oo" /*0b93*/, "au" /*0b94*/, "k" /*0b95*/, "[?]" /*0b96*/, "[?]" /*0b97*/, "[?]" /*0b98*/, "ng" /*0b99*/, "c" /*0b9a*/, "[?]" /*0b9b*/, "j" /*0b9c*/, "[?]" /*0b9d*/, "ny" /*0b9e*/, "tt" /*0b9f*/, "[?]" /*0ba0*/, "[?]" /*0ba1*/, "[?]" /*0ba2*/, "nn" /*0ba3*/, "t" /*0ba4*/, "[?]" /*0ba5*/, "[?]" /*0ba6*/, "[?]" /*0ba7*/, "n" /*0ba8*/, "nnn" /*0ba9*/, "p" /*0baa*/, "[?]" /*0bab*/, "[?]" /*0bac*/, "[?]" /*0bad*/, "m" /*0bae*/, "y" /*0baf*/, "r" /*0bb0*/, "rr" /*0bb1*/, "l" /*0bb2*/, "ll" /*0bb3*/, "lll" /*0bb4*/, "v" /*0bb5*/, "[?]" /*0bb6*/, "ss" /*0bb7*/, "s" /*0bb8*/, "h" /*0bb9*/, "[?]" /*0bba*/, "[?]" /*0bbb*/, "[?]" /*0bbc*/, "[?]" /*0bbd*/, "aa" /*0bbe*/, "i" /*0bbf*/, "ii" /*0bc0*/, "u" /*0bc1*/, "uu" /*0bc2*/, "[?]" /*0bc3*/, "[?]" /*0bc4*/, "[?]" /*0bc5*/, "e" /*0bc6*/, "ee" /*0bc7*/, "ai" /*0bc8*/, "[?]" /*0bc9*/, "o" /*0bca*/, "oo" /*0bcb*/, "au" /*0bcc*/, "" /*0bcd*/, "[?]" /*0bce*/, "[?]" /*0bcf*/, "[?]" /*0bd0*/, "[?]" /*0bd1*/, "[?]" /*0bd2*/, "[?]" /*0bd3*/, "[?]" /*0bd4*/, "[?]" /*0bd5*/, "[?]" /*0bd6*/, "+" /*0bd7*/, "[?]" /*0bd8*/, "[?]" /*0bd9*/, "[?]" /*0bda*/, "[?]" /*0bdb*/, "[?]" /*0bdc*/, "[?]" /*0bdd*/, "[?]" /*0bde*/, "[?]" /*0bdf*/, "[?]" /*0be0*/, "[?]" /*0be1*/, "[?]" /*0be2*/, "[?]" /*0be3*/, "[?]" /*0be4*/, "[?]" /*0be5*/, "0" /*0be6*/, "1" /*0be7*/, "2" /*0be8*/, "3" /*0be9*/, "4" /*0bea*/, "5" /*0beb*/, "6" /*0bec*/, "7" /*0bed*/, "8" /*0bee*/, "9" /*0bef*/, "+10+" /*0bf0*/, "+100+" /*0bf1*/, "+1000+" /*0bf2*/, "[?]" /*0bf3*/, "[?]" /*0bf4*/, "[?]" /*0bf5*/, "[?]" /*0bf6*/, "[?]" /*0bf7*/, "[?]" /*0bf8*/, "[?]" /*0bf9*/, "[?]" /*0bfa*/, "[?]" /*0bfb*/, "[?]" /*0bfc*/, "[?]" /*0bfd*/, "[?]" /*0bfe*/, 
			});
						characters.TryAdd(12 /*3072 0c*/, new string[] {
				"[?]" /*0c00*/, "N" /*0c01*/, "N" /*0c02*/, "H" /*0c03*/, "[?]" /*0c04*/, "a" /*0c05*/, "aa" /*0c06*/, "i" /*0c07*/, "ii" /*0c08*/, "u" /*0c09*/, "uu" /*0c0a*/, "R" /*0c0b*/, "L" /*0c0c*/, "[?]" /*0c0d*/, "e" /*0c0e*/, "ee" /*0c0f*/, "ai" /*0c10*/, "[?]" /*0c11*/, "o" /*0c12*/, "oo" /*0c13*/, "au" /*0c14*/, "k" /*0c15*/, "kh" /*0c16*/, "g" /*0c17*/, "gh" /*0c18*/, "ng" /*0c19*/, "c" /*0c1a*/, "ch" /*0c1b*/, "j" /*0c1c*/, "jh" /*0c1d*/, "ny" /*0c1e*/, "tt" /*0c1f*/, "tth" /*0c20*/, "dd" /*0c21*/, "ddh" /*0c22*/, "nn" /*0c23*/, "t" /*0c24*/, "th" /*0c25*/, "d" /*0c26*/, "dh" /*0c27*/, "n" /*0c28*/, "[?]" /*0c29*/, "p" /*0c2a*/, "ph" /*0c2b*/, "b" /*0c2c*/, "bh" /*0c2d*/, "m" /*0c2e*/, "y" /*0c2f*/, "r" /*0c30*/, "rr" /*0c31*/, "l" /*0c32*/, "ll" /*0c33*/, "[?]" /*0c34*/, "v" /*0c35*/, "sh" /*0c36*/, "ss" /*0c37*/, "s" /*0c38*/, "h" /*0c39*/, "[?]" /*0c3a*/, "[?]" /*0c3b*/, "[?]" /*0c3c*/, "[?]" /*0c3d*/, "aa" /*0c3e*/, "i" /*0c3f*/, "ii" /*0c40*/, "u" /*0c41*/, "uu" /*0c42*/, "R" /*0c43*/, "RR" /*0c44*/, "[?]" /*0c45*/, "e" /*0c46*/, "ee" /*0c47*/, "ai" /*0c48*/, "[?]" /*0c49*/, "o" /*0c4a*/, "oo" /*0c4b*/, "au" /*0c4c*/, "" /*0c4d*/, "[?]" /*0c4e*/, "[?]" /*0c4f*/, "[?]" /*0c50*/, "[?]" /*0c51*/, "[?]" /*0c52*/, "[?]" /*0c53*/, "[?]" /*0c54*/, "+" /*0c55*/, "+" /*0c56*/, "[?]" /*0c57*/, "[?]" /*0c58*/, "[?]" /*0c59*/, "[?]" /*0c5a*/, "[?]" /*0c5b*/, "[?]" /*0c5c*/, "[?]" /*0c5d*/, "[?]" /*0c5e*/, "[?]" /*0c5f*/, "RR" /*0c60*/, "LL" /*0c61*/, "[?]" /*0c62*/, "[?]" /*0c63*/, "[?]" /*0c64*/, "[?]" /*0c65*/, "0" /*0c66*/, "1" /*0c67*/, "2" /*0c68*/, "3" /*0c69*/, "4" /*0c6a*/, "5" /*0c6b*/, "6" /*0c6c*/, "7" /*0c6d*/, "8" /*0c6e*/, "9" /*0c6f*/, "[?]" /*0c70*/, "[?]" /*0c71*/, "[?]" /*0c72*/, "[?]" /*0c73*/, "[?]" /*0c74*/, "[?]" /*0c75*/, "[?]" /*0c76*/, "[?]" /*0c77*/, "[?]" /*0c78*/, "[?]" /*0c79*/, "[?]" /*0c7a*/, "[?]" /*0c7b*/, "[?]" /*0c7c*/, "[?]" /*0c7d*/, "[?]" /*0c7e*/, "[?]" /*0c7f*/, "[?]" /*0c80*/, "[?]" /*0c81*/, "N" /*0c82*/, "H" /*0c83*/, "[?]" /*0c84*/, "a" /*0c85*/, "aa" /*0c86*/, "i" /*0c87*/, "ii" /*0c88*/, "u" /*0c89*/, "uu" /*0c8a*/, "R" /*0c8b*/, "L" /*0c8c*/, "[?]" /*0c8d*/, "e" /*0c8e*/, "ee" /*0c8f*/, "ai" /*0c90*/, "[?]" /*0c91*/, "o" /*0c92*/, "oo" /*0c93*/, "au" /*0c94*/, "k" /*0c95*/, "kh" /*0c96*/, "g" /*0c97*/, "gh" /*0c98*/, "ng" /*0c99*/, "c" /*0c9a*/, "ch" /*0c9b*/, "j" /*0c9c*/, "jh" /*0c9d*/, "ny" /*0c9e*/, "tt" /*0c9f*/, "tth" /*0ca0*/, "dd" /*0ca1*/, "ddh" /*0ca2*/, "nn" /*0ca3*/, "t" /*0ca4*/, "th" /*0ca5*/, "d" /*0ca6*/, "dh" /*0ca7*/, "n" /*0ca8*/, "[?]" /*0ca9*/, "p" /*0caa*/, "ph" /*0cab*/, "b" /*0cac*/, "bh" /*0cad*/, "m" /*0cae*/, "y" /*0caf*/, "r" /*0cb0*/, "rr" /*0cb1*/, "l" /*0cb2*/, "ll" /*0cb3*/, "[?]" /*0cb4*/, "v" /*0cb5*/, "sh" /*0cb6*/, "ss" /*0cb7*/, "s" /*0cb8*/, "h" /*0cb9*/, "[?]" /*0cba*/, "[?]" /*0cbb*/, "[?]" /*0cbc*/, "[?]" /*0cbd*/, "aa" /*0cbe*/, "i" /*0cbf*/, "ii" /*0cc0*/, "u" /*0cc1*/, "uu" /*0cc2*/, "R" /*0cc3*/, "RR" /*0cc4*/, "[?]" /*0cc5*/, "e" /*0cc6*/, "ee" /*0cc7*/, "ai" /*0cc8*/, "[?]" /*0cc9*/, "o" /*0cca*/, "oo" /*0ccb*/, "au" /*0ccc*/, "" /*0ccd*/, "[?]" /*0cce*/, "[?]" /*0ccf*/, "[?]" /*0cd0*/, "[?]" /*0cd1*/, "[?]" /*0cd2*/, "[?]" /*0cd3*/, "[?]" /*0cd4*/, "+" /*0cd5*/, "+" /*0cd6*/, "[?]" /*0cd7*/, "[?]" /*0cd8*/, "[?]" /*0cd9*/, "[?]" /*0cda*/, "[?]" /*0cdb*/, "[?]" /*0cdc*/, "[?]" /*0cdd*/, "lll" /*0cde*/, "[?]" /*0cdf*/, "RR" /*0ce0*/, "LL" /*0ce1*/, "[?]" /*0ce2*/, "[?]" /*0ce3*/, "[?]" /*0ce4*/, "[?]" /*0ce5*/, "0" /*0ce6*/, "1" /*0ce7*/, "2" /*0ce8*/, "3" /*0ce9*/, "4" /*0cea*/, "5" /*0ceb*/, "6" /*0cec*/, "7" /*0ced*/, "8" /*0cee*/, "9" /*0cef*/, "[?]" /*0cf0*/, "[?]" /*0cf1*/, "[?]" /*0cf2*/, "[?]" /*0cf3*/, "[?]" /*0cf4*/, "[?]" /*0cf5*/, "[?]" /*0cf6*/, "[?]" /*0cf7*/, "[?]" /*0cf8*/, "[?]" /*0cf9*/, "[?]" /*0cfa*/, "[?]" /*0cfb*/, "[?]" /*0cfc*/, "[?]" /*0cfd*/, "[?]" /*0cfe*/, 
			});
						characters.TryAdd(13 /*3328 0d*/, new string[] {
				"[?]" /*0d00*/, "[?]" /*0d01*/, "N" /*0d02*/, "H" /*0d03*/, "[?]" /*0d04*/, "a" /*0d05*/, "aa" /*0d06*/, "i" /*0d07*/, "ii" /*0d08*/, "u" /*0d09*/, "uu" /*0d0a*/, "R" /*0d0b*/, "L" /*0d0c*/, "[?]" /*0d0d*/, "e" /*0d0e*/, "ee" /*0d0f*/, "ai" /*0d10*/, "[?]" /*0d11*/, "o" /*0d12*/, "oo" /*0d13*/, "au" /*0d14*/, "k" /*0d15*/, "kh" /*0d16*/, "g" /*0d17*/, "gh" /*0d18*/, "ng" /*0d19*/, "c" /*0d1a*/, "ch" /*0d1b*/, "j" /*0d1c*/, "jh" /*0d1d*/, "ny" /*0d1e*/, "tt" /*0d1f*/, "tth" /*0d20*/, "dd" /*0d21*/, "ddh" /*0d22*/, "nn" /*0d23*/, "t" /*0d24*/, "th" /*0d25*/, "d" /*0d26*/, "dh" /*0d27*/, "n" /*0d28*/, "[?]" /*0d29*/, "p" /*0d2a*/, "ph" /*0d2b*/, "b" /*0d2c*/, "bh" /*0d2d*/, "m" /*0d2e*/, "y" /*0d2f*/, "r" /*0d30*/, "rr" /*0d31*/, "l" /*0d32*/, "ll" /*0d33*/, "lll" /*0d34*/, "v" /*0d35*/, "sh" /*0d36*/, "ss" /*0d37*/, "s" /*0d38*/, "h" /*0d39*/, "[?]" /*0d3a*/, "[?]" /*0d3b*/, "[?]" /*0d3c*/, "[?]" /*0d3d*/, "aa" /*0d3e*/, "i" /*0d3f*/, "ii" /*0d40*/, "u" /*0d41*/, "uu" /*0d42*/, "R" /*0d43*/, "[?]" /*0d44*/, "[?]" /*0d45*/, "e" /*0d46*/, "ee" /*0d47*/, "ai" /*0d48*/, "" /*0d49*/, "o" /*0d4a*/, "oo" /*0d4b*/, "au" /*0d4c*/, "" /*0d4d*/, "[?]" /*0d4e*/, "[?]" /*0d4f*/, "[?]" /*0d50*/, "[?]" /*0d51*/, "[?]" /*0d52*/, "[?]" /*0d53*/, "[?]" /*0d54*/, "[?]" /*0d55*/, "[?]" /*0d56*/, "+" /*0d57*/, "[?]" /*0d58*/, "[?]" /*0d59*/, "[?]" /*0d5a*/, "[?]" /*0d5b*/, "[?]" /*0d5c*/, "[?]" /*0d5d*/, "[?]" /*0d5e*/, "[?]" /*0d5f*/, "RR" /*0d60*/, "LL" /*0d61*/, "[?]" /*0d62*/, "[?]" /*0d63*/, "[?]" /*0d64*/, "[?]" /*0d65*/, "0" /*0d66*/, "1" /*0d67*/, "2" /*0d68*/, "3" /*0d69*/, "4" /*0d6a*/, "5" /*0d6b*/, "6" /*0d6c*/, "7" /*0d6d*/, "8" /*0d6e*/, "9" /*0d6f*/, "[?]" /*0d70*/, "[?]" /*0d71*/, "[?]" /*0d72*/, "[?]" /*0d73*/, "[?]" /*0d74*/, "[?]" /*0d75*/, "[?]" /*0d76*/, "[?]" /*0d77*/, "[?]" /*0d78*/, "[?]" /*0d79*/, "[?]" /*0d7a*/, "[?]" /*0d7b*/, "[?]" /*0d7c*/, "[?]" /*0d7d*/, "[?]" /*0d7e*/, "[?]" /*0d7f*/, "[?]" /*0d80*/, "[?]" /*0d81*/, "N" /*0d82*/, "H" /*0d83*/, "[?]" /*0d84*/, "a" /*0d85*/, "aa" /*0d86*/, "ae" /*0d87*/, "aae" /*0d88*/, "i" /*0d89*/, "ii" /*0d8a*/, "u" /*0d8b*/, "uu" /*0d8c*/, "R" /*0d8d*/, "RR" /*0d8e*/, "L" /*0d8f*/, "LL" /*0d90*/, "e" /*0d91*/, "ee" /*0d92*/, "ai" /*0d93*/, "o" /*0d94*/, "oo" /*0d95*/, "au" /*0d96*/, "[?]" /*0d97*/, "[?]" /*0d98*/, "[?]" /*0d99*/, "k" /*0d9a*/, "kh" /*0d9b*/, "g" /*0d9c*/, "gh" /*0d9d*/, "ng" /*0d9e*/, "nng" /*0d9f*/, "c" /*0da0*/, "ch" /*0da1*/, "j" /*0da2*/, "jh" /*0da3*/, "ny" /*0da4*/, "jny" /*0da5*/, "nyj" /*0da6*/, "tt" /*0da7*/, "tth" /*0da8*/, "dd" /*0da9*/, "ddh" /*0daa*/, "nn" /*0dab*/, "nndd" /*0dac*/, "t" /*0dad*/, "th" /*0dae*/, "d" /*0daf*/, "dh" /*0db0*/, "n" /*0db1*/, "[?]" /*0db2*/, "nd" /*0db3*/, "p" /*0db4*/, "ph" /*0db5*/, "b" /*0db6*/, "bh" /*0db7*/, "m" /*0db8*/, "mb" /*0db9*/, "y" /*0dba*/, "r" /*0dbb*/, "[?]" /*0dbc*/, "l" /*0dbd*/, "[?]" /*0dbe*/, "[?]" /*0dbf*/, "v" /*0dc0*/, "sh" /*0dc1*/, "ss" /*0dc2*/, "s" /*0dc3*/, "h" /*0dc4*/, "ll" /*0dc5*/, "f" /*0dc6*/, "[?]" /*0dc7*/, "[?]" /*0dc8*/, "[?]" /*0dc9*/, "" /*0dca*/, "[?]" /*0dcb*/, "[?]" /*0dcc*/, "[?]" /*0dcd*/, "[?]" /*0dce*/, "aa" /*0dcf*/, "ae" /*0dd0*/, "aae" /*0dd1*/, "i" /*0dd2*/, "ii" /*0dd3*/, "u" /*0dd4*/, "[?]" /*0dd5*/, "uu" /*0dd6*/, "[?]" /*0dd7*/, "R" /*0dd8*/, "e" /*0dd9*/, "ee" /*0dda*/, "ai" /*0ddb*/, "o" /*0ddc*/, "oo" /*0ddd*/, "au" /*0dde*/, "L" /*0ddf*/, "[?]" /*0de0*/, "[?]" /*0de1*/, "[?]" /*0de2*/, "[?]" /*0de3*/, "[?]" /*0de4*/, "[?]" /*0de5*/, "[?]" /*0de6*/, "[?]" /*0de7*/, "[?]" /*0de8*/, "[?]" /*0de9*/, "[?]" /*0dea*/, "[?]" /*0deb*/, "[?]" /*0dec*/, "[?]" /*0ded*/, "[?]" /*0dee*/, "[?]" /*0def*/, "[?]" /*0df0*/, "[?]" /*0df1*/, "RR" /*0df2*/, "LL" /*0df3*/, " . " /*0df4*/, "[?]" /*0df5*/, "[?]" /*0df6*/, "[?]" /*0df7*/, "[?]" /*0df8*/, "[?]" /*0df9*/, "[?]" /*0dfa*/, "[?]" /*0dfb*/, "[?]" /*0dfc*/, "[?]" /*0dfd*/, "[?]" /*0dfe*/, 
			});
						characters.TryAdd(14 /*3584 0e*/, new string[] {
				"[?]" /*0e00*/, "k" /*0e01*/, "kh" /*0e02*/, "kh" /*0e03*/, "kh" /*0e04*/, "kh" /*0e05*/, "kh" /*0e06*/, "ng" /*0e07*/, "cch" /*0e08*/, "ch" /*0e09*/, "ch" /*0e0a*/, "ch" /*0e0b*/, "ch" /*0e0c*/, "y" /*0e0d*/, "d" /*0e0e*/, "t" /*0e0f*/, "th" /*0e10*/, "th" /*0e11*/, "th" /*0e12*/, "n" /*0e13*/, "d" /*0e14*/, "t" /*0e15*/, "th" /*0e16*/, "th" /*0e17*/, "th" /*0e18*/, "n" /*0e19*/, "b" /*0e1a*/, "p" /*0e1b*/, "ph" /*0e1c*/, "f" /*0e1d*/, "ph" /*0e1e*/, "f" /*0e1f*/, "ph" /*0e20*/, "m" /*0e21*/, "y" /*0e22*/, "r" /*0e23*/, "R" /*0e24*/, "l" /*0e25*/, "L" /*0e26*/, "w" /*0e27*/, "s" /*0e28*/, "s" /*0e29*/, "s" /*0e2a*/, "h" /*0e2b*/, "l" /*0e2c*/, "`" /*0e2d*/, "h" /*0e2e*/, "~" /*0e2f*/, "a" /*0e30*/, "a" /*0e31*/, "aa" /*0e32*/, "am" /*0e33*/, "i" /*0e34*/, "ii" /*0e35*/, "ue" /*0e36*/, "uue" /*0e37*/, "u" /*0e38*/, "uu" /*0e39*/, "'" /*0e3a*/, "[?]" /*0e3b*/, "[?]" /*0e3c*/, "[?]" /*0e3d*/, "[?]" /*0e3e*/, "Bh." /*0e3f*/, "e" /*0e40*/, "ae" /*0e41*/, "o" /*0e42*/, "ai" /*0e43*/, "ai" /*0e44*/, "ao" /*0e45*/, "+" /*0e46*/, "" /*0e47*/, "" /*0e48*/, "" /*0e49*/, "" /*0e4a*/, "" /*0e4b*/, "" /*0e4c*/, "M" /*0e4d*/, "" /*0e4e*/, " * " /*0e4f*/, "0" /*0e50*/, "1" /*0e51*/, "2" /*0e52*/, "3" /*0e53*/, "4" /*0e54*/, "5" /*0e55*/, "6" /*0e56*/, "7" /*0e57*/, "8" /*0e58*/, "9" /*0e59*/, " // " /*0e5a*/, " /// " /*0e5b*/, "[?]" /*0e5c*/, "[?]" /*0e5d*/, "[?]" /*0e5e*/, "[?]" /*0e5f*/, "[?]" /*0e60*/, "[?]" /*0e61*/, "[?]" /*0e62*/, "[?]" /*0e63*/, "[?]" /*0e64*/, "[?]" /*0e65*/, "[?]" /*0e66*/, "[?]" /*0e67*/, "[?]" /*0e68*/, "[?]" /*0e69*/, "[?]" /*0e6a*/, "[?]" /*0e6b*/, "[?]" /*0e6c*/, "[?]" /*0e6d*/, "[?]" /*0e6e*/, "[?]" /*0e6f*/, "[?]" /*0e70*/, "[?]" /*0e71*/, "[?]" /*0e72*/, "[?]" /*0e73*/, "[?]" /*0e74*/, "[?]" /*0e75*/, "[?]" /*0e76*/, "[?]" /*0e77*/, "[?]" /*0e78*/, "[?]" /*0e79*/, "[?]" /*0e7a*/, "[?]" /*0e7b*/, "[?]" /*0e7c*/, "[?]" /*0e7d*/, "[?]" /*0e7e*/, "[?]" /*0e7f*/, "[?]" /*0e80*/, "k" /*0e81*/, "kh" /*0e82*/, "[?]" /*0e83*/, "kh" /*0e84*/, "[?]" /*0e85*/, "[?]" /*0e86*/, "ng" /*0e87*/, "ch" /*0e88*/, "[?]" /*0e89*/, "s" /*0e8a*/, "[?]" /*0e8b*/, "[?]" /*0e8c*/, "ny" /*0e8d*/, "[?]" /*0e8e*/, "[?]" /*0e8f*/, "[?]" /*0e90*/, "[?]" /*0e91*/, "[?]" /*0e92*/, "[?]" /*0e93*/, "d" /*0e94*/, "h" /*0e95*/, "th" /*0e96*/, "th" /*0e97*/, "[?]" /*0e98*/, "n" /*0e99*/, "b" /*0e9a*/, "p" /*0e9b*/, "ph" /*0e9c*/, "f" /*0e9d*/, "ph" /*0e9e*/, "f" /*0e9f*/, "[?]" /*0ea0*/, "m" /*0ea1*/, "y" /*0ea2*/, "r" /*0ea3*/, "[?]" /*0ea4*/, "l" /*0ea5*/, "[?]" /*0ea6*/, "w" /*0ea7*/, "[?]" /*0ea8*/, "[?]" /*0ea9*/, "s" /*0eaa*/, "h" /*0eab*/, "[?]" /*0eac*/, "`" /*0ead*/, "" /*0eae*/, "~" /*0eaf*/, "a" /*0eb0*/, "" /*0eb1*/, "aa" /*0eb2*/, "am" /*0eb3*/, "i" /*0eb4*/, "ii" /*0eb5*/, "y" /*0eb6*/, "yy" /*0eb7*/, "u" /*0eb8*/, "uu" /*0eb9*/, "[?]" /*0eba*/, "o" /*0ebb*/, "l" /*0ebc*/, "ny" /*0ebd*/, "[?]" /*0ebe*/, "[?]" /*0ebf*/, "e" /*0ec0*/, "ei" /*0ec1*/, "o" /*0ec2*/, "ay" /*0ec3*/, "ai" /*0ec4*/, "[?]" /*0ec5*/, "+" /*0ec6*/, "[?]" /*0ec7*/, "" /*0ec8*/, "" /*0ec9*/, "" /*0eca*/, "" /*0ecb*/, "" /*0ecc*/, "M" /*0ecd*/, "[?]" /*0ece*/, "[?]" /*0ecf*/, "0" /*0ed0*/, "1" /*0ed1*/, "2" /*0ed2*/, "3" /*0ed3*/, "4" /*0ed4*/, "5" /*0ed5*/, "6" /*0ed6*/, "7" /*0ed7*/, "8" /*0ed8*/, "9" /*0ed9*/, "[?]" /*0eda*/, "[?]" /*0edb*/, "hn" /*0edc*/, "hm" /*0edd*/, "[?]" /*0ede*/, "[?]" /*0edf*/, "[?]" /*0ee0*/, "[?]" /*0ee1*/, "[?]" /*0ee2*/, "[?]" /*0ee3*/, "[?]" /*0ee4*/, "[?]" /*0ee5*/, "[?]" /*0ee6*/, "[?]" /*0ee7*/, "[?]" /*0ee8*/, "[?]" /*0ee9*/, "[?]" /*0eea*/, "[?]" /*0eeb*/, "[?]" /*0eec*/, "[?]" /*0eed*/, "[?]" /*0eee*/, "[?]" /*0eef*/, "[?]" /*0ef0*/, "[?]" /*0ef1*/, "[?]" /*0ef2*/, "[?]" /*0ef3*/, "[?]" /*0ef4*/, "[?]" /*0ef5*/, "[?]" /*0ef6*/, "[?]" /*0ef7*/, "[?]" /*0ef8*/, "[?]" /*0ef9*/, "[?]" /*0efa*/, "[?]" /*0efb*/, "[?]" /*0efc*/, "[?]" /*0efd*/, "[?]" /*0efe*/, 
			});
						characters.TryAdd(15 /*3840 0f*/, new string[] {
				"AUM" /*0f00*/, "" /*0f01*/, "" /*0f02*/, "" /*0f03*/, "" /*0f04*/, "" /*0f05*/, "" /*0f06*/, "" /*0f07*/, " // " /*0f08*/, " * " /*0f09*/, "" /*0f0a*/, "-" /*0f0b*/, " / " /*0f0c*/, " / " /*0f0d*/, " // " /*0f0e*/, " -/ " /*0f0f*/, " +/ " /*0f10*/, " X/ " /*0f11*/, " /XX/ " /*0f12*/, " /X/ " /*0f13*/, ", " /*0f14*/, "" /*0f15*/, "" /*0f16*/, "" /*0f17*/, "" /*0f18*/, "" /*0f19*/, "" /*0f1a*/, "" /*0f1b*/, "" /*0f1c*/, "" /*0f1d*/, "" /*0f1e*/, "" /*0f1f*/, "0" /*0f20*/, "1" /*0f21*/, "2" /*0f22*/, "3" /*0f23*/, "4" /*0f24*/, "5" /*0f25*/, "6" /*0f26*/, "7" /*0f27*/, "8" /*0f28*/, "9" /*0f29*/, ".5" /*0f2a*/, "1.5" /*0f2b*/, "2.5" /*0f2c*/, "3.5" /*0f2d*/, "4.5" /*0f2e*/, "5.5" /*0f2f*/, "6.5" /*0f30*/, "7.5" /*0f31*/, "8.5" /*0f32*/, "-.5" /*0f33*/, "+" /*0f34*/, "*" /*0f35*/, "^" /*0f36*/, "_" /*0f37*/, "" /*0f38*/, "~" /*0f39*/, "[?]" /*0f3a*/, "]" /*0f3b*/, "[[" /*0f3c*/, "]]" /*0f3d*/, "" /*0f3e*/, "" /*0f3f*/, "k" /*0f40*/, "kh" /*0f41*/, "g" /*0f42*/, "gh" /*0f43*/, "ng" /*0f44*/, "c" /*0f45*/, "ch" /*0f46*/, "j" /*0f47*/, "[?]" /*0f48*/, "ny" /*0f49*/, "tt" /*0f4a*/, "tth" /*0f4b*/, "dd" /*0f4c*/, "ddh" /*0f4d*/, "nn" /*0f4e*/, "t" /*0f4f*/, "th" /*0f50*/, "d" /*0f51*/, "dh" /*0f52*/, "n" /*0f53*/, "p" /*0f54*/, "ph" /*0f55*/, "b" /*0f56*/, "bh" /*0f57*/, "m" /*0f58*/, "ts" /*0f59*/, "tsh" /*0f5a*/, "dz" /*0f5b*/, "dzh" /*0f5c*/, "w" /*0f5d*/, "zh" /*0f5e*/, "z" /*0f5f*/, "'" /*0f60*/, "y" /*0f61*/, "r" /*0f62*/, "l" /*0f63*/, "sh" /*0f64*/, "ssh" /*0f65*/, "s" /*0f66*/, "h" /*0f67*/, "a" /*0f68*/, "kss" /*0f69*/, "r" /*0f6a*/, "[?]" /*0f6b*/, "[?]" /*0f6c*/, "[?]" /*0f6d*/, "[?]" /*0f6e*/, "[?]" /*0f6f*/, "[?]" /*0f70*/, "aa" /*0f71*/, "i" /*0f72*/, "ii" /*0f73*/, "u" /*0f74*/, "uu" /*0f75*/, "R" /*0f76*/, "RR" /*0f77*/, "L" /*0f78*/, "LL" /*0f79*/, "e" /*0f7a*/, "ee" /*0f7b*/, "o" /*0f7c*/, "oo" /*0f7d*/, "M" /*0f7e*/, "H" /*0f7f*/, "i" /*0f80*/, "ii" /*0f81*/, "" /*0f82*/, "" /*0f83*/, "" /*0f84*/, "" /*0f85*/, "" /*0f86*/, "" /*0f87*/, "" /*0f88*/, "" /*0f89*/, "" /*0f8a*/, "" /*0f8b*/, "[?]" /*0f8c*/, "[?]" /*0f8d*/, "[?]" /*0f8e*/, "[?]" /*0f8f*/, "k" /*0f90*/, "kh" /*0f91*/, "g" /*0f92*/, "gh" /*0f93*/, "ng" /*0f94*/, "c" /*0f95*/, "ch" /*0f96*/, "j" /*0f97*/, "[?]" /*0f98*/, "ny" /*0f99*/, "tt" /*0f9a*/, "tth" /*0f9b*/, "dd" /*0f9c*/, "ddh" /*0f9d*/, "nn" /*0f9e*/, "t" /*0f9f*/, "th" /*0fa0*/, "d" /*0fa1*/, "dh" /*0fa2*/, "n" /*0fa3*/, "p" /*0fa4*/, "ph" /*0fa5*/, "b" /*0fa6*/, "bh" /*0fa7*/, "m" /*0fa8*/, "ts" /*0fa9*/, "tsh" /*0faa*/, "dz" /*0fab*/, "dzh" /*0fac*/, "w" /*0fad*/, "zh" /*0fae*/, "z" /*0faf*/, "'" /*0fb0*/, "y" /*0fb1*/, "r" /*0fb2*/, "l" /*0fb3*/, "sh" /*0fb4*/, "ss" /*0fb5*/, "s" /*0fb6*/, "h" /*0fb7*/, "a" /*0fb8*/, "kss" /*0fb9*/, "w" /*0fba*/, "y" /*0fbb*/, "r" /*0fbc*/, "[?]" /*0fbd*/, "X" /*0fbe*/, " :X: " /*0fbf*/, " /O/ " /*0fc0*/, " /o/ " /*0fc1*/, " \\o\\ " /*0fc2*/, " (O) " /*0fc3*/, "" /*0fc4*/, "" /*0fc5*/, "" /*0fc6*/, "" /*0fc7*/, "" /*0fc8*/, "" /*0fc9*/, "" /*0fca*/, "" /*0fcb*/, "" /*0fcc*/, "[?]" /*0fcd*/, "[?]" /*0fce*/, "" /*0fcf*/, "[?]" /*0fd0*/, "[?]" /*0fd1*/, "[?]" /*0fd2*/, "[?]" /*0fd3*/, "[?]" /*0fd4*/, "[?]" /*0fd5*/, "[?]" /*0fd6*/, "[?]" /*0fd7*/, "[?]" /*0fd8*/, "[?]" /*0fd9*/, "[?]" /*0fda*/, "[?]" /*0fdb*/, "[?]" /*0fdc*/, "[?]" /*0fdd*/, "[?]" /*0fde*/, "[?]" /*0fdf*/, "[?]" /*0fe0*/, "[?]" /*0fe1*/, "[?]" /*0fe2*/, "[?]" /*0fe3*/, "[?]" /*0fe4*/, "[?]" /*0fe5*/, "[?]" /*0fe6*/, "[?]" /*0fe7*/, "[?]" /*0fe8*/, "[?]" /*0fe9*/, "[?]" /*0fea*/, "[?]" /*0feb*/, "[?]" /*0fec*/, "[?]" /*0fed*/, "[?]" /*0fee*/, "[?]" /*0fef*/, "[?]" /*0ff0*/, "[?]" /*0ff1*/, "[?]" /*0ff2*/, "[?]" /*0ff3*/, "[?]" /*0ff4*/, "[?]" /*0ff5*/, "[?]" /*0ff6*/, "[?]" /*0ff7*/, "[?]" /*0ff8*/, "[?]" /*0ff9*/, "[?]" /*0ffa*/, "[?]" /*0ffb*/, "[?]" /*0ffc*/, "[?]" /*0ffd*/, "[?]" /*0ffe*/, 
			});
						characters.TryAdd(16 /*4096 10*/, new string[] {
				"k" /*1000*/, "kh" /*1001*/, "g" /*1002*/, "gh" /*1003*/, "ng" /*1004*/, "c" /*1005*/, "ch" /*1006*/, "j" /*1007*/, "jh" /*1008*/, "ny" /*1009*/, "nny" /*100a*/, "tt" /*100b*/, "tth" /*100c*/, "dd" /*100d*/, "ddh" /*100e*/, "nn" /*100f*/, "tt" /*1010*/, "th" /*1011*/, "d" /*1012*/, "dh" /*1013*/, "n" /*1014*/, "p" /*1015*/, "ph" /*1016*/, "b" /*1017*/, "bh" /*1018*/, "m" /*1019*/, "y" /*101a*/, "r" /*101b*/, "l" /*101c*/, "w" /*101d*/, "s" /*101e*/, "h" /*101f*/, "ll" /*1020*/, "a" /*1021*/, "[?]" /*1022*/, "i" /*1023*/, "ii" /*1024*/, "u" /*1025*/, "uu" /*1026*/, "e" /*1027*/, "[?]" /*1028*/, "o" /*1029*/, "au" /*102a*/, "[?]" /*102b*/, "aa" /*102c*/, "i" /*102d*/, "ii" /*102e*/, "u" /*102f*/, "uu" /*1030*/, "e" /*1031*/, "ai" /*1032*/, "[?]" /*1033*/, "[?]" /*1034*/, "[?]" /*1035*/, "N" /*1036*/, "'" /*1037*/, ":" /*1038*/, "" /*1039*/, "[?]" /*103a*/, "[?]" /*103b*/, "[?]" /*103c*/, "[?]" /*103d*/, "[?]" /*103e*/, "[?]" /*103f*/, "0" /*1040*/, "1" /*1041*/, "2" /*1042*/, "3" /*1043*/, "4" /*1044*/, "5" /*1045*/, "6" /*1046*/, "7" /*1047*/, "8" /*1048*/, "9" /*1049*/, " / " /*104a*/, " // " /*104b*/, "n*" /*104c*/, "r*" /*104d*/, "l*" /*104e*/, "e*" /*104f*/, "sh" /*1050*/, "ss" /*1051*/, "R" /*1052*/, "RR" /*1053*/, "L" /*1054*/, "LL" /*1055*/, "R" /*1056*/, "RR" /*1057*/, "L" /*1058*/, "LL" /*1059*/, "[?]" /*105a*/, "[?]" /*105b*/, "[?]" /*105c*/, "[?]" /*105d*/, "[?]" /*105e*/, "[?]" /*105f*/, "[?]" /*1060*/, "[?]" /*1061*/, "[?]" /*1062*/, "[?]" /*1063*/, "[?]" /*1064*/, "[?]" /*1065*/, "[?]" /*1066*/, "[?]" /*1067*/, "[?]" /*1068*/, "[?]" /*1069*/, "[?]" /*106a*/, "[?]" /*106b*/, "[?]" /*106c*/, "[?]" /*106d*/, "[?]" /*106e*/, "[?]" /*106f*/, "[?]" /*1070*/, "[?]" /*1071*/, "[?]" /*1072*/, "[?]" /*1073*/, "[?]" /*1074*/, "[?]" /*1075*/, "[?]" /*1076*/, "[?]" /*1077*/, "[?]" /*1078*/, "[?]" /*1079*/, "[?]" /*107a*/, "[?]" /*107b*/, "[?]" /*107c*/, "[?]" /*107d*/, "[?]" /*107e*/, "[?]" /*107f*/, "[?]" /*1080*/, "[?]" /*1081*/, "[?]" /*1082*/, "[?]" /*1083*/, "[?]" /*1084*/, "[?]" /*1085*/, "[?]" /*1086*/, "[?]" /*1087*/, "[?]" /*1088*/, "[?]" /*1089*/, "[?]" /*108a*/, "[?]" /*108b*/, "[?]" /*108c*/, "[?]" /*108d*/, "[?]" /*108e*/, "[?]" /*108f*/, "[?]" /*1090*/, "[?]" /*1091*/, "[?]" /*1092*/, "[?]" /*1093*/, "[?]" /*1094*/, "[?]" /*1095*/, "[?]" /*1096*/, "[?]" /*1097*/, "[?]" /*1098*/, "[?]" /*1099*/, "[?]" /*109a*/, "[?]" /*109b*/, "[?]" /*109c*/, "[?]" /*109d*/, "[?]" /*109e*/, "[?]" /*109f*/, "A" /*10a0*/, "B" /*10a1*/, "G" /*10a2*/, "D" /*10a3*/, "E" /*10a4*/, "V" /*10a5*/, "Z" /*10a6*/, "T`" /*10a7*/, "I" /*10a8*/, "K" /*10a9*/, "L" /*10aa*/, "M" /*10ab*/, "N" /*10ac*/, "O" /*10ad*/, "P" /*10ae*/, "Zh" /*10af*/, "R" /*10b0*/, "S" /*10b1*/, "T" /*10b2*/, "U" /*10b3*/, "P`" /*10b4*/, "K`" /*10b5*/, "G'" /*10b6*/, "Q" /*10b7*/, "Sh" /*10b8*/, "Ch`" /*10b9*/, "C`" /*10ba*/, "Z'" /*10bb*/, "C" /*10bc*/, "Ch" /*10bd*/, "X" /*10be*/, "J" /*10bf*/, "H" /*10c0*/, "E" /*10c1*/, "Y" /*10c2*/, "W" /*10c3*/, "Xh" /*10c4*/, "OE" /*10c5*/, "[?]" /*10c6*/, "[?]" /*10c7*/, "[?]" /*10c8*/, "[?]" /*10c9*/, "[?]" /*10ca*/, "[?]" /*10cb*/, "[?]" /*10cc*/, "[?]" /*10cd*/, "[?]" /*10ce*/, "[?]" /*10cf*/, "a" /*10d0*/, "b" /*10d1*/, "g" /*10d2*/, "d" /*10d3*/, "e" /*10d4*/, "v" /*10d5*/, "z" /*10d6*/, "t`" /*10d7*/, "i" /*10d8*/, "k" /*10d9*/, "l" /*10da*/, "m" /*10db*/, "n" /*10dc*/, "o" /*10dd*/, "p" /*10de*/, "zh" /*10df*/, "r" /*10e0*/, "s" /*10e1*/, "t" /*10e2*/, "u" /*10e3*/, "p`" /*10e4*/, "k`" /*10e5*/, "g'" /*10e6*/, "q" /*10e7*/, "sh" /*10e8*/, "ch`" /*10e9*/, "c`" /*10ea*/, "z'" /*10eb*/, "c" /*10ec*/, "ch" /*10ed*/, "x" /*10ee*/, "j" /*10ef*/, "h" /*10f0*/, "e" /*10f1*/, "y" /*10f2*/, "w" /*10f3*/, "xh" /*10f4*/, "oe" /*10f5*/, "f" /*10f6*/, "[?]" /*10f7*/, "[?]" /*10f8*/, "[?]" /*10f9*/, "[?]" /*10fa*/, " // " /*10fb*/, "[?]" /*10fc*/, "[?]" /*10fd*/, "[?]" /*10fe*/, 
			});
						characters.TryAdd(17 /*4352 11*/, new string[] {
				"g" /*1100*/, "gg" /*1101*/, "n" /*1102*/, "d" /*1103*/, "dd" /*1104*/, "r" /*1105*/, "m" /*1106*/, "b" /*1107*/, "bb" /*1108*/, "s" /*1109*/, "ss" /*110a*/, "" /*110b*/, "j" /*110c*/, "jj" /*110d*/, "c" /*110e*/, "k" /*110f*/, "t" /*1110*/, "p" /*1111*/, "h" /*1112*/, "ng" /*1113*/, "nn" /*1114*/, "nd" /*1115*/, "nb" /*1116*/, "dg" /*1117*/, "rn" /*1118*/, "rr" /*1119*/, "rh" /*111a*/, "rN" /*111b*/, "mb" /*111c*/, "mN" /*111d*/, "bg" /*111e*/, "bn" /*111f*/, "" /*1120*/, "bs" /*1121*/, "bsg" /*1122*/, "bst" /*1123*/, "bsb" /*1124*/, "bss" /*1125*/, "bsj" /*1126*/, "bj" /*1127*/, "bc" /*1128*/, "bt" /*1129*/, "bp" /*112a*/, "bN" /*112b*/, "bbN" /*112c*/, "sg" /*112d*/, "sn" /*112e*/, "sd" /*112f*/, "sr" /*1130*/, "sm" /*1131*/, "sb" /*1132*/, "sbg" /*1133*/, "sss" /*1134*/, "s" /*1135*/, "sj" /*1136*/, "sc" /*1137*/, "sk" /*1138*/, "st" /*1139*/, "sp" /*113a*/, "sh" /*113b*/, "" /*113c*/, "" /*113d*/, "" /*113e*/, "" /*113f*/, "Z" /*1140*/, "g" /*1141*/, "d" /*1142*/, "m" /*1143*/, "b" /*1144*/, "s" /*1145*/, "Z" /*1146*/, "" /*1147*/, "j" /*1148*/, "c" /*1149*/, "t" /*114a*/, "p" /*114b*/, "N" /*114c*/, "j" /*114d*/, "" /*114e*/, "" /*114f*/, "" /*1150*/, "" /*1151*/, "ck" /*1152*/, "ch" /*1153*/, "" /*1154*/, "" /*1155*/, "pb" /*1156*/, "pN" /*1157*/, "hh" /*1158*/, "Q" /*1159*/, "[?]" /*115a*/, "[?]" /*115b*/, "[?]" /*115c*/, "[?]" /*115d*/, "[?]" /*115e*/, "" /*115f*/, "" /*1160*/, "a" /*1161*/, "ae" /*1162*/, "ya" /*1163*/, "yae" /*1164*/, "eo" /*1165*/, "e" /*1166*/, "yeo" /*1167*/, "ye" /*1168*/, "o" /*1169*/, "wa" /*116a*/, "wae" /*116b*/, "oe" /*116c*/, "yo" /*116d*/, "u" /*116e*/, "weo" /*116f*/, "we" /*1170*/, "wi" /*1171*/, "yu" /*1172*/, "eu" /*1173*/, "yi" /*1174*/, "i" /*1175*/, "a-o" /*1176*/, "a-u" /*1177*/, "ya-o" /*1178*/, "ya-yo" /*1179*/, "eo-o" /*117a*/, "eo-u" /*117b*/, "eo-eu" /*117c*/, "yeo-o" /*117d*/, "yeo-u" /*117e*/, "o-eo" /*117f*/, "o-e" /*1180*/, "o-ye" /*1181*/, "o-o" /*1182*/, "o-u" /*1183*/, "yo-ya" /*1184*/, "yo-yae" /*1185*/, "yo-yeo" /*1186*/, "yo-o" /*1187*/, "yo-i" /*1188*/, "u-a" /*1189*/, "u-ae" /*118a*/, "u-eo-eu" /*118b*/, "u-ye" /*118c*/, "u-u" /*118d*/, "yu-a" /*118e*/, "yu-eo" /*118f*/, "yu-e" /*1190*/, "yu-yeo" /*1191*/, "yu-ye" /*1192*/, "yu-u" /*1193*/, "yu-i" /*1194*/, "eu-u" /*1195*/, "eu-eu" /*1196*/, "yi-u" /*1197*/, "i-a" /*1198*/, "i-ya" /*1199*/, "i-o" /*119a*/, "i-u" /*119b*/, "i-eu" /*119c*/, "i-U" /*119d*/, "U" /*119e*/, "U-eo" /*119f*/, "U-u" /*11a0*/, "U-i" /*11a1*/, "UU" /*11a2*/, "[?]" /*11a3*/, "[?]" /*11a4*/, "[?]" /*11a5*/, "[?]" /*11a6*/, "[?]" /*11a7*/, "g" /*11a8*/, "gg" /*11a9*/, "gs" /*11aa*/, "n" /*11ab*/, "nj" /*11ac*/, "nh" /*11ad*/, "d" /*11ae*/, "l" /*11af*/, "lg" /*11b0*/, "lm" /*11b1*/, "lb" /*11b2*/, "ls" /*11b3*/, "lt" /*11b4*/, "lp" /*11b5*/, "lh" /*11b6*/, "m" /*11b7*/, "b" /*11b8*/, "bs" /*11b9*/, "s" /*11ba*/, "ss" /*11bb*/, "ng" /*11bc*/, "j" /*11bd*/, "c" /*11be*/, "k" /*11bf*/, "t" /*11c0*/, "p" /*11c1*/, "h" /*11c2*/, "gl" /*11c3*/, "gsg" /*11c4*/, "ng" /*11c5*/, "nd" /*11c6*/, "ns" /*11c7*/, "nZ" /*11c8*/, "nt" /*11c9*/, "dg" /*11ca*/, "tl" /*11cb*/, "lgs" /*11cc*/, "ln" /*11cd*/, "ld" /*11ce*/, "lth" /*11cf*/, "ll" /*11d0*/, "lmg" /*11d1*/, "lms" /*11d2*/, "lbs" /*11d3*/, "lbh" /*11d4*/, "rNp" /*11d5*/, "lss" /*11d6*/, "lZ" /*11d7*/, "lk" /*11d8*/, "lQ" /*11d9*/, "mg" /*11da*/, "ml" /*11db*/, "mb" /*11dc*/, "ms" /*11dd*/, "mss" /*11de*/, "mZ" /*11df*/, "mc" /*11e0*/, "mh" /*11e1*/, "mN" /*11e2*/, "bl" /*11e3*/, "bp" /*11e4*/, "ph" /*11e5*/, "pN" /*11e6*/, "sg" /*11e7*/, "sd" /*11e8*/, "sl" /*11e9*/, "sb" /*11ea*/, "Z" /*11eb*/, "g" /*11ec*/, "ss" /*11ed*/, "" /*11ee*/, "kh" /*11ef*/, "N" /*11f0*/, "Ns" /*11f1*/, "NZ" /*11f2*/, "pb" /*11f3*/, "pN" /*11f4*/, "hn" /*11f5*/, "hl" /*11f6*/, "hm" /*11f7*/, "hb" /*11f8*/, "Q" /*11f9*/, "[?]" /*11fa*/, "[?]" /*11fb*/, "[?]" /*11fc*/, "[?]" /*11fd*/, "[?]" /*11fe*/, 
			});
						characters.TryAdd(18 /*4608 12*/, new string[] {
				"ha" /*1200*/, "hu" /*1201*/, "hi" /*1202*/, "haa" /*1203*/, "hee" /*1204*/, "he" /*1205*/, "ho" /*1206*/, "[?]" /*1207*/, "la" /*1208*/, "lu" /*1209*/, "li" /*120a*/, "laa" /*120b*/, "lee" /*120c*/, "le" /*120d*/, "lo" /*120e*/, "lwa" /*120f*/, "hha" /*1210*/, "hhu" /*1211*/, "hhi" /*1212*/, "hhaa" /*1213*/, "hhee" /*1214*/, "hhe" /*1215*/, "hho" /*1216*/, "hhwa" /*1217*/, "ma" /*1218*/, "mu" /*1219*/, "mi" /*121a*/, "maa" /*121b*/, "mee" /*121c*/, "me" /*121d*/, "mo" /*121e*/, "mwa" /*121f*/, "sza" /*1220*/, "szu" /*1221*/, "szi" /*1222*/, "szaa" /*1223*/, "szee" /*1224*/, "sze" /*1225*/, "szo" /*1226*/, "szwa" /*1227*/, "ra" /*1228*/, "ru" /*1229*/, "ri" /*122a*/, "raa" /*122b*/, "ree" /*122c*/, "re" /*122d*/, "ro" /*122e*/, "rwa" /*122f*/, "sa" /*1230*/, "su" /*1231*/, "si" /*1232*/, "saa" /*1233*/, "see" /*1234*/, "se" /*1235*/, "so" /*1236*/, "swa" /*1237*/, "sha" /*1238*/, "shu" /*1239*/, "shi" /*123a*/, "shaa" /*123b*/, "shee" /*123c*/, "she" /*123d*/, "sho" /*123e*/, "shwa" /*123f*/, "qa" /*1240*/, "qu" /*1241*/, "qi" /*1242*/, "qaa" /*1243*/, "qee" /*1244*/, "qe" /*1245*/, "qo" /*1246*/, "[?]" /*1247*/, "qwa" /*1248*/, "[?]" /*1249*/, "qwi" /*124a*/, "qwaa" /*124b*/, "qwee" /*124c*/, "qwe" /*124d*/, "[?]" /*124e*/, "[?]" /*124f*/, "qha" /*1250*/, "qhu" /*1251*/, "qhi" /*1252*/, "qhaa" /*1253*/, "qhee" /*1254*/, "qhe" /*1255*/, "qho" /*1256*/, "[?]" /*1257*/, "qhwa" /*1258*/, "[?]" /*1259*/, "qhwi" /*125a*/, "qhwaa" /*125b*/, "qhwee" /*125c*/, "qhwe" /*125d*/, "[?]" /*125e*/, "[?]" /*125f*/, "ba" /*1260*/, "bu" /*1261*/, "bi" /*1262*/, "baa" /*1263*/, "bee" /*1264*/, "be" /*1265*/, "bo" /*1266*/, "bwa" /*1267*/, "va" /*1268*/, "vu" /*1269*/, "vi" /*126a*/, "vaa" /*126b*/, "vee" /*126c*/, "ve" /*126d*/, "vo" /*126e*/, "vwa" /*126f*/, "ta" /*1270*/, "tu" /*1271*/, "ti" /*1272*/, "taa" /*1273*/, "tee" /*1274*/, "te" /*1275*/, "to" /*1276*/, "twa" /*1277*/, "ca" /*1278*/, "cu" /*1279*/, "ci" /*127a*/, "caa" /*127b*/, "cee" /*127c*/, "ce" /*127d*/, "co" /*127e*/, "cwa" /*127f*/, "xa" /*1280*/, "xu" /*1281*/, "xi" /*1282*/, "xaa" /*1283*/, "xee" /*1284*/, "xe" /*1285*/, "xo" /*1286*/, "[?]" /*1287*/, "xwa" /*1288*/, "[?]" /*1289*/, "xwi" /*128a*/, "xwaa" /*128b*/, "xwee" /*128c*/, "xwe" /*128d*/, "[?]" /*128e*/, "[?]" /*128f*/, "na" /*1290*/, "nu" /*1291*/, "ni" /*1292*/, "naa" /*1293*/, "nee" /*1294*/, "ne" /*1295*/, "no" /*1296*/, "nwa" /*1297*/, "nya" /*1298*/, "nyu" /*1299*/, "nyi" /*129a*/, "nyaa" /*129b*/, "nyee" /*129c*/, "nye" /*129d*/, "nyo" /*129e*/, "nywa" /*129f*/, "'a" /*12a0*/, "'u" /*12a1*/, "[?]" /*12a2*/, "'aa" /*12a3*/, "'ee" /*12a4*/, "'e" /*12a5*/, "'o" /*12a6*/, "'wa" /*12a7*/, "ka" /*12a8*/, "ku" /*12a9*/, "ki" /*12aa*/, "kaa" /*12ab*/, "kee" /*12ac*/, "ke" /*12ad*/, "ko" /*12ae*/, "[?]" /*12af*/, "kwa" /*12b0*/, "[?]" /*12b1*/, "kwi" /*12b2*/, "kwaa" /*12b3*/, "kwee" /*12b4*/, "kwe" /*12b5*/, "[?]" /*12b6*/, "[?]" /*12b7*/, "kxa" /*12b8*/, "kxu" /*12b9*/, "kxi" /*12ba*/, "kxaa" /*12bb*/, "kxee" /*12bc*/, "kxe" /*12bd*/, "kxo" /*12be*/, "[?]" /*12bf*/, "kxwa" /*12c0*/, "[?]" /*12c1*/, "kxwi" /*12c2*/, "kxwaa" /*12c3*/, "kxwee" /*12c4*/, "kxwe" /*12c5*/, "[?]" /*12c6*/, "[?]" /*12c7*/, "wa" /*12c8*/, "wu" /*12c9*/, "wi" /*12ca*/, "waa" /*12cb*/, "wee" /*12cc*/, "we" /*12cd*/, "wo" /*12ce*/, "[?]" /*12cf*/, "`a" /*12d0*/, "`u" /*12d1*/, "`i" /*12d2*/, "`aa" /*12d3*/, "`ee" /*12d4*/, "`e" /*12d5*/, "`o" /*12d6*/, "[?]" /*12d7*/, "za" /*12d8*/, "zu" /*12d9*/, "zi" /*12da*/, "zaa" /*12db*/, "zee" /*12dc*/, "ze" /*12dd*/, "zo" /*12de*/, "zwa" /*12df*/, "zha" /*12e0*/, "zhu" /*12e1*/, "zhi" /*12e2*/, "zhaa" /*12e3*/, "zhee" /*12e4*/, "zhe" /*12e5*/, "zho" /*12e6*/, "zhwa" /*12e7*/, "ya" /*12e8*/, "yu" /*12e9*/, "yi" /*12ea*/, "yaa" /*12eb*/, "yee" /*12ec*/, "ye" /*12ed*/, "yo" /*12ee*/, "[?]" /*12ef*/, "da" /*12f0*/, "du" /*12f1*/, "di" /*12f2*/, "daa" /*12f3*/, "dee" /*12f4*/, "de" /*12f5*/, "do" /*12f6*/, "dwa" /*12f7*/, "dda" /*12f8*/, "ddu" /*12f9*/, "ddi" /*12fa*/, "ddaa" /*12fb*/, "ddee" /*12fc*/, "dde" /*12fd*/, "ddo" /*12fe*/, "ddwa" /*12ff*/ 
			});
						characters.TryAdd(19 /*4864 13*/, new string[] {
				"ja" /*1300*/, "ju" /*1301*/, "ji" /*1302*/, "jaa" /*1303*/, "jee" /*1304*/, "je" /*1305*/, "jo" /*1306*/, "jwa" /*1307*/, "ga" /*1308*/, "gu" /*1309*/, "gi" /*130a*/, "gaa" /*130b*/, "gee" /*130c*/, "ge" /*130d*/, "go" /*130e*/, "[?]" /*130f*/, "gwa" /*1310*/, "[?]" /*1311*/, "gwi" /*1312*/, "gwaa" /*1313*/, "gwee" /*1314*/, "gwe" /*1315*/, "[?]" /*1316*/, "[?]" /*1317*/, "gga" /*1318*/, "ggu" /*1319*/, "ggi" /*131a*/, "ggaa" /*131b*/, "ggee" /*131c*/, "gge" /*131d*/, "ggo" /*131e*/, "[?]" /*131f*/, "tha" /*1320*/, "thu" /*1321*/, "thi" /*1322*/, "thaa" /*1323*/, "thee" /*1324*/, "the" /*1325*/, "tho" /*1326*/, "thwa" /*1327*/, "cha" /*1328*/, "chu" /*1329*/, "chi" /*132a*/, "chaa" /*132b*/, "chee" /*132c*/, "che" /*132d*/, "cho" /*132e*/, "chwa" /*132f*/, "pha" /*1330*/, "phu" /*1331*/, "phi" /*1332*/, "phaa" /*1333*/, "phee" /*1334*/, "phe" /*1335*/, "pho" /*1336*/, "phwa" /*1337*/, "tsa" /*1338*/, "tsu" /*1339*/, "tsi" /*133a*/, "tsaa" /*133b*/, "tsee" /*133c*/, "tse" /*133d*/, "tso" /*133e*/, "tswa" /*133f*/, "tza" /*1340*/, "tzu" /*1341*/, "tzi" /*1342*/, "tzaa" /*1343*/, "tzee" /*1344*/, "tze" /*1345*/, "tzo" /*1346*/, "[?]" /*1347*/, "fa" /*1348*/, "fu" /*1349*/, "fi" /*134a*/, "faa" /*134b*/, "fee" /*134c*/, "fe" /*134d*/, "fo" /*134e*/, "fwa" /*134f*/, "pa" /*1350*/, "pu" /*1351*/, "pi" /*1352*/, "paa" /*1353*/, "pee" /*1354*/, "pe" /*1355*/, "po" /*1356*/, "pwa" /*1357*/, "rya" /*1358*/, "mya" /*1359*/, "fya" /*135a*/, "[?]" /*135b*/, "[?]" /*135c*/, "[?]" /*135d*/, "[?]" /*135e*/, "[?]" /*135f*/, "[?]" /*1360*/, " " /*1361*/, "." /*1362*/, "," /*1363*/, ";" /*1364*/, ":" /*1365*/, ":: " /*1366*/, "?" /*1367*/, "//" /*1368*/, "1" /*1369*/, "2" /*136a*/, "3" /*136b*/, "4" /*136c*/, "5" /*136d*/, "6" /*136e*/, "7" /*136f*/, "8" /*1370*/, "9" /*1371*/, "10+" /*1372*/, "20+" /*1373*/, "30+" /*1374*/, "40+" /*1375*/, "50+" /*1376*/, "60+" /*1377*/, "70+" /*1378*/, "80+" /*1379*/, "90+" /*137a*/, "100+" /*137b*/, "10,000+" /*137c*/, "[?]" /*137d*/, "[?]" /*137e*/, "[?]" /*137f*/, "[?]" /*1380*/, "[?]" /*1381*/, "[?]" /*1382*/, "[?]" /*1383*/, "[?]" /*1384*/, "[?]" /*1385*/, "[?]" /*1386*/, "[?]" /*1387*/, "[?]" /*1388*/, "[?]" /*1389*/, "[?]" /*138a*/, "[?]" /*138b*/, "[?]" /*138c*/, "[?]" /*138d*/, "[?]" /*138e*/, "[?]" /*138f*/, "[?]" /*1390*/, "[?]" /*1391*/, "[?]" /*1392*/, "[?]" /*1393*/, "[?]" /*1394*/, "[?]" /*1395*/, "[?]" /*1396*/, "[?]" /*1397*/, "[?]" /*1398*/, "[?]" /*1399*/, "[?]" /*139a*/, "[?]" /*139b*/, "[?]" /*139c*/, "[?]" /*139d*/, "[?]" /*139e*/, "[?]" /*139f*/, "a" /*13a0*/, "e" /*13a1*/, "i" /*13a2*/, "o" /*13a3*/, "u" /*13a4*/, "v" /*13a5*/, "ga" /*13a6*/, "ka" /*13a7*/, "ge" /*13a8*/, "gi" /*13a9*/, "go" /*13aa*/, "gu" /*13ab*/, "gv" /*13ac*/, "ha" /*13ad*/, "he" /*13ae*/, "hi" /*13af*/, "ho" /*13b0*/, "hu" /*13b1*/, "hv" /*13b2*/, "la" /*13b3*/, "le" /*13b4*/, "li" /*13b5*/, "lo" /*13b6*/, "lu" /*13b7*/, "lv" /*13b8*/, "ma" /*13b9*/, "me" /*13ba*/, "mi" /*13bb*/, "mo" /*13bc*/, "mu" /*13bd*/, "na" /*13be*/, "hna" /*13bf*/, "nah" /*13c0*/, "ne" /*13c1*/, "ni" /*13c2*/, "no" /*13c3*/, "nu" /*13c4*/, "nv" /*13c5*/, "qua" /*13c6*/, "que" /*13c7*/, "qui" /*13c8*/, "quo" /*13c9*/, "quu" /*13ca*/, "quv" /*13cb*/, "sa" /*13cc*/, "s" /*13cd*/, "se" /*13ce*/, "si" /*13cf*/, "so" /*13d0*/, "su" /*13d1*/, "sv" /*13d2*/, "da" /*13d3*/, "ta" /*13d4*/, "de" /*13d5*/, "te" /*13d6*/, "di" /*13d7*/, "ti" /*13d8*/, "do" /*13d9*/, "du" /*13da*/, "dv" /*13db*/, "dla" /*13dc*/, "tla" /*13dd*/, "tle" /*13de*/, "tli" /*13df*/, "tlo" /*13e0*/, "tlu" /*13e1*/, "tlv" /*13e2*/, "tsa" /*13e3*/, "tse" /*13e4*/, "tsi" /*13e5*/, "tso" /*13e6*/, "tsu" /*13e7*/, "tsv" /*13e8*/, "wa" /*13e9*/, "we" /*13ea*/, "wi" /*13eb*/, "wo" /*13ec*/, "wu" /*13ed*/, "wv" /*13ee*/, "ya" /*13ef*/, "ye" /*13f0*/, "yi" /*13f1*/, "yo" /*13f2*/, "yu" /*13f3*/, "yv" /*13f4*/, "[?]" /*13f5*/, "[?]" /*13f6*/, "[?]" /*13f7*/, "[?]" /*13f8*/, "[?]" /*13f9*/, "[?]" /*13fa*/, "[?]" /*13fb*/, "[?]" /*13fc*/, "[?]" /*13fd*/, "[?]" /*13fe*/, 
			});
						characters.TryAdd(20 /*5120 14*/, new string[] {
				"[?]" /*1400*/, "e" /*1401*/, "aai" /*1402*/, "i" /*1403*/, "ii" /*1404*/, "o" /*1405*/, "oo" /*1406*/, "oo" /*1407*/, "ee" /*1408*/, "i" /*1409*/, "a" /*140a*/, "aa" /*140b*/, "we" /*140c*/, "we" /*140d*/, "wi" /*140e*/, "wi" /*140f*/, "wii" /*1410*/, "wii" /*1411*/, "wo" /*1412*/, "wo" /*1413*/, "woo" /*1414*/, "woo" /*1415*/, "woo" /*1416*/, "wa" /*1417*/, "wa" /*1418*/, "waa" /*1419*/, "waa" /*141a*/, "waa" /*141b*/, "ai" /*141c*/, "w" /*141d*/, "'" /*141e*/, "t" /*141f*/, "k" /*1420*/, "sh" /*1421*/, "s" /*1422*/, "n" /*1423*/, "w" /*1424*/, "n" /*1425*/, "[?]" /*1426*/, "w" /*1427*/, "c" /*1428*/, "?" /*1429*/, "l" /*142a*/, "en" /*142b*/, "in" /*142c*/, "on" /*142d*/, "an" /*142e*/, "pe" /*142f*/, "paai" /*1430*/, "pi" /*1431*/, "pii" /*1432*/, "po" /*1433*/, "poo" /*1434*/, "poo" /*1435*/, "hee" /*1436*/, "hi" /*1437*/, "pa" /*1438*/, "paa" /*1439*/, "pwe" /*143a*/, "pwe" /*143b*/, "pwi" /*143c*/, "pwi" /*143d*/, "pwii" /*143e*/, "pwii" /*143f*/, "pwo" /*1440*/, "pwo" /*1441*/, "pwoo" /*1442*/, "pwoo" /*1443*/, "pwa" /*1444*/, "pwa" /*1445*/, "pwaa" /*1446*/, "pwaa" /*1447*/, "pwaa" /*1448*/, "p" /*1449*/, "p" /*144a*/, "h" /*144b*/, "te" /*144c*/, "taai" /*144d*/, "ti" /*144e*/, "tii" /*144f*/, "to" /*1450*/, "too" /*1451*/, "too" /*1452*/, "dee" /*1453*/, "di" /*1454*/, "ta" /*1455*/, "taa" /*1456*/, "twe" /*1457*/, "twe" /*1458*/, "twi" /*1459*/, "twi" /*145a*/, "twii" /*145b*/, "twii" /*145c*/, "two" /*145d*/, "two" /*145e*/, "twoo" /*145f*/, "twoo" /*1460*/, "twa" /*1461*/, "twa" /*1462*/, "twaa" /*1463*/, "twaa" /*1464*/, "twaa" /*1465*/, "t" /*1466*/, "tte" /*1467*/, "tti" /*1468*/, "tto" /*1469*/, "tta" /*146a*/, "ke" /*146b*/, "kaai" /*146c*/, "ki" /*146d*/, "kii" /*146e*/, "ko" /*146f*/, "koo" /*1470*/, "koo" /*1471*/, "ka" /*1472*/, "kaa" /*1473*/, "kwe" /*1474*/, "kwe" /*1475*/, "kwi" /*1476*/, "kwi" /*1477*/, "kwii" /*1478*/, "kwii" /*1479*/, "kwo" /*147a*/, "kwo" /*147b*/, "kwoo" /*147c*/, "kwoo" /*147d*/, "kwa" /*147e*/, "kwa" /*147f*/, "kwaa" /*1480*/, "kwaa" /*1481*/, "kwaa" /*1482*/, "k" /*1483*/, "kw" /*1484*/, "keh" /*1485*/, "kih" /*1486*/, "koh" /*1487*/, "kah" /*1488*/, "ce" /*1489*/, "caai" /*148a*/, "ci" /*148b*/, "cii" /*148c*/, "co" /*148d*/, "coo" /*148e*/, "coo" /*148f*/, "ca" /*1490*/, "caa" /*1491*/, "cwe" /*1492*/, "cwe" /*1493*/, "cwi" /*1494*/, "cwi" /*1495*/, "cwii" /*1496*/, "cwii" /*1497*/, "cwo" /*1498*/, "cwo" /*1499*/, "cwoo" /*149a*/, "cwoo" /*149b*/, "cwa" /*149c*/, "cwa" /*149d*/, "cwaa" /*149e*/, "cwaa" /*149f*/, "cwaa" /*14a0*/, "c" /*14a1*/, "th" /*14a2*/, "me" /*14a3*/, "maai" /*14a4*/, "mi" /*14a5*/, "mii" /*14a6*/, "mo" /*14a7*/, "moo" /*14a8*/, "moo" /*14a9*/, "ma" /*14aa*/, "maa" /*14ab*/, "mwe" /*14ac*/, "mwe" /*14ad*/, "mwi" /*14ae*/, "mwi" /*14af*/, "mwii" /*14b0*/, "mwii" /*14b1*/, "mwo" /*14b2*/, "mwo" /*14b3*/, "mwoo" /*14b4*/, "mwoo" /*14b5*/, "mwa" /*14b6*/, "mwa" /*14b7*/, "mwaa" /*14b8*/, "mwaa" /*14b9*/, "mwaa" /*14ba*/, "m" /*14bb*/, "m" /*14bc*/, "mh" /*14bd*/, "m" /*14be*/, "m" /*14bf*/, "ne" /*14c0*/, "naai" /*14c1*/, "ni" /*14c2*/, "nii" /*14c3*/, "no" /*14c4*/, "noo" /*14c5*/, "noo" /*14c6*/, "na" /*14c7*/, "naa" /*14c8*/, "nwe" /*14c9*/, "nwe" /*14ca*/, "nwa" /*14cb*/, "nwa" /*14cc*/, "nwaa" /*14cd*/, "nwaa" /*14ce*/, "nwaa" /*14cf*/, "n" /*14d0*/, "ng" /*14d1*/, "nh" /*14d2*/, "le" /*14d3*/, "laai" /*14d4*/, "li" /*14d5*/, "lii" /*14d6*/, "lo" /*14d7*/, "loo" /*14d8*/, "loo" /*14d9*/, "la" /*14da*/, "laa" /*14db*/, "lwe" /*14dc*/, "lwe" /*14dd*/, "lwi" /*14de*/, "lwi" /*14df*/, "lwii" /*14e0*/, "lwii" /*14e1*/, "lwo" /*14e2*/, "lwo" /*14e3*/, "lwoo" /*14e4*/, "lwoo" /*14e5*/, "lwa" /*14e6*/, "lwa" /*14e7*/, "lwaa" /*14e8*/, "lwaa" /*14e9*/, "l" /*14ea*/, "l" /*14eb*/, "l" /*14ec*/, "se" /*14ed*/, "saai" /*14ee*/, "si" /*14ef*/, "sii" /*14f0*/, "so" /*14f1*/, "soo" /*14f2*/, "soo" /*14f3*/, "sa" /*14f4*/, "saa" /*14f5*/, "swe" /*14f6*/, "swe" /*14f7*/, "swi" /*14f8*/, "swi" /*14f9*/, "swii" /*14fa*/, "swii" /*14fb*/, "swo" /*14fc*/, "swo" /*14fd*/, "swoo" /*14fe*/, "swoo" /*14ff*/ 
			});
						characters.TryAdd(21 /*5376 15*/, new string[] {
				"swa" /*1500*/, "swa" /*1501*/, "swaa" /*1502*/, "swaa" /*1503*/, "swaa" /*1504*/, "s" /*1505*/, "s" /*1506*/, "sw" /*1507*/, "s" /*1508*/, "sk" /*1509*/, "skw" /*150a*/, "sW" /*150b*/, "spwa" /*150c*/, "stwa" /*150d*/, "skwa" /*150e*/, "scwa" /*150f*/, "she" /*1510*/, "shi" /*1511*/, "shii" /*1512*/, "sho" /*1513*/, "shoo" /*1514*/, "sha" /*1515*/, "shaa" /*1516*/, "shwe" /*1517*/, "shwe" /*1518*/, "shwi" /*1519*/, "shwi" /*151a*/, "shwii" /*151b*/, "shwii" /*151c*/, "shwo" /*151d*/, "shwo" /*151e*/, "shwoo" /*151f*/, "shwoo" /*1520*/, "shwa" /*1521*/, "shwa" /*1522*/, "shwaa" /*1523*/, "shwaa" /*1524*/, "sh" /*1525*/, "ye" /*1526*/, "yaai" /*1527*/, "yi" /*1528*/, "yii" /*1529*/, "yo" /*152a*/, "yoo" /*152b*/, "yoo" /*152c*/, "ya" /*152d*/, "yaa" /*152e*/, "ywe" /*152f*/, "ywe" /*1530*/, "ywi" /*1531*/, "ywi" /*1532*/, "ywii" /*1533*/, "ywii" /*1534*/, "ywo" /*1535*/, "ywo" /*1536*/, "ywoo" /*1537*/, "ywoo" /*1538*/, "ywa" /*1539*/, "ywa" /*153a*/, "ywaa" /*153b*/, "ywaa" /*153c*/, "ywaa" /*153d*/, "y" /*153e*/, "y" /*153f*/, "y" /*1540*/, "yi" /*1541*/, "re" /*1542*/, "re" /*1543*/, "le" /*1544*/, "raai" /*1545*/, "ri" /*1546*/, "rii" /*1547*/, "ro" /*1548*/, "roo" /*1549*/, "lo" /*154a*/, "ra" /*154b*/, "raa" /*154c*/, "la" /*154d*/, "rwaa" /*154e*/, "rwaa" /*154f*/, "r" /*1550*/, "r" /*1551*/, "r" /*1552*/, "fe" /*1553*/, "faai" /*1554*/, "fi" /*1555*/, "fii" /*1556*/, "fo" /*1557*/, "foo" /*1558*/, "fa" /*1559*/, "faa" /*155a*/, "fwaa" /*155b*/, "fwaa" /*155c*/, "f" /*155d*/, "the" /*155e*/, "the" /*155f*/, "thi" /*1560*/, "thi" /*1561*/, "thii" /*1562*/, "thii" /*1563*/, "tho" /*1564*/, "thoo" /*1565*/, "tha" /*1566*/, "thaa" /*1567*/, "thwaa" /*1568*/, "thwaa" /*1569*/, "th" /*156a*/, "tthe" /*156b*/, "tthi" /*156c*/, "ttho" /*156d*/, "ttha" /*156e*/, "tth" /*156f*/, "tye" /*1570*/, "tyi" /*1571*/, "tyo" /*1572*/, "tya" /*1573*/, "he" /*1574*/, "hi" /*1575*/, "hii" /*1576*/, "ho" /*1577*/, "hoo" /*1578*/, "ha" /*1579*/, "haa" /*157a*/, "h" /*157b*/, "h" /*157c*/, "hk" /*157d*/, "qaai" /*157e*/, "qi" /*157f*/, "qii" /*1580*/, "qo" /*1581*/, "qoo" /*1582*/, "qa" /*1583*/, "qaa" /*1584*/, "q" /*1585*/, "tlhe" /*1586*/, "tlhi" /*1587*/, "tlho" /*1588*/, "tlha" /*1589*/, "re" /*158a*/, "ri" /*158b*/, "ro" /*158c*/, "ra" /*158d*/, "ngaai" /*158e*/, "ngi" /*158f*/, "ngii" /*1590*/, "ngo" /*1591*/, "ngoo" /*1592*/, "nga" /*1593*/, "ngaa" /*1594*/, "ng" /*1595*/, "nng" /*1596*/, "she" /*1597*/, "shi" /*1598*/, "sho" /*1599*/, "sha" /*159a*/, "the" /*159b*/, "thi" /*159c*/, "tho" /*159d*/, "tha" /*159e*/, "th" /*159f*/, "lhi" /*15a0*/, "lhii" /*15a1*/, "lho" /*15a2*/, "lhoo" /*15a3*/, "lha" /*15a4*/, "lhaa" /*15a5*/, "lh" /*15a6*/, "the" /*15a7*/, "thi" /*15a8*/, "thii" /*15a9*/, "tho" /*15aa*/, "thoo" /*15ab*/, "tha" /*15ac*/, "thaa" /*15ad*/, "th" /*15ae*/, "b" /*15af*/, "e" /*15b0*/, "i" /*15b1*/, "o" /*15b2*/, "a" /*15b3*/, "we" /*15b4*/, "wi" /*15b5*/, "wo" /*15b6*/, "wa" /*15b7*/, "ne" /*15b8*/, "ni" /*15b9*/, "no" /*15ba*/, "na" /*15bb*/, "ke" /*15bc*/, "ki" /*15bd*/, "ko" /*15be*/, "ka" /*15bf*/, "he" /*15c0*/, "hi" /*15c1*/, "ho" /*15c2*/, "ha" /*15c3*/, "ghu" /*15c4*/, "gho" /*15c5*/, "ghe" /*15c6*/, "ghee" /*15c7*/, "ghi" /*15c8*/, "gha" /*15c9*/, "ru" /*15ca*/, "ro" /*15cb*/, "re" /*15cc*/, "ree" /*15cd*/, "ri" /*15ce*/, "ra" /*15cf*/, "wu" /*15d0*/, "wo" /*15d1*/, "we" /*15d2*/, "wee" /*15d3*/, "wi" /*15d4*/, "wa" /*15d5*/, "hwu" /*15d6*/, "hwo" /*15d7*/, "hwe" /*15d8*/, "hwee" /*15d9*/, "hwi" /*15da*/, "hwa" /*15db*/, "thu" /*15dc*/, "tho" /*15dd*/, "the" /*15de*/, "thee" /*15df*/, "thi" /*15e0*/, "tha" /*15e1*/, "ttu" /*15e2*/, "tto" /*15e3*/, "tte" /*15e4*/, "ttee" /*15e5*/, "tti" /*15e6*/, "tta" /*15e7*/, "pu" /*15e8*/, "po" /*15e9*/, "pe" /*15ea*/, "pee" /*15eb*/, "pi" /*15ec*/, "pa" /*15ed*/, "p" /*15ee*/, "gu" /*15ef*/, "go" /*15f0*/, "ge" /*15f1*/, "gee" /*15f2*/, "gi" /*15f3*/, "ga" /*15f4*/, "khu" /*15f5*/, "kho" /*15f6*/, "khe" /*15f7*/, "khee" /*15f8*/, "khi" /*15f9*/, "kha" /*15fa*/, "kku" /*15fb*/, "kko" /*15fc*/, "kke" /*15fd*/, "kkee" /*15fe*/, "kki" /*15ff*/ 
			});
						characters.TryAdd(22 /*5632 16*/, new string[] {
				"kka" /*1600*/, "kk" /*1601*/, "nu" /*1602*/, "no" /*1603*/, "ne" /*1604*/, "nee" /*1605*/, "ni" /*1606*/, "na" /*1607*/, "mu" /*1608*/, "mo" /*1609*/, "me" /*160a*/, "mee" /*160b*/, "mi" /*160c*/, "ma" /*160d*/, "yu" /*160e*/, "yo" /*160f*/, "ye" /*1610*/, "yee" /*1611*/, "yi" /*1612*/, "ya" /*1613*/, "ju" /*1614*/, "ju" /*1615*/, "jo" /*1616*/, "je" /*1617*/, "jee" /*1618*/, "ji" /*1619*/, "ji" /*161a*/, "ja" /*161b*/, "jju" /*161c*/, "jjo" /*161d*/, "jje" /*161e*/, "jjee" /*161f*/, "jji" /*1620*/, "jja" /*1621*/, "lu" /*1622*/, "lo" /*1623*/, "le" /*1624*/, "lee" /*1625*/, "li" /*1626*/, "la" /*1627*/, "dlu" /*1628*/, "dlo" /*1629*/, "dle" /*162a*/, "dlee" /*162b*/, "dli" /*162c*/, "dla" /*162d*/, "lhu" /*162e*/, "lho" /*162f*/, "lhe" /*1630*/, "lhee" /*1631*/, "lhi" /*1632*/, "lha" /*1633*/, "tlhu" /*1634*/, "tlho" /*1635*/, "tlhe" /*1636*/, "tlhee" /*1637*/, "tlhi" /*1638*/, "tlha" /*1639*/, "tlu" /*163a*/, "tlo" /*163b*/, "tle" /*163c*/, "tlee" /*163d*/, "tli" /*163e*/, "tla" /*163f*/, "zu" /*1640*/, "zo" /*1641*/, "ze" /*1642*/, "zee" /*1643*/, "zi" /*1644*/, "za" /*1645*/, "z" /*1646*/, "z" /*1647*/, "dzu" /*1648*/, "dzo" /*1649*/, "dze" /*164a*/, "dzee" /*164b*/, "dzi" /*164c*/, "dza" /*164d*/, "su" /*164e*/, "so" /*164f*/, "se" /*1650*/, "see" /*1651*/, "si" /*1652*/, "sa" /*1653*/, "shu" /*1654*/, "sho" /*1655*/, "she" /*1656*/, "shee" /*1657*/, "shi" /*1658*/, "sha" /*1659*/, "sh" /*165a*/, "tsu" /*165b*/, "tso" /*165c*/, "tse" /*165d*/, "tsee" /*165e*/, "tsi" /*165f*/, "tsa" /*1660*/, "chu" /*1661*/, "cho" /*1662*/, "che" /*1663*/, "chee" /*1664*/, "chi" /*1665*/, "cha" /*1666*/, "ttsu" /*1667*/, "ttso" /*1668*/, "ttse" /*1669*/, "ttsee" /*166a*/, "ttsi" /*166b*/, "ttsa" /*166c*/, "X" /*166d*/, "." /*166e*/, "qai" /*166f*/, "ngai" /*1670*/, "nngi" /*1671*/, "nngii" /*1672*/, "nngo" /*1673*/, "nngoo" /*1674*/, "nnga" /*1675*/, "nngaa" /*1676*/, "[?]" /*1677*/, "[?]" /*1678*/, "[?]" /*1679*/, "[?]" /*167a*/, "[?]" /*167b*/, "[?]" /*167c*/, "[?]" /*167d*/, "[?]" /*167e*/, "[?]" /*167f*/, " " /*1680*/, "b" /*1681*/, "l" /*1682*/, "f" /*1683*/, "s" /*1684*/, "n" /*1685*/, "h" /*1686*/, "d" /*1687*/, "t" /*1688*/, "c" /*1689*/, "q" /*168a*/, "m" /*168b*/, "g" /*168c*/, "ng" /*168d*/, "z" /*168e*/, "r" /*168f*/, "a" /*1690*/, "o" /*1691*/, "u" /*1692*/, "e" /*1693*/, "i" /*1694*/, "ch" /*1695*/, "th" /*1696*/, "ph" /*1697*/, "p" /*1698*/, "x" /*1699*/, "p" /*169a*/, "<" /*169b*/, ">" /*169c*/, "[?]" /*169d*/, "[?]" /*169e*/, "[?]" /*169f*/, "f" /*16a0*/, "v" /*16a1*/, "u" /*16a2*/, "yr" /*16a3*/, "y" /*16a4*/, "w" /*16a5*/, "th" /*16a6*/, "th" /*16a7*/, "a" /*16a8*/, "o" /*16a9*/, "ac" /*16aa*/, "ae" /*16ab*/, "o" /*16ac*/, "o" /*16ad*/, "o" /*16ae*/, "oe" /*16af*/, "on" /*16b0*/, "r" /*16b1*/, "k" /*16b2*/, "c" /*16b3*/, "k" /*16b4*/, "g" /*16b5*/, "ng" /*16b6*/, "g" /*16b7*/, "g" /*16b8*/, "w" /*16b9*/, "h" /*16ba*/, "h" /*16bb*/, "h" /*16bc*/, "h" /*16bd*/, "n" /*16be*/, "n" /*16bf*/, "n" /*16c0*/, "i" /*16c1*/, "e" /*16c2*/, "j" /*16c3*/, "g" /*16c4*/, "ae" /*16c5*/, "a" /*16c6*/, "eo" /*16c7*/, "p" /*16c8*/, "z" /*16c9*/, "s" /*16ca*/, "s" /*16cb*/, "s" /*16cc*/, "c" /*16cd*/, "z" /*16ce*/, "t" /*16cf*/, "t" /*16d0*/, "d" /*16d1*/, "b" /*16d2*/, "b" /*16d3*/, "p" /*16d4*/, "p" /*16d5*/, "e" /*16d6*/, "m" /*16d7*/, "m" /*16d8*/, "m" /*16d9*/, "l" /*16da*/, "l" /*16db*/, "ng" /*16dc*/, "ng" /*16dd*/, "d" /*16de*/, "o" /*16df*/, "ear" /*16e0*/, "ior" /*16e1*/, "qu" /*16e2*/, "qu" /*16e3*/, "qu" /*16e4*/, "s" /*16e5*/, "yr" /*16e6*/, "yr" /*16e7*/, "yr" /*16e8*/, "q" /*16e9*/, "x" /*16ea*/, "." /*16eb*/, ":" /*16ec*/, "+" /*16ed*/, "17" /*16ee*/, "18" /*16ef*/, "19" /*16f0*/, "[?]" /*16f1*/, "[?]" /*16f2*/, "[?]" /*16f3*/, "[?]" /*16f4*/, "[?]" /*16f5*/, "[?]" /*16f6*/, "[?]" /*16f7*/, "[?]" /*16f8*/, "[?]" /*16f9*/, "[?]" /*16fa*/, "[?]" /*16fb*/, "[?]" /*16fc*/, "[?]" /*16fd*/, "[?]" /*16fe*/, 
			});
						characters.TryAdd(23 /*5888 17*/, new string[] {
				"[?]" /*1700*/, "[?]" /*1701*/, "[?]" /*1702*/, "[?]" /*1703*/, "[?]" /*1704*/, "[?]" /*1705*/, "[?]" /*1706*/, "[?]" /*1707*/, "[?]" /*1708*/, "[?]" /*1709*/, "[?]" /*170a*/, "[?]" /*170b*/, "[?]" /*170c*/, "[?]" /*170d*/, "[?]" /*170e*/, "[?]" /*170f*/, "[?]" /*1710*/, "[?]" /*1711*/, "[?]" /*1712*/, "[?]" /*1713*/, "[?]" /*1714*/, "[?]" /*1715*/, "[?]" /*1716*/, "[?]" /*1717*/, "[?]" /*1718*/, "[?]" /*1719*/, "[?]" /*171a*/, "[?]" /*171b*/, "[?]" /*171c*/, "[?]" /*171d*/, "[?]" /*171e*/, "[?]" /*171f*/, "[?]" /*1720*/, "[?]" /*1721*/, "[?]" /*1722*/, "[?]" /*1723*/, "[?]" /*1724*/, "[?]" /*1725*/, "[?]" /*1726*/, "[?]" /*1727*/, "[?]" /*1728*/, "[?]" /*1729*/, "[?]" /*172a*/, "[?]" /*172b*/, "[?]" /*172c*/, "[?]" /*172d*/, "[?]" /*172e*/, "[?]" /*172f*/, "[?]" /*1730*/, "[?]" /*1731*/, "[?]" /*1732*/, "[?]" /*1733*/, "[?]" /*1734*/, "[?]" /*1735*/, "[?]" /*1736*/, "[?]" /*1737*/, "[?]" /*1738*/, "[?]" /*1739*/, "[?]" /*173a*/, "[?]" /*173b*/, "[?]" /*173c*/, "[?]" /*173d*/, "[?]" /*173e*/, "[?]" /*173f*/, "[?]" /*1740*/, "[?]" /*1741*/, "[?]" /*1742*/, "[?]" /*1743*/, "[?]" /*1744*/, "[?]" /*1745*/, "[?]" /*1746*/, "[?]" /*1747*/, "[?]" /*1748*/, "[?]" /*1749*/, "[?]" /*174a*/, "[?]" /*174b*/, "[?]" /*174c*/, "[?]" /*174d*/, "[?]" /*174e*/, "[?]" /*174f*/, "[?]" /*1750*/, "[?]" /*1751*/, "[?]" /*1752*/, "[?]" /*1753*/, "[?]" /*1754*/, "[?]" /*1755*/, "[?]" /*1756*/, "[?]" /*1757*/, "[?]" /*1758*/, "[?]" /*1759*/, "[?]" /*175a*/, "[?]" /*175b*/, "[?]" /*175c*/, "[?]" /*175d*/, "[?]" /*175e*/, "[?]" /*175f*/, "[?]" /*1760*/, "[?]" /*1761*/, "[?]" /*1762*/, "[?]" /*1763*/, "[?]" /*1764*/, "[?]" /*1765*/, "[?]" /*1766*/, "[?]" /*1767*/, "[?]" /*1768*/, "[?]" /*1769*/, "[?]" /*176a*/, "[?]" /*176b*/, "[?]" /*176c*/, "[?]" /*176d*/, "[?]" /*176e*/, "[?]" /*176f*/, "[?]" /*1770*/, "[?]" /*1771*/, "[?]" /*1772*/, "[?]" /*1773*/, "[?]" /*1774*/, "[?]" /*1775*/, "[?]" /*1776*/, "[?]" /*1777*/, "[?]" /*1778*/, "[?]" /*1779*/, "[?]" /*177a*/, "[?]" /*177b*/, "[?]" /*177c*/, "[?]" /*177d*/, "[?]" /*177e*/, "[?]" /*177f*/, "k" /*1780*/, "kh" /*1781*/, "g" /*1782*/, "gh" /*1783*/, "ng" /*1784*/, "c" /*1785*/, "ch" /*1786*/, "j" /*1787*/, "jh" /*1788*/, "ny" /*1789*/, "t" /*178a*/, "tth" /*178b*/, "d" /*178c*/, "ddh" /*178d*/, "nn" /*178e*/, "t" /*178f*/, "th" /*1790*/, "d" /*1791*/, "dh" /*1792*/, "n" /*1793*/, "p" /*1794*/, "ph" /*1795*/, "b" /*1796*/, "bh" /*1797*/, "m" /*1798*/, "y" /*1799*/, "r" /*179a*/, "l" /*179b*/, "v" /*179c*/, "sh" /*179d*/, "ss" /*179e*/, "s" /*179f*/, "h" /*17a0*/, "l" /*17a1*/, "q" /*17a2*/, "a" /*17a3*/, "aa" /*17a4*/, "i" /*17a5*/, "ii" /*17a6*/, "u" /*17a7*/, "uk" /*17a8*/, "uu" /*17a9*/, "uuv" /*17aa*/, "ry" /*17ab*/, "ryy" /*17ac*/, "ly" /*17ad*/, "lyy" /*17ae*/, "e" /*17af*/, "ai" /*17b0*/, "oo" /*17b1*/, "oo" /*17b2*/, "au" /*17b3*/, "a" /*17b4*/, "aa" /*17b5*/, "aa" /*17b6*/, "i" /*17b7*/, "ii" /*17b8*/, "y" /*17b9*/, "yy" /*17ba*/, "u" /*17bb*/, "uu" /*17bc*/, "ua" /*17bd*/, "oe" /*17be*/, "ya" /*17bf*/, "ie" /*17c0*/, "e" /*17c1*/, "ae" /*17c2*/, "ai" /*17c3*/, "oo" /*17c4*/, "au" /*17c5*/, "M" /*17c6*/, "H" /*17c7*/, "a`" /*17c8*/, "" /*17c9*/, "" /*17ca*/, "" /*17cb*/, "r" /*17cc*/, "" /*17cd*/, "!" /*17ce*/, "" /*17cf*/, "" /*17d0*/, "" /*17d1*/, "" /*17d2*/, "" /*17d3*/, "." /*17d4*/, " // " /*17d5*/, ":" /*17d6*/, "+" /*17d7*/, "++" /*17d8*/, " * " /*17d9*/, " /// " /*17da*/, "KR" /*17db*/, "'" /*17dc*/, "[?]" /*17dd*/, "[?]" /*17de*/, "[?]" /*17df*/, "0" /*17e0*/, "1" /*17e1*/, "2" /*17e2*/, "3" /*17e3*/, "4" /*17e4*/, "5" /*17e5*/, "6" /*17e6*/, "7" /*17e7*/, "8" /*17e8*/, "9" /*17e9*/, "[?]" /*17ea*/, "[?]" /*17eb*/, "[?]" /*17ec*/, "[?]" /*17ed*/, "[?]" /*17ee*/, "[?]" /*17ef*/, "[?]" /*17f0*/, "[?]" /*17f1*/, "[?]" /*17f2*/, "[?]" /*17f3*/, "[?]" /*17f4*/, "[?]" /*17f5*/, "[?]" /*17f6*/, "[?]" /*17f7*/, "[?]" /*17f8*/, "[?]" /*17f9*/, "[?]" /*17fa*/, "[?]" /*17fb*/, "[?]" /*17fc*/, "[?]" /*17fd*/, "[?]" /*17fe*/, 
			});
						characters.TryAdd(24 /*6144 18*/, new string[] {
				" @ " /*1800*/, " ... " /*1801*/, ", " /*1802*/, ". " /*1803*/, ": " /*1804*/, " // " /*1805*/, "" /*1806*/, "-" /*1807*/, ", " /*1808*/, ". " /*1809*/, "" /*180a*/, "" /*180b*/, "" /*180c*/, "" /*180d*/, "" /*180e*/, "[?]" /*180f*/, "0" /*1810*/, "1" /*1811*/, "2" /*1812*/, "3" /*1813*/, "4" /*1814*/, "5" /*1815*/, "6" /*1816*/, "7" /*1817*/, "8" /*1818*/, "9" /*1819*/, "[?]" /*181a*/, "[?]" /*181b*/, "[?]" /*181c*/, "[?]" /*181d*/, "[?]" /*181e*/, "[?]" /*181f*/, "a" /*1820*/, "e" /*1821*/, "i" /*1822*/, "o" /*1823*/, "u" /*1824*/, "O" /*1825*/, "U" /*1826*/, "ee" /*1827*/, "n" /*1828*/, "ng" /*1829*/, "b" /*182a*/, "p" /*182b*/, "q" /*182c*/, "g" /*182d*/, "m" /*182e*/, "l" /*182f*/, "s" /*1830*/, "sh" /*1831*/, "t" /*1832*/, "d" /*1833*/, "ch" /*1834*/, "j" /*1835*/, "y" /*1836*/, "r" /*1837*/, "w" /*1838*/, "f" /*1839*/, "k" /*183a*/, "kha" /*183b*/, "ts" /*183c*/, "z" /*183d*/, "h" /*183e*/, "zr" /*183f*/, "lh" /*1840*/, "zh" /*1841*/, "ch" /*1842*/, "-" /*1843*/, "e" /*1844*/, "i" /*1845*/, "o" /*1846*/, "u" /*1847*/, "O" /*1848*/, "U" /*1849*/, "ng" /*184a*/, "b" /*184b*/, "p" /*184c*/, "q" /*184d*/, "g" /*184e*/, "m" /*184f*/, "t" /*1850*/, "d" /*1851*/, "ch" /*1852*/, "j" /*1853*/, "ts" /*1854*/, "y" /*1855*/, "w" /*1856*/, "k" /*1857*/, "g" /*1858*/, "h" /*1859*/, "jy" /*185a*/, "ny" /*185b*/, "dz" /*185c*/, "e" /*185d*/, "i" /*185e*/, "iy" /*185f*/, "U" /*1860*/, "u" /*1861*/, "ng" /*1862*/, "k" /*1863*/, "g" /*1864*/, "h" /*1865*/, "p" /*1866*/, "sh" /*1867*/, "t" /*1868*/, "d" /*1869*/, "j" /*186a*/, "f" /*186b*/, "g" /*186c*/, "h" /*186d*/, "ts" /*186e*/, "z" /*186f*/, "r" /*1870*/, "ch" /*1871*/, "zh" /*1872*/, "i" /*1873*/, "k" /*1874*/, "r" /*1875*/, "f" /*1876*/, "zh" /*1877*/, "[?]" /*1878*/, "[?]" /*1879*/, "[?]" /*187a*/, "[?]" /*187b*/, "[?]" /*187c*/, "[?]" /*187d*/, "[?]" /*187e*/, "[?]" /*187f*/, "[?]" /*1880*/, "H" /*1881*/, "X" /*1882*/, "W" /*1883*/, "M" /*1884*/, " 3 " /*1885*/, " 333 " /*1886*/, "a" /*1887*/, "i" /*1888*/, "k" /*1889*/, "ng" /*188a*/, "c" /*188b*/, "tt" /*188c*/, "tth" /*188d*/, "dd" /*188e*/, "nn" /*188f*/, "t" /*1890*/, "d" /*1891*/, "p" /*1892*/, "ph" /*1893*/, "ss" /*1894*/, "zh" /*1895*/, "z" /*1896*/, "a" /*1897*/, "t" /*1898*/, "zh" /*1899*/, "gh" /*189a*/, "ng" /*189b*/, "c" /*189c*/, "jh" /*189d*/, "tta" /*189e*/, "ddh" /*189f*/, "t" /*18a0*/, "dh" /*18a1*/, "ss" /*18a2*/, "cy" /*18a3*/, "zh" /*18a4*/, "z" /*18a5*/, "u" /*18a6*/, "y" /*18a7*/, "bh" /*18a8*/, "'" /*18a9*/, "[?]" /*18aa*/, "[?]" /*18ab*/, "[?]" /*18ac*/, "[?]" /*18ad*/, "[?]" /*18ae*/, "[?]" /*18af*/, "[?]" /*18b0*/, "[?]" /*18b1*/, "[?]" /*18b2*/, "[?]" /*18b3*/, "[?]" /*18b4*/, "[?]" /*18b5*/, "[?]" /*18b6*/, "[?]" /*18b7*/, "[?]" /*18b8*/, "[?]" /*18b9*/, "[?]" /*18ba*/, "[?]" /*18bb*/, "[?]" /*18bc*/, "[?]" /*18bd*/, "[?]" /*18be*/, "[?]" /*18bf*/, "[?]" /*18c0*/, "[?]" /*18c1*/, "[?]" /*18c2*/, "[?]" /*18c3*/, "[?]" /*18c4*/, "[?]" /*18c5*/, "[?]" /*18c6*/, "[?]" /*18c7*/, "[?]" /*18c8*/, "[?]" /*18c9*/, "[?]" /*18ca*/, "[?]" /*18cb*/, "[?]" /*18cc*/, "[?]" /*18cd*/, "[?]" /*18ce*/, "[?]" /*18cf*/, "[?]" /*18d0*/, "[?]" /*18d1*/, "[?]" /*18d2*/, "[?]" /*18d3*/, "[?]" /*18d4*/, "[?]" /*18d5*/, "[?]" /*18d6*/, "[?]" /*18d7*/, "[?]" /*18d8*/, "[?]" /*18d9*/, "[?]" /*18da*/, "[?]" /*18db*/, "[?]" /*18dc*/, "[?]" /*18dd*/, "[?]" /*18de*/, "[?]" /*18df*/, "[?]" /*18e0*/, "[?]" /*18e1*/, "[?]" /*18e2*/, "[?]" /*18e3*/, "[?]" /*18e4*/, "[?]" /*18e5*/, "[?]" /*18e6*/, "[?]" /*18e7*/, "[?]" /*18e8*/, "[?]" /*18e9*/, "[?]" /*18ea*/, "[?]" /*18eb*/, "[?]" /*18ec*/, "[?]" /*18ed*/, "[?]" /*18ee*/, "[?]" /*18ef*/, "[?]" /*18f0*/, "[?]" /*18f1*/, "[?]" /*18f2*/, "[?]" /*18f3*/, "[?]" /*18f4*/, "[?]" /*18f5*/, "[?]" /*18f6*/, "[?]" /*18f7*/, "[?]" /*18f8*/, "[?]" /*18f9*/, "[?]" /*18fa*/, "[?]" /*18fb*/, "[?]" /*18fc*/, "[?]" /*18fd*/, "[?]" /*18fe*/, 
			});
						characters.TryAdd(30 /*7680 1e*/, new string[] {
				"A" /*1e00*/, "a" /*1e01*/, "B" /*1e02*/, "b" /*1e03*/, "B" /*1e04*/, "b" /*1e05*/, "B" /*1e06*/, "b" /*1e07*/, "C" /*1e08*/, "c" /*1e09*/, "D" /*1e0a*/, "d" /*1e0b*/, "D" /*1e0c*/, "d" /*1e0d*/, "D" /*1e0e*/, "d" /*1e0f*/, "D" /*1e10*/, "d" /*1e11*/, "D" /*1e12*/, "d" /*1e13*/, "E" /*1e14*/, "e" /*1e15*/, "E" /*1e16*/, "e" /*1e17*/, "E" /*1e18*/, "e" /*1e19*/, "E" /*1e1a*/, "e" /*1e1b*/, "E" /*1e1c*/, "e" /*1e1d*/, "F" /*1e1e*/, "f" /*1e1f*/, "G" /*1e20*/, "g" /*1e21*/, "H" /*1e22*/, "h" /*1e23*/, "H" /*1e24*/, "h" /*1e25*/, "H" /*1e26*/, "h" /*1e27*/, "H" /*1e28*/, "h" /*1e29*/, "H" /*1e2a*/, "h" /*1e2b*/, "I" /*1e2c*/, "i" /*1e2d*/, "I" /*1e2e*/, "i" /*1e2f*/, "K" /*1e30*/, "k" /*1e31*/, "K" /*1e32*/, "k" /*1e33*/, "K" /*1e34*/, "k" /*1e35*/, "L" /*1e36*/, "l" /*1e37*/, "L" /*1e38*/, "l" /*1e39*/, "L" /*1e3a*/, "l" /*1e3b*/, "L" /*1e3c*/, "l" /*1e3d*/, "M" /*1e3e*/, "m" /*1e3f*/, "M" /*1e40*/, "m" /*1e41*/, "M" /*1e42*/, "m" /*1e43*/, "N" /*1e44*/, "n" /*1e45*/, "N" /*1e46*/, "n" /*1e47*/, "N" /*1e48*/, "n" /*1e49*/, "N" /*1e4a*/, "n" /*1e4b*/, "O" /*1e4c*/, "o" /*1e4d*/, "O" /*1e4e*/, "o" /*1e4f*/, "O" /*1e50*/, "o" /*1e51*/, "O" /*1e52*/, "o" /*1e53*/, "P" /*1e54*/, "p" /*1e55*/, "P" /*1e56*/, "p" /*1e57*/, "R" /*1e58*/, "r" /*1e59*/, "R" /*1e5a*/, "r" /*1e5b*/, "R" /*1e5c*/, "r" /*1e5d*/, "R" /*1e5e*/, "r" /*1e5f*/, "S" /*1e60*/, "s" /*1e61*/, "S" /*1e62*/, "s" /*1e63*/, "S" /*1e64*/, "s" /*1e65*/, "S" /*1e66*/, "s" /*1e67*/, "S" /*1e68*/, "s" /*1e69*/, "T" /*1e6a*/, "t" /*1e6b*/, "T" /*1e6c*/, "t" /*1e6d*/, "T" /*1e6e*/, "t" /*1e6f*/, "T" /*1e70*/, "t" /*1e71*/, "U" /*1e72*/, "u" /*1e73*/, "U" /*1e74*/, "u" /*1e75*/, "U" /*1e76*/, "u" /*1e77*/, "U" /*1e78*/, "u" /*1e79*/, "U" /*1e7a*/, "u" /*1e7b*/, "V" /*1e7c*/, "v" /*1e7d*/, "V" /*1e7e*/, "v" /*1e7f*/, "W" /*1e80*/, "w" /*1e81*/, "W" /*1e82*/, "w" /*1e83*/, "W" /*1e84*/, "w" /*1e85*/, "W" /*1e86*/, "w" /*1e87*/, "W" /*1e88*/, "w" /*1e89*/, "X" /*1e8a*/, "x" /*1e8b*/, "X" /*1e8c*/, "x" /*1e8d*/, "Y" /*1e8e*/, "y" /*1e8f*/, "Z" /*1e90*/, "z" /*1e91*/, "Z" /*1e92*/, "z" /*1e93*/, "Z" /*1e94*/, "z" /*1e95*/, "h" /*1e96*/, "t" /*1e97*/, "w" /*1e98*/, "y" /*1e99*/, "a" /*1e9a*/, "S" /*1e9b*/, "[?]" /*1e9c*/, "[?]" /*1e9d*/, "[?]" /*1e9e*/, "[?]" /*1e9f*/, "A" /*1ea0*/, "a" /*1ea1*/, "A" /*1ea2*/, "a" /*1ea3*/, "A" /*1ea4*/, "a" /*1ea5*/, "A" /*1ea6*/, "a" /*1ea7*/, "A" /*1ea8*/, "a" /*1ea9*/, "A" /*1eaa*/, "a" /*1eab*/, "A" /*1eac*/, "a" /*1ead*/, "A" /*1eae*/, "a" /*1eaf*/, "A" /*1eb0*/, "a" /*1eb1*/, "A" /*1eb2*/, "a" /*1eb3*/, "A" /*1eb4*/, "a" /*1eb5*/, "A" /*1eb6*/, "a" /*1eb7*/, "E" /*1eb8*/, "e" /*1eb9*/, "E" /*1eba*/, "e" /*1ebb*/, "E" /*1ebc*/, "e" /*1ebd*/, "E" /*1ebe*/, "e" /*1ebf*/, "E" /*1ec0*/, "e" /*1ec1*/, "E" /*1ec2*/, "e" /*1ec3*/, "E" /*1ec4*/, "e" /*1ec5*/, "E" /*1ec6*/, "e" /*1ec7*/, "I" /*1ec8*/, "i" /*1ec9*/, "I" /*1eca*/, "i" /*1ecb*/, "O" /*1ecc*/, "o" /*1ecd*/, "O" /*1ece*/, "o" /*1ecf*/, "O" /*1ed0*/, "o" /*1ed1*/, "O" /*1ed2*/, "o" /*1ed3*/, "O" /*1ed4*/, "o" /*1ed5*/, "O" /*1ed6*/, "o" /*1ed7*/, "O" /*1ed8*/, "o" /*1ed9*/, "O" /*1eda*/, "o" /*1edb*/, "O" /*1edc*/, "o" /*1edd*/, "O" /*1ede*/, "o" /*1edf*/, "O" /*1ee0*/, "o" /*1ee1*/, "O" /*1ee2*/, "o" /*1ee3*/, "U" /*1ee4*/, "u" /*1ee5*/, "U" /*1ee6*/, "u" /*1ee7*/, "U" /*1ee8*/, "u" /*1ee9*/, "U" /*1eea*/, "u" /*1eeb*/, "U" /*1eec*/, "u" /*1eed*/, "U" /*1eee*/, "u" /*1eef*/, "U" /*1ef0*/, "u" /*1ef1*/, "Y" /*1ef2*/, "y" /*1ef3*/, "Y" /*1ef4*/, "y" /*1ef5*/, "Y" /*1ef6*/, "y" /*1ef7*/, "Y" /*1ef8*/, "y" /*1ef9*/, "[?]" /*1efa*/, "[?]" /*1efb*/, "[?]" /*1efc*/, "[?]" /*1efd*/, "[?]" /*1efe*/, 
			});
						characters.TryAdd(31 /*7936 1f*/, new string[] {
				"a" /*1f00*/, "a" /*1f01*/, "a" /*1f02*/, "a" /*1f03*/, "a" /*1f04*/, "a" /*1f05*/, "a" /*1f06*/, "a" /*1f07*/, "A" /*1f08*/, "A" /*1f09*/, "A" /*1f0a*/, "A" /*1f0b*/, "A" /*1f0c*/, "A" /*1f0d*/, "A" /*1f0e*/, "A" /*1f0f*/, "e" /*1f10*/, "e" /*1f11*/, "e" /*1f12*/, "e" /*1f13*/, "e" /*1f14*/, "e" /*1f15*/, "[?]" /*1f16*/, "[?]" /*1f17*/, "E" /*1f18*/, "E" /*1f19*/, "E" /*1f1a*/, "E" /*1f1b*/, "E" /*1f1c*/, "E" /*1f1d*/, "[?]" /*1f1e*/, "[?]" /*1f1f*/, "e" /*1f20*/, "e" /*1f21*/, "e" /*1f22*/, "e" /*1f23*/, "e" /*1f24*/, "e" /*1f25*/, "e" /*1f26*/, "e" /*1f27*/, "E" /*1f28*/, "E" /*1f29*/, "E" /*1f2a*/, "E" /*1f2b*/, "E" /*1f2c*/, "E" /*1f2d*/, "E" /*1f2e*/, "E" /*1f2f*/, "i" /*1f30*/, "i" /*1f31*/, "i" /*1f32*/, "i" /*1f33*/, "i" /*1f34*/, "i" /*1f35*/, "i" /*1f36*/, "i" /*1f37*/, "I" /*1f38*/, "I" /*1f39*/, "I" /*1f3a*/, "I" /*1f3b*/, "I" /*1f3c*/, "I" /*1f3d*/, "I" /*1f3e*/, "I" /*1f3f*/, "o" /*1f40*/, "o" /*1f41*/, "o" /*1f42*/, "o" /*1f43*/, "o" /*1f44*/, "o" /*1f45*/, "[?]" /*1f46*/, "[?]" /*1f47*/, "O" /*1f48*/, "O" /*1f49*/, "O" /*1f4a*/, "O" /*1f4b*/, "O" /*1f4c*/, "O" /*1f4d*/, "[?]" /*1f4e*/, "[?]" /*1f4f*/, "u" /*1f50*/, "u" /*1f51*/, "u" /*1f52*/, "u" /*1f53*/, "u" /*1f54*/, "u" /*1f55*/, "u" /*1f56*/, "u" /*1f57*/, "[?]" /*1f58*/, "U" /*1f59*/, "[?]" /*1f5a*/, "U" /*1f5b*/, "[?]" /*1f5c*/, "U" /*1f5d*/, "[?]" /*1f5e*/, "U" /*1f5f*/, "o" /*1f60*/, "o" /*1f61*/, "o" /*1f62*/, "o" /*1f63*/, "o" /*1f64*/, "o" /*1f65*/, "o" /*1f66*/, "o" /*1f67*/, "O" /*1f68*/, "O" /*1f69*/, "O" /*1f6a*/, "O" /*1f6b*/, "O" /*1f6c*/, "O" /*1f6d*/, "O" /*1f6e*/, "O" /*1f6f*/, "a" /*1f70*/, "a" /*1f71*/, "e" /*1f72*/, "e" /*1f73*/, "e" /*1f74*/, "e" /*1f75*/, "i" /*1f76*/, "i" /*1f77*/, "o" /*1f78*/, "o" /*1f79*/, "u" /*1f7a*/, "u" /*1f7b*/, "o" /*1f7c*/, "o" /*1f7d*/, "[?]" /*1f7e*/, "[?]" /*1f7f*/, "a" /*1f80*/, "a" /*1f81*/, "a" /*1f82*/, "a" /*1f83*/, "a" /*1f84*/, "a" /*1f85*/, "a" /*1f86*/, "a" /*1f87*/, "A" /*1f88*/, "A" /*1f89*/, "A" /*1f8a*/, "A" /*1f8b*/, "A" /*1f8c*/, "A" /*1f8d*/, "A" /*1f8e*/, "A" /*1f8f*/, "e" /*1f90*/, "e" /*1f91*/, "e" /*1f92*/, "e" /*1f93*/, "e" /*1f94*/, "e" /*1f95*/, "e" /*1f96*/, "e" /*1f97*/, "E" /*1f98*/, "E" /*1f99*/, "E" /*1f9a*/, "E" /*1f9b*/, "E" /*1f9c*/, "E" /*1f9d*/, "E" /*1f9e*/, "E" /*1f9f*/, "o" /*1fa0*/, "o" /*1fa1*/, "o" /*1fa2*/, "o" /*1fa3*/, "o" /*1fa4*/, "o" /*1fa5*/, "o" /*1fa6*/, "o" /*1fa7*/, "O" /*1fa8*/, "O" /*1fa9*/, "O" /*1faa*/, "O" /*1fab*/, "O" /*1fac*/, "O" /*1fad*/, "O" /*1fae*/, "O" /*1faf*/, "a" /*1fb0*/, "a" /*1fb1*/, "a" /*1fb2*/, "a" /*1fb3*/, "a" /*1fb4*/, "[?]" /*1fb5*/, "a" /*1fb6*/, "a" /*1fb7*/, "A" /*1fb8*/, "A" /*1fb9*/, "A" /*1fba*/, "A" /*1fbb*/, "A" /*1fbc*/, "'" /*1fbd*/, "i" /*1fbe*/, "'" /*1fbf*/, "~" /*1fc0*/, "\"~" /*1fc1*/, "e" /*1fc2*/, "e" /*1fc3*/, "e" /*1fc4*/, "[?]" /*1fc5*/, "e" /*1fc6*/, "e" /*1fc7*/, "E" /*1fc8*/, "E" /*1fc9*/, "E" /*1fca*/, "E" /*1fcb*/, "E" /*1fcc*/, "'`" /*1fcd*/, "''" /*1fce*/, "'~" /*1fcf*/, "i" /*1fd0*/, "i" /*1fd1*/, "i" /*1fd2*/, "i" /*1fd3*/, "[?]" /*1fd4*/, "[?]" /*1fd5*/, "i" /*1fd6*/, "i" /*1fd7*/, "I" /*1fd8*/, "I" /*1fd9*/, "I" /*1fda*/, "I" /*1fdb*/, "[?]" /*1fdc*/, "`'" /*1fdd*/, "`'" /*1fde*/, "`~" /*1fdf*/, "u" /*1fe0*/, "u" /*1fe1*/, "u" /*1fe2*/, "u" /*1fe3*/, "R" /*1fe4*/, "R" /*1fe5*/, "u" /*1fe6*/, "u" /*1fe7*/, "U" /*1fe8*/, "U" /*1fe9*/, "U" /*1fea*/, "U" /*1feb*/, "R" /*1fec*/, "\"`" /*1fed*/, "\"'" /*1fee*/, "`" /*1fef*/, "[?]" /*1ff0*/, "[?]" /*1ff1*/, "o" /*1ff2*/, "o" /*1ff3*/, "o" /*1ff4*/, "[?]" /*1ff5*/, "o" /*1ff6*/, "o" /*1ff7*/, "O" /*1ff8*/, "O" /*1ff9*/, "O" /*1ffa*/, "O" /*1ffb*/, "O" /*1ffc*/, "'" /*1ffd*/, "`" /*1ffe*/, 
			});
						characters.TryAdd(32 /*8192 20*/, new string[] {
				" " /*2000*/, " " /*2001*/, " " /*2002*/, " " /*2003*/, " " /*2004*/, " " /*2005*/, " " /*2006*/, " " /*2007*/, " " /*2008*/, " " /*2009*/, " " /*200a*/, " " /*200b*/, "" /*200c*/, "" /*200d*/, "" /*200e*/, "" /*200f*/, "-" /*2010*/, "-" /*2011*/, "-" /*2012*/, "-" /*2013*/, "--" /*2014*/, "--" /*2015*/, "||" /*2016*/, "_" /*2017*/, "'" /*2018*/, "'" /*2019*/, "," /*201a*/, "'" /*201b*/, "\"" /*201c*/, "\"" /*201d*/, ",," /*201e*/, "\"" /*201f*/, "+" /*2020*/, "++" /*2021*/, "*" /*2022*/, "*>" /*2023*/, "." /*2024*/, ".." /*2025*/, "..." /*2026*/, "." /*2027*/, ""+Environment.NewLine+"" /*2028*/, ""+Environment.NewLine+""+Environment.NewLine+"" /*2029*/, "" /*202a*/, "" /*202b*/, "" /*202c*/, "" /*202d*/, "" /*202e*/, " " /*202f*/, "%0" /*2030*/, "%00" /*2031*/, "'" /*2032*/, "''" /*2033*/, "'''" /*2034*/, "`" /*2035*/, "``" /*2036*/, "```" /*2037*/, "^" /*2038*/, "<" /*2039*/, ">" /*203a*/, "*" /*203b*/, "!!" /*203c*/, "!?" /*203d*/, "-" /*203e*/, "_" /*203f*/, "-" /*2040*/, "^" /*2041*/, "***" /*2042*/, "--" /*2043*/, "/" /*2044*/, "-[" /*2045*/, "]-" /*2046*/, "[?]" /*2047*/, "?!" /*2048*/, "!?" /*2049*/, "7" /*204a*/, "PP" /*204b*/, "(]" /*204c*/, "[)" /*204d*/, "[?]" /*204e*/, "[?]" /*204f*/, "[?]" /*2050*/, "[?]" /*2051*/, "[?]" /*2052*/, "[?]" /*2053*/, "[?]" /*2054*/, "[?]" /*2055*/, "[?]" /*2056*/, "[?]" /*2057*/, "[?]" /*2058*/, "[?]" /*2059*/, "[?]" /*205a*/, "[?]" /*205b*/, "[?]" /*205c*/, "[?]" /*205d*/, "[?]" /*205e*/, "[?]" /*205f*/, "[?]" /*2060*/, "[?]" /*2061*/, "[?]" /*2062*/, "[?]" /*2063*/, "[?]" /*2064*/, "[?]" /*2065*/, "[?]" /*2066*/, "[?]" /*2067*/, "[?]" /*2068*/, "[?]" /*2069*/, "" /*206a*/, "" /*206b*/, "" /*206c*/, "" /*206d*/, "" /*206e*/, "" /*206f*/, "0" /*2070*/, "" /*2071*/, "" /*2072*/, "" /*2073*/, "4" /*2074*/, "5" /*2075*/, "6" /*2076*/, "7" /*2077*/, "8" /*2078*/, "9" /*2079*/, "+" /*207a*/, "-" /*207b*/, "=" /*207c*/, "(" /*207d*/, ")" /*207e*/, "n" /*207f*/, "0" /*2080*/, "1" /*2081*/, "2" /*2082*/, "3" /*2083*/, "4" /*2084*/, "5" /*2085*/, "6" /*2086*/, "7" /*2087*/, "8" /*2088*/, "9" /*2089*/, "+" /*208a*/, "-" /*208b*/, "=" /*208c*/, "(" /*208d*/, ")" /*208e*/, "[?]" /*208f*/, "[?]" /*2090*/, "[?]" /*2091*/, "[?]" /*2092*/, "[?]" /*2093*/, "[?]" /*2094*/, "[?]" /*2095*/, "[?]" /*2096*/, "[?]" /*2097*/, "[?]" /*2098*/, "[?]" /*2099*/, "[?]" /*209a*/, "[?]" /*209b*/, "[?]" /*209c*/, "[?]" /*209d*/, "[?]" /*209e*/, "[?]" /*209f*/, "ECU" /*20a0*/, "CL" /*20a1*/, "Cr" /*20a2*/, "FF" /*20a3*/, "L" /*20a4*/, "mil" /*20a5*/, "N" /*20a6*/, "Pts" /*20a7*/, "Rs" /*20a8*/, "W" /*20a9*/, "NS" /*20aa*/, "D" /*20ab*/, "EU" /*20ac*/, "K" /*20ad*/, "T" /*20ae*/, "Dr" /*20af*/, "[?]" /*20b0*/, "[?]" /*20b1*/, "[?]" /*20b2*/, "[?]" /*20b3*/, "[?]" /*20b4*/, "[?]" /*20b5*/, "[?]" /*20b6*/, "[?]" /*20b7*/, "[?]" /*20b8*/, "[?]" /*20b9*/, "[?]" /*20ba*/, "[?]" /*20bb*/, "[?]" /*20bc*/, "[?]" /*20bd*/, "[?]" /*20be*/, "[?]" /*20bf*/, "[?]" /*20c0*/, "[?]" /*20c1*/, "[?]" /*20c2*/, "[?]" /*20c3*/, "[?]" /*20c4*/, "[?]" /*20c5*/, "[?]" /*20c6*/, "[?]" /*20c7*/, "[?]" /*20c8*/, "[?]" /*20c9*/, "[?]" /*20ca*/, "[?]" /*20cb*/, "[?]" /*20cc*/, "[?]" /*20cd*/, "[?]" /*20ce*/, "[?]" /*20cf*/, "" /*20d0*/, "" /*20d1*/, "" /*20d2*/, "" /*20d3*/, "" /*20d4*/, "" /*20d5*/, "" /*20d6*/, "" /*20d7*/, "" /*20d8*/, "" /*20d9*/, "" /*20da*/, "" /*20db*/, "" /*20dc*/, "" /*20dd*/, "" /*20de*/, "" /*20df*/, "" /*20e0*/, "" /*20e1*/, "" /*20e2*/, "" /*20e3*/, "[?]" /*20e4*/, "[?]" /*20e5*/, "[?]" /*20e6*/, "[?]" /*20e7*/, "[?]" /*20e8*/, "[?]" /*20e9*/, "[?]" /*20ea*/, "[?]" /*20eb*/, "[?]" /*20ec*/, "[?]" /*20ed*/, "[?]" /*20ee*/, "[?]" /*20ef*/, "[?]" /*20f0*/, "[?]" /*20f1*/, "[?]" /*20f2*/, "[?]" /*20f3*/, "[?]" /*20f4*/, "[?]" /*20f5*/, "[?]" /*20f6*/, "[?]" /*20f7*/, "[?]" /*20f8*/, "[?]" /*20f9*/, "[?]" /*20fa*/, "[?]" /*20fb*/, "[?]" /*20fc*/, "[?]" /*20fd*/, "[?]" /*20fe*/, 
			});
						characters.TryAdd(33 /*8448 21*/, new string[] {
				"" /*2100*/, "" /*2101*/, "" /*2102*/, "" /*2103*/, "" /*2104*/, "" /*2105*/, "" /*2106*/, "" /*2107*/, "" /*2108*/, "" /*2109*/, "" /*210a*/, "" /*210b*/, "" /*210c*/, "" /*210d*/, "" /*210e*/, "" /*210f*/, "" /*2110*/, "" /*2111*/, "" /*2112*/, "" /*2113*/, "" /*2114*/, "" /*2115*/, "" /*2116*/, "" /*2117*/, "" /*2118*/, "" /*2119*/, "" /*211a*/, "" /*211b*/, "" /*211c*/, "" /*211d*/, "" /*211e*/, "" /*211f*/, "" /*2120*/, "" /*2121*/, "" /*2122*/, "" /*2123*/, "" /*2124*/, "" /*2125*/, "" /*2126*/, "" /*2127*/, "" /*2128*/, "" /*2129*/, "" /*212a*/, "" /*212b*/, "" /*212c*/, "" /*212d*/, "" /*212e*/, "" /*212f*/, "" /*2130*/, "" /*2131*/, "" /*2132*/, "" /*2133*/, "" /*2134*/, "" /*2135*/, "" /*2136*/, "" /*2137*/, "" /*2138*/, "" /*2139*/, "" /*213a*/, "[?]" /*213b*/, "[?]" /*213c*/, "[?]" /*213d*/, "[?]" /*213e*/, "[?]" /*213f*/, "[?]" /*2140*/, "[?]" /*2141*/, "[?]" /*2142*/, "[?]" /*2143*/, "[?]" /*2144*/, "[?]" /*2145*/, "[?]" /*2146*/, "[?]" /*2147*/, "[?]" /*2148*/, "[?]" /*2149*/, "[?]" /*214a*/, "[?]" /*214b*/, "[?]" /*214c*/, "[?]" /*214d*/, "[?]" /*214e*/, "[?]" /*214f*/, "[?]" /*2150*/, "[?]" /*2151*/, "[?]" /*2152*/, " 1/3 " /*2153*/, " 2/3 " /*2154*/, " 1/5 " /*2155*/, " 2/5 " /*2156*/, " 3/5 " /*2157*/, " 4/5 " /*2158*/, " 1/6 " /*2159*/, " 5/6 " /*215a*/, " 1/8 " /*215b*/, " 3/8 " /*215c*/, " 5/8 " /*215d*/, " 7/8 " /*215e*/, " 1/" /*215f*/, "I" /*2160*/, "II" /*2161*/, "III" /*2162*/, "IV" /*2163*/, "V" /*2164*/, "VI" /*2165*/, "VII" /*2166*/, "VIII" /*2167*/, "IX" /*2168*/, "X" /*2169*/, "XI" /*216a*/, "XII" /*216b*/, "L" /*216c*/, "C" /*216d*/, "D" /*216e*/, "M" /*216f*/, "i" /*2170*/, "ii" /*2171*/, "iii" /*2172*/, "iv" /*2173*/, "v" /*2174*/, "vi" /*2175*/, "vii" /*2176*/, "viii" /*2177*/, "ix" /*2178*/, "x" /*2179*/, "xi" /*217a*/, "xii" /*217b*/, "l" /*217c*/, "c" /*217d*/, "d" /*217e*/, "m" /*217f*/, "(D" /*2180*/, "D)" /*2181*/, "((|))" /*2182*/, ")" /*2183*/, "[?]" /*2184*/, "[?]" /*2185*/, "[?]" /*2186*/, "[?]" /*2187*/, "[?]" /*2188*/, "[?]" /*2189*/, "[?]" /*218a*/, "[?]" /*218b*/, "[?]" /*218c*/, "[?]" /*218d*/, "[?]" /*218e*/, "[?]" /*218f*/, "-" /*2190*/, "|" /*2191*/, "-" /*2192*/, "|" /*2193*/, "-" /*2194*/, "|" /*2195*/, "\\" /*2196*/, "/" /*2197*/, "\\" /*2198*/, "/" /*2199*/, "-" /*219a*/, "-" /*219b*/, "~" /*219c*/, "~" /*219d*/, "-" /*219e*/, "|" /*219f*/, "-" /*21a0*/, "|" /*21a1*/, "-" /*21a2*/, "-" /*21a3*/, "-" /*21a4*/, "|" /*21a5*/, "-" /*21a6*/, "|" /*21a7*/, "|" /*21a8*/, "-" /*21a9*/, "-" /*21aa*/, "-" /*21ab*/, "-" /*21ac*/, "-" /*21ad*/, "-" /*21ae*/, "|" /*21af*/, "|" /*21b0*/, "|" /*21b1*/, "|" /*21b2*/, "|" /*21b3*/, "|" /*21b4*/, "|" /*21b5*/, "^" /*21b6*/, "V" /*21b7*/, "\\" /*21b8*/, "=" /*21b9*/, "V" /*21ba*/, "^" /*21bb*/, "-" /*21bc*/, "-" /*21bd*/, "|" /*21be*/, "|" /*21bf*/, "-" /*21c0*/, "-" /*21c1*/, "|" /*21c2*/, "|" /*21c3*/, "=" /*21c4*/, "|" /*21c5*/, "=" /*21c6*/, "=" /*21c7*/, "|" /*21c8*/, "=" /*21c9*/, "|" /*21ca*/, "=" /*21cb*/, "=" /*21cc*/, "=" /*21cd*/, "=" /*21ce*/, "=" /*21cf*/, "=" /*21d0*/, "|" /*21d1*/, "=" /*21d2*/, "|" /*21d3*/, "=" /*21d4*/, "|" /*21d5*/, "\\" /*21d6*/, "/" /*21d7*/, "\\" /*21d8*/, "/" /*21d9*/, "=" /*21da*/, "=" /*21db*/, "~" /*21dc*/, "~" /*21dd*/, "|" /*21de*/, "|" /*21df*/, "-" /*21e0*/, "|" /*21e1*/, "-" /*21e2*/, "|" /*21e3*/, "-" /*21e4*/, "-" /*21e5*/, "-" /*21e6*/, "|" /*21e7*/, "-" /*21e8*/, "|" /*21e9*/, "|" /*21ea*/, "|" /*21eb*/, "|" /*21ec*/, "|" /*21ed*/, "|" /*21ee*/, "|" /*21ef*/, "-" /*21f0*/, "\\" /*21f1*/, "\\" /*21f2*/, "|" /*21f3*/, "[?]" /*21f4*/, "[?]" /*21f5*/, "[?]" /*21f6*/, "[?]" /*21f7*/, "[?]" /*21f8*/, "[?]" /*21f9*/, "[?]" /*21fa*/, "[?]" /*21fb*/, "[?]" /*21fc*/, "[?]" /*21fd*/, "[?]" /*21fe*/, 
			});
						characters.TryAdd(34 /*8704 22*/, new string[] {
				"[?]" /*2200*/, "[?]" /*2201*/, "[?]" /*2202*/, "[?]" /*2203*/, "[?]" /*2204*/, "[?]" /*2205*/, "[?]" /*2206*/, "[?]" /*2207*/, "[?]" /*2208*/, "[?]" /*2209*/, "[?]" /*220a*/, "[?]" /*220b*/, "[?]" /*220c*/, "[?]" /*220d*/, "[?]" /*220e*/, "[?]" /*220f*/, "[?]" /*2210*/, "[?]" /*2211*/, "[?]" /*2212*/, "[?]" /*2213*/, "[?]" /*2214*/, "[?]" /*2215*/, "[?]" /*2216*/, "[?]" /*2217*/, "[?]" /*2218*/, "[?]" /*2219*/, "[?]" /*221a*/, "[?]" /*221b*/, "[?]" /*221c*/, "[?]" /*221d*/, "[?]" /*221e*/, "[?]" /*221f*/, "[?]" /*2220*/, "[?]" /*2221*/, "[?]" /*2222*/, "[?]" /*2223*/, "[?]" /*2224*/, "[?]" /*2225*/, "[?]" /*2226*/, "[?]" /*2227*/, "[?]" /*2228*/, "[?]" /*2229*/, "[?]" /*222a*/, "[?]" /*222b*/, "[?]" /*222c*/, "[?]" /*222d*/, "[?]" /*222e*/, "[?]" /*222f*/, "[?]" /*2230*/, "[?]" /*2231*/, "[?]" /*2232*/, "[?]" /*2233*/, "[?]" /*2234*/, "[?]" /*2235*/, "[?]" /*2236*/, "[?]" /*2237*/, "[?]" /*2238*/, "[?]" /*2239*/, "[?]" /*223a*/, "[?]" /*223b*/, "[?]" /*223c*/, "[?]" /*223d*/, "[?]" /*223e*/, "[?]" /*223f*/, "[?]" /*2240*/, "[?]" /*2241*/, "[?]" /*2242*/, "[?]" /*2243*/, "[?]" /*2244*/, "[?]" /*2245*/, "[?]" /*2246*/, "[?]" /*2247*/, "[?]" /*2248*/, "[?]" /*2249*/, "[?]" /*224a*/, "[?]" /*224b*/, "[?]" /*224c*/, "[?]" /*224d*/, "[?]" /*224e*/, "[?]" /*224f*/, "[?]" /*2250*/, "[?]" /*2251*/, "[?]" /*2252*/, "[?]" /*2253*/, "[?]" /*2254*/, "[?]" /*2255*/, "[?]" /*2256*/, "[?]" /*2257*/, "[?]" /*2258*/, "[?]" /*2259*/, "[?]" /*225a*/, "[?]" /*225b*/, "[?]" /*225c*/, "[?]" /*225d*/, "[?]" /*225e*/, "[?]" /*225f*/, "[?]" /*2260*/, "[?]" /*2261*/, "[?]" /*2262*/, "[?]" /*2263*/, "[?]" /*2264*/, "[?]" /*2265*/, "[?]" /*2266*/, "[?]" /*2267*/, "[?]" /*2268*/, "[?]" /*2269*/, "[?]" /*226a*/, "[?]" /*226b*/, "[?]" /*226c*/, "[?]" /*226d*/, "[?]" /*226e*/, "[?]" /*226f*/, "[?]" /*2270*/, "[?]" /*2271*/, "[?]" /*2272*/, "[?]" /*2273*/, "[?]" /*2274*/, "[?]" /*2275*/, "[?]" /*2276*/, "[?]" /*2277*/, "[?]" /*2278*/, "[?]" /*2279*/, "[?]" /*227a*/, "[?]" /*227b*/, "[?]" /*227c*/, "[?]" /*227d*/, "[?]" /*227e*/, "[?]" /*227f*/, "[?]" /*2280*/, "[?]" /*2281*/, "[?]" /*2282*/, "[?]" /*2283*/, "[?]" /*2284*/, "[?]" /*2285*/, "[?]" /*2286*/, "[?]" /*2287*/, "[?]" /*2288*/, "[?]" /*2289*/, "[?]" /*228a*/, "[?]" /*228b*/, "[?]" /*228c*/, "[?]" /*228d*/, "[?]" /*228e*/, "[?]" /*228f*/, "[?]" /*2290*/, "[?]" /*2291*/, "[?]" /*2292*/, "[?]" /*2293*/, "[?]" /*2294*/, "[?]" /*2295*/, "[?]" /*2296*/, "[?]" /*2297*/, "[?]" /*2298*/, "[?]" /*2299*/, "[?]" /*229a*/, "[?]" /*229b*/, "[?]" /*229c*/, "[?]" /*229d*/, "[?]" /*229e*/, "[?]" /*229f*/, "[?]" /*22a0*/, "[?]" /*22a1*/, "[?]" /*22a2*/, "[?]" /*22a3*/, "[?]" /*22a4*/, "[?]" /*22a5*/, "[?]" /*22a6*/, "[?]" /*22a7*/, "[?]" /*22a8*/, "[?]" /*22a9*/, "[?]" /*22aa*/, "[?]" /*22ab*/, "[?]" /*22ac*/, "[?]" /*22ad*/, "[?]" /*22ae*/, "[?]" /*22af*/, "[?]" /*22b0*/, "[?]" /*22b1*/, "[?]" /*22b2*/, "[?]" /*22b3*/, "[?]" /*22b4*/, "[?]" /*22b5*/, "[?]" /*22b6*/, "[?]" /*22b7*/, "[?]" /*22b8*/, "[?]" /*22b9*/, "[?]" /*22ba*/, "[?]" /*22bb*/, "[?]" /*22bc*/, "[?]" /*22bd*/, "[?]" /*22be*/, "[?]" /*22bf*/, "[?]" /*22c0*/, "[?]" /*22c1*/, "[?]" /*22c2*/, "[?]" /*22c3*/, "[?]" /*22c4*/, "[?]" /*22c5*/, "[?]" /*22c6*/, "[?]" /*22c7*/, "[?]" /*22c8*/, "[?]" /*22c9*/, "[?]" /*22ca*/, "[?]" /*22cb*/, "[?]" /*22cc*/, "[?]" /*22cd*/, "[?]" /*22ce*/, "[?]" /*22cf*/, "[?]" /*22d0*/, "[?]" /*22d1*/, "[?]" /*22d2*/, "[?]" /*22d3*/, "[?]" /*22d4*/, "[?]" /*22d5*/, "[?]" /*22d6*/, "[?]" /*22d7*/, "[?]" /*22d8*/, "[?]" /*22d9*/, "[?]" /*22da*/, "[?]" /*22db*/, "[?]" /*22dc*/, "[?]" /*22dd*/, "[?]" /*22de*/, "[?]" /*22df*/, "[?]" /*22e0*/, "[?]" /*22e1*/, "[?]" /*22e2*/, "[?]" /*22e3*/, "[?]" /*22e4*/, "[?]" /*22e5*/, "[?]" /*22e6*/, "[?]" /*22e7*/, "[?]" /*22e8*/, "[?]" /*22e9*/, "[?]" /*22ea*/, "[?]" /*22eb*/, "[?]" /*22ec*/, "[?]" /*22ed*/, "[?]" /*22ee*/, "[?]" /*22ef*/, "[?]" /*22f0*/, "[?]" /*22f1*/, "[?]" /*22f2*/, "[?]" /*22f3*/, "[?]" /*22f4*/, "[?]" /*22f5*/, "[?]" /*22f6*/, "[?]" /*22f7*/, "[?]" /*22f8*/, "[?]" /*22f9*/, "[?]" /*22fa*/, "[?]" /*22fb*/, "[?]" /*22fc*/, "[?]" /*22fd*/, "[?]" /*22fe*/, 
			});
						characters.TryAdd(35 /*8960 23*/, new string[] {
				"[?]" /*2300*/, "[?]" /*2301*/, "[?]" /*2302*/, "[?]" /*2303*/, "[?]" /*2304*/, "[?]" /*2305*/, "[?]" /*2306*/, "[?]" /*2307*/, "[?]" /*2308*/, "[?]" /*2309*/, "[?]" /*230a*/, "[?]" /*230b*/, "[?]" /*230c*/, "[?]" /*230d*/, "[?]" /*230e*/, "[?]" /*230f*/, "[?]" /*2310*/, "[?]" /*2311*/, "[?]" /*2312*/, "[?]" /*2313*/, "[?]" /*2314*/, "[?]" /*2315*/, "[?]" /*2316*/, "[?]" /*2317*/, "[?]" /*2318*/, "[?]" /*2319*/, "[?]" /*231a*/, "[?]" /*231b*/, "[?]" /*231c*/, "[?]" /*231d*/, "[?]" /*231e*/, "[?]" /*231f*/, "[?]" /*2320*/, "[?]" /*2321*/, "[?]" /*2322*/, "[?]" /*2323*/, "[?]" /*2324*/, "[?]" /*2325*/, "[?]" /*2326*/, "[?]" /*2327*/, "[?]" /*2328*/, "[?]" /*2329*/, "[?]" /*232a*/, "[?]" /*232b*/, "[?]" /*232c*/, "[?]" /*232d*/, "[?]" /*232e*/, "[?]" /*232f*/, "[?]" /*2330*/, "[?]" /*2331*/, "[?]" /*2332*/, "[?]" /*2333*/, "[?]" /*2334*/, "[?]" /*2335*/, "[?]" /*2336*/, "[?]" /*2337*/, "[?]" /*2338*/, "[?]" /*2339*/, "[?]" /*233a*/, "[?]" /*233b*/, "[?]" /*233c*/, "[?]" /*233d*/, "[?]" /*233e*/, "[?]" /*233f*/, "[?]" /*2340*/, "[?]" /*2341*/, "[?]" /*2342*/, "[?]" /*2343*/, "[?]" /*2344*/, "[?]" /*2345*/, "[?]" /*2346*/, "[?]" /*2347*/, "[?]" /*2348*/, "[?]" /*2349*/, "[?]" /*234a*/, "[?]" /*234b*/, "[?]" /*234c*/, "[?]" /*234d*/, "[?]" /*234e*/, "[?]" /*234f*/, "[?]" /*2350*/, "[?]" /*2351*/, "[?]" /*2352*/, "[?]" /*2353*/, "[?]" /*2354*/, "[?]" /*2355*/, "[?]" /*2356*/, "[?]" /*2357*/, "[?]" /*2358*/, "[?]" /*2359*/, "[?]" /*235a*/, "[?]" /*235b*/, "[?]" /*235c*/, "[?]" /*235d*/, "[?]" /*235e*/, "[?]" /*235f*/, "[?]" /*2360*/, "[?]" /*2361*/, "[?]" /*2362*/, "[?]" /*2363*/, "[?]" /*2364*/, "[?]" /*2365*/, "[?]" /*2366*/, "[?]" /*2367*/, "[?]" /*2368*/, "[?]" /*2369*/, "[?]" /*236a*/, "[?]" /*236b*/, "[?]" /*236c*/, "[?]" /*236d*/, "[?]" /*236e*/, "[?]" /*236f*/, "[?]" /*2370*/, "[?]" /*2371*/, "[?]" /*2372*/, "[?]" /*2373*/, "[?]" /*2374*/, "[?]" /*2375*/, "[?]" /*2376*/, "[?]" /*2377*/, "[?]" /*2378*/, "[?]" /*2379*/, "[?]" /*237a*/, "[?]" /*237b*/, "[?]" /*237c*/, "[?]" /*237d*/, "[?]" /*237e*/, "[?]" /*237f*/, "[?]" /*2380*/, "[?]" /*2381*/, "[?]" /*2382*/, "[?]" /*2383*/, "[?]" /*2384*/, "[?]" /*2385*/, "[?]" /*2386*/, "[?]" /*2387*/, "[?]" /*2388*/, "[?]" /*2389*/, "[?]" /*238a*/, "[?]" /*238b*/, "[?]" /*238c*/, "[?]" /*238d*/, "[?]" /*238e*/, "[?]" /*238f*/, "[?]" /*2390*/, "[?]" /*2391*/, "[?]" /*2392*/, "[?]" /*2393*/, "[?]" /*2394*/, "[?]" /*2395*/, "[?]" /*2396*/, "[?]" /*2397*/, "[?]" /*2398*/, "[?]" /*2399*/, "[?]" /*239a*/, "[?]" /*239b*/, "[?]" /*239c*/, "[?]" /*239d*/, "[?]" /*239e*/, "[?]" /*239f*/, "[?]" /*23a0*/, "[?]" /*23a1*/, "[?]" /*23a2*/, "[?]" /*23a3*/, "[?]" /*23a4*/, "[?]" /*23a5*/, "[?]" /*23a6*/, "[?]" /*23a7*/, "[?]" /*23a8*/, "[?]" /*23a9*/, "[?]" /*23aa*/, "[?]" /*23ab*/, "[?]" /*23ac*/, "[?]" /*23ad*/, "[?]" /*23ae*/, "[?]" /*23af*/, "[?]" /*23b0*/, "[?]" /*23b1*/, "[?]" /*23b2*/, "[?]" /*23b3*/, "[?]" /*23b4*/, "[?]" /*23b5*/, "[?]" /*23b6*/, "[?]" /*23b7*/, "[?]" /*23b8*/, "[?]" /*23b9*/, "[?]" /*23ba*/, "[?]" /*23bb*/, "[?]" /*23bc*/, "[?]" /*23bd*/, "[?]" /*23be*/, "[?]" /*23bf*/, "[?]" /*23c0*/, "[?]" /*23c1*/, "[?]" /*23c2*/, "[?]" /*23c3*/, "[?]" /*23c4*/, "[?]" /*23c5*/, "[?]" /*23c6*/, "[?]" /*23c7*/, "[?]" /*23c8*/, "[?]" /*23c9*/, "[?]" /*23ca*/, "[?]" /*23cb*/, "[?]" /*23cc*/, "[?]" /*23cd*/, "[?]" /*23ce*/, "[?]" /*23cf*/, "[?]" /*23d0*/, "[?]" /*23d1*/, "[?]" /*23d2*/, "[?]" /*23d3*/, "[?]" /*23d4*/, "[?]" /*23d5*/, "[?]" /*23d6*/, "[?]" /*23d7*/, "[?]" /*23d8*/, "[?]" /*23d9*/, "[?]" /*23da*/, "[?]" /*23db*/, "[?]" /*23dc*/, "[?]" /*23dd*/, "[?]" /*23de*/, "[?]" /*23df*/, "[?]" /*23e0*/, "[?]" /*23e1*/, "[?]" /*23e2*/, "[?]" /*23e3*/, "[?]" /*23e4*/, "[?]" /*23e5*/, "[?]" /*23e6*/, "[?]" /*23e7*/, "[?]" /*23e8*/, "[?]" /*23e9*/, "[?]" /*23ea*/, "[?]" /*23eb*/, "[?]" /*23ec*/, "[?]" /*23ed*/, "[?]" /*23ee*/, "[?]" /*23ef*/, "[?]" /*23f0*/, "[?]" /*23f1*/, "[?]" /*23f2*/, "[?]" /*23f3*/, "[?]" /*23f4*/, "[?]" /*23f5*/, "[?]" /*23f6*/, "[?]" /*23f7*/, "[?]" /*23f8*/, "[?]" /*23f9*/, "[?]" /*23fa*/, "[?]" /*23fb*/, "[?]" /*23fc*/, "[?]" /*23fd*/, "[?]" /*23fe*/, 
			});
						characters.TryAdd(36 /*9216 24*/, new string[] {
				"" /*2400*/, "" /*2401*/, "" /*2402*/, "" /*2403*/, "" /*2404*/, "" /*2405*/, "" /*2406*/, "" /*2407*/, "" /*2408*/, "" /*2409*/, "" /*240a*/, "" /*240b*/, "" /*240c*/, "" /*240d*/, "" /*240e*/, "" /*240f*/, "" /*2410*/, "" /*2411*/, "" /*2412*/, "" /*2413*/, "" /*2414*/, "" /*2415*/, "" /*2416*/, "" /*2417*/, "" /*2418*/, "" /*2419*/, "" /*241a*/, "" /*241b*/, "" /*241c*/, "" /*241d*/, "" /*241e*/, "" /*241f*/, "" /*2420*/, "" /*2421*/, "" /*2422*/, "" /*2423*/, "" /*2424*/, "" /*2425*/, "" /*2426*/, "[?]" /*2427*/, "[?]" /*2428*/, "[?]" /*2429*/, "[?]" /*242a*/, "[?]" /*242b*/, "[?]" /*242c*/, "[?]" /*242d*/, "[?]" /*242e*/, "[?]" /*242f*/, "[?]" /*2430*/, "[?]" /*2431*/, "[?]" /*2432*/, "[?]" /*2433*/, "[?]" /*2434*/, "[?]" /*2435*/, "[?]" /*2436*/, "[?]" /*2437*/, "[?]" /*2438*/, "[?]" /*2439*/, "[?]" /*243a*/, "[?]" /*243b*/, "[?]" /*243c*/, "[?]" /*243d*/, "[?]" /*243e*/, "[?]" /*243f*/, "" /*2440*/, "" /*2441*/, "" /*2442*/, "" /*2443*/, "" /*2444*/, "" /*2445*/, "" /*2446*/, "" /*2447*/, "" /*2448*/, "" /*2449*/, "" /*244a*/, "[?]" /*244b*/, "[?]" /*244c*/, "[?]" /*244d*/, "[?]" /*244e*/, "[?]" /*244f*/, "[?]" /*2450*/, "[?]" /*2451*/, "[?]" /*2452*/, "[?]" /*2453*/, "[?]" /*2454*/, "[?]" /*2455*/, "[?]" /*2456*/, "[?]" /*2457*/, "[?]" /*2458*/, "[?]" /*2459*/, "[?]" /*245a*/, "[?]" /*245b*/, "[?]" /*245c*/, "[?]" /*245d*/, "[?]" /*245e*/, "[?]" /*245f*/, "" /*2460*/, "" /*2461*/, "" /*2462*/, "" /*2463*/, "" /*2464*/, "" /*2465*/, "" /*2466*/, "" /*2467*/, "" /*2468*/, "" /*2469*/, "" /*246a*/, "" /*246b*/, "" /*246c*/, "" /*246d*/, "" /*246e*/, "" /*246f*/, "" /*2470*/, "" /*2471*/, "" /*2472*/, "" /*2473*/, "" /*2474*/, "" /*2475*/, "" /*2476*/, "" /*2477*/, "" /*2478*/, "" /*2479*/, "" /*247a*/, "" /*247b*/, "" /*247c*/, "" /*247d*/, "" /*247e*/, "" /*247f*/, "" /*2480*/, "" /*2481*/, "" /*2482*/, "" /*2483*/, "" /*2484*/, "" /*2485*/, "" /*2486*/, "" /*2487*/, "" /*2488*/, "" /*2489*/, "" /*248a*/, "" /*248b*/, "" /*248c*/, "" /*248d*/, "" /*248e*/, "" /*248f*/, "" /*2490*/, "" /*2491*/, "" /*2492*/, "" /*2493*/, "" /*2494*/, "" /*2495*/, "" /*2496*/, "" /*2497*/, "" /*2498*/, "" /*2499*/, "" /*249a*/, "" /*249b*/, "" /*249c*/, "" /*249d*/, "" /*249e*/, "" /*249f*/, "" /*24a0*/, "" /*24a1*/, "" /*24a2*/, "" /*24a3*/, "" /*24a4*/, "" /*24a5*/, "" /*24a6*/, "" /*24a7*/, "" /*24a8*/, "" /*24a9*/, "" /*24aa*/, "" /*24ab*/, "" /*24ac*/, "" /*24ad*/, "" /*24ae*/, "" /*24af*/, "" /*24b0*/, "" /*24b1*/, "" /*24b2*/, "" /*24b3*/, "" /*24b4*/, "" /*24b5*/, "" /*24b6*/, "" /*24b7*/, "" /*24b8*/, "" /*24b9*/, "" /*24ba*/, "" /*24bb*/, "" /*24bc*/, "" /*24bd*/, "" /*24be*/, "" /*24bf*/, "" /*24c0*/, "" /*24c1*/, "" /*24c2*/, "" /*24c3*/, "" /*24c4*/, "" /*24c5*/, "" /*24c6*/, "" /*24c7*/, "" /*24c8*/, "" /*24c9*/, "" /*24ca*/, "" /*24cb*/, "" /*24cc*/, "" /*24cd*/, "" /*24ce*/, "" /*24cf*/, "" /*24d0*/, "" /*24d1*/, "" /*24d2*/, "" /*24d3*/, "" /*24d4*/, "" /*24d5*/, "" /*24d6*/, "" /*24d7*/, "" /*24d8*/, "" /*24d9*/, "" /*24da*/, "" /*24db*/, "" /*24dc*/, "" /*24dd*/, "" /*24de*/, "" /*24df*/, "" /*24e0*/, "" /*24e1*/, "" /*24e2*/, "" /*24e3*/, "" /*24e4*/, "" /*24e5*/, "" /*24e6*/, "" /*24e7*/, "" /*24e8*/, "" /*24e9*/, "" /*24ea*/, "[?]" /*24eb*/, "[?]" /*24ec*/, "[?]" /*24ed*/, "[?]" /*24ee*/, "[?]" /*24ef*/, "[?]" /*24f0*/, "[?]" /*24f1*/, "[?]" /*24f2*/, "[?]" /*24f3*/, "[?]" /*24f4*/, "[?]" /*24f5*/, "[?]" /*24f6*/, "[?]" /*24f7*/, "[?]" /*24f8*/, "[?]" /*24f9*/, "[?]" /*24fa*/, "[?]" /*24fb*/, "[?]" /*24fc*/, "[?]" /*24fd*/, "[?]" /*24fe*/, 
			});
						characters.TryAdd(37 /*9472 25*/, new string[] {
				"-" /*2500*/, "-" /*2501*/, "|" /*2502*/, "|" /*2503*/, "-" /*2504*/, "-" /*2505*/, "|" /*2506*/, "|" /*2507*/, "-" /*2508*/, "-" /*2509*/, "|" /*250a*/, "|" /*250b*/, "+" /*250c*/, "+" /*250d*/, "+" /*250e*/, "+" /*250f*/, "+" /*2510*/, "+" /*2511*/, "+" /*2512*/, "+" /*2513*/, "+" /*2514*/, "+" /*2515*/, "+" /*2516*/, "+" /*2517*/, "+" /*2518*/, "+" /*2519*/, "+" /*251a*/, "+" /*251b*/, "+" /*251c*/, "+" /*251d*/, "+" /*251e*/, "+" /*251f*/, "+" /*2520*/, "+" /*2521*/, "+" /*2522*/, "+" /*2523*/, "+" /*2524*/, "+" /*2525*/, "+" /*2526*/, "+" /*2527*/, "+" /*2528*/, "+" /*2529*/, "+" /*252a*/, "+" /*252b*/, "+" /*252c*/, "+" /*252d*/, "+" /*252e*/, "+" /*252f*/, "+" /*2530*/, "+" /*2531*/, "+" /*2532*/, "+" /*2533*/, "+" /*2534*/, "+" /*2535*/, "+" /*2536*/, "+" /*2537*/, "+" /*2538*/, "+" /*2539*/, "+" /*253a*/, "+" /*253b*/, "+" /*253c*/, "+" /*253d*/, "+" /*253e*/, "+" /*253f*/, "+" /*2540*/, "+" /*2541*/, "+" /*2542*/, "+" /*2543*/, "+" /*2544*/, "+" /*2545*/, "+" /*2546*/, "+" /*2547*/, "+" /*2548*/, "+" /*2549*/, "+" /*254a*/, "+" /*254b*/, "-" /*254c*/, "-" /*254d*/, "|" /*254e*/, "|" /*254f*/, "-" /*2550*/, "|" /*2551*/, "+" /*2552*/, "+" /*2553*/, "+" /*2554*/, "+" /*2555*/, "+" /*2556*/, "+" /*2557*/, "+" /*2558*/, "+" /*2559*/, "+" /*255a*/, "+" /*255b*/, "+" /*255c*/, "+" /*255d*/, "+" /*255e*/, "+" /*255f*/, "+" /*2560*/, "+" /*2561*/, "+" /*2562*/, "+" /*2563*/, "+" /*2564*/, "+" /*2565*/, "+" /*2566*/, "+" /*2567*/, "+" /*2568*/, "+" /*2569*/, "+" /*256a*/, "+" /*256b*/, "+" /*256c*/, "+" /*256d*/, "+" /*256e*/, "+" /*256f*/, "+" /*2570*/, "/" /*2571*/, "\\" /*2572*/, "X" /*2573*/, "-" /*2574*/, "|" /*2575*/, "-" /*2576*/, "|" /*2577*/, "-" /*2578*/, "|" /*2579*/, "-" /*257a*/, "|" /*257b*/, "-" /*257c*/, "|" /*257d*/, "-" /*257e*/, "|" /*257f*/, "#" /*2580*/, "#" /*2581*/, "#" /*2582*/, "#" /*2583*/, "#" /*2584*/, "#" /*2585*/, "#" /*2586*/, "#" /*2587*/, "#" /*2588*/, "#" /*2589*/, "#" /*258a*/, "#" /*258b*/, "#" /*258c*/, "#" /*258d*/, "#" /*258e*/, "#" /*258f*/, "#" /*2590*/, "#" /*2591*/, "#" /*2592*/, "#" /*2593*/, "-" /*2594*/, "|" /*2595*/, "[?]" /*2596*/, "[?]" /*2597*/, "[?]" /*2598*/, "[?]" /*2599*/, "[?]" /*259a*/, "[?]" /*259b*/, "[?]" /*259c*/, "[?]" /*259d*/, "[?]" /*259e*/, "[?]" /*259f*/, "#" /*25a0*/, "#" /*25a1*/, "#" /*25a2*/, "#" /*25a3*/, "#" /*25a4*/, "#" /*25a5*/, "#" /*25a6*/, "#" /*25a7*/, "#" /*25a8*/, "#" /*25a9*/, "#" /*25aa*/, "#" /*25ab*/, "#" /*25ac*/, "#" /*25ad*/, "#" /*25ae*/, "#" /*25af*/, "#" /*25b0*/, "#" /*25b1*/, "^" /*25b2*/, "^" /*25b3*/, "^" /*25b4*/, "^" /*25b5*/, ">" /*25b6*/, ">" /*25b7*/, ">" /*25b8*/, ">" /*25b9*/, ">" /*25ba*/, ">" /*25bb*/, "V" /*25bc*/, "V" /*25bd*/, "V" /*25be*/, "V" /*25bf*/, "<" /*25c0*/, "<" /*25c1*/, "<" /*25c2*/, "<" /*25c3*/, "<" /*25c4*/, "<" /*25c5*/, "*" /*25c6*/, "*" /*25c7*/, "*" /*25c8*/, "*" /*25c9*/, "*" /*25ca*/, "*" /*25cb*/, "*" /*25cc*/, "*" /*25cd*/, "*" /*25ce*/, "*" /*25cf*/, "*" /*25d0*/, "*" /*25d1*/, "*" /*25d2*/, "*" /*25d3*/, "*" /*25d4*/, "*" /*25d5*/, "*" /*25d6*/, "*" /*25d7*/, "*" /*25d8*/, "*" /*25d9*/, "*" /*25da*/, "*" /*25db*/, "*" /*25dc*/, "*" /*25dd*/, "*" /*25de*/, "*" /*25df*/, "*" /*25e0*/, "*" /*25e1*/, "*" /*25e2*/, "*" /*25e3*/, "*" /*25e4*/, "*" /*25e5*/, "*" /*25e6*/, "#" /*25e7*/, "#" /*25e8*/, "#" /*25e9*/, "#" /*25ea*/, "#" /*25eb*/, "^" /*25ec*/, "^" /*25ed*/, "^" /*25ee*/, "O" /*25ef*/, "#" /*25f0*/, "#" /*25f1*/, "#" /*25f2*/, "#" /*25f3*/, "#" /*25f4*/, "#" /*25f5*/, "#" /*25f6*/, "#" /*25f7*/, "[?]" /*25f8*/, "[?]" /*25f9*/, "[?]" /*25fa*/, "[?]" /*25fb*/, "[?]" /*25fc*/, "[?]" /*25fd*/, "[?]" /*25fe*/, 
			});
						characters.TryAdd(38 /*9728 26*/, new string[] {
				"" /*2600*/, "" /*2601*/, "" /*2602*/, "" /*2603*/, "" /*2604*/, "" /*2605*/, "" /*2606*/, "" /*2607*/, "" /*2608*/, "" /*2609*/, "" /*260a*/, "" /*260b*/, "" /*260c*/, "" /*260d*/, "" /*260e*/, "" /*260f*/, "" /*2610*/, "" /*2611*/, "" /*2612*/, "" /*2613*/, "[?]" /*2614*/, "[?]" /*2615*/, "[?]" /*2616*/, "[?]" /*2617*/, "[?]" /*2618*/, "" /*2619*/, "" /*261a*/, "" /*261b*/, "" /*261c*/, "" /*261d*/, "" /*261e*/, "" /*261f*/, "" /*2620*/, "" /*2621*/, "" /*2622*/, "" /*2623*/, "" /*2624*/, "" /*2625*/, "" /*2626*/, "" /*2627*/, "" /*2628*/, "" /*2629*/, "" /*262a*/, "" /*262b*/, "" /*262c*/, "" /*262d*/, "" /*262e*/, "" /*262f*/, "" /*2630*/, "" /*2631*/, "" /*2632*/, "" /*2633*/, "" /*2634*/, "" /*2635*/, "" /*2636*/, "" /*2637*/, "" /*2638*/, "" /*2639*/, "" /*263a*/, "" /*263b*/, "" /*263c*/, "" /*263d*/, "" /*263e*/, "" /*263f*/, "" /*2640*/, "" /*2641*/, "" /*2642*/, "" /*2643*/, "" /*2644*/, "" /*2645*/, "" /*2646*/, "" /*2647*/, "" /*2648*/, "" /*2649*/, "" /*264a*/, "" /*264b*/, "" /*264c*/, "" /*264d*/, "" /*264e*/, "" /*264f*/, "" /*2650*/, "" /*2651*/, "" /*2652*/, "" /*2653*/, "" /*2654*/, "" /*2655*/, "" /*2656*/, "" /*2657*/, "" /*2658*/, "" /*2659*/, "" /*265a*/, "" /*265b*/, "" /*265c*/, "" /*265d*/, "" /*265e*/, "" /*265f*/, "" /*2660*/, "" /*2661*/, "" /*2662*/, "" /*2663*/, "" /*2664*/, "" /*2665*/, "" /*2666*/, "" /*2667*/, "" /*2668*/, "" /*2669*/, "" /*266a*/, "" /*266b*/, "" /*266c*/, "" /*266d*/, "" /*266e*/, "" /*266f*/, "" /*2670*/, "" /*2671*/, "[?]" /*2672*/, "[?]" /*2673*/, "[?]" /*2674*/, "[?]" /*2675*/, "[?]" /*2676*/, "[?]" /*2677*/, "[?]" /*2678*/, "[?]" /*2679*/, "[?]" /*267a*/, "[?]" /*267b*/, "[?]" /*267c*/, "[?]" /*267d*/, "[?]" /*267e*/, "[?]" /*267f*/, "[?]" /*2680*/, "[?]" /*2681*/, "[?]" /*2682*/, "[?]" /*2683*/, "[?]" /*2684*/, "[?]" /*2685*/, "[?]" /*2686*/, "[?]" /*2687*/, "[?]" /*2688*/, "[?]" /*2689*/, "[?]" /*268a*/, "[?]" /*268b*/, "[?]" /*268c*/, "[?]" /*268d*/, "[?]" /*268e*/, "[?]" /*268f*/, "[?]" /*2690*/, "[?]" /*2691*/, "[?]" /*2692*/, "[?]" /*2693*/, "[?]" /*2694*/, "[?]" /*2695*/, "[?]" /*2696*/, "[?]" /*2697*/, "[?]" /*2698*/, "[?]" /*2699*/, "[?]" /*269a*/, "[?]" /*269b*/, "[?]" /*269c*/, "[?]" /*269d*/, "[?]" /*269e*/, "[?]" /*269f*/, "[?]" /*26a0*/, "[?]" /*26a1*/, "[?]" /*26a2*/, "[?]" /*26a3*/, "[?]" /*26a4*/, "[?]" /*26a5*/, "[?]" /*26a6*/, "[?]" /*26a7*/, "[?]" /*26a8*/, "[?]" /*26a9*/, "[?]" /*26aa*/, "[?]" /*26ab*/, "[?]" /*26ac*/, "[?]" /*26ad*/, "[?]" /*26ae*/, "[?]" /*26af*/, "[?]" /*26b0*/, "[?]" /*26b1*/, "[?]" /*26b2*/, "[?]" /*26b3*/, "[?]" /*26b4*/, "[?]" /*26b5*/, "[?]" /*26b6*/, "[?]" /*26b7*/, "[?]" /*26b8*/, "[?]" /*26b9*/, "[?]" /*26ba*/, "[?]" /*26bb*/, "[?]" /*26bc*/, "[?]" /*26bd*/, "[?]" /*26be*/, "[?]" /*26bf*/, "[?]" /*26c0*/, "[?]" /*26c1*/, "[?]" /*26c2*/, "[?]" /*26c3*/, "[?]" /*26c4*/, "[?]" /*26c5*/, "[?]" /*26c6*/, "[?]" /*26c7*/, "[?]" /*26c8*/, "[?]" /*26c9*/, "[?]" /*26ca*/, "[?]" /*26cb*/, "[?]" /*26cc*/, "[?]" /*26cd*/, "[?]" /*26ce*/, "[?]" /*26cf*/, "[?]" /*26d0*/, "[?]" /*26d1*/, "[?]" /*26d2*/, "[?]" /*26d3*/, "[?]" /*26d4*/, "[?]" /*26d5*/, "[?]" /*26d6*/, "[?]" /*26d7*/, "[?]" /*26d8*/, "[?]" /*26d9*/, "[?]" /*26da*/, "[?]" /*26db*/, "[?]" /*26dc*/, "[?]" /*26dd*/, "[?]" /*26de*/, "[?]" /*26df*/, "[?]" /*26e0*/, "[?]" /*26e1*/, "[?]" /*26e2*/, "[?]" /*26e3*/, "[?]" /*26e4*/, "[?]" /*26e5*/, "[?]" /*26e6*/, "[?]" /*26e7*/, "[?]" /*26e8*/, "[?]" /*26e9*/, "[?]" /*26ea*/, "[?]" /*26eb*/, "[?]" /*26ec*/, "[?]" /*26ed*/, "[?]" /*26ee*/, "[?]" /*26ef*/, "[?]" /*26f0*/, "[?]" /*26f1*/, "[?]" /*26f2*/, "[?]" /*26f3*/, "[?]" /*26f4*/, "[?]" /*26f5*/, "[?]" /*26f6*/, "[?]" /*26f7*/, "[?]" /*26f8*/, "[?]" /*26f9*/, "[?]" /*26fa*/, "[?]" /*26fb*/, "[?]" /*26fc*/, "[?]" /*26fd*/, "[?]" /*26fe*/, 
			});
						characters.TryAdd(39 /*9984 27*/, new string[] {
				"[?]" /*2700*/, "" /*2701*/, "" /*2702*/, "" /*2703*/, "" /*2704*/, "" /*2705*/, "" /*2706*/, "" /*2707*/, "" /*2708*/, "" /*2709*/, "" /*270a*/, "" /*270b*/, "" /*270c*/, "" /*270d*/, "" /*270e*/, "" /*270f*/, "" /*2710*/, "" /*2711*/, "" /*2712*/, "" /*2713*/, "" /*2714*/, "" /*2715*/, "" /*2716*/, "" /*2717*/, "" /*2718*/, "" /*2719*/, "" /*271a*/, "" /*271b*/, "" /*271c*/, "" /*271d*/, "" /*271e*/, "" /*271f*/, "" /*2720*/, "" /*2721*/, "" /*2722*/, "" /*2723*/, "" /*2724*/, "" /*2725*/, "" /*2726*/, "" /*2727*/, "" /*2728*/, "" /*2729*/, "" /*272a*/, "" /*272b*/, "" /*272c*/, "" /*272d*/, "" /*272e*/, "" /*272f*/, "" /*2730*/, "" /*2731*/, "" /*2732*/, "" /*2733*/, "" /*2734*/, "" /*2735*/, "" /*2736*/, "" /*2737*/, "" /*2738*/, "" /*2739*/, "" /*273a*/, "" /*273b*/, "" /*273c*/, "" /*273d*/, "" /*273e*/, "" /*273f*/, "" /*2740*/, "" /*2741*/, "" /*2742*/, "" /*2743*/, "" /*2744*/, "" /*2745*/, "" /*2746*/, "" /*2747*/, "" /*2748*/, "" /*2749*/, "" /*274a*/, "" /*274b*/, "" /*274c*/, "" /*274d*/, "" /*274e*/, "" /*274f*/, "" /*2750*/, "" /*2751*/, "" /*2752*/, "" /*2753*/, "" /*2754*/, "" /*2755*/, "" /*2756*/, "" /*2757*/, "" /*2758*/, "" /*2759*/, "" /*275a*/, "" /*275b*/, "" /*275c*/, "" /*275d*/, "" /*275e*/, "[?]" /*275f*/, "[?]" /*2760*/, "" /*2761*/, "" /*2762*/, "" /*2763*/, "" /*2764*/, "" /*2765*/, "" /*2766*/, "" /*2767*/, "" /*2768*/, "" /*2769*/, "" /*276a*/, "" /*276b*/, "" /*276c*/, "" /*276d*/, "" /*276e*/, "" /*276f*/, "" /*2770*/, "" /*2771*/, "" /*2772*/, "" /*2773*/, "" /*2774*/, "" /*2775*/, "" /*2776*/, "" /*2777*/, "" /*2778*/, "" /*2779*/, "" /*277a*/, "" /*277b*/, "" /*277c*/, "" /*277d*/, "" /*277e*/, "" /*277f*/, "" /*2780*/, "" /*2781*/, "" /*2782*/, "" /*2783*/, "" /*2784*/, "" /*2785*/, "" /*2786*/, "" /*2787*/, "" /*2788*/, "" /*2789*/, "" /*278a*/, "" /*278b*/, "" /*278c*/, "" /*278d*/, "" /*278e*/, "" /*278f*/, "" /*2790*/, "" /*2791*/, "" /*2792*/, "" /*2793*/, "" /*2794*/, "" /*2795*/, "" /*2796*/, "" /*2797*/, "" /*2798*/, "" /*2799*/, "" /*279a*/, "" /*279b*/, "" /*279c*/, "" /*279d*/, "" /*279e*/, "" /*279f*/, "" /*27a0*/, "" /*27a1*/, "" /*27a2*/, "" /*27a3*/, "" /*27a4*/, "" /*27a5*/, "" /*27a6*/, "" /*27a7*/, "" /*27a8*/, "" /*27a9*/, "" /*27aa*/, "" /*27ab*/, "" /*27ac*/, "" /*27ad*/, "" /*27ae*/, "" /*27af*/, "[?]" /*27b0*/, "" /*27b1*/, "" /*27b2*/, "" /*27b3*/, "" /*27b4*/, "" /*27b5*/, "" /*27b6*/, "" /*27b7*/, "" /*27b8*/, "" /*27b9*/, "" /*27ba*/, "" /*27bb*/, "" /*27bc*/, "" /*27bd*/, "" /*27be*/, "[?]" /*27bf*/, "[?]" /*27c0*/, "[?]" /*27c1*/, "[?]" /*27c2*/, "[?]" /*27c3*/, "[?]" /*27c4*/, "[?]" /*27c5*/, "[?]" /*27c6*/, "[?]" /*27c7*/, "[?]" /*27c8*/, "[?]" /*27c9*/, "[?]" /*27ca*/, "[?]" /*27cb*/, "[?]" /*27cc*/, "[?]" /*27cd*/, "[?]" /*27ce*/, "[?]" /*27cf*/, "[?]" /*27d0*/, "[?]" /*27d1*/, "[?]" /*27d2*/, "[?]" /*27d3*/, "[?]" /*27d4*/, "[?]" /*27d5*/, "[?]" /*27d6*/, "[?]" /*27d7*/, "[?]" /*27d8*/, "[?]" /*27d9*/, "[?]" /*27da*/, "[?]" /*27db*/, "[?]" /*27dc*/, "[?]" /*27dd*/, "[?]" /*27de*/, "[?]" /*27df*/, "[?]" /*27e0*/, "[?]" /*27e1*/, "[?]" /*27e2*/, "[?]" /*27e3*/, "[?]" /*27e4*/, "[?]" /*27e5*/, "[?]" /*27e6*/, "[?]" /*27e7*/, "[?]" /*27e8*/, "[?]" /*27e9*/, "[?]" /*27ea*/, "[?]" /*27eb*/, "[?]" /*27ec*/, "[?]" /*27ed*/, "[?]" /*27ee*/, "[?]" /*27ef*/, "[?]" /*27f0*/, "[?]" /*27f1*/, "[?]" /*27f2*/, "[?]" /*27f3*/, "[?]" /*27f4*/, "[?]" /*27f5*/, "[?]" /*27f6*/, "[?]" /*27f7*/, "[?]" /*27f8*/, "[?]" /*27f9*/, "[?]" /*27fa*/, "[?]" /*27fb*/, "[?]" /*27fc*/, "[?]" /*27fd*/, "[?]" /*27fe*/, 
			});
						characters.TryAdd(40 /*10240 28*/, new string[] {
				" " /*2800*/, "a" /*2801*/, "1" /*2802*/, "b" /*2803*/, "'" /*2804*/, "k" /*2805*/, "2" /*2806*/, "l" /*2807*/, "@" /*2808*/, "c" /*2809*/, "i" /*280a*/, "f" /*280b*/, "/" /*280c*/, "m" /*280d*/, "s" /*280e*/, "p" /*280f*/, "\"" /*2810*/, "e" /*2811*/, "3" /*2812*/, "h" /*2813*/, "9" /*2814*/, "o" /*2815*/, "6" /*2816*/, "r" /*2817*/, "^" /*2818*/, "d" /*2819*/, "j" /*281a*/, "g" /*281b*/, ">" /*281c*/, "n" /*281d*/, "t" /*281e*/, "q" /*281f*/, "," /*2820*/, "*" /*2821*/, "5" /*2822*/, "<" /*2823*/, "-" /*2824*/, "u" /*2825*/, "8" /*2826*/, "v" /*2827*/, "." /*2828*/, "%" /*2829*/, "[" /*282a*/, "$" /*282b*/, "+" /*282c*/, "x" /*282d*/, "!" /*282e*/, "&" /*282f*/, ";" /*2830*/, ":" /*2831*/, "4" /*2832*/, "\\" /*2833*/, "0" /*2834*/, "z" /*2835*/, "7" /*2836*/, "(" /*2837*/, "_" /*2838*/, "?" /*2839*/, "w" /*283a*/, "]" /*283b*/, "#" /*283c*/, "y" /*283d*/, ")" /*283e*/, "=" /*283f*/, "[d7]" /*2840*/, "[d17]" /*2841*/, "[d27]" /*2842*/, "[d127]" /*2843*/, "[d37]" /*2844*/, "[d137]" /*2845*/, "[d237]" /*2846*/, "[d1237]" /*2847*/, "[d47]" /*2848*/, "[d147]" /*2849*/, "[d247]" /*284a*/, "[d1247]" /*284b*/, "[d347]" /*284c*/, "[d1347]" /*284d*/, "[d2347]" /*284e*/, "[d12347]" /*284f*/, "[d57]" /*2850*/, "[d157]" /*2851*/, "[d257]" /*2852*/, "[d1257]" /*2853*/, "[d357]" /*2854*/, "[d1357]" /*2855*/, "[d2357]" /*2856*/, "[d12357]" /*2857*/, "[d457]" /*2858*/, "[d1457]" /*2859*/, "[d2457]" /*285a*/, "[d12457]" /*285b*/, "[d3457]" /*285c*/, "[d13457]" /*285d*/, "[d23457]" /*285e*/, "[d123457]" /*285f*/, "[d67]" /*2860*/, "[d167]" /*2861*/, "[d267]" /*2862*/, "[d1267]" /*2863*/, "[d367]" /*2864*/, "[d1367]" /*2865*/, "[d2367]" /*2866*/, "[d12367]" /*2867*/, "[d467]" /*2868*/, "[d1467]" /*2869*/, "[d2467]" /*286a*/, "[d12467]" /*286b*/, "[d3467]" /*286c*/, "[d13467]" /*286d*/, "[d23467]" /*286e*/, "[d123467]" /*286f*/, "[d567]" /*2870*/, "[d1567]" /*2871*/, "[d2567]" /*2872*/, "[d12567]" /*2873*/, "[d3567]" /*2874*/, "[d13567]" /*2875*/, "[d23567]" /*2876*/, "[d123567]" /*2877*/, "[d4567]" /*2878*/, "[d14567]" /*2879*/, "[d24567]" /*287a*/, "[d124567]" /*287b*/, "[d34567]" /*287c*/, "[d134567]" /*287d*/, "[d234567]" /*287e*/, "[d1234567]" /*287f*/, "[d8]" /*2880*/, "[d18]" /*2881*/, "[d28]" /*2882*/, "[d128]" /*2883*/, "[d38]" /*2884*/, "[d138]" /*2885*/, "[d238]" /*2886*/, "[d1238]" /*2887*/, "[d48]" /*2888*/, "[d148]" /*2889*/, "[d248]" /*288a*/, "[d1248]" /*288b*/, "[d348]" /*288c*/, "[d1348]" /*288d*/, "[d2348]" /*288e*/, "[d12348]" /*288f*/, "[d58]" /*2890*/, "[d158]" /*2891*/, "[d258]" /*2892*/, "[d1258]" /*2893*/, "[d358]" /*2894*/, "[d1358]" /*2895*/, "[d2358]" /*2896*/, "[d12358]" /*2897*/, "[d458]" /*2898*/, "[d1458]" /*2899*/, "[d2458]" /*289a*/, "[d12458]" /*289b*/, "[d3458]" /*289c*/, "[d13458]" /*289d*/, "[d23458]" /*289e*/, "[d123458]" /*289f*/, "[d68]" /*28a0*/, "[d168]" /*28a1*/, "[d268]" /*28a2*/, "[d1268]" /*28a3*/, "[d368]" /*28a4*/, "[d1368]" /*28a5*/, "[d2368]" /*28a6*/, "[d12368]" /*28a7*/, "[d468]" /*28a8*/, "[d1468]" /*28a9*/, "[d2468]" /*28aa*/, "[d12468]" /*28ab*/, "[d3468]" /*28ac*/, "[d13468]" /*28ad*/, "[d23468]" /*28ae*/, "[d123468]" /*28af*/, "[d568]" /*28b0*/, "[d1568]" /*28b1*/, "[d2568]" /*28b2*/, "[d12568]" /*28b3*/, "[d3568]" /*28b4*/, "[d13568]" /*28b5*/, "[d23568]" /*28b6*/, "[d123568]" /*28b7*/, "[d4568]" /*28b8*/, "[d14568]" /*28b9*/, "[d24568]" /*28ba*/, "[d124568]" /*28bb*/, "[d34568]" /*28bc*/, "[d134568]" /*28bd*/, "[d234568]" /*28be*/, "[d1234568]" /*28bf*/, "[d78]" /*28c0*/, "[d178]" /*28c1*/, "[d278]" /*28c2*/, "[d1278]" /*28c3*/, "[d378]" /*28c4*/, "[d1378]" /*28c5*/, "[d2378]" /*28c6*/, "[d12378]" /*28c7*/, "[d478]" /*28c8*/, "[d1478]" /*28c9*/, "[d2478]" /*28ca*/, "[d12478]" /*28cb*/, "[d3478]" /*28cc*/, "[d13478]" /*28cd*/, "[d23478]" /*28ce*/, "[d123478]" /*28cf*/, "[d578]" /*28d0*/, "[d1578]" /*28d1*/, "[d2578]" /*28d2*/, "[d12578]" /*28d3*/, "[d3578]" /*28d4*/, "[d13578]" /*28d5*/, "[d23578]" /*28d6*/, "[d123578]" /*28d7*/, "[d4578]" /*28d8*/, "[d14578]" /*28d9*/, "[d24578]" /*28da*/, "[d124578]" /*28db*/, "[d34578]" /*28dc*/, "[d134578]" /*28dd*/, "[d234578]" /*28de*/, "[d1234578]" /*28df*/, "[d678]" /*28e0*/, "[d1678]" /*28e1*/, "[d2678]" /*28e2*/, "[d12678]" /*28e3*/, "[d3678]" /*28e4*/, "[d13678]" /*28e5*/, "[d23678]" /*28e6*/, "[d123678]" /*28e7*/, "[d4678]" /*28e8*/, "[d14678]" /*28e9*/, "[d24678]" /*28ea*/, "[d124678]" /*28eb*/, "[d34678]" /*28ec*/, "[d134678]" /*28ed*/, "[d234678]" /*28ee*/, "[d1234678]" /*28ef*/, "[d5678]" /*28f0*/, "[d15678]" /*28f1*/, "[d25678]" /*28f2*/, "[d125678]" /*28f3*/, "[d35678]" /*28f4*/, "[d135678]" /*28f5*/, "[d235678]" /*28f6*/, "[d1235678]" /*28f7*/, "[d45678]" /*28f8*/, "[d145678]" /*28f9*/, "[d245678]" /*28fa*/, "[d1245678]" /*28fb*/, "[d345678]" /*28fc*/, "[d1345678]" /*28fd*/, "[d2345678]" /*28fe*/, "[d12345678]" /*28ff*/ 
			});
						characters.TryAdd(46 /*11776 2e*/, new string[] {
				"[?]" /*2e00*/, "[?]" /*2e01*/, "[?]" /*2e02*/, "[?]" /*2e03*/, "[?]" /*2e04*/, "[?]" /*2e05*/, "[?]" /*2e06*/, "[?]" /*2e07*/, "[?]" /*2e08*/, "[?]" /*2e09*/, "[?]" /*2e0a*/, "[?]" /*2e0b*/, "[?]" /*2e0c*/, "[?]" /*2e0d*/, "[?]" /*2e0e*/, "[?]" /*2e0f*/, "[?]" /*2e10*/, "[?]" /*2e11*/, "[?]" /*2e12*/, "[?]" /*2e13*/, "[?]" /*2e14*/, "[?]" /*2e15*/, "[?]" /*2e16*/, "[?]" /*2e17*/, "[?]" /*2e18*/, "[?]" /*2e19*/, "[?]" /*2e1a*/, "[?]" /*2e1b*/, "[?]" /*2e1c*/, "[?]" /*2e1d*/, "[?]" /*2e1e*/, "[?]" /*2e1f*/, "[?]" /*2e20*/, "[?]" /*2e21*/, "[?]" /*2e22*/, "[?]" /*2e23*/, "[?]" /*2e24*/, "[?]" /*2e25*/, "[?]" /*2e26*/, "[?]" /*2e27*/, "[?]" /*2e28*/, "[?]" /*2e29*/, "[?]" /*2e2a*/, "[?]" /*2e2b*/, "[?]" /*2e2c*/, "[?]" /*2e2d*/, "[?]" /*2e2e*/, "[?]" /*2e2f*/, "[?]" /*2e30*/, "[?]" /*2e31*/, "[?]" /*2e32*/, "[?]" /*2e33*/, "[?]" /*2e34*/, "[?]" /*2e35*/, "[?]" /*2e36*/, "[?]" /*2e37*/, "[?]" /*2e38*/, "[?]" /*2e39*/, "[?]" /*2e3a*/, "[?]" /*2e3b*/, "[?]" /*2e3c*/, "[?]" /*2e3d*/, "[?]" /*2e3e*/, "[?]" /*2e3f*/, "[?]" /*2e40*/, "[?]" /*2e41*/, "[?]" /*2e42*/, "[?]" /*2e43*/, "[?]" /*2e44*/, "[?]" /*2e45*/, "[?]" /*2e46*/, "[?]" /*2e47*/, "[?]" /*2e48*/, "[?]" /*2e49*/, "[?]" /*2e4a*/, "[?]" /*2e4b*/, "[?]" /*2e4c*/, "[?]" /*2e4d*/, "[?]" /*2e4e*/, "[?]" /*2e4f*/, "[?]" /*2e50*/, "[?]" /*2e51*/, "[?]" /*2e52*/, "[?]" /*2e53*/, "[?]" /*2e54*/, "[?]" /*2e55*/, "[?]" /*2e56*/, "[?]" /*2e57*/, "[?]" /*2e58*/, "[?]" /*2e59*/, "[?]" /*2e5a*/, "[?]" /*2e5b*/, "[?]" /*2e5c*/, "[?]" /*2e5d*/, "[?]" /*2e5e*/, "[?]" /*2e5f*/, "[?]" /*2e60*/, "[?]" /*2e61*/, "[?]" /*2e62*/, "[?]" /*2e63*/, "[?]" /*2e64*/, "[?]" /*2e65*/, "[?]" /*2e66*/, "[?]" /*2e67*/, "[?]" /*2e68*/, "[?]" /*2e69*/, "[?]" /*2e6a*/, "[?]" /*2e6b*/, "[?]" /*2e6c*/, "[?]" /*2e6d*/, "[?]" /*2e6e*/, "[?]" /*2e6f*/, "[?]" /*2e70*/, "[?]" /*2e71*/, "[?]" /*2e72*/, "[?]" /*2e73*/, "[?]" /*2e74*/, "[?]" /*2e75*/, "[?]" /*2e76*/, "[?]" /*2e77*/, "[?]" /*2e78*/, "[?]" /*2e79*/, "[?]" /*2e7a*/, "[?]" /*2e7b*/, "[?]" /*2e7c*/, "[?]" /*2e7d*/, "[?]" /*2e7e*/, "[?]" /*2e7f*/, "[?] " /*2e80*/, "[?] " /*2e81*/, "[?] " /*2e82*/, "[?] " /*2e83*/, "[?] " /*2e84*/, "[?] " /*2e85*/, "[?] " /*2e86*/, "[?] " /*2e87*/, "[?] " /*2e88*/, "[?] " /*2e89*/, "[?] " /*2e8a*/, "[?] " /*2e8b*/, "[?] " /*2e8c*/, "[?] " /*2e8d*/, "[?] " /*2e8e*/, "[?] " /*2e8f*/, "[?] " /*2e90*/, "[?] " /*2e91*/, "[?] " /*2e92*/, "[?] " /*2e93*/, "[?] " /*2e94*/, "[?] " /*2e95*/, "[?] " /*2e96*/, "[?] " /*2e97*/, "[?] " /*2e98*/, "[?] " /*2e99*/, "[?]" /*2e9a*/, "[?] " /*2e9b*/, "[?] " /*2e9c*/, "[?] " /*2e9d*/, "[?] " /*2e9e*/, "[?] " /*2e9f*/, "[?] " /*2ea0*/, "[?] " /*2ea1*/, "[?] " /*2ea2*/, "[?] " /*2ea3*/, "[?] " /*2ea4*/, "[?] " /*2ea5*/, "[?] " /*2ea6*/, "[?] " /*2ea7*/, "[?] " /*2ea8*/, "[?] " /*2ea9*/, "[?] " /*2eaa*/, "[?] " /*2eab*/, "[?] " /*2eac*/, "[?] " /*2ead*/, "[?] " /*2eae*/, "[?] " /*2eaf*/, "[?] " /*2eb0*/, "[?] " /*2eb1*/, "[?] " /*2eb2*/, "[?] " /*2eb3*/, "[?] " /*2eb4*/, "[?] " /*2eb5*/, "[?] " /*2eb6*/, "[?] " /*2eb7*/, "[?] " /*2eb8*/, "[?] " /*2eb9*/, "[?] " /*2eba*/, "[?] " /*2ebb*/, "[?] " /*2ebc*/, "[?] " /*2ebd*/, "[?] " /*2ebe*/, "[?] " /*2ebf*/, "[?] " /*2ec0*/, "[?] " /*2ec1*/, "[?] " /*2ec2*/, "[?] " /*2ec3*/, "[?] " /*2ec4*/, "[?] " /*2ec5*/, "[?] " /*2ec6*/, "[?] " /*2ec7*/, "[?] " /*2ec8*/, "[?] " /*2ec9*/, "[?] " /*2eca*/, "[?] " /*2ecb*/, "[?] " /*2ecc*/, "[?] " /*2ecd*/, "[?] " /*2ece*/, "[?] " /*2ecf*/, "[?] " /*2ed0*/, "[?] " /*2ed1*/, "[?] " /*2ed2*/, "[?] " /*2ed3*/, "[?] " /*2ed4*/, "[?] " /*2ed5*/, "[?] " /*2ed6*/, "[?] " /*2ed7*/, "[?] " /*2ed8*/, "[?] " /*2ed9*/, "[?] " /*2eda*/, "[?] " /*2edb*/, "[?] " /*2edc*/, "[?] " /*2edd*/, "[?] " /*2ede*/, "[?] " /*2edf*/, "[?] " /*2ee0*/, "[?] " /*2ee1*/, "[?] " /*2ee2*/, "[?] " /*2ee3*/, "[?] " /*2ee4*/, "[?] " /*2ee5*/, "[?] " /*2ee6*/, "[?] " /*2ee7*/, "[?] " /*2ee8*/, "[?] " /*2ee9*/, "[?] " /*2eea*/, "[?] " /*2eeb*/, "[?] " /*2eec*/, "[?] " /*2eed*/, "[?] " /*2eee*/, "[?] " /*2eef*/, "[?] " /*2ef0*/, "[?] " /*2ef1*/, "[?] " /*2ef2*/, "[?] " /*2ef3*/, "[?]" /*2ef4*/, "[?]" /*2ef5*/, "[?]" /*2ef6*/, "[?]" /*2ef7*/, "[?]" /*2ef8*/, "[?]" /*2ef9*/, "[?]" /*2efa*/, "[?]" /*2efb*/, "[?]" /*2efc*/, "[?]" /*2efd*/, "[?]" /*2efe*/, 
			});
						characters.TryAdd(47 /*12032 2f*/, new string[] {
				"[?] " /*2f00*/, "[?] " /*2f01*/, "[?] " /*2f02*/, "[?] " /*2f03*/, "[?] " /*2f04*/, "[?] " /*2f05*/, "[?] " /*2f06*/, "[?] " /*2f07*/, "[?] " /*2f08*/, "[?] " /*2f09*/, "[?] " /*2f0a*/, "[?] " /*2f0b*/, "[?] " /*2f0c*/, "[?] " /*2f0d*/, "[?] " /*2f0e*/, "[?] " /*2f0f*/, "[?] " /*2f10*/, "[?] " /*2f11*/, "[?] " /*2f12*/, "[?] " /*2f13*/, "[?] " /*2f14*/, "[?] " /*2f15*/, "[?] " /*2f16*/, "[?] " /*2f17*/, "[?] " /*2f18*/, "[?] " /*2f19*/, "[?] " /*2f1a*/, "[?] " /*2f1b*/, "[?] " /*2f1c*/, "[?] " /*2f1d*/, "[?] " /*2f1e*/, "[?] " /*2f1f*/, "[?] " /*2f20*/, "[?] " /*2f21*/, "[?] " /*2f22*/, "[?] " /*2f23*/, "[?] " /*2f24*/, "[?] " /*2f25*/, "[?] " /*2f26*/, "[?] " /*2f27*/, "[?] " /*2f28*/, "[?] " /*2f29*/, "[?] " /*2f2a*/, "[?] " /*2f2b*/, "[?] " /*2f2c*/, "[?] " /*2f2d*/, "[?] " /*2f2e*/, "[?] " /*2f2f*/, "[?] " /*2f30*/, "[?] " /*2f31*/, "[?] " /*2f32*/, "[?] " /*2f33*/, "[?] " /*2f34*/, "[?] " /*2f35*/, "[?] " /*2f36*/, "[?] " /*2f37*/, "[?] " /*2f38*/, "[?] " /*2f39*/, "[?] " /*2f3a*/, "[?] " /*2f3b*/, "[?] " /*2f3c*/, "[?] " /*2f3d*/, "[?] " /*2f3e*/, "[?] " /*2f3f*/, "[?] " /*2f40*/, "[?] " /*2f41*/, "[?] " /*2f42*/, "[?] " /*2f43*/, "[?] " /*2f44*/, "[?] " /*2f45*/, "[?] " /*2f46*/, "[?] " /*2f47*/, "[?] " /*2f48*/, "[?] " /*2f49*/, "[?] " /*2f4a*/, "[?] " /*2f4b*/, "[?] " /*2f4c*/, "[?] " /*2f4d*/, "[?] " /*2f4e*/, "[?] " /*2f4f*/, "[?] " /*2f50*/, "[?] " /*2f51*/, "[?] " /*2f52*/, "[?] " /*2f53*/, "[?] " /*2f54*/, "[?] " /*2f55*/, "[?] " /*2f56*/, "[?] " /*2f57*/, "[?] " /*2f58*/, "[?] " /*2f59*/, "[?] " /*2f5a*/, "[?] " /*2f5b*/, "[?] " /*2f5c*/, "[?] " /*2f5d*/, "[?] " /*2f5e*/, "[?] " /*2f5f*/, "[?] " /*2f60*/, "[?] " /*2f61*/, "[?] " /*2f62*/, "[?] " /*2f63*/, "[?] " /*2f64*/, "[?] " /*2f65*/, "[?] " /*2f66*/, "[?] " /*2f67*/, "[?] " /*2f68*/, "[?] " /*2f69*/, "[?] " /*2f6a*/, "[?] " /*2f6b*/, "[?] " /*2f6c*/, "[?] " /*2f6d*/, "[?] " /*2f6e*/, "[?] " /*2f6f*/, "[?] " /*2f70*/, "[?] " /*2f71*/, "[?] " /*2f72*/, "[?] " /*2f73*/, "[?] " /*2f74*/, "[?] " /*2f75*/, "[?] " /*2f76*/, "[?] " /*2f77*/, "[?] " /*2f78*/, "[?] " /*2f79*/, "[?] " /*2f7a*/, "[?] " /*2f7b*/, "[?] " /*2f7c*/, "[?] " /*2f7d*/, "[?] " /*2f7e*/, "[?] " /*2f7f*/, "[?] " /*2f80*/, "[?] " /*2f81*/, "[?] " /*2f82*/, "[?] " /*2f83*/, "[?] " /*2f84*/, "[?] " /*2f85*/, "[?] " /*2f86*/, "[?] " /*2f87*/, "[?] " /*2f88*/, "[?] " /*2f89*/, "[?] " /*2f8a*/, "[?] " /*2f8b*/, "[?] " /*2f8c*/, "[?] " /*2f8d*/, "[?] " /*2f8e*/, "[?] " /*2f8f*/, "[?] " /*2f90*/, "[?] " /*2f91*/, "[?] " /*2f92*/, "[?] " /*2f93*/, "[?] " /*2f94*/, "[?] " /*2f95*/, "[?] " /*2f96*/, "[?] " /*2f97*/, "[?] " /*2f98*/, "[?] " /*2f99*/, "[?] " /*2f9a*/, "[?] " /*2f9b*/, "[?] " /*2f9c*/, "[?] " /*2f9d*/, "[?] " /*2f9e*/, "[?] " /*2f9f*/, "[?] " /*2fa0*/, "[?] " /*2fa1*/, "[?] " /*2fa2*/, "[?] " /*2fa3*/, "[?] " /*2fa4*/, "[?] " /*2fa5*/, "[?] " /*2fa6*/, "[?] " /*2fa7*/, "[?] " /*2fa8*/, "[?] " /*2fa9*/, "[?] " /*2faa*/, "[?] " /*2fab*/, "[?] " /*2fac*/, "[?] " /*2fad*/, "[?] " /*2fae*/, "[?] " /*2faf*/, "[?] " /*2fb0*/, "[?] " /*2fb1*/, "[?] " /*2fb2*/, "[?] " /*2fb3*/, "[?] " /*2fb4*/, "[?] " /*2fb5*/, "[?] " /*2fb6*/, "[?] " /*2fb7*/, "[?] " /*2fb8*/, "[?] " /*2fb9*/, "[?] " /*2fba*/, "[?] " /*2fbb*/, "[?] " /*2fbc*/, "[?] " /*2fbd*/, "[?] " /*2fbe*/, "[?] " /*2fbf*/, "[?] " /*2fc0*/, "[?] " /*2fc1*/, "[?] " /*2fc2*/, "[?] " /*2fc3*/, "[?] " /*2fc4*/, "[?] " /*2fc5*/, "[?] " /*2fc6*/, "[?] " /*2fc7*/, "[?] " /*2fc8*/, "[?] " /*2fc9*/, "[?] " /*2fca*/, "[?] " /*2fcb*/, "[?] " /*2fcc*/, "[?] " /*2fcd*/, "[?] " /*2fce*/, "[?] " /*2fcf*/, "[?] " /*2fd0*/, "[?] " /*2fd1*/, "[?] " /*2fd2*/, "[?] " /*2fd3*/, "[?] " /*2fd4*/, "[?] " /*2fd5*/, "[?]" /*2fd6*/, "[?]" /*2fd7*/, "[?]" /*2fd8*/, "[?]" /*2fd9*/, "[?]" /*2fda*/, "[?]" /*2fdb*/, "[?]" /*2fdc*/, "[?]" /*2fdd*/, "[?]" /*2fde*/, "[?]" /*2fdf*/, "[?]" /*2fe0*/, "[?]" /*2fe1*/, "[?]" /*2fe2*/, "[?]" /*2fe3*/, "[?]" /*2fe4*/, "[?]" /*2fe5*/, "[?]" /*2fe6*/, "[?]" /*2fe7*/, "[?]" /*2fe8*/, "[?]" /*2fe9*/, "[?]" /*2fea*/, "[?]" /*2feb*/, "[?]" /*2fec*/, "[?]" /*2fed*/, "[?]" /*2fee*/, "[?]" /*2fef*/, "[?] " /*2ff0*/, "[?] " /*2ff1*/, "[?] " /*2ff2*/, "[?] " /*2ff3*/, "[?] " /*2ff4*/, "[?] " /*2ff5*/, "[?] " /*2ff6*/, "[?] " /*2ff7*/, "[?] " /*2ff8*/, "[?] " /*2ff9*/, "[?] " /*2ffa*/, "[?] " /*2ffb*/, "[?]" /*2ffc*/, "[?]" /*2ffd*/, "[?]" /*2ffe*/, 
			});
						characters.TryAdd(48 /*12288 30*/, new string[] {
				" " /*3000*/, ", " /*3001*/, ". " /*3002*/, "\"" /*3003*/, "[JIS]" /*3004*/, "\"" /*3005*/, "/" /*3006*/, "0" /*3007*/, "<" /*3008*/, "> " /*3009*/, "<<" /*300a*/, ">> " /*300b*/, "[" /*300c*/, "] " /*300d*/, "{" /*300e*/, "} " /*300f*/, "[(" /*3010*/, ")] " /*3011*/, "@" /*3012*/, "X " /*3013*/, "[" /*3014*/, "] " /*3015*/, "[[" /*3016*/, "]] " /*3017*/, "((" /*3018*/, ")) " /*3019*/, "[[" /*301a*/, "]] " /*301b*/, "~ " /*301c*/, "``" /*301d*/, "''" /*301e*/, ",," /*301f*/, "@" /*3020*/, "1" /*3021*/, "2" /*3022*/, "3" /*3023*/, "4" /*3024*/, "5" /*3025*/, "6" /*3026*/, "7" /*3027*/, "8" /*3028*/, "9" /*3029*/, "" /*302a*/, "" /*302b*/, "" /*302c*/, "" /*302d*/, "" /*302e*/, "" /*302f*/, "~" /*3030*/, "+" /*3031*/, "+" /*3032*/, "+" /*3033*/, "+" /*3034*/, "" /*3035*/, "@" /*3036*/, " // " /*3037*/, "+10+" /*3038*/, "+20+" /*3039*/, "+30+" /*303a*/, "[?]" /*303b*/, "[?]" /*303c*/, "[?]" /*303d*/, "" /*303e*/, "" /*303f*/, "[?]" /*3040*/, "a" /*3041*/, "a" /*3042*/, "i" /*3043*/, "i" /*3044*/, "u" /*3045*/, "u" /*3046*/, "e" /*3047*/, "e" /*3048*/, "o" /*3049*/, "o" /*304a*/, "ka" /*304b*/, "ga" /*304c*/, "ki" /*304d*/, "gi" /*304e*/, "ku" /*304f*/, "gu" /*3050*/, "ke" /*3051*/, "ge" /*3052*/, "ko" /*3053*/, "go" /*3054*/, "sa" /*3055*/, "za" /*3056*/, "si" /*3057*/, "zi" /*3058*/, "su" /*3059*/, "zu" /*305a*/, "se" /*305b*/, "ze" /*305c*/, "so" /*305d*/, "zo" /*305e*/, "ta" /*305f*/, "da" /*3060*/, "ti" /*3061*/, "di" /*3062*/, "tu" /*3063*/, "tu" /*3064*/, "du" /*3065*/, "te" /*3066*/, "de" /*3067*/, "to" /*3068*/, "do" /*3069*/, "na" /*306a*/, "ni" /*306b*/, "nu" /*306c*/, "ne" /*306d*/, "no" /*306e*/, "ha" /*306f*/, "ba" /*3070*/, "pa" /*3071*/, "hi" /*3072*/, "bi" /*3073*/, "pi" /*3074*/, "hu" /*3075*/, "bu" /*3076*/, "pu" /*3077*/, "he" /*3078*/, "be" /*3079*/, "pe" /*307a*/, "ho" /*307b*/, "bo" /*307c*/, "po" /*307d*/, "ma" /*307e*/, "mi" /*307f*/, "mu" /*3080*/, "me" /*3081*/, "mo" /*3082*/, "ya" /*3083*/, "ya" /*3084*/, "yu" /*3085*/, "yu" /*3086*/, "yo" /*3087*/, "yo" /*3088*/, "ra" /*3089*/, "ri" /*308a*/, "ru" /*308b*/, "re" /*308c*/, "ro" /*308d*/, "wa" /*308e*/, "wa" /*308f*/, "wi" /*3090*/, "we" /*3091*/, "wo" /*3092*/, "n" /*3093*/, "vu" /*3094*/, "[?]" /*3095*/, "[?]" /*3096*/, "[?]" /*3097*/, "[?]" /*3098*/, "" /*3099*/, "" /*309a*/, "" /*309b*/, "" /*309c*/, "\"" /*309d*/, "\"" /*309e*/, "[?]" /*309f*/, "[?]" /*30a0*/, "a" /*30a1*/, "a" /*30a2*/, "i" /*30a3*/, "i" /*30a4*/, "u" /*30a5*/, "u" /*30a6*/, "e" /*30a7*/, "e" /*30a8*/, "o" /*30a9*/, "o" /*30aa*/, "ka" /*30ab*/, "ga" /*30ac*/, "ki" /*30ad*/, "gi" /*30ae*/, "ku" /*30af*/, "gu" /*30b0*/, "ke" /*30b1*/, "ge" /*30b2*/, "ko" /*30b3*/, "go" /*30b4*/, "sa" /*30b5*/, "za" /*30b6*/, "si" /*30b7*/, "zi" /*30b8*/, "su" /*30b9*/, "zu" /*30ba*/, "se" /*30bb*/, "ze" /*30bc*/, "so" /*30bd*/, "zo" /*30be*/, "ta" /*30bf*/, "da" /*30c0*/, "ti" /*30c1*/, "di" /*30c2*/, "tu" /*30c3*/, "tu" /*30c4*/, "du" /*30c5*/, "te" /*30c6*/, "de" /*30c7*/, "to" /*30c8*/, "do" /*30c9*/, "na" /*30ca*/, "ni" /*30cb*/, "nu" /*30cc*/, "ne" /*30cd*/, "no" /*30ce*/, "ha" /*30cf*/, "ba" /*30d0*/, "pa" /*30d1*/, "hi" /*30d2*/, "bi" /*30d3*/, "pi" /*30d4*/, "hu" /*30d5*/, "bu" /*30d6*/, "pu" /*30d7*/, "he" /*30d8*/, "be" /*30d9*/, "pe" /*30da*/, "ho" /*30db*/, "bo" /*30dc*/, "po" /*30dd*/, "ma" /*30de*/, "mi" /*30df*/, "mu" /*30e0*/, "me" /*30e1*/, "mo" /*30e2*/, "ya" /*30e3*/, "ya" /*30e4*/, "yu" /*30e5*/, "yu" /*30e6*/, "yo" /*30e7*/, "yo" /*30e8*/, "ra" /*30e9*/, "ri" /*30ea*/, "ru" /*30eb*/, "re" /*30ec*/, "ro" /*30ed*/, "wa" /*30ee*/, "wa" /*30ef*/, "wi" /*30f0*/, "we" /*30f1*/, "wo" /*30f2*/, "n" /*30f3*/, "vu" /*30f4*/, "ka" /*30f5*/, "ke" /*30f6*/, "va" /*30f7*/, "vi" /*30f8*/, "ve" /*30f9*/, "vo" /*30fa*/, "" /*30fb*/, "" /*30fc*/, "\"" /*30fd*/, "\"" /*30fe*/, 
			});
						characters.TryAdd(49 /*12544 31*/, new string[] {
				"[?]" /*3100*/, "[?]" /*3101*/, "[?]" /*3102*/, "[?]" /*3103*/, "[?]" /*3104*/, "B" /*3105*/, "P" /*3106*/, "M" /*3107*/, "F" /*3108*/, "D" /*3109*/, "T" /*310a*/, "N" /*310b*/, "L" /*310c*/, "G" /*310d*/, "K" /*310e*/, "H" /*310f*/, "J" /*3110*/, "Q" /*3111*/, "X" /*3112*/, "ZH" /*3113*/, "CH" /*3114*/, "SH" /*3115*/, "R" /*3116*/, "Z" /*3117*/, "C" /*3118*/, "S" /*3119*/, "A" /*311a*/, "O" /*311b*/, "E" /*311c*/, "EH" /*311d*/, "AI" /*311e*/, "EI" /*311f*/, "AU" /*3120*/, "OU" /*3121*/, "AN" /*3122*/, "EN" /*3123*/, "ANG" /*3124*/, "ENG" /*3125*/, "ER" /*3126*/, "I" /*3127*/, "U" /*3128*/, "IU" /*3129*/, "V" /*312a*/, "NG" /*312b*/, "GN" /*312c*/, "[?]" /*312d*/, "[?]" /*312e*/, "[?]" /*312f*/, "[?]" /*3130*/, "g" /*3131*/, "gg" /*3132*/, "gs" /*3133*/, "n" /*3134*/, "nj" /*3135*/, "nh" /*3136*/, "d" /*3137*/, "dd" /*3138*/, "r" /*3139*/, "lg" /*313a*/, "lm" /*313b*/, "lb" /*313c*/, "ls" /*313d*/, "lt" /*313e*/, "lp" /*313f*/, "rh" /*3140*/, "m" /*3141*/, "b" /*3142*/, "bb" /*3143*/, "bs" /*3144*/, "s" /*3145*/, "ss" /*3146*/, "" /*3147*/, "j" /*3148*/, "jj" /*3149*/, "c" /*314a*/, "k" /*314b*/, "t" /*314c*/, "p" /*314d*/, "h" /*314e*/, "a" /*314f*/, "ae" /*3150*/, "ya" /*3151*/, "yae" /*3152*/, "eo" /*3153*/, "e" /*3154*/, "yeo" /*3155*/, "ye" /*3156*/, "o" /*3157*/, "wa" /*3158*/, "wae" /*3159*/, "oe" /*315a*/, "yo" /*315b*/, "u" /*315c*/, "weo" /*315d*/, "we" /*315e*/, "wi" /*315f*/, "yu" /*3160*/, "eu" /*3161*/, "yi" /*3162*/, "i" /*3163*/, "" /*3164*/, "nn" /*3165*/, "nd" /*3166*/, "ns" /*3167*/, "nZ" /*3168*/, "lgs" /*3169*/, "ld" /*316a*/, "lbs" /*316b*/, "lZ" /*316c*/, "lQ" /*316d*/, "mb" /*316e*/, "ms" /*316f*/, "mZ" /*3170*/, "mN" /*3171*/, "bg" /*3172*/, "" /*3173*/, "bsg" /*3174*/, "bst" /*3175*/, "bj" /*3176*/, "bt" /*3177*/, "bN" /*3178*/, "bbN" /*3179*/, "sg" /*317a*/, "sn" /*317b*/, "sd" /*317c*/, "sb" /*317d*/, "sj" /*317e*/, "Z" /*317f*/, "" /*3180*/, "N" /*3181*/, "Ns" /*3182*/, "NZ" /*3183*/, "pN" /*3184*/, "hh" /*3185*/, "Q" /*3186*/, "yo-ya" /*3187*/, "yo-yae" /*3188*/, "yo-i" /*3189*/, "yu-yeo" /*318a*/, "yu-ye" /*318b*/, "yu-i" /*318c*/, "U" /*318d*/, "U-i" /*318e*/, "[?]" /*318f*/, "" /*3190*/, "" /*3191*/, "" /*3192*/, "" /*3193*/, "" /*3194*/, "" /*3195*/, "" /*3196*/, "" /*3197*/, "" /*3198*/, "" /*3199*/, "" /*319a*/, "" /*319b*/, "" /*319c*/, "" /*319d*/, "" /*319e*/, "" /*319f*/, "BU" /*31a0*/, "ZI" /*31a1*/, "JI" /*31a2*/, "GU" /*31a3*/, "EE" /*31a4*/, "ENN" /*31a5*/, "OO" /*31a6*/, "ONN" /*31a7*/, "IR" /*31a8*/, "ANN" /*31a9*/, "INN" /*31aa*/, "UNN" /*31ab*/, "IM" /*31ac*/, "NGG" /*31ad*/, "AINN" /*31ae*/, "AUNN" /*31af*/, "AM" /*31b0*/, "OM" /*31b1*/, "ONG" /*31b2*/, "INNN" /*31b3*/, "P" /*31b4*/, "T" /*31b5*/, "K" /*31b6*/, "H" /*31b7*/, "[?]" /*31b8*/, "[?]" /*31b9*/, "[?]" /*31ba*/, "[?]" /*31bb*/, "[?]" /*31bc*/, "[?]" /*31bd*/, "[?]" /*31be*/, "[?]" /*31bf*/, "[?]" /*31c0*/, "[?]" /*31c1*/, "[?]" /*31c2*/, "[?]" /*31c3*/, "[?]" /*31c4*/, "[?]" /*31c5*/, "[?]" /*31c6*/, "[?]" /*31c7*/, "[?]" /*31c8*/, "[?]" /*31c9*/, "[?]" /*31ca*/, "[?]" /*31cb*/, "[?]" /*31cc*/, "[?]" /*31cd*/, "[?]" /*31ce*/, "[?]" /*31cf*/, "[?]" /*31d0*/, "[?]" /*31d1*/, "[?]" /*31d2*/, "[?]" /*31d3*/, "[?]" /*31d4*/, "[?]" /*31d5*/, "[?]" /*31d6*/, "[?]" /*31d7*/, "[?]" /*31d8*/, "[?]" /*31d9*/, "[?]" /*31da*/, "[?]" /*31db*/, "[?]" /*31dc*/, "[?]" /*31dd*/, "[?]" /*31de*/, "[?]" /*31df*/, "[?]" /*31e0*/, "[?]" /*31e1*/, "[?]" /*31e2*/, "[?]" /*31e3*/, "[?]" /*31e4*/, "[?]" /*31e5*/, "[?]" /*31e6*/, "[?]" /*31e7*/, "[?]" /*31e8*/, "[?]" /*31e9*/, "[?]" /*31ea*/, "[?]" /*31eb*/, "[?]" /*31ec*/, "[?]" /*31ed*/, "[?]" /*31ee*/, "[?]" /*31ef*/, "[?]" /*31f0*/, "[?]" /*31f1*/, "[?]" /*31f2*/, "[?]" /*31f3*/, "[?]" /*31f4*/, "[?]" /*31f5*/, "[?]" /*31f6*/, "[?]" /*31f7*/, "[?]" /*31f8*/, "[?]" /*31f9*/, "[?]" /*31fa*/, "[?]" /*31fb*/, "[?]" /*31fc*/, "[?]" /*31fd*/, "[?]" /*31fe*/, 
			});
						characters.TryAdd(50 /*12800 32*/, new string[] {
				"(g)" /*3200*/, "(n)" /*3201*/, "(d)" /*3202*/, "(r)" /*3203*/, "(m)" /*3204*/, "(b)" /*3205*/, "(s)" /*3206*/, "()" /*3207*/, "(j)" /*3208*/, "(c)" /*3209*/, "(k)" /*320a*/, "(t)" /*320b*/, "(p)" /*320c*/, "(h)" /*320d*/, "(ga)" /*320e*/, "(na)" /*320f*/, "(da)" /*3210*/, "(ra)" /*3211*/, "(ma)" /*3212*/, "(ba)" /*3213*/, "(sa)" /*3214*/, "(a)" /*3215*/, "(ja)" /*3216*/, "(ca)" /*3217*/, "(ka)" /*3218*/, "(ta)" /*3219*/, "(pa)" /*321a*/, "(ha)" /*321b*/, "(ju)" /*321c*/, "[?]" /*321d*/, "[?]" /*321e*/, "[?]" /*321f*/, "(1) " /*3220*/, "(2) " /*3221*/, "(3) " /*3222*/, "(4) " /*3223*/, "(5) " /*3224*/, "(6) " /*3225*/, "(7) " /*3226*/, "(8) " /*3227*/, "(9) " /*3228*/, "(10) " /*3229*/, "(Yue) " /*322a*/, "(Huo) " /*322b*/, "(Shui) " /*322c*/, "(Mu) " /*322d*/, "(Jin) " /*322e*/, "(Tu) " /*322f*/, "(Ri) " /*3230*/, "(Zhu) " /*3231*/, "(You) " /*3232*/, "(She) " /*3233*/, "(Ming) " /*3234*/, "(Te) " /*3235*/, "(Cai) " /*3236*/, "(Zhu) " /*3237*/, "(Lao) " /*3238*/, "(Dai) " /*3239*/, "(Hu) " /*323a*/, "(Xue) " /*323b*/, "(Jian) " /*323c*/, "(Qi) " /*323d*/, "(Zi) " /*323e*/, "(Xie) " /*323f*/, "(Ji) " /*3240*/, "(Xiu) " /*3241*/, "<<" /*3242*/, ">>" /*3243*/, "[?]" /*3244*/, "[?]" /*3245*/, "[?]" /*3246*/, "[?]" /*3247*/, "[?]" /*3248*/, "[?]" /*3249*/, "[?]" /*324a*/, "[?]" /*324b*/, "[?]" /*324c*/, "[?]" /*324d*/, "[?]" /*324e*/, "[?]" /*324f*/, "[?]" /*3250*/, "[?]" /*3251*/, "[?]" /*3252*/, "[?]" /*3253*/, "[?]" /*3254*/, "[?]" /*3255*/, "[?]" /*3256*/, "[?]" /*3257*/, "[?]" /*3258*/, "[?]" /*3259*/, "[?]" /*325a*/, "[?]" /*325b*/, "[?]" /*325c*/, "[?]" /*325d*/, "[?]" /*325e*/, "[?]" /*325f*/, "(g)" /*3260*/, "(n)" /*3261*/, "(d)" /*3262*/, "(r)" /*3263*/, "(m)" /*3264*/, "(b)" /*3265*/, "(s)" /*3266*/, "()" /*3267*/, "(j)" /*3268*/, "(c)" /*3269*/, "(k)" /*326a*/, "(t)" /*326b*/, "(p)" /*326c*/, "(h)" /*326d*/, "(ga)" /*326e*/, "(na)" /*326f*/, "(da)" /*3270*/, "(ra)" /*3271*/, "(ma)" /*3272*/, "(ba)" /*3273*/, "(sa)" /*3274*/, "(a)" /*3275*/, "(ja)" /*3276*/, "(ca)" /*3277*/, "(ka)" /*3278*/, "(ta)" /*3279*/, "(pa)" /*327a*/, "(ha)" /*327b*/, "[?]" /*327c*/, "[?]" /*327d*/, "[?]" /*327e*/, "KIS " /*327f*/, "(1) " /*3280*/, "(2) " /*3281*/, "(3) " /*3282*/, "(4) " /*3283*/, "(5) " /*3284*/, "(6) " /*3285*/, "(7) " /*3286*/, "(8) " /*3287*/, "(9) " /*3288*/, "(10) " /*3289*/, "(Yue) " /*328a*/, "(Huo) " /*328b*/, "(Shui) " /*328c*/, "(Mu) " /*328d*/, "(Jin) " /*328e*/, "(Tu) " /*328f*/, "(Ri) " /*3290*/, "(Zhu) " /*3291*/, "(You) " /*3292*/, "(She) " /*3293*/, "(Ming) " /*3294*/, "(Te) " /*3295*/, "(Cai) " /*3296*/, "(Zhu) " /*3297*/, "(Lao) " /*3298*/, "(Mi) " /*3299*/, "(Nan) " /*329a*/, "(Nu) " /*329b*/, "(Shi) " /*329c*/, "(You) " /*329d*/, "(Yin) " /*329e*/, "(Zhu) " /*329f*/, "(Xiang) " /*32a0*/, "(Xiu) " /*32a1*/, "(Xie) " /*32a2*/, "(Zheng) " /*32a3*/, "(Shang) " /*32a4*/, "(Zhong) " /*32a5*/, "(Xia) " /*32a6*/, "(Zuo) " /*32a7*/, "(You) " /*32a8*/, "(Yi) " /*32a9*/, "(Zong) " /*32aa*/, "(Xue) " /*32ab*/, "(Jian) " /*32ac*/, "(Qi) " /*32ad*/, "(Zi) " /*32ae*/, "(Xie) " /*32af*/, "(Ye) " /*32b0*/, "[?]" /*32b1*/, "[?]" /*32b2*/, "[?]" /*32b3*/, "[?]" /*32b4*/, "[?]" /*32b5*/, "[?]" /*32b6*/, "[?]" /*32b7*/, "[?]" /*32b8*/, "[?]" /*32b9*/, "[?]" /*32ba*/, "[?]" /*32bb*/, "[?]" /*32bc*/, "[?]" /*32bd*/, "[?]" /*32be*/, "[?]" /*32bf*/, "1M" /*32c0*/, "2M" /*32c1*/, "3M" /*32c2*/, "4M" /*32c3*/, "5M" /*32c4*/, "6M" /*32c5*/, "7M" /*32c6*/, "8M" /*32c7*/, "9M" /*32c8*/, "10M" /*32c9*/, "11M" /*32ca*/, "12M" /*32cb*/, "[?]" /*32cc*/, "[?]" /*32cd*/, "[?]" /*32ce*/, "[?]" /*32cf*/, "a" /*32d0*/, "i" /*32d1*/, "u" /*32d2*/, "u" /*32d3*/, "o" /*32d4*/, "ka" /*32d5*/, "ki" /*32d6*/, "ku" /*32d7*/, "ke" /*32d8*/, "ko" /*32d9*/, "sa" /*32da*/, "si" /*32db*/, "su" /*32dc*/, "se" /*32dd*/, "so" /*32de*/, "ta" /*32df*/, "ti" /*32e0*/, "tu" /*32e1*/, "te" /*32e2*/, "to" /*32e3*/, "na" /*32e4*/, "ni" /*32e5*/, "nu" /*32e6*/, "ne" /*32e7*/, "no" /*32e8*/, "ha" /*32e9*/, "hi" /*32ea*/, "hu" /*32eb*/, "he" /*32ec*/, "ho" /*32ed*/, "ma" /*32ee*/, "mi" /*32ef*/, "mu" /*32f0*/, "me" /*32f1*/, "mo" /*32f2*/, "ya" /*32f3*/, "yu" /*32f4*/, "yo" /*32f5*/, "ra" /*32f6*/, "ri" /*32f7*/, "ru" /*32f8*/, "re" /*32f9*/, "ro" /*32fa*/, "wa" /*32fb*/, "wi" /*32fc*/, "we" /*32fd*/, "wo" /*32fe*/, 
			});
						characters.TryAdd(51 /*13056 33*/, new string[] {
				"apartment" /*3300*/, "alpha" /*3301*/, "ampere" /*3302*/, "are" /*3303*/, "inning" /*3304*/, "inch" /*3305*/, "won" /*3306*/, "escudo" /*3307*/, "acre" /*3308*/, "ounce" /*3309*/, "ohm" /*330a*/, "kai-ri" /*330b*/, "carat" /*330c*/, "calorie" /*330d*/, "gallon" /*330e*/, "gamma" /*330f*/, "giga" /*3310*/, "guinea" /*3311*/, "curie" /*3312*/, "guilder" /*3313*/, "kilo" /*3314*/, "kilogram" /*3315*/, "kilometer" /*3316*/, "kilowatt" /*3317*/, "gram" /*3318*/, "gram ton" /*3319*/, "cruzeiro" /*331a*/, "krone" /*331b*/, "case" /*331c*/, "koruna" /*331d*/, "co-op" /*331e*/, "cycle" /*331f*/, "centime" /*3320*/, "shilling" /*3321*/, "centi" /*3322*/, "cent" /*3323*/, "dozen" /*3324*/, "desi" /*3325*/, "dollar" /*3326*/, "ton" /*3327*/, "nano" /*3328*/, "knot" /*3329*/, "heights" /*332a*/, "percent" /*332b*/, "parts" /*332c*/, "barrel" /*332d*/, "piaster" /*332e*/, "picul" /*332f*/, "pico" /*3330*/, "building" /*3331*/, "farad" /*3332*/, "feet" /*3333*/, "bushel" /*3334*/, "franc" /*3335*/, "hectare" /*3336*/, "peso" /*3337*/, "pfennig" /*3338*/, "hertz" /*3339*/, "pence" /*333a*/, "page" /*333b*/, "beta" /*333c*/, "point" /*333d*/, "volt" /*333e*/, "hon" /*333f*/, "pound" /*3340*/, "hall" /*3341*/, "horn" /*3342*/, "micro" /*3343*/, "mile" /*3344*/, "mach" /*3345*/, "mark" /*3346*/, "mansion" /*3347*/, "micron" /*3348*/, "milli" /*3349*/, "millibar" /*334a*/, "mega" /*334b*/, "megaton" /*334c*/, "meter" /*334d*/, "yard" /*334e*/, "yard" /*334f*/, "yuan" /*3350*/, "liter" /*3351*/, "lira" /*3352*/, "rupee" /*3353*/, "ruble" /*3354*/, "rem" /*3355*/, "roentgen" /*3356*/, "watt" /*3357*/, "0h" /*3358*/, "1h" /*3359*/, "2h" /*335a*/, "3h" /*335b*/, "4h" /*335c*/, "5h" /*335d*/, "6h" /*335e*/, "7h" /*335f*/, "8h" /*3360*/, "9h" /*3361*/, "10h" /*3362*/, "11h" /*3363*/, "12h" /*3364*/, "13h" /*3365*/, "14h" /*3366*/, "15h" /*3367*/, "16h" /*3368*/, "17h" /*3369*/, "18h" /*336a*/, "19h" /*336b*/, "20h" /*336c*/, "21h" /*336d*/, "22h" /*336e*/, "23h" /*336f*/, "24h" /*3370*/, "HPA" /*3371*/, "da" /*3372*/, "AU" /*3373*/, "bar" /*3374*/, "oV" /*3375*/, "pc" /*3376*/, "[?]" /*3377*/, "[?]" /*3378*/, "[?]" /*3379*/, "[?]" /*337a*/, "Heisei" /*337b*/, "Syouwa" /*337c*/, "Taisyou" /*337d*/, "Meiji" /*337e*/, "Inc." /*337f*/, "pA" /*3380*/, "nA" /*3381*/, "microamp" /*3382*/, "mA" /*3383*/, "kA" /*3384*/, "kB" /*3385*/, "MB" /*3386*/, "GB" /*3387*/, "cal" /*3388*/, "kcal" /*3389*/, "pF" /*338a*/, "nF" /*338b*/, "microFarad" /*338c*/, "microgram" /*338d*/, "mg" /*338e*/, "kg" /*338f*/, "Hz" /*3390*/, "kHz" /*3391*/, "MHz" /*3392*/, "GHz" /*3393*/, "THz" /*3394*/, "microliter" /*3395*/, "ml" /*3396*/, "dl" /*3397*/, "kl" /*3398*/, "fm" /*3399*/, "nm" /*339a*/, "micrometer" /*339b*/, "mm" /*339c*/, "cm" /*339d*/, "km" /*339e*/, "mm^2" /*339f*/, "cm^2" /*33a0*/, "m^2" /*33a1*/, "km^2" /*33a2*/, "mm^4" /*33a3*/, "cm^3" /*33a4*/, "m^3" /*33a5*/, "km^3" /*33a6*/, "m/s" /*33a7*/, "m/s^2" /*33a8*/, "Pa" /*33a9*/, "kPa" /*33aa*/, "MPa" /*33ab*/, "GPa" /*33ac*/, "rad" /*33ad*/, "rad/s" /*33ae*/, "rad/s^2" /*33af*/, "ps" /*33b0*/, "ns" /*33b1*/, "microsecond" /*33b2*/, "ms" /*33b3*/, "pV" /*33b4*/, "nV" /*33b5*/, "microvolt" /*33b6*/, "mV" /*33b7*/, "kV" /*33b8*/, "MV" /*33b9*/, "pW" /*33ba*/, "nW" /*33bb*/, "microwatt" /*33bc*/, "mW" /*33bd*/, "kW" /*33be*/, "MW" /*33bf*/, "kOhm" /*33c0*/, "MOhm" /*33c1*/, "a.m." /*33c2*/, "Bq" /*33c3*/, "cc" /*33c4*/, "cd" /*33c5*/, "C/kg" /*33c6*/, "Co." /*33c7*/, "dB" /*33c8*/, "Gy" /*33c9*/, "ha" /*33ca*/, "HP" /*33cb*/, "in" /*33cc*/, "K.K." /*33cd*/, "KM" /*33ce*/, "kt" /*33cf*/, "lm" /*33d0*/, "ln" /*33d1*/, "log" /*33d2*/, "lx" /*33d3*/, "mb" /*33d4*/, "mil" /*33d5*/, "mol" /*33d6*/, "pH" /*33d7*/, "p.m." /*33d8*/, "PPM" /*33d9*/, "PR" /*33da*/, "sr" /*33db*/, "Sv" /*33dc*/, "Wb" /*33dd*/, "[?]" /*33de*/, "[?]" /*33df*/, "1d" /*33e0*/, "2d" /*33e1*/, "3d" /*33e2*/, "4d" /*33e3*/, "5d" /*33e4*/, "6d" /*33e5*/, "7d" /*33e6*/, "8d" /*33e7*/, "9d" /*33e8*/, "10d" /*33e9*/, "11d" /*33ea*/, "12d" /*33eb*/, "13d" /*33ec*/, "14d" /*33ed*/, "15d" /*33ee*/, "16d" /*33ef*/, "17d" /*33f0*/, "18d" /*33f1*/, "19d" /*33f2*/, "20d" /*33f3*/, "21d" /*33f4*/, "22d" /*33f5*/, "23d" /*33f6*/, "24d" /*33f7*/, "25d" /*33f8*/, "26d" /*33f9*/, "27d" /*33fa*/, "28d" /*33fb*/, "29d" /*33fc*/, "30d" /*33fd*/, "31d" /*33fe*/, 
			});
						characters.TryAdd(77 /*19712 4d*/, new string[] {
				"[?] " /*4d00*/, "[?] " /*4d01*/, "[?] " /*4d02*/, "[?] " /*4d03*/, "[?] " /*4d04*/, "[?] " /*4d05*/, "[?] " /*4d06*/, "[?] " /*4d07*/, "[?] " /*4d08*/, "[?] " /*4d09*/, "[?] " /*4d0a*/, "[?] " /*4d0b*/, "[?] " /*4d0c*/, "[?] " /*4d0d*/, "[?] " /*4d0e*/, "[?] " /*4d0f*/, "[?] " /*4d10*/, "[?] " /*4d11*/, "[?] " /*4d12*/, "[?] " /*4d13*/, "[?] " /*4d14*/, "[?] " /*4d15*/, "[?] " /*4d16*/, "[?] " /*4d17*/, "[?] " /*4d18*/, "[?] " /*4d19*/, "[?] " /*4d1a*/, "[?] " /*4d1b*/, "[?] " /*4d1c*/, "[?] " /*4d1d*/, "[?] " /*4d1e*/, "[?] " /*4d1f*/, "[?] " /*4d20*/, "[?] " /*4d21*/, "[?] " /*4d22*/, "[?] " /*4d23*/, "[?] " /*4d24*/, "[?] " /*4d25*/, "[?] " /*4d26*/, "[?] " /*4d27*/, "[?] " /*4d28*/, "[?] " /*4d29*/, "[?] " /*4d2a*/, "[?] " /*4d2b*/, "[?] " /*4d2c*/, "[?] " /*4d2d*/, "[?] " /*4d2e*/, "[?] " /*4d2f*/, "[?] " /*4d30*/, "[?] " /*4d31*/, "[?] " /*4d32*/, "[?] " /*4d33*/, "[?] " /*4d34*/, "[?] " /*4d35*/, "[?] " /*4d36*/, "[?] " /*4d37*/, "[?] " /*4d38*/, "[?] " /*4d39*/, "[?] " /*4d3a*/, "[?] " /*4d3b*/, "[?] " /*4d3c*/, "[?] " /*4d3d*/, "[?] " /*4d3e*/, "[?] " /*4d3f*/, "[?] " /*4d40*/, "[?] " /*4d41*/, "[?] " /*4d42*/, "[?] " /*4d43*/, "[?] " /*4d44*/, "[?] " /*4d45*/, "[?] " /*4d46*/, "[?] " /*4d47*/, "[?] " /*4d48*/, "[?] " /*4d49*/, "[?] " /*4d4a*/, "[?] " /*4d4b*/, "[?] " /*4d4c*/, "[?] " /*4d4d*/, "[?] " /*4d4e*/, "[?] " /*4d4f*/, "[?] " /*4d50*/, "[?] " /*4d51*/, "[?] " /*4d52*/, "[?] " /*4d53*/, "[?] " /*4d54*/, "[?] " /*4d55*/, "[?] " /*4d56*/, "[?] " /*4d57*/, "[?] " /*4d58*/, "[?] " /*4d59*/, "[?] " /*4d5a*/, "[?] " /*4d5b*/, "[?] " /*4d5c*/, "[?] " /*4d5d*/, "[?] " /*4d5e*/, "[?] " /*4d5f*/, "[?] " /*4d60*/, "[?] " /*4d61*/, "[?] " /*4d62*/, "[?] " /*4d63*/, "[?] " /*4d64*/, "[?] " /*4d65*/, "[?] " /*4d66*/, "[?] " /*4d67*/, "[?] " /*4d68*/, "[?] " /*4d69*/, "[?] " /*4d6a*/, "[?] " /*4d6b*/, "[?] " /*4d6c*/, "[?] " /*4d6d*/, "[?] " /*4d6e*/, "[?] " /*4d6f*/, "[?] " /*4d70*/, "[?] " /*4d71*/, "[?] " /*4d72*/, "[?] " /*4d73*/, "[?] " /*4d74*/, "[?] " /*4d75*/, "[?] " /*4d76*/, "[?] " /*4d77*/, "[?] " /*4d78*/, "[?] " /*4d79*/, "[?] " /*4d7a*/, "[?] " /*4d7b*/, "[?] " /*4d7c*/, "[?] " /*4d7d*/, "[?] " /*4d7e*/, "[?] " /*4d7f*/, "[?] " /*4d80*/, "[?] " /*4d81*/, "[?] " /*4d82*/, "[?] " /*4d83*/, "[?] " /*4d84*/, "[?] " /*4d85*/, "[?] " /*4d86*/, "[?] " /*4d87*/, "[?] " /*4d88*/, "[?] " /*4d89*/, "[?] " /*4d8a*/, "[?] " /*4d8b*/, "[?] " /*4d8c*/, "[?] " /*4d8d*/, "[?] " /*4d8e*/, "[?] " /*4d8f*/, "[?] " /*4d90*/, "[?] " /*4d91*/, "[?] " /*4d92*/, "[?] " /*4d93*/, "[?] " /*4d94*/, "[?] " /*4d95*/, "[?] " /*4d96*/, "[?] " /*4d97*/, "[?] " /*4d98*/, "[?] " /*4d99*/, "[?] " /*4d9a*/, "[?] " /*4d9b*/, "[?] " /*4d9c*/, "[?] " /*4d9d*/, "[?] " /*4d9e*/, "[?] " /*4d9f*/, "[?] " /*4da0*/, "[?] " /*4da1*/, "[?] " /*4da2*/, "[?] " /*4da3*/, "[?] " /*4da4*/, "[?] " /*4da5*/, "[?] " /*4da6*/, "[?] " /*4da7*/, "[?] " /*4da8*/, "[?] " /*4da9*/, "[?] " /*4daa*/, "[?] " /*4dab*/, "[?] " /*4dac*/, "[?] " /*4dad*/, "[?] " /*4dae*/, "[?] " /*4daf*/, "[?] " /*4db0*/, "[?] " /*4db1*/, "[?] " /*4db2*/, "[?] " /*4db3*/, "[?] " /*4db4*/, "[?] " /*4db5*/, "[?]" /*4db6*/, "[?]" /*4db7*/, "[?]" /*4db8*/, "[?]" /*4db9*/, "[?]" /*4dba*/, "[?]" /*4dbb*/, "[?]" /*4dbc*/, "[?]" /*4dbd*/, "[?]" /*4dbe*/, "[?]" /*4dbf*/, "[?]" /*4dc0*/, "[?]" /*4dc1*/, "[?]" /*4dc2*/, "[?]" /*4dc3*/, "[?]" /*4dc4*/, "[?]" /*4dc5*/, "[?]" /*4dc6*/, "[?]" /*4dc7*/, "[?]" /*4dc8*/, "[?]" /*4dc9*/, "[?]" /*4dca*/, "[?]" /*4dcb*/, "[?]" /*4dcc*/, "[?]" /*4dcd*/, "[?]" /*4dce*/, "[?]" /*4dcf*/, "[?]" /*4dd0*/, "[?]" /*4dd1*/, "[?]" /*4dd2*/, "[?]" /*4dd3*/, "[?]" /*4dd4*/, "[?]" /*4dd5*/, "[?]" /*4dd6*/, "[?]" /*4dd7*/, "[?]" /*4dd8*/, "[?]" /*4dd9*/, "[?]" /*4dda*/, "[?]" /*4ddb*/, "[?]" /*4ddc*/, "[?]" /*4ddd*/, "[?]" /*4dde*/, "[?]" /*4ddf*/, "[?]" /*4de0*/, "[?]" /*4de1*/, "[?]" /*4de2*/, "[?]" /*4de3*/, "[?]" /*4de4*/, "[?]" /*4de5*/, "[?]" /*4de6*/, "[?]" /*4de7*/, "[?]" /*4de8*/, "[?]" /*4de9*/, "[?]" /*4dea*/, "[?]" /*4deb*/, "[?]" /*4dec*/, "[?]" /*4ded*/, "[?]" /*4dee*/, "[?]" /*4def*/, "[?]" /*4df0*/, "[?]" /*4df1*/, "[?]" /*4df2*/, "[?]" /*4df3*/, "[?]" /*4df4*/, "[?]" /*4df5*/, "[?]" /*4df6*/, "[?]" /*4df7*/, "[?]" /*4df8*/, "[?]" /*4df9*/, "[?]" /*4dfa*/, "[?]" /*4dfb*/, "[?]" /*4dfc*/, "[?]" /*4dfd*/, "[?]" /*4dfe*/, 
			});
						characters.TryAdd(78 /*19968 4e*/, new string[] {
				"[?] " /*4e00*/, "Ding " /*4e01*/, "Kao " /*4e02*/, "Qi " /*4e03*/, "Shang " /*4e04*/, "Xia " /*4e05*/, "[?] " /*4e06*/, "Mo " /*4e07*/, "Zhang " /*4e08*/, "San " /*4e09*/, "Shang " /*4e0a*/, "Xia " /*4e0b*/, "Ji " /*4e0c*/, "Bu " /*4e0d*/, "Yu " /*4e0e*/, "Mian " /*4e0f*/, "Gai " /*4e10*/, "Chou " /*4e11*/, "Chou " /*4e12*/, "Zhuan " /*4e13*/, "Qie " /*4e14*/, "Pi " /*4e15*/, "Shi " /*4e16*/, "Shi " /*4e17*/, "Qiu " /*4e18*/, "Bing " /*4e19*/, "Ye " /*4e1a*/, "Cong " /*4e1b*/, "Dong " /*4e1c*/, "Si " /*4e1d*/, "Cheng " /*4e1e*/, "Diu " /*4e1f*/, "Qiu " /*4e20*/, "Liang " /*4e21*/, "Diu " /*4e22*/, "You " /*4e23*/, "Liang " /*4e24*/, "Yan " /*4e25*/, "Bing " /*4e26*/, "Sang " /*4e27*/, "Gun " /*4e28*/, "Jiu " /*4e29*/, "Ge " /*4e2a*/, "Ya " /*4e2b*/, "Qiang " /*4e2c*/, "Zhong " /*4e2d*/, "Ji " /*4e2e*/, "Jie " /*4e2f*/, "Feng " /*4e30*/, "Guan " /*4e31*/, "Chuan " /*4e32*/, "Chan " /*4e33*/, "Lin " /*4e34*/, "Zhuo " /*4e35*/, "Zhu " /*4e36*/, "Ha " /*4e37*/, "Wan " /*4e38*/, "Dan " /*4e39*/, "Wei " /*4e3a*/, "Zhu " /*4e3b*/, "Jing " /*4e3c*/, "Li " /*4e3d*/, "Ju " /*4e3e*/, "Pie " /*4e3f*/, "Fu " /*4e40*/, "Yi " /*4e41*/, "Yi " /*4e42*/, "Nai " /*4e43*/, "Shime " /*4e44*/, "Jiu " /*4e45*/, "Jiu " /*4e46*/, "Zhe " /*4e47*/, "Yao " /*4e48*/, "Yi " /*4e49*/, "[?] " /*4e4a*/, "Zhi " /*4e4b*/, "Wu " /*4e4c*/, "Zha " /*4e4d*/, "Hu " /*4e4e*/, "Fa " /*4e4f*/, "Le " /*4e50*/, "Zhong " /*4e51*/, "Ping " /*4e52*/, "Pang " /*4e53*/, "Qiao " /*4e54*/, "Hu " /*4e55*/, "Guai " /*4e56*/, "Cheng " /*4e57*/, "Cheng " /*4e58*/, "Yi " /*4e59*/, "Yin " /*4e5a*/, "[?] " /*4e5b*/, "Mie " /*4e5c*/, "Jiu " /*4e5d*/, "Qi " /*4e5e*/, "Ye " /*4e5f*/, "Xi " /*4e60*/, "Xiang " /*4e61*/, "Gai " /*4e62*/, "Diu " /*4e63*/, "Hal " /*4e64*/, "[?] " /*4e65*/, "Shu " /*4e66*/, "Twul " /*4e67*/, "Shi " /*4e68*/, "Ji " /*4e69*/, "Nang " /*4e6a*/, "Jia " /*4e6b*/, "Kel " /*4e6c*/, "Shi " /*4e6d*/, "[?] " /*4e6e*/, "Ol " /*4e6f*/, "Mai " /*4e70*/, "Luan " /*4e71*/, "Cal " /*4e72*/, "Ru " /*4e73*/, "Xue " /*4e74*/, "Yan " /*4e75*/, "Fu " /*4e76*/, "Sha " /*4e77*/, "Na " /*4e78*/, "Gan " /*4e79*/, "Sol " /*4e7a*/, "El " /*4e7b*/, "Cwul " /*4e7c*/, "[?] " /*4e7d*/, "Gan " /*4e7e*/, "Chi " /*4e7f*/, "Gui " /*4e80*/, "Gan " /*4e81*/, "Luan " /*4e82*/, "Lin " /*4e83*/, "Yi " /*4e84*/, "Jue " /*4e85*/, "Liao " /*4e86*/, "Ma " /*4e87*/, "Yu " /*4e88*/, "Zheng " /*4e89*/, "Shi " /*4e8a*/, "Shi " /*4e8b*/, "Er " /*4e8c*/, "Chu " /*4e8d*/, "Yu " /*4e8e*/, "Yu " /*4e8f*/, "Yu " /*4e90*/, "Yun " /*4e91*/, "Hu " /*4e92*/, "Qi " /*4e93*/, "Wu " /*4e94*/, "Jing " /*4e95*/, "Si " /*4e96*/, "Sui " /*4e97*/, "Gen " /*4e98*/, "Gen " /*4e99*/, "Ya " /*4e9a*/, "Xie " /*4e9b*/, "Ya " /*4e9c*/, "Qi " /*4e9d*/, "Ya " /*4e9e*/, "Ji " /*4e9f*/, "Tou " /*4ea0*/, "Wang " /*4ea1*/, "Kang " /*4ea2*/, "Ta " /*4ea3*/, "Jiao " /*4ea4*/, "Hai " /*4ea5*/, "Yi " /*4ea6*/, "Chan " /*4ea7*/, "Heng " /*4ea8*/, "Mu " /*4ea9*/, "[?] " /*4eaa*/, "Xiang " /*4eab*/, "Jing " /*4eac*/, "Ting " /*4ead*/, "Liang " /*4eae*/, "Xiang " /*4eaf*/, "Jing " /*4eb0*/, "Ye " /*4eb1*/, "Qin " /*4eb2*/, "Bo " /*4eb3*/, "You " /*4eb4*/, "Xie " /*4eb5*/, "Dan " /*4eb6*/, "Lian " /*4eb7*/, "Duo " /*4eb8*/, "Wei " /*4eb9*/, "Ren " /*4eba*/, "Ren " /*4ebb*/, "Ji " /*4ebc*/, "La " /*4ebd*/, "Wang " /*4ebe*/, "Yi " /*4ebf*/, "Shi " /*4ec0*/, "Ren " /*4ec1*/, "Le " /*4ec2*/, "Ding " /*4ec3*/, "Ze " /*4ec4*/, "Jin " /*4ec5*/, "Pu " /*4ec6*/, "Chou " /*4ec7*/, "Ba " /*4ec8*/, "Zhang " /*4ec9*/, "Jin " /*4eca*/, "Jie " /*4ecb*/, "Bing " /*4ecc*/, "Reng " /*4ecd*/, "Cong " /*4ece*/, "Fo " /*4ecf*/, "San " /*4ed0*/, "Lun " /*4ed1*/, "Sya " /*4ed2*/, "Cang " /*4ed3*/, "Zi " /*4ed4*/, "Shi " /*4ed5*/, "Ta " /*4ed6*/, "Zhang " /*4ed7*/, "Fu " /*4ed8*/, "Xian " /*4ed9*/, "Xian " /*4eda*/, "Tuo " /*4edb*/, "Hong " /*4edc*/, "Tong " /*4edd*/, "Ren " /*4ede*/, "Qian " /*4edf*/, "Gan " /*4ee0*/, "Yi " /*4ee1*/, "Di " /*4ee2*/, "Dai " /*4ee3*/, "Ling " /*4ee4*/, "Yi " /*4ee5*/, "Chao " /*4ee6*/, "Chang " /*4ee7*/, "Sa " /*4ee8*/, "[?] " /*4ee9*/, "Yi " /*4eea*/, "Mu " /*4eeb*/, "Men " /*4eec*/, "Ren " /*4eed*/, "Jia " /*4eee*/, "Chao " /*4eef*/, "Yang " /*4ef0*/, "Qian " /*4ef1*/, "Zhong " /*4ef2*/, "Pi " /*4ef3*/, "Wan " /*4ef4*/, "Wu " /*4ef5*/, "Jian " /*4ef6*/, "Jie " /*4ef7*/, "Yao " /*4ef8*/, "Feng " /*4ef9*/, "Cang " /*4efa*/, "Ren " /*4efb*/, "Wang " /*4efc*/, "Fen " /*4efd*/, "Di " /*4efe*/, "Fang " /*4eff*/ 
			});
						characters.TryAdd(79 /*20224 4f*/, new string[] {
				"Zhong " /*4f00*/, "Qi " /*4f01*/, "Pei " /*4f02*/, "Yu " /*4f03*/, "Diao " /*4f04*/, "Dun " /*4f05*/, "Wen " /*4f06*/, "Yi " /*4f07*/, "Xin " /*4f08*/, "Kang " /*4f09*/, "Yi " /*4f0a*/, "Ji " /*4f0b*/, "Ai " /*4f0c*/, "Wu " /*4f0d*/, "Ji " /*4f0e*/, "Fu " /*4f0f*/, "Fa " /*4f10*/, "Xiu " /*4f11*/, "Jin " /*4f12*/, "Bei " /*4f13*/, "Dan " /*4f14*/, "Fu " /*4f15*/, "Tang " /*4f16*/, "Zhong " /*4f17*/, "You " /*4f18*/, "Huo " /*4f19*/, "Hui " /*4f1a*/, "Yu " /*4f1b*/, "Cui " /*4f1c*/, "Chuan " /*4f1d*/, "San " /*4f1e*/, "Wei " /*4f1f*/, "Chuan " /*4f20*/, "Che " /*4f21*/, "Ya " /*4f22*/, "Xian " /*4f23*/, "Shang " /*4f24*/, "Chang " /*4f25*/, "Lun " /*4f26*/, "Cang " /*4f27*/, "Xun " /*4f28*/, "Xin " /*4f29*/, "Wei " /*4f2a*/, "Zhu " /*4f2b*/, "[?] " /*4f2c*/, "Xuan " /*4f2d*/, "Nu " /*4f2e*/, "Bo " /*4f2f*/, "Gu " /*4f30*/, "Ni " /*4f31*/, "Ni " /*4f32*/, "Xie " /*4f33*/, "Ban " /*4f34*/, "Xu " /*4f35*/, "Ling " /*4f36*/, "Zhou " /*4f37*/, "Shen " /*4f38*/, "Qu " /*4f39*/, "Si " /*4f3a*/, "Beng " /*4f3b*/, "Si " /*4f3c*/, "Jia " /*4f3d*/, "Pi " /*4f3e*/, "Yi " /*4f3f*/, "Si " /*4f40*/, "Ai " /*4f41*/, "Zheng " /*4f42*/, "Dian " /*4f43*/, "Han " /*4f44*/, "Mai " /*4f45*/, "Dan " /*4f46*/, "Zhu " /*4f47*/, "Bu " /*4f48*/, "Qu " /*4f49*/, "Bi " /*4f4a*/, "Shao " /*4f4b*/, "Ci " /*4f4c*/, "Wei " /*4f4d*/, "Di " /*4f4e*/, "Zhu " /*4f4f*/, "Zuo " /*4f50*/, "You " /*4f51*/, "Yang " /*4f52*/, "Ti " /*4f53*/, "Zhan " /*4f54*/, "He " /*4f55*/, "Bi " /*4f56*/, "Tuo " /*4f57*/, "She " /*4f58*/, "Yu " /*4f59*/, "Yi " /*4f5a*/, "Fo " /*4f5b*/, "Zuo " /*4f5c*/, "Kou " /*4f5d*/, "Ning " /*4f5e*/, "Tong " /*4f5f*/, "Ni " /*4f60*/, "Xuan " /*4f61*/, "Qu " /*4f62*/, "Yong " /*4f63*/, "Wa " /*4f64*/, "Qian " /*4f65*/, "[?] " /*4f66*/, "Ka " /*4f67*/, "[?] " /*4f68*/, "Pei " /*4f69*/, "Huai " /*4f6a*/, "He " /*4f6b*/, "Lao " /*4f6c*/, "Xiang " /*4f6d*/, "Ge " /*4f6e*/, "Yang " /*4f6f*/, "Bai " /*4f70*/, "Fa " /*4f71*/, "Ming " /*4f72*/, "Jia " /*4f73*/, "Er " /*4f74*/, "Bing " /*4f75*/, "Ji " /*4f76*/, "Hen " /*4f77*/, "Huo " /*4f78*/, "Gui " /*4f79*/, "Quan " /*4f7a*/, "Tiao " /*4f7b*/, "Jiao " /*4f7c*/, "Ci " /*4f7d*/, "Yi " /*4f7e*/, "Shi " /*4f7f*/, "Xing " /*4f80*/, "Shen " /*4f81*/, "Tuo " /*4f82*/, "Kan " /*4f83*/, "Zhi " /*4f84*/, "Gai " /*4f85*/, "Lai " /*4f86*/, "Yi " /*4f87*/, "Chi " /*4f88*/, "Kua " /*4f89*/, "Guang " /*4f8a*/, "Li " /*4f8b*/, "Yin " /*4f8c*/, "Shi " /*4f8d*/, "Mi " /*4f8e*/, "Zhu " /*4f8f*/, "Xu " /*4f90*/, "You " /*4f91*/, "An " /*4f92*/, "Lu " /*4f93*/, "Mou " /*4f94*/, "Er " /*4f95*/, "Lun " /*4f96*/, "Tong " /*4f97*/, "Cha " /*4f98*/, "Chi " /*4f99*/, "Xun " /*4f9a*/, "Gong " /*4f9b*/, "Zhou " /*4f9c*/, "Yi " /*4f9d*/, "Ru " /*4f9e*/, "Jian " /*4f9f*/, "Xia " /*4fa0*/, "Jia " /*4fa1*/, "Zai " /*4fa2*/, "Lu " /*4fa3*/, "Ko " /*4fa4*/, "Jiao " /*4fa5*/, "Zhen " /*4fa6*/, "Ce " /*4fa7*/, "Qiao " /*4fa8*/, "Kuai " /*4fa9*/, "Chai " /*4faa*/, "Ning " /*4fab*/, "Nong " /*4fac*/, "Jin " /*4fad*/, "Wu " /*4fae*/, "Hou " /*4faf*/, "Jiong " /*4fb0*/, "Cheng " /*4fb1*/, "Zhen " /*4fb2*/, "Zuo " /*4fb3*/, "Chou " /*4fb4*/, "Qin " /*4fb5*/, "Lu " /*4fb6*/, "Ju " /*4fb7*/, "Shu " /*4fb8*/, "Ting " /*4fb9*/, "Shen " /*4fba*/, "Tuo " /*4fbb*/, "Bo " /*4fbc*/, "Nan " /*4fbd*/, "Hao " /*4fbe*/, "Bian " /*4fbf*/, "Tui " /*4fc0*/, "Yu " /*4fc1*/, "Xi " /*4fc2*/, "Cu " /*4fc3*/, "E " /*4fc4*/, "Qiu " /*4fc5*/, "Xu " /*4fc6*/, "Kuang " /*4fc7*/, "Ku " /*4fc8*/, "Wu " /*4fc9*/, "Jun " /*4fca*/, "Yi " /*4fcb*/, "Fu " /*4fcc*/, "Lang " /*4fcd*/, "Zu " /*4fce*/, "Qiao " /*4fcf*/, "Li " /*4fd0*/, "Yong " /*4fd1*/, "Hun " /*4fd2*/, "Jing " /*4fd3*/, "Xian " /*4fd4*/, "San " /*4fd5*/, "Pai " /*4fd6*/, "Su " /*4fd7*/, "Fu " /*4fd8*/, "Xi " /*4fd9*/, "Li " /*4fda*/, "Fu " /*4fdb*/, "Ping " /*4fdc*/, "Bao " /*4fdd*/, "Yu " /*4fde*/, "Si " /*4fdf*/, "Xia " /*4fe0*/, "Xin " /*4fe1*/, "Xiu " /*4fe2*/, "Yu " /*4fe3*/, "Ti " /*4fe4*/, "Che " /*4fe5*/, "Chou " /*4fe6*/, "[?] " /*4fe7*/, "Yan " /*4fe8*/, "Lia " /*4fe9*/, "Li " /*4fea*/, "Lai " /*4feb*/, "[?] " /*4fec*/, "Jian " /*4fed*/, "Xiu " /*4fee*/, "Fu " /*4fef*/, "He " /*4ff0*/, "Ju " /*4ff1*/, "Xiao " /*4ff2*/, "Pai " /*4ff3*/, "Jian " /*4ff4*/, "Biao " /*4ff5*/, "Chu " /*4ff6*/, "Fei " /*4ff7*/, "Feng " /*4ff8*/, "Ya " /*4ff9*/, "An " /*4ffa*/, "Bei " /*4ffb*/, "Yu " /*4ffc*/, "Xin " /*4ffd*/, "Bi " /*4ffe*/, "Jian " /*4fff*/ 
			});
						characters.TryAdd(80 /*20480 50*/, new string[] {
				"Chang " /*5000*/, "Chi " /*5001*/, "Bing " /*5002*/, "Zan " /*5003*/, "Yao " /*5004*/, "Cui " /*5005*/, "Lia " /*5006*/, "Wan " /*5007*/, "Lai " /*5008*/, "Cang " /*5009*/, "Zong " /*500a*/, "Ge " /*500b*/, "Guan " /*500c*/, "Bei " /*500d*/, "Tian " /*500e*/, "Shu " /*500f*/, "Shu " /*5010*/, "Men " /*5011*/, "Dao " /*5012*/, "Tan " /*5013*/, "Jue " /*5014*/, "Chui " /*5015*/, "Xing " /*5016*/, "Peng " /*5017*/, "Tang " /*5018*/, "Hou " /*5019*/, "Yi " /*501a*/, "Qi " /*501b*/, "Ti " /*501c*/, "Gan " /*501d*/, "Jing " /*501e*/, "Jie " /*501f*/, "Sui " /*5020*/, "Chang " /*5021*/, "Jie " /*5022*/, "Fang " /*5023*/, "Zhi " /*5024*/, "Kong " /*5025*/, "Juan " /*5026*/, "Zong " /*5027*/, "Ju " /*5028*/, "Qian " /*5029*/, "Ni " /*502a*/, "Lun " /*502b*/, "Zhuo " /*502c*/, "Wei " /*502d*/, "Luo " /*502e*/, "Song " /*502f*/, "Leng " /*5030*/, "Hun " /*5031*/, "Dong " /*5032*/, "Zi " /*5033*/, "Ben " /*5034*/, "Wu " /*5035*/, "Ju " /*5036*/, "Nai " /*5037*/, "Cai " /*5038*/, "Jian " /*5039*/, "Zhai " /*503a*/, "Ye " /*503b*/, "Zhi " /*503c*/, "Sha " /*503d*/, "Qing " /*503e*/, "[?] " /*503f*/, "Ying " /*5040*/, "Cheng " /*5041*/, "Jian " /*5042*/, "Yan " /*5043*/, "Nuan " /*5044*/, "Zhong " /*5045*/, "Chun " /*5046*/, "Jia " /*5047*/, "Jie " /*5048*/, "Wei " /*5049*/, "Yu " /*504a*/, "Bing " /*504b*/, "Ruo " /*504c*/, "Ti " /*504d*/, "Wei " /*504e*/, "Pian " /*504f*/, "Yan " /*5050*/, "Feng " /*5051*/, "Tang " /*5052*/, "Wo " /*5053*/, "E " /*5054*/, "Xie " /*5055*/, "Che " /*5056*/, "Sheng " /*5057*/, "Kan " /*5058*/, "Di " /*5059*/, "Zuo " /*505a*/, "Cha " /*505b*/, "Ting " /*505c*/, "Bei " /*505d*/, "Ye " /*505e*/, "Huang " /*505f*/, "Yao " /*5060*/, "Zhan " /*5061*/, "Chou " /*5062*/, "Yan " /*5063*/, "You " /*5064*/, "Jian " /*5065*/, "Xu " /*5066*/, "Zha " /*5067*/, "Ci " /*5068*/, "Fu " /*5069*/, "Bi " /*506a*/, "Zhi " /*506b*/, "Zong " /*506c*/, "Mian " /*506d*/, "Ji " /*506e*/, "Yi " /*506f*/, "Xie " /*5070*/, "Xun " /*5071*/, "Si " /*5072*/, "Duan " /*5073*/, "Ce " /*5074*/, "Zhen " /*5075*/, "Ou " /*5076*/, "Tou " /*5077*/, "Tou " /*5078*/, "Bei " /*5079*/, "Za " /*507a*/, "Lu " /*507b*/, "Jie " /*507c*/, "Wei " /*507d*/, "Fen " /*507e*/, "Chang " /*507f*/, "Gui " /*5080*/, "Sou " /*5081*/, "Zhi " /*5082*/, "Su " /*5083*/, "Xia " /*5084*/, "Fu " /*5085*/, "Yuan " /*5086*/, "Rong " /*5087*/, "Li " /*5088*/, "Ru " /*5089*/, "Yun " /*508a*/, "Gou " /*508b*/, "Ma " /*508c*/, "Bang " /*508d*/, "Dian " /*508e*/, "Tang " /*508f*/, "Hao " /*5090*/, "Jie " /*5091*/, "Xi " /*5092*/, "Shan " /*5093*/, "Qian " /*5094*/, "Jue " /*5095*/, "Cang " /*5096*/, "Chu " /*5097*/, "San " /*5098*/, "Bei " /*5099*/, "Xiao " /*509a*/, "Yong " /*509b*/, "Yao " /*509c*/, "Tan " /*509d*/, "Suo " /*509e*/, "Yang " /*509f*/, "Fa " /*50a0*/, "Bing " /*50a1*/, "Jia " /*50a2*/, "Dai " /*50a3*/, "Zai " /*50a4*/, "Tang " /*50a5*/, "[?] " /*50a6*/, "Bin " /*50a7*/, "Chu " /*50a8*/, "Nuo " /*50a9*/, "Can " /*50aa*/, "Lei " /*50ab*/, "Cui " /*50ac*/, "Yong " /*50ad*/, "Zao " /*50ae*/, "Zong " /*50af*/, "Peng " /*50b0*/, "Song " /*50b1*/, "Ao " /*50b2*/, "Chuan " /*50b3*/, "Yu " /*50b4*/, "Zhai " /*50b5*/, "Cou " /*50b6*/, "Shang " /*50b7*/, "Qiang " /*50b8*/, "Jing " /*50b9*/, "Chi " /*50ba*/, "Sha " /*50bb*/, "Han " /*50bc*/, "Zhang " /*50bd*/, "Qing " /*50be*/, "Yan " /*50bf*/, "Di " /*50c0*/, "Xi " /*50c1*/, "Lu " /*50c2*/, "Bei " /*50c3*/, "Piao " /*50c4*/, "Jin " /*50c5*/, "Lian " /*50c6*/, "Lu " /*50c7*/, "Man " /*50c8*/, "Qian " /*50c9*/, "Xian " /*50ca*/, "Tan " /*50cb*/, "Ying " /*50cc*/, "Dong " /*50cd*/, "Zhuan " /*50ce*/, "Xiang " /*50cf*/, "Shan " /*50d0*/, "Qiao " /*50d1*/, "Jiong " /*50d2*/, "Tui " /*50d3*/, "Zun " /*50d4*/, "Pu " /*50d5*/, "Xi " /*50d6*/, "Lao " /*50d7*/, "Chang " /*50d8*/, "Guang " /*50d9*/, "Liao " /*50da*/, "Qi " /*50db*/, "Deng " /*50dc*/, "Chan " /*50dd*/, "Wei " /*50de*/, "Ji " /*50df*/, "Fan " /*50e0*/, "Hui " /*50e1*/, "Chuan " /*50e2*/, "Jian " /*50e3*/, "Dan " /*50e4*/, "Jiao " /*50e5*/, "Jiu " /*50e6*/, "Seng " /*50e7*/, "Fen " /*50e8*/, "Xian " /*50e9*/, "Jue " /*50ea*/, "E " /*50eb*/, "Jiao " /*50ec*/, "Jian " /*50ed*/, "Tong " /*50ee*/, "Lin " /*50ef*/, "Bo " /*50f0*/, "Gu " /*50f1*/, "[?] " /*50f2*/, "Su " /*50f3*/, "Xian " /*50f4*/, "Jiang " /*50f5*/, "Min " /*50f6*/, "Ye " /*50f7*/, "Jin " /*50f8*/, "Jia " /*50f9*/, "Qiao " /*50fa*/, "Pi " /*50fb*/, "Feng " /*50fc*/, "Zhou " /*50fd*/, "Ai " /*50fe*/, "Sai " /*50ff*/ 
			});
						characters.TryAdd(81 /*20736 51*/, new string[] {
				"Yi " /*5100*/, "Jun " /*5101*/, "Nong " /*5102*/, "Chan " /*5103*/, "Yi " /*5104*/, "Dang " /*5105*/, "Jing " /*5106*/, "Xuan " /*5107*/, "Kuai " /*5108*/, "Jian " /*5109*/, "Chu " /*510a*/, "Dan " /*510b*/, "Jiao " /*510c*/, "Sha " /*510d*/, "Zai " /*510e*/, "[?] " /*510f*/, "Bin " /*5110*/, "An " /*5111*/, "Ru " /*5112*/, "Tai " /*5113*/, "Chou " /*5114*/, "Chai " /*5115*/, "Lan " /*5116*/, "Ni " /*5117*/, "Jin " /*5118*/, "Qian " /*5119*/, "Meng " /*511a*/, "Wu " /*511b*/, "Ning " /*511c*/, "Qiong " /*511d*/, "Ni " /*511e*/, "Chang " /*511f*/, "Lie " /*5120*/, "Lei " /*5121*/, "Lu " /*5122*/, "Kuang " /*5123*/, "Bao " /*5124*/, "Du " /*5125*/, "Biao " /*5126*/, "Zan " /*5127*/, "Zhi " /*5128*/, "Si " /*5129*/, "You " /*512a*/, "Hao " /*512b*/, "Chen " /*512c*/, "Chen " /*512d*/, "Li " /*512e*/, "Teng " /*512f*/, "Wei " /*5130*/, "Long " /*5131*/, "Chu " /*5132*/, "Chan " /*5133*/, "Rang " /*5134*/, "Shu " /*5135*/, "Hui " /*5136*/, "Li " /*5137*/, "Luo " /*5138*/, "Zan " /*5139*/, "Nuo " /*513a*/, "Tang " /*513b*/, "Yan " /*513c*/, "Lei " /*513d*/, "Nang " /*513e*/, "Er " /*513f*/, "Wu " /*5140*/, "Yun " /*5141*/, "Zan " /*5142*/, "Yuan " /*5143*/, "Xiong " /*5144*/, "Chong " /*5145*/, "Zhao " /*5146*/, "Xiong " /*5147*/, "Xian " /*5148*/, "Guang " /*5149*/, "Dui " /*514a*/, "Ke " /*514b*/, "Dui " /*514c*/, "Mian " /*514d*/, "Tu " /*514e*/, "Chang " /*514f*/, "Er " /*5150*/, "Dui " /*5151*/, "Er " /*5152*/, "Xin " /*5153*/, "Tu " /*5154*/, "Si " /*5155*/, "Yan " /*5156*/, "Yan " /*5157*/, "Shi " /*5158*/, "Shi " /*5159*/, "Dang " /*515a*/, "Qian " /*515b*/, "Dou " /*515c*/, "Fen " /*515d*/, "Mao " /*515e*/, "Shen " /*515f*/, "Dou " /*5160*/, "Bai " /*5161*/, "Jing " /*5162*/, "Li " /*5163*/, "Huang " /*5164*/, "Ru " /*5165*/, "Wang " /*5166*/, "Nei " /*5167*/, "Quan " /*5168*/, "Liang " /*5169*/, "Yu " /*516a*/, "Ba " /*516b*/, "Gong " /*516c*/, "Liu " /*516d*/, "Xi " /*516e*/, "[?] " /*516f*/, "Lan " /*5170*/, "Gong " /*5171*/, "Tian " /*5172*/, "Guan " /*5173*/, "Xing " /*5174*/, "Bing " /*5175*/, "Qi " /*5176*/, "Ju " /*5177*/, "Dian " /*5178*/, "Zi " /*5179*/, "Ppwun " /*517a*/, "Yang " /*517b*/, "Jian " /*517c*/, "Shou " /*517d*/, "Ji " /*517e*/, "Yi " /*517f*/, "Ji " /*5180*/, "Chan " /*5181*/, "Jiong " /*5182*/, "Mao " /*5183*/, "Ran " /*5184*/, "Nei " /*5185*/, "Yuan " /*5186*/, "Mao " /*5187*/, "Gang " /*5188*/, "Ran " /*5189*/, "Ce " /*518a*/, "Jiong " /*518b*/, "Ce " /*518c*/, "Zai " /*518d*/, "Gua " /*518e*/, "Jiong " /*518f*/, "Mao " /*5190*/, "Zhou " /*5191*/, "Mou " /*5192*/, "Gou " /*5193*/, "Xu " /*5194*/, "Mian " /*5195*/, "Mi " /*5196*/, "Rong " /*5197*/, "Yin " /*5198*/, "Xie " /*5199*/, "Kan " /*519a*/, "Jun " /*519b*/, "Nong " /*519c*/, "Yi " /*519d*/, "Mi " /*519e*/, "Shi " /*519f*/, "Guan " /*51a0*/, "Meng " /*51a1*/, "Zhong " /*51a2*/, "Ju " /*51a3*/, "Yuan " /*51a4*/, "Ming " /*51a5*/, "Kou " /*51a6*/, "Lam " /*51a7*/, "Fu " /*51a8*/, "Xie " /*51a9*/, "Mi " /*51aa*/, "Bing " /*51ab*/, "Dong " /*51ac*/, "Tai " /*51ad*/, "Gang " /*51ae*/, "Feng " /*51af*/, "Bing " /*51b0*/, "Hu " /*51b1*/, "Chong " /*51b2*/, "Jue " /*51b3*/, "Hu " /*51b4*/, "Kuang " /*51b5*/, "Ye " /*51b6*/, "Leng " /*51b7*/, "Pan " /*51b8*/, "Fu " /*51b9*/, "Min " /*51ba*/, "Dong " /*51bb*/, "Xian " /*51bc*/, "Lie " /*51bd*/, "Xia " /*51be*/, "Jian " /*51bf*/, "Jing " /*51c0*/, "Shu " /*51c1*/, "Mei " /*51c2*/, "Tu " /*51c3*/, "Qi " /*51c4*/, "Gu " /*51c5*/, "Zhun " /*51c6*/, "Song " /*51c7*/, "Jing " /*51c8*/, "Liang " /*51c9*/, "Qing " /*51ca*/, "Diao " /*51cb*/, "Ling " /*51cc*/, "Dong " /*51cd*/, "Gan " /*51ce*/, "Jian " /*51cf*/, "Yin " /*51d0*/, "Cou " /*51d1*/, "Yi " /*51d2*/, "Li " /*51d3*/, "Cang " /*51d4*/, "Ming " /*51d5*/, "Zhuen " /*51d6*/, "Cui " /*51d7*/, "Si " /*51d8*/, "Duo " /*51d9*/, "Jin " /*51da*/, "Lin " /*51db*/, "Lin " /*51dc*/, "Ning " /*51dd*/, "Xi " /*51de*/, "Du " /*51df*/, "Ji " /*51e0*/, "Fan " /*51e1*/, "Fan " /*51e2*/, "Fan " /*51e3*/, "Feng " /*51e4*/, "Ju " /*51e5*/, "Chu " /*51e6*/, "Tako " /*51e7*/, "Feng " /*51e8*/, "Mok " /*51e9*/, "Ci " /*51ea*/, "Fu " /*51eb*/, "Feng " /*51ec*/, "Ping " /*51ed*/, "Feng " /*51ee*/, "Kai " /*51ef*/, "Huang " /*51f0*/, "Kai " /*51f1*/, "Gan " /*51f2*/, "Deng " /*51f3*/, "Ping " /*51f4*/, "Qu " /*51f5*/, "Xiong " /*51f6*/, "Kuai " /*51f7*/, "Tu " /*51f8*/, "Ao " /*51f9*/, "Chu " /*51fa*/, "Ji " /*51fb*/, "Dang " /*51fc*/, "Han " /*51fd*/, "Han " /*51fe*/, "Zao " /*51ff*/ 
			});
						characters.TryAdd(82 /*20992 52*/, new string[] {
				"Dao " /*5200*/, "Diao " /*5201*/, "Dao " /*5202*/, "Ren " /*5203*/, "Ren " /*5204*/, "Chuang " /*5205*/, "Fen " /*5206*/, "Qie " /*5207*/, "Yi " /*5208*/, "Ji " /*5209*/, "Kan " /*520a*/, "Qian " /*520b*/, "Cun " /*520c*/, "Chu " /*520d*/, "Wen " /*520e*/, "Ji " /*520f*/, "Dan " /*5210*/, "Xing " /*5211*/, "Hua " /*5212*/, "Wan " /*5213*/, "Jue " /*5214*/, "Li " /*5215*/, "Yue " /*5216*/, "Lie " /*5217*/, "Liu " /*5218*/, "Ze " /*5219*/, "Gang " /*521a*/, "Chuang " /*521b*/, "Fu " /*521c*/, "Chu " /*521d*/, "Qu " /*521e*/, "Ju " /*521f*/, "Shan " /*5220*/, "Min " /*5221*/, "Ling " /*5222*/, "Zhong " /*5223*/, "Pan " /*5224*/, "Bie " /*5225*/, "Jie " /*5226*/, "Jie " /*5227*/, "Bao " /*5228*/, "Li " /*5229*/, "Shan " /*522a*/, "Bie " /*522b*/, "Chan " /*522c*/, "Jing " /*522d*/, "Gua " /*522e*/, "Gen " /*522f*/, "Dao " /*5230*/, "Chuang " /*5231*/, "Kui " /*5232*/, "Ku " /*5233*/, "Duo " /*5234*/, "Er " /*5235*/, "Zhi " /*5236*/, "Shua " /*5237*/, "Quan " /*5238*/, "Cha " /*5239*/, "Ci " /*523a*/, "Ke " /*523b*/, "Jie " /*523c*/, "Gui " /*523d*/, "Ci " /*523e*/, "Gui " /*523f*/, "Kai " /*5240*/, "Duo " /*5241*/, "Ji " /*5242*/, "Ti " /*5243*/, "Jing " /*5244*/, "Lou " /*5245*/, "Gen " /*5246*/, "Ze " /*5247*/, "Yuan " /*5248*/, "Cuo " /*5249*/, "Xue " /*524a*/, "Ke " /*524b*/, "La " /*524c*/, "Qian " /*524d*/, "Cha " /*524e*/, "Chuang " /*524f*/, "Gua " /*5250*/, "Jian " /*5251*/, "Cuo " /*5252*/, "Li " /*5253*/, "Ti " /*5254*/, "Fei " /*5255*/, "Pou " /*5256*/, "Chan " /*5257*/, "Qi " /*5258*/, "Chuang " /*5259*/, "Zi " /*525a*/, "Gang " /*525b*/, "Wan " /*525c*/, "Bo " /*525d*/, "Ji " /*525e*/, "Duo " /*525f*/, "Qing " /*5260*/, "Yan " /*5261*/, "Zhuo " /*5262*/, "Jian " /*5263*/, "Ji " /*5264*/, "Bo " /*5265*/, "Yan " /*5266*/, "Ju " /*5267*/, "Huo " /*5268*/, "Sheng " /*5269*/, "Jian " /*526a*/, "Duo " /*526b*/, "Duan " /*526c*/, "Wu " /*526d*/, "Gua " /*526e*/, "Fu " /*526f*/, "Sheng " /*5270*/, "Jian " /*5271*/, "Ge " /*5272*/, "Zha " /*5273*/, "Kai " /*5274*/, "Chuang " /*5275*/, "Juan " /*5276*/, "Chan " /*5277*/, "Tuan " /*5278*/, "Lu " /*5279*/, "Li " /*527a*/, "Fou " /*527b*/, "Shan " /*527c*/, "Piao " /*527d*/, "Kou " /*527e*/, "Jiao " /*527f*/, "Gua " /*5280*/, "Qiao " /*5281*/, "Jue " /*5282*/, "Hua " /*5283*/, "Zha " /*5284*/, "Zhuo " /*5285*/, "Lian " /*5286*/, "Ju " /*5287*/, "Pi " /*5288*/, "Liu " /*5289*/, "Gui " /*528a*/, "Jiao " /*528b*/, "Gui " /*528c*/, "Jian " /*528d*/, "Jian " /*528e*/, "Tang " /*528f*/, "Huo " /*5290*/, "Ji " /*5291*/, "Jian " /*5292*/, "Yi " /*5293*/, "Jian " /*5294*/, "Zhi " /*5295*/, "Chan " /*5296*/, "Cuan " /*5297*/, "Mo " /*5298*/, "Li " /*5299*/, "Zhu " /*529a*/, "Li " /*529b*/, "Ya " /*529c*/, "Quan " /*529d*/, "Ban " /*529e*/, "Gong " /*529f*/, "Jia " /*52a0*/, "Wu " /*52a1*/, "Mai " /*52a2*/, "Lie " /*52a3*/, "Jin " /*52a4*/, "Keng " /*52a5*/, "Xie " /*52a6*/, "Zhi " /*52a7*/, "Dong " /*52a8*/, "Zhu " /*52a9*/, "Nu " /*52aa*/, "Jie " /*52ab*/, "Qu " /*52ac*/, "Shao " /*52ad*/, "Yi " /*52ae*/, "Zhu " /*52af*/, "Miao " /*52b0*/, "Li " /*52b1*/, "Jing " /*52b2*/, "Lao " /*52b3*/, "Lao " /*52b4*/, "Juan " /*52b5*/, "Kou " /*52b6*/, "Yang " /*52b7*/, "Wa " /*52b8*/, "Xiao " /*52b9*/, "Mou " /*52ba*/, "Kuang " /*52bb*/, "Jie " /*52bc*/, "Lie " /*52bd*/, "He " /*52be*/, "Shi " /*52bf*/, "Ke " /*52c0*/, "Jing " /*52c1*/, "Hao " /*52c2*/, "Bo " /*52c3*/, "Min " /*52c4*/, "Chi " /*52c5*/, "Lang " /*52c6*/, "Yong " /*52c7*/, "Yong " /*52c8*/, "Mian " /*52c9*/, "Ke " /*52ca*/, "Xun " /*52cb*/, "Juan " /*52cc*/, "Qing " /*52cd*/, "Lu " /*52ce*/, "Pou " /*52cf*/, "Meng " /*52d0*/, "Lai " /*52d1*/, "Le " /*52d2*/, "Kai " /*52d3*/, "Mian " /*52d4*/, "Dong " /*52d5*/, "Xu " /*52d6*/, "Xu " /*52d7*/, "Kan " /*52d8*/, "Wu " /*52d9*/, "Yi " /*52da*/, "Xun " /*52db*/, "Weng " /*52dc*/, "Sheng " /*52dd*/, "Lao " /*52de*/, "Mu " /*52df*/, "Lu " /*52e0*/, "Piao " /*52e1*/, "Shi " /*52e2*/, "Ji " /*52e3*/, "Qin " /*52e4*/, "Qiang " /*52e5*/, "Jiao " /*52e6*/, "Quan " /*52e7*/, "Yang " /*52e8*/, "Yi " /*52e9*/, "Jue " /*52ea*/, "Fan " /*52eb*/, "Juan " /*52ec*/, "Tong " /*52ed*/, "Ju " /*52ee*/, "Dan " /*52ef*/, "Xie " /*52f0*/, "Mai " /*52f1*/, "Xun " /*52f2*/, "Xun " /*52f3*/, "Lu " /*52f4*/, "Li " /*52f5*/, "Che " /*52f6*/, "Rang " /*52f7*/, "Quan " /*52f8*/, "Bao " /*52f9*/, "Shao " /*52fa*/, "Yun " /*52fb*/, "Jiu " /*52fc*/, "Bao " /*52fd*/, "Gou " /*52fe*/, "Wu " /*52ff*/ 
			});
						characters.TryAdd(83 /*21248 53*/, new string[] {
				"Yun " /*5300*/, "Mwun " /*5301*/, "Nay " /*5302*/, "Gai " /*5303*/, "Gai " /*5304*/, "Bao " /*5305*/, "Cong " /*5306*/, "[?] " /*5307*/, "Xiong " /*5308*/, "Peng " /*5309*/, "Ju " /*530a*/, "Tao " /*530b*/, "Ge " /*530c*/, "Pu " /*530d*/, "An " /*530e*/, "Pao " /*530f*/, "Fu " /*5310*/, "Gong " /*5311*/, "Da " /*5312*/, "Jiu " /*5313*/, "Qiong " /*5314*/, "Bi " /*5315*/, "Hua " /*5316*/, "Bei " /*5317*/, "Nao " /*5318*/, "Chi " /*5319*/, "Fang " /*531a*/, "Jiu " /*531b*/, "Yi " /*531c*/, "Za " /*531d*/, "Jiang " /*531e*/, "Kang " /*531f*/, "Jiang " /*5320*/, "Kuang " /*5321*/, "Hu " /*5322*/, "Xia " /*5323*/, "Qu " /*5324*/, "Bian " /*5325*/, "Gui " /*5326*/, "Qie " /*5327*/, "Zang " /*5328*/, "Kuang " /*5329*/, "Fei " /*532a*/, "Hu " /*532b*/, "Tou " /*532c*/, "Gui " /*532d*/, "Gui " /*532e*/, "Hui " /*532f*/, "Dan " /*5330*/, "Gui " /*5331*/, "Lian " /*5332*/, "Lian " /*5333*/, "Suan " /*5334*/, "Du " /*5335*/, "Jiu " /*5336*/, "Qu " /*5337*/, "Xi " /*5338*/, "Pi " /*5339*/, "Qu " /*533a*/, "Yi " /*533b*/, "Qia " /*533c*/, "Yan " /*533d*/, "Bian " /*533e*/, "Ni " /*533f*/, "Qu " /*5340*/, "Shi " /*5341*/, "Xin " /*5342*/, "Qian " /*5343*/, "Nian " /*5344*/, "Sa " /*5345*/, "Zu " /*5346*/, "Sheng " /*5347*/, "Wu " /*5348*/, "Hui " /*5349*/, "Ban " /*534a*/, "Shi " /*534b*/, "Xi " /*534c*/, "Wan " /*534d*/, "Hua " /*534e*/, "Xie " /*534f*/, "Wan " /*5350*/, "Bei " /*5351*/, "Zu " /*5352*/, "Zhuo " /*5353*/, "Xie " /*5354*/, "Dan " /*5355*/, "Mai " /*5356*/, "Nan " /*5357*/, "Dan " /*5358*/, "Ji " /*5359*/, "Bo " /*535a*/, "Shuai " /*535b*/, "Bu " /*535c*/, "Kuang " /*535d*/, "Bian " /*535e*/, "Bu " /*535f*/, "Zhan " /*5360*/, "Qia " /*5361*/, "Lu " /*5362*/, "You " /*5363*/, "Lu " /*5364*/, "Xi " /*5365*/, "Gua " /*5366*/, "Wo " /*5367*/, "Xie " /*5368*/, "Jie " /*5369*/, "Jie " /*536a*/, "Wei " /*536b*/, "Ang " /*536c*/, "Qiong " /*536d*/, "Zhi " /*536e*/, "Mao " /*536f*/, "Yin " /*5370*/, "Wei " /*5371*/, "Shao " /*5372*/, "Ji " /*5373*/, "Que " /*5374*/, "Luan " /*5375*/, "Shi " /*5376*/, "Juan " /*5377*/, "Xie " /*5378*/, "Xu " /*5379*/, "Jin " /*537a*/, "Que " /*537b*/, "Wu " /*537c*/, "Ji " /*537d*/, "E " /*537e*/, "Qing " /*537f*/, "Xi " /*5380*/, "[?] " /*5381*/, "Han " /*5382*/, "Zhan " /*5383*/, "E " /*5384*/, "Ting " /*5385*/, "Li " /*5386*/, "Zhe " /*5387*/, "Han " /*5388*/, "Li " /*5389*/, "Ya " /*538a*/, "Ya " /*538b*/, "Yan " /*538c*/, "She " /*538d*/, "Zhi " /*538e*/, "Zha " /*538f*/, "Pang " /*5390*/, "[?] " /*5391*/, "He " /*5392*/, "Ya " /*5393*/, "Zhi " /*5394*/, "Ce " /*5395*/, "Pang " /*5396*/, "Ti " /*5397*/, "Li " /*5398*/, "She " /*5399*/, "Hou " /*539a*/, "Ting " /*539b*/, "Zui " /*539c*/, "Cuo " /*539d*/, "Fei " /*539e*/, "Yuan " /*539f*/, "Ce " /*53a0*/, "Yuan " /*53a1*/, "Xiang " /*53a2*/, "Yan " /*53a3*/, "Li " /*53a4*/, "Jue " /*53a5*/, "Sha " /*53a6*/, "Dian " /*53a7*/, "Chu " /*53a8*/, "Jiu " /*53a9*/, "Qin " /*53aa*/, "Ao " /*53ab*/, "Gui " /*53ac*/, "Yan " /*53ad*/, "Si " /*53ae*/, "Li " /*53af*/, "Chang " /*53b0*/, "Lan " /*53b1*/, "Li " /*53b2*/, "Yan " /*53b3*/, "Yan " /*53b4*/, "Yuan " /*53b5*/, "Si " /*53b6*/, "Gong " /*53b7*/, "Lin " /*53b8*/, "Qiu " /*53b9*/, "Qu " /*53ba*/, "Qu " /*53bb*/, "Uk " /*53bc*/, "Lei " /*53bd*/, "Du " /*53be*/, "Xian " /*53bf*/, "Zhuan " /*53c0*/, "San " /*53c1*/, "Can " /*53c2*/, "Can " /*53c3*/, "Can " /*53c4*/, "Can " /*53c5*/, "Ai " /*53c6*/, "Dai " /*53c7*/, "You " /*53c8*/, "Cha " /*53c9*/, "Ji " /*53ca*/, "You " /*53cb*/, "Shuang " /*53cc*/, "Fan " /*53cd*/, "Shou " /*53ce*/, "Guai " /*53cf*/, "Ba " /*53d0*/, "Fa " /*53d1*/, "Ruo " /*53d2*/, "Shi " /*53d3*/, "Shu " /*53d4*/, "Zhuo " /*53d5*/, "Qu " /*53d6*/, "Shou " /*53d7*/, "Bian " /*53d8*/, "Xu " /*53d9*/, "Jia " /*53da*/, "Pan " /*53db*/, "Sou " /*53dc*/, "Gao " /*53dd*/, "Wei " /*53de*/, "Sou " /*53df*/, "Die " /*53e0*/, "Rui " /*53e1*/, "Cong " /*53e2*/, "Kou " /*53e3*/, "Gu " /*53e4*/, "Ju " /*53e5*/, "Ling " /*53e6*/, "Gua " /*53e7*/, "Tao " /*53e8*/, "Kou " /*53e9*/, "Zhi " /*53ea*/, "Jiao " /*53eb*/, "Zhao " /*53ec*/, "Ba " /*53ed*/, "Ding " /*53ee*/, "Ke " /*53ef*/, "Tai " /*53f0*/, "Chi " /*53f1*/, "Shi " /*53f2*/, "You " /*53f3*/, "Qiu " /*53f4*/, "Po " /*53f5*/, "Xie " /*53f6*/, "Hao " /*53f7*/, "Si " /*53f8*/, "Tan " /*53f9*/, "Chi " /*53fa*/, "Le " /*53fb*/, "Diao " /*53fc*/, "Ji " /*53fd*/, "[?] " /*53fe*/, "Hong " /*53ff*/ 
			});
						characters.TryAdd(84 /*21504 54*/, new string[] {
				"Mie " /*5400*/, "Xu " /*5401*/, "Mang " /*5402*/, "Chi " /*5403*/, "Ge " /*5404*/, "Xuan " /*5405*/, "Yao " /*5406*/, "Zi " /*5407*/, "He " /*5408*/, "Ji " /*5409*/, "Diao " /*540a*/, "Cun " /*540b*/, "Tong " /*540c*/, "Ming " /*540d*/, "Hou " /*540e*/, "Li " /*540f*/, "Tu " /*5410*/, "Xiang " /*5411*/, "Zha " /*5412*/, "Xia " /*5413*/, "Ye " /*5414*/, "Lu " /*5415*/, "A " /*5416*/, "Ma " /*5417*/, "Ou " /*5418*/, "Xue " /*5419*/, "Yi " /*541a*/, "Jun " /*541b*/, "Chou " /*541c*/, "Lin " /*541d*/, "Tun " /*541e*/, "Yin " /*541f*/, "Fei " /*5420*/, "Bi " /*5421*/, "Qin " /*5422*/, "Qin " /*5423*/, "Jie " /*5424*/, "Bu " /*5425*/, "Fou " /*5426*/, "Ba " /*5427*/, "Dun " /*5428*/, "Fen " /*5429*/, "E " /*542a*/, "Han " /*542b*/, "Ting " /*542c*/, "Hang " /*542d*/, "Shun " /*542e*/, "Qi " /*542f*/, "Hong " /*5430*/, "Zhi " /*5431*/, "Shen " /*5432*/, "Wu " /*5433*/, "Wu " /*5434*/, "Chao " /*5435*/, "Ne " /*5436*/, "Xue " /*5437*/, "Xi " /*5438*/, "Chui " /*5439*/, "Dou " /*543a*/, "Wen " /*543b*/, "Hou " /*543c*/, "Ou " /*543d*/, "Wu " /*543e*/, "Gao " /*543f*/, "Ya " /*5440*/, "Jun " /*5441*/, "Lu " /*5442*/, "E " /*5443*/, "Ge " /*5444*/, "Mei " /*5445*/, "Ai " /*5446*/, "Qi " /*5447*/, "Cheng " /*5448*/, "Wu " /*5449*/, "Gao " /*544a*/, "Fu " /*544b*/, "Jiao " /*544c*/, "Hong " /*544d*/, "Chi " /*544e*/, "Sheng " /*544f*/, "Ne " /*5450*/, "Tun " /*5451*/, "Fu " /*5452*/, "Yi " /*5453*/, "Dai " /*5454*/, "Ou " /*5455*/, "Li " /*5456*/, "Bai " /*5457*/, "Yuan " /*5458*/, "Kuai " /*5459*/, "[?] " /*545a*/, "Qiang " /*545b*/, "Wu " /*545c*/, "E " /*545d*/, "Shi " /*545e*/, "Quan " /*545f*/, "Pen " /*5460*/, "Wen " /*5461*/, "Ni " /*5462*/, "M " /*5463*/, "Ling " /*5464*/, "Ran " /*5465*/, "You " /*5466*/, "Di " /*5467*/, "Zhou " /*5468*/, "Shi " /*5469*/, "Zhou " /*546a*/, "Tie " /*546b*/, "Xi " /*546c*/, "Yi " /*546d*/, "Qi " /*546e*/, "Ping " /*546f*/, "Zi " /*5470*/, "Gu " /*5471*/, "Zi " /*5472*/, "Wei " /*5473*/, "Xu " /*5474*/, "He " /*5475*/, "Nao " /*5476*/, "Xia " /*5477*/, "Pei " /*5478*/, "Yi " /*5479*/, "Xiao " /*547a*/, "Shen " /*547b*/, "Hu " /*547c*/, "Ming " /*547d*/, "Da " /*547e*/, "Qu " /*547f*/, "Ju " /*5480*/, "Gem " /*5481*/, "Za " /*5482*/, "Tuo " /*5483*/, "Duo " /*5484*/, "Pou " /*5485*/, "Pao " /*5486*/, "Bi " /*5487*/, "Fu " /*5488*/, "Yang " /*5489*/, "He " /*548a*/, "Zha " /*548b*/, "He " /*548c*/, "Hai " /*548d*/, "Jiu " /*548e*/, "Yong " /*548f*/, "Fu " /*5490*/, "Que " /*5491*/, "Zhou " /*5492*/, "Wa " /*5493*/, "Ka " /*5494*/, "Gu " /*5495*/, "Ka " /*5496*/, "Zuo " /*5497*/, "Bu " /*5498*/, "Long " /*5499*/, "Dong " /*549a*/, "Ning " /*549b*/, "Tha " /*549c*/, "Si " /*549d*/, "Xian " /*549e*/, "Huo " /*549f*/, "Qi " /*54a0*/, "Er " /*54a1*/, "E " /*54a2*/, "Guang " /*54a3*/, "Zha " /*54a4*/, "Xi " /*54a5*/, "Yi " /*54a6*/, "Lie " /*54a7*/, "Zi " /*54a8*/, "Mie " /*54a9*/, "Mi " /*54aa*/, "Zhi " /*54ab*/, "Yao " /*54ac*/, "Ji " /*54ad*/, "Zhou " /*54ae*/, "Ge " /*54af*/, "Shuai " /*54b0*/, "Zan " /*54b1*/, "Xiao " /*54b2*/, "Ke " /*54b3*/, "Hui " /*54b4*/, "Kua " /*54b5*/, "Huai " /*54b6*/, "Tao " /*54b7*/, "Xian " /*54b8*/, "E " /*54b9*/, "Xuan " /*54ba*/, "Xiu " /*54bb*/, "Wai " /*54bc*/, "Yan " /*54bd*/, "Lao " /*54be*/, "Yi " /*54bf*/, "Ai " /*54c0*/, "Pin " /*54c1*/, "Shen " /*54c2*/, "Tong " /*54c3*/, "Hong " /*54c4*/, "Xiong " /*54c5*/, "Chi " /*54c6*/, "Wa " /*54c7*/, "Ha " /*54c8*/, "Zai " /*54c9*/, "Yu " /*54ca*/, "Di " /*54cb*/, "Pai " /*54cc*/, "Xiang " /*54cd*/, "Ai " /*54ce*/, "Hen " /*54cf*/, "Kuang " /*54d0*/, "Ya " /*54d1*/, "Da " /*54d2*/, "Xiao " /*54d3*/, "Bi " /*54d4*/, "Yue " /*54d5*/, "[?] " /*54d6*/, "Hua " /*54d7*/, "Sasou " /*54d8*/, "Kuai " /*54d9*/, "Duo " /*54da*/, "[?] " /*54db*/, "Ji " /*54dc*/, "Nong " /*54dd*/, "Mou " /*54de*/, "Yo " /*54df*/, "Hao " /*54e0*/, "Yuan " /*54e1*/, "Long " /*54e2*/, "Pou " /*54e3*/, "Mang " /*54e4*/, "Ge " /*54e5*/, "E " /*54e6*/, "Chi " /*54e7*/, "Shao " /*54e8*/, "Li " /*54e9*/, "Na " /*54ea*/, "Zu " /*54eb*/, "He " /*54ec*/, "Ku " /*54ed*/, "Xiao " /*54ee*/, "Xian " /*54ef*/, "Lao " /*54f0*/, "Bo " /*54f1*/, "Zhe " /*54f2*/, "Zha " /*54f3*/, "Liang " /*54f4*/, "Ba " /*54f5*/, "Mie " /*54f6*/, "Le " /*54f7*/, "Sui " /*54f8*/, "Fou " /*54f9*/, "Bu " /*54fa*/, "Han " /*54fb*/, "Heng " /*54fc*/, "Geng " /*54fd*/, "Shuo " /*54fe*/, "Ge " /*54ff*/ 
			});
						characters.TryAdd(85 /*21760 55*/, new string[] {
				"You " /*5500*/, "Yan " /*5501*/, "Gu " /*5502*/, "Gu " /*5503*/, "Bai " /*5504*/, "Han " /*5505*/, "Suo " /*5506*/, "Chun " /*5507*/, "Yi " /*5508*/, "Ai " /*5509*/, "Jia " /*550a*/, "Tu " /*550b*/, "Xian " /*550c*/, "Huan " /*550d*/, "Li " /*550e*/, "Xi " /*550f*/, "Tang " /*5510*/, "Zuo " /*5511*/, "Qiu " /*5512*/, "Che " /*5513*/, "Wu " /*5514*/, "Zao " /*5515*/, "Ya " /*5516*/, "Dou " /*5517*/, "Qi " /*5518*/, "Di " /*5519*/, "Qin " /*551a*/, "Ma " /*551b*/, "Mal " /*551c*/, "Hong " /*551d*/, "Dou " /*551e*/, "Kes " /*551f*/, "Lao " /*5520*/, "Liang " /*5521*/, "Suo " /*5522*/, "Zao " /*5523*/, "Huan " /*5524*/, "Lang " /*5525*/, "Sha " /*5526*/, "Ji " /*5527*/, "Zuo " /*5528*/, "Wo " /*5529*/, "Feng " /*552a*/, "Yin " /*552b*/, "Hu " /*552c*/, "Qi " /*552d*/, "Shou " /*552e*/, "Wei " /*552f*/, "Shua " /*5530*/, "Chang " /*5531*/, "Er " /*5532*/, "Li " /*5533*/, "Qiang " /*5534*/, "An " /*5535*/, "Jie " /*5536*/, "Yo " /*5537*/, "Nian " /*5538*/, "Yu " /*5539*/, "Tian " /*553a*/, "Lai " /*553b*/, "Sha " /*553c*/, "Xi " /*553d*/, "Tuo " /*553e*/, "Hu " /*553f*/, "Ai " /*5540*/, "Zhou " /*5541*/, "Nou " /*5542*/, "Ken " /*5543*/, "Zhuo " /*5544*/, "Zhuo " /*5545*/, "Shang " /*5546*/, "Di " /*5547*/, "Heng " /*5548*/, "Lan " /*5549*/, "A " /*554a*/, "Xiao " /*554b*/, "Xiang " /*554c*/, "Tun " /*554d*/, "Wu " /*554e*/, "Wen " /*554f*/, "Cui " /*5550*/, "Sha " /*5551*/, "Hu " /*5552*/, "Qi " /*5553*/, "Qi " /*5554*/, "Tao " /*5555*/, "Dan " /*5556*/, "Dan " /*5557*/, "Ye " /*5558*/, "Zi " /*5559*/, "Bi " /*555a*/, "Cui " /*555b*/, "Chuo " /*555c*/, "He " /*555d*/, "Ya " /*555e*/, "Qi " /*555f*/, "Zhe " /*5560*/, "Pei " /*5561*/, "Liang " /*5562*/, "Xian " /*5563*/, "Pi " /*5564*/, "Sha " /*5565*/, "La " /*5566*/, "Ze " /*5567*/, "Qing " /*5568*/, "Gua " /*5569*/, "Pa " /*556a*/, "Zhe " /*556b*/, "Se " /*556c*/, "Zhuan " /*556d*/, "Nie " /*556e*/, "Guo " /*556f*/, "Luo " /*5570*/, "Yan " /*5571*/, "Di " /*5572*/, "Quan " /*5573*/, "Tan " /*5574*/, "Bo " /*5575*/, "Ding " /*5576*/, "Lang " /*5577*/, "Xiao " /*5578*/, "[?] " /*5579*/, "Tang " /*557a*/, "Chi " /*557b*/, "Ti " /*557c*/, "An " /*557d*/, "Jiu " /*557e*/, "Dan " /*557f*/, "Ke " /*5580*/, "Yong " /*5581*/, "Wei " /*5582*/, "Nan " /*5583*/, "Shan " /*5584*/, "Yu " /*5585*/, "Zhe " /*5586*/, "La " /*5587*/, "Jie " /*5588*/, "Hou " /*5589*/, "Han " /*558a*/, "Die " /*558b*/, "Zhou " /*558c*/, "Chai " /*558d*/, "Wai " /*558e*/, "Re " /*558f*/, "Yu " /*5590*/, "Yin " /*5591*/, "Zan " /*5592*/, "Yao " /*5593*/, "Wo " /*5594*/, "Mian " /*5595*/, "Hu " /*5596*/, "Yun " /*5597*/, "Chuan " /*5598*/, "Hui " /*5599*/, "Huan " /*559a*/, "Huan " /*559b*/, "Xi " /*559c*/, "He " /*559d*/, "Ji " /*559e*/, "Kui " /*559f*/, "Zhong " /*55a0*/, "Wei " /*55a1*/, "Sha " /*55a2*/, "Xu " /*55a3*/, "Huang " /*55a4*/, "Du " /*55a5*/, "Nie " /*55a6*/, "Xuan " /*55a7*/, "Liang " /*55a8*/, "Yu " /*55a9*/, "Sang " /*55aa*/, "Chi " /*55ab*/, "Qiao " /*55ac*/, "Yan " /*55ad*/, "Dan " /*55ae*/, "Pen " /*55af*/, "Can " /*55b0*/, "Li " /*55b1*/, "Yo " /*55b2*/, "Zha " /*55b3*/, "Wei " /*55b4*/, "Miao " /*55b5*/, "Ying " /*55b6*/, "Pen " /*55b7*/, "Phos " /*55b8*/, "Kui " /*55b9*/, "Xi " /*55ba*/, "Yu " /*55bb*/, "Jie " /*55bc*/, "Lou " /*55bd*/, "Ku " /*55be*/, "Sao " /*55bf*/, "Huo " /*55c0*/, "Ti " /*55c1*/, "Yao " /*55c2*/, "He " /*55c3*/, "A " /*55c4*/, "Xiu " /*55c5*/, "Qiang " /*55c6*/, "Se " /*55c7*/, "Yong " /*55c8*/, "Su " /*55c9*/, "Hong " /*55ca*/, "Xie " /*55cb*/, "Yi " /*55cc*/, "Suo " /*55cd*/, "Ma " /*55ce*/, "Cha " /*55cf*/, "Hai " /*55d0*/, "Ke " /*55d1*/, "Ta " /*55d2*/, "Sang " /*55d3*/, "Tian " /*55d4*/, "Ru " /*55d5*/, "Sou " /*55d6*/, "Wa " /*55d7*/, "Ji " /*55d8*/, "Pang " /*55d9*/, "Wu " /*55da*/, "Xian " /*55db*/, "Shi " /*55dc*/, "Ge " /*55dd*/, "Zi " /*55de*/, "Jie " /*55df*/, "Luo " /*55e0*/, "Weng " /*55e1*/, "Wa " /*55e2*/, "Si " /*55e3*/, "Chi " /*55e4*/, "Hao " /*55e5*/, "Suo " /*55e6*/, "Jia " /*55e7*/, "Hai " /*55e8*/, "Suo " /*55e9*/, "Qin " /*55ea*/, "Nie " /*55eb*/, "He " /*55ec*/, "Cis " /*55ed*/, "Sai " /*55ee*/, "Ng " /*55ef*/, "Ge " /*55f0*/, "Na " /*55f1*/, "Dia " /*55f2*/, "Ai " /*55f3*/, "[?] " /*55f4*/, "Tong " /*55f5*/, "Bi " /*55f6*/, "Ao " /*55f7*/, "Ao " /*55f8*/, "Lian " /*55f9*/, "Cui " /*55fa*/, "Zhe " /*55fb*/, "Mo " /*55fc*/, "Sou " /*55fd*/, "Sou " /*55fe*/, "Tan " /*55ff*/ 
			});
						characters.TryAdd(86 /*22016 56*/, new string[] {
				"Di " /*5600*/, "Qi " /*5601*/, "Jiao " /*5602*/, "Chong " /*5603*/, "Jiao " /*5604*/, "Kai " /*5605*/, "Tan " /*5606*/, "San " /*5607*/, "Cao " /*5608*/, "Jia " /*5609*/, "Ai " /*560a*/, "Xiao " /*560b*/, "Piao " /*560c*/, "Lou " /*560d*/, "Ga " /*560e*/, "Gu " /*560f*/, "Xiao " /*5610*/, "Hu " /*5611*/, "Hui " /*5612*/, "Guo " /*5613*/, "Ou " /*5614*/, "Xian " /*5615*/, "Ze " /*5616*/, "Chang " /*5617*/, "Xu " /*5618*/, "Po " /*5619*/, "De " /*561a*/, "Ma " /*561b*/, "Ma " /*561c*/, "Hu " /*561d*/, "Lei " /*561e*/, "Du " /*561f*/, "Ga " /*5620*/, "Tang " /*5621*/, "Ye " /*5622*/, "Beng " /*5623*/, "Ying " /*5624*/, "Saai " /*5625*/, "Jiao " /*5626*/, "Mi " /*5627*/, "Xiao " /*5628*/, "Hua " /*5629*/, "Mai " /*562a*/, "Ran " /*562b*/, "Zuo " /*562c*/, "Peng " /*562d*/, "Lao " /*562e*/, "Xiao " /*562f*/, "Ji " /*5630*/, "Zhu " /*5631*/, "Chao " /*5632*/, "Kui " /*5633*/, "Zui " /*5634*/, "Xiao " /*5635*/, "Si " /*5636*/, "Hao " /*5637*/, "Fu " /*5638*/, "Liao " /*5639*/, "Qiao " /*563a*/, "Xi " /*563b*/, "Xiu " /*563c*/, "Tan " /*563d*/, "Tan " /*563e*/, "Mo " /*563f*/, "Xun " /*5640*/, "E " /*5641*/, "Zun " /*5642*/, "Fan " /*5643*/, "Chi " /*5644*/, "Hui " /*5645*/, "Zan " /*5646*/, "Chuang " /*5647*/, "Cu " /*5648*/, "Dan " /*5649*/, "Yu " /*564a*/, "Tun " /*564b*/, "Cheng " /*564c*/, "Jiao " /*564d*/, "Ye " /*564e*/, "Xi " /*564f*/, "Qi " /*5650*/, "Hao " /*5651*/, "Lian " /*5652*/, "Xu " /*5653*/, "Deng " /*5654*/, "Hui " /*5655*/, "Yin " /*5656*/, "Pu " /*5657*/, "Jue " /*5658*/, "Qin " /*5659*/, "Xun " /*565a*/, "Nie " /*565b*/, "Lu " /*565c*/, "Si " /*565d*/, "Yan " /*565e*/, "Ying " /*565f*/, "Da " /*5660*/, "Dan " /*5661*/, "Yu " /*5662*/, "Zhou " /*5663*/, "Jin " /*5664*/, "Nong " /*5665*/, "Yue " /*5666*/, "Hui " /*5667*/, "Qi " /*5668*/, "E " /*5669*/, "Zao " /*566a*/, "Yi " /*566b*/, "Shi " /*566c*/, "Jiao " /*566d*/, "Yuan " /*566e*/, "Ai " /*566f*/, "Yong " /*5670*/, "Jue " /*5671*/, "Kuai " /*5672*/, "Yu " /*5673*/, "Pen " /*5674*/, "Dao " /*5675*/, "Ge " /*5676*/, "Xin " /*5677*/, "Dun " /*5678*/, "Dang " /*5679*/, "Sin " /*567a*/, "Sai " /*567b*/, "Pi " /*567c*/, "Pi " /*567d*/, "Yin " /*567e*/, "Zui " /*567f*/, "Ning " /*5680*/, "Di " /*5681*/, "Lan " /*5682*/, "Ta " /*5683*/, "Huo " /*5684*/, "Ru " /*5685*/, "Hao " /*5686*/, "Xia " /*5687*/, "Ya " /*5688*/, "Duo " /*5689*/, "Xi " /*568a*/, "Chou " /*568b*/, "Ji " /*568c*/, "Jin " /*568d*/, "Hao " /*568e*/, "Ti " /*568f*/, "Chang " /*5690*/, "[?] " /*5691*/, "[?] " /*5692*/, "Ca " /*5693*/, "Ti " /*5694*/, "Lu " /*5695*/, "Hui " /*5696*/, "Bo " /*5697*/, "You " /*5698*/, "Nie " /*5699*/, "Yin " /*569a*/, "Hu " /*569b*/, "Mo " /*569c*/, "Huang " /*569d*/, "Zhe " /*569e*/, "Li " /*569f*/, "Liu " /*56a0*/, "Haai " /*56a1*/, "Nang " /*56a2*/, "Xiao " /*56a3*/, "Mo " /*56a4*/, "Yan " /*56a5*/, "Li " /*56a6*/, "Lu " /*56a7*/, "Long " /*56a8*/, "Fu " /*56a9*/, "Dan " /*56aa*/, "Chen " /*56ab*/, "Pin " /*56ac*/, "Pi " /*56ad*/, "Xiang " /*56ae*/, "Huo " /*56af*/, "Mo " /*56b0*/, "Xi " /*56b1*/, "Duo " /*56b2*/, "Ku " /*56b3*/, "Yan " /*56b4*/, "Chan " /*56b5*/, "Ying " /*56b6*/, "Rang " /*56b7*/, "Dian " /*56b8*/, "La " /*56b9*/, "Ta " /*56ba*/, "Xiao " /*56bb*/, "Jiao " /*56bc*/, "Chuo " /*56bd*/, "Huan " /*56be*/, "Huo " /*56bf*/, "Zhuan " /*56c0*/, "Nie " /*56c1*/, "Xiao " /*56c2*/, "Ca " /*56c3*/, "Li " /*56c4*/, "Chan " /*56c5*/, "Chai " /*56c6*/, "Li " /*56c7*/, "Yi " /*56c8*/, "Luo " /*56c9*/, "Nang " /*56ca*/, "Zan " /*56cb*/, "Su " /*56cc*/, "Xi " /*56cd*/, "So " /*56ce*/, "Jian " /*56cf*/, "Za " /*56d0*/, "Zhu " /*56d1*/, "Lan " /*56d2*/, "Nie " /*56d3*/, "Nang " /*56d4*/, "[?] " /*56d5*/, "[?] " /*56d6*/, "Wei " /*56d7*/, "Hui " /*56d8*/, "Yin " /*56d9*/, "Qiu " /*56da*/, "Si " /*56db*/, "Nin " /*56dc*/, "Jian " /*56dd*/, "Hui " /*56de*/, "Xin " /*56df*/, "Yin " /*56e0*/, "Nan " /*56e1*/, "Tuan " /*56e2*/, "Tuan " /*56e3*/, "Dun " /*56e4*/, "Kang " /*56e5*/, "Yuan " /*56e6*/, "Jiong " /*56e7*/, "Pian " /*56e8*/, "Yun " /*56e9*/, "Cong " /*56ea*/, "Hu " /*56eb*/, "Hui " /*56ec*/, "Yuan " /*56ed*/, "You " /*56ee*/, "Guo " /*56ef*/, "Kun " /*56f0*/, "Cong " /*56f1*/, "Wei " /*56f2*/, "Tu " /*56f3*/, "Wei " /*56f4*/, "Lun " /*56f5*/, "Guo " /*56f6*/, "Qun " /*56f7*/, "Ri " /*56f8*/, "Ling " /*56f9*/, "Gu " /*56fa*/, "Guo " /*56fb*/, "Tai " /*56fc*/, "Guo " /*56fd*/, "Tu " /*56fe*/, "You " /*56ff*/ 
			});
						characters.TryAdd(87 /*22272 57*/, new string[] {
				"Guo " /*5700*/, "Yin " /*5701*/, "Hun " /*5702*/, "Pu " /*5703*/, "Yu " /*5704*/, "Han " /*5705*/, "Yuan " /*5706*/, "Lun " /*5707*/, "Quan " /*5708*/, "Yu " /*5709*/, "Qing " /*570a*/, "Guo " /*570b*/, "Chuan " /*570c*/, "Wei " /*570d*/, "Yuan " /*570e*/, "Quan " /*570f*/, "Ku " /*5710*/, "Fu " /*5711*/, "Yuan " /*5712*/, "Yuan " /*5713*/, "E " /*5714*/, "Tu " /*5715*/, "Tu " /*5716*/, "Tu " /*5717*/, "Tuan " /*5718*/, "Lue " /*5719*/, "Hui " /*571a*/, "Yi " /*571b*/, "Yuan " /*571c*/, "Luan " /*571d*/, "Luan " /*571e*/, "Tu " /*571f*/, "Ya " /*5720*/, "Tu " /*5721*/, "Ting " /*5722*/, "Sheng " /*5723*/, "Pu " /*5724*/, "Lu " /*5725*/, "Iri " /*5726*/, "Ya " /*5727*/, "Zai " /*5728*/, "Wei " /*5729*/, "Ge " /*572a*/, "Yu " /*572b*/, "Wu " /*572c*/, "Gui " /*572d*/, "Pi " /*572e*/, "Yi " /*572f*/, "Di " /*5730*/, "Qian " /*5731*/, "Qian " /*5732*/, "Zhen " /*5733*/, "Zhuo " /*5734*/, "Dang " /*5735*/, "Qia " /*5736*/, "Akutsu " /*5737*/, "Yama " /*5738*/, "Kuang " /*5739*/, "Chang " /*573a*/, "Qi " /*573b*/, "Nie " /*573c*/, "Mo " /*573d*/, "Ji " /*573e*/, "Jia " /*573f*/, "Zhi " /*5740*/, "Zhi " /*5741*/, "Ban " /*5742*/, "Xun " /*5743*/, "Tou " /*5744*/, "Qin " /*5745*/, "Fen " /*5746*/, "Jun " /*5747*/, "Keng " /*5748*/, "Tun " /*5749*/, "Fang " /*574a*/, "Fen " /*574b*/, "Ben " /*574c*/, "Tan " /*574d*/, "Kan " /*574e*/, "Pi " /*574f*/, "Zuo " /*5750*/, "Keng " /*5751*/, "Bi " /*5752*/, "Xing " /*5753*/, "Di " /*5754*/, "Jing " /*5755*/, "Ji " /*5756*/, "Kuai " /*5757*/, "Di " /*5758*/, "Jing " /*5759*/, "Jian " /*575a*/, "Tan " /*575b*/, "Li " /*575c*/, "Ba " /*575d*/, "Wu " /*575e*/, "Fen " /*575f*/, "Zhui " /*5760*/, "Po " /*5761*/, "Pan " /*5762*/, "Tang " /*5763*/, "Kun " /*5764*/, "Qu " /*5765*/, "Tan " /*5766*/, "Zhi " /*5767*/, "Tuo " /*5768*/, "Gan " /*5769*/, "Ping " /*576a*/, "Dian " /*576b*/, "Gua " /*576c*/, "Ni " /*576d*/, "Tai " /*576e*/, "Pi " /*576f*/, "Jiong " /*5770*/, "Yang " /*5771*/, "Fo " /*5772*/, "Ao " /*5773*/, "Liu " /*5774*/, "Qiu " /*5775*/, "Mu " /*5776*/, "Ke " /*5777*/, "Gou " /*5778*/, "Xue " /*5779*/, "Ba " /*577a*/, "Chi " /*577b*/, "Che " /*577c*/, "Ling " /*577d*/, "Zhu " /*577e*/, "Fu " /*577f*/, "Hu " /*5780*/, "Zhi " /*5781*/, "Chui " /*5782*/, "La " /*5783*/, "Long " /*5784*/, "Long " /*5785*/, "Lu " /*5786*/, "Ao " /*5787*/, "Tay " /*5788*/, "Pao " /*5789*/, "[?] " /*578a*/, "Xing " /*578b*/, "Dong " /*578c*/, "Ji " /*578d*/, "Ke " /*578e*/, "Lu " /*578f*/, "Ci " /*5790*/, "Chi " /*5791*/, "Lei " /*5792*/, "Gai " /*5793*/, "Yin " /*5794*/, "Hou " /*5795*/, "Dui " /*5796*/, "Zhao " /*5797*/, "Fu " /*5798*/, "Guang " /*5799*/, "Yao " /*579a*/, "Duo " /*579b*/, "Duo " /*579c*/, "Gui " /*579d*/, "Cha " /*579e*/, "Yang " /*579f*/, "Yin " /*57a0*/, "Fa " /*57a1*/, "Gou " /*57a2*/, "Yuan " /*57a3*/, "Die " /*57a4*/, "Xie " /*57a5*/, "Ken " /*57a6*/, "Jiong " /*57a7*/, "Shou " /*57a8*/, "E " /*57a9*/, "Ha " /*57aa*/, "Dian " /*57ab*/, "Hong " /*57ac*/, "Wu " /*57ad*/, "Kua " /*57ae*/, "[?] " /*57af*/, "Tao " /*57b0*/, "Dang " /*57b1*/, "Kai " /*57b2*/, "Gake " /*57b3*/, "Nao " /*57b4*/, "An " /*57b5*/, "Xing " /*57b6*/, "Xian " /*57b7*/, "Huan " /*57b8*/, "Bang " /*57b9*/, "Pei " /*57ba*/, "Ba " /*57bb*/, "Yi " /*57bc*/, "Yin " /*57bd*/, "Han " /*57be*/, "Xu " /*57bf*/, "Chui " /*57c0*/, "Cen " /*57c1*/, "Geng " /*57c2*/, "Ai " /*57c3*/, "Peng " /*57c4*/, "Fang " /*57c5*/, "Que " /*57c6*/, "Yong " /*57c7*/, "Xun " /*57c8*/, "Jia " /*57c9*/, "Di " /*57ca*/, "Mai " /*57cb*/, "Lang " /*57cc*/, "Xuan " /*57cd*/, "Cheng " /*57ce*/, "Yan " /*57cf*/, "Jin " /*57d0*/, "Zhe " /*57d1*/, "Lei " /*57d2*/, "Lie " /*57d3*/, "Bu " /*57d4*/, "Cheng " /*57d5*/, "Gomi " /*57d6*/, "Bu " /*57d7*/, "Shi " /*57d8*/, "Xun " /*57d9*/, "Guo " /*57da*/, "Jiong " /*57db*/, "Ye " /*57dc*/, "Nian " /*57dd*/, "Di " /*57de*/, "Yu " /*57df*/, "Bu " /*57e0*/, "Ya " /*57e1*/, "Juan " /*57e2*/, "Sui " /*57e3*/, "Pi " /*57e4*/, "Cheng " /*57e5*/, "Wan " /*57e6*/, "Ju " /*57e7*/, "Lun " /*57e8*/, "Zheng " /*57e9*/, "Kong " /*57ea*/, "Chong " /*57eb*/, "Dong " /*57ec*/, "Dai " /*57ed*/, "Tan " /*57ee*/, "An " /*57ef*/, "Cai " /*57f0*/, "Shu " /*57f1*/, "Beng " /*57f2*/, "Kan " /*57f3*/, "Zhi " /*57f4*/, "Duo " /*57f5*/, "Yi " /*57f6*/, "Zhi " /*57f7*/, "Yi " /*57f8*/, "Pei " /*57f9*/, "Ji " /*57fa*/, "Zhun " /*57fb*/, "Qi " /*57fc*/, "Sao " /*57fd*/, "Ju " /*57fe*/, "Ni " /*57ff*/ 
			});
						characters.TryAdd(88 /*22528 58*/, new string[] {
				"Ku " /*5800*/, "Ke " /*5801*/, "Tang " /*5802*/, "Kun " /*5803*/, "Ni " /*5804*/, "Jian " /*5805*/, "Dui " /*5806*/, "Jin " /*5807*/, "Gang " /*5808*/, "Yu " /*5809*/, "E " /*580a*/, "Peng " /*580b*/, "Gu " /*580c*/, "Tu " /*580d*/, "Leng " /*580e*/, "[?] " /*580f*/, "Ya " /*5810*/, "Qian " /*5811*/, "[?] " /*5812*/, "An " /*5813*/, "[?] " /*5814*/, "Duo " /*5815*/, "Nao " /*5816*/, "Tu " /*5817*/, "Cheng " /*5818*/, "Yin " /*5819*/, "Hun " /*581a*/, "Bi " /*581b*/, "Lian " /*581c*/, "Guo " /*581d*/, "Die " /*581e*/, "Zhuan " /*581f*/, "Hou " /*5820*/, "Bao " /*5821*/, "Bao " /*5822*/, "Yu " /*5823*/, "Di " /*5824*/, "Mao " /*5825*/, "Jie " /*5826*/, "Ruan " /*5827*/, "E " /*5828*/, "Geng " /*5829*/, "Kan " /*582a*/, "Zong " /*582b*/, "Yu " /*582c*/, "Huang " /*582d*/, "E " /*582e*/, "Yao " /*582f*/, "Yan " /*5830*/, "Bao " /*5831*/, "Ji " /*5832*/, "Mei " /*5833*/, "Chang " /*5834*/, "Du " /*5835*/, "Tuo " /*5836*/, "Yin " /*5837*/, "Feng " /*5838*/, "Zhong " /*5839*/, "Jie " /*583a*/, "Zhen " /*583b*/, "Feng " /*583c*/, "Gang " /*583d*/, "Chuan " /*583e*/, "Jian " /*583f*/, "Pyeng " /*5840*/, "Toride " /*5841*/, "Xiang " /*5842*/, "Huang " /*5843*/, "Leng " /*5844*/, "Duan " /*5845*/, "[?] " /*5846*/, "Xuan " /*5847*/, "Ji " /*5848*/, "Ji " /*5849*/, "Kuai " /*584a*/, "Ying " /*584b*/, "Ta " /*584c*/, "Cheng " /*584d*/, "Yong " /*584e*/, "Kai " /*584f*/, "Su " /*5850*/, "Su " /*5851*/, "Shi " /*5852*/, "Mi " /*5853*/, "Ta " /*5854*/, "Weng " /*5855*/, "Cheng " /*5856*/, "Tu " /*5857*/, "Tang " /*5858*/, "Que " /*5859*/, "Zhong " /*585a*/, "Li " /*585b*/, "Peng " /*585c*/, "Bang " /*585d*/, "Sai " /*585e*/, "Zang " /*585f*/, "Dui " /*5860*/, "Tian " /*5861*/, "Wu " /*5862*/, "Cheng " /*5863*/, "Xun " /*5864*/, "Ge " /*5865*/, "Zhen " /*5866*/, "Ai " /*5867*/, "Gong " /*5868*/, "Yan " /*5869*/, "Kan " /*586a*/, "Tian " /*586b*/, "Yuan " /*586c*/, "Wen " /*586d*/, "Xie " /*586e*/, "Liu " /*586f*/, "Ama " /*5870*/, "Lang " /*5871*/, "Chang " /*5872*/, "Peng " /*5873*/, "Beng " /*5874*/, "Chen " /*5875*/, "Cu " /*5876*/, "Lu " /*5877*/, "Ou " /*5878*/, "Qian " /*5879*/, "Mei " /*587a*/, "Mo " /*587b*/, "Zhuan " /*587c*/, "Shuang " /*587d*/, "Shu " /*587e*/, "Lou " /*587f*/, "Chi " /*5880*/, "Man " /*5881*/, "Biao " /*5882*/, "Jing " /*5883*/, "Qi " /*5884*/, "Shu " /*5885*/, "Di " /*5886*/, "Zhang " /*5887*/, "Kan " /*5888*/, "Yong " /*5889*/, "Dian " /*588a*/, "Chen " /*588b*/, "Zhi " /*588c*/, "Xi " /*588d*/, "Guo " /*588e*/, "Qiang " /*588f*/, "Jin " /*5890*/, "Di " /*5891*/, "Shang " /*5892*/, "Mu " /*5893*/, "Cui " /*5894*/, "Yan " /*5895*/, "Ta " /*5896*/, "Zeng " /*5897*/, "Qi " /*5898*/, "Qiang " /*5899*/, "Liang " /*589a*/, "[?] " /*589b*/, "Zhui " /*589c*/, "Qiao " /*589d*/, "Zeng " /*589e*/, "Xu " /*589f*/, "Shan " /*58a0*/, "Shan " /*58a1*/, "Ba " /*58a2*/, "Pu " /*58a3*/, "Kuai " /*58a4*/, "Dong " /*58a5*/, "Fan " /*58a6*/, "Que " /*58a7*/, "Mo " /*58a8*/, "Dun " /*58a9*/, "Dun " /*58aa*/, "Dun " /*58ab*/, "Di " /*58ac*/, "Sheng " /*58ad*/, "Duo " /*58ae*/, "Duo " /*58af*/, "Tan " /*58b0*/, "Deng " /*58b1*/, "Wu " /*58b2*/, "Fen " /*58b3*/, "Huang " /*58b4*/, "Tan " /*58b5*/, "Da " /*58b6*/, "Ye " /*58b7*/, "Sho " /*58b8*/, "Mama " /*58b9*/, "Yu " /*58ba*/, "Qiang " /*58bb*/, "Ji " /*58bc*/, "Qiao " /*58bd*/, "Ken " /*58be*/, "Yi " /*58bf*/, "Pi " /*58c0*/, "Bi " /*58c1*/, "Dian " /*58c2*/, "Jiang " /*58c3*/, "Ye " /*58c4*/, "Yong " /*58c5*/, "Bo " /*58c6*/, "Tan " /*58c7*/, "Lan " /*58c8*/, "Ju " /*58c9*/, "Huai " /*58ca*/, "Dang " /*58cb*/, "Rang " /*58cc*/, "Qian " /*58cd*/, "Xun " /*58ce*/, "Lan " /*58cf*/, "Xi " /*58d0*/, "He " /*58d1*/, "Ai " /*58d2*/, "Ya " /*58d3*/, "Dao " /*58d4*/, "Hao " /*58d5*/, "Ruan " /*58d6*/, "Mama " /*58d7*/, "Lei " /*58d8*/, "Kuang " /*58d9*/, "Lu " /*58da*/, "Yan " /*58db*/, "Tan " /*58dc*/, "Wei " /*58dd*/, "Huai " /*58de*/, "Long " /*58df*/, "Long " /*58e0*/, "Rui " /*58e1*/, "Li " /*58e2*/, "Lin " /*58e3*/, "Rang " /*58e4*/, "Ten " /*58e5*/, "Xun " /*58e6*/, "Yan " /*58e7*/, "Lei " /*58e8*/, "Ba " /*58e9*/, "[?] " /*58ea*/, "Shi " /*58eb*/, "Ren " /*58ec*/, "[?] " /*58ed*/, "Zhuang " /*58ee*/, "Zhuang " /*58ef*/, "Sheng " /*58f0*/, "Yi " /*58f1*/, "Mai " /*58f2*/, "Ke " /*58f3*/, "Zhu " /*58f4*/, "Zhuang " /*58f5*/, "Hu " /*58f6*/, "Hu " /*58f7*/, "Kun " /*58f8*/, "Yi " /*58f9*/, "Hu " /*58fa*/, "Xu " /*58fb*/, "Kun " /*58fc*/, "Shou " /*58fd*/, "Mang " /*58fe*/, "Zun " /*58ff*/ 
			});
						characters.TryAdd(89 /*22784 59*/, new string[] {
				"Shou " /*5900*/, "Yi " /*5901*/, "Zhi " /*5902*/, "Gu " /*5903*/, "Chu " /*5904*/, "Jiang " /*5905*/, "Feng " /*5906*/, "Bei " /*5907*/, "Cay " /*5908*/, "Bian " /*5909*/, "Sui " /*590a*/, "Qun " /*590b*/, "Ling " /*590c*/, "Fu " /*590d*/, "Zuo " /*590e*/, "Xia " /*590f*/, "Xiong " /*5910*/, "[?] " /*5911*/, "Nao " /*5912*/, "Xia " /*5913*/, "Kui " /*5914*/, "Xi " /*5915*/, "Wai " /*5916*/, "Yuan " /*5917*/, "Mao " /*5918*/, "Su " /*5919*/, "Duo " /*591a*/, "Duo " /*591b*/, "Ye " /*591c*/, "Qing " /*591d*/, "Uys " /*591e*/, "Gou " /*591f*/, "Gou " /*5920*/, "Qi " /*5921*/, "Meng " /*5922*/, "Meng " /*5923*/, "Yin " /*5924*/, "Huo " /*5925*/, "Chen " /*5926*/, "Da " /*5927*/, "Ze " /*5928*/, "Tian " /*5929*/, "Tai " /*592a*/, "Fu " /*592b*/, "Guai " /*592c*/, "Yao " /*592d*/, "Yang " /*592e*/, "Hang " /*592f*/, "Gao " /*5930*/, "Shi " /*5931*/, "Ben " /*5932*/, "Tai " /*5933*/, "Tou " /*5934*/, "Yan " /*5935*/, "Bi " /*5936*/, "Yi " /*5937*/, "Kua " /*5938*/, "Jia " /*5939*/, "Duo " /*593a*/, "Kwu " /*593b*/, "Kuang " /*593c*/, "Yun " /*593d*/, "Jia " /*593e*/, "Pa " /*593f*/, "En " /*5940*/, "Lian " /*5941*/, "Huan " /*5942*/, "Di " /*5943*/, "Yan " /*5944*/, "Pao " /*5945*/, "Quan " /*5946*/, "Qi " /*5947*/, "Nai " /*5948*/, "Feng " /*5949*/, "Xie " /*594a*/, "Fen " /*594b*/, "Dian " /*594c*/, "[?] " /*594d*/, "Kui " /*594e*/, "Zou " /*594f*/, "Huan " /*5950*/, "Qi " /*5951*/, "Kai " /*5952*/, "Zha " /*5953*/, "Ben " /*5954*/, "Yi " /*5955*/, "Jiang " /*5956*/, "Tao " /*5957*/, "Zang " /*5958*/, "Ben " /*5959*/, "Xi " /*595a*/, "Xiang " /*595b*/, "Fei " /*595c*/, "Diao " /*595d*/, "Xun " /*595e*/, "Keng " /*595f*/, "Dian " /*5960*/, "Ao " /*5961*/, "She " /*5962*/, "Weng " /*5963*/, "Pan " /*5964*/, "Ao " /*5965*/, "Wu " /*5966*/, "Ao " /*5967*/, "Jiang " /*5968*/, "Lian " /*5969*/, "Duo " /*596a*/, "Yun " /*596b*/, "Jiang " /*596c*/, "Shi " /*596d*/, "Fen " /*596e*/, "Huo " /*596f*/, "Bi " /*5970*/, "Lian " /*5971*/, "Duo " /*5972*/, "Nu " /*5973*/, "Nu " /*5974*/, "Ding " /*5975*/, "Nai " /*5976*/, "Qian " /*5977*/, "Jian " /*5978*/, "Ta " /*5979*/, "Jiu " /*597a*/, "Nan " /*597b*/, "Cha " /*597c*/, "Hao " /*597d*/, "Xian " /*597e*/, "Fan " /*597f*/, "Ji " /*5980*/, "Shuo " /*5981*/, "Ru " /*5982*/, "Fei " /*5983*/, "Wang " /*5984*/, "Hong " /*5985*/, "Zhuang " /*5986*/, "Fu " /*5987*/, "Ma " /*5988*/, "Dan " /*5989*/, "Ren " /*598a*/, "Fu " /*598b*/, "Jing " /*598c*/, "Yan " /*598d*/, "Xie " /*598e*/, "Wen " /*598f*/, "Zhong " /*5990*/, "Pa " /*5991*/, "Du " /*5992*/, "Ji " /*5993*/, "Keng " /*5994*/, "Zhong " /*5995*/, "Yao " /*5996*/, "Jin " /*5997*/, "Yun " /*5998*/, "Miao " /*5999*/, "Pei " /*599a*/, "Shi " /*599b*/, "Yue " /*599c*/, "Zhuang " /*599d*/, "Niu " /*599e*/, "Yan " /*599f*/, "Na " /*59a0*/, "Xin " /*59a1*/, "Fen " /*59a2*/, "Bi " /*59a3*/, "Yu " /*59a4*/, "Tuo " /*59a5*/, "Feng " /*59a6*/, "Yuan " /*59a7*/, "Fang " /*59a8*/, "Wu " /*59a9*/, "Yu " /*59aa*/, "Gui " /*59ab*/, "Du " /*59ac*/, "Ba " /*59ad*/, "Ni " /*59ae*/, "Zhou " /*59af*/, "Zhuo " /*59b0*/, "Zhao " /*59b1*/, "Da " /*59b2*/, "Nai " /*59b3*/, "Yuan " /*59b4*/, "Tou " /*59b5*/, "Xuan " /*59b6*/, "Zhi " /*59b7*/, "E " /*59b8*/, "Mei " /*59b9*/, "Mo " /*59ba*/, "Qi " /*59bb*/, "Bi " /*59bc*/, "Shen " /*59bd*/, "Qie " /*59be*/, "E " /*59bf*/, "He " /*59c0*/, "Xu " /*59c1*/, "Fa " /*59c2*/, "Zheng " /*59c3*/, "Min " /*59c4*/, "Ban " /*59c5*/, "Mu " /*59c6*/, "Fu " /*59c7*/, "Ling " /*59c8*/, "Zi " /*59c9*/, "Zi " /*59ca*/, "Shi " /*59cb*/, "Ran " /*59cc*/, "Shan " /*59cd*/, "Yang " /*59ce*/, "Man " /*59cf*/, "Jie " /*59d0*/, "Gu " /*59d1*/, "Si " /*59d2*/, "Xing " /*59d3*/, "Wei " /*59d4*/, "Zi " /*59d5*/, "Ju " /*59d6*/, "Shan " /*59d7*/, "Pin " /*59d8*/, "Ren " /*59d9*/, "Yao " /*59da*/, "Tong " /*59db*/, "Jiang " /*59dc*/, "Shu " /*59dd*/, "Ji " /*59de*/, "Gai " /*59df*/, "Shang " /*59e0*/, "Kuo " /*59e1*/, "Juan " /*59e2*/, "Jiao " /*59e3*/, "Gou " /*59e4*/, "Mu " /*59e5*/, "Jian " /*59e6*/, "Jian " /*59e7*/, "Yi " /*59e8*/, "Nian " /*59e9*/, "Zhi " /*59ea*/, "Ji " /*59eb*/, "Ji " /*59ec*/, "Xian " /*59ed*/, "Heng " /*59ee*/, "Guang " /*59ef*/, "Jun " /*59f0*/, "Kua " /*59f1*/, "Yan " /*59f2*/, "Ming " /*59f3*/, "Lie " /*59f4*/, "Pei " /*59f5*/, "Yan " /*59f6*/, "You " /*59f7*/, "Yan " /*59f8*/, "Cha " /*59f9*/, "Shen " /*59fa*/, "Yin " /*59fb*/, "Chi " /*59fc*/, "Gui " /*59fd*/, "Quan " /*59fe*/, "Zi " /*59ff*/ 
			});
						characters.TryAdd(90 /*23040 5a*/, new string[] {
				"Song " /*5a00*/, "Wei " /*5a01*/, "Hong " /*5a02*/, "Wa " /*5a03*/, "Lou " /*5a04*/, "Ya " /*5a05*/, "Rao " /*5a06*/, "Jiao " /*5a07*/, "Luan " /*5a08*/, "Ping " /*5a09*/, "Xian " /*5a0a*/, "Shao " /*5a0b*/, "Li " /*5a0c*/, "Cheng " /*5a0d*/, "Xiao " /*5a0e*/, "Mang " /*5a0f*/, "Fu " /*5a10*/, "Suo " /*5a11*/, "Wu " /*5a12*/, "Wei " /*5a13*/, "Ke " /*5a14*/, "Lai " /*5a15*/, "Chuo " /*5a16*/, "Ding " /*5a17*/, "Niang " /*5a18*/, "Xing " /*5a19*/, "Nan " /*5a1a*/, "Yu " /*5a1b*/, "Nuo " /*5a1c*/, "Pei " /*5a1d*/, "Nei " /*5a1e*/, "Juan " /*5a1f*/, "Shen " /*5a20*/, "Zhi " /*5a21*/, "Han " /*5a22*/, "Di " /*5a23*/, "Zhuang " /*5a24*/, "E " /*5a25*/, "Pin " /*5a26*/, "Tui " /*5a27*/, "Han " /*5a28*/, "Mian " /*5a29*/, "Wu " /*5a2a*/, "Yan " /*5a2b*/, "Wu " /*5a2c*/, "Xi " /*5a2d*/, "Yan " /*5a2e*/, "Yu " /*5a2f*/, "Si " /*5a30*/, "Yu " /*5a31*/, "Wa " /*5a32*/, "[?] " /*5a33*/, "Xian " /*5a34*/, "Ju " /*5a35*/, "Qu " /*5a36*/, "Shui " /*5a37*/, "Qi " /*5a38*/, "Xian " /*5a39*/, "Zhui " /*5a3a*/, "Dong " /*5a3b*/, "Chang " /*5a3c*/, "Lu " /*5a3d*/, "Ai " /*5a3e*/, "E " /*5a3f*/, "E " /*5a40*/, "Lou " /*5a41*/, "Mian " /*5a42*/, "Cong " /*5a43*/, "Pou " /*5a44*/, "Ju " /*5a45*/, "Po " /*5a46*/, "Cai " /*5a47*/, "Ding " /*5a48*/, "Wan " /*5a49*/, "Biao " /*5a4a*/, "Xiao " /*5a4b*/, "Shu " /*5a4c*/, "Qi " /*5a4d*/, "Hui " /*5a4e*/, "Fu " /*5a4f*/, "E " /*5a50*/, "Wo " /*5a51*/, "Tan " /*5a52*/, "Fei " /*5a53*/, "Wei " /*5a54*/, "Jie " /*5a55*/, "Tian " /*5a56*/, "Ni " /*5a57*/, "Quan " /*5a58*/, "Jing " /*5a59*/, "Hun " /*5a5a*/, "Jing " /*5a5b*/, "Qian " /*5a5c*/, "Dian " /*5a5d*/, "Xing " /*5a5e*/, "Hu " /*5a5f*/, "Wa " /*5a60*/, "Lai " /*5a61*/, "Bi " /*5a62*/, "Yin " /*5a63*/, "Chou " /*5a64*/, "Chuo " /*5a65*/, "Fu " /*5a66*/, "Jing " /*5a67*/, "Lun " /*5a68*/, "Yan " /*5a69*/, "Lan " /*5a6a*/, "Kun " /*5a6b*/, "Yin " /*5a6c*/, "Ya " /*5a6d*/, "Ju " /*5a6e*/, "Li " /*5a6f*/, "Dian " /*5a70*/, "Xian " /*5a71*/, "Hwa " /*5a72*/, "Hua " /*5a73*/, "Ying " /*5a74*/, "Chan " /*5a75*/, "Shen " /*5a76*/, "Ting " /*5a77*/, "Dang " /*5a78*/, "Yao " /*5a79*/, "Wu " /*5a7a*/, "Nan " /*5a7b*/, "Ruo " /*5a7c*/, "Jia " /*5a7d*/, "Tou " /*5a7e*/, "Xu " /*5a7f*/, "Yu " /*5a80*/, "Wei " /*5a81*/, "Ti " /*5a82*/, "Rou " /*5a83*/, "Mei " /*5a84*/, "Dan " /*5a85*/, "Ruan " /*5a86*/, "Qin " /*5a87*/, "Hui " /*5a88*/, "Wu " /*5a89*/, "Qian " /*5a8a*/, "Chun " /*5a8b*/, "Mao " /*5a8c*/, "Fu " /*5a8d*/, "Jie " /*5a8e*/, "Duan " /*5a8f*/, "Xi " /*5a90*/, "Zhong " /*5a91*/, "Mei " /*5a92*/, "Huang " /*5a93*/, "Mian " /*5a94*/, "An " /*5a95*/, "Ying " /*5a96*/, "Xuan " /*5a97*/, "Jie " /*5a98*/, "Wei " /*5a99*/, "Mei " /*5a9a*/, "Yuan " /*5a9b*/, "Zhen " /*5a9c*/, "Qiu " /*5a9d*/, "Ti " /*5a9e*/, "Xie " /*5a9f*/, "Tuo " /*5aa0*/, "Lian " /*5aa1*/, "Mao " /*5aa2*/, "Ran " /*5aa3*/, "Si " /*5aa4*/, "Pian " /*5aa5*/, "Wei " /*5aa6*/, "Wa " /*5aa7*/, "Jiu " /*5aa8*/, "Hu " /*5aa9*/, "Ao " /*5aaa*/, "[?] " /*5aab*/, "Bou " /*5aac*/, "Xu " /*5aad*/, "Tou " /*5aae*/, "Gui " /*5aaf*/, "Zou " /*5ab0*/, "Yao " /*5ab1*/, "Pi " /*5ab2*/, "Xi " /*5ab3*/, "Yuan " /*5ab4*/, "Ying " /*5ab5*/, "Rong " /*5ab6*/, "Ru " /*5ab7*/, "Chi " /*5ab8*/, "Liu " /*5ab9*/, "Mei " /*5aba*/, "Pan " /*5abb*/, "Ao " /*5abc*/, "Ma " /*5abd*/, "Gou " /*5abe*/, "Kui " /*5abf*/, "Qin " /*5ac0*/, "Jia " /*5ac1*/, "Sao " /*5ac2*/, "Zhen " /*5ac3*/, "Yuan " /*5ac4*/, "Cha " /*5ac5*/, "Yong " /*5ac6*/, "Ming " /*5ac7*/, "Ying " /*5ac8*/, "Ji " /*5ac9*/, "Su " /*5aca*/, "Niao " /*5acb*/, "Xian " /*5acc*/, "Tao " /*5acd*/, "Pang " /*5ace*/, "Lang " /*5acf*/, "Nao " /*5ad0*/, "Bao " /*5ad1*/, "Ai " /*5ad2*/, "Pi " /*5ad3*/, "Pin " /*5ad4*/, "Yi " /*5ad5*/, "Piao " /*5ad6*/, "Yu " /*5ad7*/, "Lei " /*5ad8*/, "Xuan " /*5ad9*/, "Man " /*5ada*/, "Yi " /*5adb*/, "Zhang " /*5adc*/, "Kang " /*5add*/, "Yong " /*5ade*/, "Ni " /*5adf*/, "Li " /*5ae0*/, "Di " /*5ae1*/, "Gui " /*5ae2*/, "Yan " /*5ae3*/, "Jin " /*5ae4*/, "Zhuan " /*5ae5*/, "Chang " /*5ae6*/, "Ce " /*5ae7*/, "Han " /*5ae8*/, "Nen " /*5ae9*/, "Lao " /*5aea*/, "Mo " /*5aeb*/, "Zhe " /*5aec*/, "Hu " /*5aed*/, "Hu " /*5aee*/, "Ao " /*5aef*/, "Nen " /*5af0*/, "Qiang " /*5af1*/, "Ma " /*5af2*/, "Pie " /*5af3*/, "Gu " /*5af4*/, "Wu " /*5af5*/, "Jiao " /*5af6*/, "Tuo " /*5af7*/, "Zhan " /*5af8*/, "Mao " /*5af9*/, "Xian " /*5afa*/, "Xian " /*5afb*/, "Mo " /*5afc*/, "Liao " /*5afd*/, "Lian " /*5afe*/, "Hua " /*5aff*/ 
			});
						characters.TryAdd(91 /*23296 5b*/, new string[] {
				"Gui " /*5b00*/, "Deng " /*5b01*/, "Zhi " /*5b02*/, "Xu " /*5b03*/, "Yi " /*5b04*/, "Hua " /*5b05*/, "Xi " /*5b06*/, "Hui " /*5b07*/, "Rao " /*5b08*/, "Xi " /*5b09*/, "Yan " /*5b0a*/, "Chan " /*5b0b*/, "Jiao " /*5b0c*/, "Mei " /*5b0d*/, "Fan " /*5b0e*/, "Fan " /*5b0f*/, "Xian " /*5b10*/, "Yi " /*5b11*/, "Wei " /*5b12*/, "Jiao " /*5b13*/, "Fu " /*5b14*/, "Shi " /*5b15*/, "Bi " /*5b16*/, "Shan " /*5b17*/, "Sui " /*5b18*/, "Qiang " /*5b19*/, "Lian " /*5b1a*/, "Huan " /*5b1b*/, "Xin " /*5b1c*/, "Niao " /*5b1d*/, "Dong " /*5b1e*/, "Yi " /*5b1f*/, "Can " /*5b20*/, "Ai " /*5b21*/, "Niang " /*5b22*/, "Neng " /*5b23*/, "Ma " /*5b24*/, "Tiao " /*5b25*/, "Chou " /*5b26*/, "Jin " /*5b27*/, "Ci " /*5b28*/, "Yu " /*5b29*/, "Pin " /*5b2a*/, "Yong " /*5b2b*/, "Xu " /*5b2c*/, "Nai " /*5b2d*/, "Yan " /*5b2e*/, "Tai " /*5b2f*/, "Ying " /*5b30*/, "Can " /*5b31*/, "Niao " /*5b32*/, "Wo " /*5b33*/, "Ying " /*5b34*/, "Mian " /*5b35*/, "Kaka " /*5b36*/, "Ma " /*5b37*/, "Shen " /*5b38*/, "Xing " /*5b39*/, "Ni " /*5b3a*/, "Du " /*5b3b*/, "Liu " /*5b3c*/, "Yuan " /*5b3d*/, "Lan " /*5b3e*/, "Yan " /*5b3f*/, "Shuang " /*5b40*/, "Ling " /*5b41*/, "Jiao " /*5b42*/, "Niang " /*5b43*/, "Lan " /*5b44*/, "Xian " /*5b45*/, "Ying " /*5b46*/, "Shuang " /*5b47*/, "Shuai " /*5b48*/, "Quan " /*5b49*/, "Mi " /*5b4a*/, "Li " /*5b4b*/, "Luan " /*5b4c*/, "Yan " /*5b4d*/, "Zhu " /*5b4e*/, "Lan " /*5b4f*/, "Zi " /*5b50*/, "Jie " /*5b51*/, "Jue " /*5b52*/, "Jue " /*5b53*/, "Kong " /*5b54*/, "Yun " /*5b55*/, "Zi " /*5b56*/, "Zi " /*5b57*/, "Cun " /*5b58*/, "Sun " /*5b59*/, "Fu " /*5b5a*/, "Bei " /*5b5b*/, "Zi " /*5b5c*/, "Xiao " /*5b5d*/, "Xin " /*5b5e*/, "Meng " /*5b5f*/, "Si " /*5b60*/, "Tai " /*5b61*/, "Bao " /*5b62*/, "Ji " /*5b63*/, "Gu " /*5b64*/, "Nu " /*5b65*/, "Xue " /*5b66*/, "[?] " /*5b67*/, "Zhuan " /*5b68*/, "Hai " /*5b69*/, "Luan " /*5b6a*/, "Sun " /*5b6b*/, "Huai " /*5b6c*/, "Mie " /*5b6d*/, "Cong " /*5b6e*/, "Qian " /*5b6f*/, "Shu " /*5b70*/, "Chan " /*5b71*/, "Ya " /*5b72*/, "Zi " /*5b73*/, "Ni " /*5b74*/, "Fu " /*5b75*/, "Zi " /*5b76*/, "Li " /*5b77*/, "Xue " /*5b78*/, "Bo " /*5b79*/, "Ru " /*5b7a*/, "Lai " /*5b7b*/, "Nie " /*5b7c*/, "Nie " /*5b7d*/, "Ying " /*5b7e*/, "Luan " /*5b7f*/, "Mian " /*5b80*/, "Zhu " /*5b81*/, "Rong " /*5b82*/, "Ta " /*5b83*/, "Gui " /*5b84*/, "Zhai " /*5b85*/, "Qiong " /*5b86*/, "Yu " /*5b87*/, "Shou " /*5b88*/, "An " /*5b89*/, "Tu " /*5b8a*/, "Song " /*5b8b*/, "Wan " /*5b8c*/, "Rou " /*5b8d*/, "Yao " /*5b8e*/, "Hong " /*5b8f*/, "Yi " /*5b90*/, "Jing " /*5b91*/, "Zhun " /*5b92*/, "Mi " /*5b93*/, "Zhu " /*5b94*/, "Dang " /*5b95*/, "Hong " /*5b96*/, "Zong " /*5b97*/, "Guan " /*5b98*/, "Zhou " /*5b99*/, "Ding " /*5b9a*/, "Wan " /*5b9b*/, "Yi " /*5b9c*/, "Bao " /*5b9d*/, "Shi " /*5b9e*/, "Shi " /*5b9f*/, "Chong " /*5ba0*/, "Shen " /*5ba1*/, "Ke " /*5ba2*/, "Xuan " /*5ba3*/, "Shi " /*5ba4*/, "You " /*5ba5*/, "Huan " /*5ba6*/, "Yi " /*5ba7*/, "Tiao " /*5ba8*/, "Shi " /*5ba9*/, "Xian " /*5baa*/, "Gong " /*5bab*/, "Cheng " /*5bac*/, "Qun " /*5bad*/, "Gong " /*5bae*/, "Xiao " /*5baf*/, "Zai " /*5bb0*/, "Zha " /*5bb1*/, "Bao " /*5bb2*/, "Hai " /*5bb3*/, "Yan " /*5bb4*/, "Xiao " /*5bb5*/, "Jia " /*5bb6*/, "Shen " /*5bb7*/, "Chen " /*5bb8*/, "Rong " /*5bb9*/, "Huang " /*5bba*/, "Mi " /*5bbb*/, "Kou " /*5bbc*/, "Kuan " /*5bbd*/, "Bin " /*5bbe*/, "Su " /*5bbf*/, "Cai " /*5bc0*/, "Zan " /*5bc1*/, "Ji " /*5bc2*/, "Yuan " /*5bc3*/, "Ji " /*5bc4*/, "Yin " /*5bc5*/, "Mi " /*5bc6*/, "Kou " /*5bc7*/, "Qing " /*5bc8*/, "Que " /*5bc9*/, "Zhen " /*5bca*/, "Jian " /*5bcb*/, "Fu " /*5bcc*/, "Ning " /*5bcd*/, "Bing " /*5bce*/, "Huan " /*5bcf*/, "Mei " /*5bd0*/, "Qin " /*5bd1*/, "Han " /*5bd2*/, "Yu " /*5bd3*/, "Shi " /*5bd4*/, "Ning " /*5bd5*/, "Qin " /*5bd6*/, "Ning " /*5bd7*/, "Zhi " /*5bd8*/, "Yu " /*5bd9*/, "Bao " /*5bda*/, "Kuan " /*5bdb*/, "Ning " /*5bdc*/, "Qin " /*5bdd*/, "Mo " /*5bde*/, "Cha " /*5bdf*/, "Ju " /*5be0*/, "Gua " /*5be1*/, "Qin " /*5be2*/, "Hu " /*5be3*/, "Wu " /*5be4*/, "Liao " /*5be5*/, "Shi " /*5be6*/, "Zhu " /*5be7*/, "Zhai " /*5be8*/, "Shen " /*5be9*/, "Wei " /*5bea*/, "Xie " /*5beb*/, "Kuan " /*5bec*/, "Hui " /*5bed*/, "Liao " /*5bee*/, "Jun " /*5bef*/, "Huan " /*5bf0*/, "Yi " /*5bf1*/, "Yi " /*5bf2*/, "Bao " /*5bf3*/, "Qin " /*5bf4*/, "Chong " /*5bf5*/, "Bao " /*5bf6*/, "Feng " /*5bf7*/, "Cun " /*5bf8*/, "Dui " /*5bf9*/, "Si " /*5bfa*/, "Xun " /*5bfb*/, "Dao " /*5bfc*/, "Lu " /*5bfd*/, "Dui " /*5bfe*/, "Shou " /*5bff*/ 
			});
						characters.TryAdd(92 /*23552 5c*/, new string[] {
				"Po " /*5c00*/, "Feng " /*5c01*/, "Zhuan " /*5c02*/, "Fu " /*5c03*/, "She " /*5c04*/, "Ke " /*5c05*/, "Jiang " /*5c06*/, "Jiang " /*5c07*/, "Zhuan " /*5c08*/, "Wei " /*5c09*/, "Zun " /*5c0a*/, "Xun " /*5c0b*/, "Shu " /*5c0c*/, "Dui " /*5c0d*/, "Dao " /*5c0e*/, "Xiao " /*5c0f*/, "Ji " /*5c10*/, "Shao " /*5c11*/, "Er " /*5c12*/, "Er " /*5c13*/, "Er " /*5c14*/, "Ga " /*5c15*/, "Jian " /*5c16*/, "Shu " /*5c17*/, "Chen " /*5c18*/, "Shang " /*5c19*/, "Shang " /*5c1a*/, "Mo " /*5c1b*/, "Ga " /*5c1c*/, "Chang " /*5c1d*/, "Liao " /*5c1e*/, "Xian " /*5c1f*/, "Xian " /*5c20*/, "[?] " /*5c21*/, "Wang " /*5c22*/, "Wang " /*5c23*/, "You " /*5c24*/, "Liao " /*5c25*/, "Liao " /*5c26*/, "Yao " /*5c27*/, "Mang " /*5c28*/, "Wang " /*5c29*/, "Wang " /*5c2a*/, "Wang " /*5c2b*/, "Ga " /*5c2c*/, "Yao " /*5c2d*/, "Duo " /*5c2e*/, "Kui " /*5c2f*/, "Zhong " /*5c30*/, "Jiu " /*5c31*/, "Gan " /*5c32*/, "Gu " /*5c33*/, "Gan " /*5c34*/, "Tui " /*5c35*/, "Gan " /*5c36*/, "Gan " /*5c37*/, "Shi " /*5c38*/, "Yin " /*5c39*/, "Chi " /*5c3a*/, "Kao " /*5c3b*/, "Ni " /*5c3c*/, "Jin " /*5c3d*/, "Wei " /*5c3e*/, "Niao " /*5c3f*/, "Ju " /*5c40*/, "Pi " /*5c41*/, "Ceng " /*5c42*/, "Xi " /*5c43*/, "Bi " /*5c44*/, "Ju " /*5c45*/, "Jie " /*5c46*/, "Tian " /*5c47*/, "Qu " /*5c48*/, "Ti " /*5c49*/, "Jie " /*5c4a*/, "Wu " /*5c4b*/, "Diao " /*5c4c*/, "Shi " /*5c4d*/, "Shi " /*5c4e*/, "Ping " /*5c4f*/, "Ji " /*5c50*/, "Xie " /*5c51*/, "Chen " /*5c52*/, "Xi " /*5c53*/, "Ni " /*5c54*/, "Zhan " /*5c55*/, "Xi " /*5c56*/, "[?] " /*5c57*/, "Man " /*5c58*/, "E " /*5c59*/, "Lou " /*5c5a*/, "Ping " /*5c5b*/, "Ti " /*5c5c*/, "Fei " /*5c5d*/, "Shu " /*5c5e*/, "Xie " /*5c5f*/, "Tu " /*5c60*/, "Lu " /*5c61*/, "Lu " /*5c62*/, "Xi " /*5c63*/, "Ceng " /*5c64*/, "Lu " /*5c65*/, "Ju " /*5c66*/, "Xie " /*5c67*/, "Ju " /*5c68*/, "Jue " /*5c69*/, "Liao " /*5c6a*/, "Jue " /*5c6b*/, "Shu " /*5c6c*/, "Xi " /*5c6d*/, "Che " /*5c6e*/, "Tun " /*5c6f*/, "Ni " /*5c70*/, "Shan " /*5c71*/, "[?] " /*5c72*/, "Xian " /*5c73*/, "Li " /*5c74*/, "Xue " /*5c75*/, "Nata " /*5c76*/, "[?] " /*5c77*/, "Long " /*5c78*/, "Yi " /*5c79*/, "Qi " /*5c7a*/, "Ren " /*5c7b*/, "Wu " /*5c7c*/, "Han " /*5c7d*/, "Shen " /*5c7e*/, "Yu " /*5c7f*/, "Chu " /*5c80*/, "Sui " /*5c81*/, "Qi " /*5c82*/, "[?] " /*5c83*/, "Yue " /*5c84*/, "Ban " /*5c85*/, "Yao " /*5c86*/, "Ang " /*5c87*/, "Ya " /*5c88*/, "Wu " /*5c89*/, "Jie " /*5c8a*/, "E " /*5c8b*/, "Ji " /*5c8c*/, "Qian " /*5c8d*/, "Fen " /*5c8e*/, "Yuan " /*5c8f*/, "Qi " /*5c90*/, "Cen " /*5c91*/, "Qian " /*5c92*/, "Qi " /*5c93*/, "Cha " /*5c94*/, "Jie " /*5c95*/, "Qu " /*5c96*/, "Gang " /*5c97*/, "Xian " /*5c98*/, "Ao " /*5c99*/, "Lan " /*5c9a*/, "Dao " /*5c9b*/, "Ba " /*5c9c*/, "Zuo " /*5c9d*/, "Zuo " /*5c9e*/, "Yang " /*5c9f*/, "Ju " /*5ca0*/, "Gang " /*5ca1*/, "Ke " /*5ca2*/, "Gou " /*5ca3*/, "Xue " /*5ca4*/, "Bei " /*5ca5*/, "Li " /*5ca6*/, "Tiao " /*5ca7*/, "Ju " /*5ca8*/, "Yan " /*5ca9*/, "Fu " /*5caa*/, "Xiu " /*5cab*/, "Jia " /*5cac*/, "Ling " /*5cad*/, "Tuo " /*5cae*/, "Pei " /*5caf*/, "You " /*5cb0*/, "Dai " /*5cb1*/, "Kuang " /*5cb2*/, "Yue " /*5cb3*/, "Qu " /*5cb4*/, "Hu " /*5cb5*/, "Po " /*5cb6*/, "Min " /*5cb7*/, "An " /*5cb8*/, "Tiao " /*5cb9*/, "Ling " /*5cba*/, "Chi " /*5cbb*/, "Yuri " /*5cbc*/, "Dong " /*5cbd*/, "Cem " /*5cbe*/, "Kui " /*5cbf*/, "Xiu " /*5cc0*/, "Mao " /*5cc1*/, "Tong " /*5cc2*/, "Xue " /*5cc3*/, "Yi " /*5cc4*/, "Kura " /*5cc5*/, "He " /*5cc6*/, "Ke " /*5cc7*/, "Luo " /*5cc8*/, "E " /*5cc9*/, "Fu " /*5cca*/, "Xun " /*5ccb*/, "Die " /*5ccc*/, "Lu " /*5ccd*/, "An " /*5cce*/, "Er " /*5ccf*/, "Gai " /*5cd0*/, "Quan " /*5cd1*/, "Tong " /*5cd2*/, "Yi " /*5cd3*/, "Mu " /*5cd4*/, "Shi " /*5cd5*/, "An " /*5cd6*/, "Wei " /*5cd7*/, "Hu " /*5cd8*/, "Zhi " /*5cd9*/, "Mi " /*5cda*/, "Li " /*5cdb*/, "Ji " /*5cdc*/, "Tong " /*5cdd*/, "Wei " /*5cde*/, "You " /*5cdf*/, "Sang " /*5ce0*/, "Xia " /*5ce1*/, "Li " /*5ce2*/, "Yao " /*5ce3*/, "Jiao " /*5ce4*/, "Zheng " /*5ce5*/, "Luan " /*5ce6*/, "Jiao " /*5ce7*/, "E " /*5ce8*/, "E " /*5ce9*/, "Yu " /*5cea*/, "Ye " /*5ceb*/, "Bu " /*5cec*/, "Qiao " /*5ced*/, "Qun " /*5cee*/, "Feng " /*5cef*/, "Feng " /*5cf0*/, "Nao " /*5cf1*/, "Li " /*5cf2*/, "You " /*5cf3*/, "Xian " /*5cf4*/, "Hong " /*5cf5*/, "Dao " /*5cf6*/, "Shen " /*5cf7*/, "Cheng " /*5cf8*/, "Tu " /*5cf9*/, "Geng " /*5cfa*/, "Jun " /*5cfb*/, "Hao " /*5cfc*/, "Xia " /*5cfd*/, "Yin " /*5cfe*/, "Yu " /*5cff*/ 
			});
						characters.TryAdd(93 /*23808 5d*/, new string[] {
				"Lang " /*5d00*/, "Kan " /*5d01*/, "Lao " /*5d02*/, "Lai " /*5d03*/, "Xian " /*5d04*/, "Que " /*5d05*/, "Kong " /*5d06*/, "Chong " /*5d07*/, "Chong " /*5d08*/, "Ta " /*5d09*/, "Lin " /*5d0a*/, "Hua " /*5d0b*/, "Ju " /*5d0c*/, "Lai " /*5d0d*/, "Qi " /*5d0e*/, "Min " /*5d0f*/, "Kun " /*5d10*/, "Kun " /*5d11*/, "Zu " /*5d12*/, "Gu " /*5d13*/, "Cui " /*5d14*/, "Ya " /*5d15*/, "Ya " /*5d16*/, "Gang " /*5d17*/, "Lun " /*5d18*/, "Lun " /*5d19*/, "Leng " /*5d1a*/, "Jue " /*5d1b*/, "Duo " /*5d1c*/, "Zheng " /*5d1d*/, "Guo " /*5d1e*/, "Yin " /*5d1f*/, "Dong " /*5d20*/, "Han " /*5d21*/, "Zheng " /*5d22*/, "Wei " /*5d23*/, "Yao " /*5d24*/, "Pi " /*5d25*/, "Yan " /*5d26*/, "Song " /*5d27*/, "Jie " /*5d28*/, "Beng " /*5d29*/, "Zu " /*5d2a*/, "Jue " /*5d2b*/, "Dong " /*5d2c*/, "Zhan " /*5d2d*/, "Gu " /*5d2e*/, "Yin " /*5d2f*/, "[?] " /*5d30*/, "Ze " /*5d31*/, "Huang " /*5d32*/, "Yu " /*5d33*/, "Wei " /*5d34*/, "Yang " /*5d35*/, "Feng " /*5d36*/, "Qiu " /*5d37*/, "Dun " /*5d38*/, "Ti " /*5d39*/, "Yi " /*5d3a*/, "Zhi " /*5d3b*/, "Shi " /*5d3c*/, "Zai " /*5d3d*/, "Yao " /*5d3e*/, "E " /*5d3f*/, "Zhu " /*5d40*/, "Kan " /*5d41*/, "Lu " /*5d42*/, "Yan " /*5d43*/, "Mei " /*5d44*/, "Gan " /*5d45*/, "Ji " /*5d46*/, "Ji " /*5d47*/, "Huan " /*5d48*/, "Ting " /*5d49*/, "Sheng " /*5d4a*/, "Mei " /*5d4b*/, "Qian " /*5d4c*/, "Wu " /*5d4d*/, "Yu " /*5d4e*/, "Zong " /*5d4f*/, "Lan " /*5d50*/, "Jue " /*5d51*/, "Yan " /*5d52*/, "Yan " /*5d53*/, "Wei " /*5d54*/, "Zong " /*5d55*/, "Cha " /*5d56*/, "Sui " /*5d57*/, "Rong " /*5d58*/, "Yamashina " /*5d59*/, "Qin " /*5d5a*/, "Yu " /*5d5b*/, "Kewashii " /*5d5c*/, "Lou " /*5d5d*/, "Tu " /*5d5e*/, "Dui " /*5d5f*/, "Xi " /*5d60*/, "Weng " /*5d61*/, "Cang " /*5d62*/, "Dang " /*5d63*/, "Hong " /*5d64*/, "Jie " /*5d65*/, "Ai " /*5d66*/, "Liu " /*5d67*/, "Wu " /*5d68*/, "Song " /*5d69*/, "Qiao " /*5d6a*/, "Zi " /*5d6b*/, "Wei " /*5d6c*/, "Beng " /*5d6d*/, "Dian " /*5d6e*/, "Cuo " /*5d6f*/, "Qian " /*5d70*/, "Yong " /*5d71*/, "Nie " /*5d72*/, "Cuo " /*5d73*/, "Ji " /*5d74*/, "[?] " /*5d75*/, "Tao " /*5d76*/, "Song " /*5d77*/, "Zong " /*5d78*/, "Jiang " /*5d79*/, "Liao " /*5d7a*/, "Kang " /*5d7b*/, "Chan " /*5d7c*/, "Die " /*5d7d*/, "Cen " /*5d7e*/, "Ding " /*5d7f*/, "Tu " /*5d80*/, "Lou " /*5d81*/, "Zhang " /*5d82*/, "Zhan " /*5d83*/, "Zhan " /*5d84*/, "Ao " /*5d85*/, "Cao " /*5d86*/, "Qu " /*5d87*/, "Qiang " /*5d88*/, "Zui " /*5d89*/, "Zui " /*5d8a*/, "Dao " /*5d8b*/, "Dao " /*5d8c*/, "Xi " /*5d8d*/, "Yu " /*5d8e*/, "Bo " /*5d8f*/, "Long " /*5d90*/, "Xiang " /*5d91*/, "Ceng " /*5d92*/, "Bo " /*5d93*/, "Qin " /*5d94*/, "Jiao " /*5d95*/, "Yan " /*5d96*/, "Lao " /*5d97*/, "Zhan " /*5d98*/, "Lin " /*5d99*/, "Liao " /*5d9a*/, "Liao " /*5d9b*/, "Jin " /*5d9c*/, "Deng " /*5d9d*/, "Duo " /*5d9e*/, "Zun " /*5d9f*/, "Jiao " /*5da0*/, "Gui " /*5da1*/, "Yao " /*5da2*/, "Qiao " /*5da3*/, "Yao " /*5da4*/, "Jue " /*5da5*/, "Zhan " /*5da6*/, "Yi " /*5da7*/, "Xue " /*5da8*/, "Nao " /*5da9*/, "Ye " /*5daa*/, "Ye " /*5dab*/, "Yi " /*5dac*/, "E " /*5dad*/, "Xian " /*5dae*/, "Ji " /*5daf*/, "Xie " /*5db0*/, "Ke " /*5db1*/, "Xi " /*5db2*/, "Di " /*5db3*/, "Ao " /*5db4*/, "Zui " /*5db5*/, "[?] " /*5db6*/, "Ni " /*5db7*/, "Rong " /*5db8*/, "Dao " /*5db9*/, "Ling " /*5dba*/, "Za " /*5dbb*/, "Yu " /*5dbc*/, "Yue " /*5dbd*/, "Yin " /*5dbe*/, "[?] " /*5dbf*/, "Jie " /*5dc0*/, "Li " /*5dc1*/, "Sui " /*5dc2*/, "Long " /*5dc3*/, "Long " /*5dc4*/, "Dian " /*5dc5*/, "Ying " /*5dc6*/, "Xi " /*5dc7*/, "Ju " /*5dc8*/, "Chan " /*5dc9*/, "Ying " /*5dca*/, "Kui " /*5dcb*/, "Yan " /*5dcc*/, "Wei " /*5dcd*/, "Nao " /*5dce*/, "Quan " /*5dcf*/, "Chao " /*5dd0*/, "Cuan " /*5dd1*/, "Luan " /*5dd2*/, "Dian " /*5dd3*/, "Dian " /*5dd4*/, "[?] " /*5dd5*/, "Yan " /*5dd6*/, "Yan " /*5dd7*/, "Yan " /*5dd8*/, "Nao " /*5dd9*/, "Yan " /*5dda*/, "Chuan " /*5ddb*/, "Gui " /*5ddc*/, "Chuan " /*5ddd*/, "Zhou " /*5dde*/, "Huang " /*5ddf*/, "Jing " /*5de0*/, "Xun " /*5de1*/, "Chao " /*5de2*/, "Chao " /*5de3*/, "Lie " /*5de4*/, "Gong " /*5de5*/, "Zuo " /*5de6*/, "Qiao " /*5de7*/, "Ju " /*5de8*/, "Gong " /*5de9*/, "Kek " /*5dea*/, "Wu " /*5deb*/, "Pwu " /*5dec*/, "Pwu " /*5ded*/, "Chai " /*5dee*/, "Qiu " /*5def*/, "Qiu " /*5df0*/, "Ji " /*5df1*/, "Yi " /*5df2*/, "Si " /*5df3*/, "Ba " /*5df4*/, "Zhi " /*5df5*/, "Zhao " /*5df6*/, "Xiang " /*5df7*/, "Yi " /*5df8*/, "Jin " /*5df9*/, "Xun " /*5dfa*/, "Juan " /*5dfb*/, "Phas " /*5dfc*/, "Xun " /*5dfd*/, "Jin " /*5dfe*/, "Fu " /*5dff*/ 
			});
						characters.TryAdd(94 /*24064 5e*/, new string[] {
				"Za " /*5e00*/, "Bi " /*5e01*/, "Shi " /*5e02*/, "Bu " /*5e03*/, "Ding " /*5e04*/, "Shuai " /*5e05*/, "Fan " /*5e06*/, "Nie " /*5e07*/, "Shi " /*5e08*/, "Fen " /*5e09*/, "Pa " /*5e0a*/, "Zhi " /*5e0b*/, "Xi " /*5e0c*/, "Hu " /*5e0d*/, "Dan " /*5e0e*/, "Wei " /*5e0f*/, "Zhang " /*5e10*/, "Tang " /*5e11*/, "Dai " /*5e12*/, "Ma " /*5e13*/, "Pei " /*5e14*/, "Pa " /*5e15*/, "Tie " /*5e16*/, "Fu " /*5e17*/, "Lian " /*5e18*/, "Zhi " /*5e19*/, "Zhou " /*5e1a*/, "Bo " /*5e1b*/, "Zhi " /*5e1c*/, "Di " /*5e1d*/, "Mo " /*5e1e*/, "Yi " /*5e1f*/, "Yi " /*5e20*/, "Ping " /*5e21*/, "Qia " /*5e22*/, "Juan " /*5e23*/, "Ru " /*5e24*/, "Shuai " /*5e25*/, "Dai " /*5e26*/, "Zheng " /*5e27*/, "Shui " /*5e28*/, "Qiao " /*5e29*/, "Zhen " /*5e2a*/, "Shi " /*5e2b*/, "Qun " /*5e2c*/, "Xi " /*5e2d*/, "Bang " /*5e2e*/, "Dai " /*5e2f*/, "Gui " /*5e30*/, "Chou " /*5e31*/, "Ping " /*5e32*/, "Zhang " /*5e33*/, "Sha " /*5e34*/, "Wan " /*5e35*/, "Dai " /*5e36*/, "Wei " /*5e37*/, "Chang " /*5e38*/, "Sha " /*5e39*/, "Qi " /*5e3a*/, "Ze " /*5e3b*/, "Guo " /*5e3c*/, "Mao " /*5e3d*/, "Du " /*5e3e*/, "Hou " /*5e3f*/, "Zheng " /*5e40*/, "Xu " /*5e41*/, "Mi " /*5e42*/, "Wei " /*5e43*/, "Wo " /*5e44*/, "Fu " /*5e45*/, "Yi " /*5e46*/, "Bang " /*5e47*/, "Ping " /*5e48*/, "Tazuna " /*5e49*/, "Gong " /*5e4a*/, "Pan " /*5e4b*/, "Huang " /*5e4c*/, "Dao " /*5e4d*/, "Mi " /*5e4e*/, "Jia " /*5e4f*/, "Teng " /*5e50*/, "Hui " /*5e51*/, "Zhong " /*5e52*/, "Shan " /*5e53*/, "Man " /*5e54*/, "Mu " /*5e55*/, "Biao " /*5e56*/, "Guo " /*5e57*/, "Ze " /*5e58*/, "Mu " /*5e59*/, "Bang " /*5e5a*/, "Zhang " /*5e5b*/, "Jiong " /*5e5c*/, "Chan " /*5e5d*/, "Fu " /*5e5e*/, "Zhi " /*5e5f*/, "Hu " /*5e60*/, "Fan " /*5e61*/, "Chuang " /*5e62*/, "Bi " /*5e63*/, "Hei " /*5e64*/, "[?] " /*5e65*/, "Mi " /*5e66*/, "Qiao " /*5e67*/, "Chan " /*5e68*/, "Fen " /*5e69*/, "Meng " /*5e6a*/, "Bang " /*5e6b*/, "Chou " /*5e6c*/, "Mie " /*5e6d*/, "Chu " /*5e6e*/, "Jie " /*5e6f*/, "Xian " /*5e70*/, "Lan " /*5e71*/, "Gan " /*5e72*/, "Ping " /*5e73*/, "Nian " /*5e74*/, "Qian " /*5e75*/, "Bing " /*5e76*/, "Bing " /*5e77*/, "Xing " /*5e78*/, "Gan " /*5e79*/, "Yao " /*5e7a*/, "Huan " /*5e7b*/, "You " /*5e7c*/, "You " /*5e7d*/, "Ji " /*5e7e*/, "Yan " /*5e7f*/, "Pi " /*5e80*/, "Ting " /*5e81*/, "Ze " /*5e82*/, "Guang " /*5e83*/, "Zhuang " /*5e84*/, "Mo " /*5e85*/, "Qing " /*5e86*/, "Bi " /*5e87*/, "Qin " /*5e88*/, "Dun " /*5e89*/, "Chuang " /*5e8a*/, "Gui " /*5e8b*/, "Ya " /*5e8c*/, "Bai " /*5e8d*/, "Jie " /*5e8e*/, "Xu " /*5e8f*/, "Lu " /*5e90*/, "Wu " /*5e91*/, "[?] " /*5e92*/, "Ku " /*5e93*/, "Ying " /*5e94*/, "Di " /*5e95*/, "Pao " /*5e96*/, "Dian " /*5e97*/, "Ya " /*5e98*/, "Miao " /*5e99*/, "Geng " /*5e9a*/, "Ci " /*5e9b*/, "Fu " /*5e9c*/, "Tong " /*5e9d*/, "Pang " /*5e9e*/, "Fei " /*5e9f*/, "Xiang " /*5ea0*/, "Yi " /*5ea1*/, "Zhi " /*5ea2*/, "Tiao " /*5ea3*/, "Zhi " /*5ea4*/, "Xiu " /*5ea5*/, "Du " /*5ea6*/, "Zuo " /*5ea7*/, "Xiao " /*5ea8*/, "Tu " /*5ea9*/, "Gui " /*5eaa*/, "Ku " /*5eab*/, "Pang " /*5eac*/, "Ting " /*5ead*/, "You " /*5eae*/, "Bu " /*5eaf*/, "Ding " /*5eb0*/, "Cheng " /*5eb1*/, "Lai " /*5eb2*/, "Bei " /*5eb3*/, "Ji " /*5eb4*/, "An " /*5eb5*/, "Shu " /*5eb6*/, "Kang " /*5eb7*/, "Yong " /*5eb8*/, "Tuo " /*5eb9*/, "Song " /*5eba*/, "Shu " /*5ebb*/, "Qing " /*5ebc*/, "Yu " /*5ebd*/, "Yu " /*5ebe*/, "Miao " /*5ebf*/, "Sou " /*5ec0*/, "Ce " /*5ec1*/, "Xiang " /*5ec2*/, "Fei " /*5ec3*/, "Jiu " /*5ec4*/, "He " /*5ec5*/, "Hui " /*5ec6*/, "Liu " /*5ec7*/, "Sha " /*5ec8*/, "Lian " /*5ec9*/, "Lang " /*5eca*/, "Sou " /*5ecb*/, "Jian " /*5ecc*/, "Pou " /*5ecd*/, "Qing " /*5ece*/, "Jiu " /*5ecf*/, "Jiu " /*5ed0*/, "Qin " /*5ed1*/, "Ao " /*5ed2*/, "Kuo " /*5ed3*/, "Lou " /*5ed4*/, "Yin " /*5ed5*/, "Liao " /*5ed6*/, "Dai " /*5ed7*/, "Lu " /*5ed8*/, "Yi " /*5ed9*/, "Chu " /*5eda*/, "Chan " /*5edb*/, "Tu " /*5edc*/, "Si " /*5edd*/, "Xin " /*5ede*/, "Miao " /*5edf*/, "Chang " /*5ee0*/, "Wu " /*5ee1*/, "Fei " /*5ee2*/, "Guang " /*5ee3*/, "Koc " /*5ee4*/, "Kuai " /*5ee5*/, "Bi " /*5ee6*/, "Qiang " /*5ee7*/, "Xie " /*5ee8*/, "Lin " /*5ee9*/, "Lin " /*5eea*/, "Liao " /*5eeb*/, "Lu " /*5eec*/, "[?] " /*5eed*/, "Ying " /*5eee*/, "Xian " /*5eef*/, "Ting " /*5ef0*/, "Yong " /*5ef1*/, "Li " /*5ef2*/, "Ting " /*5ef3*/, "Yin " /*5ef4*/, "Xun " /*5ef5*/, "Yan " /*5ef6*/, "Ting " /*5ef7*/, "Di " /*5ef8*/, "Po " /*5ef9*/, "Jian " /*5efa*/, "Hui " /*5efb*/, "Nai " /*5efc*/, "Hui " /*5efd*/, "Gong " /*5efe*/, "Nian " /*5eff*/ 
			});
						characters.TryAdd(95 /*24320 5f*/, new string[] {
				"Kai " /*5f00*/, "Bian " /*5f01*/, "Yi " /*5f02*/, "Qi " /*5f03*/, "Nong " /*5f04*/, "Fen " /*5f05*/, "Ju " /*5f06*/, "Yan " /*5f07*/, "Yi " /*5f08*/, "Zang " /*5f09*/, "Bi " /*5f0a*/, "Yi " /*5f0b*/, "Yi " /*5f0c*/, "Er " /*5f0d*/, "San " /*5f0e*/, "Shi " /*5f0f*/, "Er " /*5f10*/, "Shi " /*5f11*/, "Shi " /*5f12*/, "Gong " /*5f13*/, "Diao " /*5f14*/, "Yin " /*5f15*/, "Hu " /*5f16*/, "Fu " /*5f17*/, "Hong " /*5f18*/, "Wu " /*5f19*/, "Tui " /*5f1a*/, "Chi " /*5f1b*/, "Jiang " /*5f1c*/, "Ba " /*5f1d*/, "Shen " /*5f1e*/, "Di " /*5f1f*/, "Zhang " /*5f20*/, "Jue " /*5f21*/, "Tao " /*5f22*/, "Fu " /*5f23*/, "Di " /*5f24*/, "Mi " /*5f25*/, "Xian " /*5f26*/, "Hu " /*5f27*/, "Chao " /*5f28*/, "Nu " /*5f29*/, "Jing " /*5f2a*/, "Zhen " /*5f2b*/, "Yi " /*5f2c*/, "Mi " /*5f2d*/, "Quan " /*5f2e*/, "Wan " /*5f2f*/, "Shao " /*5f30*/, "Ruo " /*5f31*/, "Xuan " /*5f32*/, "Jing " /*5f33*/, "Dun " /*5f34*/, "Zhang " /*5f35*/, "Jiang " /*5f36*/, "Qiang " /*5f37*/, "Peng " /*5f38*/, "Dan " /*5f39*/, "Qiang " /*5f3a*/, "Bi " /*5f3b*/, "Bi " /*5f3c*/, "She " /*5f3d*/, "Dan " /*5f3e*/, "Jian " /*5f3f*/, "Gou " /*5f40*/, "Sei " /*5f41*/, "Fa " /*5f42*/, "Bi " /*5f43*/, "Kou " /*5f44*/, "Nagi " /*5f45*/, "Bie " /*5f46*/, "Xiao " /*5f47*/, "Dan " /*5f48*/, "Kuo " /*5f49*/, "Qiang " /*5f4a*/, "Hong " /*5f4b*/, "Mi " /*5f4c*/, "Kuo " /*5f4d*/, "Wan " /*5f4e*/, "Jue " /*5f4f*/, "Ji " /*5f50*/, "Ji " /*5f51*/, "Gui " /*5f52*/, "Dang " /*5f53*/, "Lu " /*5f54*/, "Lu " /*5f55*/, "Tuan " /*5f56*/, "Hui " /*5f57*/, "Zhi " /*5f58*/, "Hui " /*5f59*/, "Hui " /*5f5a*/, "Yi " /*5f5b*/, "Yi " /*5f5c*/, "Yi " /*5f5d*/, "Yi " /*5f5e*/, "Huo " /*5f5f*/, "Huo " /*5f60*/, "Shan " /*5f61*/, "Xing " /*5f62*/, "Wen " /*5f63*/, "Tong " /*5f64*/, "Yan " /*5f65*/, "Yan " /*5f66*/, "Yu " /*5f67*/, "Chi " /*5f68*/, "Cai " /*5f69*/, "Biao " /*5f6a*/, "Diao " /*5f6b*/, "Bin " /*5f6c*/, "Peng " /*5f6d*/, "Yong " /*5f6e*/, "Piao " /*5f6f*/, "Zhang " /*5f70*/, "Ying " /*5f71*/, "Chi " /*5f72*/, "Chi " /*5f73*/, "Zhuo " /*5f74*/, "Tuo " /*5f75*/, "Ji " /*5f76*/, "Pang " /*5f77*/, "Zhong " /*5f78*/, "Yi " /*5f79*/, "Wang " /*5f7a*/, "Che " /*5f7b*/, "Bi " /*5f7c*/, "Chi " /*5f7d*/, "Ling " /*5f7e*/, "Fu " /*5f7f*/, "Wang " /*5f80*/, "Zheng " /*5f81*/, "Cu " /*5f82*/, "Wang " /*5f83*/, "Jing " /*5f84*/, "Dai " /*5f85*/, "Xi " /*5f86*/, "Xun " /*5f87*/, "Hen " /*5f88*/, "Yang " /*5f89*/, "Huai " /*5f8a*/, "Lu " /*5f8b*/, "Hou " /*5f8c*/, "Wa " /*5f8d*/, "Cheng " /*5f8e*/, "Zhi " /*5f8f*/, "Xu " /*5f90*/, "Jing " /*5f91*/, "Tu " /*5f92*/, "Cong " /*5f93*/, "[?] " /*5f94*/, "Lai " /*5f95*/, "Cong " /*5f96*/, "De " /*5f97*/, "Pai " /*5f98*/, "Xi " /*5f99*/, "[?] " /*5f9a*/, "Qi " /*5f9b*/, "Chang " /*5f9c*/, "Zhi " /*5f9d*/, "Cong " /*5f9e*/, "Zhou " /*5f9f*/, "Lai " /*5fa0*/, "Yu " /*5fa1*/, "Xie " /*5fa2*/, "Jie " /*5fa3*/, "Jian " /*5fa4*/, "Chi " /*5fa5*/, "Jia " /*5fa6*/, "Bian " /*5fa7*/, "Huang " /*5fa8*/, "Fu " /*5fa9*/, "Xun " /*5faa*/, "Wei " /*5fab*/, "Pang " /*5fac*/, "Yao " /*5fad*/, "Wei " /*5fae*/, "Xi " /*5faf*/, "Zheng " /*5fb0*/, "Piao " /*5fb1*/, "Chi " /*5fb2*/, "De " /*5fb3*/, "Zheng " /*5fb4*/, "Zheng " /*5fb5*/, "Bie " /*5fb6*/, "De " /*5fb7*/, "Chong " /*5fb8*/, "Che " /*5fb9*/, "Jiao " /*5fba*/, "Wei " /*5fbb*/, "Jiao " /*5fbc*/, "Hui " /*5fbd*/, "Mei " /*5fbe*/, "Long " /*5fbf*/, "Xiang " /*5fc0*/, "Bao " /*5fc1*/, "Qu " /*5fc2*/, "Xin " /*5fc3*/, "Shu " /*5fc4*/, "Bi " /*5fc5*/, "Yi " /*5fc6*/, "Le " /*5fc7*/, "Ren " /*5fc8*/, "Dao " /*5fc9*/, "Ding " /*5fca*/, "Gai " /*5fcb*/, "Ji " /*5fcc*/, "Ren " /*5fcd*/, "Ren " /*5fce*/, "Chan " /*5fcf*/, "Tan " /*5fd0*/, "Te " /*5fd1*/, "Te " /*5fd2*/, "Gan " /*5fd3*/, "Qi " /*5fd4*/, "Shi " /*5fd5*/, "Cun " /*5fd6*/, "Zhi " /*5fd7*/, "Wang " /*5fd8*/, "Mang " /*5fd9*/, "Xi " /*5fda*/, "Fan " /*5fdb*/, "Ying " /*5fdc*/, "Tian " /*5fdd*/, "Min " /*5fde*/, "Min " /*5fdf*/, "Zhong " /*5fe0*/, "Chong " /*5fe1*/, "Wu " /*5fe2*/, "Ji " /*5fe3*/, "Wu " /*5fe4*/, "Xi " /*5fe5*/, "Ye " /*5fe6*/, "You " /*5fe7*/, "Wan " /*5fe8*/, "Cong " /*5fe9*/, "Zhong " /*5fea*/, "Kuai " /*5feb*/, "Yu " /*5fec*/, "Bian " /*5fed*/, "Zhi " /*5fee*/, "Qi " /*5fef*/, "Cui " /*5ff0*/, "Chen " /*5ff1*/, "Tai " /*5ff2*/, "Tun " /*5ff3*/, "Qian " /*5ff4*/, "Nian " /*5ff5*/, "Hun " /*5ff6*/, "Xiong " /*5ff7*/, "Niu " /*5ff8*/, "Wang " /*5ff9*/, "Xian " /*5ffa*/, "Xin " /*5ffb*/, "Kang " /*5ffc*/, "Hu " /*5ffd*/, "Kai " /*5ffe*/, "Fen " /*5fff*/ 
			});
						characters.TryAdd(96 /*24576 60*/, new string[] {
				"Huai " /*6000*/, "Tai " /*6001*/, "Song " /*6002*/, "Wu " /*6003*/, "Ou " /*6004*/, "Chang " /*6005*/, "Chuang " /*6006*/, "Ju " /*6007*/, "Yi " /*6008*/, "Bao " /*6009*/, "Chao " /*600a*/, "Min " /*600b*/, "Pei " /*600c*/, "Zuo " /*600d*/, "Zen " /*600e*/, "Yang " /*600f*/, "Kou " /*6010*/, "Ban " /*6011*/, "Nu " /*6012*/, "Nao " /*6013*/, "Zheng " /*6014*/, "Pa " /*6015*/, "Bu " /*6016*/, "Tie " /*6017*/, "Gu " /*6018*/, "Hu " /*6019*/, "Ju " /*601a*/, "Da " /*601b*/, "Lian " /*601c*/, "Si " /*601d*/, "Chou " /*601e*/, "Di " /*601f*/, "Dai " /*6020*/, "Yi " /*6021*/, "Tu " /*6022*/, "You " /*6023*/, "Fu " /*6024*/, "Ji " /*6025*/, "Peng " /*6026*/, "Xing " /*6027*/, "Yuan " /*6028*/, "Ni " /*6029*/, "Guai " /*602a*/, "Fu " /*602b*/, "Xi " /*602c*/, "Bi " /*602d*/, "You " /*602e*/, "Qie " /*602f*/, "Xuan " /*6030*/, "Cong " /*6031*/, "Bing " /*6032*/, "Huang " /*6033*/, "Xu " /*6034*/, "Chu " /*6035*/, "Pi " /*6036*/, "Xi " /*6037*/, "Xi " /*6038*/, "Tan " /*6039*/, "Koraeru " /*603a*/, "Zong " /*603b*/, "Dui " /*603c*/, "[?] " /*603d*/, "Ki " /*603e*/, "Yi " /*603f*/, "Chi " /*6040*/, "Ren " /*6041*/, "Xun " /*6042*/, "Shi " /*6043*/, "Xi " /*6044*/, "Lao " /*6045*/, "Heng " /*6046*/, "Kuang " /*6047*/, "Mu " /*6048*/, "Zhi " /*6049*/, "Xie " /*604a*/, "Lian " /*604b*/, "Tiao " /*604c*/, "Huang " /*604d*/, "Die " /*604e*/, "Hao " /*604f*/, "Kong " /*6050*/, "Gui " /*6051*/, "Heng " /*6052*/, "Xi " /*6053*/, "Xiao " /*6054*/, "Shu " /*6055*/, "S " /*6056*/, "Kua " /*6057*/, "Qiu " /*6058*/, "Yang " /*6059*/, "Hui " /*605a*/, "Hui " /*605b*/, "Chi " /*605c*/, "Jia " /*605d*/, "Yi " /*605e*/, "Xiong " /*605f*/, "Guai " /*6060*/, "Lin " /*6061*/, "Hui " /*6062*/, "Zi " /*6063*/, "Xu " /*6064*/, "Chi " /*6065*/, "Xiang " /*6066*/, "Nu " /*6067*/, "Hen " /*6068*/, "En " /*6069*/, "Ke " /*606a*/, "Tong " /*606b*/, "Tian " /*606c*/, "Gong " /*606d*/, "Quan " /*606e*/, "Xi " /*606f*/, "Qia " /*6070*/, "Yue " /*6071*/, "Peng " /*6072*/, "Ken " /*6073*/, "De " /*6074*/, "Hui " /*6075*/, "E " /*6076*/, "Kyuu " /*6077*/, "Tong " /*6078*/, "Yan " /*6079*/, "Kai " /*607a*/, "Ce " /*607b*/, "Nao " /*607c*/, "Yun " /*607d*/, "Mang " /*607e*/, "Yong " /*607f*/, "Yong " /*6080*/, "Yuan " /*6081*/, "Pi " /*6082*/, "Kun " /*6083*/, "Qiao " /*6084*/, "Yue " /*6085*/, "Yu " /*6086*/, "Yu " /*6087*/, "Jie " /*6088*/, "Xi " /*6089*/, "Zhe " /*608a*/, "Lin " /*608b*/, "Ti " /*608c*/, "Han " /*608d*/, "Hao " /*608e*/, "Qie " /*608f*/, "Ti " /*6090*/, "Bu " /*6091*/, "Yi " /*6092*/, "Qian " /*6093*/, "Hui " /*6094*/, "Xi " /*6095*/, "Bei " /*6096*/, "Man " /*6097*/, "Yi " /*6098*/, "Heng " /*6099*/, "Song " /*609a*/, "Quan " /*609b*/, "Cheng " /*609c*/, "Hui " /*609d*/, "Wu " /*609e*/, "Wu " /*609f*/, "You " /*60a0*/, "Li " /*60a1*/, "Liang " /*60a2*/, "Huan " /*60a3*/, "Cong " /*60a4*/, "Yi " /*60a5*/, "Yue " /*60a6*/, "Li " /*60a7*/, "Nin " /*60a8*/, "Nao " /*60a9*/, "E " /*60aa*/, "Que " /*60ab*/, "Xuan " /*60ac*/, "Qian " /*60ad*/, "Wu " /*60ae*/, "Min " /*60af*/, "Cong " /*60b0*/, "Fei " /*60b1*/, "Bei " /*60b2*/, "Duo " /*60b3*/, "Cui " /*60b4*/, "Chang " /*60b5*/, "Men " /*60b6*/, "Li " /*60b7*/, "Ji " /*60b8*/, "Guan " /*60b9*/, "Guan " /*60ba*/, "Xing " /*60bb*/, "Dao " /*60bc*/, "Qi " /*60bd*/, "Kong " /*60be*/, "Tian " /*60bf*/, "Lun " /*60c0*/, "Xi " /*60c1*/, "Kan " /*60c2*/, "Kun " /*60c3*/, "Ni " /*60c4*/, "Qing " /*60c5*/, "Chou " /*60c6*/, "Dun " /*60c7*/, "Guo " /*60c8*/, "Chan " /*60c9*/, "Liang " /*60ca*/, "Wan " /*60cb*/, "Yuan " /*60cc*/, "Jin " /*60cd*/, "Ji " /*60ce*/, "Lin " /*60cf*/, "Yu " /*60d0*/, "Huo " /*60d1*/, "He " /*60d2*/, "Quan " /*60d3*/, "Tan " /*60d4*/, "Ti " /*60d5*/, "Ti " /*60d6*/, "Nie " /*60d7*/, "Wang " /*60d8*/, "Chuo " /*60d9*/, "Bu " /*60da*/, "Hun " /*60db*/, "Xi " /*60dc*/, "Tang " /*60dd*/, "Xin " /*60de*/, "Wei " /*60df*/, "Hui " /*60e0*/, "E " /*60e1*/, "Rui " /*60e2*/, "Zong " /*60e3*/, "Jian " /*60e4*/, "Yong " /*60e5*/, "Dian " /*60e6*/, "Ju " /*60e7*/, "Can " /*60e8*/, "Cheng " /*60e9*/, "De " /*60ea*/, "Bei " /*60eb*/, "Qie " /*60ec*/, "Can " /*60ed*/, "Dan " /*60ee*/, "Guan " /*60ef*/, "Duo " /*60f0*/, "Nao " /*60f1*/, "Yun " /*60f2*/, "Xiang " /*60f3*/, "Zhui " /*60f4*/, "Die " /*60f5*/, "Huang " /*60f6*/, "Chun " /*60f7*/, "Qiong " /*60f8*/, "Re " /*60f9*/, "Xing " /*60fa*/, "Ce " /*60fb*/, "Bian " /*60fc*/, "Hun " /*60fd*/, "Zong " /*60fe*/, "Ti " /*60ff*/ 
			});
						characters.TryAdd(97 /*24832 61*/, new string[] {
				"Qiao " /*6100*/, "Chou " /*6101*/, "Bei " /*6102*/, "Xuan " /*6103*/, "Wei " /*6104*/, "Ge " /*6105*/, "Qian " /*6106*/, "Wei " /*6107*/, "Yu " /*6108*/, "Yu " /*6109*/, "Bi " /*610a*/, "Xuan " /*610b*/, "Huan " /*610c*/, "Min " /*610d*/, "Bi " /*610e*/, "Yi " /*610f*/, "Mian " /*6110*/, "Yong " /*6111*/, "Kai " /*6112*/, "Dang " /*6113*/, "Yin " /*6114*/, "E " /*6115*/, "Chen " /*6116*/, "Mou " /*6117*/, "Ke " /*6118*/, "Ke " /*6119*/, "Yu " /*611a*/, "Ai " /*611b*/, "Qie " /*611c*/, "Yan " /*611d*/, "Nuo " /*611e*/, "Gan " /*611f*/, "Yun " /*6120*/, "Zong " /*6121*/, "Sai " /*6122*/, "Leng " /*6123*/, "Fen " /*6124*/, "[?] " /*6125*/, "Kui " /*6126*/, "Kui " /*6127*/, "Que " /*6128*/, "Gong " /*6129*/, "Yun " /*612a*/, "Su " /*612b*/, "Su " /*612c*/, "Qi " /*612d*/, "Yao " /*612e*/, "Song " /*612f*/, "Huang " /*6130*/, "Ji " /*6131*/, "Gu " /*6132*/, "Ju " /*6133*/, "Chuang " /*6134*/, "Ni " /*6135*/, "Xie " /*6136*/, "Kai " /*6137*/, "Zheng " /*6138*/, "Yong " /*6139*/, "Cao " /*613a*/, "Sun " /*613b*/, "Shen " /*613c*/, "Bo " /*613d*/, "Kai " /*613e*/, "Yuan " /*613f*/, "Xie " /*6140*/, "Hun " /*6141*/, "Yong " /*6142*/, "Yang " /*6143*/, "Li " /*6144*/, "Sao " /*6145*/, "Tao " /*6146*/, "Yin " /*6147*/, "Ci " /*6148*/, "Xu " /*6149*/, "Qian " /*614a*/, "Tai " /*614b*/, "Huang " /*614c*/, "Yun " /*614d*/, "Shen " /*614e*/, "Ming " /*614f*/, "[?] " /*6150*/, "She " /*6151*/, "Cong " /*6152*/, "Piao " /*6153*/, "Mo " /*6154*/, "Mu " /*6155*/, "Guo " /*6156*/, "Chi " /*6157*/, "Can " /*6158*/, "Can " /*6159*/, "Can " /*615a*/, "Cui " /*615b*/, "Min " /*615c*/, "Te " /*615d*/, "Zhang " /*615e*/, "Tong " /*615f*/, "Ao " /*6160*/, "Shuang " /*6161*/, "Man " /*6162*/, "Guan " /*6163*/, "Que " /*6164*/, "Zao " /*6165*/, "Jiu " /*6166*/, "Hui " /*6167*/, "Kai " /*6168*/, "Lian " /*6169*/, "Ou " /*616a*/, "Song " /*616b*/, "Jin " /*616c*/, "Yin " /*616d*/, "Lu " /*616e*/, "Shang " /*616f*/, "Wei " /*6170*/, "Tuan " /*6171*/, "Man " /*6172*/, "Qian " /*6173*/, "She " /*6174*/, "Yong " /*6175*/, "Qing " /*6176*/, "Kang " /*6177*/, "Di " /*6178*/, "Zhi " /*6179*/, "Lou " /*617a*/, "Juan " /*617b*/, "Qi " /*617c*/, "Qi " /*617d*/, "Yu " /*617e*/, "Ping " /*617f*/, "Liao " /*6180*/, "Cong " /*6181*/, "You " /*6182*/, "Chong " /*6183*/, "Zhi " /*6184*/, "Tong " /*6185*/, "Cheng " /*6186*/, "Qi " /*6187*/, "Qu " /*6188*/, "Peng " /*6189*/, "Bei " /*618a*/, "Bie " /*618b*/, "Chun " /*618c*/, "Jiao " /*618d*/, "Zeng " /*618e*/, "Chi " /*618f*/, "Lian " /*6190*/, "Ping " /*6191*/, "Kui " /*6192*/, "Hui " /*6193*/, "Qiao " /*6194*/, "Cheng " /*6195*/, "Yin " /*6196*/, "Yin " /*6197*/, "Xi " /*6198*/, "Xi " /*6199*/, "Dan " /*619a*/, "Tan " /*619b*/, "Duo " /*619c*/, "Dui " /*619d*/, "Dui " /*619e*/, "Su " /*619f*/, "Jue " /*61a0*/, "Ce " /*61a1*/, "Xiao " /*61a2*/, "Fan " /*61a3*/, "Fen " /*61a4*/, "Lao " /*61a5*/, "Lao " /*61a6*/, "Chong " /*61a7*/, "Han " /*61a8*/, "Qi " /*61a9*/, "Xian " /*61aa*/, "Min " /*61ab*/, "Jing " /*61ac*/, "Liao " /*61ad*/, "Wu " /*61ae*/, "Can " /*61af*/, "Jue " /*61b0*/, "Cu " /*61b1*/, "Xian " /*61b2*/, "Tan " /*61b3*/, "Sheng " /*61b4*/, "Pi " /*61b5*/, "Yi " /*61b6*/, "Chu " /*61b7*/, "Xian " /*61b8*/, "Nao " /*61b9*/, "Dan " /*61ba*/, "Tan " /*61bb*/, "Jing " /*61bc*/, "Song " /*61bd*/, "Han " /*61be*/, "Jiao " /*61bf*/, "Wai " /*61c0*/, "Huan " /*61c1*/, "Dong " /*61c2*/, "Qin " /*61c3*/, "Qin " /*61c4*/, "Qu " /*61c5*/, "Cao " /*61c6*/, "Ken " /*61c7*/, "Xie " /*61c8*/, "Ying " /*61c9*/, "Ao " /*61ca*/, "Mao " /*61cb*/, "Yi " /*61cc*/, "Lin " /*61cd*/, "Se " /*61ce*/, "Jun " /*61cf*/, "Huai " /*61d0*/, "Men " /*61d1*/, "Lan " /*61d2*/, "Ai " /*61d3*/, "Lin " /*61d4*/, "Yan " /*61d5*/, "Gua " /*61d6*/, "Xia " /*61d7*/, "Chi " /*61d8*/, "Yu " /*61d9*/, "Yin " /*61da*/, "Dai " /*61db*/, "Meng " /*61dc*/, "Ai " /*61dd*/, "Meng " /*61de*/, "Dui " /*61df*/, "Qi " /*61e0*/, "Mo " /*61e1*/, "Lan " /*61e2*/, "Men " /*61e3*/, "Chou " /*61e4*/, "Zhi " /*61e5*/, "Nuo " /*61e6*/, "Nuo " /*61e7*/, "Yan " /*61e8*/, "Yang " /*61e9*/, "Bo " /*61ea*/, "Zhi " /*61eb*/, "Kuang " /*61ec*/, "Kuang " /*61ed*/, "You " /*61ee*/, "Fu " /*61ef*/, "Liu " /*61f0*/, "Mie " /*61f1*/, "Cheng " /*61f2*/, "[?] " /*61f3*/, "Chan " /*61f4*/, "Meng " /*61f5*/, "Lan " /*61f6*/, "Huai " /*61f7*/, "Xuan " /*61f8*/, "Rang " /*61f9*/, "Chan " /*61fa*/, "Ji " /*61fb*/, "Ju " /*61fc*/, "Huan " /*61fd*/, "She " /*61fe*/, "Yi " /*61ff*/ 
			});
						characters.TryAdd(98 /*25088 62*/, new string[] {
				"Lian " /*6200*/, "Nan " /*6201*/, "Mi " /*6202*/, "Tang " /*6203*/, "Jue " /*6204*/, "Gang " /*6205*/, "Gang " /*6206*/, "Gang " /*6207*/, "Ge " /*6208*/, "Yue " /*6209*/, "Wu " /*620a*/, "Jian " /*620b*/, "Xu " /*620c*/, "Shu " /*620d*/, "Rong " /*620e*/, "Xi " /*620f*/, "Cheng " /*6210*/, "Wo " /*6211*/, "Jie " /*6212*/, "Ge " /*6213*/, "Jian " /*6214*/, "Qiang " /*6215*/, "Huo " /*6216*/, "Qiang " /*6217*/, "Zhan " /*6218*/, "Dong " /*6219*/, "Qi " /*621a*/, "Jia " /*621b*/, "Die " /*621c*/, "Zei " /*621d*/, "Jia " /*621e*/, "Ji " /*621f*/, "Shi " /*6220*/, "Kan " /*6221*/, "Ji " /*6222*/, "Kui " /*6223*/, "Gai " /*6224*/, "Deng " /*6225*/, "Zhan " /*6226*/, "Chuang " /*6227*/, "Ge " /*6228*/, "Jian " /*6229*/, "Jie " /*622a*/, "Yu " /*622b*/, "Jian " /*622c*/, "Yan " /*622d*/, "Lu " /*622e*/, "Xi " /*622f*/, "Zhan " /*6230*/, "Xi " /*6231*/, "Xi " /*6232*/, "Chuo " /*6233*/, "Dai " /*6234*/, "Qu " /*6235*/, "Hu " /*6236*/, "Hu " /*6237*/, "Hu " /*6238*/, "E " /*6239*/, "Shi " /*623a*/, "Li " /*623b*/, "Mao " /*623c*/, "Hu " /*623d*/, "Li " /*623e*/, "Fang " /*623f*/, "Suo " /*6240*/, "Bian " /*6241*/, "Dian " /*6242*/, "Jiong " /*6243*/, "Shang " /*6244*/, "Yi " /*6245*/, "Yi " /*6246*/, "Shan " /*6247*/, "Hu " /*6248*/, "Fei " /*6249*/, "Yan " /*624a*/, "Shou " /*624b*/, "T " /*624c*/, "Cai " /*624d*/, "Zha " /*624e*/, "Qiu " /*624f*/, "Le " /*6250*/, "Bu " /*6251*/, "Ba " /*6252*/, "Da " /*6253*/, "Reng " /*6254*/, "Fu " /*6255*/, "Hameru " /*6256*/, "Zai " /*6257*/, "Tuo " /*6258*/, "Zhang " /*6259*/, "Diao " /*625a*/, "Kang " /*625b*/, "Yu " /*625c*/, "Ku " /*625d*/, "Han " /*625e*/, "Shen " /*625f*/, "Cha " /*6260*/, "Yi " /*6261*/, "Gu " /*6262*/, "Kou " /*6263*/, "Wu " /*6264*/, "Tuo " /*6265*/, "Qian " /*6266*/, "Zhi " /*6267*/, "Ren " /*6268*/, "Kuo " /*6269*/, "Men " /*626a*/, "Sao " /*626b*/, "Yang " /*626c*/, "Niu " /*626d*/, "Ban " /*626e*/, "Che " /*626f*/, "Rao " /*6270*/, "Xi " /*6271*/, "Qian " /*6272*/, "Ban " /*6273*/, "Jia " /*6274*/, "Yu " /*6275*/, "Fu " /*6276*/, "Ao " /*6277*/, "Xi " /*6278*/, "Pi " /*6279*/, "Zhi " /*627a*/, "Zi " /*627b*/, "E " /*627c*/, "Dun " /*627d*/, "Zhao " /*627e*/, "Cheng " /*627f*/, "Ji " /*6280*/, "Yan " /*6281*/, "Kuang " /*6282*/, "Bian " /*6283*/, "Chao " /*6284*/, "Ju " /*6285*/, "Wen " /*6286*/, "Hu " /*6287*/, "Yue " /*6288*/, "Jue " /*6289*/, "Ba " /*628a*/, "Qin " /*628b*/, "Zhen " /*628c*/, "Zheng " /*628d*/, "Yun " /*628e*/, "Wan " /*628f*/, "Nu " /*6290*/, "Yi " /*6291*/, "Shu " /*6292*/, "Zhua " /*6293*/, "Pou " /*6294*/, "Tou " /*6295*/, "Dou " /*6296*/, "Kang " /*6297*/, "Zhe " /*6298*/, "Pou " /*6299*/, "Fu " /*629a*/, "Pao " /*629b*/, "Ba " /*629c*/, "Ao " /*629d*/, "Ze " /*629e*/, "Tuan " /*629f*/, "Kou " /*62a0*/, "Lun " /*62a1*/, "Qiang " /*62a2*/, "[?] " /*62a3*/, "Hu " /*62a4*/, "Bao " /*62a5*/, "Bing " /*62a6*/, "Zhi " /*62a7*/, "Peng " /*62a8*/, "Tan " /*62a9*/, "Pu " /*62aa*/, "Pi " /*62ab*/, "Tai " /*62ac*/, "Yao " /*62ad*/, "Zhen " /*62ae*/, "Zha " /*62af*/, "Yang " /*62b0*/, "Bao " /*62b1*/, "He " /*62b2*/, "Ni " /*62b3*/, "Yi " /*62b4*/, "Di " /*62b5*/, "Chi " /*62b6*/, "Pi " /*62b7*/, "Za " /*62b8*/, "Mo " /*62b9*/, "Mo " /*62ba*/, "Shen " /*62bb*/, "Ya " /*62bc*/, "Chou " /*62bd*/, "Qu " /*62be*/, "Min " /*62bf*/, "Chu " /*62c0*/, "Jia " /*62c1*/, "Fu " /*62c2*/, "Zhan " /*62c3*/, "Zhu " /*62c4*/, "Dan " /*62c5*/, "Chai " /*62c6*/, "Mu " /*62c7*/, "Nian " /*62c8*/, "La " /*62c9*/, "Fu " /*62ca*/, "Pao " /*62cb*/, "Ban " /*62cc*/, "Pai " /*62cd*/, "Ling " /*62ce*/, "Na " /*62cf*/, "Guai " /*62d0*/, "Qian " /*62d1*/, "Ju " /*62d2*/, "Tuo " /*62d3*/, "Ba " /*62d4*/, "Tuo " /*62d5*/, "Tuo " /*62d6*/, "Ao " /*62d7*/, "Ju " /*62d8*/, "Zhuo " /*62d9*/, "Pan " /*62da*/, "Zhao " /*62db*/, "Bai " /*62dc*/, "Bai " /*62dd*/, "Di " /*62de*/, "Ni " /*62df*/, "Ju " /*62e0*/, "Kuo " /*62e1*/, "Long " /*62e2*/, "Jian " /*62e3*/, "[?] " /*62e4*/, "Yong " /*62e5*/, "Lan " /*62e6*/, "Ning " /*62e7*/, "Bo " /*62e8*/, "Ze " /*62e9*/, "Qian " /*62ea*/, "Hen " /*62eb*/, "Gua " /*62ec*/, "Shi " /*62ed*/, "Jie " /*62ee*/, "Zheng " /*62ef*/, "Nin " /*62f0*/, "Gong " /*62f1*/, "Gong " /*62f2*/, "Quan " /*62f3*/, "Shuan " /*62f4*/, "Cun " /*62f5*/, "Zan " /*62f6*/, "Kao " /*62f7*/, "Chi " /*62f8*/, "Xie " /*62f9*/, "Ce " /*62fa*/, "Hui " /*62fb*/, "Pin " /*62fc*/, "Zhuai " /*62fd*/, "Shi " /*62fe*/, "Na " /*62ff*/ 
			});
						characters.TryAdd(99 /*25344 63*/, new string[] {
				"Bo " /*6300*/, "Chi " /*6301*/, "Gua " /*6302*/, "Zhi " /*6303*/, "Kuo " /*6304*/, "Duo " /*6305*/, "Duo " /*6306*/, "Zhi " /*6307*/, "Qie " /*6308*/, "An " /*6309*/, "Nong " /*630a*/, "Zhen " /*630b*/, "Ge " /*630c*/, "Jiao " /*630d*/, "Ku " /*630e*/, "Dong " /*630f*/, "Ru " /*6310*/, "Tiao " /*6311*/, "Lie " /*6312*/, "Zha " /*6313*/, "Lu " /*6314*/, "Die " /*6315*/, "Wa " /*6316*/, "Jue " /*6317*/, "Mushiru " /*6318*/, "Ju " /*6319*/, "Zhi " /*631a*/, "Luan " /*631b*/, "Ya " /*631c*/, "Zhua " /*631d*/, "Ta " /*631e*/, "Xie " /*631f*/, "Nao " /*6320*/, "Dang " /*6321*/, "Jiao " /*6322*/, "Zheng " /*6323*/, "Ji " /*6324*/, "Hui " /*6325*/, "Xun " /*6326*/, "Ku " /*6327*/, "Ai " /*6328*/, "Tuo " /*6329*/, "Nuo " /*632a*/, "Cuo " /*632b*/, "Bo " /*632c*/, "Geng " /*632d*/, "Ti " /*632e*/, "Zhen " /*632f*/, "Cheng " /*6330*/, "Suo " /*6331*/, "Suo " /*6332*/, "Keng " /*6333*/, "Mei " /*6334*/, "Long " /*6335*/, "Ju " /*6336*/, "Peng " /*6337*/, "Jian " /*6338*/, "Yi " /*6339*/, "Ting " /*633a*/, "Shan " /*633b*/, "Nuo " /*633c*/, "Wan " /*633d*/, "Xie " /*633e*/, "Cha " /*633f*/, "Feng " /*6340*/, "Jiao " /*6341*/, "Wu " /*6342*/, "Jun " /*6343*/, "Jiu " /*6344*/, "Tong " /*6345*/, "Kun " /*6346*/, "Huo " /*6347*/, "Tu " /*6348*/, "Zhuo " /*6349*/, "Pou " /*634a*/, "Le " /*634b*/, "Ba " /*634c*/, "Han " /*634d*/, "Shao " /*634e*/, "Nie " /*634f*/, "Juan " /*6350*/, "Ze " /*6351*/, "Song " /*6352*/, "Ye " /*6353*/, "Jue " /*6354*/, "Bu " /*6355*/, "Huan " /*6356*/, "Bu " /*6357*/, "Zun " /*6358*/, "Yi " /*6359*/, "Zhai " /*635a*/, "Lu " /*635b*/, "Sou " /*635c*/, "Tuo " /*635d*/, "Lao " /*635e*/, "Sun " /*635f*/, "Bang " /*6360*/, "Jian " /*6361*/, "Huan " /*6362*/, "Dao " /*6363*/, "[?] " /*6364*/, "Wan " /*6365*/, "Qin " /*6366*/, "Peng " /*6367*/, "She " /*6368*/, "Lie " /*6369*/, "Min " /*636a*/, "Men " /*636b*/, "Fu " /*636c*/, "Bai " /*636d*/, "Ju " /*636e*/, "Dao " /*636f*/, "Wo " /*6370*/, "Ai " /*6371*/, "Juan " /*6372*/, "Yue " /*6373*/, "Zong " /*6374*/, "Chen " /*6375*/, "Chui " /*6376*/, "Jie " /*6377*/, "Tu " /*6378*/, "Ben " /*6379*/, "Na " /*637a*/, "Nian " /*637b*/, "Nuo " /*637c*/, "Zu " /*637d*/, "Wo " /*637e*/, "Xi " /*637f*/, "Xian " /*6380*/, "Cheng " /*6381*/, "Dian " /*6382*/, "Sao " /*6383*/, "Lun " /*6384*/, "Qing " /*6385*/, "Gang " /*6386*/, "Duo " /*6387*/, "Shou " /*6388*/, "Diao " /*6389*/, "Pou " /*638a*/, "Di " /*638b*/, "Zhang " /*638c*/, "Gun " /*638d*/, "Ji " /*638e*/, "Tao " /*638f*/, "Qia " /*6390*/, "Qi " /*6391*/, "Pai " /*6392*/, "Shu " /*6393*/, "Qian " /*6394*/, "Ling " /*6395*/, "Yi " /*6396*/, "Ya " /*6397*/, "Jue " /*6398*/, "Zheng " /*6399*/, "Liang " /*639a*/, "Gua " /*639b*/, "Yi " /*639c*/, "Huo " /*639d*/, "Shan " /*639e*/, "Zheng " /*639f*/, "Lue " /*63a0*/, "Cai " /*63a1*/, "Tan " /*63a2*/, "Che " /*63a3*/, "Bing " /*63a4*/, "Jie " /*63a5*/, "Ti " /*63a6*/, "Kong " /*63a7*/, "Tui " /*63a8*/, "Yan " /*63a9*/, "Cuo " /*63aa*/, "Zou " /*63ab*/, "Ju " /*63ac*/, "Tian " /*63ad*/, "Qian " /*63ae*/, "Ken " /*63af*/, "Bai " /*63b0*/, "Shou " /*63b1*/, "Jie " /*63b2*/, "Lu " /*63b3*/, "Guo " /*63b4*/, "Haba " /*63b5*/, "[?] " /*63b6*/, "Zhi " /*63b7*/, "Dan " /*63b8*/, "Mang " /*63b9*/, "Xian " /*63ba*/, "Sao " /*63bb*/, "Guan " /*63bc*/, "Peng " /*63bd*/, "Yuan " /*63be*/, "Nuo " /*63bf*/, "Jian " /*63c0*/, "Zhen " /*63c1*/, "Jiu " /*63c2*/, "Jian " /*63c3*/, "Yu " /*63c4*/, "Yan " /*63c5*/, "Kui " /*63c6*/, "Nan " /*63c7*/, "Hong " /*63c8*/, "Rou " /*63c9*/, "Pi " /*63ca*/, "Wei " /*63cb*/, "Sai " /*63cc*/, "Zou " /*63cd*/, "Xuan " /*63ce*/, "Miao " /*63cf*/, "Ti " /*63d0*/, "Nie " /*63d1*/, "Cha " /*63d2*/, "Shi " /*63d3*/, "Zong " /*63d4*/, "Zhen " /*63d5*/, "Yi " /*63d6*/, "Shun " /*63d7*/, "Heng " /*63d8*/, "Bian " /*63d9*/, "Yang " /*63da*/, "Huan " /*63db*/, "Yan " /*63dc*/, "Zuan " /*63dd*/, "An " /*63de*/, "Xu " /*63df*/, "Ya " /*63e0*/, "Wo " /*63e1*/, "Ke " /*63e2*/, "Chuai " /*63e3*/, "Ji " /*63e4*/, "Ti " /*63e5*/, "La " /*63e6*/, "La " /*63e7*/, "Cheng " /*63e8*/, "Kai " /*63e9*/, "Jiu " /*63ea*/, "Jiu " /*63eb*/, "Tu " /*63ec*/, "Jie " /*63ed*/, "Hui " /*63ee*/, "Geng " /*63ef*/, "Chong " /*63f0*/, "Shuo " /*63f1*/, "She " /*63f2*/, "Xie " /*63f3*/, "Yuan " /*63f4*/, "Qian " /*63f5*/, "Ye " /*63f6*/, "Cha " /*63f7*/, "Zha " /*63f8*/, "Bei " /*63f9*/, "Yao " /*63fa*/, "[?] " /*63fb*/, "[?] " /*63fc*/, "Lan " /*63fd*/, "Wen " /*63fe*/, "Qin " /*63ff*/ 
			});
						characters.TryAdd(100 /*25600 64*/, new string[] {
				"Chan " /*6400*/, "Ge " /*6401*/, "Lou " /*6402*/, "Zong " /*6403*/, "Geng " /*6404*/, "Jiao " /*6405*/, "Gou " /*6406*/, "Qin " /*6407*/, "Yong " /*6408*/, "Que " /*6409*/, "Chou " /*640a*/, "Chi " /*640b*/, "Zhan " /*640c*/, "Sun " /*640d*/, "Sun " /*640e*/, "Bo " /*640f*/, "Chu " /*6410*/, "Rong " /*6411*/, "Beng " /*6412*/, "Cuo " /*6413*/, "Sao " /*6414*/, "Ke " /*6415*/, "Yao " /*6416*/, "Dao " /*6417*/, "Zhi " /*6418*/, "Nu " /*6419*/, "Xie " /*641a*/, "Jian " /*641b*/, "Sou " /*641c*/, "Qiu " /*641d*/, "Gao " /*641e*/, "Xian " /*641f*/, "Shuo " /*6420*/, "Sang " /*6421*/, "Jin " /*6422*/, "Mie " /*6423*/, "E " /*6424*/, "Chui " /*6425*/, "Nuo " /*6426*/, "Shan " /*6427*/, "Ta " /*6428*/, "Jie " /*6429*/, "Tang " /*642a*/, "Pan " /*642b*/, "Ban " /*642c*/, "Da " /*642d*/, "Li " /*642e*/, "Tao " /*642f*/, "Hu " /*6430*/, "Zhi " /*6431*/, "Wa " /*6432*/, "Xia " /*6433*/, "Qian " /*6434*/, "Wen " /*6435*/, "Qiang " /*6436*/, "Tian " /*6437*/, "Zhen " /*6438*/, "E " /*6439*/, "Xi " /*643a*/, "Nuo " /*643b*/, "Quan " /*643c*/, "Cha " /*643d*/, "Zha " /*643e*/, "Ge " /*643f*/, "Wu " /*6440*/, "En " /*6441*/, "She " /*6442*/, "Kang " /*6443*/, "She " /*6444*/, "Shu " /*6445*/, "Bai " /*6446*/, "Yao " /*6447*/, "Bin " /*6448*/, "Sou " /*6449*/, "Tan " /*644a*/, "Sa " /*644b*/, "Chan " /*644c*/, "Suo " /*644d*/, "Liao " /*644e*/, "Chong " /*644f*/, "Chuang " /*6450*/, "Guo " /*6451*/, "Bing " /*6452*/, "Feng " /*6453*/, "Shuai " /*6454*/, "Di " /*6455*/, "Qi " /*6456*/, "Sou " /*6457*/, "Zhai " /*6458*/, "Lian " /*6459*/, "Tang " /*645a*/, "Chi " /*645b*/, "Guan " /*645c*/, "Lu " /*645d*/, "Luo " /*645e*/, "Lou " /*645f*/, "Zong " /*6460*/, "Gai " /*6461*/, "Hu " /*6462*/, "Zha " /*6463*/, "Chuang " /*6464*/, "Tang " /*6465*/, "Hua " /*6466*/, "Cui " /*6467*/, "Nai " /*6468*/, "Mo " /*6469*/, "Jiang " /*646a*/, "Gui " /*646b*/, "Ying " /*646c*/, "Zhi " /*646d*/, "Ao " /*646e*/, "Zhi " /*646f*/, "Nie " /*6470*/, "Man " /*6471*/, "Shan " /*6472*/, "Kou " /*6473*/, "Shu " /*6474*/, "Suo " /*6475*/, "Tuan " /*6476*/, "Jiao " /*6477*/, "Mo " /*6478*/, "Mo " /*6479*/, "Zhe " /*647a*/, "Xian " /*647b*/, "Keng " /*647c*/, "Piao " /*647d*/, "Jiang " /*647e*/, "Yin " /*647f*/, "Gou " /*6480*/, "Qian " /*6481*/, "Lue " /*6482*/, "Ji " /*6483*/, "Ying " /*6484*/, "Jue " /*6485*/, "Pie " /*6486*/, "Pie " /*6487*/, "Lao " /*6488*/, "Dun " /*6489*/, "Xian " /*648a*/, "Ruan " /*648b*/, "Kui " /*648c*/, "Zan " /*648d*/, "Yi " /*648e*/, "Xun " /*648f*/, "Cheng " /*6490*/, "Cheng " /*6491*/, "Sa " /*6492*/, "Nao " /*6493*/, "Heng " /*6494*/, "Si " /*6495*/, "Qian " /*6496*/, "Huang " /*6497*/, "Da " /*6498*/, "Zun " /*6499*/, "Nian " /*649a*/, "Lin " /*649b*/, "Zheng " /*649c*/, "Hui " /*649d*/, "Zhuang " /*649e*/, "Jiao " /*649f*/, "Ji " /*64a0*/, "Cao " /*64a1*/, "Dan " /*64a2*/, "Dan " /*64a3*/, "Che " /*64a4*/, "Bo " /*64a5*/, "Che " /*64a6*/, "Jue " /*64a7*/, "Xiao " /*64a8*/, "Liao " /*64a9*/, "Ben " /*64aa*/, "Fu " /*64ab*/, "Qiao " /*64ac*/, "Bo " /*64ad*/, "Cuo " /*64ae*/, "Zhuo " /*64af*/, "Zhuan " /*64b0*/, "Tuo " /*64b1*/, "Pu " /*64b2*/, "Qin " /*64b3*/, "Dun " /*64b4*/, "Nian " /*64b5*/, "[?] " /*64b6*/, "Xie " /*64b7*/, "Lu " /*64b8*/, "Jiao " /*64b9*/, "Cuan " /*64ba*/, "Ta " /*64bb*/, "Han " /*64bc*/, "Qiao " /*64bd*/, "Zhua " /*64be*/, "Jian " /*64bf*/, "Gan " /*64c0*/, "Yong " /*64c1*/, "Lei " /*64c2*/, "Kuo " /*64c3*/, "Lu " /*64c4*/, "Shan " /*64c5*/, "Zhuo " /*64c6*/, "Ze " /*64c7*/, "Pu " /*64c8*/, "Chuo " /*64c9*/, "Ji " /*64ca*/, "Dang " /*64cb*/, "Suo " /*64cc*/, "Cao " /*64cd*/, "Qing " /*64ce*/, "Jing " /*64cf*/, "Huan " /*64d0*/, "Jie " /*64d1*/, "Qin " /*64d2*/, "Kuai " /*64d3*/, "Dan " /*64d4*/, "Xi " /*64d5*/, "Ge " /*64d6*/, "Pi " /*64d7*/, "Bo " /*64d8*/, "Ao " /*64d9*/, "Ju " /*64da*/, "Ye " /*64db*/, "[?] " /*64dc*/, "Mang " /*64dd*/, "Sou " /*64de*/, "Mi " /*64df*/, "Ji " /*64e0*/, "Tai " /*64e1*/, "Zhuo " /*64e2*/, "Dao " /*64e3*/, "Xing " /*64e4*/, "Lan " /*64e5*/, "Ca " /*64e6*/, "Ju " /*64e7*/, "Ye " /*64e8*/, "Ru " /*64e9*/, "Ye " /*64ea*/, "Ye " /*64eb*/, "Ni " /*64ec*/, "Hu " /*64ed*/, "Ji " /*64ee*/, "Bin " /*64ef*/, "Ning " /*64f0*/, "Ge " /*64f1*/, "Zhi " /*64f2*/, "Jie " /*64f3*/, "Kuo " /*64f4*/, "Mo " /*64f5*/, "Jian " /*64f6*/, "Xie " /*64f7*/, "Lie " /*64f8*/, "Tan " /*64f9*/, "Bai " /*64fa*/, "Sou " /*64fb*/, "Lu " /*64fc*/, "Lue " /*64fd*/, "Rao " /*64fe*/, "Zhi " /*64ff*/ 
			});
						characters.TryAdd(101 /*25856 65*/, new string[] {
				"Pan " /*6500*/, "Yang " /*6501*/, "Lei " /*6502*/, "Sa " /*6503*/, "Shu " /*6504*/, "Zan " /*6505*/, "Nian " /*6506*/, "Xian " /*6507*/, "Jun " /*6508*/, "Huo " /*6509*/, "Li " /*650a*/, "La " /*650b*/, "Han " /*650c*/, "Ying " /*650d*/, "Lu " /*650e*/, "Long " /*650f*/, "Qian " /*6510*/, "Qian " /*6511*/, "Zan " /*6512*/, "Qian " /*6513*/, "Lan " /*6514*/, "San " /*6515*/, "Ying " /*6516*/, "Mei " /*6517*/, "Rang " /*6518*/, "Chan " /*6519*/, "[?] " /*651a*/, "Cuan " /*651b*/, "Xi " /*651c*/, "She " /*651d*/, "Luo " /*651e*/, "Jun " /*651f*/, "Mi " /*6520*/, "Li " /*6521*/, "Zan " /*6522*/, "Luan " /*6523*/, "Tan " /*6524*/, "Zuan " /*6525*/, "Li " /*6526*/, "Dian " /*6527*/, "Wa " /*6528*/, "Dang " /*6529*/, "Jiao " /*652a*/, "Jue " /*652b*/, "Lan " /*652c*/, "Li " /*652d*/, "Nang " /*652e*/, "Zhi " /*652f*/, "Gui " /*6530*/, "Gui " /*6531*/, "Qi " /*6532*/, "Xin " /*6533*/, "Pu " /*6534*/, "Sui " /*6535*/, "Shou " /*6536*/, "Kao " /*6537*/, "You " /*6538*/, "Gai " /*6539*/, "Yi " /*653a*/, "Gong " /*653b*/, "Gan " /*653c*/, "Ban " /*653d*/, "Fang " /*653e*/, "Zheng " /*653f*/, "Bo " /*6540*/, "Dian " /*6541*/, "Kou " /*6542*/, "Min " /*6543*/, "Wu " /*6544*/, "Gu " /*6545*/, "He " /*6546*/, "Ce " /*6547*/, "Xiao " /*6548*/, "Mi " /*6549*/, "Chu " /*654a*/, "Ge " /*654b*/, "Di " /*654c*/, "Xu " /*654d*/, "Jiao " /*654e*/, "Min " /*654f*/, "Chen " /*6550*/, "Jiu " /*6551*/, "Zhen " /*6552*/, "Duo " /*6553*/, "Yu " /*6554*/, "Chi " /*6555*/, "Ao " /*6556*/, "Bai " /*6557*/, "Xu " /*6558*/, "Jiao " /*6559*/, "Duo " /*655a*/, "Lian " /*655b*/, "Nie " /*655c*/, "Bi " /*655d*/, "Chang " /*655e*/, "Dian " /*655f*/, "Duo " /*6560*/, "Yi " /*6561*/, "Gan " /*6562*/, "San " /*6563*/, "Ke " /*6564*/, "Yan " /*6565*/, "Dun " /*6566*/, "Qi " /*6567*/, "Dou " /*6568*/, "Xiao " /*6569*/, "Duo " /*656a*/, "Jiao " /*656b*/, "Jing " /*656c*/, "Yang " /*656d*/, "Xia " /*656e*/, "Min " /*656f*/, "Shu " /*6570*/, "Ai " /*6571*/, "Qiao " /*6572*/, "Ai " /*6573*/, "Zheng " /*6574*/, "Di " /*6575*/, "Zhen " /*6576*/, "Fu " /*6577*/, "Shu " /*6578*/, "Liao " /*6579*/, "Qu " /*657a*/, "Xiong " /*657b*/, "Xi " /*657c*/, "Jiao " /*657d*/, "Sen " /*657e*/, "Jiao " /*657f*/, "Zhuo " /*6580*/, "Yi " /*6581*/, "Lian " /*6582*/, "Bi " /*6583*/, "Li " /*6584*/, "Xiao " /*6585*/, "Xiao " /*6586*/, "Wen " /*6587*/, "Xue " /*6588*/, "Qi " /*6589*/, "Qi " /*658a*/, "Zhai " /*658b*/, "Bin " /*658c*/, "Jue " /*658d*/, "Zhai " /*658e*/, "[?] " /*658f*/, "Fei " /*6590*/, "Ban " /*6591*/, "Ban " /*6592*/, "Lan " /*6593*/, "Yu " /*6594*/, "Lan " /*6595*/, "Wei " /*6596*/, "Dou " /*6597*/, "Sheng " /*6598*/, "Liao " /*6599*/, "Jia " /*659a*/, "Hu " /*659b*/, "Xie " /*659c*/, "Jia " /*659d*/, "Yu " /*659e*/, "Zhen " /*659f*/, "Jiao " /*65a0*/, "Wo " /*65a1*/, "Tou " /*65a2*/, "Chu " /*65a3*/, "Jin " /*65a4*/, "Chi " /*65a5*/, "Yin " /*65a6*/, "Fu " /*65a7*/, "Qiang " /*65a8*/, "Zhan " /*65a9*/, "Qu " /*65aa*/, "Zhuo " /*65ab*/, "Zhan " /*65ac*/, "Duan " /*65ad*/, "Zhuo " /*65ae*/, "Si " /*65af*/, "Xin " /*65b0*/, "Zhuo " /*65b1*/, "Zhuo " /*65b2*/, "Qin " /*65b3*/, "Lin " /*65b4*/, "Zhuo " /*65b5*/, "Chu " /*65b6*/, "Duan " /*65b7*/, "Zhu " /*65b8*/, "Fang " /*65b9*/, "Xie " /*65ba*/, "Hang " /*65bb*/, "Yu " /*65bc*/, "Shi " /*65bd*/, "Pei " /*65be*/, "You " /*65bf*/, "Mye " /*65c0*/, "Pang " /*65c1*/, "Qi " /*65c2*/, "Zhan " /*65c3*/, "Mao " /*65c4*/, "Lu " /*65c5*/, "Pei " /*65c6*/, "Pi " /*65c7*/, "Liu " /*65c8*/, "Fu " /*65c9*/, "Fang " /*65ca*/, "Xuan " /*65cb*/, "Jing " /*65cc*/, "Jing " /*65cd*/, "Ni " /*65ce*/, "Zu " /*65cf*/, "Zhao " /*65d0*/, "Yi " /*65d1*/, "Liu " /*65d2*/, "Shao " /*65d3*/, "Jian " /*65d4*/, "Es " /*65d5*/, "Yi " /*65d6*/, "Qi " /*65d7*/, "Zhi " /*65d8*/, "Fan " /*65d9*/, "Piao " /*65da*/, "Fan " /*65db*/, "Zhan " /*65dc*/, "Guai " /*65dd*/, "Sui " /*65de*/, "Yu " /*65df*/, "Wu " /*65e0*/, "Ji " /*65e1*/, "Ji " /*65e2*/, "Ji " /*65e3*/, "Huo " /*65e4*/, "Ri " /*65e5*/, "Dan " /*65e6*/, "Jiu " /*65e7*/, "Zhi " /*65e8*/, "Zao " /*65e9*/, "Xie " /*65ea*/, "Tiao " /*65eb*/, "Xun " /*65ec*/, "Xu " /*65ed*/, "Xu " /*65ee*/, "Xu " /*65ef*/, "Gan " /*65f0*/, "Han " /*65f1*/, "Tai " /*65f2*/, "Di " /*65f3*/, "Xu " /*65f4*/, "Chan " /*65f5*/, "Shi " /*65f6*/, "Kuang " /*65f7*/, "Yang " /*65f8*/, "Shi " /*65f9*/, "Wang " /*65fa*/, "Min " /*65fb*/, "Min " /*65fc*/, "Tun " /*65fd*/, "Chun " /*65fe*/, "Wu " /*65ff*/ 
			});
						characters.TryAdd(102 /*26112 66*/, new string[] {
				"Yun " /*6600*/, "Bei " /*6601*/, "Ang " /*6602*/, "Ze " /*6603*/, "Ban " /*6604*/, "Jie " /*6605*/, "Kun " /*6606*/, "Sheng " /*6607*/, "Hu " /*6608*/, "Fang " /*6609*/, "Hao " /*660a*/, "Gui " /*660b*/, "Chang " /*660c*/, "Xuan " /*660d*/, "Ming " /*660e*/, "Hun " /*660f*/, "Fen " /*6610*/, "Qin " /*6611*/, "Hu " /*6612*/, "Yi " /*6613*/, "Xi " /*6614*/, "Xin " /*6615*/, "Yan " /*6616*/, "Ze " /*6617*/, "Fang " /*6618*/, "Tan " /*6619*/, "Shen " /*661a*/, "Ju " /*661b*/, "Yang " /*661c*/, "Zan " /*661d*/, "Bing " /*661e*/, "Xing " /*661f*/, "Ying " /*6620*/, "Xuan " /*6621*/, "Pei " /*6622*/, "Zhen " /*6623*/, "Ling " /*6624*/, "Chun " /*6625*/, "Hao " /*6626*/, "Mei " /*6627*/, "Zuo " /*6628*/, "Mo " /*6629*/, "Bian " /*662a*/, "Xu " /*662b*/, "Hun " /*662c*/, "Zhao " /*662d*/, "Zong " /*662e*/, "Shi " /*662f*/, "Shi " /*6630*/, "Yu " /*6631*/, "Fei " /*6632*/, "Die " /*6633*/, "Mao " /*6634*/, "Ni " /*6635*/, "Chang " /*6636*/, "Wen " /*6637*/, "Dong " /*6638*/, "Ai " /*6639*/, "Bing " /*663a*/, "Ang " /*663b*/, "Zhou " /*663c*/, "Long " /*663d*/, "Xian " /*663e*/, "Kuang " /*663f*/, "Tiao " /*6640*/, "Chao " /*6641*/, "Shi " /*6642*/, "Huang " /*6643*/, "Huang " /*6644*/, "Xuan " /*6645*/, "Kui " /*6646*/, "Xu " /*6647*/, "Jiao " /*6648*/, "Jin " /*6649*/, "Zhi " /*664a*/, "Jin " /*664b*/, "Shang " /*664c*/, "Tong " /*664d*/, "Hong " /*664e*/, "Yan " /*664f*/, "Gai " /*6650*/, "Xiang " /*6651*/, "Shai " /*6652*/, "Xiao " /*6653*/, "Ye " /*6654*/, "Yun " /*6655*/, "Hui " /*6656*/, "Han " /*6657*/, "Han " /*6658*/, "Jun " /*6659*/, "Wan " /*665a*/, "Xian " /*665b*/, "Kun " /*665c*/, "Zhou " /*665d*/, "Xi " /*665e*/, "Cheng " /*665f*/, "Sheng " /*6660*/, "Bu " /*6661*/, "Zhe " /*6662*/, "Zhe " /*6663*/, "Wu " /*6664*/, "Han " /*6665*/, "Hui " /*6666*/, "Hao " /*6667*/, "Chen " /*6668*/, "Wan " /*6669*/, "Tian " /*666a*/, "Zhuo " /*666b*/, "Zui " /*666c*/, "Zhou " /*666d*/, "Pu " /*666e*/, "Jing " /*666f*/, "Xi " /*6670*/, "Shan " /*6671*/, "Yi " /*6672*/, "Xi " /*6673*/, "Qing " /*6674*/, "Qi " /*6675*/, "Jing " /*6676*/, "Gui " /*6677*/, "Zhen " /*6678*/, "Yi " /*6679*/, "Zhi " /*667a*/, "An " /*667b*/, "Wan " /*667c*/, "Lin " /*667d*/, "Liang " /*667e*/, "Chang " /*667f*/, "Wang " /*6680*/, "Xiao " /*6681*/, "Zan " /*6682*/, "Hi " /*6683*/, "Xuan " /*6684*/, "Xuan " /*6685*/, "Yi " /*6686*/, "Xia " /*6687*/, "Yun " /*6688*/, "Hui " /*6689*/, "Fu " /*668a*/, "Min " /*668b*/, "Kui " /*668c*/, "He " /*668d*/, "Ying " /*668e*/, "Du " /*668f*/, "Wei " /*6690*/, "Shu " /*6691*/, "Qing " /*6692*/, "Mao " /*6693*/, "Nan " /*6694*/, "Jian " /*6695*/, "Nuan " /*6696*/, "An " /*6697*/, "Yang " /*6698*/, "Chun " /*6699*/, "Yao " /*669a*/, "Suo " /*669b*/, "Jin " /*669c*/, "Ming " /*669d*/, "Jiao " /*669e*/, "Kai " /*669f*/, "Gao " /*66a0*/, "Weng " /*66a1*/, "Chang " /*66a2*/, "Qi " /*66a3*/, "Hao " /*66a4*/, "Yan " /*66a5*/, "Li " /*66a6*/, "Ai " /*66a7*/, "Ji " /*66a8*/, "Gui " /*66a9*/, "Men " /*66aa*/, "Zan " /*66ab*/, "Xie " /*66ac*/, "Hao " /*66ad*/, "Mu " /*66ae*/, "Mo " /*66af*/, "Cong " /*66b0*/, "Ni " /*66b1*/, "Zhang " /*66b2*/, "Hui " /*66b3*/, "Bao " /*66b4*/, "Han " /*66b5*/, "Xuan " /*66b6*/, "Chuan " /*66b7*/, "Liao " /*66b8*/, "Xian " /*66b9*/, "Dan " /*66ba*/, "Jing " /*66bb*/, "Pie " /*66bc*/, "Lin " /*66bd*/, "Tun " /*66be*/, "Xi " /*66bf*/, "Yi " /*66c0*/, "Ji " /*66c1*/, "Huang " /*66c2*/, "Tai " /*66c3*/, "Ye " /*66c4*/, "Ye " /*66c5*/, "Li " /*66c6*/, "Tan " /*66c7*/, "Tong " /*66c8*/, "Xiao " /*66c9*/, "Fei " /*66ca*/, "Qin " /*66cb*/, "Zhao " /*66cc*/, "Hao " /*66cd*/, "Yi " /*66ce*/, "Xiang " /*66cf*/, "Xing " /*66d0*/, "Sen " /*66d1*/, "Jiao " /*66d2*/, "Bao " /*66d3*/, "Jing " /*66d4*/, "Yian " /*66d5*/, "Ai " /*66d6*/, "Ye " /*66d7*/, "Ru " /*66d8*/, "Shu " /*66d9*/, "Meng " /*66da*/, "Xun " /*66db*/, "Yao " /*66dc*/, "Pu " /*66dd*/, "Li " /*66de*/, "Chen " /*66df*/, "Kuang " /*66e0*/, "Die " /*66e1*/, "[?] " /*66e2*/, "Yan " /*66e3*/, "Huo " /*66e4*/, "Lu " /*66e5*/, "Xi " /*66e6*/, "Rong " /*66e7*/, "Long " /*66e8*/, "Nang " /*66e9*/, "Luo " /*66ea*/, "Luan " /*66eb*/, "Shai " /*66ec*/, "Tang " /*66ed*/, "Yan " /*66ee*/, "Chu " /*66ef*/, "Yue " /*66f0*/, "Yue " /*66f1*/, "Qu " /*66f2*/, "Yi " /*66f3*/, "Geng " /*66f4*/, "Ye " /*66f5*/, "Hu " /*66f6*/, "He " /*66f7*/, "Shu " /*66f8*/, "Cao " /*66f9*/, "Cao " /*66fa*/, "Noboru " /*66fb*/, "Man " /*66fc*/, "Ceng " /*66fd*/, "Ceng " /*66fe*/, "Ti " /*66ff*/ 
			});
						characters.TryAdd(103 /*26368 67*/, new string[] {
				"Zui " /*6700*/, "Can " /*6701*/, "Xu " /*6702*/, "Hui " /*6703*/, "Yin " /*6704*/, "Qie " /*6705*/, "Fen " /*6706*/, "Pi " /*6707*/, "Yue " /*6708*/, "You " /*6709*/, "Ruan " /*670a*/, "Peng " /*670b*/, "Ban " /*670c*/, "Fu " /*670d*/, "Ling " /*670e*/, "Fei " /*670f*/, "Qu " /*6710*/, "[?] " /*6711*/, "Nu " /*6712*/, "Tiao " /*6713*/, "Shuo " /*6714*/, "Zhen " /*6715*/, "Lang " /*6716*/, "Lang " /*6717*/, "Juan " /*6718*/, "Ming " /*6719*/, "Huang " /*671a*/, "Wang " /*671b*/, "Tun " /*671c*/, "Zhao " /*671d*/, "Ji " /*671e*/, "Qi " /*671f*/, "Ying " /*6720*/, "Zong " /*6721*/, "Wang " /*6722*/, "Tong " /*6723*/, "Lang " /*6724*/, "[?] " /*6725*/, "Meng " /*6726*/, "Long " /*6727*/, "Mu " /*6728*/, "Deng " /*6729*/, "Wei " /*672a*/, "Mo " /*672b*/, "Ben " /*672c*/, "Zha " /*672d*/, "Zhu " /*672e*/, "Zhu " /*672f*/, "[?] " /*6730*/, "Zhu " /*6731*/, "Ren " /*6732*/, "Ba " /*6733*/, "Po " /*6734*/, "Duo " /*6735*/, "Duo " /*6736*/, "Dao " /*6737*/, "Li " /*6738*/, "Qiu " /*6739*/, "Ji " /*673a*/, "Jiu " /*673b*/, "Bi " /*673c*/, "Xiu " /*673d*/, "Ting " /*673e*/, "Ci " /*673f*/, "Sha " /*6740*/, "Eburi " /*6741*/, "Za " /*6742*/, "Quan " /*6743*/, "Qian " /*6744*/, "Yu " /*6745*/, "Gan " /*6746*/, "Wu " /*6747*/, "Cha " /*6748*/, "Shan " /*6749*/, "Xun " /*674a*/, "Fan " /*674b*/, "Wu " /*674c*/, "Zi " /*674d*/, "Li " /*674e*/, "Xing " /*674f*/, "Cai " /*6750*/, "Cun " /*6751*/, "Ren " /*6752*/, "Shao " /*6753*/, "Tuo " /*6754*/, "Di " /*6755*/, "Zhang " /*6756*/, "Mang " /*6757*/, "Chi " /*6758*/, "Yi " /*6759*/, "Gu " /*675a*/, "Gong " /*675b*/, "Du " /*675c*/, "Yi " /*675d*/, "Qi " /*675e*/, "Shu " /*675f*/, "Gang " /*6760*/, "Tiao " /*6761*/, "Moku " /*6762*/, "Soma " /*6763*/, "Tochi " /*6764*/, "Lai " /*6765*/, "Sugi " /*6766*/, "Mang " /*6767*/, "Yang " /*6768*/, "Ma " /*6769*/, "Miao " /*676a*/, "Si " /*676b*/, "Yuan " /*676c*/, "Hang " /*676d*/, "Fei " /*676e*/, "Bei " /*676f*/, "Jie " /*6770*/, "Dong " /*6771*/, "Gao " /*6772*/, "Yao " /*6773*/, "Xian " /*6774*/, "Chu " /*6775*/, "Qun " /*6776*/, "Pa " /*6777*/, "Shu " /*6778*/, "Hua " /*6779*/, "Xin " /*677a*/, "Chou " /*677b*/, "Zhu " /*677c*/, "Chou " /*677d*/, "Song " /*677e*/, "Ban " /*677f*/, "Song " /*6780*/, "Ji " /*6781*/, "Yue " /*6782*/, "Jin " /*6783*/, "Gou " /*6784*/, "Ji " /*6785*/, "Mao " /*6786*/, "Pi " /*6787*/, "Bi " /*6788*/, "Wang " /*6789*/, "Ang " /*678a*/, "Fang " /*678b*/, "Fen " /*678c*/, "Yi " /*678d*/, "Fu " /*678e*/, "Nan " /*678f*/, "Xi " /*6790*/, "Hu " /*6791*/, "Ya " /*6792*/, "Dou " /*6793*/, "Xun " /*6794*/, "Zhen " /*6795*/, "Yao " /*6796*/, "Lin " /*6797*/, "Rui " /*6798*/, "E " /*6799*/, "Mei " /*679a*/, "Zhao " /*679b*/, "Guo " /*679c*/, "Zhi " /*679d*/, "Cong " /*679e*/, "Yun " /*679f*/, "Waku " /*67a0*/, "Dou " /*67a1*/, "Shu " /*67a2*/, "Zao " /*67a3*/, "[?] " /*67a4*/, "Li " /*67a5*/, "Haze " /*67a6*/, "Jian " /*67a7*/, "Cheng " /*67a8*/, "Matsu " /*67a9*/, "Qiang " /*67aa*/, "Feng " /*67ab*/, "Nan " /*67ac*/, "Xiao " /*67ad*/, "Xian " /*67ae*/, "Ku " /*67af*/, "Ping " /*67b0*/, "Yi " /*67b1*/, "Xi " /*67b2*/, "Zhi " /*67b3*/, "Guai " /*67b4*/, "Xiao " /*67b5*/, "Jia " /*67b6*/, "Jia " /*67b7*/, "Gou " /*67b8*/, "Fu " /*67b9*/, "Mo " /*67ba*/, "Yi " /*67bb*/, "Ye " /*67bc*/, "Ye " /*67bd*/, "Shi " /*67be*/, "Nie " /*67bf*/, "Bi " /*67c0*/, "Duo " /*67c1*/, "Yi " /*67c2*/, "Ling " /*67c3*/, "Bing " /*67c4*/, "Ni " /*67c5*/, "La " /*67c6*/, "He " /*67c7*/, "Pan " /*67c8*/, "Fan " /*67c9*/, "Zhong " /*67ca*/, "Dai " /*67cb*/, "Ci " /*67cc*/, "Yang " /*67cd*/, "Fu " /*67ce*/, "Bo " /*67cf*/, "Mou " /*67d0*/, "Gan " /*67d1*/, "Qi " /*67d2*/, "Ran " /*67d3*/, "Rou " /*67d4*/, "Mao " /*67d5*/, "Zhao " /*67d6*/, "Song " /*67d7*/, "Zhe " /*67d8*/, "Xia " /*67d9*/, "You " /*67da*/, "Shen " /*67db*/, "Ju " /*67dc*/, "Tuo " /*67dd*/, "Zuo " /*67de*/, "Nan " /*67df*/, "Ning " /*67e0*/, "Yong " /*67e1*/, "Di " /*67e2*/, "Zhi " /*67e3*/, "Zha " /*67e4*/, "Cha " /*67e5*/, "Dan " /*67e6*/, "Gu " /*67e7*/, "Pu " /*67e8*/, "Jiu " /*67e9*/, "Ao " /*67ea*/, "Fu " /*67eb*/, "Jian " /*67ec*/, "Bo " /*67ed*/, "Duo " /*67ee*/, "Ke " /*67ef*/, "Nai " /*67f0*/, "Zhu " /*67f1*/, "Bi " /*67f2*/, "Liu " /*67f3*/, "Chai " /*67f4*/, "Zha " /*67f5*/, "Si " /*67f6*/, "Zhu " /*67f7*/, "Pei " /*67f8*/, "Shi " /*67f9*/, "Guai " /*67fa*/, "Cha " /*67fb*/, "Yao " /*67fc*/, "Jue " /*67fd*/, "Jiu " /*67fe*/, "Shi " /*67ff*/ 
			});
						characters.TryAdd(104 /*26624 68*/, new string[] {
				"Zhi " /*6800*/, "Liu " /*6801*/, "Mei " /*6802*/, "Hoy " /*6803*/, "Rong " /*6804*/, "Zha " /*6805*/, "[?] " /*6806*/, "Biao " /*6807*/, "Zhan " /*6808*/, "Jie " /*6809*/, "Long " /*680a*/, "Dong " /*680b*/, "Lu " /*680c*/, "Sayng " /*680d*/, "Li " /*680e*/, "Lan " /*680f*/, "Yong " /*6810*/, "Shu " /*6811*/, "Xun " /*6812*/, "Shuan " /*6813*/, "Qi " /*6814*/, "Zhen " /*6815*/, "Qi " /*6816*/, "Li " /*6817*/, "Yi " /*6818*/, "Xiang " /*6819*/, "Zhen " /*681a*/, "Li " /*681b*/, "Su " /*681c*/, "Gua " /*681d*/, "Kan " /*681e*/, "Bing " /*681f*/, "Ren " /*6820*/, "Xiao " /*6821*/, "Bo " /*6822*/, "Ren " /*6823*/, "Bing " /*6824*/, "Zi " /*6825*/, "Chou " /*6826*/, "Yi " /*6827*/, "Jie " /*6828*/, "Xu " /*6829*/, "Zhu " /*682a*/, "Jian " /*682b*/, "Zui " /*682c*/, "Er " /*682d*/, "Er " /*682e*/, "You " /*682f*/, "Fa " /*6830*/, "Gong " /*6831*/, "Kao " /*6832*/, "Lao " /*6833*/, "Zhan " /*6834*/, "Li " /*6835*/, "Yin " /*6836*/, "Yang " /*6837*/, "He " /*6838*/, "Gen " /*6839*/, "Zhi " /*683a*/, "Chi " /*683b*/, "Ge " /*683c*/, "Zai " /*683d*/, "Luan " /*683e*/, "Fu " /*683f*/, "Jie " /*6840*/, "Hang " /*6841*/, "Gui " /*6842*/, "Tao " /*6843*/, "Guang " /*6844*/, "Wei " /*6845*/, "Kuang " /*6846*/, "Ru " /*6847*/, "An " /*6848*/, "An " /*6849*/, "Juan " /*684a*/, "Yi " /*684b*/, "Zhuo " /*684c*/, "Ku " /*684d*/, "Zhi " /*684e*/, "Qiong " /*684f*/, "Tong " /*6850*/, "Sang " /*6851*/, "Sang " /*6852*/, "Huan " /*6853*/, "Jie " /*6854*/, "Jiu " /*6855*/, "Xue " /*6856*/, "Duo " /*6857*/, "Zhui " /*6858*/, "Yu " /*6859*/, "Zan " /*685a*/, "Kasei " /*685b*/, "Ying " /*685c*/, "Masu " /*685d*/, "[?] " /*685e*/, "Zhan " /*685f*/, "Ya " /*6860*/, "Nao " /*6861*/, "Zhen " /*6862*/, "Dang " /*6863*/, "Qi " /*6864*/, "Qiao " /*6865*/, "Hua " /*6866*/, "Kuai " /*6867*/, "Jiang " /*6868*/, "Zhuang " /*6869*/, "Xun " /*686a*/, "Suo " /*686b*/, "Sha " /*686c*/, "Zhen " /*686d*/, "Bei " /*686e*/, "Ting " /*686f*/, "Gua " /*6870*/, "Jing " /*6871*/, "Bo " /*6872*/, "Ben " /*6873*/, "Fu " /*6874*/, "Rui " /*6875*/, "Tong " /*6876*/, "Jue " /*6877*/, "Xi " /*6878*/, "Lang " /*6879*/, "Liu " /*687a*/, "Feng " /*687b*/, "Qi " /*687c*/, "Wen " /*687d*/, "Jun " /*687e*/, "Gan " /*687f*/, "Cu " /*6880*/, "Liang " /*6881*/, "Qiu " /*6882*/, "Ting " /*6883*/, "You " /*6884*/, "Mei " /*6885*/, "Bang " /*6886*/, "Long " /*6887*/, "Peng " /*6888*/, "Zhuang " /*6889*/, "Di " /*688a*/, "Xuan " /*688b*/, "Tu " /*688c*/, "Zao " /*688d*/, "Ao " /*688e*/, "Gu " /*688f*/, "Bi " /*6890*/, "Di " /*6891*/, "Han " /*6892*/, "Zi " /*6893*/, "Zhi " /*6894*/, "Ren " /*6895*/, "Bei " /*6896*/, "Geng " /*6897*/, "Jian " /*6898*/, "Huan " /*6899*/, "Wan " /*689a*/, "Nuo " /*689b*/, "Jia " /*689c*/, "Tiao " /*689d*/, "Ji " /*689e*/, "Xiao " /*689f*/, "Lu " /*68a0*/, "Huan " /*68a1*/, "Shao " /*68a2*/, "Cen " /*68a3*/, "Fen " /*68a4*/, "Song " /*68a5*/, "Meng " /*68a6*/, "Wu " /*68a7*/, "Li " /*68a8*/, "Li " /*68a9*/, "Dou " /*68aa*/, "Cen " /*68ab*/, "Ying " /*68ac*/, "Suo " /*68ad*/, "Ju " /*68ae*/, "Ti " /*68af*/, "Jie " /*68b0*/, "Kun " /*68b1*/, "Zhuo " /*68b2*/, "Shu " /*68b3*/, "Chan " /*68b4*/, "Fan " /*68b5*/, "Wei " /*68b6*/, "Jing " /*68b7*/, "Li " /*68b8*/, "Bing " /*68b9*/, "Fumoto " /*68ba*/, "Shikimi " /*68bb*/, "Tao " /*68bc*/, "Zhi " /*68bd*/, "Lai " /*68be*/, "Lian " /*68bf*/, "Jian " /*68c0*/, "Zhuo " /*68c1*/, "Ling " /*68c2*/, "Li " /*68c3*/, "Qi " /*68c4*/, "Bing " /*68c5*/, "Zhun " /*68c6*/, "Cong " /*68c7*/, "Qian " /*68c8*/, "Mian " /*68c9*/, "Qi " /*68ca*/, "Qi " /*68cb*/, "Cai " /*68cc*/, "Gun " /*68cd*/, "Chan " /*68ce*/, "Te " /*68cf*/, "Fei " /*68d0*/, "Pai " /*68d1*/, "Bang " /*68d2*/, "Pou " /*68d3*/, "Hun " /*68d4*/, "Zong " /*68d5*/, "Cheng " /*68d6*/, "Zao " /*68d7*/, "Ji " /*68d8*/, "Li " /*68d9*/, "Peng " /*68da*/, "Yu " /*68db*/, "Yu " /*68dc*/, "Gu " /*68dd*/, "Hun " /*68de*/, "Dong " /*68df*/, "Tang " /*68e0*/, "Gang " /*68e1*/, "Wang " /*68e2*/, "Di " /*68e3*/, "Xi " /*68e4*/, "Fan " /*68e5*/, "Cheng " /*68e6*/, "Zhan " /*68e7*/, "Qi " /*68e8*/, "Yuan " /*68e9*/, "Yan " /*68ea*/, "Yu " /*68eb*/, "Quan " /*68ec*/, "Yi " /*68ed*/, "Sen " /*68ee*/, "Ren " /*68ef*/, "Chui " /*68f0*/, "Leng " /*68f1*/, "Qi " /*68f2*/, "Zhuo " /*68f3*/, "Fu " /*68f4*/, "Ke " /*68f5*/, "Lai " /*68f6*/, "Zou " /*68f7*/, "Zou " /*68f8*/, "Zhuo " /*68f9*/, "Guan " /*68fa*/, "Fen " /*68fb*/, "Fen " /*68fc*/, "Chen " /*68fd*/, "Qiong " /*68fe*/, "Nie " /*68ff*/ 
			});
						characters.TryAdd(105 /*26880 69*/, new string[] {
				"Wan " /*6900*/, "Guo " /*6901*/, "Lu " /*6902*/, "Hao " /*6903*/, "Jie " /*6904*/, "Yi " /*6905*/, "Chou " /*6906*/, "Ju " /*6907*/, "Ju " /*6908*/, "Cheng " /*6909*/, "Zuo " /*690a*/, "Liang " /*690b*/, "Qiang " /*690c*/, "Zhi " /*690d*/, "Zhui " /*690e*/, "Ya " /*690f*/, "Ju " /*6910*/, "Bei " /*6911*/, "Jiao " /*6912*/, "Zhuo " /*6913*/, "Zi " /*6914*/, "Bin " /*6915*/, "Peng " /*6916*/, "Ding " /*6917*/, "Chu " /*6918*/, "Chang " /*6919*/, "Kunugi " /*691a*/, "Momiji " /*691b*/, "Jian " /*691c*/, "Gui " /*691d*/, "Xi " /*691e*/, "Du " /*691f*/, "Qian " /*6920*/, "Kunugi " /*6921*/, "Soko " /*6922*/, "Shide " /*6923*/, "Luo " /*6924*/, "Zhi " /*6925*/, "Ken " /*6926*/, "Myeng " /*6927*/, "Tafu " /*6928*/, "[?] " /*6929*/, "Peng " /*692a*/, "Zhan " /*692b*/, "[?] " /*692c*/, "Tuo " /*692d*/, "Sen " /*692e*/, "Duo " /*692f*/, "Ye " /*6930*/, "Fou " /*6931*/, "Wei " /*6932*/, "Wei " /*6933*/, "Duan " /*6934*/, "Jia " /*6935*/, "Zong " /*6936*/, "Jian " /*6937*/, "Yi " /*6938*/, "Shen " /*6939*/, "Xi " /*693a*/, "Yan " /*693b*/, "Yan " /*693c*/, "Chuan " /*693d*/, "Zhan " /*693e*/, "Chun " /*693f*/, "Yu " /*6940*/, "He " /*6941*/, "Zha " /*6942*/, "Wo " /*6943*/, "Pian " /*6944*/, "Bi " /*6945*/, "Yao " /*6946*/, "Huo " /*6947*/, "Xu " /*6948*/, "Ruo " /*6949*/, "Yang " /*694a*/, "La " /*694b*/, "Yan " /*694c*/, "Ben " /*694d*/, "Hun " /*694e*/, "Kui " /*694f*/, "Jie " /*6950*/, "Kui " /*6951*/, "Si " /*6952*/, "Feng " /*6953*/, "Xie " /*6954*/, "Tuo " /*6955*/, "Zhi " /*6956*/, "Jian " /*6957*/, "Mu " /*6958*/, "Mao " /*6959*/, "Chu " /*695a*/, "Hu " /*695b*/, "Hu " /*695c*/, "Lian " /*695d*/, "Leng " /*695e*/, "Ting " /*695f*/, "Nan " /*6960*/, "Yu " /*6961*/, "You " /*6962*/, "Mei " /*6963*/, "Song " /*6964*/, "Xuan " /*6965*/, "Xuan " /*6966*/, "Ying " /*6967*/, "Zhen " /*6968*/, "Pian " /*6969*/, "Ye " /*696a*/, "Ji " /*696b*/, "Jie " /*696c*/, "Ye " /*696d*/, "Chu " /*696e*/, "Shun " /*696f*/, "Yu " /*6970*/, "Cou " /*6971*/, "Wei " /*6972*/, "Mei " /*6973*/, "Di " /*6974*/, "Ji " /*6975*/, "Jie " /*6976*/, "Kai " /*6977*/, "Qiu " /*6978*/, "Ying " /*6979*/, "Rou " /*697a*/, "Heng " /*697b*/, "Lou " /*697c*/, "Le " /*697d*/, "Hazou " /*697e*/, "Katsura " /*697f*/, "Pin " /*6980*/, "Muro " /*6981*/, "Gai " /*6982*/, "Tan " /*6983*/, "Lan " /*6984*/, "Yun " /*6985*/, "Yu " /*6986*/, "Chen " /*6987*/, "Lu " /*6988*/, "Ju " /*6989*/, "Sakaki " /*698a*/, "[?] " /*698b*/, "Pi " /*698c*/, "Xie " /*698d*/, "Jia " /*698e*/, "Yi " /*698f*/, "Zhan " /*6990*/, "Fu " /*6991*/, "Nai " /*6992*/, "Mi " /*6993*/, "Lang " /*6994*/, "Rong " /*6995*/, "Gu " /*6996*/, "Jian " /*6997*/, "Ju " /*6998*/, "Ta " /*6999*/, "Yao " /*699a*/, "Zhen " /*699b*/, "Bang " /*699c*/, "Sha " /*699d*/, "Yuan " /*699e*/, "Zi " /*699f*/, "Ming " /*69a0*/, "Su " /*69a1*/, "Jia " /*69a2*/, "Yao " /*69a3*/, "Jie " /*69a4*/, "Huang " /*69a5*/, "Gan " /*69a6*/, "Fei " /*69a7*/, "Zha " /*69a8*/, "Qian " /*69a9*/, "Ma " /*69aa*/, "Sun " /*69ab*/, "Yuan " /*69ac*/, "Xie " /*69ad*/, "Rong " /*69ae*/, "Shi " /*69af*/, "Zhi " /*69b0*/, "Cui " /*69b1*/, "Yun " /*69b2*/, "Ting " /*69b3*/, "Liu " /*69b4*/, "Rong " /*69b5*/, "Tang " /*69b6*/, "Que " /*69b7*/, "Zhai " /*69b8*/, "Si " /*69b9*/, "Sheng " /*69ba*/, "Ta " /*69bb*/, "Ke " /*69bc*/, "Xi " /*69bd*/, "Gu " /*69be*/, "Qi " /*69bf*/, "Kao " /*69c0*/, "Gao " /*69c1*/, "Sun " /*69c2*/, "Pan " /*69c3*/, "Tao " /*69c4*/, "Ge " /*69c5*/, "Xun " /*69c6*/, "Dian " /*69c7*/, "Nou " /*69c8*/, "Ji " /*69c9*/, "Shuo " /*69ca*/, "Gou " /*69cb*/, "Chui " /*69cc*/, "Qiang " /*69cd*/, "Cha " /*69ce*/, "Qian " /*69cf*/, "Huai " /*69d0*/, "Mei " /*69d1*/, "Xu " /*69d2*/, "Gang " /*69d3*/, "Gao " /*69d4*/, "Zhuo " /*69d5*/, "Tuo " /*69d6*/, "Hashi " /*69d7*/, "Yang " /*69d8*/, "Dian " /*69d9*/, "Jia " /*69da*/, "Jian " /*69db*/, "Zui " /*69dc*/, "Kashi " /*69dd*/, "Ori " /*69de*/, "Bin " /*69df*/, "Zhu " /*69e0*/, "[?] " /*69e1*/, "Xi " /*69e2*/, "Qi " /*69e3*/, "Lian " /*69e4*/, "Hui " /*69e5*/, "Yong " /*69e6*/, "Qian " /*69e7*/, "Guo " /*69e8*/, "Gai " /*69e9*/, "Gai " /*69ea*/, "Tuan " /*69eb*/, "Hua " /*69ec*/, "Cu " /*69ed*/, "Sen " /*69ee*/, "Cui " /*69ef*/, "Beng " /*69f0*/, "You " /*69f1*/, "Hu " /*69f2*/, "Jiang " /*69f3*/, "Hu " /*69f4*/, "Huan " /*69f5*/, "Kui " /*69f6*/, "Yi " /*69f7*/, "Nie " /*69f8*/, "Gao " /*69f9*/, "Kang " /*69fa*/, "Gui " /*69fb*/, "Gui " /*69fc*/, "Cao " /*69fd*/, "Man " /*69fe*/, "Jin " /*69ff*/ 
			});
						characters.TryAdd(106 /*27136 6a*/, new string[] {
				"Di " /*6a00*/, "Zhuang " /*6a01*/, "Le " /*6a02*/, "Lang " /*6a03*/, "Chen " /*6a04*/, "Cong " /*6a05*/, "Li " /*6a06*/, "Xiu " /*6a07*/, "Qing " /*6a08*/, "Shuang " /*6a09*/, "Fan " /*6a0a*/, "Tong " /*6a0b*/, "Guan " /*6a0c*/, "Ji " /*6a0d*/, "Suo " /*6a0e*/, "Lei " /*6a0f*/, "Lu " /*6a10*/, "Liang " /*6a11*/, "Mi " /*6a12*/, "Lou " /*6a13*/, "Chao " /*6a14*/, "Su " /*6a15*/, "Ke " /*6a16*/, "Shu " /*6a17*/, "Tang " /*6a18*/, "Biao " /*6a19*/, "Lu " /*6a1a*/, "Jiu " /*6a1b*/, "Shu " /*6a1c*/, "Zha " /*6a1d*/, "Shu " /*6a1e*/, "Zhang " /*6a1f*/, "Men " /*6a20*/, "Mo " /*6a21*/, "Niao " /*6a22*/, "Yang " /*6a23*/, "Tiao " /*6a24*/, "Peng " /*6a25*/, "Zhu " /*6a26*/, "Sha " /*6a27*/, "Xi " /*6a28*/, "Quan " /*6a29*/, "Heng " /*6a2a*/, "Jian " /*6a2b*/, "Cong " /*6a2c*/, "[?] " /*6a2d*/, "Hokuso " /*6a2e*/, "Qiang " /*6a2f*/, "Tara " /*6a30*/, "Ying " /*6a31*/, "Er " /*6a32*/, "Xin " /*6a33*/, "Zhi " /*6a34*/, "Qiao " /*6a35*/, "Zui " /*6a36*/, "Cong " /*6a37*/, "Pu " /*6a38*/, "Shu " /*6a39*/, "Hua " /*6a3a*/, "Kui " /*6a3b*/, "Zhen " /*6a3c*/, "Zun " /*6a3d*/, "Yue " /*6a3e*/, "Zhan " /*6a3f*/, "Xi " /*6a40*/, "Xun " /*6a41*/, "Dian " /*6a42*/, "Fa " /*6a43*/, "Gan " /*6a44*/, "Mo " /*6a45*/, "Wu " /*6a46*/, "Qiao " /*6a47*/, "Nao " /*6a48*/, "Lin " /*6a49*/, "Liu " /*6a4a*/, "Qiao " /*6a4b*/, "Xian " /*6a4c*/, "Run " /*6a4d*/, "Fan " /*6a4e*/, "Zhan " /*6a4f*/, "Tuo " /*6a50*/, "Lao " /*6a51*/, "Yun " /*6a52*/, "Shun " /*6a53*/, "Tui " /*6a54*/, "Cheng " /*6a55*/, "Tang " /*6a56*/, "Meng " /*6a57*/, "Ju " /*6a58*/, "Cheng " /*6a59*/, "Su " /*6a5a*/, "Jue " /*6a5b*/, "Jue " /*6a5c*/, "Tan " /*6a5d*/, "Hui " /*6a5e*/, "Ji " /*6a5f*/, "Nuo " /*6a60*/, "Xiang " /*6a61*/, "Tuo " /*6a62*/, "Ning " /*6a63*/, "Rui " /*6a64*/, "Zhu " /*6a65*/, "Chuang " /*6a66*/, "Zeng " /*6a67*/, "Fen " /*6a68*/, "Qiong " /*6a69*/, "Ran " /*6a6a*/, "Heng " /*6a6b*/, "Cen " /*6a6c*/, "Gu " /*6a6d*/, "Liu " /*6a6e*/, "Lao " /*6a6f*/, "Gao " /*6a70*/, "Chu " /*6a71*/, "Zusa " /*6a72*/, "Nude " /*6a73*/, "Ca " /*6a74*/, "San " /*6a75*/, "Ji " /*6a76*/, "Dou " /*6a77*/, "Shou " /*6a78*/, "Lu " /*6a79*/, "[?] " /*6a7a*/, "[?] " /*6a7b*/, "Yuan " /*6a7c*/, "Ta " /*6a7d*/, "Shu " /*6a7e*/, "Jiang " /*6a7f*/, "Tan " /*6a80*/, "Lin " /*6a81*/, "Nong " /*6a82*/, "Yin " /*6a83*/, "Xi " /*6a84*/, "Sui " /*6a85*/, "Shan " /*6a86*/, "Zui " /*6a87*/, "Xuan " /*6a88*/, "Cheng " /*6a89*/, "Gan " /*6a8a*/, "Ju " /*6a8b*/, "Zui " /*6a8c*/, "Yi " /*6a8d*/, "Qin " /*6a8e*/, "Pu " /*6a8f*/, "Yan " /*6a90*/, "Lei " /*6a91*/, "Feng " /*6a92*/, "Hui " /*6a93*/, "Dang " /*6a94*/, "Ji " /*6a95*/, "Sui " /*6a96*/, "Bo " /*6a97*/, "Bi " /*6a98*/, "Ding " /*6a99*/, "Chu " /*6a9a*/, "Zhua " /*6a9b*/, "Kuai " /*6a9c*/, "Ji " /*6a9d*/, "Jie " /*6a9e*/, "Jia " /*6a9f*/, "Qing " /*6aa0*/, "Zhe " /*6aa1*/, "Jian " /*6aa2*/, "Qiang " /*6aa3*/, "Dao " /*6aa4*/, "Yi " /*6aa5*/, "Biao " /*6aa6*/, "Song " /*6aa7*/, "She " /*6aa8*/, "Lin " /*6aa9*/, "Kunugi " /*6aaa*/, "Cha " /*6aab*/, "Meng " /*6aac*/, "Yin " /*6aad*/, "Tao " /*6aae*/, "Tai " /*6aaf*/, "Mian " /*6ab0*/, "Qi " /*6ab1*/, "Toan " /*6ab2*/, "Bin " /*6ab3*/, "Huo " /*6ab4*/, "Ji " /*6ab5*/, "Qian " /*6ab6*/, "Mi " /*6ab7*/, "Ning " /*6ab8*/, "Yi " /*6ab9*/, "Gao " /*6aba*/, "Jian " /*6abb*/, "Yin " /*6abc*/, "Er " /*6abd*/, "Qing " /*6abe*/, "Yan " /*6abf*/, "Qi " /*6ac0*/, "Mi " /*6ac1*/, "Zhao " /*6ac2*/, "Gui " /*6ac3*/, "Chun " /*6ac4*/, "Ji " /*6ac5*/, "Kui " /*6ac6*/, "Po " /*6ac7*/, "Deng " /*6ac8*/, "Chu " /*6ac9*/, "[?] " /*6aca*/, "Mian " /*6acb*/, "You " /*6acc*/, "Zhi " /*6acd*/, "Guang " /*6ace*/, "Qian " /*6acf*/, "Lei " /*6ad0*/, "Lei " /*6ad1*/, "Sa " /*6ad2*/, "Lu " /*6ad3*/, "Li " /*6ad4*/, "Cuan " /*6ad5*/, "Lu " /*6ad6*/, "Mie " /*6ad7*/, "Hui " /*6ad8*/, "Ou " /*6ad9*/, "Lu " /*6ada*/, "Jie " /*6adb*/, "Gao " /*6adc*/, "Du " /*6add*/, "Yuan " /*6ade*/, "Li " /*6adf*/, "Fei " /*6ae0*/, "Zhuo " /*6ae1*/, "Sou " /*6ae2*/, "Lian " /*6ae3*/, "Tamo " /*6ae4*/, "Chu " /*6ae5*/, "[?] " /*6ae6*/, "Zhu " /*6ae7*/, "Lu " /*6ae8*/, "Yan " /*6ae9*/, "Li " /*6aea*/, "Zhu " /*6aeb*/, "Chen " /*6aec*/, "Jie " /*6aed*/, "E " /*6aee*/, "Su " /*6aef*/, "Huai " /*6af0*/, "Nie " /*6af1*/, "Yu " /*6af2*/, "Long " /*6af3*/, "Lai " /*6af4*/, "[?] " /*6af5*/, "Xian " /*6af6*/, "Kwi " /*6af7*/, "Ju " /*6af8*/, "Xiao " /*6af9*/, "Ling " /*6afa*/, "Ying " /*6afb*/, "Jian " /*6afc*/, "Yin " /*6afd*/, "You " /*6afe*/, "Ying " /*6aff*/ 
			});
						characters.TryAdd(107 /*27392 6b*/, new string[] {
				"Xiang " /*6b00*/, "Nong " /*6b01*/, "Bo " /*6b02*/, "Chan " /*6b03*/, "Lan " /*6b04*/, "Ju " /*6b05*/, "Shuang " /*6b06*/, "She " /*6b07*/, "Wei " /*6b08*/, "Cong " /*6b09*/, "Quan " /*6b0a*/, "Qu " /*6b0b*/, "Cang " /*6b0c*/, "[?] " /*6b0d*/, "Yu " /*6b0e*/, "Luo " /*6b0f*/, "Li " /*6b10*/, "Zan " /*6b11*/, "Luan " /*6b12*/, "Dang " /*6b13*/, "Jue " /*6b14*/, "Em " /*6b15*/, "Lan " /*6b16*/, "Lan " /*6b17*/, "Zhu " /*6b18*/, "Lei " /*6b19*/, "Li " /*6b1a*/, "Ba " /*6b1b*/, "Nang " /*6b1c*/, "Yu " /*6b1d*/, "Ling " /*6b1e*/, "Tsuki " /*6b1f*/, "Qian " /*6b20*/, "Ci " /*6b21*/, "Huan " /*6b22*/, "Xin " /*6b23*/, "Yu " /*6b24*/, "Yu " /*6b25*/, "Qian " /*6b26*/, "Ou " /*6b27*/, "Xu " /*6b28*/, "Chao " /*6b29*/, "Chu " /*6b2a*/, "Chi " /*6b2b*/, "Kai " /*6b2c*/, "Yi " /*6b2d*/, "Jue " /*6b2e*/, "Xi " /*6b2f*/, "Xu " /*6b30*/, "Xia " /*6b31*/, "Yu " /*6b32*/, "Kuai " /*6b33*/, "Lang " /*6b34*/, "Kuan " /*6b35*/, "Shuo " /*6b36*/, "Xi " /*6b37*/, "Ai " /*6b38*/, "Yi " /*6b39*/, "Qi " /*6b3a*/, "Hu " /*6b3b*/, "Chi " /*6b3c*/, "Qin " /*6b3d*/, "Kuan " /*6b3e*/, "Kan " /*6b3f*/, "Kuan " /*6b40*/, "Kan " /*6b41*/, "Chuan " /*6b42*/, "Sha " /*6b43*/, "Gua " /*6b44*/, "Yin " /*6b45*/, "Xin " /*6b46*/, "Xie " /*6b47*/, "Yu " /*6b48*/, "Qian " /*6b49*/, "Xiao " /*6b4a*/, "Yi " /*6b4b*/, "Ge " /*6b4c*/, "Wu " /*6b4d*/, "Tan " /*6b4e*/, "Jin " /*6b4f*/, "Ou " /*6b50*/, "Hu " /*6b51*/, "Ti " /*6b52*/, "Huan " /*6b53*/, "Xu " /*6b54*/, "Pen " /*6b55*/, "Xi " /*6b56*/, "Xiao " /*6b57*/, "Xu " /*6b58*/, "Xi " /*6b59*/, "Sen " /*6b5a*/, "Lian " /*6b5b*/, "Chu " /*6b5c*/, "Yi " /*6b5d*/, "Kan " /*6b5e*/, "Yu " /*6b5f*/, "Chuo " /*6b60*/, "Huan " /*6b61*/, "Zhi " /*6b62*/, "Zheng " /*6b63*/, "Ci " /*6b64*/, "Bu " /*6b65*/, "Wu " /*6b66*/, "Qi " /*6b67*/, "Bu " /*6b68*/, "Bu " /*6b69*/, "Wai " /*6b6a*/, "Ju " /*6b6b*/, "Qian " /*6b6c*/, "Chi " /*6b6d*/, "Se " /*6b6e*/, "Chi " /*6b6f*/, "Se " /*6b70*/, "Zhong " /*6b71*/, "Sui " /*6b72*/, "Sui " /*6b73*/, "Li " /*6b74*/, "Cuo " /*6b75*/, "Yu " /*6b76*/, "Li " /*6b77*/, "Gui " /*6b78*/, "Dai " /*6b79*/, "Dai " /*6b7a*/, "Si " /*6b7b*/, "Jian " /*6b7c*/, "Zhe " /*6b7d*/, "Mo " /*6b7e*/, "Mo " /*6b7f*/, "Yao " /*6b80*/, "Mo " /*6b81*/, "Cu " /*6b82*/, "Yang " /*6b83*/, "Tian " /*6b84*/, "Sheng " /*6b85*/, "Dai " /*6b86*/, "Shang " /*6b87*/, "Xu " /*6b88*/, "Xun " /*6b89*/, "Shu " /*6b8a*/, "Can " /*6b8b*/, "Jue " /*6b8c*/, "Piao " /*6b8d*/, "Qia " /*6b8e*/, "Qiu " /*6b8f*/, "Su " /*6b90*/, "Qing " /*6b91*/, "Yun " /*6b92*/, "Lian " /*6b93*/, "Yi " /*6b94*/, "Fou " /*6b95*/, "Zhi " /*6b96*/, "Ye " /*6b97*/, "Can " /*6b98*/, "Hun " /*6b99*/, "Dan " /*6b9a*/, "Ji " /*6b9b*/, "Ye " /*6b9c*/, "Zhen " /*6b9d*/, "Yun " /*6b9e*/, "Wen " /*6b9f*/, "Chou " /*6ba0*/, "Bin " /*6ba1*/, "Ti " /*6ba2*/, "Jin " /*6ba3*/, "Shang " /*6ba4*/, "Yin " /*6ba5*/, "Diao " /*6ba6*/, "Cu " /*6ba7*/, "Hui " /*6ba8*/, "Cuan " /*6ba9*/, "Yi " /*6baa*/, "Dan " /*6bab*/, "Du " /*6bac*/, "Jiang " /*6bad*/, "Lian " /*6bae*/, "Bin " /*6baf*/, "Du " /*6bb0*/, "Tsukusu " /*6bb1*/, "Jian " /*6bb2*/, "Shu " /*6bb3*/, "Ou " /*6bb4*/, "Duan " /*6bb5*/, "Zhu " /*6bb6*/, "Yin " /*6bb7*/, "Qing " /*6bb8*/, "Yi " /*6bb9*/, "Sha " /*6bba*/, "Que " /*6bbb*/, "Ke " /*6bbc*/, "Yao " /*6bbd*/, "Jun " /*6bbe*/, "Dian " /*6bbf*/, "Hui " /*6bc0*/, "Hui " /*6bc1*/, "Gu " /*6bc2*/, "Que " /*6bc3*/, "Ji " /*6bc4*/, "Yi " /*6bc5*/, "Ou " /*6bc6*/, "Hui " /*6bc7*/, "Duan " /*6bc8*/, "Yi " /*6bc9*/, "Xiao " /*6bca*/, "Wu " /*6bcb*/, "Guan " /*6bcc*/, "Mu " /*6bcd*/, "Mei " /*6bce*/, "Mei " /*6bcf*/, "Ai " /*6bd0*/, "Zuo " /*6bd1*/, "Du " /*6bd2*/, "Yu " /*6bd3*/, "Bi " /*6bd4*/, "Bi " /*6bd5*/, "Bi " /*6bd6*/, "Pi " /*6bd7*/, "Pi " /*6bd8*/, "Bi " /*6bd9*/, "Chan " /*6bda*/, "Mao " /*6bdb*/, "[?] " /*6bdc*/, "[?] " /*6bdd*/, "Pu " /*6bde*/, "Mushiru " /*6bdf*/, "Jia " /*6be0*/, "Zhan " /*6be1*/, "Sai " /*6be2*/, "Mu " /*6be3*/, "Tuo " /*6be4*/, "Xun " /*6be5*/, "Er " /*6be6*/, "Rong " /*6be7*/, "Xian " /*6be8*/, "Ju " /*6be9*/, "Mu " /*6bea*/, "Hao " /*6beb*/, "Qiu " /*6bec*/, "Dou " /*6bed*/, "Mushiru " /*6bee*/, "Tan " /*6bef*/, "Pei " /*6bf0*/, "Ju " /*6bf1*/, "Duo " /*6bf2*/, "Cui " /*6bf3*/, "Bi " /*6bf4*/, "San " /*6bf5*/, "[?] " /*6bf6*/, "Mao " /*6bf7*/, "Sui " /*6bf8*/, "Yu " /*6bf9*/, "Yu " /*6bfa*/, "Tuo " /*6bfb*/, "He " /*6bfc*/, "Jian " /*6bfd*/, "Ta " /*6bfe*/, "San " /*6bff*/ 
			});
						characters.TryAdd(108 /*27648 6c*/, new string[] {
				"Lu " /*6c00*/, "Mu " /*6c01*/, "Li " /*6c02*/, "Tong " /*6c03*/, "Rong " /*6c04*/, "Chang " /*6c05*/, "Pu " /*6c06*/, "Luo " /*6c07*/, "Zhan " /*6c08*/, "Sao " /*6c09*/, "Zhan " /*6c0a*/, "Meng " /*6c0b*/, "Luo " /*6c0c*/, "Qu " /*6c0d*/, "Die " /*6c0e*/, "Shi " /*6c0f*/, "Di " /*6c10*/, "Min " /*6c11*/, "Jue " /*6c12*/, "Mang " /*6c13*/, "Qi " /*6c14*/, "Pie " /*6c15*/, "Nai " /*6c16*/, "Qi " /*6c17*/, "Dao " /*6c18*/, "Xian " /*6c19*/, "Chuan " /*6c1a*/, "Fen " /*6c1b*/, "Ri " /*6c1c*/, "Nei " /*6c1d*/, "[?] " /*6c1e*/, "Fu " /*6c1f*/, "Shen " /*6c20*/, "Dong " /*6c21*/, "Qing " /*6c22*/, "Qi " /*6c23*/, "Yin " /*6c24*/, "Xi " /*6c25*/, "Hai " /*6c26*/, "Yang " /*6c27*/, "An " /*6c28*/, "Ya " /*6c29*/, "Ke " /*6c2a*/, "Qing " /*6c2b*/, "Ya " /*6c2c*/, "Dong " /*6c2d*/, "Dan " /*6c2e*/, "Lu " /*6c2f*/, "Qing " /*6c30*/, "Yang " /*6c31*/, "Yun " /*6c32*/, "Yun " /*6c33*/, "Shui " /*6c34*/, "San " /*6c35*/, "Zheng " /*6c36*/, "Bing " /*6c37*/, "Yong " /*6c38*/, "Dang " /*6c39*/, "Shitamizu " /*6c3a*/, "Le " /*6c3b*/, "Ni " /*6c3c*/, "Tun " /*6c3d*/, "Fan " /*6c3e*/, "Gui " /*6c3f*/, "Ting " /*6c40*/, "Zhi " /*6c41*/, "Qiu " /*6c42*/, "Bin " /*6c43*/, "Ze " /*6c44*/, "Mian " /*6c45*/, "Cuan " /*6c46*/, "Hui " /*6c47*/, "Diao " /*6c48*/, "Yi " /*6c49*/, "Cha " /*6c4a*/, "Zhuo " /*6c4b*/, "Chuan " /*6c4c*/, "Wan " /*6c4d*/, "Fan " /*6c4e*/, "Dai " /*6c4f*/, "Xi " /*6c50*/, "Tuo " /*6c51*/, "Mang " /*6c52*/, "Qiu " /*6c53*/, "Qi " /*6c54*/, "Shan " /*6c55*/, "Pai " /*6c56*/, "Han " /*6c57*/, "Qian " /*6c58*/, "Wu " /*6c59*/, "Wu " /*6c5a*/, "Xun " /*6c5b*/, "Si " /*6c5c*/, "Ru " /*6c5d*/, "Gong " /*6c5e*/, "Jiang " /*6c5f*/, "Chi " /*6c60*/, "Wu " /*6c61*/, "Tsuchi " /*6c62*/, "[?] " /*6c63*/, "Tang " /*6c64*/, "Zhi " /*6c65*/, "Chi " /*6c66*/, "Qian " /*6c67*/, "Mi " /*6c68*/, "Yu " /*6c69*/, "Wang " /*6c6a*/, "Qing " /*6c6b*/, "Jing " /*6c6c*/, "Rui " /*6c6d*/, "Jun " /*6c6e*/, "Hong " /*6c6f*/, "Tai " /*6c70*/, "Quan " /*6c71*/, "Ji " /*6c72*/, "Bian " /*6c73*/, "Bian " /*6c74*/, "Gan " /*6c75*/, "Wen " /*6c76*/, "Zhong " /*6c77*/, "Fang " /*6c78*/, "Xiong " /*6c79*/, "Jue " /*6c7a*/, "Hang " /*6c7b*/, "Niou " /*6c7c*/, "Qi " /*6c7d*/, "Fen " /*6c7e*/, "Xu " /*6c7f*/, "Xu " /*6c80*/, "Qin " /*6c81*/, "Yi " /*6c82*/, "Wo " /*6c83*/, "Yun " /*6c84*/, "Yuan " /*6c85*/, "Hang " /*6c86*/, "Yan " /*6c87*/, "Chen " /*6c88*/, "Chen " /*6c89*/, "Dan " /*6c8a*/, "You " /*6c8b*/, "Dun " /*6c8c*/, "Hu " /*6c8d*/, "Huo " /*6c8e*/, "Qie " /*6c8f*/, "Mu " /*6c90*/, "Rou " /*6c91*/, "Mei " /*6c92*/, "Ta " /*6c93*/, "Mian " /*6c94*/, "Wu " /*6c95*/, "Chong " /*6c96*/, "Tian " /*6c97*/, "Bi " /*6c98*/, "Sha " /*6c99*/, "Zhi " /*6c9a*/, "Pei " /*6c9b*/, "Pan " /*6c9c*/, "Zhui " /*6c9d*/, "Za " /*6c9e*/, "Gou " /*6c9f*/, "Liu " /*6ca0*/, "Mei " /*6ca1*/, "Ze " /*6ca2*/, "Feng " /*6ca3*/, "Ou " /*6ca4*/, "Li " /*6ca5*/, "Lun " /*6ca6*/, "Cang " /*6ca7*/, "Feng " /*6ca8*/, "Wei " /*6ca9*/, "Hu " /*6caa*/, "Mo " /*6cab*/, "Mei " /*6cac*/, "Shu " /*6cad*/, "Ju " /*6cae*/, "Zan " /*6caf*/, "Tuo " /*6cb0*/, "Tuo " /*6cb1*/, "Tuo " /*6cb2*/, "He " /*6cb3*/, "Li " /*6cb4*/, "Mi " /*6cb5*/, "Yi " /*6cb6*/, "Fa " /*6cb7*/, "Fei " /*6cb8*/, "You " /*6cb9*/, "Tian " /*6cba*/, "Zhi " /*6cbb*/, "Zhao " /*6cbc*/, "Gu " /*6cbd*/, "Zhan " /*6cbe*/, "Yan " /*6cbf*/, "Si " /*6cc0*/, "Kuang " /*6cc1*/, "Jiong " /*6cc2*/, "Ju " /*6cc3*/, "Xie " /*6cc4*/, "Qiu " /*6cc5*/, "Yi " /*6cc6*/, "Jia " /*6cc7*/, "Zhong " /*6cc8*/, "Quan " /*6cc9*/, "Bo " /*6cca*/, "Hui " /*6ccb*/, "Mi " /*6ccc*/, "Ben " /*6ccd*/, "Zhuo " /*6cce*/, "Chu " /*6ccf*/, "Le " /*6cd0*/, "You " /*6cd1*/, "Gu " /*6cd2*/, "Hong " /*6cd3*/, "Gan " /*6cd4*/, "Fa " /*6cd5*/, "Mao " /*6cd6*/, "Si " /*6cd7*/, "Hu " /*6cd8*/, "Ping " /*6cd9*/, "Ci " /*6cda*/, "Fan " /*6cdb*/, "Chi " /*6cdc*/, "Su " /*6cdd*/, "Ning " /*6cde*/, "Cheng " /*6cdf*/, "Ling " /*6ce0*/, "Pao " /*6ce1*/, "Bo " /*6ce2*/, "Qi " /*6ce3*/, "Si " /*6ce4*/, "Ni " /*6ce5*/, "Ju " /*6ce6*/, "Yue " /*6ce7*/, "Zhu " /*6ce8*/, "Sheng " /*6ce9*/, "Lei " /*6cea*/, "Xuan " /*6ceb*/, "Xue " /*6cec*/, "Fu " /*6ced*/, "Pan " /*6cee*/, "Min " /*6cef*/, "Tai " /*6cf0*/, "Yang " /*6cf1*/, "Ji " /*6cf2*/, "Yong " /*6cf3*/, "Guan " /*6cf4*/, "Beng " /*6cf5*/, "Xue " /*6cf6*/, "Long " /*6cf7*/, "Lu " /*6cf8*/, "[?] " /*6cf9*/, "Bo " /*6cfa*/, "Xie " /*6cfb*/, "Po " /*6cfc*/, "Ze " /*6cfd*/, "Jing " /*6cfe*/, "Yin " /*6cff*/ 
			});
						characters.TryAdd(109 /*27904 6d*/, new string[] {
				"Zhou " /*6d00*/, "Ji " /*6d01*/, "Yi " /*6d02*/, "Hui " /*6d03*/, "Hui " /*6d04*/, "Zui " /*6d05*/, "Cheng " /*6d06*/, "Yin " /*6d07*/, "Wei " /*6d08*/, "Hou " /*6d09*/, "Jian " /*6d0a*/, "Yang " /*6d0b*/, "Lie " /*6d0c*/, "Si " /*6d0d*/, "Ji " /*6d0e*/, "Er " /*6d0f*/, "Xing " /*6d10*/, "Fu " /*6d11*/, "Sa " /*6d12*/, "Suo " /*6d13*/, "Zhi " /*6d14*/, "Yin " /*6d15*/, "Wu " /*6d16*/, "Xi " /*6d17*/, "Kao " /*6d18*/, "Zhu " /*6d19*/, "Jiang " /*6d1a*/, "Luo " /*6d1b*/, "[?] " /*6d1c*/, "An " /*6d1d*/, "Dong " /*6d1e*/, "Yi " /*6d1f*/, "Mou " /*6d20*/, "Lei " /*6d21*/, "Yi " /*6d22*/, "Mi " /*6d23*/, "Quan " /*6d24*/, "Jin " /*6d25*/, "Mo " /*6d26*/, "Wei " /*6d27*/, "Xiao " /*6d28*/, "Xie " /*6d29*/, "Hong " /*6d2a*/, "Xu " /*6d2b*/, "Shuo " /*6d2c*/, "Kuang " /*6d2d*/, "Tao " /*6d2e*/, "Qie " /*6d2f*/, "Ju " /*6d30*/, "Er " /*6d31*/, "Zhou " /*6d32*/, "Ru " /*6d33*/, "Ping " /*6d34*/, "Xun " /*6d35*/, "Xiong " /*6d36*/, "Zhi " /*6d37*/, "Guang " /*6d38*/, "Huan " /*6d39*/, "Ming " /*6d3a*/, "Huo " /*6d3b*/, "Wa " /*6d3c*/, "Qia " /*6d3d*/, "Pai " /*6d3e*/, "Wu " /*6d3f*/, "Qu " /*6d40*/, "Liu " /*6d41*/, "Yi " /*6d42*/, "Jia " /*6d43*/, "Jing " /*6d44*/, "Qian " /*6d45*/, "Jiang " /*6d46*/, "Jiao " /*6d47*/, "Cheng " /*6d48*/, "Shi " /*6d49*/, "Zhuo " /*6d4a*/, "Ce " /*6d4b*/, "Pal " /*6d4c*/, "Kuai " /*6d4d*/, "Ji " /*6d4e*/, "Liu " /*6d4f*/, "Chan " /*6d50*/, "Hun " /*6d51*/, "Hu " /*6d52*/, "Nong " /*6d53*/, "Xun " /*6d54*/, "Jin " /*6d55*/, "Lie " /*6d56*/, "Qiu " /*6d57*/, "Wei " /*6d58*/, "Zhe " /*6d59*/, "Jun " /*6d5a*/, "Han " /*6d5b*/, "Bang " /*6d5c*/, "Mang " /*6d5d*/, "Zhuo " /*6d5e*/, "You " /*6d5f*/, "Xi " /*6d60*/, "Bo " /*6d61*/, "Dou " /*6d62*/, "Wan " /*6d63*/, "Hong " /*6d64*/, "Yi " /*6d65*/, "Pu " /*6d66*/, "Ying " /*6d67*/, "Lan " /*6d68*/, "Hao " /*6d69*/, "Lang " /*6d6a*/, "Han " /*6d6b*/, "Li " /*6d6c*/, "Geng " /*6d6d*/, "Fu " /*6d6e*/, "Wu " /*6d6f*/, "Lian " /*6d70*/, "Chun " /*6d71*/, "Feng " /*6d72*/, "Yi " /*6d73*/, "Yu " /*6d74*/, "Tong " /*6d75*/, "Lao " /*6d76*/, "Hai " /*6d77*/, "Jin " /*6d78*/, "Jia " /*6d79*/, "Chong " /*6d7a*/, "Weng " /*6d7b*/, "Mei " /*6d7c*/, "Sui " /*6d7d*/, "Cheng " /*6d7e*/, "Pei " /*6d7f*/, "Xian " /*6d80*/, "Shen " /*6d81*/, "Tu " /*6d82*/, "Kun " /*6d83*/, "Pin " /*6d84*/, "Nie " /*6d85*/, "Han " /*6d86*/, "Jing " /*6d87*/, "Xiao " /*6d88*/, "She " /*6d89*/, "Nian " /*6d8a*/, "Tu " /*6d8b*/, "Yong " /*6d8c*/, "Xiao " /*6d8d*/, "Xian " /*6d8e*/, "Ting " /*6d8f*/, "E " /*6d90*/, "Su " /*6d91*/, "Tun " /*6d92*/, "Juan " /*6d93*/, "Cen " /*6d94*/, "Ti " /*6d95*/, "Li " /*6d96*/, "Shui " /*6d97*/, "Si " /*6d98*/, "Lei " /*6d99*/, "Shui " /*6d9a*/, "Tao " /*6d9b*/, "Du " /*6d9c*/, "Lao " /*6d9d*/, "Lai " /*6d9e*/, "Lian " /*6d9f*/, "Wei " /*6da0*/, "Wo " /*6da1*/, "Yun " /*6da2*/, "Huan " /*6da3*/, "Di " /*6da4*/, "[?] " /*6da5*/, "Run " /*6da6*/, "Jian " /*6da7*/, "Zhang " /*6da8*/, "Se " /*6da9*/, "Fu " /*6daa*/, "Guan " /*6dab*/, "Xing " /*6dac*/, "Shou " /*6dad*/, "Shuan " /*6dae*/, "Ya " /*6daf*/, "Chuo " /*6db0*/, "Zhang " /*6db1*/, "Ye " /*6db2*/, "Kong " /*6db3*/, "Wo " /*6db4*/, "Han " /*6db5*/, "Tuo " /*6db6*/, "Dong " /*6db7*/, "He " /*6db8*/, "Wo " /*6db9*/, "Ju " /*6dba*/, "Gan " /*6dbb*/, "Liang " /*6dbc*/, "Hun " /*6dbd*/, "Ta " /*6dbe*/, "Zhuo " /*6dbf*/, "Dian " /*6dc0*/, "Qie " /*6dc1*/, "De " /*6dc2*/, "Juan " /*6dc3*/, "Zi " /*6dc4*/, "Xi " /*6dc5*/, "Yao " /*6dc6*/, "Qi " /*6dc7*/, "Gu " /*6dc8*/, "Guo " /*6dc9*/, "Han " /*6dca*/, "Lin " /*6dcb*/, "Tang " /*6dcc*/, "Zhou " /*6dcd*/, "Peng " /*6dce*/, "Hao " /*6dcf*/, "Chang " /*6dd0*/, "Shu " /*6dd1*/, "Qi " /*6dd2*/, "Fang " /*6dd3*/, "Chi " /*6dd4*/, "Lu " /*6dd5*/, "Nao " /*6dd6*/, "Ju " /*6dd7*/, "Tao " /*6dd8*/, "Cong " /*6dd9*/, "Lei " /*6dda*/, "Zhi " /*6ddb*/, "Peng " /*6ddc*/, "Fei " /*6ddd*/, "Song " /*6dde*/, "Tian " /*6ddf*/, "Pi " /*6de0*/, "Dan " /*6de1*/, "Yu " /*6de2*/, "Ni " /*6de3*/, "Yu " /*6de4*/, "Lu " /*6de5*/, "Gan " /*6de6*/, "Mi " /*6de7*/, "Jing " /*6de8*/, "Ling " /*6de9*/, "Lun " /*6dea*/, "Yin " /*6deb*/, "Cui " /*6dec*/, "Qu " /*6ded*/, "Huai " /*6dee*/, "Yu " /*6def*/, "Nian " /*6df0*/, "Shen " /*6df1*/, "Piao " /*6df2*/, "Chun " /*6df3*/, "Wa " /*6df4*/, "Yuan " /*6df5*/, "Lai " /*6df6*/, "Hun " /*6df7*/, "Qing " /*6df8*/, "Yan " /*6df9*/, "Qian " /*6dfa*/, "Tian " /*6dfb*/, "Miao " /*6dfc*/, "Zhi " /*6dfd*/, "Yin " /*6dfe*/, "Mi " /*6dff*/ 
			});
						characters.TryAdd(110 /*28160 6e*/, new string[] {
				"Ben " /*6e00*/, "Yuan " /*6e01*/, "Wen " /*6e02*/, "Re " /*6e03*/, "Fei " /*6e04*/, "Qing " /*6e05*/, "Yuan " /*6e06*/, "Ke " /*6e07*/, "Ji " /*6e08*/, "She " /*6e09*/, "Yuan " /*6e0a*/, "Shibui " /*6e0b*/, "Lu " /*6e0c*/, "Zi " /*6e0d*/, "Du " /*6e0e*/, "[?] " /*6e0f*/, "Jian " /*6e10*/, "Min " /*6e11*/, "Pi " /*6e12*/, "Tani " /*6e13*/, "Yu " /*6e14*/, "Yuan " /*6e15*/, "Shen " /*6e16*/, "Shen " /*6e17*/, "Rou " /*6e18*/, "Huan " /*6e19*/, "Zhu " /*6e1a*/, "Jian " /*6e1b*/, "Nuan " /*6e1c*/, "Yu " /*6e1d*/, "Qiu " /*6e1e*/, "Ting " /*6e1f*/, "Qu " /*6e20*/, "Du " /*6e21*/, "Feng " /*6e22*/, "Zha " /*6e23*/, "Bo " /*6e24*/, "Wo " /*6e25*/, "Wo " /*6e26*/, "Di " /*6e27*/, "Wei " /*6e28*/, "Wen " /*6e29*/, "Ru " /*6e2a*/, "Xie " /*6e2b*/, "Ce " /*6e2c*/, "Wei " /*6e2d*/, "Ge " /*6e2e*/, "Gang " /*6e2f*/, "Yan " /*6e30*/, "Hong " /*6e31*/, "Xuan " /*6e32*/, "Mi " /*6e33*/, "Ke " /*6e34*/, "Mao " /*6e35*/, "Ying " /*6e36*/, "Yan " /*6e37*/, "You " /*6e38*/, "Hong " /*6e39*/, "Miao " /*6e3a*/, "Xing " /*6e3b*/, "Mei " /*6e3c*/, "Zai " /*6e3d*/, "Hun " /*6e3e*/, "Nai " /*6e3f*/, "Kui " /*6e40*/, "Shi " /*6e41*/, "E " /*6e42*/, "Pai " /*6e43*/, "Mei " /*6e44*/, "Lian " /*6e45*/, "Qi " /*6e46*/, "Qi " /*6e47*/, "Mei " /*6e48*/, "Tian " /*6e49*/, "Cou " /*6e4a*/, "Wei " /*6e4b*/, "Can " /*6e4c*/, "Tuan " /*6e4d*/, "Mian " /*6e4e*/, "Hui " /*6e4f*/, "Mo " /*6e50*/, "Xu " /*6e51*/, "Ji " /*6e52*/, "Pen " /*6e53*/, "Jian " /*6e54*/, "Jian " /*6e55*/, "Hu " /*6e56*/, "Feng " /*6e57*/, "Xiang " /*6e58*/, "Yi " /*6e59*/, "Yin " /*6e5a*/, "Zhan " /*6e5b*/, "Shi " /*6e5c*/, "Jie " /*6e5d*/, "Cheng " /*6e5e*/, "Huang " /*6e5f*/, "Tan " /*6e60*/, "Yu " /*6e61*/, "Bi " /*6e62*/, "Min " /*6e63*/, "Shi " /*6e64*/, "Tu " /*6e65*/, "Sheng " /*6e66*/, "Yong " /*6e67*/, "Qu " /*6e68*/, "Zhong " /*6e69*/, "Suei " /*6e6a*/, "Jiu " /*6e6b*/, "Jiao " /*6e6c*/, "Qiou " /*6e6d*/, "Yin " /*6e6e*/, "Tang " /*6e6f*/, "Long " /*6e70*/, "Huo " /*6e71*/, "Yuan " /*6e72*/, "Nan " /*6e73*/, "Ban " /*6e74*/, "You " /*6e75*/, "Quan " /*6e76*/, "Chui " /*6e77*/, "Liang " /*6e78*/, "Chan " /*6e79*/, "Yan " /*6e7a*/, "Chun " /*6e7b*/, "Nie " /*6e7c*/, "Zi " /*6e7d*/, "Wan " /*6e7e*/, "Shi " /*6e7f*/, "Man " /*6e80*/, "Ying " /*6e81*/, "Ratsu " /*6e82*/, "Kui " /*6e83*/, "[?] " /*6e84*/, "Jian " /*6e85*/, "Xu " /*6e86*/, "Lu " /*6e87*/, "Gui " /*6e88*/, "Gai " /*6e89*/, "[?] " /*6e8a*/, "[?] " /*6e8b*/, "Po " /*6e8c*/, "Jin " /*6e8d*/, "Gui " /*6e8e*/, "Tang " /*6e8f*/, "Yuan " /*6e90*/, "Suo " /*6e91*/, "Yuan " /*6e92*/, "Lian " /*6e93*/, "Yao " /*6e94*/, "Meng " /*6e95*/, "Zhun " /*6e96*/, "Sheng " /*6e97*/, "Ke " /*6e98*/, "Tai " /*6e99*/, "Da " /*6e9a*/, "Wa " /*6e9b*/, "Liu " /*6e9c*/, "Gou " /*6e9d*/, "Sao " /*6e9e*/, "Ming " /*6e9f*/, "Zha " /*6ea0*/, "Shi " /*6ea1*/, "Yi " /*6ea2*/, "Lun " /*6ea3*/, "Ma " /*6ea4*/, "Pu " /*6ea5*/, "Wei " /*6ea6*/, "Li " /*6ea7*/, "Cai " /*6ea8*/, "Wu " /*6ea9*/, "Xi " /*6eaa*/, "Wen " /*6eab*/, "Qiang " /*6eac*/, "Ze " /*6ead*/, "Shi " /*6eae*/, "Su " /*6eaf*/, "Yi " /*6eb0*/, "Zhen " /*6eb1*/, "Sou " /*6eb2*/, "Yun " /*6eb3*/, "Xiu " /*6eb4*/, "Yin " /*6eb5*/, "Rong " /*6eb6*/, "Hun " /*6eb7*/, "Su " /*6eb8*/, "Su " /*6eb9*/, "Ni " /*6eba*/, "Ta " /*6ebb*/, "Shi " /*6ebc*/, "Ru " /*6ebd*/, "Wei " /*6ebe*/, "Pan " /*6ebf*/, "Chu " /*6ec0*/, "Chu " /*6ec1*/, "Pang " /*6ec2*/, "Weng " /*6ec3*/, "Cang " /*6ec4*/, "Mie " /*6ec5*/, "He " /*6ec6*/, "Dian " /*6ec7*/, "Hao " /*6ec8*/, "Huang " /*6ec9*/, "Xi " /*6eca*/, "Zi " /*6ecb*/, "Di " /*6ecc*/, "Zhi " /*6ecd*/, "Ying " /*6ece*/, "Fu " /*6ecf*/, "Jie " /*6ed0*/, "Hua " /*6ed1*/, "Ge " /*6ed2*/, "Zi " /*6ed3*/, "Tao " /*6ed4*/, "Teng " /*6ed5*/, "Sui " /*6ed6*/, "Bi " /*6ed7*/, "Jiao " /*6ed8*/, "Hui " /*6ed9*/, "Gun " /*6eda*/, "Yin " /*6edb*/, "Gao " /*6edc*/, "Long " /*6edd*/, "Zhi " /*6ede*/, "Yan " /*6edf*/, "She " /*6ee0*/, "Man " /*6ee1*/, "Ying " /*6ee2*/, "Chun " /*6ee3*/, "Lu " /*6ee4*/, "Lan " /*6ee5*/, "Luan " /*6ee6*/, "[?] " /*6ee7*/, "Bin " /*6ee8*/, "Tan " /*6ee9*/, "Yu " /*6eea*/, "Sou " /*6eeb*/, "Hu " /*6eec*/, "Bi " /*6eed*/, "Biao " /*6eee*/, "Zhi " /*6eef*/, "Jiang " /*6ef0*/, "Kou " /*6ef1*/, "Shen " /*6ef2*/, "Shang " /*6ef3*/, "Di " /*6ef4*/, "Mi " /*6ef5*/, "Ao " /*6ef6*/, "Lu " /*6ef7*/, "Hu " /*6ef8*/, "Hu " /*6ef9*/, "You " /*6efa*/, "Chan " /*6efb*/, "Fan " /*6efc*/, "Yong " /*6efd*/, "Gun " /*6efe*/, "Man " /*6eff*/ 
			});
						characters.TryAdd(111 /*28416 6f*/, new string[] {
				"Qing " /*6f00*/, "Yu " /*6f01*/, "Piao " /*6f02*/, "Ji " /*6f03*/, "Ya " /*6f04*/, "Jiao " /*6f05*/, "Qi " /*6f06*/, "Xi " /*6f07*/, "Ji " /*6f08*/, "Lu " /*6f09*/, "Lu " /*6f0a*/, "Long " /*6f0b*/, "Jin " /*6f0c*/, "Guo " /*6f0d*/, "Cong " /*6f0e*/, "Lou " /*6f0f*/, "Zhi " /*6f10*/, "Gai " /*6f11*/, "Qiang " /*6f12*/, "Li " /*6f13*/, "Yan " /*6f14*/, "Cao " /*6f15*/, "Jiao " /*6f16*/, "Cong " /*6f17*/, "Qun " /*6f18*/, "Tuan " /*6f19*/, "Ou " /*6f1a*/, "Teng " /*6f1b*/, "Ye " /*6f1c*/, "Xi " /*6f1d*/, "Mi " /*6f1e*/, "Tang " /*6f1f*/, "Mo " /*6f20*/, "Shang " /*6f21*/, "Han " /*6f22*/, "Lian " /*6f23*/, "Lan " /*6f24*/, "Wa " /*6f25*/, "Li " /*6f26*/, "Qian " /*6f27*/, "Feng " /*6f28*/, "Xuan " /*6f29*/, "Yi " /*6f2a*/, "Man " /*6f2b*/, "Zi " /*6f2c*/, "Mang " /*6f2d*/, "Kang " /*6f2e*/, "Lei " /*6f2f*/, "Peng " /*6f30*/, "Shu " /*6f31*/, "Zhang " /*6f32*/, "Zhang " /*6f33*/, "Chong " /*6f34*/, "Xu " /*6f35*/, "Huan " /*6f36*/, "Kuo " /*6f37*/, "Jian " /*6f38*/, "Yan " /*6f39*/, "Chuang " /*6f3a*/, "Liao " /*6f3b*/, "Cui " /*6f3c*/, "Ti " /*6f3d*/, "Yang " /*6f3e*/, "Jiang " /*6f3f*/, "Cong " /*6f40*/, "Ying " /*6f41*/, "Hong " /*6f42*/, "Xun " /*6f43*/, "Shu " /*6f44*/, "Guan " /*6f45*/, "Ying " /*6f46*/, "Xiao " /*6f47*/, "[?] " /*6f48*/, "[?] " /*6f49*/, "Xu " /*6f4a*/, "Lian " /*6f4b*/, "Zhi " /*6f4c*/, "Wei " /*6f4d*/, "Pi " /*6f4e*/, "Jue " /*6f4f*/, "Jiao " /*6f50*/, "Po " /*6f51*/, "Dang " /*6f52*/, "Hui " /*6f53*/, "Jie " /*6f54*/, "Wu " /*6f55*/, "Pa " /*6f56*/, "Ji " /*6f57*/, "Pan " /*6f58*/, "Gui " /*6f59*/, "Xiao " /*6f5a*/, "Qian " /*6f5b*/, "Qian " /*6f5c*/, "Xi " /*6f5d*/, "Lu " /*6f5e*/, "Xi " /*6f5f*/, "Xuan " /*6f60*/, "Dun " /*6f61*/, "Huang " /*6f62*/, "Min " /*6f63*/, "Run " /*6f64*/, "Su " /*6f65*/, "Liao " /*6f66*/, "Zhen " /*6f67*/, "Zhong " /*6f68*/, "Yi " /*6f69*/, "Di " /*6f6a*/, "Wan " /*6f6b*/, "Dan " /*6f6c*/, "Tan " /*6f6d*/, "Chao " /*6f6e*/, "Xun " /*6f6f*/, "Kui " /*6f70*/, "Yie " /*6f71*/, "Shao " /*6f72*/, "Tu " /*6f73*/, "Zhu " /*6f74*/, "San " /*6f75*/, "Hei " /*6f76*/, "Bi " /*6f77*/, "Shan " /*6f78*/, "Chan " /*6f79*/, "Chan " /*6f7a*/, "Shu " /*6f7b*/, "Tong " /*6f7c*/, "Pu " /*6f7d*/, "Lin " /*6f7e*/, "Wei " /*6f7f*/, "Se " /*6f80*/, "Se " /*6f81*/, "Cheng " /*6f82*/, "Jiong " /*6f83*/, "Cheng " /*6f84*/, "Hua " /*6f85*/, "Jiao " /*6f86*/, "Lao " /*6f87*/, "Che " /*6f88*/, "Gan " /*6f89*/, "Cun " /*6f8a*/, "Heng " /*6f8b*/, "Si " /*6f8c*/, "Shu " /*6f8d*/, "Peng " /*6f8e*/, "Han " /*6f8f*/, "Yun " /*6f90*/, "Liu " /*6f91*/, "Hong " /*6f92*/, "Fu " /*6f93*/, "Hao " /*6f94*/, "He " /*6f95*/, "Xian " /*6f96*/, "Jian " /*6f97*/, "Shan " /*6f98*/, "Xi " /*6f99*/, "Oki " /*6f9a*/, "[?] " /*6f9b*/, "Lan " /*6f9c*/, "[?] " /*6f9d*/, "Yu " /*6f9e*/, "Lin " /*6f9f*/, "Min " /*6fa0*/, "Zao " /*6fa1*/, "Dang " /*6fa2*/, "Wan " /*6fa3*/, "Ze " /*6fa4*/, "Xie " /*6fa5*/, "Yu " /*6fa6*/, "Li " /*6fa7*/, "Shi " /*6fa8*/, "Xue " /*6fa9*/, "Ling " /*6faa*/, "Man " /*6fab*/, "Zi " /*6fac*/, "Yong " /*6fad*/, "Kuai " /*6fae*/, "Can " /*6faf*/, "Lian " /*6fb0*/, "Dian " /*6fb1*/, "Ye " /*6fb2*/, "Ao " /*6fb3*/, "Huan " /*6fb4*/, "Zhen " /*6fb5*/, "Chan " /*6fb6*/, "Man " /*6fb7*/, "Dan " /*6fb8*/, "Dan " /*6fb9*/, "Yi " /*6fba*/, "Sui " /*6fbb*/, "Pi " /*6fbc*/, "Ju " /*6fbd*/, "Ta " /*6fbe*/, "Qin " /*6fbf*/, "Ji " /*6fc0*/, "Zhuo " /*6fc1*/, "Lian " /*6fc2*/, "Nong " /*6fc3*/, "Guo " /*6fc4*/, "Jin " /*6fc5*/, "Fen " /*6fc6*/, "Se " /*6fc7*/, "Ji " /*6fc8*/, "Sui " /*6fc9*/, "Hui " /*6fca*/, "Chu " /*6fcb*/, "Ta " /*6fcc*/, "Song " /*6fcd*/, "Ding " /*6fce*/, "[?] " /*6fcf*/, "Zhu " /*6fd0*/, "Lai " /*6fd1*/, "Bin " /*6fd2*/, "Lian " /*6fd3*/, "Mi " /*6fd4*/, "Shi " /*6fd5*/, "Shu " /*6fd6*/, "Mi " /*6fd7*/, "Ning " /*6fd8*/, "Ying " /*6fd9*/, "Ying " /*6fda*/, "Meng " /*6fdb*/, "Jin " /*6fdc*/, "Qi " /*6fdd*/, "Pi " /*6fde*/, "Ji " /*6fdf*/, "Hao " /*6fe0*/, "Ru " /*6fe1*/, "Zui " /*6fe2*/, "Wo " /*6fe3*/, "Tao " /*6fe4*/, "Yin " /*6fe5*/, "Yin " /*6fe6*/, "Dui " /*6fe7*/, "Ci " /*6fe8*/, "Huo " /*6fe9*/, "Jing " /*6fea*/, "Lan " /*6feb*/, "Jun " /*6fec*/, "Ai " /*6fed*/, "Pu " /*6fee*/, "Zhuo " /*6fef*/, "Wei " /*6ff0*/, "Bin " /*6ff1*/, "Gu " /*6ff2*/, "Qian " /*6ff3*/, "Xing " /*6ff4*/, "Hama " /*6ff5*/, "Kuo " /*6ff6*/, "Fei " /*6ff7*/, "[?] " /*6ff8*/, "Boku " /*6ff9*/, "Jian " /*6ffa*/, "Wei " /*6ffb*/, "Luo " /*6ffc*/, "Zan " /*6ffd*/, "Lu " /*6ffe*/, "Li " /*6fff*/ 
			});
						characters.TryAdd(112 /*28672 70*/, new string[] {
				"You " /*7000*/, "Yang " /*7001*/, "Lu " /*7002*/, "Si " /*7003*/, "Jie " /*7004*/, "Ying " /*7005*/, "Du " /*7006*/, "Wang " /*7007*/, "Hui " /*7008*/, "Xie " /*7009*/, "Pan " /*700a*/, "Shen " /*700b*/, "Biao " /*700c*/, "Chan " /*700d*/, "Mo " /*700e*/, "Liu " /*700f*/, "Jian " /*7010*/, "Pu " /*7011*/, "Se " /*7012*/, "Cheng " /*7013*/, "Gu " /*7014*/, "Bin " /*7015*/, "Huo " /*7016*/, "Xian " /*7017*/, "Lu " /*7018*/, "Qin " /*7019*/, "Han " /*701a*/, "Ying " /*701b*/, "Yong " /*701c*/, "Li " /*701d*/, "Jing " /*701e*/, "Xiao " /*701f*/, "Ying " /*7020*/, "Sui " /*7021*/, "Wei " /*7022*/, "Xie " /*7023*/, "Huai " /*7024*/, "Hao " /*7025*/, "Zhu " /*7026*/, "Long " /*7027*/, "Lai " /*7028*/, "Dui " /*7029*/, "Fan " /*702a*/, "Hu " /*702b*/, "Lai " /*702c*/, "[?] " /*702d*/, "[?] " /*702e*/, "Ying " /*702f*/, "Mi " /*7030*/, "Ji " /*7031*/, "Lian " /*7032*/, "Jian " /*7033*/, "Ying " /*7034*/, "Fen " /*7035*/, "Lin " /*7036*/, "Yi " /*7037*/, "Jian " /*7038*/, "Yue " /*7039*/, "Chan " /*703a*/, "Dai " /*703b*/, "Rang " /*703c*/, "Jian " /*703d*/, "Lan " /*703e*/, "Fan " /*703f*/, "Shuang " /*7040*/, "Yuan " /*7041*/, "Zhuo " /*7042*/, "Feng " /*7043*/, "She " /*7044*/, "Lei " /*7045*/, "Lan " /*7046*/, "Cong " /*7047*/, "Qu " /*7048*/, "Yong " /*7049*/, "Qian " /*704a*/, "Fa " /*704b*/, "Guan " /*704c*/, "Que " /*704d*/, "Yan " /*704e*/, "Hao " /*704f*/, "Hyeng " /*7050*/, "Sa " /*7051*/, "Zan " /*7052*/, "Luan " /*7053*/, "Yan " /*7054*/, "Li " /*7055*/, "Mi " /*7056*/, "Shan " /*7057*/, "Tan " /*7058*/, "Dang " /*7059*/, "Jiao " /*705a*/, "Chan " /*705b*/, "[?] " /*705c*/, "Hao " /*705d*/, "Ba " /*705e*/, "Zhu " /*705f*/, "Lan " /*7060*/, "Lan " /*7061*/, "Nang " /*7062*/, "Wan " /*7063*/, "Luan " /*7064*/, "Xun " /*7065*/, "Xian " /*7066*/, "Yan " /*7067*/, "Gan " /*7068*/, "Yan " /*7069*/, "Yu " /*706a*/, "Huo " /*706b*/, "Si " /*706c*/, "Mie " /*706d*/, "Guang " /*706e*/, "Deng " /*706f*/, "Hui " /*7070*/, "Xiao " /*7071*/, "Xiao " /*7072*/, "Hu " /*7073*/, "Hong " /*7074*/, "Ling " /*7075*/, "Zao " /*7076*/, "Zhuan " /*7077*/, "Jiu " /*7078*/, "Zha " /*7079*/, "Xie " /*707a*/, "Chi " /*707b*/, "Zhuo " /*707c*/, "Zai " /*707d*/, "Zai " /*707e*/, "Can " /*707f*/, "Yang " /*7080*/, "Qi " /*7081*/, "Zhong " /*7082*/, "Fen " /*7083*/, "Niu " /*7084*/, "Jiong " /*7085*/, "Wen " /*7086*/, "Po " /*7087*/, "Yi " /*7088*/, "Lu " /*7089*/, "Chui " /*708a*/, "Pi " /*708b*/, "Kai " /*708c*/, "Pan " /*708d*/, "Yan " /*708e*/, "Kai " /*708f*/, "Pang " /*7090*/, "Mu " /*7091*/, "Chao " /*7092*/, "Liao " /*7093*/, "Gui " /*7094*/, "Kang " /*7095*/, "Tun " /*7096*/, "Guang " /*7097*/, "Xin " /*7098*/, "Zhi " /*7099*/, "Guang " /*709a*/, "Guang " /*709b*/, "Wei " /*709c*/, "Qiang " /*709d*/, "[?] " /*709e*/, "Da " /*709f*/, "Xia " /*70a0*/, "Zheng " /*70a1*/, "Zhu " /*70a2*/, "Ke " /*70a3*/, "Zhao " /*70a4*/, "Fu " /*70a5*/, "Ba " /*70a6*/, "Duo " /*70a7*/, "Duo " /*70a8*/, "Ling " /*70a9*/, "Zhuo " /*70aa*/, "Xuan " /*70ab*/, "Ju " /*70ac*/, "Tan " /*70ad*/, "Pao " /*70ae*/, "Jiong " /*70af*/, "Pao " /*70b0*/, "Tai " /*70b1*/, "Tai " /*70b2*/, "Bing " /*70b3*/, "Yang " /*70b4*/, "Tong " /*70b5*/, "Han " /*70b6*/, "Zhu " /*70b7*/, "Zha " /*70b8*/, "Dian " /*70b9*/, "Wei " /*70ba*/, "Shi " /*70bb*/, "Lian " /*70bc*/, "Chi " /*70bd*/, "Huang " /*70be*/, "[?] " /*70bf*/, "Hu " /*70c0*/, "Shuo " /*70c1*/, "Lan " /*70c2*/, "Jing " /*70c3*/, "Jiao " /*70c4*/, "Xu " /*70c5*/, "Xing " /*70c6*/, "Quan " /*70c7*/, "Lie " /*70c8*/, "Huan " /*70c9*/, "Yang " /*70ca*/, "Xiao " /*70cb*/, "Xiu " /*70cc*/, "Xian " /*70cd*/, "Yin " /*70ce*/, "Wu " /*70cf*/, "Zhou " /*70d0*/, "Yao " /*70d1*/, "Shi " /*70d2*/, "Wei " /*70d3*/, "Tong " /*70d4*/, "Xue " /*70d5*/, "Zai " /*70d6*/, "Kai " /*70d7*/, "Hong " /*70d8*/, "Luo " /*70d9*/, "Xia " /*70da*/, "Zhu " /*70db*/, "Xuan " /*70dc*/, "Zheng " /*70dd*/, "Po " /*70de*/, "Yan " /*70df*/, "Hui " /*70e0*/, "Guang " /*70e1*/, "Zhe " /*70e2*/, "Hui " /*70e3*/, "Kao " /*70e4*/, "[?] " /*70e5*/, "Fan " /*70e6*/, "Shao " /*70e7*/, "Ye " /*70e8*/, "Hui " /*70e9*/, "[?] " /*70ea*/, "Tang " /*70eb*/, "Jin " /*70ec*/, "Re " /*70ed*/, "[?] " /*70ee*/, "Xi " /*70ef*/, "Fu " /*70f0*/, "Jiong " /*70f1*/, "Che " /*70f2*/, "Pu " /*70f3*/, "Jing " /*70f4*/, "Zhuo " /*70f5*/, "Ting " /*70f6*/, "Wan " /*70f7*/, "Hai " /*70f8*/, "Peng " /*70f9*/, "Lang " /*70fa*/, "Shan " /*70fb*/, "Hu " /*70fc*/, "Feng " /*70fd*/, "Chi " /*70fe*/, "Rong " /*70ff*/ 
			});
						characters.TryAdd(113 /*28928 71*/, new string[] {
				"Hu " /*7100*/, "Xi " /*7101*/, "Shu " /*7102*/, "He " /*7103*/, "Xun " /*7104*/, "Ku " /*7105*/, "Jue " /*7106*/, "Xiao " /*7107*/, "Xi " /*7108*/, "Yan " /*7109*/, "Han " /*710a*/, "Zhuang " /*710b*/, "Jun " /*710c*/, "Di " /*710d*/, "Xie " /*710e*/, "Ji " /*710f*/, "Wu " /*7110*/, "[?] " /*7111*/, "[?] " /*7112*/, "Han " /*7113*/, "Yan " /*7114*/, "Huan " /*7115*/, "Men " /*7116*/, "Ju " /*7117*/, "Chou " /*7118*/, "Bei " /*7119*/, "Fen " /*711a*/, "Lin " /*711b*/, "Kun " /*711c*/, "Hun " /*711d*/, "Tun " /*711e*/, "Xi " /*711f*/, "Cui " /*7120*/, "Wu " /*7121*/, "Hong " /*7122*/, "Ju " /*7123*/, "Fu " /*7124*/, "Wo " /*7125*/, "Jiao " /*7126*/, "Cong " /*7127*/, "Feng " /*7128*/, "Ping " /*7129*/, "Qiong " /*712a*/, "Ruo " /*712b*/, "Xi " /*712c*/, "Qiong " /*712d*/, "Xin " /*712e*/, "Zhuo " /*712f*/, "Yan " /*7130*/, "Yan " /*7131*/, "Yi " /*7132*/, "Jue " /*7133*/, "Yu " /*7134*/, "Gang " /*7135*/, "Ran " /*7136*/, "Pi " /*7137*/, "Gu " /*7138*/, "[?] " /*7139*/, "Sheng " /*713a*/, "Chang " /*713b*/, "Shao " /*713c*/, "[?] " /*713d*/, "[?] " /*713e*/, "[?] " /*713f*/, "[?] " /*7140*/, "Chen " /*7141*/, "He " /*7142*/, "Kui " /*7143*/, "Zhong " /*7144*/, "Duan " /*7145*/, "Xia " /*7146*/, "Hui " /*7147*/, "Feng " /*7148*/, "Lian " /*7149*/, "Xuan " /*714a*/, "Xing " /*714b*/, "Huang " /*714c*/, "Jiao " /*714d*/, "Jian " /*714e*/, "Bi " /*714f*/, "Ying " /*7150*/, "Zhu " /*7151*/, "Wei " /*7152*/, "Tuan " /*7153*/, "Tian " /*7154*/, "Xi " /*7155*/, "Nuan " /*7156*/, "Nuan " /*7157*/, "Chan " /*7158*/, "Yan " /*7159*/, "Jiong " /*715a*/, "Jiong " /*715b*/, "Yu " /*715c*/, "Mei " /*715d*/, "Sha " /*715e*/, "Wei " /*715f*/, "Ye " /*7160*/, "Xin " /*7161*/, "Qiong " /*7162*/, "Rou " /*7163*/, "Mei " /*7164*/, "Huan " /*7165*/, "Xu " /*7166*/, "Zhao " /*7167*/, "Wei " /*7168*/, "Fan " /*7169*/, "Qiu " /*716a*/, "Sui " /*716b*/, "Yang " /*716c*/, "Lie " /*716d*/, "Zhu " /*716e*/, "Jie " /*716f*/, "Gao " /*7170*/, "Gua " /*7171*/, "Bao " /*7172*/, "Hu " /*7173*/, "Yun " /*7174*/, "Xia " /*7175*/, "[?] " /*7176*/, "[?] " /*7177*/, "Bian " /*7178*/, "Gou " /*7179*/, "Tui " /*717a*/, "Tang " /*717b*/, "Chao " /*717c*/, "Shan " /*717d*/, "N " /*717e*/, "Bo " /*717f*/, "Huang " /*7180*/, "Xie " /*7181*/, "Xi " /*7182*/, "Wu " /*7183*/, "Xi " /*7184*/, "Yun " /*7185*/, "He " /*7186*/, "He " /*7187*/, "Xi " /*7188*/, "Yun " /*7189*/, "Xiong " /*718a*/, "Nai " /*718b*/, "Shan " /*718c*/, "Qiong " /*718d*/, "Yao " /*718e*/, "Xun " /*718f*/, "Mi " /*7190*/, "Lian " /*7191*/, "Ying " /*7192*/, "Wen " /*7193*/, "Rong " /*7194*/, "Oozutsu " /*7195*/, "[?] " /*7196*/, "Qiang " /*7197*/, "Liu " /*7198*/, "Xi " /*7199*/, "Bi " /*719a*/, "Biao " /*719b*/, "Zong " /*719c*/, "Lu " /*719d*/, "Jian " /*719e*/, "Shou " /*719f*/, "Yi " /*71a0*/, "Lou " /*71a1*/, "Feng " /*71a2*/, "Sui " /*71a3*/, "Yi " /*71a4*/, "Tong " /*71a5*/, "Jue " /*71a6*/, "Zong " /*71a7*/, "Yun " /*71a8*/, "Hu " /*71a9*/, "Yi " /*71aa*/, "Zhi " /*71ab*/, "Ao " /*71ac*/, "Wei " /*71ad*/, "Liao " /*71ae*/, "Han " /*71af*/, "Ou " /*71b0*/, "Re " /*71b1*/, "Jiong " /*71b2*/, "Man " /*71b3*/, "[?] " /*71b4*/, "Shang " /*71b5*/, "Cuan " /*71b6*/, "Zeng " /*71b7*/, "Jian " /*71b8*/, "Xi " /*71b9*/, "Xi " /*71ba*/, "Xi " /*71bb*/, "Yi " /*71bc*/, "Xiao " /*71bd*/, "Chi " /*71be*/, "Huang " /*71bf*/, "Chan " /*71c0*/, "Ye " /*71c1*/, "Qian " /*71c2*/, "Ran " /*71c3*/, "Yan " /*71c4*/, "Xian " /*71c5*/, "Qiao " /*71c6*/, "Zun " /*71c7*/, "Deng " /*71c8*/, "Dun " /*71c9*/, "Shen " /*71ca*/, "Jiao " /*71cb*/, "Fen " /*71cc*/, "Si " /*71cd*/, "Liao " /*71ce*/, "Yu " /*71cf*/, "Lin " /*71d0*/, "Tong " /*71d1*/, "Shao " /*71d2*/, "Fen " /*71d3*/, "Fan " /*71d4*/, "Yan " /*71d5*/, "Xun " /*71d6*/, "Lan " /*71d7*/, "Mei " /*71d8*/, "Tang " /*71d9*/, "Yi " /*71da*/, "Jing " /*71db*/, "Men " /*71dc*/, "[?] " /*71dd*/, "[?] " /*71de*/, "Ying " /*71df*/, "Yu " /*71e0*/, "Yi " /*71e1*/, "Xue " /*71e2*/, "Lan " /*71e3*/, "Tai " /*71e4*/, "Zao " /*71e5*/, "Can " /*71e6*/, "Sui " /*71e7*/, "Xi " /*71e8*/, "Que " /*71e9*/, "Cong " /*71ea*/, "Lian " /*71eb*/, "Hui " /*71ec*/, "Zhu " /*71ed*/, "Xie " /*71ee*/, "Ling " /*71ef*/, "Wei " /*71f0*/, "Yi " /*71f1*/, "Xie " /*71f2*/, "Zhao " /*71f3*/, "Hui " /*71f4*/, "Tatsu " /*71f5*/, "Nung " /*71f6*/, "Lan " /*71f7*/, "Ru " /*71f8*/, "Xian " /*71f9*/, "Kao " /*71fa*/, "Xun " /*71fb*/, "Jin " /*71fc*/, "Chou " /*71fd*/, "Chou " /*71fe*/, "Yao " /*71ff*/ 
			});
						characters.TryAdd(114 /*29184 72*/, new string[] {
				"He " /*7200*/, "Lan " /*7201*/, "Biao " /*7202*/, "Rong " /*7203*/, "Li " /*7204*/, "Mo " /*7205*/, "Bao " /*7206*/, "Ruo " /*7207*/, "Lu " /*7208*/, "La " /*7209*/, "Ao " /*720a*/, "Xun " /*720b*/, "Kuang " /*720c*/, "Shuo " /*720d*/, "[?] " /*720e*/, "Li " /*720f*/, "Lu " /*7210*/, "Jue " /*7211*/, "Liao " /*7212*/, "Yan " /*7213*/, "Xi " /*7214*/, "Xie " /*7215*/, "Long " /*7216*/, "Ye " /*7217*/, "[?] " /*7218*/, "Rang " /*7219*/, "Yue " /*721a*/, "Lan " /*721b*/, "Cong " /*721c*/, "Jue " /*721d*/, "Tong " /*721e*/, "Guan " /*721f*/, "[?] " /*7220*/, "Che " /*7221*/, "Mi " /*7222*/, "Tang " /*7223*/, "Lan " /*7224*/, "Zhu " /*7225*/, "[?] " /*7226*/, "Ling " /*7227*/, "Cuan " /*7228*/, "Yu " /*7229*/, "Zhua " /*722a*/, "Tsumekanmuri " /*722b*/, "Pa " /*722c*/, "Zheng " /*722d*/, "Pao " /*722e*/, "Cheng " /*722f*/, "Yuan " /*7230*/, "Ai " /*7231*/, "Wei " /*7232*/, "[?] " /*7233*/, "Jue " /*7234*/, "Jue " /*7235*/, "Fu " /*7236*/, "Ye " /*7237*/, "Ba " /*7238*/, "Die " /*7239*/, "Ye " /*723a*/, "Yao " /*723b*/, "Zu " /*723c*/, "Shuang " /*723d*/, "Er " /*723e*/, "Qiang " /*723f*/, "Chuang " /*7240*/, "Ge " /*7241*/, "Zang " /*7242*/, "Die " /*7243*/, "Qiang " /*7244*/, "Yong " /*7245*/, "Qiang " /*7246*/, "Pian " /*7247*/, "Ban " /*7248*/, "Pan " /*7249*/, "Shao " /*724a*/, "Jian " /*724b*/, "Pai " /*724c*/, "Du " /*724d*/, "Chuang " /*724e*/, "Tou " /*724f*/, "Zha " /*7250*/, "Bian " /*7251*/, "Die " /*7252*/, "Bang " /*7253*/, "Bo " /*7254*/, "Chuang " /*7255*/, "You " /*7256*/, "[?] " /*7257*/, "Du " /*7258*/, "Ya " /*7259*/, "Cheng " /*725a*/, "Niu " /*725b*/, "Ushihen " /*725c*/, "Pin " /*725d*/, "Jiu " /*725e*/, "Mou " /*725f*/, "Tuo " /*7260*/, "Mu " /*7261*/, "Lao " /*7262*/, "Ren " /*7263*/, "Mang " /*7264*/, "Fang " /*7265*/, "Mao " /*7266*/, "Mu " /*7267*/, "Gang " /*7268*/, "Wu " /*7269*/, "Yan " /*726a*/, "Ge " /*726b*/, "Bei " /*726c*/, "Si " /*726d*/, "Jian " /*726e*/, "Gu " /*726f*/, "You " /*7270*/, "Ge " /*7271*/, "Sheng " /*7272*/, "Mu " /*7273*/, "Di " /*7274*/, "Qian " /*7275*/, "Quan " /*7276*/, "Quan " /*7277*/, "Zi " /*7278*/, "Te " /*7279*/, "Xi " /*727a*/, "Mang " /*727b*/, "Keng " /*727c*/, "Qian " /*727d*/, "Wu " /*727e*/, "Gu " /*727f*/, "Xi " /*7280*/, "Li " /*7281*/, "Li " /*7282*/, "Pou " /*7283*/, "Ji " /*7284*/, "Gang " /*7285*/, "Zhi " /*7286*/, "Ben " /*7287*/, "Quan " /*7288*/, "Run " /*7289*/, "Du " /*728a*/, "Ju " /*728b*/, "Jia " /*728c*/, "Jian " /*728d*/, "Feng " /*728e*/, "Pian " /*728f*/, "Ke " /*7290*/, "Ju " /*7291*/, "Kao " /*7292*/, "Chu " /*7293*/, "Xi " /*7294*/, "Bei " /*7295*/, "Luo " /*7296*/, "Jie " /*7297*/, "Ma " /*7298*/, "San " /*7299*/, "Wei " /*729a*/, "Li " /*729b*/, "Dun " /*729c*/, "Tong " /*729d*/, "[?] " /*729e*/, "Jiang " /*729f*/, "Ikenie " /*72a0*/, "Li " /*72a1*/, "Du " /*72a2*/, "Lie " /*72a3*/, "Pi " /*72a4*/, "Piao " /*72a5*/, "Bao " /*72a6*/, "Xi " /*72a7*/, "Chou " /*72a8*/, "Wei " /*72a9*/, "Kui " /*72aa*/, "Chou " /*72ab*/, "Quan " /*72ac*/, "Fan " /*72ad*/, "Ba " /*72ae*/, "Fan " /*72af*/, "Qiu " /*72b0*/, "Ji " /*72b1*/, "Cai " /*72b2*/, "Chuo " /*72b3*/, "An " /*72b4*/, "Jie " /*72b5*/, "Zhuang " /*72b6*/, "Guang " /*72b7*/, "Ma " /*72b8*/, "You " /*72b9*/, "Kang " /*72ba*/, "Bo " /*72bb*/, "Hou " /*72bc*/, "Ya " /*72bd*/, "Yin " /*72be*/, "Huan " /*72bf*/, "Zhuang " /*72c0*/, "Yun " /*72c1*/, "Kuang " /*72c2*/, "Niu " /*72c3*/, "Di " /*72c4*/, "Qing " /*72c5*/, "Zhong " /*72c6*/, "Mu " /*72c7*/, "Bei " /*72c8*/, "Pi " /*72c9*/, "Ju " /*72ca*/, "Ni " /*72cb*/, "Sheng " /*72cc*/, "Pao " /*72cd*/, "Xia " /*72ce*/, "Tuo " /*72cf*/, "Hu " /*72d0*/, "Ling " /*72d1*/, "Fei " /*72d2*/, "Pi " /*72d3*/, "Ni " /*72d4*/, "Ao " /*72d5*/, "You " /*72d6*/, "Gou " /*72d7*/, "Yue " /*72d8*/, "Ju " /*72d9*/, "Dan " /*72da*/, "Po " /*72db*/, "Gu " /*72dc*/, "Xian " /*72dd*/, "Ning " /*72de*/, "Huan " /*72df*/, "Hen " /*72e0*/, "Jiao " /*72e1*/, "He " /*72e2*/, "Zhao " /*72e3*/, "Ji " /*72e4*/, "Xun " /*72e5*/, "Shan " /*72e6*/, "Ta " /*72e7*/, "Rong " /*72e8*/, "Shou " /*72e9*/, "Tong " /*72ea*/, "Lao " /*72eb*/, "Du " /*72ec*/, "Xia " /*72ed*/, "Shi " /*72ee*/, "Hua " /*72ef*/, "Zheng " /*72f0*/, "Yu " /*72f1*/, "Sun " /*72f2*/, "Yu " /*72f3*/, "Bi " /*72f4*/, "Mang " /*72f5*/, "Xi " /*72f6*/, "Juan " /*72f7*/, "Li " /*72f8*/, "Xia " /*72f9*/, "Yin " /*72fa*/, "Suan " /*72fb*/, "Lang " /*72fc*/, "Bei " /*72fd*/, "Zhi " /*72fe*/, "Yan " /*72ff*/ 
			});
						characters.TryAdd(115 /*29440 73*/, new string[] {
				"Sha " /*7300*/, "Li " /*7301*/, "Han " /*7302*/, "Xian " /*7303*/, "Jing " /*7304*/, "Pai " /*7305*/, "Fei " /*7306*/, "Yao " /*7307*/, "Ba " /*7308*/, "Qi " /*7309*/, "Ni " /*730a*/, "Biao " /*730b*/, "Yin " /*730c*/, "Lai " /*730d*/, "Xi " /*730e*/, "Jian " /*730f*/, "Qiang " /*7310*/, "Kun " /*7311*/, "Yan " /*7312*/, "Guo " /*7313*/, "Zong " /*7314*/, "Mi " /*7315*/, "Chang " /*7316*/, "Yi " /*7317*/, "Zhi " /*7318*/, "Zheng " /*7319*/, "Ya " /*731a*/, "Meng " /*731b*/, "Cai " /*731c*/, "Cu " /*731d*/, "She " /*731e*/, "Kari " /*731f*/, "Cen " /*7320*/, "Luo " /*7321*/, "Hu " /*7322*/, "Zong " /*7323*/, "Ji " /*7324*/, "Wei " /*7325*/, "Feng " /*7326*/, "Wo " /*7327*/, "Yuan " /*7328*/, "Xing " /*7329*/, "Zhu " /*732a*/, "Mao " /*732b*/, "Wei " /*732c*/, "Yuan " /*732d*/, "Xian " /*732e*/, "Tuan " /*732f*/, "Ya " /*7330*/, "Nao " /*7331*/, "Xie " /*7332*/, "Jia " /*7333*/, "Hou " /*7334*/, "Bian " /*7335*/, "You " /*7336*/, "You " /*7337*/, "Mei " /*7338*/, "Zha " /*7339*/, "Yao " /*733a*/, "Sun " /*733b*/, "Bo " /*733c*/, "Ming " /*733d*/, "Hua " /*733e*/, "Yuan " /*733f*/, "Sou " /*7340*/, "Ma " /*7341*/, "Yuan " /*7342*/, "Dai " /*7343*/, "Yu " /*7344*/, "Shi " /*7345*/, "Hao " /*7346*/, "[?] " /*7347*/, "Yi " /*7348*/, "Zhen " /*7349*/, "Chuang " /*734a*/, "Hao " /*734b*/, "Man " /*734c*/, "Jing " /*734d*/, "Jiang " /*734e*/, "Mu " /*734f*/, "Zhang " /*7350*/, "Chan " /*7351*/, "Ao " /*7352*/, "Ao " /*7353*/, "Hao " /*7354*/, "Cui " /*7355*/, "Fen " /*7356*/, "Jue " /*7357*/, "Bi " /*7358*/, "Bi " /*7359*/, "Huang " /*735a*/, "Pu " /*735b*/, "Lin " /*735c*/, "Yu " /*735d*/, "Tong " /*735e*/, "Yao " /*735f*/, "Liao " /*7360*/, "Shuo " /*7361*/, "Xiao " /*7362*/, "Swu " /*7363*/, "Ton " /*7364*/, "Xi " /*7365*/, "Ge " /*7366*/, "Juan " /*7367*/, "Du " /*7368*/, "Hui " /*7369*/, "Kuai " /*736a*/, "Xian " /*736b*/, "Xie " /*736c*/, "Ta " /*736d*/, "Xian " /*736e*/, "Xun " /*736f*/, "Ning " /*7370*/, "Pin " /*7371*/, "Huo " /*7372*/, "Nou " /*7373*/, "Meng " /*7374*/, "Lie " /*7375*/, "Nao " /*7376*/, "Guang " /*7377*/, "Shou " /*7378*/, "Lu " /*7379*/, "Ta " /*737a*/, "Xian " /*737b*/, "Mi " /*737c*/, "Rang " /*737d*/, "Huan " /*737e*/, "Nao " /*737f*/, "Luo " /*7380*/, "Xian " /*7381*/, "Qi " /*7382*/, "Jue " /*7383*/, "Xuan " /*7384*/, "Miao " /*7385*/, "Zi " /*7386*/, "Lu " /*7387*/, "Lu " /*7388*/, "Yu " /*7389*/, "Su " /*738a*/, "Wang " /*738b*/, "Qiu " /*738c*/, "Ga " /*738d*/, "Ding " /*738e*/, "Le " /*738f*/, "Ba " /*7390*/, "Ji " /*7391*/, "Hong " /*7392*/, "Di " /*7393*/, "Quan " /*7394*/, "Gan " /*7395*/, "Jiu " /*7396*/, "Yu " /*7397*/, "Ji " /*7398*/, "Yu " /*7399*/, "Yang " /*739a*/, "Ma " /*739b*/, "Gong " /*739c*/, "Wu " /*739d*/, "Fu " /*739e*/, "Wen " /*739f*/, "Jie " /*73a0*/, "Ya " /*73a1*/, "Fen " /*73a2*/, "Bian " /*73a3*/, "Beng " /*73a4*/, "Yue " /*73a5*/, "Jue " /*73a6*/, "Yun " /*73a7*/, "Jue " /*73a8*/, "Wan " /*73a9*/, "Jian " /*73aa*/, "Mei " /*73ab*/, "Dan " /*73ac*/, "Pi " /*73ad*/, "Wei " /*73ae*/, "Huan " /*73af*/, "Xian " /*73b0*/, "Qiang " /*73b1*/, "Ling " /*73b2*/, "Dai " /*73b3*/, "Yi " /*73b4*/, "An " /*73b5*/, "Ping " /*73b6*/, "Dian " /*73b7*/, "Fu " /*73b8*/, "Xuan " /*73b9*/, "Xi " /*73ba*/, "Bo " /*73bb*/, "Ci " /*73bc*/, "Gou " /*73bd*/, "Jia " /*73be*/, "Shao " /*73bf*/, "Po " /*73c0*/, "Ci " /*73c1*/, "Ke " /*73c2*/, "Ran " /*73c3*/, "Sheng " /*73c4*/, "Shen " /*73c5*/, "Yi " /*73c6*/, "Zu " /*73c7*/, "Jia " /*73c8*/, "Min " /*73c9*/, "Shan " /*73ca*/, "Liu " /*73cb*/, "Bi " /*73cc*/, "Zhen " /*73cd*/, "Zhen " /*73ce*/, "Jue " /*73cf*/, "Fa " /*73d0*/, "Long " /*73d1*/, "Jin " /*73d2*/, "Jiao " /*73d3*/, "Jian " /*73d4*/, "Li " /*73d5*/, "Guang " /*73d6*/, "Xian " /*73d7*/, "Zhou " /*73d8*/, "Gong " /*73d9*/, "Yan " /*73da*/, "Xiu " /*73db*/, "Yang " /*73dc*/, "Xu " /*73dd*/, "Luo " /*73de*/, "Su " /*73df*/, "Zhu " /*73e0*/, "Qin " /*73e1*/, "Ken " /*73e2*/, "Xun " /*73e3*/, "Bao " /*73e4*/, "Er " /*73e5*/, "Xiang " /*73e6*/, "Yao " /*73e7*/, "Xia " /*73e8*/, "Heng " /*73e9*/, "Gui " /*73ea*/, "Chong " /*73eb*/, "Xu " /*73ec*/, "Ban " /*73ed*/, "Pei " /*73ee*/, "[?] " /*73ef*/, "Dang " /*73f0*/, "Ei " /*73f1*/, "Hun " /*73f2*/, "Wen " /*73f3*/, "E " /*73f4*/, "Cheng " /*73f5*/, "Ti " /*73f6*/, "Wu " /*73f7*/, "Wu " /*73f8*/, "Cheng " /*73f9*/, "Jun " /*73fa*/, "Mei " /*73fb*/, "Bei " /*73fc*/, "Ting " /*73fd*/, "Xian " /*73fe*/, "Chuo " /*73ff*/ 
			});
						characters.TryAdd(116 /*29696 74*/, new string[] {
				"Han " /*7400*/, "Xuan " /*7401*/, "Yan " /*7402*/, "Qiu " /*7403*/, "Quan " /*7404*/, "Lang " /*7405*/, "Li " /*7406*/, "Xiu " /*7407*/, "Fu " /*7408*/, "Liu " /*7409*/, "Ye " /*740a*/, "Xi " /*740b*/, "Ling " /*740c*/, "Li " /*740d*/, "Jin " /*740e*/, "Lian " /*740f*/, "Suo " /*7410*/, "Chiisai " /*7411*/, "[?] " /*7412*/, "Wan " /*7413*/, "Dian " /*7414*/, "Pin " /*7415*/, "Zhan " /*7416*/, "Cui " /*7417*/, "Min " /*7418*/, "Yu " /*7419*/, "Ju " /*741a*/, "Chen " /*741b*/, "Lai " /*741c*/, "Wen " /*741d*/, "Sheng " /*741e*/, "Wei " /*741f*/, "Dian " /*7420*/, "Chu " /*7421*/, "Zhuo " /*7422*/, "Pei " /*7423*/, "Cheng " /*7424*/, "Hu " /*7425*/, "Qi " /*7426*/, "E " /*7427*/, "Kun " /*7428*/, "Chang " /*7429*/, "Qi " /*742a*/, "Beng " /*742b*/, "Wan " /*742c*/, "Lu " /*742d*/, "Cong " /*742e*/, "Guan " /*742f*/, "Yan " /*7430*/, "Diao " /*7431*/, "Bei " /*7432*/, "Lin " /*7433*/, "Qin " /*7434*/, "Pi " /*7435*/, "Pa " /*7436*/, "Que " /*7437*/, "Zhuo " /*7438*/, "Qin " /*7439*/, "Fa " /*743a*/, "[?] " /*743b*/, "Qiong " /*743c*/, "Du " /*743d*/, "Jie " /*743e*/, "Hun " /*743f*/, "Yu " /*7440*/, "Mao " /*7441*/, "Mei " /*7442*/, "Chun " /*7443*/, "Xuan " /*7444*/, "Ti " /*7445*/, "Xing " /*7446*/, "Dai " /*7447*/, "Rou " /*7448*/, "Min " /*7449*/, "Zhen " /*744a*/, "Wei " /*744b*/, "Ruan " /*744c*/, "Huan " /*744d*/, "Jie " /*744e*/, "Chuan " /*744f*/, "Jian " /*7450*/, "Zhuan " /*7451*/, "Yang " /*7452*/, "Lian " /*7453*/, "Quan " /*7454*/, "Xia " /*7455*/, "Duan " /*7456*/, "Yuan " /*7457*/, "Ye " /*7458*/, "Nao " /*7459*/, "Hu " /*745a*/, "Ying " /*745b*/, "Yu " /*745c*/, "Huang " /*745d*/, "Rui " /*745e*/, "Se " /*745f*/, "Liu " /*7460*/, "Shi " /*7461*/, "Rong " /*7462*/, "Suo " /*7463*/, "Yao " /*7464*/, "Wen " /*7465*/, "Wu " /*7466*/, "Jin " /*7467*/, "Jin " /*7468*/, "Ying " /*7469*/, "Ma " /*746a*/, "Tao " /*746b*/, "Liu " /*746c*/, "Tang " /*746d*/, "Li " /*746e*/, "Lang " /*746f*/, "Gui " /*7470*/, "Zhen " /*7471*/, "Qiang " /*7472*/, "Cuo " /*7473*/, "Jue " /*7474*/, "Zhao " /*7475*/, "Yao " /*7476*/, "Ai " /*7477*/, "Bin " /*7478*/, "Tu " /*7479*/, "Chang " /*747a*/, "Kun " /*747b*/, "Zhuan " /*747c*/, "Cong " /*747d*/, "Jin " /*747e*/, "Yi " /*747f*/, "Cui " /*7480*/, "Cong " /*7481*/, "Qi " /*7482*/, "Li " /*7483*/, "Ying " /*7484*/, "Suo " /*7485*/, "Qiu " /*7486*/, "Xuan " /*7487*/, "Ao " /*7488*/, "Lian " /*7489*/, "Man " /*748a*/, "Zhang " /*748b*/, "Yin " /*748c*/, "[?] " /*748d*/, "Ying " /*748e*/, "Zhi " /*748f*/, "Lu " /*7490*/, "Wu " /*7491*/, "Deng " /*7492*/, "Xiou " /*7493*/, "Zeng " /*7494*/, "Xun " /*7495*/, "Qu " /*7496*/, "Dang " /*7497*/, "Lin " /*7498*/, "Liao " /*7499*/, "Qiong " /*749a*/, "Su " /*749b*/, "Huang " /*749c*/, "Gui " /*749d*/, "Pu " /*749e*/, "Jing " /*749f*/, "Fan " /*74a0*/, "Jin " /*74a1*/, "Liu " /*74a2*/, "Ji " /*74a3*/, "[?] " /*74a4*/, "Jing " /*74a5*/, "Ai " /*74a6*/, "Bi " /*74a7*/, "Can " /*74a8*/, "Qu " /*74a9*/, "Zao " /*74aa*/, "Dang " /*74ab*/, "Jiao " /*74ac*/, "Gun " /*74ad*/, "Tan " /*74ae*/, "Hui " /*74af*/, "Huan " /*74b0*/, "Se " /*74b1*/, "Sui " /*74b2*/, "Tian " /*74b3*/, "[?] " /*74b4*/, "Yu " /*74b5*/, "Jin " /*74b6*/, "Lu " /*74b7*/, "Bin " /*74b8*/, "Shou " /*74b9*/, "Wen " /*74ba*/, "Zui " /*74bb*/, "Lan " /*74bc*/, "Xi " /*74bd*/, "Ji " /*74be*/, "Xuan " /*74bf*/, "Ruan " /*74c0*/, "Huo " /*74c1*/, "Gai " /*74c2*/, "Lei " /*74c3*/, "Du " /*74c4*/, "Li " /*74c5*/, "Zhi " /*74c6*/, "Rou " /*74c7*/, "Li " /*74c8*/, "Zan " /*74c9*/, "Qiong " /*74ca*/, "Zhe " /*74cb*/, "Gui " /*74cc*/, "Sui " /*74cd*/, "La " /*74ce*/, "Long " /*74cf*/, "Lu " /*74d0*/, "Li " /*74d1*/, "Zan " /*74d2*/, "Lan " /*74d3*/, "Ying " /*74d4*/, "Mi " /*74d5*/, "Xiang " /*74d6*/, "Xi " /*74d7*/, "Guan " /*74d8*/, "Dao " /*74d9*/, "Zan " /*74da*/, "Huan " /*74db*/, "Gua " /*74dc*/, "Bo " /*74dd*/, "Die " /*74de*/, "Bao " /*74df*/, "Hu " /*74e0*/, "Zhi " /*74e1*/, "Piao " /*74e2*/, "Ban " /*74e3*/, "Rang " /*74e4*/, "Li " /*74e5*/, "Wa " /*74e6*/, "Dekaguramu " /*74e7*/, "Jiang " /*74e8*/, "Qian " /*74e9*/, "Fan " /*74ea*/, "Pen " /*74eb*/, "Fang " /*74ec*/, "Dan " /*74ed*/, "Weng " /*74ee*/, "Ou " /*74ef*/, "Deshiguramu " /*74f0*/, "Miriguramu " /*74f1*/, "Thon " /*74f2*/, "Hu " /*74f3*/, "Ling " /*74f4*/, "Yi " /*74f5*/, "Ping " /*74f6*/, "Ci " /*74f7*/, "Hekutogura " /*74f8*/, "Juan " /*74f9*/, "Chang " /*74fa*/, "Chi " /*74fb*/, "Sarake " /*74fc*/, "Dang " /*74fd*/, "Meng " /*74fe*/, "Pou " /*74ff*/ 
			});
						characters.TryAdd(117 /*29952 75*/, new string[] {
				"Zhui " /*7500*/, "Ping " /*7501*/, "Bian " /*7502*/, "Zhou " /*7503*/, "Zhen " /*7504*/, "Senchigura " /*7505*/, "Ci " /*7506*/, "Ying " /*7507*/, "Qi " /*7508*/, "Xian " /*7509*/, "Lou " /*750a*/, "Di " /*750b*/, "Ou " /*750c*/, "Meng " /*750d*/, "Zhuan " /*750e*/, "Peng " /*750f*/, "Lin " /*7510*/, "Zeng " /*7511*/, "Wu " /*7512*/, "Pi " /*7513*/, "Dan " /*7514*/, "Weng " /*7515*/, "Ying " /*7516*/, "Yan " /*7517*/, "Gan " /*7518*/, "Dai " /*7519*/, "Shen " /*751a*/, "Tian " /*751b*/, "Tian " /*751c*/, "Han " /*751d*/, "Chang " /*751e*/, "Sheng " /*751f*/, "Qing " /*7520*/, "Sheng " /*7521*/, "Chan " /*7522*/, "Chan " /*7523*/, "Rui " /*7524*/, "Sheng " /*7525*/, "Su " /*7526*/, "Sen " /*7527*/, "Yong " /*7528*/, "Shuai " /*7529*/, "Lu " /*752a*/, "Fu " /*752b*/, "Yong " /*752c*/, "Beng " /*752d*/, "Feng " /*752e*/, "Ning " /*752f*/, "Tian " /*7530*/, "You " /*7531*/, "Jia " /*7532*/, "Shen " /*7533*/, "Zha " /*7534*/, "Dian " /*7535*/, "Fu " /*7536*/, "Nan " /*7537*/, "Dian " /*7538*/, "Ping " /*7539*/, "Ting " /*753a*/, "Hua " /*753b*/, "Ting " /*753c*/, "Quan " /*753d*/, "Zi " /*753e*/, "Meng " /*753f*/, "Bi " /*7540*/, "Qi " /*7541*/, "Liu " /*7542*/, "Xun " /*7543*/, "Liu " /*7544*/, "Chang " /*7545*/, "Mu " /*7546*/, "Yun " /*7547*/, "Fan " /*7548*/, "Fu " /*7549*/, "Geng " /*754a*/, "Tian " /*754b*/, "Jie " /*754c*/, "Jie " /*754d*/, "Quan " /*754e*/, "Wei " /*754f*/, "Fu " /*7550*/, "Tian " /*7551*/, "Mu " /*7552*/, "Tap " /*7553*/, "Pan " /*7554*/, "Jiang " /*7555*/, "Wa " /*7556*/, "Da " /*7557*/, "Nan " /*7558*/, "Liu " /*7559*/, "Ben " /*755a*/, "Zhen " /*755b*/, "Chu " /*755c*/, "Mu " /*755d*/, "Mu " /*755e*/, "Ce " /*755f*/, "Cen " /*7560*/, "Gai " /*7561*/, "Bi " /*7562*/, "Da " /*7563*/, "Zhi " /*7564*/, "Lue " /*7565*/, "Qi " /*7566*/, "Lue " /*7567*/, "Pan " /*7568*/, "Kesa " /*7569*/, "Fan " /*756a*/, "Hua " /*756b*/, "Yu " /*756c*/, "Yu " /*756d*/, "Mu " /*756e*/, "Jun " /*756f*/, "Yi " /*7570*/, "Liu " /*7571*/, "Yu " /*7572*/, "Die " /*7573*/, "Chou " /*7574*/, "Hua " /*7575*/, "Dang " /*7576*/, "Chuo " /*7577*/, "Ji " /*7578*/, "Wan " /*7579*/, "Jiang " /*757a*/, "Sheng " /*757b*/, "Chang " /*757c*/, "Tuan " /*757d*/, "Lei " /*757e*/, "Ji " /*757f*/, "Cha " /*7580*/, "Liu " /*7581*/, "Tatamu " /*7582*/, "Tuan " /*7583*/, "Lin " /*7584*/, "Jiang " /*7585*/, "Jiang " /*7586*/, "Chou " /*7587*/, "Bo " /*7588*/, "Die " /*7589*/, "Die " /*758a*/, "Pi " /*758b*/, "Nie " /*758c*/, "Dan " /*758d*/, "Shu " /*758e*/, "Shu " /*758f*/, "Zhi " /*7590*/, "Yi " /*7591*/, "Chuang " /*7592*/, "Nai " /*7593*/, "Ding " /*7594*/, "Bi " /*7595*/, "Jie " /*7596*/, "Liao " /*7597*/, "Gong " /*7598*/, "Ge " /*7599*/, "Jiu " /*759a*/, "Zhou " /*759b*/, "Xia " /*759c*/, "Shan " /*759d*/, "Xu " /*759e*/, "Nue " /*759f*/, "Li " /*75a0*/, "Yang " /*75a1*/, "Chen " /*75a2*/, "You " /*75a3*/, "Ba " /*75a4*/, "Jie " /*75a5*/, "Jue " /*75a6*/, "Zhi " /*75a7*/, "Xia " /*75a8*/, "Cui " /*75a9*/, "Bi " /*75aa*/, "Yi " /*75ab*/, "Li " /*75ac*/, "Zong " /*75ad*/, "Chuang " /*75ae*/, "Feng " /*75af*/, "Zhu " /*75b0*/, "Pao " /*75b1*/, "Pi " /*75b2*/, "Gan " /*75b3*/, "Ke " /*75b4*/, "Ci " /*75b5*/, "Xie " /*75b6*/, "Qi " /*75b7*/, "Dan " /*75b8*/, "Zhen " /*75b9*/, "Fa " /*75ba*/, "Zhi " /*75bb*/, "Teng " /*75bc*/, "Ju " /*75bd*/, "Ji " /*75be*/, "Fei " /*75bf*/, "Qu " /*75c0*/, "Dian " /*75c1*/, "Jia " /*75c2*/, "Xian " /*75c3*/, "Cha " /*75c4*/, "Bing " /*75c5*/, "Ni " /*75c6*/, "Zheng " /*75c7*/, "Yong " /*75c8*/, "Jing " /*75c9*/, "Quan " /*75ca*/, "Chong " /*75cb*/, "Tong " /*75cc*/, "Yi " /*75cd*/, "Kai " /*75ce*/, "Wei " /*75cf*/, "Hui " /*75d0*/, "Duo " /*75d1*/, "Yang " /*75d2*/, "Chi " /*75d3*/, "Zhi " /*75d4*/, "Hen " /*75d5*/, "Ya " /*75d6*/, "Mei " /*75d7*/, "Dou " /*75d8*/, "Jing " /*75d9*/, "Xiao " /*75da*/, "Tong " /*75db*/, "Tu " /*75dc*/, "Mang " /*75dd*/, "Pi " /*75de*/, "Xiao " /*75df*/, "Suan " /*75e0*/, "Pu " /*75e1*/, "Li " /*75e2*/, "Zhi " /*75e3*/, "Cuo " /*75e4*/, "Duo " /*75e5*/, "Wu " /*75e6*/, "Sha " /*75e7*/, "Lao " /*75e8*/, "Shou " /*75e9*/, "Huan " /*75ea*/, "Xian " /*75eb*/, "Yi " /*75ec*/, "Peng " /*75ed*/, "Zhang " /*75ee*/, "Guan " /*75ef*/, "Tan " /*75f0*/, "Fei " /*75f1*/, "Ma " /*75f2*/, "Lin " /*75f3*/, "Chi " /*75f4*/, "Ji " /*75f5*/, "Dian " /*75f6*/, "An " /*75f7*/, "Chi " /*75f8*/, "Bi " /*75f9*/, "Bei " /*75fa*/, "Min " /*75fb*/, "Gu " /*75fc*/, "Dui " /*75fd*/, "E " /*75fe*/, "Wei " /*75ff*/ 
			});
						characters.TryAdd(118 /*30208 76*/, new string[] {
				"Yu " /*7600*/, "Cui " /*7601*/, "Ya " /*7602*/, "Zhu " /*7603*/, "Cu " /*7604*/, "Dan " /*7605*/, "Shen " /*7606*/, "Zhung " /*7607*/, "Ji " /*7608*/, "Yu " /*7609*/, "Hou " /*760a*/, "Feng " /*760b*/, "La " /*760c*/, "Yang " /*760d*/, "Shen " /*760e*/, "Tu " /*760f*/, "Yu " /*7610*/, "Gua " /*7611*/, "Wen " /*7612*/, "Huan " /*7613*/, "Ku " /*7614*/, "Jia " /*7615*/, "Yin " /*7616*/, "Yi " /*7617*/, "Lu " /*7618*/, "Sao " /*7619*/, "Jue " /*761a*/, "Chi " /*761b*/, "Xi " /*761c*/, "Guan " /*761d*/, "Yi " /*761e*/, "Wen " /*761f*/, "Ji " /*7620*/, "Chuang " /*7621*/, "Ban " /*7622*/, "Lei " /*7623*/, "Liu " /*7624*/, "Chai " /*7625*/, "Shou " /*7626*/, "Nue " /*7627*/, "Dian " /*7628*/, "Da " /*7629*/, "Pie " /*762a*/, "Tan " /*762b*/, "Zhang " /*762c*/, "Biao " /*762d*/, "Shen " /*762e*/, "Cu " /*762f*/, "Luo " /*7630*/, "Yi " /*7631*/, "Zong " /*7632*/, "Chou " /*7633*/, "Zhang " /*7634*/, "Zhai " /*7635*/, "Sou " /*7636*/, "Suo " /*7637*/, "Que " /*7638*/, "Diao " /*7639*/, "Lou " /*763a*/, "Lu " /*763b*/, "Mo " /*763c*/, "Jin " /*763d*/, "Yin " /*763e*/, "Ying " /*763f*/, "Huang " /*7640*/, "Fu " /*7641*/, "Liao " /*7642*/, "Long " /*7643*/, "Qiao " /*7644*/, "Liu " /*7645*/, "Lao " /*7646*/, "Xian " /*7647*/, "Fei " /*7648*/, "Dan " /*7649*/, "Yin " /*764a*/, "He " /*764b*/, "Yan " /*764c*/, "Ban " /*764d*/, "Xian " /*764e*/, "Guan " /*764f*/, "Guai " /*7650*/, "Nong " /*7651*/, "Yu " /*7652*/, "Wei " /*7653*/, "Yi " /*7654*/, "Yong " /*7655*/, "Pi " /*7656*/, "Lei " /*7657*/, "Li " /*7658*/, "Shu " /*7659*/, "Dan " /*765a*/, "Lin " /*765b*/, "Dian " /*765c*/, "Lin " /*765d*/, "Lai " /*765e*/, "Pie " /*765f*/, "Ji " /*7660*/, "Chi " /*7661*/, "Yang " /*7662*/, "Xian " /*7663*/, "Jie " /*7664*/, "Zheng " /*7665*/, "[?] " /*7666*/, "Li " /*7667*/, "Huo " /*7668*/, "Lai " /*7669*/, "Shaku " /*766a*/, "Dian " /*766b*/, "Xian " /*766c*/, "Ying " /*766d*/, "Yin " /*766e*/, "Qu " /*766f*/, "Yong " /*7670*/, "Tan " /*7671*/, "Dian " /*7672*/, "Luo " /*7673*/, "Luan " /*7674*/, "Luan " /*7675*/, "Bo " /*7676*/, "[?] " /*7677*/, "Gui " /*7678*/, "Po " /*7679*/, "Fa " /*767a*/, "Deng " /*767b*/, "Fa " /*767c*/, "Bai " /*767d*/, "Bai " /*767e*/, "Qie " /*767f*/, "Bi " /*7680*/, "Zao " /*7681*/, "Zao " /*7682*/, "Mao " /*7683*/, "De " /*7684*/, "Pa " /*7685*/, "Jie " /*7686*/, "Huang " /*7687*/, "Gui " /*7688*/, "Ci " /*7689*/, "Ling " /*768a*/, "Gao " /*768b*/, "Mo " /*768c*/, "Ji " /*768d*/, "Jiao " /*768e*/, "Peng " /*768f*/, "Gao " /*7690*/, "Ai " /*7691*/, "E " /*7692*/, "Hao " /*7693*/, "Han " /*7694*/, "Bi " /*7695*/, "Wan " /*7696*/, "Chou " /*7697*/, "Qian " /*7698*/, "Xi " /*7699*/, "Ai " /*769a*/, "Jiong " /*769b*/, "Hao " /*769c*/, "Huang " /*769d*/, "Hao " /*769e*/, "Ze " /*769f*/, "Cui " /*76a0*/, "Hao " /*76a1*/, "Xiao " /*76a2*/, "Ye " /*76a3*/, "Po " /*76a4*/, "Hao " /*76a5*/, "Jiao " /*76a6*/, "Ai " /*76a7*/, "Xing " /*76a8*/, "Huang " /*76a9*/, "Li " /*76aa*/, "Piao " /*76ab*/, "He " /*76ac*/, "Jiao " /*76ad*/, "Pi " /*76ae*/, "Gan " /*76af*/, "Pao " /*76b0*/, "Zhou " /*76b1*/, "Jun " /*76b2*/, "Qiu " /*76b3*/, "Cun " /*76b4*/, "Que " /*76b5*/, "Zha " /*76b6*/, "Gu " /*76b7*/, "Jun " /*76b8*/, "Jun " /*76b9*/, "Zhou " /*76ba*/, "Zha " /*76bb*/, "Gu " /*76bc*/, "Zhan " /*76bd*/, "Du " /*76be*/, "Min " /*76bf*/, "Qi " /*76c0*/, "Ying " /*76c1*/, "Yu " /*76c2*/, "Bei " /*76c3*/, "Zhao " /*76c4*/, "Zhong " /*76c5*/, "Pen " /*76c6*/, "He " /*76c7*/, "Ying " /*76c8*/, "He " /*76c9*/, "Yi " /*76ca*/, "Bo " /*76cb*/, "Wan " /*76cc*/, "He " /*76cd*/, "Ang " /*76ce*/, "Zhan " /*76cf*/, "Yan " /*76d0*/, "Jian " /*76d1*/, "He " /*76d2*/, "Yu " /*76d3*/, "Kui " /*76d4*/, "Fan " /*76d5*/, "Gai " /*76d6*/, "Dao " /*76d7*/, "Pan " /*76d8*/, "Fu " /*76d9*/, "Qiu " /*76da*/, "Sheng " /*76db*/, "Dao " /*76dc*/, "Lu " /*76dd*/, "Zhan " /*76de*/, "Meng " /*76df*/, "Li " /*76e0*/, "Jin " /*76e1*/, "Xu " /*76e2*/, "Jian " /*76e3*/, "Pan " /*76e4*/, "Guan " /*76e5*/, "An " /*76e6*/, "Lu " /*76e7*/, "Shu " /*76e8*/, "Zhou " /*76e9*/, "Dang " /*76ea*/, "An " /*76eb*/, "Gu " /*76ec*/, "Li " /*76ed*/, "Mu " /*76ee*/, "Cheng " /*76ef*/, "Gan " /*76f0*/, "Xu " /*76f1*/, "Mang " /*76f2*/, "Mang " /*76f3*/, "Zhi " /*76f4*/, "Qi " /*76f5*/, "Ruan " /*76f6*/, "Tian " /*76f7*/, "Xiang " /*76f8*/, "Dun " /*76f9*/, "Xin " /*76fa*/, "Xi " /*76fb*/, "Pan " /*76fc*/, "Feng " /*76fd*/, "Dun " /*76fe*/, "Min " /*76ff*/ 
			});
						characters.TryAdd(119 /*30464 77*/, new string[] {
				"Ming " /*7700*/, "Sheng " /*7701*/, "Shi " /*7702*/, "Yun " /*7703*/, "Mian " /*7704*/, "Pan " /*7705*/, "Fang " /*7706*/, "Miao " /*7707*/, "Dan " /*7708*/, "Mei " /*7709*/, "Mao " /*770a*/, "Kan " /*770b*/, "Xian " /*770c*/, "Ou " /*770d*/, "Shi " /*770e*/, "Yang " /*770f*/, "Zheng " /*7710*/, "Yao " /*7711*/, "Shen " /*7712*/, "Huo " /*7713*/, "Da " /*7714*/, "Zhen " /*7715*/, "Kuang " /*7716*/, "Ju " /*7717*/, "Shen " /*7718*/, "Chi " /*7719*/, "Sheng " /*771a*/, "Mei " /*771b*/, "Mo " /*771c*/, "Zhu " /*771d*/, "Zhen " /*771e*/, "Zhen " /*771f*/, "Mian " /*7720*/, "Di " /*7721*/, "Yuan " /*7722*/, "Die " /*7723*/, "Yi " /*7724*/, "Zi " /*7725*/, "Zi " /*7726*/, "Chao " /*7727*/, "Zha " /*7728*/, "Xuan " /*7729*/, "Bing " /*772a*/, "Mi " /*772b*/, "Long " /*772c*/, "Sui " /*772d*/, "Dong " /*772e*/, "Mi " /*772f*/, "Die " /*7730*/, "Yi " /*7731*/, "Er " /*7732*/, "Ming " /*7733*/, "Xuan " /*7734*/, "Chi " /*7735*/, "Kuang " /*7736*/, "Juan " /*7737*/, "Mou " /*7738*/, "Zhen " /*7739*/, "Tiao " /*773a*/, "Yang " /*773b*/, "Yan " /*773c*/, "Mo " /*773d*/, "Zhong " /*773e*/, "Mai " /*773f*/, "Zhao " /*7740*/, "Zheng " /*7741*/, "Mei " /*7742*/, "Jun " /*7743*/, "Shao " /*7744*/, "Han " /*7745*/, "Huan " /*7746*/, "Di " /*7747*/, "Cheng " /*7748*/, "Cuo " /*7749*/, "Juan " /*774a*/, "E " /*774b*/, "Wan " /*774c*/, "Xian " /*774d*/, "Xi " /*774e*/, "Kun " /*774f*/, "Lai " /*7750*/, "Jian " /*7751*/, "Shan " /*7752*/, "Tian " /*7753*/, "Hun " /*7754*/, "Wan " /*7755*/, "Ling " /*7756*/, "Shi " /*7757*/, "Qiong " /*7758*/, "Lie " /*7759*/, "Yai " /*775a*/, "Jing " /*775b*/, "Zheng " /*775c*/, "Li " /*775d*/, "Lai " /*775e*/, "Sui " /*775f*/, "Juan " /*7760*/, "Shui " /*7761*/, "Sui " /*7762*/, "Du " /*7763*/, "Bi " /*7764*/, "Bi " /*7765*/, "Mu " /*7766*/, "Hun " /*7767*/, "Ni " /*7768*/, "Lu " /*7769*/, "Yi " /*776a*/, "Jie " /*776b*/, "Cai " /*776c*/, "Zhou " /*776d*/, "Yu " /*776e*/, "Hun " /*776f*/, "Ma " /*7770*/, "Xia " /*7771*/, "Xing " /*7772*/, "Xi " /*7773*/, "Gun " /*7774*/, "Cai " /*7775*/, "Chun " /*7776*/, "Jian " /*7777*/, "Mei " /*7778*/, "Du " /*7779*/, "Hou " /*777a*/, "Xuan " /*777b*/, "Ti " /*777c*/, "Kui " /*777d*/, "Gao " /*777e*/, "Rui " /*777f*/, "Mou " /*7780*/, "Xu " /*7781*/, "Fa " /*7782*/, "Wen " /*7783*/, "Miao " /*7784*/, "Chou " /*7785*/, "Kui " /*7786*/, "Mi " /*7787*/, "Weng " /*7788*/, "Kou " /*7789*/, "Dang " /*778a*/, "Chen " /*778b*/, "Ke " /*778c*/, "Sou " /*778d*/, "Xia " /*778e*/, "Qiong " /*778f*/, "Mao " /*7790*/, "Ming " /*7791*/, "Man " /*7792*/, "Shui " /*7793*/, "Ze " /*7794*/, "Zhang " /*7795*/, "Yi " /*7796*/, "Diao " /*7797*/, "Ou " /*7798*/, "Mo " /*7799*/, "Shun " /*779a*/, "Cong " /*779b*/, "Lou " /*779c*/, "Chi " /*779d*/, "Man " /*779e*/, "Piao " /*779f*/, "Cheng " /*77a0*/, "Ji " /*77a1*/, "Meng " /*77a2*/, "[?] " /*77a3*/, "Run " /*77a4*/, "Pie " /*77a5*/, "Xi " /*77a6*/, "Qiao " /*77a7*/, "Pu " /*77a8*/, "Zhu " /*77a9*/, "Deng " /*77aa*/, "Shen " /*77ab*/, "Shun " /*77ac*/, "Liao " /*77ad*/, "Che " /*77ae*/, "Xian " /*77af*/, "Kan " /*77b0*/, "Ye " /*77b1*/, "Xu " /*77b2*/, "Tong " /*77b3*/, "Mou " /*77b4*/, "Lin " /*77b5*/, "Kui " /*77b6*/, "Xian " /*77b7*/, "Ye " /*77b8*/, "Ai " /*77b9*/, "Hui " /*77ba*/, "Zhan " /*77bb*/, "Jian " /*77bc*/, "Gu " /*77bd*/, "Zhao " /*77be*/, "Qu " /*77bf*/, "Wei " /*77c0*/, "Chou " /*77c1*/, "Sao " /*77c2*/, "Ning " /*77c3*/, "Xun " /*77c4*/, "Yao " /*77c5*/, "Huo " /*77c6*/, "Meng " /*77c7*/, "Mian " /*77c8*/, "Bin " /*77c9*/, "Mian " /*77ca*/, "Li " /*77cb*/, "Kuang " /*77cc*/, "Jue " /*77cd*/, "Xuan " /*77ce*/, "Mian " /*77cf*/, "Huo " /*77d0*/, "Lu " /*77d1*/, "Meng " /*77d2*/, "Long " /*77d3*/, "Guan " /*77d4*/, "Man " /*77d5*/, "Xi " /*77d6*/, "Chu " /*77d7*/, "Tang " /*77d8*/, "Kan " /*77d9*/, "Zhu " /*77da*/, "Mao " /*77db*/, "Jin " /*77dc*/, "Lin " /*77dd*/, "Yu " /*77de*/, "Shuo " /*77df*/, "Ce " /*77e0*/, "Jue " /*77e1*/, "Shi " /*77e2*/, "Yi " /*77e3*/, "Shen " /*77e4*/, "Zhi " /*77e5*/, "Hou " /*77e6*/, "Shen " /*77e7*/, "Ying " /*77e8*/, "Ju " /*77e9*/, "Zhou " /*77ea*/, "Jiao " /*77eb*/, "Cuo " /*77ec*/, "Duan " /*77ed*/, "Ai " /*77ee*/, "Jiao " /*77ef*/, "Zeng " /*77f0*/, "Huo " /*77f1*/, "Bai " /*77f2*/, "Shi " /*77f3*/, "Ding " /*77f4*/, "Qi " /*77f5*/, "Ji " /*77f6*/, "Zi " /*77f7*/, "Gan " /*77f8*/, "Wu " /*77f9*/, "Tuo " /*77fa*/, "Ku " /*77fb*/, "Qiang " /*77fc*/, "Xi " /*77fd*/, "Fan " /*77fe*/, "Kuang " /*77ff*/ 
			});
						characters.TryAdd(120 /*30720 78*/, new string[] {
				"Dang " /*7800*/, "Ma " /*7801*/, "Sha " /*7802*/, "Dan " /*7803*/, "Jue " /*7804*/, "Li " /*7805*/, "Fu " /*7806*/, "Min " /*7807*/, "Nuo " /*7808*/, "Huo " /*7809*/, "Kang " /*780a*/, "Zhi " /*780b*/, "Qi " /*780c*/, "Kan " /*780d*/, "Jie " /*780e*/, "Fen " /*780f*/, "E " /*7810*/, "Ya " /*7811*/, "Pi " /*7812*/, "Zhe " /*7813*/, "Yan " /*7814*/, "Sui " /*7815*/, "Zhuan " /*7816*/, "Che " /*7817*/, "Dun " /*7818*/, "Pan " /*7819*/, "Yan " /*781a*/, "[?] " /*781b*/, "Feng " /*781c*/, "Fa " /*781d*/, "Mo " /*781e*/, "Zha " /*781f*/, "Qu " /*7820*/, "Yu " /*7821*/, "Luo " /*7822*/, "Tuo " /*7823*/, "Tuo " /*7824*/, "Di " /*7825*/, "Zhai " /*7826*/, "Zhen " /*7827*/, "Ai " /*7828*/, "Fei " /*7829*/, "Mu " /*782a*/, "Zhu " /*782b*/, "Li " /*782c*/, "Bian " /*782d*/, "Nu " /*782e*/, "Ping " /*782f*/, "Peng " /*7830*/, "Ling " /*7831*/, "Pao " /*7832*/, "Le " /*7833*/, "Po " /*7834*/, "Bo " /*7835*/, "Po " /*7836*/, "Shen " /*7837*/, "Za " /*7838*/, "Nuo " /*7839*/, "Li " /*783a*/, "Long " /*783b*/, "Tong " /*783c*/, "[?] " /*783d*/, "Li " /*783e*/, "Aragane " /*783f*/, "Chu " /*7840*/, "Keng " /*7841*/, "Quan " /*7842*/, "Zhu " /*7843*/, "Kuang " /*7844*/, "Huo " /*7845*/, "E " /*7846*/, "Nao " /*7847*/, "Jia " /*7848*/, "Lu " /*7849*/, "Wei " /*784a*/, "Ai " /*784b*/, "Luo " /*784c*/, "Ken " /*784d*/, "Xing " /*784e*/, "Yan " /*784f*/, "Tong " /*7850*/, "Peng " /*7851*/, "Xi " /*7852*/, "[?] " /*7853*/, "Hong " /*7854*/, "Shuo " /*7855*/, "Xia " /*7856*/, "Qiao " /*7857*/, "[?] " /*7858*/, "Wei " /*7859*/, "Qiao " /*785a*/, "[?] " /*785b*/, "Keng " /*785c*/, "Xiao " /*785d*/, "Que " /*785e*/, "Chan " /*785f*/, "Lang " /*7860*/, "Hong " /*7861*/, "Yu " /*7862*/, "Xiao " /*7863*/, "Xia " /*7864*/, "Mang " /*7865*/, "Long " /*7866*/, "Iong " /*7867*/, "Che " /*7868*/, "Che " /*7869*/, "E " /*786a*/, "Liu " /*786b*/, "Ying " /*786c*/, "Mang " /*786d*/, "Que " /*786e*/, "Yan " /*786f*/, "Sha " /*7870*/, "Kun " /*7871*/, "Yu " /*7872*/, "[?] " /*7873*/, "Kaki " /*7874*/, "Lu " /*7875*/, "Chen " /*7876*/, "Jian " /*7877*/, "Nue " /*7878*/, "Song " /*7879*/, "Zhuo " /*787a*/, "Keng " /*787b*/, "Peng " /*787c*/, "Yan " /*787d*/, "Zhui " /*787e*/, "Kong " /*787f*/, "Ceng " /*7880*/, "Qi " /*7881*/, "Zong " /*7882*/, "Qing " /*7883*/, "Lin " /*7884*/, "Jun " /*7885*/, "Bo " /*7886*/, "Ding " /*7887*/, "Min " /*7888*/, "Diao " /*7889*/, "Jian " /*788a*/, "He " /*788b*/, "Lu " /*788c*/, "Ai " /*788d*/, "Sui " /*788e*/, "Que " /*788f*/, "Ling " /*7890*/, "Bei " /*7891*/, "Yin " /*7892*/, "Dui " /*7893*/, "Wu " /*7894*/, "Qi " /*7895*/, "Lun " /*7896*/, "Wan " /*7897*/, "Dian " /*7898*/, "Gang " /*7899*/, "Pei " /*789a*/, "Qi " /*789b*/, "Chen " /*789c*/, "Ruan " /*789d*/, "Yan " /*789e*/, "Die " /*789f*/, "Ding " /*78a0*/, "Du " /*78a1*/, "Tuo " /*78a2*/, "Jie " /*78a3*/, "Ying " /*78a4*/, "Bian " /*78a5*/, "Ke " /*78a6*/, "Bi " /*78a7*/, "Wei " /*78a8*/, "Shuo " /*78a9*/, "Zhen " /*78aa*/, "Duan " /*78ab*/, "Xia " /*78ac*/, "Dang " /*78ad*/, "Ti " /*78ae*/, "Nao " /*78af*/, "Peng " /*78b0*/, "Jian " /*78b1*/, "Di " /*78b2*/, "Tan " /*78b3*/, "Cha " /*78b4*/, "Seki " /*78b5*/, "Qi " /*78b6*/, "[?] " /*78b7*/, "Feng " /*78b8*/, "Xuan " /*78b9*/, "Que " /*78ba*/, "Que " /*78bb*/, "Ma " /*78bc*/, "Gong " /*78bd*/, "Nian " /*78be*/, "Su " /*78bf*/, "E " /*78c0*/, "Ci " /*78c1*/, "Liu " /*78c2*/, "Si " /*78c3*/, "Tang " /*78c4*/, "Bang " /*78c5*/, "Hua " /*78c6*/, "Pi " /*78c7*/, "Wei " /*78c8*/, "Sang " /*78c9*/, "Lei " /*78ca*/, "Cuo " /*78cb*/, "Zhen " /*78cc*/, "Xia " /*78cd*/, "Qi " /*78ce*/, "Lian " /*78cf*/, "Pan " /*78d0*/, "Wei " /*78d1*/, "Yun " /*78d2*/, "Dui " /*78d3*/, "Zhe " /*78d4*/, "Ke " /*78d5*/, "La " /*78d6*/, "[?] " /*78d7*/, "Qing " /*78d8*/, "Gun " /*78d9*/, "Zhuan " /*78da*/, "Chan " /*78db*/, "Qi " /*78dc*/, "Ao " /*78dd*/, "Peng " /*78de*/, "Lu " /*78df*/, "Lu " /*78e0*/, "Kan " /*78e1*/, "Qiang " /*78e2*/, "Chen " /*78e3*/, "Yin " /*78e4*/, "Lei " /*78e5*/, "Biao " /*78e6*/, "Qi " /*78e7*/, "Mo " /*78e8*/, "Qi " /*78e9*/, "Cui " /*78ea*/, "Zong " /*78eb*/, "Qing " /*78ec*/, "Chuo " /*78ed*/, "[?] " /*78ee*/, "Ji " /*78ef*/, "Shan " /*78f0*/, "Lao " /*78f1*/, "Qu " /*78f2*/, "Zeng " /*78f3*/, "Deng " /*78f4*/, "Jian " /*78f5*/, "Xi " /*78f6*/, "Lin " /*78f7*/, "Ding " /*78f8*/, "Dian " /*78f9*/, "Huang " /*78fa*/, "Pan " /*78fb*/, "Za " /*78fc*/, "Qiao " /*78fd*/, "Di " /*78fe*/, "Li " /*78ff*/ 
			});
						characters.TryAdd(121 /*30976 79*/, new string[] {
				"Tani " /*7900*/, "Jiao " /*7901*/, "[?] " /*7902*/, "Zhang " /*7903*/, "Qiao " /*7904*/, "Dun " /*7905*/, "Xian " /*7906*/, "Yu " /*7907*/, "Zhui " /*7908*/, "He " /*7909*/, "Huo " /*790a*/, "Zhai " /*790b*/, "Lei " /*790c*/, "Ke " /*790d*/, "Chu " /*790e*/, "Ji " /*790f*/, "Que " /*7910*/, "Dang " /*7911*/, "Yi " /*7912*/, "Jiang " /*7913*/, "Pi " /*7914*/, "Pi " /*7915*/, "Yu " /*7916*/, "Pin " /*7917*/, "Qi " /*7918*/, "Ai " /*7919*/, "Kai " /*791a*/, "Jian " /*791b*/, "Yu " /*791c*/, "Ruan " /*791d*/, "Meng " /*791e*/, "Pao " /*791f*/, "Ci " /*7920*/, "[?] " /*7921*/, "[?] " /*7922*/, "Mie " /*7923*/, "Ca " /*7924*/, "Xian " /*7925*/, "Kuang " /*7926*/, "Lei " /*7927*/, "Lei " /*7928*/, "Zhi " /*7929*/, "Li " /*792a*/, "Li " /*792b*/, "Fan " /*792c*/, "Que " /*792d*/, "Pao " /*792e*/, "Ying " /*792f*/, "Li " /*7930*/, "Long " /*7931*/, "Long " /*7932*/, "Mo " /*7933*/, "Bo " /*7934*/, "Shuang " /*7935*/, "Guan " /*7936*/, "Lan " /*7937*/, "Zan " /*7938*/, "Yan " /*7939*/, "Shi " /*793a*/, "Shi " /*793b*/, "Li " /*793c*/, "Reng " /*793d*/, "She " /*793e*/, "Yue " /*793f*/, "Si " /*7940*/, "Qi " /*7941*/, "Ta " /*7942*/, "Ma " /*7943*/, "Xie " /*7944*/, "Xian " /*7945*/, "Xian " /*7946*/, "Zhi " /*7947*/, "Qi " /*7948*/, "Zhi " /*7949*/, "Beng " /*794a*/, "Dui " /*794b*/, "Zhong " /*794c*/, "[?] " /*794d*/, "Yi " /*794e*/, "Shi " /*794f*/, "You " /*7950*/, "Zhi " /*7951*/, "Tiao " /*7952*/, "Fu " /*7953*/, "Fu " /*7954*/, "Mi " /*7955*/, "Zu " /*7956*/, "Zhi " /*7957*/, "Suan " /*7958*/, "Mei " /*7959*/, "Zuo " /*795a*/, "Qu " /*795b*/, "Hu " /*795c*/, "Zhu " /*795d*/, "Shen " /*795e*/, "Sui " /*795f*/, "Ci " /*7960*/, "Chai " /*7961*/, "Mi " /*7962*/, "Lu " /*7963*/, "Yu " /*7964*/, "Xiang " /*7965*/, "Wu " /*7966*/, "Tiao " /*7967*/, "Piao " /*7968*/, "Zhu " /*7969*/, "Gui " /*796a*/, "Xia " /*796b*/, "Zhi " /*796c*/, "Ji " /*796d*/, "Gao " /*796e*/, "Zhen " /*796f*/, "Gao " /*7970*/, "Shui " /*7971*/, "Jin " /*7972*/, "Chen " /*7973*/, "Gai " /*7974*/, "Kun " /*7975*/, "Di " /*7976*/, "Dao " /*7977*/, "Huo " /*7978*/, "Tao " /*7979*/, "Qi " /*797a*/, "Gu " /*797b*/, "Guan " /*797c*/, "Zui " /*797d*/, "Ling " /*797e*/, "Lu " /*797f*/, "Bing " /*7980*/, "Jin " /*7981*/, "Dao " /*7982*/, "Zhi " /*7983*/, "Lu " /*7984*/, "Shan " /*7985*/, "Bei " /*7986*/, "Zhe " /*7987*/, "Hui " /*7988*/, "You " /*7989*/, "Xi " /*798a*/, "Yin " /*798b*/, "Zi " /*798c*/, "Huo " /*798d*/, "Zhen " /*798e*/, "Fu " /*798f*/, "Yuan " /*7990*/, "Wu " /*7991*/, "Xian " /*7992*/, "Yang " /*7993*/, "Ti " /*7994*/, "Yi " /*7995*/, "Mei " /*7996*/, "Si " /*7997*/, "Di " /*7998*/, "[?] " /*7999*/, "Zhuo " /*799a*/, "Zhen " /*799b*/, "Yong " /*799c*/, "Ji " /*799d*/, "Gao " /*799e*/, "Tang " /*799f*/, "Si " /*79a0*/, "Ma " /*79a1*/, "Ta " /*79a2*/, "[?] " /*79a3*/, "Xuan " /*79a4*/, "Qi " /*79a5*/, "Yu " /*79a6*/, "Xi " /*79a7*/, "Ji " /*79a8*/, "Si " /*79a9*/, "Chan " /*79aa*/, "Tan " /*79ab*/, "Kuai " /*79ac*/, "Sui " /*79ad*/, "Li " /*79ae*/, "Nong " /*79af*/, "Ni " /*79b0*/, "Dao " /*79b1*/, "Li " /*79b2*/, "Rang " /*79b3*/, "Yue " /*79b4*/, "Ti " /*79b5*/, "Zan " /*79b6*/, "Lei " /*79b7*/, "Rou " /*79b8*/, "Yu " /*79b9*/, "Yu " /*79ba*/, "Chi " /*79bb*/, "Xie " /*79bc*/, "Qin " /*79bd*/, "He " /*79be*/, "Tu " /*79bf*/, "Xiu " /*79c0*/, "Si " /*79c1*/, "Ren " /*79c2*/, "Tu " /*79c3*/, "Zi " /*79c4*/, "Cha " /*79c5*/, "Gan " /*79c6*/, "Yi " /*79c7*/, "Xian " /*79c8*/, "Bing " /*79c9*/, "Nian " /*79ca*/, "Qiu " /*79cb*/, "Qiu " /*79cc*/, "Chong " /*79cd*/, "Fen " /*79ce*/, "Hao " /*79cf*/, "Yun " /*79d0*/, "Ke " /*79d1*/, "Miao " /*79d2*/, "Zhi " /*79d3*/, "Geng " /*79d4*/, "Bi " /*79d5*/, "Zhi " /*79d6*/, "Yu " /*79d7*/, "Mi " /*79d8*/, "Ku " /*79d9*/, "Ban " /*79da*/, "Pi " /*79db*/, "Ni " /*79dc*/, "Li " /*79dd*/, "You " /*79de*/, "Zu " /*79df*/, "Pi " /*79e0*/, "Ba " /*79e1*/, "Ling " /*79e2*/, "Mo " /*79e3*/, "Cheng " /*79e4*/, "Nian " /*79e5*/, "Qin " /*79e6*/, "Yang " /*79e7*/, "Zuo " /*79e8*/, "Zhi " /*79e9*/, "Zhi " /*79ea*/, "Shu " /*79eb*/, "Ju " /*79ec*/, "Zi " /*79ed*/, "Huo " /*79ee*/, "Ji " /*79ef*/, "Cheng " /*79f0*/, "Tong " /*79f1*/, "Zhi " /*79f2*/, "Huo " /*79f3*/, "He " /*79f4*/, "Yin " /*79f5*/, "Zi " /*79f6*/, "Zhi " /*79f7*/, "Jie " /*79f8*/, "Ren " /*79f9*/, "Du " /*79fa*/, "Yi " /*79fb*/, "Zhu " /*79fc*/, "Hui " /*79fd*/, "Nong " /*79fe*/, "Fu " /*79ff*/ 
			});
						characters.TryAdd(122 /*31232 7a*/, new string[] {
				"Xi " /*7a00*/, "Kao " /*7a01*/, "Lang " /*7a02*/, "Fu " /*7a03*/, "Ze " /*7a04*/, "Shui " /*7a05*/, "Lu " /*7a06*/, "Kun " /*7a07*/, "Gan " /*7a08*/, "Geng " /*7a09*/, "Ti " /*7a0a*/, "Cheng " /*7a0b*/, "Tu " /*7a0c*/, "Shao " /*7a0d*/, "Shui " /*7a0e*/, "Ya " /*7a0f*/, "Lun " /*7a10*/, "Lu " /*7a11*/, "Gu " /*7a12*/, "Zuo " /*7a13*/, "Ren " /*7a14*/, "Zhun " /*7a15*/, "Bang " /*7a16*/, "Bai " /*7a17*/, "Ji " /*7a18*/, "Zhi " /*7a19*/, "Zhi " /*7a1a*/, "Kun " /*7a1b*/, "Leng " /*7a1c*/, "Peng " /*7a1d*/, "Ke " /*7a1e*/, "Bing " /*7a1f*/, "Chou " /*7a20*/, "Zu " /*7a21*/, "Yu " /*7a22*/, "Su " /*7a23*/, "Lue " /*7a24*/, "[?] " /*7a25*/, "Yi " /*7a26*/, "Xi " /*7a27*/, "Bian " /*7a28*/, "Ji " /*7a29*/, "Fu " /*7a2a*/, "Bi " /*7a2b*/, "Nuo " /*7a2c*/, "Jie " /*7a2d*/, "Zhong " /*7a2e*/, "Zong " /*7a2f*/, "Xu " /*7a30*/, "Cheng " /*7a31*/, "Dao " /*7a32*/, "Wen " /*7a33*/, "Lian " /*7a34*/, "Zi " /*7a35*/, "Yu " /*7a36*/, "Ji " /*7a37*/, "Xu " /*7a38*/, "Zhen " /*7a39*/, "Zhi " /*7a3a*/, "Dao " /*7a3b*/, "Jia " /*7a3c*/, "Ji " /*7a3d*/, "Gao " /*7a3e*/, "Gao " /*7a3f*/, "Gu " /*7a40*/, "Rong " /*7a41*/, "Sui " /*7a42*/, "You " /*7a43*/, "Ji " /*7a44*/, "Kang " /*7a45*/, "Mu " /*7a46*/, "Shan " /*7a47*/, "Men " /*7a48*/, "Zhi " /*7a49*/, "Ji " /*7a4a*/, "Lu " /*7a4b*/, "Su " /*7a4c*/, "Ji " /*7a4d*/, "Ying " /*7a4e*/, "Wen " /*7a4f*/, "Qiu " /*7a50*/, "Se " /*7a51*/, "[?] " /*7a52*/, "Yi " /*7a53*/, "Huang " /*7a54*/, "Qie " /*7a55*/, "Ji " /*7a56*/, "Sui " /*7a57*/, "Xiao " /*7a58*/, "Pu " /*7a59*/, "Jiao " /*7a5a*/, "Zhuo " /*7a5b*/, "Tong " /*7a5c*/, "Sai " /*7a5d*/, "Lu " /*7a5e*/, "Sui " /*7a5f*/, "Nong " /*7a60*/, "Se " /*7a61*/, "Hui " /*7a62*/, "Rang " /*7a63*/, "Nuo " /*7a64*/, "Yu " /*7a65*/, "Bin " /*7a66*/, "Ji " /*7a67*/, "Tui " /*7a68*/, "Wen " /*7a69*/, "Cheng " /*7a6a*/, "Huo " /*7a6b*/, "Gong " /*7a6c*/, "Lu " /*7a6d*/, "Biao " /*7a6e*/, "[?] " /*7a6f*/, "Rang " /*7a70*/, "Zhuo " /*7a71*/, "Li " /*7a72*/, "Zan " /*7a73*/, "Xue " /*7a74*/, "Wa " /*7a75*/, "Jiu " /*7a76*/, "Qiong " /*7a77*/, "Xi " /*7a78*/, "Qiong " /*7a79*/, "Kong " /*7a7a*/, "Yu " /*7a7b*/, "Sen " /*7a7c*/, "Jing " /*7a7d*/, "Yao " /*7a7e*/, "Chuan " /*7a7f*/, "Zhun " /*7a80*/, "Tu " /*7a81*/, "Lao " /*7a82*/, "Qie " /*7a83*/, "Zhai " /*7a84*/, "Yao " /*7a85*/, "Bian " /*7a86*/, "Bao " /*7a87*/, "Yao " /*7a88*/, "Bing " /*7a89*/, "Wa " /*7a8a*/, "Zhu " /*7a8b*/, "Jiao " /*7a8c*/, "Qiao " /*7a8d*/, "Diao " /*7a8e*/, "Wu " /*7a8f*/, "Gui " /*7a90*/, "Yao " /*7a91*/, "Zhi " /*7a92*/, "Chuang " /*7a93*/, "Yao " /*7a94*/, "Tiao " /*7a95*/, "Jiao " /*7a96*/, "Chuang " /*7a97*/, "Jiong " /*7a98*/, "Xiao " /*7a99*/, "Cheng " /*7a9a*/, "Kou " /*7a9b*/, "Cuan " /*7a9c*/, "Wo " /*7a9d*/, "Dan " /*7a9e*/, "Ku " /*7a9f*/, "Ke " /*7aa0*/, "Zhui " /*7aa1*/, "Xu " /*7aa2*/, "Su " /*7aa3*/, "Guan " /*7aa4*/, "Kui " /*7aa5*/, "Dou " /*7aa6*/, "[?] " /*7aa7*/, "Yin " /*7aa8*/, "Wo " /*7aa9*/, "Wa " /*7aaa*/, "Ya " /*7aab*/, "Yu " /*7aac*/, "Ju " /*7aad*/, "Qiong " /*7aae*/, "Yao " /*7aaf*/, "Yao " /*7ab0*/, "Tiao " /*7ab1*/, "Chao " /*7ab2*/, "Yu " /*7ab3*/, "Tian " /*7ab4*/, "Diao " /*7ab5*/, "Ju " /*7ab6*/, "Liao " /*7ab7*/, "Xi " /*7ab8*/, "Wu " /*7ab9*/, "Kui " /*7aba*/, "Chuang " /*7abb*/, "Zhao " /*7abc*/, "[?] " /*7abd*/, "Kuan " /*7abe*/, "Long " /*7abf*/, "Cheng " /*7ac0*/, "Cui " /*7ac1*/, "Piao " /*7ac2*/, "Zao " /*7ac3*/, "Cuan " /*7ac4*/, "Qiao " /*7ac5*/, "Qiong " /*7ac6*/, "Dou " /*7ac7*/, "Zao " /*7ac8*/, "Long " /*7ac9*/, "Qie " /*7aca*/, "Li " /*7acb*/, "Chu " /*7acc*/, "Shi " /*7acd*/, "Fou " /*7ace*/, "Qian " /*7acf*/, "Chu " /*7ad0*/, "Hong " /*7ad1*/, "Qi " /*7ad2*/, "Qian " /*7ad3*/, "Gong " /*7ad4*/, "Shi " /*7ad5*/, "Shu " /*7ad6*/, "Miao " /*7ad7*/, "Ju " /*7ad8*/, "Zhan " /*7ad9*/, "Zhu " /*7ada*/, "Ling " /*7adb*/, "Long " /*7adc*/, "Bing " /*7add*/, "Jing " /*7ade*/, "Jing " /*7adf*/, "Zhang " /*7ae0*/, "Yi " /*7ae1*/, "Si " /*7ae2*/, "Jun " /*7ae3*/, "Hong " /*7ae4*/, "Tong " /*7ae5*/, "Song " /*7ae6*/, "Jing " /*7ae7*/, "Diao " /*7ae8*/, "Yi " /*7ae9*/, "Shu " /*7aea*/, "Jing " /*7aeb*/, "Qu " /*7aec*/, "Jie " /*7aed*/, "Ping " /*7aee*/, "Duan " /*7aef*/, "Shao " /*7af0*/, "Zhuan " /*7af1*/, "Ceng " /*7af2*/, "Deng " /*7af3*/, "Cui " /*7af4*/, "Huai " /*7af5*/, "Jing " /*7af6*/, "Kan " /*7af7*/, "Jing " /*7af8*/, "Zhu " /*7af9*/, "Zhu " /*7afa*/, "Le " /*7afb*/, "Peng " /*7afc*/, "Yu " /*7afd*/, "Chi " /*7afe*/, "Gan " /*7aff*/ 
			});
						characters.TryAdd(123 /*31488 7b*/, new string[] {
				"Mang " /*7b00*/, "Zhu " /*7b01*/, "Utsubo " /*7b02*/, "Du " /*7b03*/, "Ji " /*7b04*/, "Xiao " /*7b05*/, "Ba " /*7b06*/, "Suan " /*7b07*/, "Ji " /*7b08*/, "Zhen " /*7b09*/, "Zhao " /*7b0a*/, "Sun " /*7b0b*/, "Ya " /*7b0c*/, "Zhui " /*7b0d*/, "Yuan " /*7b0e*/, "Hu " /*7b0f*/, "Gang " /*7b10*/, "Xiao " /*7b11*/, "Cen " /*7b12*/, "Pi " /*7b13*/, "Bi " /*7b14*/, "Jian " /*7b15*/, "Yi " /*7b16*/, "Dong " /*7b17*/, "Shan " /*7b18*/, "Sheng " /*7b19*/, "Xia " /*7b1a*/, "Di " /*7b1b*/, "Zhu " /*7b1c*/, "Na " /*7b1d*/, "Chi " /*7b1e*/, "Gu " /*7b1f*/, "Li " /*7b20*/, "Qie " /*7b21*/, "Min " /*7b22*/, "Bao " /*7b23*/, "Tiao " /*7b24*/, "Si " /*7b25*/, "Fu " /*7b26*/, "Ce " /*7b27*/, "Ben " /*7b28*/, "Pei " /*7b29*/, "Da " /*7b2a*/, "Zi " /*7b2b*/, "Di " /*7b2c*/, "Ling " /*7b2d*/, "Ze " /*7b2e*/, "Nu " /*7b2f*/, "Fu " /*7b30*/, "Gou " /*7b31*/, "Fan " /*7b32*/, "Jia " /*7b33*/, "Ge " /*7b34*/, "Fan " /*7b35*/, "Shi " /*7b36*/, "Mao " /*7b37*/, "Po " /*7b38*/, "Sey " /*7b39*/, "Jian " /*7b3a*/, "Qiong " /*7b3b*/, "Long " /*7b3c*/, "Souke " /*7b3d*/, "Bian " /*7b3e*/, "Luo " /*7b3f*/, "Gui " /*7b40*/, "Qu " /*7b41*/, "Chi " /*7b42*/, "Yin " /*7b43*/, "Yao " /*7b44*/, "Xian " /*7b45*/, "Bi " /*7b46*/, "Qiong " /*7b47*/, "Gua " /*7b48*/, "Deng " /*7b49*/, "Jiao " /*7b4a*/, "Jin " /*7b4b*/, "Quan " /*7b4c*/, "Sun " /*7b4d*/, "Ru " /*7b4e*/, "Fa " /*7b4f*/, "Kuang " /*7b50*/, "Zhu " /*7b51*/, "Tong " /*7b52*/, "Ji " /*7b53*/, "Da " /*7b54*/, "Xing " /*7b55*/, "Ce " /*7b56*/, "Zhong " /*7b57*/, "Kou " /*7b58*/, "Lai " /*7b59*/, "Bi " /*7b5a*/, "Shai " /*7b5b*/, "Dang " /*7b5c*/, "Zheng " /*7b5d*/, "Ce " /*7b5e*/, "Fu " /*7b5f*/, "Yun " /*7b60*/, "Tu " /*7b61*/, "Pa " /*7b62*/, "Li " /*7b63*/, "Lang " /*7b64*/, "Ju " /*7b65*/, "Guan " /*7b66*/, "Jian " /*7b67*/, "Han " /*7b68*/, "Tong " /*7b69*/, "Xia " /*7b6a*/, "Zhi " /*7b6b*/, "Cheng " /*7b6c*/, "Suan " /*7b6d*/, "Shi " /*7b6e*/, "Zhu " /*7b6f*/, "Zuo " /*7b70*/, "Xiao " /*7b71*/, "Shao " /*7b72*/, "Ting " /*7b73*/, "Ce " /*7b74*/, "Yan " /*7b75*/, "Gao " /*7b76*/, "Kuai " /*7b77*/, "Gan " /*7b78*/, "Chou " /*7b79*/, "Kago " /*7b7a*/, "Gang " /*7b7b*/, "Yun " /*7b7c*/, "O " /*7b7d*/, "Qian " /*7b7e*/, "Xiao " /*7b7f*/, "Jian " /*7b80*/, "Pu " /*7b81*/, "Lai " /*7b82*/, "Zou " /*7b83*/, "Bi " /*7b84*/, "Bi " /*7b85*/, "Bi " /*7b86*/, "Ge " /*7b87*/, "Chi " /*7b88*/, "Guai " /*7b89*/, "Yu " /*7b8a*/, "Jian " /*7b8b*/, "Zhao " /*7b8c*/, "Gu " /*7b8d*/, "Chi " /*7b8e*/, "Zheng " /*7b8f*/, "Jing " /*7b90*/, "Sha " /*7b91*/, "Zhou " /*7b92*/, "Lu " /*7b93*/, "Bo " /*7b94*/, "Ji " /*7b95*/, "Lin " /*7b96*/, "Suan " /*7b97*/, "Jun " /*7b98*/, "Fu " /*7b99*/, "Zha " /*7b9a*/, "Gu " /*7b9b*/, "Kong " /*7b9c*/, "Qian " /*7b9d*/, "Quan " /*7b9e*/, "Jun " /*7b9f*/, "Chui " /*7ba0*/, "Guan " /*7ba1*/, "Yuan " /*7ba2*/, "Ce " /*7ba3*/, "Ju " /*7ba4*/, "Bo " /*7ba5*/, "Ze " /*7ba6*/, "Qie " /*7ba7*/, "Tuo " /*7ba8*/, "Luo " /*7ba9*/, "Dan " /*7baa*/, "Xiao " /*7bab*/, "Ruo " /*7bac*/, "Jian " /*7bad*/, "Xuan " /*7bae*/, "Bian " /*7baf*/, "Sun " /*7bb0*/, "Xiang " /*7bb1*/, "Xian " /*7bb2*/, "Ping " /*7bb3*/, "Zhen " /*7bb4*/, "Sheng " /*7bb5*/, "Hu " /*7bb6*/, "Shi " /*7bb7*/, "Zhu " /*7bb8*/, "Yue " /*7bb9*/, "Chun " /*7bba*/, "Lu " /*7bbb*/, "Wu " /*7bbc*/, "Dong " /*7bbd*/, "Xiao " /*7bbe*/, "Ji " /*7bbf*/, "Jie " /*7bc0*/, "Huang " /*7bc1*/, "Xing " /*7bc2*/, "Mei " /*7bc3*/, "Fan " /*7bc4*/, "Chui " /*7bc5*/, "Zhuan " /*7bc6*/, "Pian " /*7bc7*/, "Feng " /*7bc8*/, "Zhu " /*7bc9*/, "Hong " /*7bca*/, "Qie " /*7bcb*/, "Hou " /*7bcc*/, "Qiu " /*7bcd*/, "Miao " /*7bce*/, "Qian " /*7bcf*/, "[?] " /*7bd0*/, "Kui " /*7bd1*/, "Sik " /*7bd2*/, "Lou " /*7bd3*/, "Yun " /*7bd4*/, "He " /*7bd5*/, "Tang " /*7bd6*/, "Yue " /*7bd7*/, "Chou " /*7bd8*/, "Gao " /*7bd9*/, "Fei " /*7bda*/, "Ruo " /*7bdb*/, "Zheng " /*7bdc*/, "Gou " /*7bdd*/, "Nie " /*7bde*/, "Qian " /*7bdf*/, "Xiao " /*7be0*/, "Cuan " /*7be1*/, "Gong " /*7be2*/, "Pang " /*7be3*/, "Du " /*7be4*/, "Li " /*7be5*/, "Bi " /*7be6*/, "Zhuo " /*7be7*/, "Chu " /*7be8*/, "Shai " /*7be9*/, "Chi " /*7bea*/, "Zhu " /*7beb*/, "Qiang " /*7bec*/, "Long " /*7bed*/, "Lan " /*7bee*/, "Jian " /*7bef*/, "Bu " /*7bf0*/, "Li " /*7bf1*/, "Hui " /*7bf2*/, "Bi " /*7bf3*/, "Di " /*7bf4*/, "Cong " /*7bf5*/, "Yan " /*7bf6*/, "Peng " /*7bf7*/, "Sen " /*7bf8*/, "Zhuan " /*7bf9*/, "Pai " /*7bfa*/, "Piao " /*7bfb*/, "Dou " /*7bfc*/, "Yu " /*7bfd*/, "Mie " /*7bfe*/, "Zhuan " /*7bff*/ 
			});
						characters.TryAdd(124 /*31744 7c*/, new string[] {
				"Ze " /*7c00*/, "Xi " /*7c01*/, "Guo " /*7c02*/, "Yi " /*7c03*/, "Hu " /*7c04*/, "Chan " /*7c05*/, "Kou " /*7c06*/, "Cu " /*7c07*/, "Ping " /*7c08*/, "Chou " /*7c09*/, "Ji " /*7c0a*/, "Gui " /*7c0b*/, "Su " /*7c0c*/, "Lou " /*7c0d*/, "Zha " /*7c0e*/, "Lu " /*7c0f*/, "Nian " /*7c10*/, "Suo " /*7c11*/, "Cuan " /*7c12*/, "Sasara " /*7c13*/, "Suo " /*7c14*/, "Le " /*7c15*/, "Duan " /*7c16*/, "Yana " /*7c17*/, "Xiao " /*7c18*/, "Bo " /*7c19*/, "Mi " /*7c1a*/, "Si " /*7c1b*/, "Dang " /*7c1c*/, "Liao " /*7c1d*/, "Dan " /*7c1e*/, "Dian " /*7c1f*/, "Fu " /*7c20*/, "Jian " /*7c21*/, "Min " /*7c22*/, "Kui " /*7c23*/, "Dai " /*7c24*/, "Qiao " /*7c25*/, "Deng " /*7c26*/, "Huang " /*7c27*/, "Sun " /*7c28*/, "Lao " /*7c29*/, "Zan " /*7c2a*/, "Xiao " /*7c2b*/, "Du " /*7c2c*/, "Shi " /*7c2d*/, "Zan " /*7c2e*/, "[?] " /*7c2f*/, "Pai " /*7c30*/, "Hata " /*7c31*/, "Pai " /*7c32*/, "Gan " /*7c33*/, "Ju " /*7c34*/, "Du " /*7c35*/, "Lu " /*7c36*/, "Yan " /*7c37*/, "Bo " /*7c38*/, "Dang " /*7c39*/, "Sai " /*7c3a*/, "Ke " /*7c3b*/, "Long " /*7c3c*/, "Qian " /*7c3d*/, "Lian " /*7c3e*/, "Bo " /*7c3f*/, "Zhou " /*7c40*/, "Lai " /*7c41*/, "[?] " /*7c42*/, "Lan " /*7c43*/, "Kui " /*7c44*/, "Yu " /*7c45*/, "Yue " /*7c46*/, "Hao " /*7c47*/, "Zhen " /*7c48*/, "Tai " /*7c49*/, "Ti " /*7c4a*/, "Mi " /*7c4b*/, "Chou " /*7c4c*/, "Ji " /*7c4d*/, "[?] " /*7c4e*/, "Hata " /*7c4f*/, "Teng " /*7c50*/, "Zhuan " /*7c51*/, "Zhou " /*7c52*/, "Fan " /*7c53*/, "Sou " /*7c54*/, "Zhou " /*7c55*/, "Kuji " /*7c56*/, "Zhuo " /*7c57*/, "Teng " /*7c58*/, "Lu " /*7c59*/, "Lu " /*7c5a*/, "Jian " /*7c5b*/, "Tuo " /*7c5c*/, "Ying " /*7c5d*/, "Yu " /*7c5e*/, "Lai " /*7c5f*/, "Long " /*7c60*/, "Shinshi " /*7c61*/, "Lian " /*7c62*/, "Lan " /*7c63*/, "Qian " /*7c64*/, "Yue " /*7c65*/, "Zhong " /*7c66*/, "Qu " /*7c67*/, "Lian " /*7c68*/, "Bian " /*7c69*/, "Duan " /*7c6a*/, "Zuan " /*7c6b*/, "Li " /*7c6c*/, "Si " /*7c6d*/, "Luo " /*7c6e*/, "Ying " /*7c6f*/, "Yue " /*7c70*/, "Zhuo " /*7c71*/, "Xu " /*7c72*/, "Mi " /*7c73*/, "Di " /*7c74*/, "Fan " /*7c75*/, "Shen " /*7c76*/, "Zhe " /*7c77*/, "Shen " /*7c78*/, "Nu " /*7c79*/, "Xie " /*7c7a*/, "Lei " /*7c7b*/, "Xian " /*7c7c*/, "Zi " /*7c7d*/, "Ni " /*7c7e*/, "Cun " /*7c7f*/, "[?] " /*7c80*/, "Qian " /*7c81*/, "Kume " /*7c82*/, "Bi " /*7c83*/, "Ban " /*7c84*/, "Wu " /*7c85*/, "Sha " /*7c86*/, "Kang " /*7c87*/, "Rou " /*7c88*/, "Fen " /*7c89*/, "Bi " /*7c8a*/, "Cui " /*7c8b*/, "[?] " /*7c8c*/, "Li " /*7c8d*/, "Chi " /*7c8e*/, "Nukamiso " /*7c8f*/, "Ro " /*7c90*/, "Ba " /*7c91*/, "Li " /*7c92*/, "Gan " /*7c93*/, "Ju " /*7c94*/, "Po " /*7c95*/, "Mo " /*7c96*/, "Cu " /*7c97*/, "Nian " /*7c98*/, "Zhou " /*7c99*/, "Li " /*7c9a*/, "Su " /*7c9b*/, "Tiao " /*7c9c*/, "Li " /*7c9d*/, "Qi " /*7c9e*/, "Su " /*7c9f*/, "Hong " /*7ca0*/, "Tong " /*7ca1*/, "Zi " /*7ca2*/, "Ce " /*7ca3*/, "Yue " /*7ca4*/, "Zhou " /*7ca5*/, "Lin " /*7ca6*/, "Zhuang " /*7ca7*/, "Bai " /*7ca8*/, "[?] " /*7ca9*/, "Fen " /*7caa*/, "Ji " /*7cab*/, "[?] " /*7cac*/, "Sukumo " /*7cad*/, "Liang " /*7cae*/, "Xian " /*7caf*/, "Fu " /*7cb0*/, "Liang " /*7cb1*/, "Can " /*7cb2*/, "Geng " /*7cb3*/, "Li " /*7cb4*/, "Yue " /*7cb5*/, "Lu " /*7cb6*/, "Ju " /*7cb7*/, "Qi " /*7cb8*/, "Cui " /*7cb9*/, "Bai " /*7cba*/, "Zhang " /*7cbb*/, "Lin " /*7cbc*/, "Zong " /*7cbd*/, "Jing " /*7cbe*/, "Guo " /*7cbf*/, "Kouji " /*7cc0*/, "San " /*7cc1*/, "San " /*7cc2*/, "Tang " /*7cc3*/, "Bian " /*7cc4*/, "Rou " /*7cc5*/, "Mian " /*7cc6*/, "Hou " /*7cc7*/, "Xu " /*7cc8*/, "Zong " /*7cc9*/, "Hu " /*7cca*/, "Jian " /*7ccb*/, "Zan " /*7ccc*/, "Ci " /*7ccd*/, "Li " /*7cce*/, "Xie " /*7ccf*/, "Fu " /*7cd0*/, "Ni " /*7cd1*/, "Bei " /*7cd2*/, "Gu " /*7cd3*/, "Xiu " /*7cd4*/, "Gao " /*7cd5*/, "Tang " /*7cd6*/, "Qiu " /*7cd7*/, "Sukumo " /*7cd8*/, "Cao " /*7cd9*/, "Zhuang " /*7cda*/, "Tang " /*7cdb*/, "Mi " /*7cdc*/, "San " /*7cdd*/, "Fen " /*7cde*/, "Zao " /*7cdf*/, "Kang " /*7ce0*/, "Jiang " /*7ce1*/, "Mo " /*7ce2*/, "San " /*7ce3*/, "San " /*7ce4*/, "Nuo " /*7ce5*/, "Xi " /*7ce6*/, "Liang " /*7ce7*/, "Jiang " /*7ce8*/, "Kuai " /*7ce9*/, "Bo " /*7cea*/, "Huan " /*7ceb*/, "[?] " /*7cec*/, "Zong " /*7ced*/, "Xian " /*7cee*/, "Nuo " /*7cef*/, "Tuan " /*7cf0*/, "Nie " /*7cf1*/, "Li " /*7cf2*/, "Zuo " /*7cf3*/, "Di " /*7cf4*/, "Nie " /*7cf5*/, "Tiao " /*7cf6*/, "Lan " /*7cf7*/, "Mi " /*7cf8*/, "Jiao " /*7cf9*/, "Jiu " /*7cfa*/, "Xi " /*7cfb*/, "Gong " /*7cfc*/, "Zheng " /*7cfd*/, "Jiu " /*7cfe*/, "You " /*7cff*/ 
			});
						characters.TryAdd(125 /*32000 7d*/, new string[] {
				"Ji " /*7d00*/, "Cha " /*7d01*/, "Zhou " /*7d02*/, "Xun " /*7d03*/, "Yue " /*7d04*/, "Hong " /*7d05*/, "Yu " /*7d06*/, "He " /*7d07*/, "Wan " /*7d08*/, "Ren " /*7d09*/, "Wen " /*7d0a*/, "Wen " /*7d0b*/, "Qiu " /*7d0c*/, "Na " /*7d0d*/, "Zi " /*7d0e*/, "Tou " /*7d0f*/, "Niu " /*7d10*/, "Fou " /*7d11*/, "Jie " /*7d12*/, "Shu " /*7d13*/, "Chun " /*7d14*/, "Pi " /*7d15*/, "Yin " /*7d16*/, "Sha " /*7d17*/, "Hong " /*7d18*/, "Zhi " /*7d19*/, "Ji " /*7d1a*/, "Fen " /*7d1b*/, "Yun " /*7d1c*/, "Ren " /*7d1d*/, "Dan " /*7d1e*/, "Jin " /*7d1f*/, "Su " /*7d20*/, "Fang " /*7d21*/, "Suo " /*7d22*/, "Cui " /*7d23*/, "Jiu " /*7d24*/, "Zha " /*7d25*/, "Kinu " /*7d26*/, "Jin " /*7d27*/, "Fu " /*7d28*/, "Zhi " /*7d29*/, "Ci " /*7d2a*/, "Zi " /*7d2b*/, "Chou " /*7d2c*/, "Hong " /*7d2d*/, "Zha " /*7d2e*/, "Lei " /*7d2f*/, "Xi " /*7d30*/, "Fu " /*7d31*/, "Xie " /*7d32*/, "Shen " /*7d33*/, "Bei " /*7d34*/, "Zhu " /*7d35*/, "Qu " /*7d36*/, "Ling " /*7d37*/, "Zhu " /*7d38*/, "Shao " /*7d39*/, "Gan " /*7d3a*/, "Yang " /*7d3b*/, "Fu " /*7d3c*/, "Tuo " /*7d3d*/, "Zhen " /*7d3e*/, "Dai " /*7d3f*/, "Zhuo " /*7d40*/, "Shi " /*7d41*/, "Zhong " /*7d42*/, "Xian " /*7d43*/, "Zu " /*7d44*/, "Jiong " /*7d45*/, "Ban " /*7d46*/, "Ju " /*7d47*/, "Mo " /*7d48*/, "Shu " /*7d49*/, "Zui " /*7d4a*/, "Wata " /*7d4b*/, "Jing " /*7d4c*/, "Ren " /*7d4d*/, "Heng " /*7d4e*/, "Xie " /*7d4f*/, "Jie " /*7d50*/, "Zhu " /*7d51*/, "Chou " /*7d52*/, "Gua " /*7d53*/, "Bai " /*7d54*/, "Jue " /*7d55*/, "Kuang " /*7d56*/, "Hu " /*7d57*/, "Ci " /*7d58*/, "Geng " /*7d59*/, "Geng " /*7d5a*/, "Tao " /*7d5b*/, "Xie " /*7d5c*/, "Ku " /*7d5d*/, "Jiao " /*7d5e*/, "Quan " /*7d5f*/, "Gai " /*7d60*/, "Luo " /*7d61*/, "Xuan " /*7d62*/, "Bing " /*7d63*/, "Xian " /*7d64*/, "Fu " /*7d65*/, "Gei " /*7d66*/, "Tong " /*7d67*/, "Rong " /*7d68*/, "Tiao " /*7d69*/, "Yin " /*7d6a*/, "Lei " /*7d6b*/, "Xie " /*7d6c*/, "Quan " /*7d6d*/, "Xu " /*7d6e*/, "Lun " /*7d6f*/, "Die " /*7d70*/, "Tong " /*7d71*/, "Si " /*7d72*/, "Jiang " /*7d73*/, "Xiang " /*7d74*/, "Hui " /*7d75*/, "Jue " /*7d76*/, "Zhi " /*7d77*/, "Jian " /*7d78*/, "Juan " /*7d79*/, "Chi " /*7d7a*/, "Mian " /*7d7b*/, "Zhen " /*7d7c*/, "Lu " /*7d7d*/, "Cheng " /*7d7e*/, "Qiu " /*7d7f*/, "Shu " /*7d80*/, "Bang " /*7d81*/, "Tong " /*7d82*/, "Xiao " /*7d83*/, "Wan " /*7d84*/, "Qin " /*7d85*/, "Geng " /*7d86*/, "Xiu " /*7d87*/, "Ti " /*7d88*/, "Xiu " /*7d89*/, "Xie " /*7d8a*/, "Hong " /*7d8b*/, "Xi " /*7d8c*/, "Fu " /*7d8d*/, "Ting " /*7d8e*/, "Sui " /*7d8f*/, "Dui " /*7d90*/, "Kun " /*7d91*/, "Fu " /*7d92*/, "Jing " /*7d93*/, "Hu " /*7d94*/, "Zhi " /*7d95*/, "Yan " /*7d96*/, "Jiong " /*7d97*/, "Feng " /*7d98*/, "Ji " /*7d99*/, "Sok " /*7d9a*/, "Kase " /*7d9b*/, "Zong " /*7d9c*/, "Lin " /*7d9d*/, "Duo " /*7d9e*/, "Li " /*7d9f*/, "Lu " /*7da0*/, "Liang " /*7da1*/, "Chou " /*7da2*/, "Quan " /*7da3*/, "Shao " /*7da4*/, "Qi " /*7da5*/, "Qi " /*7da6*/, "Zhun " /*7da7*/, "Qi " /*7da8*/, "Wan " /*7da9*/, "Qian " /*7daa*/, "Xian " /*7dab*/, "Shou " /*7dac*/, "Wei " /*7dad*/, "Qi " /*7dae*/, "Tao " /*7daf*/, "Wan " /*7db0*/, "Gang " /*7db1*/, "Wang " /*7db2*/, "Beng " /*7db3*/, "Zhui " /*7db4*/, "Cai " /*7db5*/, "Guo " /*7db6*/, "Cui " /*7db7*/, "Lun " /*7db8*/, "Liu " /*7db9*/, "Qi " /*7dba*/, "Zhan " /*7dbb*/, "Bei " /*7dbc*/, "Chuo " /*7dbd*/, "Ling " /*7dbe*/, "Mian " /*7dbf*/, "Qi " /*7dc0*/, "Qie " /*7dc1*/, "Tan " /*7dc2*/, "Zong " /*7dc3*/, "Gun " /*7dc4*/, "Zou " /*7dc5*/, "Yi " /*7dc6*/, "Zi " /*7dc7*/, "Xing " /*7dc8*/, "Liang " /*7dc9*/, "Jin " /*7dca*/, "Fei " /*7dcb*/, "Rui " /*7dcc*/, "Min " /*7dcd*/, "Yu " /*7dce*/, "Zong " /*7dcf*/, "Fan " /*7dd0*/, "Lu " /*7dd1*/, "Xu " /*7dd2*/, "Yingl " /*7dd3*/, "Zhang " /*7dd4*/, "Kasuri " /*7dd5*/, "Xu " /*7dd6*/, "Xiang " /*7dd7*/, "Jian " /*7dd8*/, "Ke " /*7dd9*/, "Xian " /*7dda*/, "Ruan " /*7ddb*/, "Mian " /*7ddc*/, "Qi " /*7ddd*/, "Duan " /*7dde*/, "Zhong " /*7ddf*/, "Di " /*7de0*/, "Min " /*7de1*/, "Miao " /*7de2*/, "Yuan " /*7de3*/, "Xie " /*7de4*/, "Bao " /*7de5*/, "Si " /*7de6*/, "Qiu " /*7de7*/, "Bian " /*7de8*/, "Huan " /*7de9*/, "Geng " /*7dea*/, "Cong " /*7deb*/, "Mian " /*7dec*/, "Wei " /*7ded*/, "Fu " /*7dee*/, "Wei " /*7def*/, "Yu " /*7df0*/, "Gou " /*7df1*/, "Miao " /*7df2*/, "Xie " /*7df3*/, "Lian " /*7df4*/, "Zong " /*7df5*/, "Bian " /*7df6*/, "Yun " /*7df7*/, "Yin " /*7df8*/, "Ti " /*7df9*/, "Gua " /*7dfa*/, "Zhi " /*7dfb*/, "Yun " /*7dfc*/, "Cheng " /*7dfd*/, "Chan " /*7dfe*/, "Dai " /*7dff*/ 
			});
						characters.TryAdd(126 /*32256 7e*/, new string[] {
				"Xia " /*7e00*/, "Yuan " /*7e01*/, "Zong " /*7e02*/, "Xu " /*7e03*/, "Nawa " /*7e04*/, "Odoshi " /*7e05*/, "Geng " /*7e06*/, "Sen " /*7e07*/, "Ying " /*7e08*/, "Jin " /*7e09*/, "Yi " /*7e0a*/, "Zhui " /*7e0b*/, "Ni " /*7e0c*/, "Bang " /*7e0d*/, "Gu " /*7e0e*/, "Pan " /*7e0f*/, "Zhou " /*7e10*/, "Jian " /*7e11*/, "Cuo " /*7e12*/, "Quan " /*7e13*/, "Shuang " /*7e14*/, "Yun " /*7e15*/, "Xia " /*7e16*/, "Shuai " /*7e17*/, "Xi " /*7e18*/, "Rong " /*7e19*/, "Tao " /*7e1a*/, "Fu " /*7e1b*/, "Yun " /*7e1c*/, "Zhen " /*7e1d*/, "Gao " /*7e1e*/, "Ru " /*7e1f*/, "Hu " /*7e20*/, "Zai " /*7e21*/, "Teng " /*7e22*/, "Xian " /*7e23*/, "Su " /*7e24*/, "Zhen " /*7e25*/, "Zong " /*7e26*/, "Tao " /*7e27*/, "Horo " /*7e28*/, "Cai " /*7e29*/, "Bi " /*7e2a*/, "Feng " /*7e2b*/, "Cu " /*7e2c*/, "Li " /*7e2d*/, "Suo " /*7e2e*/, "Yin " /*7e2f*/, "Xi " /*7e30*/, "Zong " /*7e31*/, "Lei " /*7e32*/, "Zhuan " /*7e33*/, "Qian " /*7e34*/, "Man " /*7e35*/, "Zhi " /*7e36*/, "Lu " /*7e37*/, "Mo " /*7e38*/, "Piao " /*7e39*/, "Lian " /*7e3a*/, "Mi " /*7e3b*/, "Xuan " /*7e3c*/, "Zong " /*7e3d*/, "Ji " /*7e3e*/, "Shan " /*7e3f*/, "Sui " /*7e40*/, "Fan " /*7e41*/, "Shuai " /*7e42*/, "Beng " /*7e43*/, "Yi " /*7e44*/, "Sao " /*7e45*/, "Mou " /*7e46*/, "Zhou " /*7e47*/, "Qiang " /*7e48*/, "Hun " /*7e49*/, "Sem " /*7e4a*/, "Xi " /*7e4b*/, "Jung " /*7e4c*/, "Xiu " /*7e4d*/, "Ran " /*7e4e*/, "Xuan " /*7e4f*/, "Hui " /*7e50*/, "Qiao " /*7e51*/, "Zeng " /*7e52*/, "Zuo " /*7e53*/, "Zhi " /*7e54*/, "Shan " /*7e55*/, "San " /*7e56*/, "Lin " /*7e57*/, "Yu " /*7e58*/, "Fan " /*7e59*/, "Liao " /*7e5a*/, "Chuo " /*7e5b*/, "Zun " /*7e5c*/, "Jian " /*7e5d*/, "Rao " /*7e5e*/, "Chan " /*7e5f*/, "Rui " /*7e60*/, "Xiu " /*7e61*/, "Hui " /*7e62*/, "Hua " /*7e63*/, "Zuan " /*7e64*/, "Xi " /*7e65*/, "Qiang " /*7e66*/, "Un " /*7e67*/, "Da " /*7e68*/, "Sheng " /*7e69*/, "Hui " /*7e6a*/, "Xi " /*7e6b*/, "Se " /*7e6c*/, "Jian " /*7e6d*/, "Jiang " /*7e6e*/, "Huan " /*7e6f*/, "Zao " /*7e70*/, "Cong " /*7e71*/, "Jie " /*7e72*/, "Jiao " /*7e73*/, "Bo " /*7e74*/, "Chan " /*7e75*/, "Yi " /*7e76*/, "Nao " /*7e77*/, "Sui " /*7e78*/, "Yi " /*7e79*/, "Shai " /*7e7a*/, "Xu " /*7e7b*/, "Ji " /*7e7c*/, "Bin " /*7e7d*/, "Qian " /*7e7e*/, "Lan " /*7e7f*/, "Pu " /*7e80*/, "Xun " /*7e81*/, "Zuan " /*7e82*/, "Qi " /*7e83*/, "Peng " /*7e84*/, "Li " /*7e85*/, "Mo " /*7e86*/, "Lei " /*7e87*/, "Xie " /*7e88*/, "Zuan " /*7e89*/, "Kuang " /*7e8a*/, "You " /*7e8b*/, "Xu " /*7e8c*/, "Lei " /*7e8d*/, "Xian " /*7e8e*/, "Chan " /*7e8f*/, "Kou " /*7e90*/, "Lu " /*7e91*/, "Chan " /*7e92*/, "Ying " /*7e93*/, "Cai " /*7e94*/, "Xiang " /*7e95*/, "Xian " /*7e96*/, "Zui " /*7e97*/, "Zuan " /*7e98*/, "Luo " /*7e99*/, "Xi " /*7e9a*/, "Dao " /*7e9b*/, "Lan " /*7e9c*/, "Lei " /*7e9d*/, "Lian " /*7e9e*/, "Si " /*7e9f*/, "Jiu " /*7ea0*/, "Yu " /*7ea1*/, "Hong " /*7ea2*/, "Zhou " /*7ea3*/, "Xian " /*7ea4*/, "He " /*7ea5*/, "Yue " /*7ea6*/, "Ji " /*7ea7*/, "Wan " /*7ea8*/, "Kuang " /*7ea9*/, "Ji " /*7eaa*/, "Ren " /*7eab*/, "Wei " /*7eac*/, "Yun " /*7ead*/, "Hong " /*7eae*/, "Chun " /*7eaf*/, "Pi " /*7eb0*/, "Sha " /*7eb1*/, "Gang " /*7eb2*/, "Na " /*7eb3*/, "Ren " /*7eb4*/, "Zong " /*7eb5*/, "Lun " /*7eb6*/, "Fen " /*7eb7*/, "Zhi " /*7eb8*/, "Wen " /*7eb9*/, "Fang " /*7eba*/, "Zhu " /*7ebb*/, "Yin " /*7ebc*/, "Niu " /*7ebd*/, "Shu " /*7ebe*/, "Xian " /*7ebf*/, "Gan " /*7ec0*/, "Xie " /*7ec1*/, "Fu " /*7ec2*/, "Lian " /*7ec3*/, "Zu " /*7ec4*/, "Shen " /*7ec5*/, "Xi " /*7ec6*/, "Zhi " /*7ec7*/, "Zhong " /*7ec8*/, "Zhou " /*7ec9*/, "Ban " /*7eca*/, "Fu " /*7ecb*/, "Zhuo " /*7ecc*/, "Shao " /*7ecd*/, "Yi " /*7ece*/, "Jing " /*7ecf*/, "Dai " /*7ed0*/, "Bang " /*7ed1*/, "Rong " /*7ed2*/, "Jie " /*7ed3*/, "Ku " /*7ed4*/, "Rao " /*7ed5*/, "Die " /*7ed6*/, "Heng " /*7ed7*/, "Hui " /*7ed8*/, "Gei " /*7ed9*/, "Xuan " /*7eda*/, "Jiang " /*7edb*/, "Luo " /*7edc*/, "Jue " /*7edd*/, "Jiao " /*7ede*/, "Tong " /*7edf*/, "Geng " /*7ee0*/, "Xiao " /*7ee1*/, "Juan " /*7ee2*/, "Xiu " /*7ee3*/, "Xi " /*7ee4*/, "Sui " /*7ee5*/, "Tao " /*7ee6*/, "Ji " /*7ee7*/, "Ti " /*7ee8*/, "Ji " /*7ee9*/, "Xu " /*7eea*/, "Ling " /*7eeb*/, "[?] " /*7eec*/, "Xu " /*7eed*/, "Qi " /*7eee*/, "Fei " /*7eef*/, "Chuo " /*7ef0*/, "Zhang " /*7ef1*/, "Gun " /*7ef2*/, "Sheng " /*7ef3*/, "Wei " /*7ef4*/, "Mian " /*7ef5*/, "Shou " /*7ef6*/, "Beng " /*7ef7*/, "Chou " /*7ef8*/, "Tao " /*7ef9*/, "Liu " /*7efa*/, "Quan " /*7efb*/, "Zong " /*7efc*/, "Zhan " /*7efd*/, "Wan " /*7efe*/, "Lu " /*7eff*/ 
			});
						characters.TryAdd(127 /*32512 7f*/, new string[] {
				"Zhui " /*7f00*/, "Zi " /*7f01*/, "Ke " /*7f02*/, "Xiang " /*7f03*/, "Jian " /*7f04*/, "Mian " /*7f05*/, "Lan " /*7f06*/, "Ti " /*7f07*/, "Miao " /*7f08*/, "Qi " /*7f09*/, "Yun " /*7f0a*/, "Hui " /*7f0b*/, "Si " /*7f0c*/, "Duo " /*7f0d*/, "Duan " /*7f0e*/, "Bian " /*7f0f*/, "Xian " /*7f10*/, "Gou " /*7f11*/, "Zhui " /*7f12*/, "Huan " /*7f13*/, "Di " /*7f14*/, "Lu " /*7f15*/, "Bian " /*7f16*/, "Min " /*7f17*/, "Yuan " /*7f18*/, "Jin " /*7f19*/, "Fu " /*7f1a*/, "Ru " /*7f1b*/, "Zhen " /*7f1c*/, "Feng " /*7f1d*/, "Shuai " /*7f1e*/, "Gao " /*7f1f*/, "Chan " /*7f20*/, "Li " /*7f21*/, "Yi " /*7f22*/, "Jian " /*7f23*/, "Bin " /*7f24*/, "Piao " /*7f25*/, "Man " /*7f26*/, "Lei " /*7f27*/, "Ying " /*7f28*/, "Suo " /*7f29*/, "Mou " /*7f2a*/, "Sao " /*7f2b*/, "Xie " /*7f2c*/, "Liao " /*7f2d*/, "Shan " /*7f2e*/, "Zeng " /*7f2f*/, "Jiang " /*7f30*/, "Qian " /*7f31*/, "Zao " /*7f32*/, "Huan " /*7f33*/, "Jiao " /*7f34*/, "Zuan " /*7f35*/, "Fou " /*7f36*/, "Xie " /*7f37*/, "Gang " /*7f38*/, "Fou " /*7f39*/, "Que " /*7f3a*/, "Fou " /*7f3b*/, "Kaakeru " /*7f3c*/, "Bo " /*7f3d*/, "Ping " /*7f3e*/, "Hou " /*7f3f*/, "[?] " /*7f40*/, "Gang " /*7f41*/, "Ying " /*7f42*/, "Ying " /*7f43*/, "Qing " /*7f44*/, "Xia " /*7f45*/, "Guan " /*7f46*/, "Zun " /*7f47*/, "Tan " /*7f48*/, "Chang " /*7f49*/, "Qi " /*7f4a*/, "Weng " /*7f4b*/, "Ying " /*7f4c*/, "Lei " /*7f4d*/, "Tan " /*7f4e*/, "Lu " /*7f4f*/, "Guan " /*7f50*/, "Wang " /*7f51*/, "Wang " /*7f52*/, "Gang " /*7f53*/, "Wang " /*7f54*/, "Han " /*7f55*/, "[?] " /*7f56*/, "Luo " /*7f57*/, "Fu " /*7f58*/, "Mi " /*7f59*/, "Fa " /*7f5a*/, "Gu " /*7f5b*/, "Zhu " /*7f5c*/, "Ju " /*7f5d*/, "Mao " /*7f5e*/, "Gu " /*7f5f*/, "Min " /*7f60*/, "Gang " /*7f61*/, "Ba " /*7f62*/, "Gua " /*7f63*/, "Ti " /*7f64*/, "Juan " /*7f65*/, "Fu " /*7f66*/, "Lin " /*7f67*/, "Yan " /*7f68*/, "Zhao " /*7f69*/, "Zui " /*7f6a*/, "Gua " /*7f6b*/, "Zhuo " /*7f6c*/, "Yu " /*7f6d*/, "Zhi " /*7f6e*/, "An " /*7f6f*/, "Fa " /*7f70*/, "Nan " /*7f71*/, "Shu " /*7f72*/, "Si " /*7f73*/, "Pi " /*7f74*/, "Ma " /*7f75*/, "Liu " /*7f76*/, "Ba " /*7f77*/, "Fa " /*7f78*/, "Li " /*7f79*/, "Chao " /*7f7a*/, "Wei " /*7f7b*/, "Bi " /*7f7c*/, "Ji " /*7f7d*/, "Zeng " /*7f7e*/, "Tong " /*7f7f*/, "Liu " /*7f80*/, "Ji " /*7f81*/, "Juan " /*7f82*/, "Mi " /*7f83*/, "Zhao " /*7f84*/, "Luo " /*7f85*/, "Pi " /*7f86*/, "Ji " /*7f87*/, "Ji " /*7f88*/, "Luan " /*7f89*/, "Yang " /*7f8a*/, "Mie " /*7f8b*/, "Qiang " /*7f8c*/, "Ta " /*7f8d*/, "Mei " /*7f8e*/, "Yang " /*7f8f*/, "You " /*7f90*/, "You " /*7f91*/, "Fen " /*7f92*/, "Ba " /*7f93*/, "Gao " /*7f94*/, "Yang " /*7f95*/, "Gu " /*7f96*/, "Qiang " /*7f97*/, "Zang " /*7f98*/, "Gao " /*7f99*/, "Ling " /*7f9a*/, "Yi " /*7f9b*/, "Zhu " /*7f9c*/, "Di " /*7f9d*/, "Xiu " /*7f9e*/, "Qian " /*7f9f*/, "Yi " /*7fa0*/, "Xian " /*7fa1*/, "Rong " /*7fa2*/, "Qun " /*7fa3*/, "Qun " /*7fa4*/, "Qian " /*7fa5*/, "Huan " /*7fa6*/, "Zui " /*7fa7*/, "Xian " /*7fa8*/, "Yi " /*7fa9*/, "Yashinau " /*7faa*/, "Qiang " /*7fab*/, "Xian " /*7fac*/, "Yu " /*7fad*/, "Geng " /*7fae*/, "Jie " /*7faf*/, "Tang " /*7fb0*/, "Yuan " /*7fb1*/, "Xi " /*7fb2*/, "Fan " /*7fb3*/, "Shan " /*7fb4*/, "Fen " /*7fb5*/, "Shan " /*7fb6*/, "Lian " /*7fb7*/, "Lei " /*7fb8*/, "Geng " /*7fb9*/, "Nou " /*7fba*/, "Qiang " /*7fbb*/, "Chan " /*7fbc*/, "Yu " /*7fbd*/, "Gong " /*7fbe*/, "Yi " /*7fbf*/, "Chong " /*7fc0*/, "Weng " /*7fc1*/, "Fen " /*7fc2*/, "Hong " /*7fc3*/, "Chi " /*7fc4*/, "Chi " /*7fc5*/, "Cui " /*7fc6*/, "Fu " /*7fc7*/, "Xia " /*7fc8*/, "Pen " /*7fc9*/, "Yi " /*7fca*/, "La " /*7fcb*/, "Yi " /*7fcc*/, "Pi " /*7fcd*/, "Ling " /*7fce*/, "Liu " /*7fcf*/, "Zhi " /*7fd0*/, "Qu " /*7fd1*/, "Xi " /*7fd2*/, "Xie " /*7fd3*/, "Xiang " /*7fd4*/, "Xi " /*7fd5*/, "Xi " /*7fd6*/, "Qi " /*7fd7*/, "Qiao " /*7fd8*/, "Hui " /*7fd9*/, "Hui " /*7fda*/, "Xiao " /*7fdb*/, "Se " /*7fdc*/, "Hong " /*7fdd*/, "Jiang " /*7fde*/, "Di " /*7fdf*/, "Cui " /*7fe0*/, "Fei " /*7fe1*/, "Tao " /*7fe2*/, "Sha " /*7fe3*/, "Chi " /*7fe4*/, "Zhu " /*7fe5*/, "Jian " /*7fe6*/, "Xuan " /*7fe7*/, "Shi " /*7fe8*/, "Pian " /*7fe9*/, "Zong " /*7fea*/, "Wan " /*7feb*/, "Hui " /*7fec*/, "Hou " /*7fed*/, "He " /*7fee*/, "He " /*7fef*/, "Han " /*7ff0*/, "Ao " /*7ff1*/, "Piao " /*7ff2*/, "Yi " /*7ff3*/, "Lian " /*7ff4*/, "Qu " /*7ff5*/, "[?] " /*7ff6*/, "Lin " /*7ff7*/, "Pen " /*7ff8*/, "Qiao " /*7ff9*/, "Ao " /*7ffa*/, "Fan " /*7ffb*/, "Yi " /*7ffc*/, "Hui " /*7ffd*/, "Xuan " /*7ffe*/, "Dao " /*7fff*/ 
			});
						characters.TryAdd(128 /*32768 80*/, new string[] {
				"Yao " /*8000*/, "Lao " /*8001*/, "[?] " /*8002*/, "Kao " /*8003*/, "Mao " /*8004*/, "Zhe " /*8005*/, "Qi " /*8006*/, "Gou " /*8007*/, "Gou " /*8008*/, "Gou " /*8009*/, "Die " /*800a*/, "Die " /*800b*/, "Er " /*800c*/, "Shua " /*800d*/, "Ruan " /*800e*/, "Er " /*800f*/, "Nai " /*8010*/, "Zhuan " /*8011*/, "Lei " /*8012*/, "Ting " /*8013*/, "Zi " /*8014*/, "Geng " /*8015*/, "Chao " /*8016*/, "Hao " /*8017*/, "Yun " /*8018*/, "Pa " /*8019*/, "Pi " /*801a*/, "Chi " /*801b*/, "Si " /*801c*/, "Chu " /*801d*/, "Jia " /*801e*/, "Ju " /*801f*/, "He " /*8020*/, "Chu " /*8021*/, "Lao " /*8022*/, "Lun " /*8023*/, "Ji " /*8024*/, "Tang " /*8025*/, "Ou " /*8026*/, "Lou " /*8027*/, "Nou " /*8028*/, "Gou " /*8029*/, "Pang " /*802a*/, "Ze " /*802b*/, "Lou " /*802c*/, "Ji " /*802d*/, "Lao " /*802e*/, "Huo " /*802f*/, "You " /*8030*/, "Mo " /*8031*/, "Huai " /*8032*/, "Er " /*8033*/, "Zhe " /*8034*/, "Ting " /*8035*/, "Ye " /*8036*/, "Da " /*8037*/, "Song " /*8038*/, "Qin " /*8039*/, "Yun " /*803a*/, "Chi " /*803b*/, "Dan " /*803c*/, "Dan " /*803d*/, "Hong " /*803e*/, "Geng " /*803f*/, "Zhi " /*8040*/, "[?] " /*8041*/, "Nie " /*8042*/, "Dan " /*8043*/, "Zhen " /*8044*/, "Che " /*8045*/, "Ling " /*8046*/, "Zheng " /*8047*/, "You " /*8048*/, "Wa " /*8049*/, "Liao " /*804a*/, "Long " /*804b*/, "Zhi " /*804c*/, "Ning " /*804d*/, "Tiao " /*804e*/, "Er " /*804f*/, "Ya " /*8050*/, "Die " /*8051*/, "Gua " /*8052*/, "[?] " /*8053*/, "Lian " /*8054*/, "Hao " /*8055*/, "Sheng " /*8056*/, "Lie " /*8057*/, "Pin " /*8058*/, "Jing " /*8059*/, "Ju " /*805a*/, "Bi " /*805b*/, "Di " /*805c*/, "Guo " /*805d*/, "Wen " /*805e*/, "Xu " /*805f*/, "Ping " /*8060*/, "Cong " /*8061*/, "Shikato " /*8062*/, "[?] " /*8063*/, "Ting " /*8064*/, "Yu " /*8065*/, "Cong " /*8066*/, "Kui " /*8067*/, "Tsuraneru " /*8068*/, "Kui " /*8069*/, "Cong " /*806a*/, "Lian " /*806b*/, "Weng " /*806c*/, "Kui " /*806d*/, "Lian " /*806e*/, "Lian " /*806f*/, "Cong " /*8070*/, "Ao " /*8071*/, "Sheng " /*8072*/, "Song " /*8073*/, "Ting " /*8074*/, "Kui " /*8075*/, "Nie " /*8076*/, "Zhi " /*8077*/, "Dan " /*8078*/, "Ning " /*8079*/, "Qie " /*807a*/, "Ji " /*807b*/, "Ting " /*807c*/, "Ting " /*807d*/, "Long " /*807e*/, "Yu " /*807f*/, "Yu " /*8080*/, "Zhao " /*8081*/, "Si " /*8082*/, "Su " /*8083*/, "Yi " /*8084*/, "Su " /*8085*/, "Si " /*8086*/, "Zhao " /*8087*/, "Zhao " /*8088*/, "Rou " /*8089*/, "Yi " /*808a*/, "Le " /*808b*/, "Ji " /*808c*/, "Qiu " /*808d*/, "Ken " /*808e*/, "Cao " /*808f*/, "Ge " /*8090*/, "Di " /*8091*/, "Huan " /*8092*/, "Huang " /*8093*/, "Yi " /*8094*/, "Ren " /*8095*/, "Xiao " /*8096*/, "Ru " /*8097*/, "Zhou " /*8098*/, "Yuan " /*8099*/, "Du " /*809a*/, "Gang " /*809b*/, "Rong " /*809c*/, "Gan " /*809d*/, "Cha " /*809e*/, "Wo " /*809f*/, "Chang " /*80a0*/, "Gu " /*80a1*/, "Zhi " /*80a2*/, "Han " /*80a3*/, "Fu " /*80a4*/, "Fei " /*80a5*/, "Fen " /*80a6*/, "Pei " /*80a7*/, "Pang " /*80a8*/, "Jian " /*80a9*/, "Fang " /*80aa*/, "Zhun " /*80ab*/, "You " /*80ac*/, "Na " /*80ad*/, "Hang " /*80ae*/, "Ken " /*80af*/, "Ran " /*80b0*/, "Gong " /*80b1*/, "Yu " /*80b2*/, "Wen " /*80b3*/, "Yao " /*80b4*/, "Jin " /*80b5*/, "Pi " /*80b6*/, "Qian " /*80b7*/, "Xi " /*80b8*/, "Xi " /*80b9*/, "Fei " /*80ba*/, "Ken " /*80bb*/, "Jing " /*80bc*/, "Tai " /*80bd*/, "Shen " /*80be*/, "Zhong " /*80bf*/, "Zhang " /*80c0*/, "Xie " /*80c1*/, "Shen " /*80c2*/, "Wei " /*80c3*/, "Zhou " /*80c4*/, "Die " /*80c5*/, "Dan " /*80c6*/, "Fei " /*80c7*/, "Ba " /*80c8*/, "Bo " /*80c9*/, "Qu " /*80ca*/, "Tian " /*80cb*/, "Bei " /*80cc*/, "Gua " /*80cd*/, "Tai " /*80ce*/, "Zi " /*80cf*/, "Ku " /*80d0*/, "Zhi " /*80d1*/, "Ni " /*80d2*/, "Ping " /*80d3*/, "Zi " /*80d4*/, "Fu " /*80d5*/, "Pang " /*80d6*/, "Zhen " /*80d7*/, "Xian " /*80d8*/, "Zuo " /*80d9*/, "Pei " /*80da*/, "Jia " /*80db*/, "Sheng " /*80dc*/, "Zhi " /*80dd*/, "Bao " /*80de*/, "Mu " /*80df*/, "Qu " /*80e0*/, "Hu " /*80e1*/, "Ke " /*80e2*/, "Yi " /*80e3*/, "Yin " /*80e4*/, "Xu " /*80e5*/, "Yang " /*80e6*/, "Long " /*80e7*/, "Dong " /*80e8*/, "Ka " /*80e9*/, "Lu " /*80ea*/, "Jing " /*80eb*/, "Nu " /*80ec*/, "Yan " /*80ed*/, "Pang " /*80ee*/, "Kua " /*80ef*/, "Yi " /*80f0*/, "Guang " /*80f1*/, "Gai " /*80f2*/, "Ge " /*80f3*/, "Dong " /*80f4*/, "Zhi " /*80f5*/, "Xiao " /*80f6*/, "Xiong " /*80f7*/, "Xiong " /*80f8*/, "Er " /*80f9*/, "E " /*80fa*/, "Xing " /*80fb*/, "Pian " /*80fc*/, "Neng " /*80fd*/, "Zi " /*80fe*/, "Gui " /*80ff*/ 
			});
						characters.TryAdd(129 /*33024 81*/, new string[] {
				"Cheng " /*8100*/, "Tiao " /*8101*/, "Zhi " /*8102*/, "Cui " /*8103*/, "Mei " /*8104*/, "Xie " /*8105*/, "Cui " /*8106*/, "Xie " /*8107*/, "Mo " /*8108*/, "Mai " /*8109*/, "Ji " /*810a*/, "Obiyaakasu " /*810b*/, "[?] " /*810c*/, "Kuai " /*810d*/, "Sa " /*810e*/, "Zang " /*810f*/, "Qi " /*8110*/, "Nao " /*8111*/, "Mi " /*8112*/, "Nong " /*8113*/, "Luan " /*8114*/, "Wan " /*8115*/, "Bo " /*8116*/, "Wen " /*8117*/, "Guan " /*8118*/, "Qiu " /*8119*/, "Jiao " /*811a*/, "Jing " /*811b*/, "Rou " /*811c*/, "Heng " /*811d*/, "Cuo " /*811e*/, "Lie " /*811f*/, "Shan " /*8120*/, "Ting " /*8121*/, "Mei " /*8122*/, "Chun " /*8123*/, "Shen " /*8124*/, "Xie " /*8125*/, "De " /*8126*/, "Zui " /*8127*/, "Cu " /*8128*/, "Xiu " /*8129*/, "Xin " /*812a*/, "Tuo " /*812b*/, "Pao " /*812c*/, "Cheng " /*812d*/, "Nei " /*812e*/, "Fu " /*812f*/, "Dou " /*8130*/, "Tuo " /*8131*/, "Niao " /*8132*/, "Noy " /*8133*/, "Pi " /*8134*/, "Gu " /*8135*/, "Gua " /*8136*/, "Li " /*8137*/, "Lian " /*8138*/, "Zhang " /*8139*/, "Cui " /*813a*/, "Jie " /*813b*/, "Liang " /*813c*/, "Zhou " /*813d*/, "Pi " /*813e*/, "Biao " /*813f*/, "Lun " /*8140*/, "Pian " /*8141*/, "Guo " /*8142*/, "Kui " /*8143*/, "Chui " /*8144*/, "Dan " /*8145*/, "Tian " /*8146*/, "Nei " /*8147*/, "Jing " /*8148*/, "Jie " /*8149*/, "La " /*814a*/, "Yi " /*814b*/, "An " /*814c*/, "Ren " /*814d*/, "Shen " /*814e*/, "Chuo " /*814f*/, "Fu " /*8150*/, "Fu " /*8151*/, "Ju " /*8152*/, "Fei " /*8153*/, "Qiang " /*8154*/, "Wan " /*8155*/, "Dong " /*8156*/, "Pi " /*8157*/, "Guo " /*8158*/, "Zong " /*8159*/, "Ding " /*815a*/, "Wu " /*815b*/, "Mei " /*815c*/, "Ruan " /*815d*/, "Zhuan " /*815e*/, "Zhi " /*815f*/, "Cou " /*8160*/, "Gua " /*8161*/, "Ou " /*8162*/, "Di " /*8163*/, "An " /*8164*/, "Xing " /*8165*/, "Nao " /*8166*/, "Yu " /*8167*/, "Chuan " /*8168*/, "Nan " /*8169*/, "Yun " /*816a*/, "Zhong " /*816b*/, "Rou " /*816c*/, "E " /*816d*/, "Sai " /*816e*/, "Tu " /*816f*/, "Yao " /*8170*/, "Jian " /*8171*/, "Wei " /*8172*/, "Jiao " /*8173*/, "Yu " /*8174*/, "Jia " /*8175*/, "Duan " /*8176*/, "Bi " /*8177*/, "Chang " /*8178*/, "Fu " /*8179*/, "Xian " /*817a*/, "Ni " /*817b*/, "Mian " /*817c*/, "Wa " /*817d*/, "Teng " /*817e*/, "Tui " /*817f*/, "Bang " /*8180*/, "Qian " /*8181*/, "Lu " /*8182*/, "Wa " /*8183*/, "Sou " /*8184*/, "Tang " /*8185*/, "Su " /*8186*/, "Zhui " /*8187*/, "Ge " /*8188*/, "Yi " /*8189*/, "Bo " /*818a*/, "Liao " /*818b*/, "Ji " /*818c*/, "Pi " /*818d*/, "Xie " /*818e*/, "Gao " /*818f*/, "Lu " /*8190*/, "Bin " /*8191*/, "Ou " /*8192*/, "Chang " /*8193*/, "Lu " /*8194*/, "Guo " /*8195*/, "Pang " /*8196*/, "Chuai " /*8197*/, "Piao " /*8198*/, "Jiang " /*8199*/, "Fu " /*819a*/, "Tang " /*819b*/, "Mo " /*819c*/, "Xi " /*819d*/, "Zhuan " /*819e*/, "Lu " /*819f*/, "Jiao " /*81a0*/, "Ying " /*81a1*/, "Lu " /*81a2*/, "Zhi " /*81a3*/, "Tara " /*81a4*/, "Chun " /*81a5*/, "Lian " /*81a6*/, "Tong " /*81a7*/, "Peng " /*81a8*/, "Ni " /*81a9*/, "Zha " /*81aa*/, "Liao " /*81ab*/, "Cui " /*81ac*/, "Gui " /*81ad*/, "Xiao " /*81ae*/, "Teng " /*81af*/, "Fan " /*81b0*/, "Zhi " /*81b1*/, "Jiao " /*81b2*/, "Shan " /*81b3*/, "Wu " /*81b4*/, "Cui " /*81b5*/, "Run " /*81b6*/, "Xiang " /*81b7*/, "Sui " /*81b8*/, "Fen " /*81b9*/, "Ying " /*81ba*/, "Tan " /*81bb*/, "Zhua " /*81bc*/, "Dan " /*81bd*/, "Kuai " /*81be*/, "Nong " /*81bf*/, "Tun " /*81c0*/, "Lian " /*81c1*/, "Bi " /*81c2*/, "Yong " /*81c3*/, "Jue " /*81c4*/, "Chu " /*81c5*/, "Yi " /*81c6*/, "Juan " /*81c7*/, "La " /*81c8*/, "Lian " /*81c9*/, "Sao " /*81ca*/, "Tun " /*81cb*/, "Gu " /*81cc*/, "Qi " /*81cd*/, "Cui " /*81ce*/, "Bin " /*81cf*/, "Xun " /*81d0*/, "Ru " /*81d1*/, "Huo " /*81d2*/, "Zang " /*81d3*/, "Xian " /*81d4*/, "Biao " /*81d5*/, "Xing " /*81d6*/, "Kuan " /*81d7*/, "La " /*81d8*/, "Yan " /*81d9*/, "Lu " /*81da*/, "Huo " /*81db*/, "Zang " /*81dc*/, "Luo " /*81dd*/, "Qu " /*81de*/, "Zang " /*81df*/, "Luan " /*81e0*/, "Ni " /*81e1*/, "Zang " /*81e2*/, "Chen " /*81e3*/, "Qian " /*81e4*/, "Wo " /*81e5*/, "Guang " /*81e6*/, "Zang " /*81e7*/, "Lin " /*81e8*/, "Guang " /*81e9*/, "Zi " /*81ea*/, "Jiao " /*81eb*/, "Nie " /*81ec*/, "Chou " /*81ed*/, "Ji " /*81ee*/, "Gao " /*81ef*/, "Chou " /*81f0*/, "Mian " /*81f1*/, "Nie " /*81f2*/, "Zhi " /*81f3*/, "Zhi " /*81f4*/, "Ge " /*81f5*/, "Jian " /*81f6*/, "Die " /*81f7*/, "Zhi " /*81f8*/, "Xiu " /*81f9*/, "Tai " /*81fa*/, "Zhen " /*81fb*/, "Jiu " /*81fc*/, "Xian " /*81fd*/, "Yu " /*81fe*/, "Cha " /*81ff*/ 
			});
						characters.TryAdd(130 /*33280 82*/, new string[] {
				"Yao " /*8200*/, "Yu " /*8201*/, "Chong " /*8202*/, "Xi " /*8203*/, "Xi " /*8204*/, "Jiu " /*8205*/, "Yu " /*8206*/, "Yu " /*8207*/, "Xing " /*8208*/, "Ju " /*8209*/, "Jiu " /*820a*/, "Xin " /*820b*/, "She " /*820c*/, "She " /*820d*/, "Yadoru " /*820e*/, "Jiu " /*820f*/, "Shi " /*8210*/, "Tan " /*8211*/, "Shu " /*8212*/, "Shi " /*8213*/, "Tian " /*8214*/, "Dan " /*8215*/, "Pu " /*8216*/, "Pu " /*8217*/, "Guan " /*8218*/, "Hua " /*8219*/, "Tan " /*821a*/, "Chuan " /*821b*/, "Shun " /*821c*/, "Xia " /*821d*/, "Wu " /*821e*/, "Zhou " /*821f*/, "Dao " /*8220*/, "Gang " /*8221*/, "Shan " /*8222*/, "Yi " /*8223*/, "[?] " /*8224*/, "Pa " /*8225*/, "Tai " /*8226*/, "Fan " /*8227*/, "Ban " /*8228*/, "Chuan " /*8229*/, "Hang " /*822a*/, "Fang " /*822b*/, "Ban " /*822c*/, "Que " /*822d*/, "Hesaki " /*822e*/, "Zhong " /*822f*/, "Jian " /*8230*/, "Cang " /*8231*/, "Ling " /*8232*/, "Zhu " /*8233*/, "Ze " /*8234*/, "Duo " /*8235*/, "Bo " /*8236*/, "Xian " /*8237*/, "Ge " /*8238*/, "Chuan " /*8239*/, "Jia " /*823a*/, "Lu " /*823b*/, "Hong " /*823c*/, "Pang " /*823d*/, "Xi " /*823e*/, "[?] " /*823f*/, "Fu " /*8240*/, "Zao " /*8241*/, "Feng " /*8242*/, "Li " /*8243*/, "Shao " /*8244*/, "Yu " /*8245*/, "Lang " /*8246*/, "Ting " /*8247*/, "[?] " /*8248*/, "Wei " /*8249*/, "Bo " /*824a*/, "Meng " /*824b*/, "Nian " /*824c*/, "Ju " /*824d*/, "Huang " /*824e*/, "Shou " /*824f*/, "Zong " /*8250*/, "Bian " /*8251*/, "Mao " /*8252*/, "Die " /*8253*/, "[?] " /*8254*/, "Bang " /*8255*/, "Cha " /*8256*/, "Yi " /*8257*/, "Sao " /*8258*/, "Cang " /*8259*/, "Cao " /*825a*/, "Lou " /*825b*/, "Dai " /*825c*/, "Sori " /*825d*/, "Yao " /*825e*/, "Tong " /*825f*/, "Yofune " /*8260*/, "Dang " /*8261*/, "Tan " /*8262*/, "Lu " /*8263*/, "Yi " /*8264*/, "Jie " /*8265*/, "Jian " /*8266*/, "Huo " /*8267*/, "Meng " /*8268*/, "Qi " /*8269*/, "Lu " /*826a*/, "Lu " /*826b*/, "Chan " /*826c*/, "Shuang " /*826d*/, "Gen " /*826e*/, "Liang " /*826f*/, "Jian " /*8270*/, "Jian " /*8271*/, "Se " /*8272*/, "Yan " /*8273*/, "Fu " /*8274*/, "Ping " /*8275*/, "Yan " /*8276*/, "Yan " /*8277*/, "Cao " /*8278*/, "Cao " /*8279*/, "Yi " /*827a*/, "Le " /*827b*/, "Ting " /*827c*/, "Qiu " /*827d*/, "Ai " /*827e*/, "Nai " /*827f*/, "Tiao " /*8280*/, "Jiao " /*8281*/, "Jie " /*8282*/, "Peng " /*8283*/, "Wan " /*8284*/, "Yi " /*8285*/, "Chai " /*8286*/, "Mian " /*8287*/, "Mie " /*8288*/, "Gan " /*8289*/, "Qian " /*828a*/, "Yu " /*828b*/, "Yu " /*828c*/, "Shuo " /*828d*/, "Qiong " /*828e*/, "Tu " /*828f*/, "Xia " /*8290*/, "Qi " /*8291*/, "Mang " /*8292*/, "Zi " /*8293*/, "Hui " /*8294*/, "Sui " /*8295*/, "Zhi " /*8296*/, "Xiang " /*8297*/, "Bi " /*8298*/, "Fu " /*8299*/, "Tun " /*829a*/, "Wei " /*829b*/, "Wu " /*829c*/, "Zhi " /*829d*/, "Qi " /*829e*/, "Shan " /*829f*/, "Wen " /*82a0*/, "Qian " /*82a1*/, "Ren " /*82a2*/, "Fou " /*82a3*/, "Kou " /*82a4*/, "Jie " /*82a5*/, "Lu " /*82a6*/, "Xu " /*82a7*/, "Ji " /*82a8*/, "Qin " /*82a9*/, "Qi " /*82aa*/, "Yuan " /*82ab*/, "Fen " /*82ac*/, "Ba " /*82ad*/, "Rui " /*82ae*/, "Xin " /*82af*/, "Ji " /*82b0*/, "Hua " /*82b1*/, "Hua " /*82b2*/, "Fang " /*82b3*/, "Wu " /*82b4*/, "Jue " /*82b5*/, "Gou " /*82b6*/, "Zhi " /*82b7*/, "Yun " /*82b8*/, "Qin " /*82b9*/, "Ao " /*82ba*/, "Chu " /*82bb*/, "Mao " /*82bc*/, "Ya " /*82bd*/, "Fei " /*82be*/, "Reng " /*82bf*/, "Hang " /*82c0*/, "Cong " /*82c1*/, "Yin " /*82c2*/, "You " /*82c3*/, "Bian " /*82c4*/, "Yi " /*82c5*/, "Susa " /*82c6*/, "Wei " /*82c7*/, "Li " /*82c8*/, "Pi " /*82c9*/, "E " /*82ca*/, "Xian " /*82cb*/, "Chang " /*82cc*/, "Cang " /*82cd*/, "Meng " /*82ce*/, "Su " /*82cf*/, "Yi " /*82d0*/, "Yuan " /*82d1*/, "Ran " /*82d2*/, "Ling " /*82d3*/, "Tai " /*82d4*/, "Tiao " /*82d5*/, "Di " /*82d6*/, "Miao " /*82d7*/, "Qiong " /*82d8*/, "Li " /*82d9*/, "Yong " /*82da*/, "Ke " /*82db*/, "Mu " /*82dc*/, "Pei " /*82dd*/, "Bao " /*82de*/, "Gou " /*82df*/, "Min " /*82e0*/, "Yi " /*82e1*/, "Yi " /*82e2*/, "Ju " /*82e3*/, "Pi " /*82e4*/, "Ruo " /*82e5*/, "Ku " /*82e6*/, "Zhu " /*82e7*/, "Ni " /*82e8*/, "Bo " /*82e9*/, "Bing " /*82ea*/, "Shan " /*82eb*/, "Qiu " /*82ec*/, "Yao " /*82ed*/, "Xian " /*82ee*/, "Ben " /*82ef*/, "Hong " /*82f0*/, "Ying " /*82f1*/, "Zha " /*82f2*/, "Dong " /*82f3*/, "Ju " /*82f4*/, "Die " /*82f5*/, "Nie " /*82f6*/, "Gan " /*82f7*/, "Hu " /*82f8*/, "Ping " /*82f9*/, "Mei " /*82fa*/, "Fu " /*82fb*/, "Sheng " /*82fc*/, "Gu " /*82fd*/, "Bi " /*82fe*/, "Wei " /*82ff*/ 
			});
						characters.TryAdd(131 /*33536 83*/, new string[] {
				"Fu " /*8300*/, "Zhuo " /*8301*/, "Mao " /*8302*/, "Fan " /*8303*/, "Qie " /*8304*/, "Mao " /*8305*/, "Mao " /*8306*/, "Ba " /*8307*/, "Zi " /*8308*/, "Mo " /*8309*/, "Zi " /*830a*/, "Di " /*830b*/, "Chi " /*830c*/, "Ji " /*830d*/, "Jing " /*830e*/, "Long " /*830f*/, "[?] " /*8310*/, "Niao " /*8311*/, "[?] " /*8312*/, "Xue " /*8313*/, "Ying " /*8314*/, "Qiong " /*8315*/, "Ge " /*8316*/, "Ming " /*8317*/, "Li " /*8318*/, "Rong " /*8319*/, "Yin " /*831a*/, "Gen " /*831b*/, "Qian " /*831c*/, "Chai " /*831d*/, "Chen " /*831e*/, "Yu " /*831f*/, "Xiu " /*8320*/, "Zi " /*8321*/, "Lie " /*8322*/, "Wu " /*8323*/, "Ji " /*8324*/, "Kui " /*8325*/, "Ce " /*8326*/, "Chong " /*8327*/, "Ci " /*8328*/, "Gou " /*8329*/, "Guang " /*832a*/, "Mang " /*832b*/, "Chi " /*832c*/, "Jiao " /*832d*/, "Jiao " /*832e*/, "Fu " /*832f*/, "Yu " /*8330*/, "Zhu " /*8331*/, "Zi " /*8332*/, "Jiang " /*8333*/, "Hui " /*8334*/, "Yin " /*8335*/, "Cha " /*8336*/, "Fa " /*8337*/, "Rong " /*8338*/, "Ru " /*8339*/, "Chong " /*833a*/, "Mang " /*833b*/, "Tong " /*833c*/, "Zhong " /*833d*/, "[?] " /*833e*/, "Zhu " /*833f*/, "Xun " /*8340*/, "Huan " /*8341*/, "Kua " /*8342*/, "Quan " /*8343*/, "Gai " /*8344*/, "Da " /*8345*/, "Jing " /*8346*/, "Xing " /*8347*/, "Quan " /*8348*/, "Cao " /*8349*/, "Jing " /*834a*/, "Er " /*834b*/, "An " /*834c*/, "Shou " /*834d*/, "Chi " /*834e*/, "Ren " /*834f*/, "Jian " /*8350*/, "Ti " /*8351*/, "Huang " /*8352*/, "Ping " /*8353*/, "Li " /*8354*/, "Jin " /*8355*/, "Lao " /*8356*/, "Shu " /*8357*/, "Zhuang " /*8358*/, "Da " /*8359*/, "Jia " /*835a*/, "Rao " /*835b*/, "Bi " /*835c*/, "Ze " /*835d*/, "Qiao " /*835e*/, "Hui " /*835f*/, "Qi " /*8360*/, "Dang " /*8361*/, "[?] " /*8362*/, "Rong " /*8363*/, "Hun " /*8364*/, "Ying " /*8365*/, "Luo " /*8366*/, "Ying " /*8367*/, "Xun " /*8368*/, "Jin " /*8369*/, "Sun " /*836a*/, "Yin " /*836b*/, "Mai " /*836c*/, "Hong " /*836d*/, "Zhou " /*836e*/, "Yao " /*836f*/, "Du " /*8370*/, "Wei " /*8371*/, "Chu " /*8372*/, "Dou " /*8373*/, "Fu " /*8374*/, "Ren " /*8375*/, "Yin " /*8376*/, "He " /*8377*/, "Bi " /*8378*/, "Bu " /*8379*/, "Yun " /*837a*/, "Di " /*837b*/, "Tu " /*837c*/, "Sui " /*837d*/, "Sui " /*837e*/, "Cheng " /*837f*/, "Chen " /*8380*/, "Wu " /*8381*/, "Bie " /*8382*/, "Xi " /*8383*/, "Geng " /*8384*/, "Li " /*8385*/, "Fu " /*8386*/, "Zhu " /*8387*/, "Mo " /*8388*/, "Li " /*8389*/, "Zhuang " /*838a*/, "Ji " /*838b*/, "Duo " /*838c*/, "Qiu " /*838d*/, "Sha " /*838e*/, "Suo " /*838f*/, "Chen " /*8390*/, "Feng " /*8391*/, "Ju " /*8392*/, "Mei " /*8393*/, "Meng " /*8394*/, "Xing " /*8395*/, "Jing " /*8396*/, "Che " /*8397*/, "Xin " /*8398*/, "Jun " /*8399*/, "Yan " /*839a*/, "Ting " /*839b*/, "Diao " /*839c*/, "Cuo " /*839d*/, "Wan " /*839e*/, "Han " /*839f*/, "You " /*83a0*/, "Cuo " /*83a1*/, "Jia " /*83a2*/, "Wang " /*83a3*/, "You " /*83a4*/, "Niu " /*83a5*/, "Shao " /*83a6*/, "Xian " /*83a7*/, "Lang " /*83a8*/, "Fu " /*83a9*/, "E " /*83aa*/, "Mo " /*83ab*/, "Wen " /*83ac*/, "Jie " /*83ad*/, "Nan " /*83ae*/, "Mu " /*83af*/, "Kan " /*83b0*/, "Lai " /*83b1*/, "Lian " /*83b2*/, "Shi " /*83b3*/, "Wo " /*83b4*/, "Usagi " /*83b5*/, "Lian " /*83b6*/, "Huo " /*83b7*/, "You " /*83b8*/, "Ying " /*83b9*/, "Ying " /*83ba*/, "Nuc " /*83bb*/, "Chun " /*83bc*/, "Mang " /*83bd*/, "Mang " /*83be*/, "Ci " /*83bf*/, "Wan " /*83c0*/, "Jing " /*83c1*/, "Di " /*83c2*/, "Qu " /*83c3*/, "Dong " /*83c4*/, "Jian " /*83c5*/, "Zou " /*83c6*/, "Gu " /*83c7*/, "La " /*83c8*/, "Lu " /*83c9*/, "Ju " /*83ca*/, "Wei " /*83cb*/, "Jun " /*83cc*/, "Nie " /*83cd*/, "Kun " /*83ce*/, "He " /*83cf*/, "Pu " /*83d0*/, "Zi " /*83d1*/, "Gao " /*83d2*/, "Guo " /*83d3*/, "Fu " /*83d4*/, "Lun " /*83d5*/, "Chang " /*83d6*/, "Chou " /*83d7*/, "Song " /*83d8*/, "Chui " /*83d9*/, "Zhan " /*83da*/, "Men " /*83db*/, "Cai " /*83dc*/, "Ba " /*83dd*/, "Li " /*83de*/, "Tu " /*83df*/, "Bo " /*83e0*/, "Han " /*83e1*/, "Bao " /*83e2*/, "Qin " /*83e3*/, "Juan " /*83e4*/, "Xi " /*83e5*/, "Qin " /*83e6*/, "Di " /*83e7*/, "Jie " /*83e8*/, "Pu " /*83e9*/, "Dang " /*83ea*/, "Jin " /*83eb*/, "Zhao " /*83ec*/, "Tai " /*83ed*/, "Geng " /*83ee*/, "Hua " /*83ef*/, "Gu " /*83f0*/, "Ling " /*83f1*/, "Fei " /*83f2*/, "Jin " /*83f3*/, "An " /*83f4*/, "Wang " /*83f5*/, "Beng " /*83f6*/, "Zhou " /*83f7*/, "Yan " /*83f8*/, "Ju " /*83f9*/, "Jian " /*83fa*/, "Lin " /*83fb*/, "Tan " /*83fc*/, "Shu " /*83fd*/, "Tian " /*83fe*/, "Dao " /*83ff*/ 
			});
						characters.TryAdd(132 /*33792 84*/, new string[] {
				"Hu " /*8400*/, "Qi " /*8401*/, "He " /*8402*/, "Cui " /*8403*/, "Tao " /*8404*/, "Chun " /*8405*/, "Bei " /*8406*/, "Chang " /*8407*/, "Huan " /*8408*/, "Fei " /*8409*/, "Lai " /*840a*/, "Qi " /*840b*/, "Meng " /*840c*/, "Ping " /*840d*/, "Wei " /*840e*/, "Dan " /*840f*/, "Sha " /*8410*/, "Huan " /*8411*/, "Yan " /*8412*/, "Yi " /*8413*/, "Tiao " /*8414*/, "Qi " /*8415*/, "Wan " /*8416*/, "Ce " /*8417*/, "Nai " /*8418*/, "Kutabireru " /*8419*/, "Tuo " /*841a*/, "Jiu " /*841b*/, "Tie " /*841c*/, "Luo " /*841d*/, "[?] " /*841e*/, "[?] " /*841f*/, "Meng " /*8420*/, "[?] " /*8421*/, "Yaji " /*8422*/, "[?] " /*8423*/, "Ying " /*8424*/, "Ying " /*8425*/, "Ying " /*8426*/, "Xiao " /*8427*/, "Sa " /*8428*/, "Qiu " /*8429*/, "Ke " /*842a*/, "Xiang " /*842b*/, "Wan " /*842c*/, "Yu " /*842d*/, "Yu " /*842e*/, "Fu " /*842f*/, "Lian " /*8430*/, "Xuan " /*8431*/, "Yuan " /*8432*/, "Nan " /*8433*/, "Ze " /*8434*/, "Wo " /*8435*/, "Chun " /*8436*/, "Xiao " /*8437*/, "Yu " /*8438*/, "Pian " /*8439*/, "Mao " /*843a*/, "An " /*843b*/, "E " /*843c*/, "Luo " /*843d*/, "Ying " /*843e*/, "Huo " /*843f*/, "Gua " /*8440*/, "Jiang " /*8441*/, "Mian " /*8442*/, "Zuo " /*8443*/, "Zuo " /*8444*/, "Ju " /*8445*/, "Bao " /*8446*/, "Rou " /*8447*/, "Xi " /*8448*/, "Xie " /*8449*/, "An " /*844a*/, "Qu " /*844b*/, "Jian " /*844c*/, "Fu " /*844d*/, "Lu " /*844e*/, "Jing " /*844f*/, "Pen " /*8450*/, "Feng " /*8451*/, "Hong " /*8452*/, "Hong " /*8453*/, "Hou " /*8454*/, "Yan " /*8455*/, "Tu " /*8456*/, "Zhu " /*8457*/, "Zi " /*8458*/, "Xiang " /*8459*/, "Shen " /*845a*/, "Ge " /*845b*/, "Jie " /*845c*/, "Jing " /*845d*/, "Mi " /*845e*/, "Huang " /*845f*/, "Shen " /*8460*/, "Pu " /*8461*/, "Gai " /*8462*/, "Dong " /*8463*/, "Zhou " /*8464*/, "Qian " /*8465*/, "Wei " /*8466*/, "Bo " /*8467*/, "Wei " /*8468*/, "Pa " /*8469*/, "Ji " /*846a*/, "Hu " /*846b*/, "Zang " /*846c*/, "Jia " /*846d*/, "Duan " /*846e*/, "Yao " /*846f*/, "Jun " /*8470*/, "Cong " /*8471*/, "Quan " /*8472*/, "Wei " /*8473*/, "Xian " /*8474*/, "Kui " /*8475*/, "Ting " /*8476*/, "Hun " /*8477*/, "Xi " /*8478*/, "Shi " /*8479*/, "Qi " /*847a*/, "Lan " /*847b*/, "Zong " /*847c*/, "Yao " /*847d*/, "Yuan " /*847e*/, "Mei " /*847f*/, "Yun " /*8480*/, "Shu " /*8481*/, "Di " /*8482*/, "Zhuan " /*8483*/, "Guan " /*8484*/, "Sukumo " /*8485*/, "Xue " /*8486*/, "Chan " /*8487*/, "Kai " /*8488*/, "Kui " /*8489*/, "[?] " /*848a*/, "Jiang " /*848b*/, "Lou " /*848c*/, "Wei " /*848d*/, "Pai " /*848e*/, "[?] " /*848f*/, "Sou " /*8490*/, "Yin " /*8491*/, "Shi " /*8492*/, "Chun " /*8493*/, "Shi " /*8494*/, "Yun " /*8495*/, "Zhen " /*8496*/, "Lang " /*8497*/, "Nu " /*8498*/, "Meng " /*8499*/, "He " /*849a*/, "Que " /*849b*/, "Suan " /*849c*/, "Yuan " /*849d*/, "Li " /*849e*/, "Ju " /*849f*/, "Xi " /*84a0*/, "Pang " /*84a1*/, "Chu " /*84a2*/, "Xu " /*84a3*/, "Tu " /*84a4*/, "Liu " /*84a5*/, "Wo " /*84a6*/, "Zhen " /*84a7*/, "Qian " /*84a8*/, "Zu " /*84a9*/, "Po " /*84aa*/, "Cuo " /*84ab*/, "Yuan " /*84ac*/, "Chu " /*84ad*/, "Yu " /*84ae*/, "Kuai " /*84af*/, "Pan " /*84b0*/, "Pu " /*84b1*/, "Pu " /*84b2*/, "Na " /*84b3*/, "Shuo " /*84b4*/, "Xi " /*84b5*/, "Fen " /*84b6*/, "Yun " /*84b7*/, "Zheng " /*84b8*/, "Jian " /*84b9*/, "Ji " /*84ba*/, "Ruo " /*84bb*/, "Cang " /*84bc*/, "En " /*84bd*/, "Mi " /*84be*/, "Hao " /*84bf*/, "Sun " /*84c0*/, "Zhen " /*84c1*/, "Ming " /*84c2*/, "Sou " /*84c3*/, "Xu " /*84c4*/, "Liu " /*84c5*/, "Xi " /*84c6*/, "Gu " /*84c7*/, "Lang " /*84c8*/, "Rong " /*84c9*/, "Weng " /*84ca*/, "Gai " /*84cb*/, "Cuo " /*84cc*/, "Shi " /*84cd*/, "Tang " /*84ce*/, "Luo " /*84cf*/, "Ru " /*84d0*/, "Suo " /*84d1*/, "Xian " /*84d2*/, "Bei " /*84d3*/, "Yao " /*84d4*/, "Gui " /*84d5*/, "Bi " /*84d6*/, "Zong " /*84d7*/, "Gun " /*84d8*/, "Za " /*84d9*/, "Xiu " /*84da*/, "Ce " /*84db*/, "Hai " /*84dc*/, "Lan " /*84dd*/, "[?] " /*84de*/, "Ji " /*84df*/, "Li " /*84e0*/, "Can " /*84e1*/, "Lang " /*84e2*/, "Yu " /*84e3*/, "[?] " /*84e4*/, "Ying " /*84e5*/, "Mo " /*84e6*/, "Diao " /*84e7*/, "Tiao " /*84e8*/, "Mao " /*84e9*/, "Tong " /*84ea*/, "Zhu " /*84eb*/, "Peng " /*84ec*/, "An " /*84ed*/, "Lian " /*84ee*/, "Cong " /*84ef*/, "Xi " /*84f0*/, "Ping " /*84f1*/, "Qiu " /*84f2*/, "Jin " /*84f3*/, "Chun " /*84f4*/, "Jie " /*84f5*/, "Wei " /*84f6*/, "Tui " /*84f7*/, "Cao " /*84f8*/, "Yu " /*84f9*/, "Yi " /*84fa*/, "Ji " /*84fb*/, "Liao " /*84fc*/, "Bi " /*84fd*/, "Lu " /*84fe*/, "Su " /*84ff*/ 
			});
						characters.TryAdd(133 /*34048 85*/, new string[] {
				"Bu " /*8500*/, "Zhang " /*8501*/, "Luo " /*8502*/, "Jiang " /*8503*/, "Man " /*8504*/, "Yan " /*8505*/, "Ling " /*8506*/, "Ji " /*8507*/, "Piao " /*8508*/, "Gun " /*8509*/, "Han " /*850a*/, "Di " /*850b*/, "Su " /*850c*/, "Lu " /*850d*/, "She " /*850e*/, "Shang " /*850f*/, "Di " /*8510*/, "Mie " /*8511*/, "Xun " /*8512*/, "Man " /*8513*/, "Bo " /*8514*/, "Di " /*8515*/, "Cuo " /*8516*/, "Zhe " /*8517*/, "Sen " /*8518*/, "Xuan " /*8519*/, "Wei " /*851a*/, "Hu " /*851b*/, "Ao " /*851c*/, "Mi " /*851d*/, "Lou " /*851e*/, "Cu " /*851f*/, "Zhong " /*8520*/, "Cai " /*8521*/, "Po " /*8522*/, "Jiang " /*8523*/, "Mi " /*8524*/, "Cong " /*8525*/, "Niao " /*8526*/, "Hui " /*8527*/, "Jun " /*8528*/, "Yin " /*8529*/, "Jian " /*852a*/, "Yan " /*852b*/, "Shu " /*852c*/, "Yin " /*852d*/, "Kui " /*852e*/, "Chen " /*852f*/, "Hu " /*8530*/, "Sha " /*8531*/, "Kou " /*8532*/, "Qian " /*8533*/, "Ma " /*8534*/, "Zang " /*8535*/, "Sonoko " /*8536*/, "Qiang " /*8537*/, "Dou " /*8538*/, "Lian " /*8539*/, "Lin " /*853a*/, "Kou " /*853b*/, "Ai " /*853c*/, "Bi " /*853d*/, "Li " /*853e*/, "Wei " /*853f*/, "Ji " /*8540*/, "Xun " /*8541*/, "Sheng " /*8542*/, "Fan " /*8543*/, "Meng " /*8544*/, "Ou " /*8545*/, "Chan " /*8546*/, "Dian " /*8547*/, "Xun " /*8548*/, "Jiao " /*8549*/, "Rui " /*854a*/, "Rui " /*854b*/, "Lei " /*854c*/, "Yu " /*854d*/, "Qiao " /*854e*/, "Chu " /*854f*/, "Hua " /*8550*/, "Jian " /*8551*/, "Mai " /*8552*/, "Yun " /*8553*/, "Bao " /*8554*/, "You " /*8555*/, "Qu " /*8556*/, "Lu " /*8557*/, "Rao " /*8558*/, "Hui " /*8559*/, "E " /*855a*/, "Teng " /*855b*/, "Fei " /*855c*/, "Jue " /*855d*/, "Zui " /*855e*/, "Fa " /*855f*/, "Ru " /*8560*/, "Fen " /*8561*/, "Kui " /*8562*/, "Shun " /*8563*/, "Rui " /*8564*/, "Ya " /*8565*/, "Xu " /*8566*/, "Fu " /*8567*/, "Jue " /*8568*/, "Dang " /*8569*/, "Wu " /*856a*/, "Tong " /*856b*/, "Si " /*856c*/, "Xiao " /*856d*/, "Xi " /*856e*/, "Long " /*856f*/, "Yun " /*8570*/, "[?] " /*8571*/, "Qi " /*8572*/, "Jian " /*8573*/, "Yun " /*8574*/, "Sun " /*8575*/, "Ling " /*8576*/, "Yu " /*8577*/, "Xia " /*8578*/, "Yong " /*8579*/, "Ji " /*857a*/, "Hong " /*857b*/, "Si " /*857c*/, "Nong " /*857d*/, "Lei " /*857e*/, "Xuan " /*857f*/, "Yun " /*8580*/, "Yu " /*8581*/, "Xi " /*8582*/, "Hao " /*8583*/, "Bo " /*8584*/, "Hao " /*8585*/, "Ai " /*8586*/, "Wei " /*8587*/, "Hui " /*8588*/, "Wei " /*8589*/, "Ji " /*858a*/, "Ci " /*858b*/, "Xiang " /*858c*/, "Luan " /*858d*/, "Mie " /*858e*/, "Yi " /*858f*/, "Leng " /*8590*/, "Jiang " /*8591*/, "Can " /*8592*/, "Shen " /*8593*/, "Qiang " /*8594*/, "Lian " /*8595*/, "Ke " /*8596*/, "Yuan " /*8597*/, "Da " /*8598*/, "Ti " /*8599*/, "Tang " /*859a*/, "Xie " /*859b*/, "Bi " /*859c*/, "Zhan " /*859d*/, "Sun " /*859e*/, "Lian " /*859f*/, "Fan " /*85a0*/, "Ding " /*85a1*/, "Jie " /*85a2*/, "Gu " /*85a3*/, "Xie " /*85a4*/, "Shu " /*85a5*/, "Jian " /*85a6*/, "Kao " /*85a7*/, "Hong " /*85a8*/, "Sa " /*85a9*/, "Xin " /*85aa*/, "Xun " /*85ab*/, "Yao " /*85ac*/, "Hie " /*85ad*/, "Sou " /*85ae*/, "Shu " /*85af*/, "Xun " /*85b0*/, "Dui " /*85b1*/, "Pin " /*85b2*/, "Wei " /*85b3*/, "Neng " /*85b4*/, "Chou " /*85b5*/, "Mai " /*85b6*/, "Ru " /*85b7*/, "Piao " /*85b8*/, "Tai " /*85b9*/, "Qi " /*85ba*/, "Zao " /*85bb*/, "Chen " /*85bc*/, "Zhen " /*85bd*/, "Er " /*85be*/, "Ni " /*85bf*/, "Ying " /*85c0*/, "Gao " /*85c1*/, "Cong " /*85c2*/, "Xiao " /*85c3*/, "Qi " /*85c4*/, "Fa " /*85c5*/, "Jian " /*85c6*/, "Xu " /*85c7*/, "Kui " /*85c8*/, "Jie " /*85c9*/, "Bian " /*85ca*/, "Diao " /*85cb*/, "Mi " /*85cc*/, "Lan " /*85cd*/, "Jin " /*85ce*/, "Cang " /*85cf*/, "Miao " /*85d0*/, "Qiong " /*85d1*/, "Qie " /*85d2*/, "Xian " /*85d3*/, "[?] " /*85d4*/, "Ou " /*85d5*/, "Xian " /*85d6*/, "Su " /*85d7*/, "Lu " /*85d8*/, "Yi " /*85d9*/, "Xu " /*85da*/, "Xie " /*85db*/, "Li " /*85dc*/, "Yi " /*85dd*/, "La " /*85de*/, "Lei " /*85df*/, "Xiao " /*85e0*/, "Di " /*85e1*/, "Zhi " /*85e2*/, "Bei " /*85e3*/, "Teng " /*85e4*/, "Yao " /*85e5*/, "Mo " /*85e6*/, "Huan " /*85e7*/, "Piao " /*85e8*/, "Fan " /*85e9*/, "Sou " /*85ea*/, "Tan " /*85eb*/, "Tui " /*85ec*/, "Qiong " /*85ed*/, "Qiao " /*85ee*/, "Wei " /*85ef*/, "Liu " /*85f0*/, "Hui " /*85f1*/, "[?] " /*85f2*/, "Gao " /*85f3*/, "Yun " /*85f4*/, "[?] " /*85f5*/, "Li " /*85f6*/, "Shu " /*85f7*/, "Chu " /*85f8*/, "Ai " /*85f9*/, "Lin " /*85fa*/, "Zao " /*85fb*/, "Xuan " /*85fc*/, "Chen " /*85fd*/, "Lai " /*85fe*/, "Huo " /*85ff*/ 
			});
						characters.TryAdd(134 /*34304 86*/, new string[] {
				"Tuo " /*8600*/, "Wu " /*8601*/, "Rui " /*8602*/, "Rui " /*8603*/, "Qi " /*8604*/, "Heng " /*8605*/, "Lu " /*8606*/, "Su " /*8607*/, "Tui " /*8608*/, "Mang " /*8609*/, "Yun " /*860a*/, "Pin " /*860b*/, "Yu " /*860c*/, "Xun " /*860d*/, "Ji " /*860e*/, "Jiong " /*860f*/, "Xian " /*8610*/, "Mo " /*8611*/, "Hagi " /*8612*/, "Su " /*8613*/, "Jiong " /*8614*/, "[?] " /*8615*/, "Nie " /*8616*/, "Bo " /*8617*/, "Rang " /*8618*/, "Yi " /*8619*/, "Xian " /*861a*/, "Yu " /*861b*/, "Ju " /*861c*/, "Lian " /*861d*/, "Lian " /*861e*/, "Yin " /*861f*/, "Qiang " /*8620*/, "Ying " /*8621*/, "Long " /*8622*/, "Tong " /*8623*/, "Wei " /*8624*/, "Yue " /*8625*/, "Ling " /*8626*/, "Qu " /*8627*/, "Yao " /*8628*/, "Fan " /*8629*/, "Mi " /*862a*/, "Lan " /*862b*/, "Kui " /*862c*/, "Lan " /*862d*/, "Ji " /*862e*/, "Dang " /*862f*/, "Katsura " /*8630*/, "Lei " /*8631*/, "Lei " /*8632*/, "Hua " /*8633*/, "Feng " /*8634*/, "Zhi " /*8635*/, "Wei " /*8636*/, "Kui " /*8637*/, "Zhan " /*8638*/, "Huai " /*8639*/, "Li " /*863a*/, "Ji " /*863b*/, "Mi " /*863c*/, "Lei " /*863d*/, "Huai " /*863e*/, "Luo " /*863f*/, "Ji " /*8640*/, "Kui " /*8641*/, "Lu " /*8642*/, "Jian " /*8643*/, "San " /*8644*/, "[?] " /*8645*/, "Lei " /*8646*/, "Quan " /*8647*/, "Xiao " /*8648*/, "Yi " /*8649*/, "Luan " /*864a*/, "Men " /*864b*/, "Bie " /*864c*/, "Hu " /*864d*/, "Hu " /*864e*/, "Lu " /*864f*/, "Nue " /*8650*/, "Lu " /*8651*/, "Si " /*8652*/, "Xiao " /*8653*/, "Qian " /*8654*/, "Chu " /*8655*/, "Hu " /*8656*/, "Xu " /*8657*/, "Cuo " /*8658*/, "Fu " /*8659*/, "Xu " /*865a*/, "Xu " /*865b*/, "Lu " /*865c*/, "Hu " /*865d*/, "Yu " /*865e*/, "Hao " /*865f*/, "Jiao " /*8660*/, "Ju " /*8661*/, "Guo " /*8662*/, "Bao " /*8663*/, "Yan " /*8664*/, "Zhan " /*8665*/, "Zhan " /*8666*/, "Kui " /*8667*/, "Ban " /*8668*/, "Xi " /*8669*/, "Shu " /*866a*/, "Chong " /*866b*/, "Qiu " /*866c*/, "Diao " /*866d*/, "Ji " /*866e*/, "Qiu " /*866f*/, "Cheng " /*8670*/, "Shi " /*8671*/, "[?] " /*8672*/, "Di " /*8673*/, "Zhe " /*8674*/, "She " /*8675*/, "Yu " /*8676*/, "Gan " /*8677*/, "Zi " /*8678*/, "Hong " /*8679*/, "Hui " /*867a*/, "Meng " /*867b*/, "Ge " /*867c*/, "Sui " /*867d*/, "Xia " /*867e*/, "Chai " /*867f*/, "Shi " /*8680*/, "Yi " /*8681*/, "Ma " /*8682*/, "Xiang " /*8683*/, "Fang " /*8684*/, "E " /*8685*/, "Pa " /*8686*/, "Chi " /*8687*/, "Qian " /*8688*/, "Wen " /*8689*/, "Wen " /*868a*/, "Rui " /*868b*/, "Bang " /*868c*/, "Bi " /*868d*/, "Yue " /*868e*/, "Yue " /*868f*/, "Jun " /*8690*/, "Qi " /*8691*/, "Ran " /*8692*/, "Yin " /*8693*/, "Qi " /*8694*/, "Tian " /*8695*/, "Yuan " /*8696*/, "Jue " /*8697*/, "Hui " /*8698*/, "Qin " /*8699*/, "Qi " /*869a*/, "Zhong " /*869b*/, "Ya " /*869c*/, "Ci " /*869d*/, "Mu " /*869e*/, "Wang " /*869f*/, "Fen " /*86a0*/, "Fen " /*86a1*/, "Hang " /*86a2*/, "Gong " /*86a3*/, "Zao " /*86a4*/, "Fu " /*86a5*/, "Ran " /*86a6*/, "Jie " /*86a7*/, "Fu " /*86a8*/, "Chi " /*86a9*/, "Dou " /*86aa*/, "Piao " /*86ab*/, "Xian " /*86ac*/, "Ni " /*86ad*/, "Te " /*86ae*/, "Qiu " /*86af*/, "You " /*86b0*/, "Zha " /*86b1*/, "Ping " /*86b2*/, "Chi " /*86b3*/, "You " /*86b4*/, "He " /*86b5*/, "Han " /*86b6*/, "Ju " /*86b7*/, "Li " /*86b8*/, "Fu " /*86b9*/, "Ran " /*86ba*/, "Zha " /*86bb*/, "Gou " /*86bc*/, "Pi " /*86bd*/, "Bo " /*86be*/, "Xian " /*86bf*/, "Zhu " /*86c0*/, "Diao " /*86c1*/, "Bie " /*86c2*/, "Bing " /*86c3*/, "Gu " /*86c4*/, "Ran " /*86c5*/, "Qu " /*86c6*/, "She " /*86c7*/, "Tie " /*86c8*/, "Ling " /*86c9*/, "Gu " /*86ca*/, "Dan " /*86cb*/, "Gu " /*86cc*/, "Ying " /*86cd*/, "Li " /*86ce*/, "Cheng " /*86cf*/, "Qu " /*86d0*/, "Mou " /*86d1*/, "Ge " /*86d2*/, "Ci " /*86d3*/, "Hui " /*86d4*/, "Hui " /*86d5*/, "Mang " /*86d6*/, "Fu " /*86d7*/, "Yang " /*86d8*/, "Wa " /*86d9*/, "Lie " /*86da*/, "Zhu " /*86db*/, "Yi " /*86dc*/, "Xian " /*86dd*/, "Kuo " /*86de*/, "Jiao " /*86df*/, "Li " /*86e0*/, "Yi " /*86e1*/, "Ping " /*86e2*/, "Ji " /*86e3*/, "Ha " /*86e4*/, "She " /*86e5*/, "Yi " /*86e6*/, "Wang " /*86e7*/, "Mo " /*86e8*/, "Qiong " /*86e9*/, "Qie " /*86ea*/, "Gui " /*86eb*/, "Gong " /*86ec*/, "Zhi " /*86ed*/, "Man " /*86ee*/, "Ebi " /*86ef*/, "Zhi " /*86f0*/, "Jia " /*86f1*/, "Rao " /*86f2*/, "Si " /*86f3*/, "Qi " /*86f4*/, "Xing " /*86f5*/, "Lie " /*86f6*/, "Qiu " /*86f7*/, "Shao " /*86f8*/, "Yong " /*86f9*/, "Jia " /*86fa*/, "Shui " /*86fb*/, "Che " /*86fc*/, "Bai " /*86fd*/, "E " /*86fe*/, "Han " /*86ff*/ 
			});
						characters.TryAdd(135 /*34560 87*/, new string[] {
				"Shu " /*8700*/, "Xuan " /*8701*/, "Feng " /*8702*/, "Shen " /*8703*/, "Zhen " /*8704*/, "Fu " /*8705*/, "Xian " /*8706*/, "Zhe " /*8707*/, "Wu " /*8708*/, "Fu " /*8709*/, "Li " /*870a*/, "Lang " /*870b*/, "Bi " /*870c*/, "Chu " /*870d*/, "Yuan " /*870e*/, "You " /*870f*/, "Jie " /*8710*/, "Dan " /*8711*/, "Yan " /*8712*/, "Ting " /*8713*/, "Dian " /*8714*/, "Shui " /*8715*/, "Hui " /*8716*/, "Gua " /*8717*/, "Zhi " /*8718*/, "Song " /*8719*/, "Fei " /*871a*/, "Ju " /*871b*/, "Mi " /*871c*/, "Qi " /*871d*/, "Qi " /*871e*/, "Yu " /*871f*/, "Jun " /*8720*/, "Zha " /*8721*/, "Meng " /*8722*/, "Qiang " /*8723*/, "Si " /*8724*/, "Xi " /*8725*/, "Lun " /*8726*/, "Li " /*8727*/, "Die " /*8728*/, "Tiao " /*8729*/, "Tao " /*872a*/, "Kun " /*872b*/, "Gan " /*872c*/, "Han " /*872d*/, "Yu " /*872e*/, "Bang " /*872f*/, "Fei " /*8730*/, "Pi " /*8731*/, "Wei " /*8732*/, "Dun " /*8733*/, "Yi " /*8734*/, "Yuan " /*8735*/, "Su " /*8736*/, "Quan " /*8737*/, "Qian " /*8738*/, "Rui " /*8739*/, "Ni " /*873a*/, "Qing " /*873b*/, "Wei " /*873c*/, "Liang " /*873d*/, "Guo " /*873e*/, "Wan " /*873f*/, "Dong " /*8740*/, "E " /*8741*/, "Ban " /*8742*/, "Di " /*8743*/, "Wang " /*8744*/, "Can " /*8745*/, "Yang " /*8746*/, "Ying " /*8747*/, "Guo " /*8748*/, "Chan " /*8749*/, "[?] " /*874a*/, "La " /*874b*/, "Ke " /*874c*/, "Ji " /*874d*/, "He " /*874e*/, "Ting " /*874f*/, "Mai " /*8750*/, "Xu " /*8751*/, "Mian " /*8752*/, "Yu " /*8753*/, "Jie " /*8754*/, "Shi " /*8755*/, "Xuan " /*8756*/, "Huang " /*8757*/, "Yan " /*8758*/, "Bian " /*8759*/, "Rou " /*875a*/, "Wei " /*875b*/, "Fu " /*875c*/, "Yuan " /*875d*/, "Mei " /*875e*/, "Wei " /*875f*/, "Fu " /*8760*/, "Ruan " /*8761*/, "Xie " /*8762*/, "You " /*8763*/, "Qiu " /*8764*/, "Mao " /*8765*/, "Xia " /*8766*/, "Ying " /*8767*/, "Shi " /*8768*/, "Chong " /*8769*/, "Tang " /*876a*/, "Zhu " /*876b*/, "Zong " /*876c*/, "Ti " /*876d*/, "Fu " /*876e*/, "Yuan " /*876f*/, "Hui " /*8770*/, "Meng " /*8771*/, "La " /*8772*/, "Du " /*8773*/, "Hu " /*8774*/, "Qiu " /*8775*/, "Die " /*8776*/, "Li " /*8777*/, "Gua " /*8778*/, "Yun " /*8779*/, "Ju " /*877a*/, "Nan " /*877b*/, "Lou " /*877c*/, "Qun " /*877d*/, "Rong " /*877e*/, "Ying " /*877f*/, "Jiang " /*8780*/, "[?] " /*8781*/, "Lang " /*8782*/, "Pang " /*8783*/, "Si " /*8784*/, "Xi " /*8785*/, "Ci " /*8786*/, "Xi " /*8787*/, "Yuan " /*8788*/, "Weng " /*8789*/, "Lian " /*878a*/, "Sou " /*878b*/, "Ban " /*878c*/, "Rong " /*878d*/, "Rong " /*878e*/, "Ji " /*878f*/, "Wu " /*8790*/, "Qiu " /*8791*/, "Han " /*8792*/, "Qin " /*8793*/, "Yi " /*8794*/, "Bi " /*8795*/, "Hua " /*8796*/, "Tang " /*8797*/, "Yi " /*8798*/, "Du " /*8799*/, "Nai " /*879a*/, "He " /*879b*/, "Hu " /*879c*/, "Hui " /*879d*/, "Ma " /*879e*/, "Ming " /*879f*/, "Yi " /*87a0*/, "Wen " /*87a1*/, "Ying " /*87a2*/, "Teng " /*87a3*/, "Yu " /*87a4*/, "Cang " /*87a5*/, "So " /*87a6*/, "Ebi " /*87a7*/, "Man " /*87a8*/, "[?] " /*87a9*/, "Shang " /*87aa*/, "Zhe " /*87ab*/, "Cao " /*87ac*/, "Chi " /*87ad*/, "Di " /*87ae*/, "Ao " /*87af*/, "Lu " /*87b0*/, "Wei " /*87b1*/, "Zhi " /*87b2*/, "Tang " /*87b3*/, "Chen " /*87b4*/, "Piao " /*87b5*/, "Qu " /*87b6*/, "Pi " /*87b7*/, "Yu " /*87b8*/, "Jian " /*87b9*/, "Luo " /*87ba*/, "Lou " /*87bb*/, "Qin " /*87bc*/, "Zhong " /*87bd*/, "Yin " /*87be*/, "Jiang " /*87bf*/, "Shuai " /*87c0*/, "Wen " /*87c1*/, "Jiao " /*87c2*/, "Wan " /*87c3*/, "Zhi " /*87c4*/, "Zhe " /*87c5*/, "Ma " /*87c6*/, "Ma " /*87c7*/, "Guo " /*87c8*/, "Liu " /*87c9*/, "Mao " /*87ca*/, "Xi " /*87cb*/, "Cong " /*87cc*/, "Li " /*87cd*/, "Man " /*87ce*/, "Xiao " /*87cf*/, "Kamakiri " /*87d0*/, "Zhang " /*87d1*/, "Mang " /*87d2*/, "Xiang " /*87d3*/, "Mo " /*87d4*/, "Zui " /*87d5*/, "Si " /*87d6*/, "Qiu " /*87d7*/, "Te " /*87d8*/, "Zhi " /*87d9*/, "Peng " /*87da*/, "Peng " /*87db*/, "Jiao " /*87dc*/, "Qu " /*87dd*/, "Bie " /*87de*/, "Liao " /*87df*/, "Pan " /*87e0*/, "Gui " /*87e1*/, "Xi " /*87e2*/, "Ji " /*87e3*/, "Zhuan " /*87e4*/, "Huang " /*87e5*/, "Fei " /*87e6*/, "Lao " /*87e7*/, "Jue " /*87e8*/, "Jue " /*87e9*/, "Hui " /*87ea*/, "Yin " /*87eb*/, "Chan " /*87ec*/, "Jiao " /*87ed*/, "Shan " /*87ee*/, "Rao " /*87ef*/, "Xiao " /*87f0*/, "Mou " /*87f1*/, "Chong " /*87f2*/, "Xun " /*87f3*/, "Si " /*87f4*/, "[?] " /*87f5*/, "Cheng " /*87f6*/, "Dang " /*87f7*/, "Li " /*87f8*/, "Xie " /*87f9*/, "Shan " /*87fa*/, "Yi " /*87fb*/, "Jing " /*87fc*/, "Da " /*87fd*/, "Chan " /*87fe*/, "Qi " /*87ff*/ 
			});
						characters.TryAdd(136 /*34816 88*/, new string[] {
				"Ci " /*8800*/, "Xiang " /*8801*/, "She " /*8802*/, "Luo " /*8803*/, "Qin " /*8804*/, "Ying " /*8805*/, "Chai " /*8806*/, "Li " /*8807*/, "Ze " /*8808*/, "Xuan " /*8809*/, "Lian " /*880a*/, "Zhu " /*880b*/, "Ze " /*880c*/, "Xie " /*880d*/, "Mang " /*880e*/, "Xie " /*880f*/, "Qi " /*8810*/, "Rong " /*8811*/, "Jian " /*8812*/, "Meng " /*8813*/, "Hao " /*8814*/, "Ruan " /*8815*/, "Huo " /*8816*/, "Zhuo " /*8817*/, "Jie " /*8818*/, "Bin " /*8819*/, "He " /*881a*/, "Mie " /*881b*/, "Fan " /*881c*/, "Lei " /*881d*/, "Jie " /*881e*/, "La " /*881f*/, "Mi " /*8820*/, "Li " /*8821*/, "Chun " /*8822*/, "Li " /*8823*/, "Qiu " /*8824*/, "Nie " /*8825*/, "Lu " /*8826*/, "Du " /*8827*/, "Xiao " /*8828*/, "Zhu " /*8829*/, "Long " /*882a*/, "Li " /*882b*/, "Long " /*882c*/, "Feng " /*882d*/, "Ye " /*882e*/, "Beng " /*882f*/, "Shang " /*8830*/, "Gu " /*8831*/, "Juan " /*8832*/, "Ying " /*8833*/, "[?] " /*8834*/, "Xi " /*8835*/, "Can " /*8836*/, "Qu " /*8837*/, "Quan " /*8838*/, "Du " /*8839*/, "Can " /*883a*/, "Man " /*883b*/, "Jue " /*883c*/, "Jie " /*883d*/, "Zhu " /*883e*/, "Zha " /*883f*/, "Xie " /*8840*/, "Huang " /*8841*/, "Niu " /*8842*/, "Pei " /*8843*/, "Nu " /*8844*/, "Xin " /*8845*/, "Zhong " /*8846*/, "Mo " /*8847*/, "Er " /*8848*/, "Ke " /*8849*/, "Mie " /*884a*/, "Xi " /*884b*/, "Xing " /*884c*/, "Yan " /*884d*/, "Kan " /*884e*/, "Yuan " /*884f*/, "[?] " /*8850*/, "Ling " /*8851*/, "Xuan " /*8852*/, "Shu " /*8853*/, "Xian " /*8854*/, "Tong " /*8855*/, "Long " /*8856*/, "Jie " /*8857*/, "Xian " /*8858*/, "Ya " /*8859*/, "Hu " /*885a*/, "Wei " /*885b*/, "Dao " /*885c*/, "Chong " /*885d*/, "Wei " /*885e*/, "Dao " /*885f*/, "Zhun " /*8860*/, "Heng " /*8861*/, "Qu " /*8862*/, "Yi " /*8863*/, "Yi " /*8864*/, "Bu " /*8865*/, "Gan " /*8866*/, "Yu " /*8867*/, "Biao " /*8868*/, "Cha " /*8869*/, "Yi " /*886a*/, "Shan " /*886b*/, "Chen " /*886c*/, "Fu " /*886d*/, "Gun " /*886e*/, "Fen " /*886f*/, "Shuai " /*8870*/, "Jie " /*8871*/, "Na " /*8872*/, "Zhong " /*8873*/, "Dan " /*8874*/, "Ri " /*8875*/, "Zhong " /*8876*/, "Zhong " /*8877*/, "Xie " /*8878*/, "Qi " /*8879*/, "Xie " /*887a*/, "Ran " /*887b*/, "Zhi " /*887c*/, "Ren " /*887d*/, "Qin " /*887e*/, "Jin " /*887f*/, "Jun " /*8880*/, "Yuan " /*8881*/, "Mei " /*8882*/, "Chai " /*8883*/, "Ao " /*8884*/, "Niao " /*8885*/, "Hui " /*8886*/, "Ran " /*8887*/, "Jia " /*8888*/, "Tuo " /*8889*/, "Ling " /*888a*/, "Dai " /*888b*/, "Bao " /*888c*/, "Pao " /*888d*/, "Yao " /*888e*/, "Zuo " /*888f*/, "Bi " /*8890*/, "Shao " /*8891*/, "Tan " /*8892*/, "Ju " /*8893*/, "He " /*8894*/, "Shu " /*8895*/, "Xiu " /*8896*/, "Zhen " /*8897*/, "Yi " /*8898*/, "Pa " /*8899*/, "Bo " /*889a*/, "Di " /*889b*/, "Wa " /*889c*/, "Fu " /*889d*/, "Gun " /*889e*/, "Zhi " /*889f*/, "Zhi " /*88a0*/, "Ran " /*88a1*/, "Pan " /*88a2*/, "Yi " /*88a3*/, "Mao " /*88a4*/, "Tuo " /*88a5*/, "Na " /*88a6*/, "Kou " /*88a7*/, "Xian " /*88a8*/, "Chan " /*88a9*/, "Qu " /*88aa*/, "Bei " /*88ab*/, "Gun " /*88ac*/, "Xi " /*88ad*/, "Ne " /*88ae*/, "Bo " /*88af*/, "Horo " /*88b0*/, "Fu " /*88b1*/, "Yi " /*88b2*/, "Chi " /*88b3*/, "Ku " /*88b4*/, "Ren " /*88b5*/, "Jiang " /*88b6*/, "Jia " /*88b7*/, "Cun " /*88b8*/, "Mo " /*88b9*/, "Jie " /*88ba*/, "Er " /*88bb*/, "Luo " /*88bc*/, "Ru " /*88bd*/, "Zhu " /*88be*/, "Gui " /*88bf*/, "Yin " /*88c0*/, "Cai " /*88c1*/, "Lie " /*88c2*/, "Kamishimo " /*88c3*/, "Yuki " /*88c4*/, "Zhuang " /*88c5*/, "Dang " /*88c6*/, "[?] " /*88c7*/, "Kun " /*88c8*/, "Ken " /*88c9*/, "Niao " /*88ca*/, "Shu " /*88cb*/, "Jia " /*88cc*/, "Kun " /*88cd*/, "Cheng " /*88ce*/, "Li " /*88cf*/, "Juan " /*88d0*/, "Shen " /*88d1*/, "Pou " /*88d2*/, "Ge " /*88d3*/, "Yi " /*88d4*/, "Yu " /*88d5*/, "Zhen " /*88d6*/, "Liu " /*88d7*/, "Qiu " /*88d8*/, "Qun " /*88d9*/, "Ji " /*88da*/, "Yi " /*88db*/, "Bu " /*88dc*/, "Zhuang " /*88dd*/, "Shui " /*88de*/, "Sha " /*88df*/, "Qun " /*88e0*/, "Li " /*88e1*/, "Lian " /*88e2*/, "Lian " /*88e3*/, "Ku " /*88e4*/, "Jian " /*88e5*/, "Fou " /*88e6*/, "Chan " /*88e7*/, "Bi " /*88e8*/, "Gun " /*88e9*/, "Tao " /*88ea*/, "Yuan " /*88eb*/, "Ling " /*88ec*/, "Chi " /*88ed*/, "Chang " /*88ee*/, "Chou " /*88ef*/, "Duo " /*88f0*/, "Biao " /*88f1*/, "Liang " /*88f2*/, "Chang " /*88f3*/, "Pei " /*88f4*/, "Pei " /*88f5*/, "Fei " /*88f6*/, "Yuan " /*88f7*/, "Luo " /*88f8*/, "Guo " /*88f9*/, "Yan " /*88fa*/, "Du " /*88fb*/, "Xi " /*88fc*/, "Zhi " /*88fd*/, "Ju " /*88fe*/, "Qi " /*88ff*/ 
			});
						characters.TryAdd(137 /*35072 89*/, new string[] {
				"Ji " /*8900*/, "Zhi " /*8901*/, "Gua " /*8902*/, "Ken " /*8903*/, "Che " /*8904*/, "Ti " /*8905*/, "Ti " /*8906*/, "Fu " /*8907*/, "Chong " /*8908*/, "Xie " /*8909*/, "Bian " /*890a*/, "Die " /*890b*/, "Kun " /*890c*/, "Duan " /*890d*/, "Xiu " /*890e*/, "Xiu " /*890f*/, "He " /*8910*/, "Yuan " /*8911*/, "Bao " /*8912*/, "Bao " /*8913*/, "Fu " /*8914*/, "Yu " /*8915*/, "Tuan " /*8916*/, "Yan " /*8917*/, "Hui " /*8918*/, "Bei " /*8919*/, "Chu " /*891a*/, "Lu " /*891b*/, "Ena " /*891c*/, "Hitoe " /*891d*/, "Yun " /*891e*/, "Da " /*891f*/, "Gou " /*8920*/, "Da " /*8921*/, "Huai " /*8922*/, "Rong " /*8923*/, "Yuan " /*8924*/, "Ru " /*8925*/, "Nai " /*8926*/, "Jiong " /*8927*/, "Suo " /*8928*/, "Ban " /*8929*/, "Tun " /*892a*/, "Chi " /*892b*/, "Sang " /*892c*/, "Niao " /*892d*/, "Ying " /*892e*/, "Jie " /*892f*/, "Qian " /*8930*/, "Huai " /*8931*/, "Ku " /*8932*/, "Lian " /*8933*/, "Bao " /*8934*/, "Li " /*8935*/, "Zhe " /*8936*/, "Shi " /*8937*/, "Lu " /*8938*/, "Yi " /*8939*/, "Die " /*893a*/, "Xie " /*893b*/, "Xian " /*893c*/, "Wei " /*893d*/, "Biao " /*893e*/, "Cao " /*893f*/, "Ji " /*8940*/, "Jiang " /*8941*/, "Sen " /*8942*/, "Bao " /*8943*/, "Xiang " /*8944*/, "Chihaya " /*8945*/, "Pu " /*8946*/, "Jian " /*8947*/, "Zhuan " /*8948*/, "Jian " /*8949*/, "Zui " /*894a*/, "Ji " /*894b*/, "Dan " /*894c*/, "Za " /*894d*/, "Fan " /*894e*/, "Bo " /*894f*/, "Xiang " /*8950*/, "Xin " /*8951*/, "Bie " /*8952*/, "Rao " /*8953*/, "Man " /*8954*/, "Lan " /*8955*/, "Ao " /*8956*/, "Duo " /*8957*/, "Gui " /*8958*/, "Cao " /*8959*/, "Sui " /*895a*/, "Nong " /*895b*/, "Chan " /*895c*/, "Lian " /*895d*/, "Bi " /*895e*/, "Jin " /*895f*/, "Dang " /*8960*/, "Shu " /*8961*/, "Tan " /*8962*/, "Bi " /*8963*/, "Lan " /*8964*/, "Pu " /*8965*/, "Ru " /*8966*/, "Zhi " /*8967*/, "[?] " /*8968*/, "Shu " /*8969*/, "Wa " /*896a*/, "Shi " /*896b*/, "Bai " /*896c*/, "Xie " /*896d*/, "Bo " /*896e*/, "Chen " /*896f*/, "Lai " /*8970*/, "Long " /*8971*/, "Xi " /*8972*/, "Xian " /*8973*/, "Lan " /*8974*/, "Zhe " /*8975*/, "Dai " /*8976*/, "Tasuki " /*8977*/, "Zan " /*8978*/, "Shi " /*8979*/, "Jian " /*897a*/, "Pan " /*897b*/, "Yi " /*897c*/, "Ran " /*897d*/, "Ya " /*897e*/, "Xi " /*897f*/, "Xi " /*8980*/, "Yao " /*8981*/, "Feng " /*8982*/, "Tan " /*8983*/, "[?] " /*8984*/, "Biao " /*8985*/, "Fu " /*8986*/, "Ba " /*8987*/, "He " /*8988*/, "Ji " /*8989*/, "Ji " /*898a*/, "Jian " /*898b*/, "Guan " /*898c*/, "Bian " /*898d*/, "Yan " /*898e*/, "Gui " /*898f*/, "Jue " /*8990*/, "Pian " /*8991*/, "Mao " /*8992*/, "Mi " /*8993*/, "Mi " /*8994*/, "Mie " /*8995*/, "Shi " /*8996*/, "Si " /*8997*/, "Zhan " /*8998*/, "Luo " /*8999*/, "Jue " /*899a*/, "Mi " /*899b*/, "Tiao " /*899c*/, "Lian " /*899d*/, "Yao " /*899e*/, "Zhi " /*899f*/, "Jun " /*89a0*/, "Xi " /*89a1*/, "Shan " /*89a2*/, "Wei " /*89a3*/, "Xi " /*89a4*/, "Tian " /*89a5*/, "Yu " /*89a6*/, "Lan " /*89a7*/, "E " /*89a8*/, "Du " /*89a9*/, "Qin " /*89aa*/, "Pang " /*89ab*/, "Ji " /*89ac*/, "Ming " /*89ad*/, "Ying " /*89ae*/, "Gou " /*89af*/, "Qu " /*89b0*/, "Zhan " /*89b1*/, "Jin " /*89b2*/, "Guan " /*89b3*/, "Deng " /*89b4*/, "Jian " /*89b5*/, "Luo " /*89b6*/, "Qu " /*89b7*/, "Jian " /*89b8*/, "Wei " /*89b9*/, "Jue " /*89ba*/, "Qu " /*89bb*/, "Luo " /*89bc*/, "Lan " /*89bd*/, "Shen " /*89be*/, "Di " /*89bf*/, "Guan " /*89c0*/, "Jian " /*89c1*/, "Guan " /*89c2*/, "Yan " /*89c3*/, "Gui " /*89c4*/, "Mi " /*89c5*/, "Shi " /*89c6*/, "Zhan " /*89c7*/, "Lan " /*89c8*/, "Jue " /*89c9*/, "Ji " /*89ca*/, "Xi " /*89cb*/, "Di " /*89cc*/, "Tian " /*89cd*/, "Yu " /*89ce*/, "Gou " /*89cf*/, "Jin " /*89d0*/, "Qu " /*89d1*/, "Jiao " /*89d2*/, "Jiu " /*89d3*/, "Jin " /*89d4*/, "Cu " /*89d5*/, "Jue " /*89d6*/, "Zhi " /*89d7*/, "Chao " /*89d8*/, "Ji " /*89d9*/, "Gu " /*89da*/, "Dan " /*89db*/, "Zui " /*89dc*/, "Di " /*89dd*/, "Shang " /*89de*/, "Hua " /*89df*/, "Quan " /*89e0*/, "Ge " /*89e1*/, "Chi " /*89e2*/, "Jie " /*89e3*/, "Gui " /*89e4*/, "Gong " /*89e5*/, "Hong " /*89e6*/, "Jie " /*89e7*/, "Hun " /*89e8*/, "Qiu " /*89e9*/, "Xing " /*89ea*/, "Su " /*89eb*/, "Ni " /*89ec*/, "Ji " /*89ed*/, "Lu " /*89ee*/, "Zhi " /*89ef*/, "Zha " /*89f0*/, "Bi " /*89f1*/, "Xing " /*89f2*/, "Hu " /*89f3*/, "Shang " /*89f4*/, "Gong " /*89f5*/, "Zhi " /*89f6*/, "Xue " /*89f7*/, "Chu " /*89f8*/, "Xi " /*89f9*/, "Yi " /*89fa*/, "Lu " /*89fb*/, "Jue " /*89fc*/, "Xi " /*89fd*/, "Yan " /*89fe*/, "Xi " /*89ff*/ 
			});
						characters.TryAdd(138 /*35328 8a*/, new string[] {
				"Yan " /*8a00*/, "Yan " /*8a01*/, "Ding " /*8a02*/, "Fu " /*8a03*/, "Qiu " /*8a04*/, "Qiu " /*8a05*/, "Jiao " /*8a06*/, "Hong " /*8a07*/, "Ji " /*8a08*/, "Fan " /*8a09*/, "Xun " /*8a0a*/, "Diao " /*8a0b*/, "Hong " /*8a0c*/, "Cha " /*8a0d*/, "Tao " /*8a0e*/, "Xu " /*8a0f*/, "Jie " /*8a10*/, "Yi " /*8a11*/, "Ren " /*8a12*/, "Xun " /*8a13*/, "Yin " /*8a14*/, "Shan " /*8a15*/, "Qi " /*8a16*/, "Tuo " /*8a17*/, "Ji " /*8a18*/, "Xun " /*8a19*/, "Yin " /*8a1a*/, "E " /*8a1b*/, "Fen " /*8a1c*/, "Ya " /*8a1d*/, "Yao " /*8a1e*/, "Song " /*8a1f*/, "Shen " /*8a20*/, "Yin " /*8a21*/, "Xin " /*8a22*/, "Jue " /*8a23*/, "Xiao " /*8a24*/, "Ne " /*8a25*/, "Chen " /*8a26*/, "You " /*8a27*/, "Zhi " /*8a28*/, "Xiong " /*8a29*/, "Fang " /*8a2a*/, "Xin " /*8a2b*/, "Chao " /*8a2c*/, "She " /*8a2d*/, "Xian " /*8a2e*/, "Sha " /*8a2f*/, "Tun " /*8a30*/, "Xu " /*8a31*/, "Yi " /*8a32*/, "Yi " /*8a33*/, "Su " /*8a34*/, "Chi " /*8a35*/, "He " /*8a36*/, "Shen " /*8a37*/, "He " /*8a38*/, "Xu " /*8a39*/, "Zhen " /*8a3a*/, "Zhu " /*8a3b*/, "Zheng " /*8a3c*/, "Gou " /*8a3d*/, "Zi " /*8a3e*/, "Zi " /*8a3f*/, "Zhan " /*8a40*/, "Gu " /*8a41*/, "Fu " /*8a42*/, "Quan " /*8a43*/, "Die " /*8a44*/, "Ling " /*8a45*/, "Di " /*8a46*/, "Yang " /*8a47*/, "Li " /*8a48*/, "Nao " /*8a49*/, "Pan " /*8a4a*/, "Zhou " /*8a4b*/, "Gan " /*8a4c*/, "Yi " /*8a4d*/, "Ju " /*8a4e*/, "Ao " /*8a4f*/, "Zha " /*8a50*/, "Tuo " /*8a51*/, "Yi " /*8a52*/, "Qu " /*8a53*/, "Zhao " /*8a54*/, "Ping " /*8a55*/, "Bi " /*8a56*/, "Xiong " /*8a57*/, "Qu " /*8a58*/, "Ba " /*8a59*/, "Da " /*8a5a*/, "Zu " /*8a5b*/, "Tao " /*8a5c*/, "Zhu " /*8a5d*/, "Ci " /*8a5e*/, "Zhe " /*8a5f*/, "Yong " /*8a60*/, "Xu " /*8a61*/, "Xun " /*8a62*/, "Yi " /*8a63*/, "Huang " /*8a64*/, "He " /*8a65*/, "Shi " /*8a66*/, "Cha " /*8a67*/, "Jiao " /*8a68*/, "Shi " /*8a69*/, "Hen " /*8a6a*/, "Cha " /*8a6b*/, "Gou " /*8a6c*/, "Gui " /*8a6d*/, "Quan " /*8a6e*/, "Hui " /*8a6f*/, "Jie " /*8a70*/, "Hua " /*8a71*/, "Gai " /*8a72*/, "Xiang " /*8a73*/, "Wei " /*8a74*/, "Shen " /*8a75*/, "Chou " /*8a76*/, "Tong " /*8a77*/, "Mi " /*8a78*/, "Zhan " /*8a79*/, "Ming " /*8a7a*/, "E " /*8a7b*/, "Hui " /*8a7c*/, "Yan " /*8a7d*/, "Xiong " /*8a7e*/, "Gua " /*8a7f*/, "Er " /*8a80*/, "Beng " /*8a81*/, "Tiao " /*8a82*/, "Chi " /*8a83*/, "Lei " /*8a84*/, "Zhu " /*8a85*/, "Kuang " /*8a86*/, "Kua " /*8a87*/, "Wu " /*8a88*/, "Yu " /*8a89*/, "Teng " /*8a8a*/, "Ji " /*8a8b*/, "Zhi " /*8a8c*/, "Ren " /*8a8d*/, "Su " /*8a8e*/, "Lang " /*8a8f*/, "E " /*8a90*/, "Kuang " /*8a91*/, "E " /*8a92*/, "Shi " /*8a93*/, "Ting " /*8a94*/, "Dan " /*8a95*/, "Bo " /*8a96*/, "Chan " /*8a97*/, "You " /*8a98*/, "Heng " /*8a99*/, "Qiao " /*8a9a*/, "Qin " /*8a9b*/, "Shua " /*8a9c*/, "An " /*8a9d*/, "Yu " /*8a9e*/, "Xiao " /*8a9f*/, "Cheng " /*8aa0*/, "Jie " /*8aa1*/, "Xian " /*8aa2*/, "Wu " /*8aa3*/, "Wu " /*8aa4*/, "Gao " /*8aa5*/, "Song " /*8aa6*/, "Pu " /*8aa7*/, "Hui " /*8aa8*/, "Jing " /*8aa9*/, "Shuo " /*8aaa*/, "Zhen " /*8aab*/, "Shuo " /*8aac*/, "Du " /*8aad*/, "Yasashi " /*8aae*/, "Chang " /*8aaf*/, "Shui " /*8ab0*/, "Jie " /*8ab1*/, "Ke " /*8ab2*/, "Qu " /*8ab3*/, "Cong " /*8ab4*/, "Xiao " /*8ab5*/, "Sui " /*8ab6*/, "Wang " /*8ab7*/, "Xuan " /*8ab8*/, "Fei " /*8ab9*/, "Chi " /*8aba*/, "Ta " /*8abb*/, "Yi " /*8abc*/, "Na " /*8abd*/, "Yin " /*8abe*/, "Diao " /*8abf*/, "Pi " /*8ac0*/, "Chuo " /*8ac1*/, "Chan " /*8ac2*/, "Chen " /*8ac3*/, "Zhun " /*8ac4*/, "Ji " /*8ac5*/, "Qi " /*8ac6*/, "Tan " /*8ac7*/, "Zhui " /*8ac8*/, "Wei " /*8ac9*/, "Ju " /*8aca*/, "Qing " /*8acb*/, "Jian " /*8acc*/, "Zheng " /*8acd*/, "Ze " /*8ace*/, "Zou " /*8acf*/, "Qian " /*8ad0*/, "Zhuo " /*8ad1*/, "Liang " /*8ad2*/, "Jian " /*8ad3*/, "Zhu " /*8ad4*/, "Hao " /*8ad5*/, "Lun " /*8ad6*/, "Shen " /*8ad7*/, "Biao " /*8ad8*/, "Huai " /*8ad9*/, "Pian " /*8ada*/, "Yu " /*8adb*/, "Die " /*8adc*/, "Xu " /*8add*/, "Pian " /*8ade*/, "Shi " /*8adf*/, "Xuan " /*8ae0*/, "Shi " /*8ae1*/, "Hun " /*8ae2*/, "Hua " /*8ae3*/, "E " /*8ae4*/, "Zhong " /*8ae5*/, "Di " /*8ae6*/, "Xie " /*8ae7*/, "Fu " /*8ae8*/, "Pu " /*8ae9*/, "Ting " /*8aea*/, "Jian " /*8aeb*/, "Qi " /*8aec*/, "Yu " /*8aed*/, "Zi " /*8aee*/, "Chuan " /*8aef*/, "Xi " /*8af0*/, "Hui " /*8af1*/, "Yin " /*8af2*/, "An " /*8af3*/, "Xian " /*8af4*/, "Nan " /*8af5*/, "Chen " /*8af6*/, "Feng " /*8af7*/, "Zhu " /*8af8*/, "Yang " /*8af9*/, "Yan " /*8afa*/, "Heng " /*8afb*/, "Xuan " /*8afc*/, "Ge " /*8afd*/, "Nuo " /*8afe*/, "Qi " /*8aff*/ 
			});
						characters.TryAdd(139 /*35584 8b*/, new string[] {
				"Mou " /*8b00*/, "Ye " /*8b01*/, "Wei " /*8b02*/, "[?] " /*8b03*/, "Teng " /*8b04*/, "Zou " /*8b05*/, "Shan " /*8b06*/, "Jian " /*8b07*/, "Bo " /*8b08*/, "Ku " /*8b09*/, "Huang " /*8b0a*/, "Huo " /*8b0b*/, "Ge " /*8b0c*/, "Ying " /*8b0d*/, "Mi " /*8b0e*/, "Xiao " /*8b0f*/, "Mi " /*8b10*/, "Xi " /*8b11*/, "Qiang " /*8b12*/, "Chen " /*8b13*/, "Nue " /*8b14*/, "Ti " /*8b15*/, "Su " /*8b16*/, "Bang " /*8b17*/, "Chi " /*8b18*/, "Qian " /*8b19*/, "Shi " /*8b1a*/, "Jiang " /*8b1b*/, "Yuan " /*8b1c*/, "Xie " /*8b1d*/, "Xue " /*8b1e*/, "Tao " /*8b1f*/, "Yao " /*8b20*/, "Yao " /*8b21*/, "[?] " /*8b22*/, "Yu " /*8b23*/, "Biao " /*8b24*/, "Cong " /*8b25*/, "Qing " /*8b26*/, "Li " /*8b27*/, "Mo " /*8b28*/, "Mo " /*8b29*/, "Shang " /*8b2a*/, "Zhe " /*8b2b*/, "Miu " /*8b2c*/, "Jian " /*8b2d*/, "Ze " /*8b2e*/, "Jie " /*8b2f*/, "Lian " /*8b30*/, "Lou " /*8b31*/, "Can " /*8b32*/, "Ou " /*8b33*/, "Guan " /*8b34*/, "Xi " /*8b35*/, "Zhuo " /*8b36*/, "Ao " /*8b37*/, "Ao " /*8b38*/, "Jin " /*8b39*/, "Zhe " /*8b3a*/, "Yi " /*8b3b*/, "Hu " /*8b3c*/, "Jiang " /*8b3d*/, "Man " /*8b3e*/, "Chao " /*8b3f*/, "Han " /*8b40*/, "Hua " /*8b41*/, "Chan " /*8b42*/, "Xu " /*8b43*/, "Zeng " /*8b44*/, "Se " /*8b45*/, "Xi " /*8b46*/, "She " /*8b47*/, "Dui " /*8b48*/, "Zheng " /*8b49*/, "Nao " /*8b4a*/, "Lan " /*8b4b*/, "E " /*8b4c*/, "Ying " /*8b4d*/, "Jue " /*8b4e*/, "Ji " /*8b4f*/, "Zun " /*8b50*/, "Jiao " /*8b51*/, "Bo " /*8b52*/, "Hui " /*8b53*/, "Zhuan " /*8b54*/, "Mu " /*8b55*/, "Zen " /*8b56*/, "Zha " /*8b57*/, "Shi " /*8b58*/, "Qiao " /*8b59*/, "Tan " /*8b5a*/, "Zen " /*8b5b*/, "Pu " /*8b5c*/, "Sheng " /*8b5d*/, "Xuan " /*8b5e*/, "Zao " /*8b5f*/, "Tan " /*8b60*/, "Dang " /*8b61*/, "Sui " /*8b62*/, "Qian " /*8b63*/, "Ji " /*8b64*/, "Jiao " /*8b65*/, "Jing " /*8b66*/, "Lian " /*8b67*/, "Nou " /*8b68*/, "Yi " /*8b69*/, "Ai " /*8b6a*/, "Zhan " /*8b6b*/, "Pi " /*8b6c*/, "Hui " /*8b6d*/, "Hua " /*8b6e*/, "Yi " /*8b6f*/, "Yi " /*8b70*/, "Shan " /*8b71*/, "Rang " /*8b72*/, "Nou " /*8b73*/, "Qian " /*8b74*/, "Zhui " /*8b75*/, "Ta " /*8b76*/, "Hu " /*8b77*/, "Zhou " /*8b78*/, "Hao " /*8b79*/, "Ye " /*8b7a*/, "Ying " /*8b7b*/, "Jian " /*8b7c*/, "Yu " /*8b7d*/, "Jian " /*8b7e*/, "Hui " /*8b7f*/, "Du " /*8b80*/, "Zhe " /*8b81*/, "Xuan " /*8b82*/, "Zan " /*8b83*/, "Lei " /*8b84*/, "Shen " /*8b85*/, "Wei " /*8b86*/, "Chan " /*8b87*/, "Li " /*8b88*/, "Yi " /*8b89*/, "Bian " /*8b8a*/, "Zhe " /*8b8b*/, "Yan " /*8b8c*/, "E " /*8b8d*/, "Chou " /*8b8e*/, "Wei " /*8b8f*/, "Chou " /*8b90*/, "Yao " /*8b91*/, "Chan " /*8b92*/, "Rang " /*8b93*/, "Yin " /*8b94*/, "Lan " /*8b95*/, "Chen " /*8b96*/, "Huo " /*8b97*/, "Zhe " /*8b98*/, "Huan " /*8b99*/, "Zan " /*8b9a*/, "Yi " /*8b9b*/, "Dang " /*8b9c*/, "Zhan " /*8b9d*/, "Yan " /*8b9e*/, "Du " /*8b9f*/, "Yan " /*8ba0*/, "Ji " /*8ba1*/, "Ding " /*8ba2*/, "Fu " /*8ba3*/, "Ren " /*8ba4*/, "Ji " /*8ba5*/, "Jie " /*8ba6*/, "Hong " /*8ba7*/, "Tao " /*8ba8*/, "Rang " /*8ba9*/, "Shan " /*8baa*/, "Qi " /*8bab*/, "Tuo " /*8bac*/, "Xun " /*8bad*/, "Yi " /*8bae*/, "Xun " /*8baf*/, "Ji " /*8bb0*/, "Ren " /*8bb1*/, "Jiang " /*8bb2*/, "Hui " /*8bb3*/, "Ou " /*8bb4*/, "Ju " /*8bb5*/, "Ya " /*8bb6*/, "Ne " /*8bb7*/, "Xu " /*8bb8*/, "E " /*8bb9*/, "Lun " /*8bba*/, "Xiong " /*8bbb*/, "Song " /*8bbc*/, "Feng " /*8bbd*/, "She " /*8bbe*/, "Fang " /*8bbf*/, "Jue " /*8bc0*/, "Zheng " /*8bc1*/, "Gu " /*8bc2*/, "He " /*8bc3*/, "Ping " /*8bc4*/, "Zu " /*8bc5*/, "Shi " /*8bc6*/, "Xiong " /*8bc7*/, "Zha " /*8bc8*/, "Su " /*8bc9*/, "Zhen " /*8bca*/, "Di " /*8bcb*/, "Zou " /*8bcc*/, "Ci " /*8bcd*/, "Qu " /*8bce*/, "Zhao " /*8bcf*/, "Bi " /*8bd0*/, "Yi " /*8bd1*/, "Yi " /*8bd2*/, "Kuang " /*8bd3*/, "Lei " /*8bd4*/, "Shi " /*8bd5*/, "Gua " /*8bd6*/, "Shi " /*8bd7*/, "Jie " /*8bd8*/, "Hui " /*8bd9*/, "Cheng " /*8bda*/, "Zhu " /*8bdb*/, "Shen " /*8bdc*/, "Hua " /*8bdd*/, "Dan " /*8bde*/, "Gou " /*8bdf*/, "Quan " /*8be0*/, "Gui " /*8be1*/, "Xun " /*8be2*/, "Yi " /*8be3*/, "Zheng " /*8be4*/, "Gai " /*8be5*/, "Xiang " /*8be6*/, "Cha " /*8be7*/, "Hun " /*8be8*/, "Xu " /*8be9*/, "Zhou " /*8bea*/, "Jie " /*8beb*/, "Wu " /*8bec*/, "Yu " /*8bed*/, "Qiao " /*8bee*/, "Wu " /*8bef*/, "Gao " /*8bf0*/, "You " /*8bf1*/, "Hui " /*8bf2*/, "Kuang " /*8bf3*/, "Shuo " /*8bf4*/, "Song " /*8bf5*/, "Ai " /*8bf6*/, "Qing " /*8bf7*/, "Zhu " /*8bf8*/, "Zou " /*8bf9*/, "Nuo " /*8bfa*/, "Du " /*8bfb*/, "Zhuo " /*8bfc*/, "Fei " /*8bfd*/, "Ke " /*8bfe*/, "Wei " /*8bff*/ 
			});
						characters.TryAdd(140 /*35840 8c*/, new string[] {
				"Yu " /*8c00*/, "Shui " /*8c01*/, "Shen " /*8c02*/, "Diao " /*8c03*/, "Chan " /*8c04*/, "Liang " /*8c05*/, "Zhun " /*8c06*/, "Sui " /*8c07*/, "Tan " /*8c08*/, "Shen " /*8c09*/, "Yi " /*8c0a*/, "Mou " /*8c0b*/, "Chen " /*8c0c*/, "Die " /*8c0d*/, "Huang " /*8c0e*/, "Jian " /*8c0f*/, "Xie " /*8c10*/, "Nue " /*8c11*/, "Ye " /*8c12*/, "Wei " /*8c13*/, "E " /*8c14*/, "Yu " /*8c15*/, "Xuan " /*8c16*/, "Chan " /*8c17*/, "Zi " /*8c18*/, "An " /*8c19*/, "Yan " /*8c1a*/, "Di " /*8c1b*/, "Mi " /*8c1c*/, "Pian " /*8c1d*/, "Xu " /*8c1e*/, "Mo " /*8c1f*/, "Dang " /*8c20*/, "Su " /*8c21*/, "Xie " /*8c22*/, "Yao " /*8c23*/, "Bang " /*8c24*/, "Shi " /*8c25*/, "Qian " /*8c26*/, "Mi " /*8c27*/, "Jin " /*8c28*/, "Man " /*8c29*/, "Zhe " /*8c2a*/, "Jian " /*8c2b*/, "Miu " /*8c2c*/, "Tan " /*8c2d*/, "Zen " /*8c2e*/, "Qiao " /*8c2f*/, "Lan " /*8c30*/, "Pu " /*8c31*/, "Jue " /*8c32*/, "Yan " /*8c33*/, "Qian " /*8c34*/, "Zhan " /*8c35*/, "Chen " /*8c36*/, "Gu " /*8c37*/, "Qian " /*8c38*/, "Hong " /*8c39*/, "Xia " /*8c3a*/, "Jue " /*8c3b*/, "Hong " /*8c3c*/, "Han " /*8c3d*/, "Hong " /*8c3e*/, "Xi " /*8c3f*/, "Xi " /*8c40*/, "Huo " /*8c41*/, "Liao " /*8c42*/, "Han " /*8c43*/, "Du " /*8c44*/, "Long " /*8c45*/, "Dou " /*8c46*/, "Jiang " /*8c47*/, "Qi " /*8c48*/, "Shi " /*8c49*/, "Li " /*8c4a*/, "Deng " /*8c4b*/, "Wan " /*8c4c*/, "Bi " /*8c4d*/, "Shu " /*8c4e*/, "Xian " /*8c4f*/, "Feng " /*8c50*/, "Zhi " /*8c51*/, "Zhi " /*8c52*/, "Yan " /*8c53*/, "Yan " /*8c54*/, "Shi " /*8c55*/, "Chu " /*8c56*/, "Hui " /*8c57*/, "Tun " /*8c58*/, "Yi " /*8c59*/, "Tun " /*8c5a*/, "Yi " /*8c5b*/, "Jian " /*8c5c*/, "Ba " /*8c5d*/, "Hou " /*8c5e*/, "E " /*8c5f*/, "Cu " /*8c60*/, "Xiang " /*8c61*/, "Huan " /*8c62*/, "Jian " /*8c63*/, "Ken " /*8c64*/, "Gai " /*8c65*/, "Qu " /*8c66*/, "Fu " /*8c67*/, "Xi " /*8c68*/, "Bin " /*8c69*/, "Hao " /*8c6a*/, "Yu " /*8c6b*/, "Zhu " /*8c6c*/, "Jia " /*8c6d*/, "[?] " /*8c6e*/, "Xi " /*8c6f*/, "Bo " /*8c70*/, "Wen " /*8c71*/, "Huan " /*8c72*/, "Bin " /*8c73*/, "Di " /*8c74*/, "Zong " /*8c75*/, "Fen " /*8c76*/, "Yi " /*8c77*/, "Zhi " /*8c78*/, "Bao " /*8c79*/, "Chai " /*8c7a*/, "Han " /*8c7b*/, "Pi " /*8c7c*/, "Na " /*8c7d*/, "Pi " /*8c7e*/, "Gou " /*8c7f*/, "Na " /*8c80*/, "You " /*8c81*/, "Diao " /*8c82*/, "Mo " /*8c83*/, "Si " /*8c84*/, "Xiu " /*8c85*/, "Huan " /*8c86*/, "Kun " /*8c87*/, "He " /*8c88*/, "He " /*8c89*/, "Mo " /*8c8a*/, "Han " /*8c8b*/, "Mao " /*8c8c*/, "Li " /*8c8d*/, "Ni " /*8c8e*/, "Bi " /*8c8f*/, "Yu " /*8c90*/, "Jia " /*8c91*/, "Tuan " /*8c92*/, "Mao " /*8c93*/, "Pi " /*8c94*/, "Xi " /*8c95*/, "E " /*8c96*/, "Ju " /*8c97*/, "Mo " /*8c98*/, "Chu " /*8c99*/, "Tan " /*8c9a*/, "Huan " /*8c9b*/, "Jue " /*8c9c*/, "Bei " /*8c9d*/, "Zhen " /*8c9e*/, "Yuan " /*8c9f*/, "Fu " /*8ca0*/, "Cai " /*8ca1*/, "Gong " /*8ca2*/, "Te " /*8ca3*/, "Yi " /*8ca4*/, "Hang " /*8ca5*/, "Wan " /*8ca6*/, "Pin " /*8ca7*/, "Huo " /*8ca8*/, "Fan " /*8ca9*/, "Tan " /*8caa*/, "Guan " /*8cab*/, "Ze " /*8cac*/, "Zhi " /*8cad*/, "Er " /*8cae*/, "Zhu " /*8caf*/, "Shi " /*8cb0*/, "Bi " /*8cb1*/, "Zi " /*8cb2*/, "Er " /*8cb3*/, "Gui " /*8cb4*/, "Pian " /*8cb5*/, "Bian " /*8cb6*/, "Mai " /*8cb7*/, "Dai " /*8cb8*/, "Sheng " /*8cb9*/, "Kuang " /*8cba*/, "Fei " /*8cbb*/, "Tie " /*8cbc*/, "Yi " /*8cbd*/, "Chi " /*8cbe*/, "Mao " /*8cbf*/, "He " /*8cc0*/, "Bi " /*8cc1*/, "Lu " /*8cc2*/, "Ren " /*8cc3*/, "Hui " /*8cc4*/, "Gai " /*8cc5*/, "Pian " /*8cc6*/, "Zi " /*8cc7*/, "Jia " /*8cc8*/, "Xu " /*8cc9*/, "Zei " /*8cca*/, "Jiao " /*8ccb*/, "Gai " /*8ccc*/, "Zang " /*8ccd*/, "Jian " /*8cce*/, "Ying " /*8ccf*/, "Xun " /*8cd0*/, "Zhen " /*8cd1*/, "She " /*8cd2*/, "Bin " /*8cd3*/, "Bin " /*8cd4*/, "Qiu " /*8cd5*/, "She " /*8cd6*/, "Chuan " /*8cd7*/, "Zang " /*8cd8*/, "Zhou " /*8cd9*/, "Lai " /*8cda*/, "Zan " /*8cdb*/, "Si " /*8cdc*/, "Chen " /*8cdd*/, "Shang " /*8cde*/, "Tian " /*8cdf*/, "Pei " /*8ce0*/, "Geng " /*8ce1*/, "Xian " /*8ce2*/, "Mai " /*8ce3*/, "Jian " /*8ce4*/, "Sui " /*8ce5*/, "Fu " /*8ce6*/, "Tan " /*8ce7*/, "Cong " /*8ce8*/, "Cong " /*8ce9*/, "Zhi " /*8cea*/, "Ji " /*8ceb*/, "Zhang " /*8cec*/, "Du " /*8ced*/, "Jin " /*8cee*/, "Xiong " /*8cef*/, "Shun " /*8cf0*/, "Yun " /*8cf1*/, "Bao " /*8cf2*/, "Zai " /*8cf3*/, "Lai " /*8cf4*/, "Feng " /*8cf5*/, "Cang " /*8cf6*/, "Ji " /*8cf7*/, "Sheng " /*8cf8*/, "Ai " /*8cf9*/, "Zhuan " /*8cfa*/, "Fu " /*8cfb*/, "Gou " /*8cfc*/, "Sai " /*8cfd*/, "Ze " /*8cfe*/, "Liao " /*8cff*/ 
			});
						characters.TryAdd(141 /*36096 8d*/, new string[] {
				"Wei " /*8d00*/, "Bai " /*8d01*/, "Chen " /*8d02*/, "Zhuan " /*8d03*/, "Zhi " /*8d04*/, "Zhui " /*8d05*/, "Biao " /*8d06*/, "Yun " /*8d07*/, "Zeng " /*8d08*/, "Tan " /*8d09*/, "Zan " /*8d0a*/, "Yan " /*8d0b*/, "[?] " /*8d0c*/, "Shan " /*8d0d*/, "Wan " /*8d0e*/, "Ying " /*8d0f*/, "Jin " /*8d10*/, "Gan " /*8d11*/, "Xian " /*8d12*/, "Zang " /*8d13*/, "Bi " /*8d14*/, "Du " /*8d15*/, "Shu " /*8d16*/, "Yan " /*8d17*/, "[?] " /*8d18*/, "Xuan " /*8d19*/, "Long " /*8d1a*/, "Gan " /*8d1b*/, "Zang " /*8d1c*/, "Bei " /*8d1d*/, "Zhen " /*8d1e*/, "Fu " /*8d1f*/, "Yuan " /*8d20*/, "Gong " /*8d21*/, "Cai " /*8d22*/, "Ze " /*8d23*/, "Xian " /*8d24*/, "Bai " /*8d25*/, "Zhang " /*8d26*/, "Huo " /*8d27*/, "Zhi " /*8d28*/, "Fan " /*8d29*/, "Tan " /*8d2a*/, "Pin " /*8d2b*/, "Bian " /*8d2c*/, "Gou " /*8d2d*/, "Zhu " /*8d2e*/, "Guan " /*8d2f*/, "Er " /*8d30*/, "Jian " /*8d31*/, "Bi " /*8d32*/, "Shi " /*8d33*/, "Tie " /*8d34*/, "Gui " /*8d35*/, "Kuang " /*8d36*/, "Dai " /*8d37*/, "Mao " /*8d38*/, "Fei " /*8d39*/, "He " /*8d3a*/, "Yi " /*8d3b*/, "Zei " /*8d3c*/, "Zhi " /*8d3d*/, "Jia " /*8d3e*/, "Hui " /*8d3f*/, "Zi " /*8d40*/, "Ren " /*8d41*/, "Lu " /*8d42*/, "Zang " /*8d43*/, "Zi " /*8d44*/, "Gai " /*8d45*/, "Jin " /*8d46*/, "Qiu " /*8d47*/, "Zhen " /*8d48*/, "Lai " /*8d49*/, "She " /*8d4a*/, "Fu " /*8d4b*/, "Du " /*8d4c*/, "Ji " /*8d4d*/, "Shu " /*8d4e*/, "Shang " /*8d4f*/, "Si " /*8d50*/, "Bi " /*8d51*/, "Zhou " /*8d52*/, "Geng " /*8d53*/, "Pei " /*8d54*/, "Tan " /*8d55*/, "Lai " /*8d56*/, "Feng " /*8d57*/, "Zhui " /*8d58*/, "Fu " /*8d59*/, "Zhuan " /*8d5a*/, "Sai " /*8d5b*/, "Ze " /*8d5c*/, "Yan " /*8d5d*/, "Zan " /*8d5e*/, "Yun " /*8d5f*/, "Zeng " /*8d60*/, "Shan " /*8d61*/, "Ying " /*8d62*/, "Gan " /*8d63*/, "Chi " /*8d64*/, "Xi " /*8d65*/, "She " /*8d66*/, "Nan " /*8d67*/, "Xiong " /*8d68*/, "Xi " /*8d69*/, "Cheng " /*8d6a*/, "He " /*8d6b*/, "Cheng " /*8d6c*/, "Zhe " /*8d6d*/, "Xia " /*8d6e*/, "Tang " /*8d6f*/, "Zou " /*8d70*/, "Zou " /*8d71*/, "Li " /*8d72*/, "Jiu " /*8d73*/, "Fu " /*8d74*/, "Zhao " /*8d75*/, "Gan " /*8d76*/, "Qi " /*8d77*/, "Shan " /*8d78*/, "Qiong " /*8d79*/, "Qin " /*8d7a*/, "Xian " /*8d7b*/, "Ci " /*8d7c*/, "Jue " /*8d7d*/, "Qin " /*8d7e*/, "Chi " /*8d7f*/, "Ci " /*8d80*/, "Chen " /*8d81*/, "Chen " /*8d82*/, "Die " /*8d83*/, "Ju " /*8d84*/, "Chao " /*8d85*/, "Di " /*8d86*/, "Se " /*8d87*/, "Zhan " /*8d88*/, "Zhu " /*8d89*/, "Yue " /*8d8a*/, "Qu " /*8d8b*/, "Jie " /*8d8c*/, "Chi " /*8d8d*/, "Chu " /*8d8e*/, "Gua " /*8d8f*/, "Xue " /*8d90*/, "Ci " /*8d91*/, "Tiao " /*8d92*/, "Duo " /*8d93*/, "Lie " /*8d94*/, "Gan " /*8d95*/, "Suo " /*8d96*/, "Cu " /*8d97*/, "Xi " /*8d98*/, "Zhao " /*8d99*/, "Su " /*8d9a*/, "Yin " /*8d9b*/, "Ju " /*8d9c*/, "Jian " /*8d9d*/, "Que " /*8d9e*/, "Tang " /*8d9f*/, "Chuo " /*8da0*/, "Cui " /*8da1*/, "Lu " /*8da2*/, "Qu " /*8da3*/, "Dang " /*8da4*/, "Qiu " /*8da5*/, "Zi " /*8da6*/, "Ti " /*8da7*/, "Qu " /*8da8*/, "Chi " /*8da9*/, "Huang " /*8daa*/, "Qiao " /*8dab*/, "Qiao " /*8dac*/, "Yao " /*8dad*/, "Zao " /*8dae*/, "Ti " /*8daf*/, "[?] " /*8db0*/, "Zan " /*8db1*/, "Zan " /*8db2*/, "Zu " /*8db3*/, "Pa " /*8db4*/, "Bao " /*8db5*/, "Ku " /*8db6*/, "Ke " /*8db7*/, "Dun " /*8db8*/, "Jue " /*8db9*/, "Fu " /*8dba*/, "Chen " /*8dbb*/, "Jian " /*8dbc*/, "Fang " /*8dbd*/, "Zhi " /*8dbe*/, "Sa " /*8dbf*/, "Yue " /*8dc0*/, "Pa " /*8dc1*/, "Qi " /*8dc2*/, "Yue " /*8dc3*/, "Qiang " /*8dc4*/, "Tuo " /*8dc5*/, "Tai " /*8dc6*/, "Yi " /*8dc7*/, "Nian " /*8dc8*/, "Ling " /*8dc9*/, "Mei " /*8dca*/, "Ba " /*8dcb*/, "Die " /*8dcc*/, "Ku " /*8dcd*/, "Tuo " /*8dce*/, "Jia " /*8dcf*/, "Ci " /*8dd0*/, "Pao " /*8dd1*/, "Qia " /*8dd2*/, "Zhu " /*8dd3*/, "Ju " /*8dd4*/, "Die " /*8dd5*/, "Zhi " /*8dd6*/, "Fu " /*8dd7*/, "Pan " /*8dd8*/, "Ju " /*8dd9*/, "Shan " /*8dda*/, "Bo " /*8ddb*/, "Ni " /*8ddc*/, "Ju " /*8ddd*/, "Li " /*8dde*/, "Gen " /*8ddf*/, "Yi " /*8de0*/, "Ji " /*8de1*/, "Dai " /*8de2*/, "Xian " /*8de3*/, "Jiao " /*8de4*/, "Duo " /*8de5*/, "Zhu " /*8de6*/, "Zhuan " /*8de7*/, "Kua " /*8de8*/, "Zhuai " /*8de9*/, "Gui " /*8dea*/, "Qiong " /*8deb*/, "Kui " /*8dec*/, "Xiang " /*8ded*/, "Chi " /*8dee*/, "Lu " /*8def*/, "Beng " /*8df0*/, "Zhi " /*8df1*/, "Jia " /*8df2*/, "Tiao " /*8df3*/, "Cai " /*8df4*/, "Jian " /*8df5*/, "Ta " /*8df6*/, "Qiao " /*8df7*/, "Bi " /*8df8*/, "Xian " /*8df9*/, "Duo " /*8dfa*/, "Ji " /*8dfb*/, "Ju " /*8dfc*/, "Ji " /*8dfd*/, "Shu " /*8dfe*/, "Tu " /*8dff*/ 
			});
						characters.TryAdd(142 /*36352 8e*/, new string[] {
				"Chu " /*8e00*/, "Jing " /*8e01*/, "Nie " /*8e02*/, "Xiao " /*8e03*/, "Bo " /*8e04*/, "Chi " /*8e05*/, "Qun " /*8e06*/, "Mou " /*8e07*/, "Shu " /*8e08*/, "Lang " /*8e09*/, "Yong " /*8e0a*/, "Jiao " /*8e0b*/, "Chou " /*8e0c*/, "Qiao " /*8e0d*/, "[?] " /*8e0e*/, "Ta " /*8e0f*/, "Jian " /*8e10*/, "Qi " /*8e11*/, "Wo " /*8e12*/, "Wei " /*8e13*/, "Zhuo " /*8e14*/, "Jie " /*8e15*/, "Ji " /*8e16*/, "Nie " /*8e17*/, "Ju " /*8e18*/, "Ju " /*8e19*/, "Lun " /*8e1a*/, "Lu " /*8e1b*/, "Leng " /*8e1c*/, "Huai " /*8e1d*/, "Ju " /*8e1e*/, "Chi " /*8e1f*/, "Wan " /*8e20*/, "Quan " /*8e21*/, "Ti " /*8e22*/, "Bo " /*8e23*/, "Zu " /*8e24*/, "Qie " /*8e25*/, "Ji " /*8e26*/, "Cu " /*8e27*/, "Zong " /*8e28*/, "Cai " /*8e29*/, "Zong " /*8e2a*/, "Peng " /*8e2b*/, "Zhi " /*8e2c*/, "Zheng " /*8e2d*/, "Dian " /*8e2e*/, "Zhi " /*8e2f*/, "Yu " /*8e30*/, "Duo " /*8e31*/, "Dun " /*8e32*/, "Chun " /*8e33*/, "Yong " /*8e34*/, "Zhong " /*8e35*/, "Di " /*8e36*/, "Zhe " /*8e37*/, "Chen " /*8e38*/, "Chuai " /*8e39*/, "Jian " /*8e3a*/, "Gua " /*8e3b*/, "Tang " /*8e3c*/, "Ju " /*8e3d*/, "Fu " /*8e3e*/, "Zu " /*8e3f*/, "Die " /*8e40*/, "Pian " /*8e41*/, "Rou " /*8e42*/, "Nuo " /*8e43*/, "Ti " /*8e44*/, "Cha " /*8e45*/, "Tui " /*8e46*/, "Jian " /*8e47*/, "Dao " /*8e48*/, "Cuo " /*8e49*/, "Xi " /*8e4a*/, "Ta " /*8e4b*/, "Qiang " /*8e4c*/, "Zhan " /*8e4d*/, "Dian " /*8e4e*/, "Ti " /*8e4f*/, "Ji " /*8e50*/, "Nie " /*8e51*/, "Man " /*8e52*/, "Liu " /*8e53*/, "Zhan " /*8e54*/, "Bi " /*8e55*/, "Chong " /*8e56*/, "Lu " /*8e57*/, "Liao " /*8e58*/, "Cu " /*8e59*/, "Tang " /*8e5a*/, "Dai " /*8e5b*/, "Suo " /*8e5c*/, "Xi " /*8e5d*/, "Kui " /*8e5e*/, "Ji " /*8e5f*/, "Zhi " /*8e60*/, "Qiang " /*8e61*/, "Di " /*8e62*/, "Man " /*8e63*/, "Zong " /*8e64*/, "Lian " /*8e65*/, "Beng " /*8e66*/, "Zao " /*8e67*/, "Nian " /*8e68*/, "Bie " /*8e69*/, "Tui " /*8e6a*/, "Ju " /*8e6b*/, "Deng " /*8e6c*/, "Ceng " /*8e6d*/, "Xian " /*8e6e*/, "Fan " /*8e6f*/, "Chu " /*8e70*/, "Zhong " /*8e71*/, "Dun " /*8e72*/, "Bo " /*8e73*/, "Cu " /*8e74*/, "Zu " /*8e75*/, "Jue " /*8e76*/, "Jue " /*8e77*/, "Lin " /*8e78*/, "Ta " /*8e79*/, "Qiao " /*8e7a*/, "Qiao " /*8e7b*/, "Pu " /*8e7c*/, "Liao " /*8e7d*/, "Dun " /*8e7e*/, "Cuan " /*8e7f*/, "Kuang " /*8e80*/, "Zao " /*8e81*/, "Ta " /*8e82*/, "Bi " /*8e83*/, "Bi " /*8e84*/, "Zhu " /*8e85*/, "Ju " /*8e86*/, "Chu " /*8e87*/, "Qiao " /*8e88*/, "Dun " /*8e89*/, "Chou " /*8e8a*/, "Ji " /*8e8b*/, "Wu " /*8e8c*/, "Yue " /*8e8d*/, "Nian " /*8e8e*/, "Lin " /*8e8f*/, "Lie " /*8e90*/, "Zhi " /*8e91*/, "Li " /*8e92*/, "Zhi " /*8e93*/, "Chan " /*8e94*/, "Chu " /*8e95*/, "Duan " /*8e96*/, "Wei " /*8e97*/, "Long " /*8e98*/, "Lin " /*8e99*/, "Xian " /*8e9a*/, "Wei " /*8e9b*/, "Zuan " /*8e9c*/, "Lan " /*8e9d*/, "Xie " /*8e9e*/, "Rang " /*8e9f*/, "Xie " /*8ea0*/, "Nie " /*8ea1*/, "Ta " /*8ea2*/, "Qu " /*8ea3*/, "Jie " /*8ea4*/, "Cuan " /*8ea5*/, "Zuan " /*8ea6*/, "Xi " /*8ea7*/, "Kui " /*8ea8*/, "Jue " /*8ea9*/, "Lin " /*8eaa*/, "Shen " /*8eab*/, "Gong " /*8eac*/, "Dan " /*8ead*/, "Segare " /*8eae*/, "Qu " /*8eaf*/, "Ti " /*8eb0*/, "Duo " /*8eb1*/, "Duo " /*8eb2*/, "Gong " /*8eb3*/, "Lang " /*8eb4*/, "Nerau " /*8eb5*/, "Luo " /*8eb6*/, "Ai " /*8eb7*/, "Ji " /*8eb8*/, "Ju " /*8eb9*/, "Tang " /*8eba*/, "Utsuke " /*8ebb*/, "[?] " /*8ebc*/, "Yan " /*8ebd*/, "Shitsuke " /*8ebe*/, "Kang " /*8ebf*/, "Qu " /*8ec0*/, "Lou " /*8ec1*/, "Lao " /*8ec2*/, "Tuo " /*8ec3*/, "Zhi " /*8ec4*/, "Yagate " /*8ec5*/, "Ti " /*8ec6*/, "Dao " /*8ec7*/, "Yagate " /*8ec8*/, "Yu " /*8ec9*/, "Che " /*8eca*/, "Ya " /*8ecb*/, "Gui " /*8ecc*/, "Jun " /*8ecd*/, "Wei " /*8ece*/, "Yue " /*8ecf*/, "Xin " /*8ed0*/, "Di " /*8ed1*/, "Xuan " /*8ed2*/, "Fan " /*8ed3*/, "Ren " /*8ed4*/, "Shan " /*8ed5*/, "Qiang " /*8ed6*/, "Shu " /*8ed7*/, "Tun " /*8ed8*/, "Chen " /*8ed9*/, "Dai " /*8eda*/, "E " /*8edb*/, "Na " /*8edc*/, "Qi " /*8edd*/, "Mao " /*8ede*/, "Ruan " /*8edf*/, "Ren " /*8ee0*/, "Fan " /*8ee1*/, "Zhuan " /*8ee2*/, "Hong " /*8ee3*/, "Hu " /*8ee4*/, "Qu " /*8ee5*/, "Huang " /*8ee6*/, "Di " /*8ee7*/, "Ling " /*8ee8*/, "Dai " /*8ee9*/, "Ao " /*8eea*/, "Zhen " /*8eeb*/, "Fan " /*8eec*/, "Kuang " /*8eed*/, "Ang " /*8eee*/, "Peng " /*8eef*/, "Bei " /*8ef0*/, "Gu " /*8ef1*/, "Ku " /*8ef2*/, "Pao " /*8ef3*/, "Zhu " /*8ef4*/, "Rong " /*8ef5*/, "E " /*8ef6*/, "Ba " /*8ef7*/, "Zhou " /*8ef8*/, "Zhi " /*8ef9*/, "Yao " /*8efa*/, "Ke " /*8efb*/, "Yi " /*8efc*/, "Qing " /*8efd*/, "Shi " /*8efe*/, "Ping " /*8eff*/ 
			});
						characters.TryAdd(143 /*36608 8f*/, new string[] {
				"Er " /*8f00*/, "Qiong " /*8f01*/, "Ju " /*8f02*/, "Jiao " /*8f03*/, "Guang " /*8f04*/, "Lu " /*8f05*/, "Kai " /*8f06*/, "Quan " /*8f07*/, "Zhou " /*8f08*/, "Zai " /*8f09*/, "Zhi " /*8f0a*/, "She " /*8f0b*/, "Liang " /*8f0c*/, "Yu " /*8f0d*/, "Shao " /*8f0e*/, "You " /*8f0f*/, "Huan " /*8f10*/, "Yun " /*8f11*/, "Zhe " /*8f12*/, "Wan " /*8f13*/, "Fu " /*8f14*/, "Qing " /*8f15*/, "Zhou " /*8f16*/, "Ni " /*8f17*/, "Ling " /*8f18*/, "Zhe " /*8f19*/, "Zhan " /*8f1a*/, "Liang " /*8f1b*/, "Zi " /*8f1c*/, "Hui " /*8f1d*/, "Wang " /*8f1e*/, "Chuo " /*8f1f*/, "Guo " /*8f20*/, "Kan " /*8f21*/, "Yi " /*8f22*/, "Peng " /*8f23*/, "Qian " /*8f24*/, "Gun " /*8f25*/, "Nian " /*8f26*/, "Pian " /*8f27*/, "Guan " /*8f28*/, "Bei " /*8f29*/, "Lun " /*8f2a*/, "Pai " /*8f2b*/, "Liang " /*8f2c*/, "Ruan " /*8f2d*/, "Rou " /*8f2e*/, "Ji " /*8f2f*/, "Yang " /*8f30*/, "Xian " /*8f31*/, "Chuan " /*8f32*/, "Cou " /*8f33*/, "Qun " /*8f34*/, "Ge " /*8f35*/, "You " /*8f36*/, "Hong " /*8f37*/, "Shu " /*8f38*/, "Fu " /*8f39*/, "Zi " /*8f3a*/, "Fu " /*8f3b*/, "Wen " /*8f3c*/, "Ben " /*8f3d*/, "Zhan " /*8f3e*/, "Yu " /*8f3f*/, "Wen " /*8f40*/, "Tao " /*8f41*/, "Gu " /*8f42*/, "Zhen " /*8f43*/, "Xia " /*8f44*/, "Yuan " /*8f45*/, "Lu " /*8f46*/, "Jiu " /*8f47*/, "Chao " /*8f48*/, "Zhuan " /*8f49*/, "Wei " /*8f4a*/, "Hun " /*8f4b*/, "Sori " /*8f4c*/, "Che " /*8f4d*/, "Jiao " /*8f4e*/, "Zhan " /*8f4f*/, "Pu " /*8f50*/, "Lao " /*8f51*/, "Fen " /*8f52*/, "Fan " /*8f53*/, "Lin " /*8f54*/, "Ge " /*8f55*/, "Se " /*8f56*/, "Kan " /*8f57*/, "Huan " /*8f58*/, "Yi " /*8f59*/, "Ji " /*8f5a*/, "Dui " /*8f5b*/, "Er " /*8f5c*/, "Yu " /*8f5d*/, "Xian " /*8f5e*/, "Hong " /*8f5f*/, "Lei " /*8f60*/, "Pei " /*8f61*/, "Li " /*8f62*/, "Li " /*8f63*/, "Lu " /*8f64*/, "Lin " /*8f65*/, "Che " /*8f66*/, "Ya " /*8f67*/, "Gui " /*8f68*/, "Xuan " /*8f69*/, "Di " /*8f6a*/, "Ren " /*8f6b*/, "Zhuan " /*8f6c*/, "E " /*8f6d*/, "Lun " /*8f6e*/, "Ruan " /*8f6f*/, "Hong " /*8f70*/, "Ku " /*8f71*/, "Ke " /*8f72*/, "Lu " /*8f73*/, "Zhou " /*8f74*/, "Zhi " /*8f75*/, "Yi " /*8f76*/, "Hu " /*8f77*/, "Zhen " /*8f78*/, "Li " /*8f79*/, "Yao " /*8f7a*/, "Qing " /*8f7b*/, "Shi " /*8f7c*/, "Zai " /*8f7d*/, "Zhi " /*8f7e*/, "Jiao " /*8f7f*/, "Zhou " /*8f80*/, "Quan " /*8f81*/, "Lu " /*8f82*/, "Jiao " /*8f83*/, "Zhe " /*8f84*/, "Fu " /*8f85*/, "Liang " /*8f86*/, "Nian " /*8f87*/, "Bei " /*8f88*/, "Hui " /*8f89*/, "Gun " /*8f8a*/, "Wang " /*8f8b*/, "Liang " /*8f8c*/, "Chuo " /*8f8d*/, "Zi " /*8f8e*/, "Cou " /*8f8f*/, "Fu " /*8f90*/, "Ji " /*8f91*/, "Wen " /*8f92*/, "Shu " /*8f93*/, "Pei " /*8f94*/, "Yuan " /*8f95*/, "Xia " /*8f96*/, "Zhan " /*8f97*/, "Lu " /*8f98*/, "Che " /*8f99*/, "Lin " /*8f9a*/, "Xin " /*8f9b*/, "Gu " /*8f9c*/, "Ci " /*8f9d*/, "Ci " /*8f9e*/, "Pi " /*8f9f*/, "Zui " /*8fa0*/, "Bian " /*8fa1*/, "La " /*8fa2*/, "La " /*8fa3*/, "Ci " /*8fa4*/, "Xue " /*8fa5*/, "Ban " /*8fa6*/, "Bian " /*8fa7*/, "Bian " /*8fa8*/, "Bian " /*8fa9*/, "[?] " /*8faa*/, "Bian " /*8fab*/, "Ban " /*8fac*/, "Ci " /*8fad*/, "Bian " /*8fae*/, "Bian " /*8faf*/, "Chen " /*8fb0*/, "Ru " /*8fb1*/, "Nong " /*8fb2*/, "Nong " /*8fb3*/, "Zhen " /*8fb4*/, "Chuo " /*8fb5*/, "Chuo " /*8fb6*/, "Suberu " /*8fb7*/, "Reng " /*8fb8*/, "Bian " /*8fb9*/, "Bian " /*8fba*/, "Sip " /*8fbb*/, "Ip " /*8fbc*/, "Liao " /*8fbd*/, "Da " /*8fbe*/, "Chan " /*8fbf*/, "Gan " /*8fc0*/, "Qian " /*8fc1*/, "Yu " /*8fc2*/, "Yu " /*8fc3*/, "Qi " /*8fc4*/, "Xun " /*8fc5*/, "Yi " /*8fc6*/, "Guo " /*8fc7*/, "Mai " /*8fc8*/, "Qi " /*8fc9*/, "Za " /*8fca*/, "Wang " /*8fcb*/, "Jia " /*8fcc*/, "Zhun " /*8fcd*/, "Ying " /*8fce*/, "Ti " /*8fcf*/, "Yun " /*8fd0*/, "Jin " /*8fd1*/, "Hang " /*8fd2*/, "Ya " /*8fd3*/, "Fan " /*8fd4*/, "Wu " /*8fd5*/, "Da " /*8fd6*/, "E " /*8fd7*/, "Huan " /*8fd8*/, "Zhe " /*8fd9*/, "Totemo " /*8fda*/, "Jin " /*8fdb*/, "Yuan " /*8fdc*/, "Wei " /*8fdd*/, "Lian " /*8fde*/, "Chi " /*8fdf*/, "Che " /*8fe0*/, "Ni " /*8fe1*/, "Tiao " /*8fe2*/, "Zhi " /*8fe3*/, "Yi " /*8fe4*/, "Jiong " /*8fe5*/, "Jia " /*8fe6*/, "Chen " /*8fe7*/, "Dai " /*8fe8*/, "Er " /*8fe9*/, "Di " /*8fea*/, "Po " /*8feb*/, "Wang " /*8fec*/, "Die " /*8fed*/, "Ze " /*8fee*/, "Tao " /*8fef*/, "Shu " /*8ff0*/, "Tuo " /*8ff1*/, "Kep " /*8ff2*/, "Jing " /*8ff3*/, "Hui " /*8ff4*/, "Tong " /*8ff5*/, "You " /*8ff6*/, "Mi " /*8ff7*/, "Beng " /*8ff8*/, "Ji " /*8ff9*/, "Nai " /*8ffa*/, "Yi " /*8ffb*/, "Jie " /*8ffc*/, "Zhui " /*8ffd*/, "Lie " /*8ffe*/, "Xun " /*8fff*/ 
			});
						characters.TryAdd(144 /*36864 90*/, new string[] {
				"Tui " /*9000*/, "Song " /*9001*/, "Gua " /*9002*/, "Tao " /*9003*/, "Pang " /*9004*/, "Hou " /*9005*/, "Ni " /*9006*/, "Dun " /*9007*/, "Jiong " /*9008*/, "Xuan " /*9009*/, "Xun " /*900a*/, "Bu " /*900b*/, "You " /*900c*/, "Xiao " /*900d*/, "Qiu " /*900e*/, "Tou " /*900f*/, "Zhu " /*9010*/, "Qiu " /*9011*/, "Di " /*9012*/, "Di " /*9013*/, "Tu " /*9014*/, "Jing " /*9015*/, "Ti " /*9016*/, "Dou " /*9017*/, "Yi " /*9018*/, "Zhe " /*9019*/, "Tong " /*901a*/, "Guang " /*901b*/, "Wu " /*901c*/, "Shi " /*901d*/, "Cheng " /*901e*/, "Su " /*901f*/, "Zao " /*9020*/, "Qun " /*9021*/, "Feng " /*9022*/, "Lian " /*9023*/, "Suo " /*9024*/, "Hui " /*9025*/, "Li " /*9026*/, "Sako " /*9027*/, "Lai " /*9028*/, "Ben " /*9029*/, "Cuo " /*902a*/, "Jue " /*902b*/, "Beng " /*902c*/, "Huan " /*902d*/, "Dai " /*902e*/, "Lu " /*902f*/, "You " /*9030*/, "Zhou " /*9031*/, "Jin " /*9032*/, "Yu " /*9033*/, "Chuo " /*9034*/, "Kui " /*9035*/, "Wei " /*9036*/, "Ti " /*9037*/, "Yi " /*9038*/, "Da " /*9039*/, "Yuan " /*903a*/, "Luo " /*903b*/, "Bi " /*903c*/, "Nuo " /*903d*/, "Yu " /*903e*/, "Dang " /*903f*/, "Sui " /*9040*/, "Dun " /*9041*/, "Sui " /*9042*/, "Yan " /*9043*/, "Chuan " /*9044*/, "Chi " /*9045*/, "Ti " /*9046*/, "Yu " /*9047*/, "Shi " /*9048*/, "Zhen " /*9049*/, "You " /*904a*/, "Yun " /*904b*/, "E " /*904c*/, "Bian " /*904d*/, "Guo " /*904e*/, "E " /*904f*/, "Xia " /*9050*/, "Huang " /*9051*/, "Qiu " /*9052*/, "Dao " /*9053*/, "Da " /*9054*/, "Wei " /*9055*/, "Appare " /*9056*/, "Yi " /*9057*/, "Gou " /*9058*/, "Yao " /*9059*/, "Chu " /*905a*/, "Liu " /*905b*/, "Xun " /*905c*/, "Ta " /*905d*/, "Di " /*905e*/, "Chi " /*905f*/, "Yuan " /*9060*/, "Su " /*9061*/, "Ta " /*9062*/, "Qian " /*9063*/, "[?] " /*9064*/, "Yao " /*9065*/, "Guan " /*9066*/, "Zhang " /*9067*/, "Ao " /*9068*/, "Shi " /*9069*/, "Ce " /*906a*/, "Chi " /*906b*/, "Su " /*906c*/, "Zao " /*906d*/, "Zhe " /*906e*/, "Dun " /*906f*/, "Di " /*9070*/, "Lou " /*9071*/, "Chi " /*9072*/, "Cuo " /*9073*/, "Lin " /*9074*/, "Zun " /*9075*/, "Rao " /*9076*/, "Qian " /*9077*/, "Xuan " /*9078*/, "Yu " /*9079*/, "Yi " /*907a*/, "Wu " /*907b*/, "Liao " /*907c*/, "Ju " /*907d*/, "Shi " /*907e*/, "Bi " /*907f*/, "Yao " /*9080*/, "Mai " /*9081*/, "Xie " /*9082*/, "Sui " /*9083*/, "Huan " /*9084*/, "Zhan " /*9085*/, "Teng " /*9086*/, "Er " /*9087*/, "Miao " /*9088*/, "Bian " /*9089*/, "Bian " /*908a*/, "La " /*908b*/, "Li " /*908c*/, "Yuan " /*908d*/, "Yao " /*908e*/, "Luo " /*908f*/, "Li " /*9090*/, "Yi " /*9091*/, "Ting " /*9092*/, "Deng " /*9093*/, "Qi " /*9094*/, "Yong " /*9095*/, "Shan " /*9096*/, "Han " /*9097*/, "Yu " /*9098*/, "Mang " /*9099*/, "Ru " /*909a*/, "Qiong " /*909b*/, "[?] " /*909c*/, "Kuang " /*909d*/, "Fu " /*909e*/, "Kang " /*909f*/, "Bin " /*90a0*/, "Fang " /*90a1*/, "Xing " /*90a2*/, "Na " /*90a3*/, "Xin " /*90a4*/, "Shen " /*90a5*/, "Bang " /*90a6*/, "Yuan " /*90a7*/, "Cun " /*90a8*/, "Huo " /*90a9*/, "Xie " /*90aa*/, "Bang " /*90ab*/, "Wu " /*90ac*/, "Ju " /*90ad*/, "You " /*90ae*/, "Han " /*90af*/, "Tai " /*90b0*/, "Qiu " /*90b1*/, "Bi " /*90b2*/, "Pei " /*90b3*/, "Bing " /*90b4*/, "Shao " /*90b5*/, "Bei " /*90b6*/, "Wa " /*90b7*/, "Di " /*90b8*/, "Zou " /*90b9*/, "Ye " /*90ba*/, "Lin " /*90bb*/, "Kuang " /*90bc*/, "Gui " /*90bd*/, "Zhu " /*90be*/, "Shi " /*90bf*/, "Ku " /*90c0*/, "Yu " /*90c1*/, "Gai " /*90c2*/, "Ge " /*90c3*/, "Xi " /*90c4*/, "Zhi " /*90c5*/, "Ji " /*90c6*/, "Xun " /*90c7*/, "Hou " /*90c8*/, "Xing " /*90c9*/, "Jiao " /*90ca*/, "Xi " /*90cb*/, "Gui " /*90cc*/, "Nuo " /*90cd*/, "Lang " /*90ce*/, "Jia " /*90cf*/, "Kuai " /*90d0*/, "Zheng " /*90d1*/, "Otoko " /*90d2*/, "Yun " /*90d3*/, "Yan " /*90d4*/, "Cheng " /*90d5*/, "Dou " /*90d6*/, "Chi " /*90d7*/, "Lu " /*90d8*/, "Fu " /*90d9*/, "Wu " /*90da*/, "Fu " /*90db*/, "Gao " /*90dc*/, "Hao " /*90dd*/, "Lang " /*90de*/, "Jia " /*90df*/, "Geng " /*90e0*/, "Jun " /*90e1*/, "Ying " /*90e2*/, "Bo " /*90e3*/, "Xi " /*90e4*/, "Bei " /*90e5*/, "Li " /*90e6*/, "Yun " /*90e7*/, "Bu " /*90e8*/, "Xiao " /*90e9*/, "Qi " /*90ea*/, "Pi " /*90eb*/, "Qing " /*90ec*/, "Guo " /*90ed*/, "Zhou " /*90ee*/, "Tan " /*90ef*/, "Zou " /*90f0*/, "Ping " /*90f1*/, "Lai " /*90f2*/, "Ni " /*90f3*/, "Chen " /*90f4*/, "You " /*90f5*/, "Bu " /*90f6*/, "Xiang " /*90f7*/, "Dan " /*90f8*/, "Ju " /*90f9*/, "Yong " /*90fa*/, "Qiao " /*90fb*/, "Yi " /*90fc*/, "Du " /*90fd*/, "Yan " /*90fe*/, "Mei " /*90ff*/ 
			});
						characters.TryAdd(145 /*37120 91*/, new string[] {
				"Ruo " /*9100*/, "Bei " /*9101*/, "E " /*9102*/, "Yu " /*9103*/, "Juan " /*9104*/, "Yu " /*9105*/, "Yun " /*9106*/, "Hou " /*9107*/, "Kui " /*9108*/, "Xiang " /*9109*/, "Xiang " /*910a*/, "Sou " /*910b*/, "Tang " /*910c*/, "Ming " /*910d*/, "Xi " /*910e*/, "Ru " /*910f*/, "Chu " /*9110*/, "Zi " /*9111*/, "Zou " /*9112*/, "Ju " /*9113*/, "Wu " /*9114*/, "Xiang " /*9115*/, "Yun " /*9116*/, "Hao " /*9117*/, "Yong " /*9118*/, "Bi " /*9119*/, "Mo " /*911a*/, "Chao " /*911b*/, "Fu " /*911c*/, "Liao " /*911d*/, "Yin " /*911e*/, "Zhuan " /*911f*/, "Hu " /*9120*/, "Qiao " /*9121*/, "Yan " /*9122*/, "Zhang " /*9123*/, "Fan " /*9124*/, "Qiao " /*9125*/, "Xu " /*9126*/, "Deng " /*9127*/, "Bi " /*9128*/, "Xin " /*9129*/, "Bi " /*912a*/, "Ceng " /*912b*/, "Wei " /*912c*/, "Zheng " /*912d*/, "Mao " /*912e*/, "Shan " /*912f*/, "Lin " /*9130*/, "Po " /*9131*/, "Dan " /*9132*/, "Meng " /*9133*/, "Ye " /*9134*/, "Cao " /*9135*/, "Kuai " /*9136*/, "Feng " /*9137*/, "Meng " /*9138*/, "Zou " /*9139*/, "Kuang " /*913a*/, "Lian " /*913b*/, "Zan " /*913c*/, "Chan " /*913d*/, "You " /*913e*/, "Qi " /*913f*/, "Yan " /*9140*/, "Chan " /*9141*/, "Zan " /*9142*/, "Ling " /*9143*/, "Huan " /*9144*/, "Xi " /*9145*/, "Feng " /*9146*/, "Zan " /*9147*/, "Li " /*9148*/, "You " /*9149*/, "Ding " /*914a*/, "Qiu " /*914b*/, "Zhuo " /*914c*/, "Pei " /*914d*/, "Zhou " /*914e*/, "Yi " /*914f*/, "Hang " /*9150*/, "Yu " /*9151*/, "Jiu " /*9152*/, "Yan " /*9153*/, "Zui " /*9154*/, "Mao " /*9155*/, "Dan " /*9156*/, "Xu " /*9157*/, "Tou " /*9158*/, "Zhen " /*9159*/, "Fen " /*915a*/, "Sakenomoto " /*915b*/, "[?] " /*915c*/, "Yun " /*915d*/, "Tai " /*915e*/, "Tian " /*915f*/, "Qia " /*9160*/, "Tuo " /*9161*/, "Zuo " /*9162*/, "Han " /*9163*/, "Gu " /*9164*/, "Su " /*9165*/, "Po " /*9166*/, "Chou " /*9167*/, "Zai " /*9168*/, "Ming " /*9169*/, "Luo " /*916a*/, "Chuo " /*916b*/, "Chou " /*916c*/, "You " /*916d*/, "Tong " /*916e*/, "Zhi " /*916f*/, "Xian " /*9170*/, "Jiang " /*9171*/, "Cheng " /*9172*/, "Yin " /*9173*/, "Tu " /*9174*/, "Xiao " /*9175*/, "Mei " /*9176*/, "Ku " /*9177*/, "Suan " /*9178*/, "Lei " /*9179*/, "Pu " /*917a*/, "Zui " /*917b*/, "Hai " /*917c*/, "Yan " /*917d*/, "Xi " /*917e*/, "Niang " /*917f*/, "Wei " /*9180*/, "Lu " /*9181*/, "Lan " /*9182*/, "Yan " /*9183*/, "Tao " /*9184*/, "Pei " /*9185*/, "Zhan " /*9186*/, "Chun " /*9187*/, "Tan " /*9188*/, "Zui " /*9189*/, "Chuo " /*918a*/, "Cu " /*918b*/, "Kun " /*918c*/, "Ti " /*918d*/, "Mian " /*918e*/, "Du " /*918f*/, "Hu " /*9190*/, "Xu " /*9191*/, "Xing " /*9192*/, "Tan " /*9193*/, "Jiu " /*9194*/, "Chun " /*9195*/, "Yun " /*9196*/, "Po " /*9197*/, "Ke " /*9198*/, "Sou " /*9199*/, "Mi " /*919a*/, "Quan " /*919b*/, "Chou " /*919c*/, "Cuo " /*919d*/, "Yun " /*919e*/, "Yong " /*919f*/, "Ang " /*91a0*/, "Zha " /*91a1*/, "Hai " /*91a2*/, "Tang " /*91a3*/, "Jiang " /*91a4*/, "Piao " /*91a5*/, "Shan " /*91a6*/, "Yu " /*91a7*/, "Li " /*91a8*/, "Zao " /*91a9*/, "Lao " /*91aa*/, "Yi " /*91ab*/, "Jiang " /*91ac*/, "Pu " /*91ad*/, "Jiao " /*91ae*/, "Xi " /*91af*/, "Tan " /*91b0*/, "Po " /*91b1*/, "Nong " /*91b2*/, "Yi " /*91b3*/, "Li " /*91b4*/, "Ju " /*91b5*/, "Jiao " /*91b6*/, "Yi " /*91b7*/, "Niang " /*91b8*/, "Ru " /*91b9*/, "Xun " /*91ba*/, "Chou " /*91bb*/, "Yan " /*91bc*/, "Ling " /*91bd*/, "Mi " /*91be*/, "Mi " /*91bf*/, "Niang " /*91c0*/, "Xin " /*91c1*/, "Jiao " /*91c2*/, "Xi " /*91c3*/, "Mi " /*91c4*/, "Yan " /*91c5*/, "Bian " /*91c6*/, "Cai " /*91c7*/, "Shi " /*91c8*/, "You " /*91c9*/, "Shi " /*91ca*/, "Shi " /*91cb*/, "Li " /*91cc*/, "Zhong " /*91cd*/, "Ye " /*91ce*/, "Liang " /*91cf*/, "Li " /*91d0*/, "Jin " /*91d1*/, "Jin " /*91d2*/, "Qiu " /*91d3*/, "Yi " /*91d4*/, "Diao " /*91d5*/, "Dao " /*91d6*/, "Zhao " /*91d7*/, "Ding " /*91d8*/, "Po " /*91d9*/, "Qiu " /*91da*/, "He " /*91db*/, "Fu " /*91dc*/, "Zhen " /*91dd*/, "Zhi " /*91de*/, "Ba " /*91df*/, "Luan " /*91e0*/, "Fu " /*91e1*/, "Nai " /*91e2*/, "Diao " /*91e3*/, "Shan " /*91e4*/, "Qiao " /*91e5*/, "Kou " /*91e6*/, "Chuan " /*91e7*/, "Zi " /*91e8*/, "Fan " /*91e9*/, "Yu " /*91ea*/, "Hua " /*91eb*/, "Han " /*91ec*/, "Gong " /*91ed*/, "Qi " /*91ee*/, "Mang " /*91ef*/, "Ri " /*91f0*/, "Di " /*91f1*/, "Si " /*91f2*/, "Xi " /*91f3*/, "Yi " /*91f4*/, "Chai " /*91f5*/, "Shi " /*91f6*/, "Tu " /*91f7*/, "Xi " /*91f8*/, "Nu " /*91f9*/, "Qian " /*91fa*/, "Ishiyumi " /*91fb*/, "Jian " /*91fc*/, "Pi " /*91fd*/, "Ye " /*91fe*/, "Yin " /*91ff*/ 
			});
						characters.TryAdd(146 /*37376 92*/, new string[] {
				"Ba " /*9200*/, "Fang " /*9201*/, "Chen " /*9202*/, "Xing " /*9203*/, "Tou " /*9204*/, "Yue " /*9205*/, "Yan " /*9206*/, "Fu " /*9207*/, "Pi " /*9208*/, "Na " /*9209*/, "Xin " /*920a*/, "E " /*920b*/, "Jue " /*920c*/, "Dun " /*920d*/, "Gou " /*920e*/, "Yin " /*920f*/, "Qian " /*9210*/, "Ban " /*9211*/, "Ji " /*9212*/, "Ren " /*9213*/, "Chao " /*9214*/, "Niu " /*9215*/, "Fen " /*9216*/, "Yun " /*9217*/, "Ji " /*9218*/, "Qin " /*9219*/, "Pi " /*921a*/, "Guo " /*921b*/, "Hong " /*921c*/, "Yin " /*921d*/, "Jun " /*921e*/, "Shi " /*921f*/, "Yi " /*9220*/, "Zhong " /*9221*/, "Nie " /*9222*/, "Gai " /*9223*/, "Ri " /*9224*/, "Huo " /*9225*/, "Tai " /*9226*/, "Kang " /*9227*/, "Habaki " /*9228*/, "Irori " /*9229*/, "Ngaak " /*922a*/, "[?] " /*922b*/, "Duo " /*922c*/, "Zi " /*922d*/, "Ni " /*922e*/, "Tu " /*922f*/, "Shi " /*9230*/, "Min " /*9231*/, "Gu " /*9232*/, "E " /*9233*/, "Ling " /*9234*/, "Bing " /*9235*/, "Yi " /*9236*/, "Gu " /*9237*/, "Ba " /*9238*/, "Pi " /*9239*/, "Yu " /*923a*/, "Si " /*923b*/, "Zuo " /*923c*/, "Bu " /*923d*/, "You " /*923e*/, "Dian " /*923f*/, "Jia " /*9240*/, "Zhen " /*9241*/, "Shi " /*9242*/, "Shi " /*9243*/, "Tie " /*9244*/, "Ju " /*9245*/, "Zhan " /*9246*/, "Shi " /*9247*/, "She " /*9248*/, "Xuan " /*9249*/, "Zhao " /*924a*/, "Bao " /*924b*/, "He " /*924c*/, "Bi " /*924d*/, "Sheng " /*924e*/, "Chu " /*924f*/, "Shi " /*9250*/, "Bo " /*9251*/, "Zhu " /*9252*/, "Chi " /*9253*/, "Za " /*9254*/, "Po " /*9255*/, "Tong " /*9256*/, "Qian " /*9257*/, "Fu " /*9258*/, "Zhai " /*9259*/, "Liu " /*925a*/, "Qian " /*925b*/, "Fu " /*925c*/, "Li " /*925d*/, "Yue " /*925e*/, "Pi " /*925f*/, "Yang " /*9260*/, "Ban " /*9261*/, "Bo " /*9262*/, "Jie " /*9263*/, "Gou " /*9264*/, "Shu " /*9265*/, "Zheng " /*9266*/, "Mu " /*9267*/, "Ni " /*9268*/, "Nie " /*9269*/, "Di " /*926a*/, "Jia " /*926b*/, "Mu " /*926c*/, "Dan " /*926d*/, "Shen " /*926e*/, "Yi " /*926f*/, "Si " /*9270*/, "Kuang " /*9271*/, "Ka " /*9272*/, "Bei " /*9273*/, "Jian " /*9274*/, "Tong " /*9275*/, "Xing " /*9276*/, "Hong " /*9277*/, "Jiao " /*9278*/, "Chi " /*9279*/, "Er " /*927a*/, "Ge " /*927b*/, "Bing " /*927c*/, "Shi " /*927d*/, "Mou " /*927e*/, "Jia " /*927f*/, "Yin " /*9280*/, "Jun " /*9281*/, "Zhou " /*9282*/, "Chong " /*9283*/, "Shang " /*9284*/, "Tong " /*9285*/, "Mo " /*9286*/, "Lei " /*9287*/, "Ji " /*9288*/, "Yu " /*9289*/, "Xu " /*928a*/, "Ren " /*928b*/, "Zun " /*928c*/, "Zhi " /*928d*/, "Qiong " /*928e*/, "Shan " /*928f*/, "Chi " /*9290*/, "Xian " /*9291*/, "Xing " /*9292*/, "Quan " /*9293*/, "Pi " /*9294*/, "Tie " /*9295*/, "Zhu " /*9296*/, "Hou " /*9297*/, "Ming " /*9298*/, "Kua " /*9299*/, "Yao " /*929a*/, "Xian " /*929b*/, "Xian " /*929c*/, "Xiu " /*929d*/, "Jun " /*929e*/, "Cha " /*929f*/, "Lao " /*92a0*/, "Ji " /*92a1*/, "Pi " /*92a2*/, "Ru " /*92a3*/, "Mi " /*92a4*/, "Yi " /*92a5*/, "Yin " /*92a6*/, "Guang " /*92a7*/, "An " /*92a8*/, "Diou " /*92a9*/, "You " /*92aa*/, "Se " /*92ab*/, "Kao " /*92ac*/, "Qian " /*92ad*/, "Luan " /*92ae*/, "Kasugai " /*92af*/, "Ai " /*92b0*/, "Diao " /*92b1*/, "Han " /*92b2*/, "Rui " /*92b3*/, "Shi " /*92b4*/, "Keng " /*92b5*/, "Qiu " /*92b6*/, "Xiao " /*92b7*/, "Zhe " /*92b8*/, "Xiu " /*92b9*/, "Zang " /*92ba*/, "Ti " /*92bb*/, "Cuo " /*92bc*/, "Gua " /*92bd*/, "Gong " /*92be*/, "Zhong " /*92bf*/, "Dou " /*92c0*/, "Lu " /*92c1*/, "Mei " /*92c2*/, "Lang " /*92c3*/, "Wan " /*92c4*/, "Xin " /*92c5*/, "Yun " /*92c6*/, "Bei " /*92c7*/, "Wu " /*92c8*/, "Su " /*92c9*/, "Yu " /*92ca*/, "Chan " /*92cb*/, "Ting " /*92cc*/, "Bo " /*92cd*/, "Han " /*92ce*/, "Jia " /*92cf*/, "Hong " /*92d0*/, "Cuan " /*92d1*/, "Feng " /*92d2*/, "Chan " /*92d3*/, "Wan " /*92d4*/, "Zhi " /*92d5*/, "Si " /*92d6*/, "Xuan " /*92d7*/, "Wu " /*92d8*/, "Wu " /*92d9*/, "Tiao " /*92da*/, "Gong " /*92db*/, "Zhuo " /*92dc*/, "Lue " /*92dd*/, "Xing " /*92de*/, "Qian " /*92df*/, "Shen " /*92e0*/, "Han " /*92e1*/, "Lue " /*92e2*/, "Xie " /*92e3*/, "Chu " /*92e4*/, "Zheng " /*92e5*/, "Ju " /*92e6*/, "Xian " /*92e7*/, "Tie " /*92e8*/, "Mang " /*92e9*/, "Pu " /*92ea*/, "Li " /*92eb*/, "Pan " /*92ec*/, "Rui " /*92ed*/, "Cheng " /*92ee*/, "Gao " /*92ef*/, "Li " /*92f0*/, "Te " /*92f1*/, "Pyeng " /*92f2*/, "Zhu " /*92f3*/, "[?] " /*92f4*/, "Tu " /*92f5*/, "Liu " /*92f6*/, "Zui " /*92f7*/, "Ju " /*92f8*/, "Chang " /*92f9*/, "Yuan " /*92fa*/, "Jian " /*92fb*/, "Gang " /*92fc*/, "Diao " /*92fd*/, "Tao " /*92fe*/, "Chang " /*92ff*/ 
			});
						characters.TryAdd(147 /*37632 93*/, new string[] {
				"Lun " /*9300*/, "Kua " /*9301*/, "Ling " /*9302*/, "Bei " /*9303*/, "Lu " /*9304*/, "Li " /*9305*/, "Qiang " /*9306*/, "Pou " /*9307*/, "Juan " /*9308*/, "Min " /*9309*/, "Zui " /*930a*/, "Peng " /*930b*/, "An " /*930c*/, "Pi " /*930d*/, "Xian " /*930e*/, "Ya " /*930f*/, "Zhui " /*9310*/, "Lei " /*9311*/, "A " /*9312*/, "Kong " /*9313*/, "Ta " /*9314*/, "Kun " /*9315*/, "Du " /*9316*/, "Wei " /*9317*/, "Chui " /*9318*/, "Zi " /*9319*/, "Zheng " /*931a*/, "Ben " /*931b*/, "Nie " /*931c*/, "Cong " /*931d*/, "Qun " /*931e*/, "Tan " /*931f*/, "Ding " /*9320*/, "Qi " /*9321*/, "Qian " /*9322*/, "Zhuo " /*9323*/, "Qi " /*9324*/, "Yu " /*9325*/, "Jin " /*9326*/, "Guan " /*9327*/, "Mao " /*9328*/, "Chang " /*9329*/, "Tian " /*932a*/, "Xi " /*932b*/, "Lian " /*932c*/, "Tao " /*932d*/, "Gu " /*932e*/, "Cuo " /*932f*/, "Shu " /*9330*/, "Zhen " /*9331*/, "Lu " /*9332*/, "Meng " /*9333*/, "Lu " /*9334*/, "Hua " /*9335*/, "Biao " /*9336*/, "Ga " /*9337*/, "Lai " /*9338*/, "Ken " /*9339*/, "Kazari " /*933a*/, "Bu " /*933b*/, "Nai " /*933c*/, "Wan " /*933d*/, "Zan " /*933e*/, "[?] " /*933f*/, "De " /*9340*/, "Xian " /*9341*/, "[?] " /*9342*/, "Huo " /*9343*/, "Liang " /*9344*/, "[?] " /*9345*/, "Men " /*9346*/, "Kai " /*9347*/, "Ying " /*9348*/, "Di " /*9349*/, "Lian " /*934a*/, "Guo " /*934b*/, "Xian " /*934c*/, "Du " /*934d*/, "Tu " /*934e*/, "Wei " /*934f*/, "Cong " /*9350*/, "Fu " /*9351*/, "Rou " /*9352*/, "Ji " /*9353*/, "E " /*9354*/, "Rou " /*9355*/, "Chen " /*9356*/, "Ti " /*9357*/, "Zha " /*9358*/, "Hong " /*9359*/, "Yang " /*935a*/, "Duan " /*935b*/, "Xia " /*935c*/, "Yu " /*935d*/, "Keng " /*935e*/, "Xing " /*935f*/, "Huang " /*9360*/, "Wei " /*9361*/, "Fu " /*9362*/, "Zhao " /*9363*/, "Cha " /*9364*/, "Qie " /*9365*/, "She " /*9366*/, "Hong " /*9367*/, "Kui " /*9368*/, "Tian " /*9369*/, "Mou " /*936a*/, "Qiao " /*936b*/, "Qiao " /*936c*/, "Hou " /*936d*/, "Tou " /*936e*/, "Cong " /*936f*/, "Huan " /*9370*/, "Ye " /*9371*/, "Min " /*9372*/, "Jian " /*9373*/, "Duan " /*9374*/, "Jian " /*9375*/, "Song " /*9376*/, "Kui " /*9377*/, "Hu " /*9378*/, "Xuan " /*9379*/, "Duo " /*937a*/, "Jie " /*937b*/, "Zhen " /*937c*/, "Bian " /*937d*/, "Zhong " /*937e*/, "Zi " /*937f*/, "Xiu " /*9380*/, "Ye " /*9381*/, "Mei " /*9382*/, "Pai " /*9383*/, "Ai " /*9384*/, "Jie " /*9385*/, "[?] " /*9386*/, "Mei " /*9387*/, "Chuo " /*9388*/, "Ta " /*9389*/, "Bang " /*938a*/, "Xia " /*938b*/, "Lian " /*938c*/, "Suo " /*938d*/, "Xi " /*938e*/, "Liu " /*938f*/, "Zu " /*9390*/, "Ye " /*9391*/, "Nou " /*9392*/, "Weng " /*9393*/, "Rong " /*9394*/, "Tang " /*9395*/, "Suo " /*9396*/, "Qiang " /*9397*/, "Ge " /*9398*/, "Shuo " /*9399*/, "Chui " /*939a*/, "Bo " /*939b*/, "Pan " /*939c*/, "Sa " /*939d*/, "Bi " /*939e*/, "Sang " /*939f*/, "Gang " /*93a0*/, "Zi " /*93a1*/, "Wu " /*93a2*/, "Ying " /*93a3*/, "Huang " /*93a4*/, "Tiao " /*93a5*/, "Liu " /*93a6*/, "Kai " /*93a7*/, "Sun " /*93a8*/, "Sha " /*93a9*/, "Sou " /*93aa*/, "Wan " /*93ab*/, "Hao " /*93ac*/, "Zhen " /*93ad*/, "Zhen " /*93ae*/, "Luo " /*93af*/, "Yi " /*93b0*/, "Yuan " /*93b1*/, "Tang " /*93b2*/, "Nie " /*93b3*/, "Xi " /*93b4*/, "Jia " /*93b5*/, "Ge " /*93b6*/, "Ma " /*93b7*/, "Juan " /*93b8*/, "Kasugai " /*93b9*/, "Habaki " /*93ba*/, "Suo " /*93bb*/, "[?] " /*93bc*/, "[?] " /*93bd*/, "[?] " /*93be*/, "Na " /*93bf*/, "Lu " /*93c0*/, "Suo " /*93c1*/, "Ou " /*93c2*/, "Zu " /*93c3*/, "Tuan " /*93c4*/, "Xiu " /*93c5*/, "Guan " /*93c6*/, "Xuan " /*93c7*/, "Lian " /*93c8*/, "Shou " /*93c9*/, "Ao " /*93ca*/, "Man " /*93cb*/, "Mo " /*93cc*/, "Luo " /*93cd*/, "Bi " /*93ce*/, "Wei " /*93cf*/, "Liu " /*93d0*/, "Di " /*93d1*/, "Qiao " /*93d2*/, "Cong " /*93d3*/, "Yi " /*93d4*/, "Lu " /*93d5*/, "Ao " /*93d6*/, "Keng " /*93d7*/, "Qiang " /*93d8*/, "Cui " /*93d9*/, "Qi " /*93da*/, "Chang " /*93db*/, "Tang " /*93dc*/, "Man " /*93dd*/, "Yong " /*93de*/, "Chan " /*93df*/, "Feng " /*93e0*/, "Jing " /*93e1*/, "Biao " /*93e2*/, "Shu " /*93e3*/, "Lou " /*93e4*/, "Xiu " /*93e5*/, "Cong " /*93e6*/, "Long " /*93e7*/, "Zan " /*93e8*/, "Jian " /*93e9*/, "Cao " /*93ea*/, "Li " /*93eb*/, "Xia " /*93ec*/, "Xi " /*93ed*/, "Kang " /*93ee*/, "[?] " /*93ef*/, "Beng " /*93f0*/, "[?] " /*93f1*/, "[?] " /*93f2*/, "Zheng " /*93f3*/, "Lu " /*93f4*/, "Hua " /*93f5*/, "Ji " /*93f6*/, "Pu " /*93f7*/, "Hui " /*93f8*/, "Qiang " /*93f9*/, "Po " /*93fa*/, "Lin " /*93fb*/, "Suo " /*93fc*/, "Xiu " /*93fd*/, "San " /*93fe*/, "Cheng " /*93ff*/ 
			});
						characters.TryAdd(148 /*37888 94*/, new string[] {
				"Kui " /*9400*/, "Si " /*9401*/, "Liu " /*9402*/, "Nao " /*9403*/, "Heng " /*9404*/, "Pie " /*9405*/, "Sui " /*9406*/, "Fan " /*9407*/, "Qiao " /*9408*/, "Quan " /*9409*/, "Yang " /*940a*/, "Tang " /*940b*/, "Xiang " /*940c*/, "Jue " /*940d*/, "Jiao " /*940e*/, "Zun " /*940f*/, "Liao " /*9410*/, "Jie " /*9411*/, "Lao " /*9412*/, "Dui " /*9413*/, "Tan " /*9414*/, "Zan " /*9415*/, "Ji " /*9416*/, "Jian " /*9417*/, "Zhong " /*9418*/, "Deng " /*9419*/, "Ya " /*941a*/, "Ying " /*941b*/, "Dui " /*941c*/, "Jue " /*941d*/, "Nou " /*941e*/, "Ti " /*941f*/, "Pu " /*9420*/, "Tie " /*9421*/, "[?] " /*9422*/, "[?] " /*9423*/, "Ding " /*9424*/, "Shan " /*9425*/, "Kai " /*9426*/, "Jian " /*9427*/, "Fei " /*9428*/, "Sui " /*9429*/, "Lu " /*942a*/, "Juan " /*942b*/, "Hui " /*942c*/, "Yu " /*942d*/, "Lian " /*942e*/, "Zhuo " /*942f*/, "Qiao " /*9430*/, "Qian " /*9431*/, "Zhuo " /*9432*/, "Lei " /*9433*/, "Bi " /*9434*/, "Tie " /*9435*/, "Huan " /*9436*/, "Ye " /*9437*/, "Duo " /*9438*/, "Guo " /*9439*/, "Dang " /*943a*/, "Ju " /*943b*/, "Fen " /*943c*/, "Da " /*943d*/, "Bei " /*943e*/, "Yi " /*943f*/, "Ai " /*9440*/, "Zong " /*9441*/, "Xun " /*9442*/, "Diao " /*9443*/, "Zhu " /*9444*/, "Heng " /*9445*/, "Zhui " /*9446*/, "Ji " /*9447*/, "Nie " /*9448*/, "Ta " /*9449*/, "Huo " /*944a*/, "Qing " /*944b*/, "Bin " /*944c*/, "Ying " /*944d*/, "Kui " /*944e*/, "Ning " /*944f*/, "Xu " /*9450*/, "Jian " /*9451*/, "Jian " /*9452*/, "Yari " /*9453*/, "Cha " /*9454*/, "Zhi " /*9455*/, "Mie " /*9456*/, "Li " /*9457*/, "Lei " /*9458*/, "Ji " /*9459*/, "Zuan " /*945a*/, "Kuang " /*945b*/, "Shang " /*945c*/, "Peng " /*945d*/, "La " /*945e*/, "Du " /*945f*/, "Shuo " /*9460*/, "Chuo " /*9461*/, "Lu " /*9462*/, "Biao " /*9463*/, "Bao " /*9464*/, "Lu " /*9465*/, "[?] " /*9466*/, "[?] " /*9467*/, "Long " /*9468*/, "E " /*9469*/, "Lu " /*946a*/, "Xin " /*946b*/, "Jian " /*946c*/, "Lan " /*946d*/, "Bo " /*946e*/, "Jian " /*946f*/, "Yao " /*9470*/, "Chan " /*9471*/, "Xiang " /*9472*/, "Jian " /*9473*/, "Xi " /*9474*/, "Guan " /*9475*/, "Cang " /*9476*/, "Nie " /*9477*/, "Lei " /*9478*/, "Cuan " /*9479*/, "Qu " /*947a*/, "Pan " /*947b*/, "Luo " /*947c*/, "Zuan " /*947d*/, "Luan " /*947e*/, "Zao " /*947f*/, "Nie " /*9480*/, "Jue " /*9481*/, "Tang " /*9482*/, "Shu " /*9483*/, "Lan " /*9484*/, "Jin " /*9485*/, "Qiu " /*9486*/, "Yi " /*9487*/, "Zhen " /*9488*/, "Ding " /*9489*/, "Zhao " /*948a*/, "Po " /*948b*/, "Diao " /*948c*/, "Tu " /*948d*/, "Qian " /*948e*/, "Chuan " /*948f*/, "Shan " /*9490*/, "Ji " /*9491*/, "Fan " /*9492*/, "Diao " /*9493*/, "Men " /*9494*/, "Nu " /*9495*/, "Xi " /*9496*/, "Chai " /*9497*/, "Xing " /*9498*/, "Gai " /*9499*/, "Bu " /*949a*/, "Tai " /*949b*/, "Ju " /*949c*/, "Dun " /*949d*/, "Chao " /*949e*/, "Zhong " /*949f*/, "Na " /*94a0*/, "Bei " /*94a1*/, "Gang " /*94a2*/, "Ban " /*94a3*/, "Qian " /*94a4*/, "Yao " /*94a5*/, "Qin " /*94a6*/, "Jun " /*94a7*/, "Wu " /*94a8*/, "Gou " /*94a9*/, "Kang " /*94aa*/, "Fang " /*94ab*/, "Huo " /*94ac*/, "Tou " /*94ad*/, "Niu " /*94ae*/, "Ba " /*94af*/, "Yu " /*94b0*/, "Qian " /*94b1*/, "Zheng " /*94b2*/, "Qian " /*94b3*/, "Gu " /*94b4*/, "Bo " /*94b5*/, "E " /*94b6*/, "Po " /*94b7*/, "Bu " /*94b8*/, "Ba " /*94b9*/, "Yue " /*94ba*/, "Zuan " /*94bb*/, "Mu " /*94bc*/, "Dan " /*94bd*/, "Jia " /*94be*/, "Dian " /*94bf*/, "You " /*94c0*/, "Tie " /*94c1*/, "Bo " /*94c2*/, "Ling " /*94c3*/, "Shuo " /*94c4*/, "Qian " /*94c5*/, "Liu " /*94c6*/, "Bao " /*94c7*/, "Shi " /*94c8*/, "Xuan " /*94c9*/, "She " /*94ca*/, "Bi " /*94cb*/, "Ni " /*94cc*/, "Pi " /*94cd*/, "Duo " /*94ce*/, "Xing " /*94cf*/, "Kao " /*94d0*/, "Lao " /*94d1*/, "Er " /*94d2*/, "Mang " /*94d3*/, "Ya " /*94d4*/, "You " /*94d5*/, "Cheng " /*94d6*/, "Jia " /*94d7*/, "Ye " /*94d8*/, "Nao " /*94d9*/, "Zhi " /*94da*/, "Dang " /*94db*/, "Tong " /*94dc*/, "Lu " /*94dd*/, "Diao " /*94de*/, "Yin " /*94df*/, "Kai " /*94e0*/, "Zha " /*94e1*/, "Zhu " /*94e2*/, "Xian " /*94e3*/, "Ting " /*94e4*/, "Diu " /*94e5*/, "Xian " /*94e6*/, "Hua " /*94e7*/, "Quan " /*94e8*/, "Sha " /*94e9*/, "Jia " /*94ea*/, "Yao " /*94eb*/, "Ge " /*94ec*/, "Ming " /*94ed*/, "Zheng " /*94ee*/, "Se " /*94ef*/, "Jiao " /*94f0*/, "Yi " /*94f1*/, "Chan " /*94f2*/, "Chong " /*94f3*/, "Tang " /*94f4*/, "An " /*94f5*/, "Yin " /*94f6*/, "Ru " /*94f7*/, "Zhu " /*94f8*/, "Lao " /*94f9*/, "Pu " /*94fa*/, "Wu " /*94fb*/, "Lai " /*94fc*/, "Te " /*94fd*/, "Lian " /*94fe*/, "Keng " /*94ff*/ 
			});
						characters.TryAdd(149 /*38144 95*/, new string[] {
				"Xiao " /*9500*/, "Suo " /*9501*/, "Li " /*9502*/, "Zheng " /*9503*/, "Chu " /*9504*/, "Guo " /*9505*/, "Gao " /*9506*/, "Tie " /*9507*/, "Xiu " /*9508*/, "Cuo " /*9509*/, "Lue " /*950a*/, "Feng " /*950b*/, "Xin " /*950c*/, "Liu " /*950d*/, "Kai " /*950e*/, "Jian " /*950f*/, "Rui " /*9510*/, "Ti " /*9511*/, "Lang " /*9512*/, "Qian " /*9513*/, "Ju " /*9514*/, "A " /*9515*/, "Qiang " /*9516*/, "Duo " /*9517*/, "Tian " /*9518*/, "Cuo " /*9519*/, "Mao " /*951a*/, "Ben " /*951b*/, "Qi " /*951c*/, "De " /*951d*/, "Kua " /*951e*/, "Kun " /*951f*/, "Chang " /*9520*/, "Xi " /*9521*/, "Gu " /*9522*/, "Luo " /*9523*/, "Chui " /*9524*/, "Zhui " /*9525*/, "Jin " /*9526*/, "Zhi " /*9527*/, "Xian " /*9528*/, "Juan " /*9529*/, "Huo " /*952a*/, "Pou " /*952b*/, "Tan " /*952c*/, "Ding " /*952d*/, "Jian " /*952e*/, "Ju " /*952f*/, "Meng " /*9530*/, "Zi " /*9531*/, "Qie " /*9532*/, "Ying " /*9533*/, "Kai " /*9534*/, "Qiang " /*9535*/, "Song " /*9536*/, "E " /*9537*/, "Cha " /*9538*/, "Qiao " /*9539*/, "Zhong " /*953a*/, "Duan " /*953b*/, "Sou " /*953c*/, "Huang " /*953d*/, "Huan " /*953e*/, "Ai " /*953f*/, "Du " /*9540*/, "Mei " /*9541*/, "Lou " /*9542*/, "Zi " /*9543*/, "Fei " /*9544*/, "Mei " /*9545*/, "Mo " /*9546*/, "Zhen " /*9547*/, "Bo " /*9548*/, "Ge " /*9549*/, "Nie " /*954a*/, "Tang " /*954b*/, "Juan " /*954c*/, "Nie " /*954d*/, "Na " /*954e*/, "Liu " /*954f*/, "Hao " /*9550*/, "Bang " /*9551*/, "Yi " /*9552*/, "Jia " /*9553*/, "Bin " /*9554*/, "Rong " /*9555*/, "Biao " /*9556*/, "Tang " /*9557*/, "Man " /*9558*/, "Luo " /*9559*/, "Beng " /*955a*/, "Yong " /*955b*/, "Jing " /*955c*/, "Di " /*955d*/, "Zu " /*955e*/, "Xuan " /*955f*/, "Liu " /*9560*/, "Tan " /*9561*/, "Jue " /*9562*/, "Liao " /*9563*/, "Pu " /*9564*/, "Lu " /*9565*/, "Dui " /*9566*/, "Lan " /*9567*/, "Pu " /*9568*/, "Cuan " /*9569*/, "Qiang " /*956a*/, "Deng " /*956b*/, "Huo " /*956c*/, "Lei " /*956d*/, "Huan " /*956e*/, "Zhuo " /*956f*/, "Lian " /*9570*/, "Yi " /*9571*/, "Cha " /*9572*/, "Biao " /*9573*/, "La " /*9574*/, "Chan " /*9575*/, "Xiang " /*9576*/, "Chang " /*9577*/, "Chang " /*9578*/, "Jiu " /*9579*/, "Ao " /*957a*/, "Die " /*957b*/, "Qu " /*957c*/, "Liao " /*957d*/, "Mi " /*957e*/, "Chang " /*957f*/, "Men " /*9580*/, "Ma " /*9581*/, "Shuan " /*9582*/, "Shan " /*9583*/, "Huo " /*9584*/, "Men " /*9585*/, "Yan " /*9586*/, "Bi " /*9587*/, "Han " /*9588*/, "Bi " /*9589*/, "San " /*958a*/, "Kai " /*958b*/, "Kang " /*958c*/, "Beng " /*958d*/, "Hong " /*958e*/, "Run " /*958f*/, "San " /*9590*/, "Xian " /*9591*/, "Xian " /*9592*/, "Jian " /*9593*/, "Min " /*9594*/, "Xia " /*9595*/, "Yuru " /*9596*/, "Dou " /*9597*/, "Zha " /*9598*/, "Nao " /*9599*/, "Jian " /*959a*/, "Peng " /*959b*/, "Xia " /*959c*/, "Ling " /*959d*/, "Bian " /*959e*/, "Bi " /*959f*/, "Run " /*95a0*/, "He " /*95a1*/, "Guan " /*95a2*/, "Ge " /*95a3*/, "Ge " /*95a4*/, "Fa " /*95a5*/, "Chu " /*95a6*/, "Hong " /*95a7*/, "Gui " /*95a8*/, "Min " /*95a9*/, "Se " /*95aa*/, "Kun " /*95ab*/, "Lang " /*95ac*/, "Lu " /*95ad*/, "Ting " /*95ae*/, "Sha " /*95af*/, "Ju " /*95b0*/, "Yue " /*95b1*/, "Yue " /*95b2*/, "Chan " /*95b3*/, "Qu " /*95b4*/, "Lin " /*95b5*/, "Chang " /*95b6*/, "Shai " /*95b7*/, "Kun " /*95b8*/, "Yan " /*95b9*/, "Min " /*95ba*/, "Yan " /*95bb*/, "E " /*95bc*/, "Hun " /*95bd*/, "Yu " /*95be*/, "Wen " /*95bf*/, "Xiang " /*95c0*/, "Bao " /*95c1*/, "Xiang " /*95c2*/, "Qu " /*95c3*/, "Yao " /*95c4*/, "Wen " /*95c5*/, "Ban " /*95c6*/, "An " /*95c7*/, "Wei " /*95c8*/, "Yin " /*95c9*/, "Kuo " /*95ca*/, "Que " /*95cb*/, "Lan " /*95cc*/, "Du " /*95cd*/, "[?] " /*95ce*/, "Phwung " /*95cf*/, "Tian " /*95d0*/, "Nie " /*95d1*/, "Ta " /*95d2*/, "Kai " /*95d3*/, "He " /*95d4*/, "Que " /*95d5*/, "Chuang " /*95d6*/, "Guan " /*95d7*/, "Dou " /*95d8*/, "Qi " /*95d9*/, "Kui " /*95da*/, "Tang " /*95db*/, "Guan " /*95dc*/, "Piao " /*95dd*/, "Kan " /*95de*/, "Xi " /*95df*/, "Hui " /*95e0*/, "Chan " /*95e1*/, "Pi " /*95e2*/, "Dang " /*95e3*/, "Huan " /*95e4*/, "Ta " /*95e5*/, "Wen " /*95e6*/, "[?] " /*95e7*/, "Men " /*95e8*/, "Shuan " /*95e9*/, "Shan " /*95ea*/, "Yan " /*95eb*/, "Han " /*95ec*/, "Bi " /*95ed*/, "Wen " /*95ee*/, "Chuang " /*95ef*/, "Run " /*95f0*/, "Wei " /*95f1*/, "Xian " /*95f2*/, "Hong " /*95f3*/, "Jian " /*95f4*/, "Min " /*95f5*/, "Kang " /*95f6*/, "Men " /*95f7*/, "Zha " /*95f8*/, "Nao " /*95f9*/, "Gui " /*95fa*/, "Wen " /*95fb*/, "Ta " /*95fc*/, "Min " /*95fd*/, "Lu " /*95fe*/, "Kai " /*95ff*/ 
			});
						characters.TryAdd(150 /*38400 96*/, new string[] {
				"Fa " /*9600*/, "Ge " /*9601*/, "He " /*9602*/, "Kun " /*9603*/, "Jiu " /*9604*/, "Yue " /*9605*/, "Lang " /*9606*/, "Du " /*9607*/, "Yu " /*9608*/, "Yan " /*9609*/, "Chang " /*960a*/, "Xi " /*960b*/, "Wen " /*960c*/, "Hun " /*960d*/, "Yan " /*960e*/, "E " /*960f*/, "Chan " /*9610*/, "Lan " /*9611*/, "Qu " /*9612*/, "Hui " /*9613*/, "Kuo " /*9614*/, "Que " /*9615*/, "Ge " /*9616*/, "Tian " /*9617*/, "Ta " /*9618*/, "Que " /*9619*/, "Kan " /*961a*/, "Huan " /*961b*/, "Fu " /*961c*/, "Fu " /*961d*/, "Le " /*961e*/, "Dui " /*961f*/, "Xin " /*9620*/, "Qian " /*9621*/, "Wu " /*9622*/, "Yi " /*9623*/, "Tuo " /*9624*/, "Yin " /*9625*/, "Yang " /*9626*/, "Dou " /*9627*/, "E " /*9628*/, "Sheng " /*9629*/, "Ban " /*962a*/, "Pei " /*962b*/, "Keng " /*962c*/, "Yun " /*962d*/, "Ruan " /*962e*/, "Zhi " /*962f*/, "Pi " /*9630*/, "Jing " /*9631*/, "Fang " /*9632*/, "Yang " /*9633*/, "Yin " /*9634*/, "Zhen " /*9635*/, "Jie " /*9636*/, "Cheng " /*9637*/, "E " /*9638*/, "Qu " /*9639*/, "Di " /*963a*/, "Zu " /*963b*/, "Zuo " /*963c*/, "Dian " /*963d*/, "Ling " /*963e*/, "A " /*963f*/, "Tuo " /*9640*/, "Tuo " /*9641*/, "Po " /*9642*/, "Bing " /*9643*/, "Fu " /*9644*/, "Ji " /*9645*/, "Lu " /*9646*/, "Long " /*9647*/, "Chen " /*9648*/, "Xing " /*9649*/, "Duo " /*964a*/, "Lou " /*964b*/, "Mo " /*964c*/, "Jiang " /*964d*/, "Shu " /*964e*/, "Duo " /*964f*/, "Xian " /*9650*/, "Er " /*9651*/, "Gui " /*9652*/, "Yu " /*9653*/, "Gai " /*9654*/, "Shan " /*9655*/, "Xun " /*9656*/, "Qiao " /*9657*/, "Xing " /*9658*/, "Chun " /*9659*/, "Fu " /*965a*/, "Bi " /*965b*/, "Xia " /*965c*/, "Shan " /*965d*/, "Sheng " /*965e*/, "Zhi " /*965f*/, "Pu " /*9660*/, "Dou " /*9661*/, "Yuan " /*9662*/, "Zhen " /*9663*/, "Chu " /*9664*/, "Xian " /*9665*/, "Tou " /*9666*/, "Nie " /*9667*/, "Yun " /*9668*/, "Xian " /*9669*/, "Pei " /*966a*/, "Pei " /*966b*/, "Zou " /*966c*/, "Yi " /*966d*/, "Dui " /*966e*/, "Lun " /*966f*/, "Yin " /*9670*/, "Ju " /*9671*/, "Chui " /*9672*/, "Chen " /*9673*/, "Pi " /*9674*/, "Ling " /*9675*/, "Tao " /*9676*/, "Xian " /*9677*/, "Lu " /*9678*/, "Sheng " /*9679*/, "Xian " /*967a*/, "Yin " /*967b*/, "Zhu " /*967c*/, "Yang " /*967d*/, "Reng " /*967e*/, "Shan " /*967f*/, "Chong " /*9680*/, "Yan " /*9681*/, "Yin " /*9682*/, "Yu " /*9683*/, "Ti " /*9684*/, "Yu " /*9685*/, "Long " /*9686*/, "Wei " /*9687*/, "Wei " /*9688*/, "Nie " /*9689*/, "Dui " /*968a*/, "Sui " /*968b*/, "An " /*968c*/, "Huang " /*968d*/, "Jie " /*968e*/, "Sui " /*968f*/, "Yin " /*9690*/, "Gai " /*9691*/, "Yan " /*9692*/, "Hui " /*9693*/, "Ge " /*9694*/, "Yun " /*9695*/, "Wu " /*9696*/, "Wei " /*9697*/, "Ai " /*9698*/, "Xi " /*9699*/, "Tang " /*969a*/, "Ji " /*969b*/, "Zhang " /*969c*/, "Dao " /*969d*/, "Ao " /*969e*/, "Xi " /*969f*/, "Yin " /*96a0*/, "[?] " /*96a1*/, "Rao " /*96a2*/, "Lin " /*96a3*/, "Tui " /*96a4*/, "Deng " /*96a5*/, "Pi " /*96a6*/, "Sui " /*96a7*/, "Sui " /*96a8*/, "Yu " /*96a9*/, "Xian " /*96aa*/, "Fen " /*96ab*/, "Ni " /*96ac*/, "Er " /*96ad*/, "Ji " /*96ae*/, "Dao " /*96af*/, "Xi " /*96b0*/, "Yin " /*96b1*/, "E " /*96b2*/, "Hui " /*96b3*/, "Long " /*96b4*/, "Xi " /*96b5*/, "Li " /*96b6*/, "Li " /*96b7*/, "Li " /*96b8*/, "Zhui " /*96b9*/, "He " /*96ba*/, "Zhi " /*96bb*/, "Zhun " /*96bc*/, "Jun " /*96bd*/, "Nan " /*96be*/, "Yi " /*96bf*/, "Que " /*96c0*/, "Yan " /*96c1*/, "Qian " /*96c2*/, "Ya " /*96c3*/, "Xiong " /*96c4*/, "Ya " /*96c5*/, "Ji " /*96c6*/, "Gu " /*96c7*/, "Huan " /*96c8*/, "Zhi " /*96c9*/, "Gou " /*96ca*/, "Jun " /*96cb*/, "Ci " /*96cc*/, "Yong " /*96cd*/, "Ju " /*96ce*/, "Chu " /*96cf*/, "Hu " /*96d0*/, "Za " /*96d1*/, "Luo " /*96d2*/, "Yu " /*96d3*/, "Chou " /*96d4*/, "Diao " /*96d5*/, "Sui " /*96d6*/, "Han " /*96d7*/, "Huo " /*96d8*/, "Shuang " /*96d9*/, "Guan " /*96da*/, "Chu " /*96db*/, "Za " /*96dc*/, "Yong " /*96dd*/, "Ji " /*96de*/, "Xi " /*96df*/, "Chou " /*96e0*/, "Liu " /*96e1*/, "Li " /*96e2*/, "Nan " /*96e3*/, "Xue " /*96e4*/, "Za " /*96e5*/, "Ji " /*96e6*/, "Ji " /*96e7*/, "Yu " /*96e8*/, "Yu " /*96e9*/, "Xue " /*96ea*/, "Na " /*96eb*/, "Fou " /*96ec*/, "Se " /*96ed*/, "Mu " /*96ee*/, "Wen " /*96ef*/, "Fen " /*96f0*/, "Pang " /*96f1*/, "Yun " /*96f2*/, "Li " /*96f3*/, "Li " /*96f4*/, "Ang " /*96f5*/, "Ling " /*96f6*/, "Lei " /*96f7*/, "An " /*96f8*/, "Bao " /*96f9*/, "Meng " /*96fa*/, "Dian " /*96fb*/, "Dang " /*96fc*/, "Xing " /*96fd*/, "Wu " /*96fe*/, "Zhao " /*96ff*/ 
			});
						characters.TryAdd(151 /*38656 97*/, new string[] {
				"Xu " /*9700*/, "Ji " /*9701*/, "Mu " /*9702*/, "Chen " /*9703*/, "Xiao " /*9704*/, "Zha " /*9705*/, "Ting " /*9706*/, "Zhen " /*9707*/, "Pei " /*9708*/, "Mei " /*9709*/, "Ling " /*970a*/, "Qi " /*970b*/, "Chou " /*970c*/, "Huo " /*970d*/, "Sha " /*970e*/, "Fei " /*970f*/, "Weng " /*9710*/, "Zhan " /*9711*/, "Yin " /*9712*/, "Ni " /*9713*/, "Chou " /*9714*/, "Tun " /*9715*/, "Lin " /*9716*/, "[?] " /*9717*/, "Dong " /*9718*/, "Ying " /*9719*/, "Wu " /*971a*/, "Ling " /*971b*/, "Shuang " /*971c*/, "Ling " /*971d*/, "Xia " /*971e*/, "Hong " /*971f*/, "Yin " /*9720*/, "Mo " /*9721*/, "Mai " /*9722*/, "Yun " /*9723*/, "Liu " /*9724*/, "Meng " /*9725*/, "Bin " /*9726*/, "Wu " /*9727*/, "Wei " /*9728*/, "Huo " /*9729*/, "Yin " /*972a*/, "Xi " /*972b*/, "Yi " /*972c*/, "Ai " /*972d*/, "Dan " /*972e*/, "Deng " /*972f*/, "Xian " /*9730*/, "Yu " /*9731*/, "Lu " /*9732*/, "Long " /*9733*/, "Dai " /*9734*/, "Ji " /*9735*/, "Pang " /*9736*/, "Yang " /*9737*/, "Ba " /*9738*/, "Pi " /*9739*/, "Wei " /*973a*/, "[?] " /*973b*/, "Xi " /*973c*/, "Ji " /*973d*/, "Mai " /*973e*/, "Meng " /*973f*/, "Meng " /*9740*/, "Lei " /*9741*/, "Li " /*9742*/, "Huo " /*9743*/, "Ai " /*9744*/, "Fei " /*9745*/, "Dai " /*9746*/, "Long " /*9747*/, "Ling " /*9748*/, "Ai " /*9749*/, "Feng " /*974a*/, "Li " /*974b*/, "Bao " /*974c*/, "[?] " /*974d*/, "He " /*974e*/, "He " /*974f*/, "Bing " /*9750*/, "Qing " /*9751*/, "Qing " /*9752*/, "Jing " /*9753*/, "Tian " /*9754*/, "Zhen " /*9755*/, "Jing " /*9756*/, "Cheng " /*9757*/, "Qing " /*9758*/, "Jing " /*9759*/, "Jing " /*975a*/, "Dian " /*975b*/, "Jing " /*975c*/, "Tian " /*975d*/, "Fei " /*975e*/, "Fei " /*975f*/, "Kao " /*9760*/, "Mi " /*9761*/, "Mian " /*9762*/, "Mian " /*9763*/, "Pao " /*9764*/, "Ye " /*9765*/, "Tian " /*9766*/, "Hui " /*9767*/, "Ye " /*9768*/, "Ge " /*9769*/, "Ding " /*976a*/, "Cha " /*976b*/, "Jian " /*976c*/, "Ren " /*976d*/, "Di " /*976e*/, "Du " /*976f*/, "Wu " /*9770*/, "Ren " /*9771*/, "Qin " /*9772*/, "Jin " /*9773*/, "Xue " /*9774*/, "Niu " /*9775*/, "Ba " /*9776*/, "Yin " /*9777*/, "Sa " /*9778*/, "Na " /*9779*/, "Mo " /*977a*/, "Zu " /*977b*/, "Da " /*977c*/, "Ban " /*977d*/, "Yi " /*977e*/, "Yao " /*977f*/, "Tao " /*9780*/, "Tuo " /*9781*/, "Jia " /*9782*/, "Hong " /*9783*/, "Pao " /*9784*/, "Yang " /*9785*/, "Tomo " /*9786*/, "Yin " /*9787*/, "Jia " /*9788*/, "Tao " /*9789*/, "Ji " /*978a*/, "Xie " /*978b*/, "An " /*978c*/, "An " /*978d*/, "Hen " /*978e*/, "Gong " /*978f*/, "Kohaze " /*9790*/, "Da " /*9791*/, "Qiao " /*9792*/, "Ting " /*9793*/, "Wan " /*9794*/, "Ying " /*9795*/, "Sui " /*9796*/, "Tiao " /*9797*/, "Qiao " /*9798*/, "Xuan " /*9799*/, "Kong " /*979a*/, "Beng " /*979b*/, "Ta " /*979c*/, "Zhang " /*979d*/, "Bing " /*979e*/, "Kuo " /*979f*/, "Ju " /*97a0*/, "La " /*97a1*/, "Xie " /*97a2*/, "Rou " /*97a3*/, "Bang " /*97a4*/, "Yi " /*97a5*/, "Qiu " /*97a6*/, "Qiu " /*97a7*/, "He " /*97a8*/, "Xiao " /*97a9*/, "Mu " /*97aa*/, "Ju " /*97ab*/, "Jian " /*97ac*/, "Bian " /*97ad*/, "Di " /*97ae*/, "Jian " /*97af*/, "On " /*97b0*/, "Tao " /*97b1*/, "Gou " /*97b2*/, "Ta " /*97b3*/, "Bei " /*97b4*/, "Xie " /*97b5*/, "Pan " /*97b6*/, "Ge " /*97b7*/, "Bi " /*97b8*/, "Kuo " /*97b9*/, "Tang " /*97ba*/, "Lou " /*97bb*/, "Gui " /*97bc*/, "Qiao " /*97bd*/, "Xue " /*97be*/, "Ji " /*97bf*/, "Jian " /*97c0*/, "Jiang " /*97c1*/, "Chan " /*97c2*/, "Da " /*97c3*/, "Huo " /*97c4*/, "Xian " /*97c5*/, "Qian " /*97c6*/, "Du " /*97c7*/, "Wa " /*97c8*/, "Jian " /*97c9*/, "Lan " /*97ca*/, "Wei " /*97cb*/, "Ren " /*97cc*/, "Fu " /*97cd*/, "Mei " /*97ce*/, "Juan " /*97cf*/, "Ge " /*97d0*/, "Wei " /*97d1*/, "Qiao " /*97d2*/, "Han " /*97d3*/, "Chang " /*97d4*/, "[?] " /*97d5*/, "Rou " /*97d6*/, "Xun " /*97d7*/, "She " /*97d8*/, "Wei " /*97d9*/, "Ge " /*97da*/, "Bei " /*97db*/, "Tao " /*97dc*/, "Gou " /*97dd*/, "Yun " /*97de*/, "[?] " /*97df*/, "Bi " /*97e0*/, "Wei " /*97e1*/, "Hui " /*97e2*/, "Du " /*97e3*/, "Wa " /*97e4*/, "Du " /*97e5*/, "Wei " /*97e6*/, "Ren " /*97e7*/, "Fu " /*97e8*/, "Han " /*97e9*/, "Wei " /*97ea*/, "Yun " /*97eb*/, "Tao " /*97ec*/, "Jiu " /*97ed*/, "Jiu " /*97ee*/, "Xian " /*97ef*/, "Xie " /*97f0*/, "Xian " /*97f1*/, "Ji " /*97f2*/, "Yin " /*97f3*/, "Za " /*97f4*/, "Yun " /*97f5*/, "Shao " /*97f6*/, "Le " /*97f7*/, "Peng " /*97f8*/, "Heng " /*97f9*/, "Ying " /*97fa*/, "Yun " /*97fb*/, "Peng " /*97fc*/, "Yin " /*97fd*/, "Yin " /*97fe*/, "Xiang " /*97ff*/ 
			});
						characters.TryAdd(152 /*38912 98*/, new string[] {
				"Hu " /*9800*/, "Ye " /*9801*/, "Ding " /*9802*/, "Qing " /*9803*/, "Pan " /*9804*/, "Xiang " /*9805*/, "Shun " /*9806*/, "Han " /*9807*/, "Xu " /*9808*/, "Yi " /*9809*/, "Xu " /*980a*/, "Gu " /*980b*/, "Song " /*980c*/, "Kui " /*980d*/, "Qi " /*980e*/, "Hang " /*980f*/, "Yu " /*9810*/, "Wan " /*9811*/, "Ban " /*9812*/, "Dun " /*9813*/, "Di " /*9814*/, "Dan " /*9815*/, "Pan " /*9816*/, "Po " /*9817*/, "Ling " /*9818*/, "Ce " /*9819*/, "Jing " /*981a*/, "Lei " /*981b*/, "He " /*981c*/, "Qiao " /*981d*/, "E " /*981e*/, "E " /*981f*/, "Wei " /*9820*/, "Jie " /*9821*/, "Gua " /*9822*/, "Shen " /*9823*/, "Yi " /*9824*/, "Shen " /*9825*/, "Hai " /*9826*/, "Dui " /*9827*/, "Pian " /*9828*/, "Ping " /*9829*/, "Lei " /*982a*/, "Fu " /*982b*/, "Jia " /*982c*/, "Tou " /*982d*/, "Hui " /*982e*/, "Kui " /*982f*/, "Jia " /*9830*/, "Le " /*9831*/, "Tian " /*9832*/, "Cheng " /*9833*/, "Ying " /*9834*/, "Jun " /*9835*/, "Hu " /*9836*/, "Han " /*9837*/, "Jing " /*9838*/, "Tui " /*9839*/, "Tui " /*983a*/, "Pin " /*983b*/, "Lai " /*983c*/, "Tui " /*983d*/, "Zi " /*983e*/, "Zi " /*983f*/, "Chui " /*9840*/, "Ding " /*9841*/, "Lai " /*9842*/, "Yan " /*9843*/, "Han " /*9844*/, "Jian " /*9845*/, "Ke " /*9846*/, "Cui " /*9847*/, "Jiong " /*9848*/, "Qin " /*9849*/, "Yi " /*984a*/, "Sai " /*984b*/, "Ti " /*984c*/, "E " /*984d*/, "E " /*984e*/, "Yan " /*984f*/, "Hun " /*9850*/, "Kan " /*9851*/, "Yong " /*9852*/, "Zhuan " /*9853*/, "Yan " /*9854*/, "Xian " /*9855*/, "Xin " /*9856*/, "Yi " /*9857*/, "Yuan " /*9858*/, "Sang " /*9859*/, "Dian " /*985a*/, "Dian " /*985b*/, "Jiang " /*985c*/, "Ku " /*985d*/, "Lei " /*985e*/, "Liao " /*985f*/, "Piao " /*9860*/, "Yi " /*9861*/, "Man " /*9862*/, "Qi " /*9863*/, "Rao " /*9864*/, "Hao " /*9865*/, "Qiao " /*9866*/, "Gu " /*9867*/, "Xun " /*9868*/, "Qian " /*9869*/, "Hui " /*986a*/, "Zhan " /*986b*/, "Ru " /*986c*/, "Hong " /*986d*/, "Bin " /*986e*/, "Xian " /*986f*/, "Pin " /*9870*/, "Lu " /*9871*/, "Lan " /*9872*/, "Nie " /*9873*/, "Quan " /*9874*/, "Ye " /*9875*/, "Ding " /*9876*/, "Qing " /*9877*/, "Han " /*9878*/, "Xiang " /*9879*/, "Shun " /*987a*/, "Xu " /*987b*/, "Xu " /*987c*/, "Wan " /*987d*/, "Gu " /*987e*/, "Dun " /*987f*/, "Qi " /*9880*/, "Ban " /*9881*/, "Song " /*9882*/, "Hang " /*9883*/, "Yu " /*9884*/, "Lu " /*9885*/, "Ling " /*9886*/, "Po " /*9887*/, "Jing " /*9888*/, "Jie " /*9889*/, "Jia " /*988a*/, "Tian " /*988b*/, "Han " /*988c*/, "Ying " /*988d*/, "Jiong " /*988e*/, "Hai " /*988f*/, "Yi " /*9890*/, "Pin " /*9891*/, "Hui " /*9892*/, "Tui " /*9893*/, "Han " /*9894*/, "Ying " /*9895*/, "Ying " /*9896*/, "Ke " /*9897*/, "Ti " /*9898*/, "Yong " /*9899*/, "E " /*989a*/, "Zhuan " /*989b*/, "Yan " /*989c*/, "E " /*989d*/, "Nie " /*989e*/, "Man " /*989f*/, "Dian " /*98a0*/, "Sang " /*98a1*/, "Hao " /*98a2*/, "Lei " /*98a3*/, "Zhan " /*98a4*/, "Ru " /*98a5*/, "Pin " /*98a6*/, "Quan " /*98a7*/, "Feng " /*98a8*/, "Biao " /*98a9*/, "Oroshi " /*98aa*/, "Fu " /*98ab*/, "Xia " /*98ac*/, "Zhan " /*98ad*/, "Biao " /*98ae*/, "Sa " /*98af*/, "Ba " /*98b0*/, "Tai " /*98b1*/, "Lie " /*98b2*/, "Gua " /*98b3*/, "Xuan " /*98b4*/, "Shao " /*98b5*/, "Ju " /*98b6*/, "Bi " /*98b7*/, "Si " /*98b8*/, "Wei " /*98b9*/, "Yang " /*98ba*/, "Yao " /*98bb*/, "Sou " /*98bc*/, "Kai " /*98bd*/, "Sao " /*98be*/, "Fan " /*98bf*/, "Liu " /*98c0*/, "Xi " /*98c1*/, "Liao " /*98c2*/, "Piao " /*98c3*/, "Piao " /*98c4*/, "Liu " /*98c5*/, "Biao " /*98c6*/, "Biao " /*98c7*/, "Biao " /*98c8*/, "Liao " /*98c9*/, "[?] " /*98ca*/, "Se " /*98cb*/, "Feng " /*98cc*/, "Biao " /*98cd*/, "Feng " /*98ce*/, "Yang " /*98cf*/, "Zhan " /*98d0*/, "Biao " /*98d1*/, "Sa " /*98d2*/, "Ju " /*98d3*/, "Si " /*98d4*/, "Sou " /*98d5*/, "Yao " /*98d6*/, "Liu " /*98d7*/, "Piao " /*98d8*/, "Biao " /*98d9*/, "Biao " /*98da*/, "Fei " /*98db*/, "Fan " /*98dc*/, "Fei " /*98dd*/, "Fei " /*98de*/, "Shi " /*98df*/, "Shi " /*98e0*/, "Can " /*98e1*/, "Ji " /*98e2*/, "Ding " /*98e3*/, "Si " /*98e4*/, "Tuo " /*98e5*/, "Zhan " /*98e6*/, "Sun " /*98e7*/, "Xiang " /*98e8*/, "Tun " /*98e9*/, "Ren " /*98ea*/, "Yu " /*98eb*/, "Juan " /*98ec*/, "Chi " /*98ed*/, "Yin " /*98ee*/, "Fan " /*98ef*/, "Fan " /*98f0*/, "Sun " /*98f1*/, "Yin " /*98f2*/, "Zhu " /*98f3*/, "Yi " /*98f4*/, "Zhai " /*98f5*/, "Bi " /*98f6*/, "Jie " /*98f7*/, "Tao " /*98f8*/, "Liu " /*98f9*/, "Ci " /*98fa*/, "Tie " /*98fb*/, "Si " /*98fc*/, "Bao " /*98fd*/, "Shi " /*98fe*/, "Duo " /*98ff*/ 
			});
						characters.TryAdd(153 /*39168 99*/, new string[] {
				"Hai " /*9900*/, "Ren " /*9901*/, "Tian " /*9902*/, "Jiao " /*9903*/, "Jia " /*9904*/, "Bing " /*9905*/, "Yao " /*9906*/, "Tong " /*9907*/, "Ci " /*9908*/, "Xiang " /*9909*/, "Yang " /*990a*/, "Yang " /*990b*/, "Er " /*990c*/, "Yan " /*990d*/, "Le " /*990e*/, "Yi " /*990f*/, "Can " /*9910*/, "Bo " /*9911*/, "Nei " /*9912*/, "E " /*9913*/, "Bu " /*9914*/, "Jun " /*9915*/, "Dou " /*9916*/, "Su " /*9917*/, "Yu " /*9918*/, "Shi " /*9919*/, "Yao " /*991a*/, "Hun " /*991b*/, "Guo " /*991c*/, "Shi " /*991d*/, "Jian " /*991e*/, "Zhui " /*991f*/, "Bing " /*9920*/, "Xian " /*9921*/, "Bu " /*9922*/, "Ye " /*9923*/, "Tan " /*9924*/, "Fei " /*9925*/, "Zhang " /*9926*/, "Wei " /*9927*/, "Guan " /*9928*/, "E " /*9929*/, "Nuan " /*992a*/, "Hun " /*992b*/, "Hu " /*992c*/, "Huang " /*992d*/, "Tie " /*992e*/, "Hui " /*992f*/, "Jian " /*9930*/, "Hou " /*9931*/, "He " /*9932*/, "Xing " /*9933*/, "Fen " /*9934*/, "Wei " /*9935*/, "Gu " /*9936*/, "Cha " /*9937*/, "Song " /*9938*/, "Tang " /*9939*/, "Bo " /*993a*/, "Gao " /*993b*/, "Xi " /*993c*/, "Kui " /*993d*/, "Liu " /*993e*/, "Sou " /*993f*/, "Tao " /*9940*/, "Ye " /*9941*/, "Yun " /*9942*/, "Mo " /*9943*/, "Tang " /*9944*/, "Man " /*9945*/, "Bi " /*9946*/, "Yu " /*9947*/, "Xiu " /*9948*/, "Jin " /*9949*/, "San " /*994a*/, "Kui " /*994b*/, "Zhuan " /*994c*/, "Shan " /*994d*/, "Chi " /*994e*/, "Dan " /*994f*/, "Yi " /*9950*/, "Ji " /*9951*/, "Rao " /*9952*/, "Cheng " /*9953*/, "Yong " /*9954*/, "Tao " /*9955*/, "Hui " /*9956*/, "Xiang " /*9957*/, "Zhan " /*9958*/, "Fen " /*9959*/, "Hai " /*995a*/, "Meng " /*995b*/, "Yan " /*995c*/, "Mo " /*995d*/, "Chan " /*995e*/, "Xiang " /*995f*/, "Luo " /*9960*/, "Zuan " /*9961*/, "Nang " /*9962*/, "Shi " /*9963*/, "Ding " /*9964*/, "Ji " /*9965*/, "Tuo " /*9966*/, "Xing " /*9967*/, "Tun " /*9968*/, "Xi " /*9969*/, "Ren " /*996a*/, "Yu " /*996b*/, "Chi " /*996c*/, "Fan " /*996d*/, "Yin " /*996e*/, "Jian " /*996f*/, "Shi " /*9970*/, "Bao " /*9971*/, "Si " /*9972*/, "Duo " /*9973*/, "Yi " /*9974*/, "Er " /*9975*/, "Rao " /*9976*/, "Xiang " /*9977*/, "Jia " /*9978*/, "Le " /*9979*/, "Jiao " /*997a*/, "Yi " /*997b*/, "Bing " /*997c*/, "Bo " /*997d*/, "Dou " /*997e*/, "E " /*997f*/, "Yu " /*9980*/, "Nei " /*9981*/, "Jun " /*9982*/, "Guo " /*9983*/, "Hun " /*9984*/, "Xian " /*9985*/, "Guan " /*9986*/, "Cha " /*9987*/, "Kui " /*9988*/, "Gu " /*9989*/, "Sou " /*998a*/, "Chan " /*998b*/, "Ye " /*998c*/, "Mo " /*998d*/, "Bo " /*998e*/, "Liu " /*998f*/, "Xiu " /*9990*/, "Jin " /*9991*/, "Man " /*9992*/, "San " /*9993*/, "Zhuan " /*9994*/, "Nang " /*9995*/, "Shou " /*9996*/, "Kui " /*9997*/, "Guo " /*9998*/, "Xiang " /*9999*/, "Fen " /*999a*/, "Ba " /*999b*/, "Ni " /*999c*/, "Bi " /*999d*/, "Bo " /*999e*/, "Tu " /*999f*/, "Han " /*99a0*/, "Fei " /*99a1*/, "Jian " /*99a2*/, "An " /*99a3*/, "Ai " /*99a4*/, "Fu " /*99a5*/, "Xian " /*99a6*/, "Wen " /*99a7*/, "Xin " /*99a8*/, "Fen " /*99a9*/, "Bin " /*99aa*/, "Xing " /*99ab*/, "Ma " /*99ac*/, "Yu " /*99ad*/, "Feng " /*99ae*/, "Han " /*99af*/, "Di " /*99b0*/, "Tuo " /*99b1*/, "Tuo " /*99b2*/, "Chi " /*99b3*/, "Xun " /*99b4*/, "Zhu " /*99b5*/, "Zhi " /*99b6*/, "Pei " /*99b7*/, "Xin " /*99b8*/, "Ri " /*99b9*/, "Sa " /*99ba*/, "Yin " /*99bb*/, "Wen " /*99bc*/, "Zhi " /*99bd*/, "Dan " /*99be*/, "Lu " /*99bf*/, "You " /*99c0*/, "Bo " /*99c1*/, "Bao " /*99c2*/, "Kuai " /*99c3*/, "Tuo " /*99c4*/, "Yi " /*99c5*/, "Qu " /*99c6*/, "[?] " /*99c7*/, "Qu " /*99c8*/, "Jiong " /*99c9*/, "Bo " /*99ca*/, "Zhao " /*99cb*/, "Yuan " /*99cc*/, "Peng " /*99cd*/, "Zhou " /*99ce*/, "Ju " /*99cf*/, "Zhu " /*99d0*/, "Nu " /*99d1*/, "Ju " /*99d2*/, "Pi " /*99d3*/, "Zang " /*99d4*/, "Jia " /*99d5*/, "Ling " /*99d6*/, "Zhen " /*99d7*/, "Tai " /*99d8*/, "Fu " /*99d9*/, "Yang " /*99da*/, "Shi " /*99db*/, "Bi " /*99dc*/, "Tuo " /*99dd*/, "Tuo " /*99de*/, "Si " /*99df*/, "Liu " /*99e0*/, "Ma " /*99e1*/, "Pian " /*99e2*/, "Tao " /*99e3*/, "Zhi " /*99e4*/, "Rong " /*99e5*/, "Teng " /*99e6*/, "Dong " /*99e7*/, "Xun " /*99e8*/, "Quan " /*99e9*/, "Shen " /*99ea*/, "Jiong " /*99eb*/, "Er " /*99ec*/, "Hai " /*99ed*/, "Bo " /*99ee*/, "Zhu " /*99ef*/, "Yin " /*99f0*/, "Luo " /*99f1*/, "Shuu " /*99f2*/, "Dan " /*99f3*/, "Xie " /*99f4*/, "Liu " /*99f5*/, "Ju " /*99f6*/, "Song " /*99f7*/, "Qin " /*99f8*/, "Mang " /*99f9*/, "Liang " /*99fa*/, "Han " /*99fb*/, "Tu " /*99fc*/, "Xuan " /*99fd*/, "Tui " /*99fe*/, "Jun " /*99ff*/ 
			});
						characters.TryAdd(154 /*39424 9a*/, new string[] {
				"E " /*9a00*/, "Cheng " /*9a01*/, "Xin " /*9a02*/, "Ai " /*9a03*/, "Lu " /*9a04*/, "Zhui " /*9a05*/, "Zhou " /*9a06*/, "She " /*9a07*/, "Pian " /*9a08*/, "Kun " /*9a09*/, "Tao " /*9a0a*/, "Lai " /*9a0b*/, "Zong " /*9a0c*/, "Ke " /*9a0d*/, "Qi " /*9a0e*/, "Qi " /*9a0f*/, "Yan " /*9a10*/, "Fei " /*9a11*/, "Sao " /*9a12*/, "Yan " /*9a13*/, "Jie " /*9a14*/, "Yao " /*9a15*/, "Wu " /*9a16*/, "Pian " /*9a17*/, "Cong " /*9a18*/, "Pian " /*9a19*/, "Qian " /*9a1a*/, "Fei " /*9a1b*/, "Huang " /*9a1c*/, "Jian " /*9a1d*/, "Huo " /*9a1e*/, "Yu " /*9a1f*/, "Ti " /*9a20*/, "Quan " /*9a21*/, "Xia " /*9a22*/, "Zong " /*9a23*/, "Kui " /*9a24*/, "Rou " /*9a25*/, "Si " /*9a26*/, "Gua " /*9a27*/, "Tuo " /*9a28*/, "Kui " /*9a29*/, "Sou " /*9a2a*/, "Qian " /*9a2b*/, "Cheng " /*9a2c*/, "Zhi " /*9a2d*/, "Liu " /*9a2e*/, "Pang " /*9a2f*/, "Teng " /*9a30*/, "Xi " /*9a31*/, "Cao " /*9a32*/, "Du " /*9a33*/, "Yan " /*9a34*/, "Yuan " /*9a35*/, "Zou " /*9a36*/, "Sao " /*9a37*/, "Shan " /*9a38*/, "Li " /*9a39*/, "Zhi " /*9a3a*/, "Shuang " /*9a3b*/, "Lu " /*9a3c*/, "Xi " /*9a3d*/, "Luo " /*9a3e*/, "Zhang " /*9a3f*/, "Mo " /*9a40*/, "Ao " /*9a41*/, "Can " /*9a42*/, "Piao " /*9a43*/, "Cong " /*9a44*/, "Qu " /*9a45*/, "Bi " /*9a46*/, "Zhi " /*9a47*/, "Yu " /*9a48*/, "Xu " /*9a49*/, "Hua " /*9a4a*/, "Bo " /*9a4b*/, "Su " /*9a4c*/, "Xiao " /*9a4d*/, "Lin " /*9a4e*/, "Chan " /*9a4f*/, "Dun " /*9a50*/, "Liu " /*9a51*/, "Tuo " /*9a52*/, "Zeng " /*9a53*/, "Tan " /*9a54*/, "Jiao " /*9a55*/, "Tie " /*9a56*/, "Yan " /*9a57*/, "Luo " /*9a58*/, "Zhan " /*9a59*/, "Jing " /*9a5a*/, "Yi " /*9a5b*/, "Ye " /*9a5c*/, "Tuo " /*9a5d*/, "Bin " /*9a5e*/, "Zou " /*9a5f*/, "Yan " /*9a60*/, "Peng " /*9a61*/, "Lu " /*9a62*/, "Teng " /*9a63*/, "Xiang " /*9a64*/, "Ji " /*9a65*/, "Shuang " /*9a66*/, "Ju " /*9a67*/, "Xi " /*9a68*/, "Huan " /*9a69*/, "Li " /*9a6a*/, "Biao " /*9a6b*/, "Ma " /*9a6c*/, "Yu " /*9a6d*/, "Tuo " /*9a6e*/, "Xun " /*9a6f*/, "Chi " /*9a70*/, "Qu " /*9a71*/, "Ri " /*9a72*/, "Bo " /*9a73*/, "Lu " /*9a74*/, "Zang " /*9a75*/, "Shi " /*9a76*/, "Si " /*9a77*/, "Fu " /*9a78*/, "Ju " /*9a79*/, "Zou " /*9a7a*/, "Zhu " /*9a7b*/, "Tuo " /*9a7c*/, "Nu " /*9a7d*/, "Jia " /*9a7e*/, "Yi " /*9a7f*/, "Tai " /*9a80*/, "Xiao " /*9a81*/, "Ma " /*9a82*/, "Yin " /*9a83*/, "Jiao " /*9a84*/, "Hua " /*9a85*/, "Luo " /*9a86*/, "Hai " /*9a87*/, "Pian " /*9a88*/, "Biao " /*9a89*/, "Li " /*9a8a*/, "Cheng " /*9a8b*/, "Yan " /*9a8c*/, "Xin " /*9a8d*/, "Qin " /*9a8e*/, "Jun " /*9a8f*/, "Qi " /*9a90*/, "Qi " /*9a91*/, "Ke " /*9a92*/, "Zhui " /*9a93*/, "Zong " /*9a94*/, "Su " /*9a95*/, "Can " /*9a96*/, "Pian " /*9a97*/, "Zhi " /*9a98*/, "Kui " /*9a99*/, "Sao " /*9a9a*/, "Wu " /*9a9b*/, "Ao " /*9a9c*/, "Liu " /*9a9d*/, "Qian " /*9a9e*/, "Shan " /*9a9f*/, "Piao " /*9aa0*/, "Luo " /*9aa1*/, "Cong " /*9aa2*/, "Chan " /*9aa3*/, "Zou " /*9aa4*/, "Ji " /*9aa5*/, "Shuang " /*9aa6*/, "Xiang " /*9aa7*/, "Gu " /*9aa8*/, "Wei " /*9aa9*/, "Wei " /*9aaa*/, "Wei " /*9aab*/, "Yu " /*9aac*/, "Gan " /*9aad*/, "Yi " /*9aae*/, "Ang " /*9aaf*/, "Tou " /*9ab0*/, "Xie " /*9ab1*/, "Bao " /*9ab2*/, "Bi " /*9ab3*/, "Chi " /*9ab4*/, "Ti " /*9ab5*/, "Di " /*9ab6*/, "Ku " /*9ab7*/, "Hai " /*9ab8*/, "Qiao " /*9ab9*/, "Gou " /*9aba*/, "Kua " /*9abb*/, "Ge " /*9abc*/, "Tui " /*9abd*/, "Geng " /*9abe*/, "Pian " /*9abf*/, "Bi " /*9ac0*/, "Ke " /*9ac1*/, "Ka " /*9ac2*/, "Yu " /*9ac3*/, "Sui " /*9ac4*/, "Lou " /*9ac5*/, "Bo " /*9ac6*/, "Xiao " /*9ac7*/, "Pang " /*9ac8*/, "Bo " /*9ac9*/, "Ci " /*9aca*/, "Kuan " /*9acb*/, "Bin " /*9acc*/, "Mo " /*9acd*/, "Liao " /*9ace*/, "Lou " /*9acf*/, "Nao " /*9ad0*/, "Du " /*9ad1*/, "Zang " /*9ad2*/, "Sui " /*9ad3*/, "Ti " /*9ad4*/, "Bin " /*9ad5*/, "Kuan " /*9ad6*/, "Lu " /*9ad7*/, "Gao " /*9ad8*/, "Gao " /*9ad9*/, "Qiao " /*9ada*/, "Kao " /*9adb*/, "Qiao " /*9adc*/, "Lao " /*9add*/, "Zao " /*9ade*/, "Biao " /*9adf*/, "Kun " /*9ae0*/, "Kun " /*9ae1*/, "Ti " /*9ae2*/, "Fang " /*9ae3*/, "Xiu " /*9ae4*/, "Ran " /*9ae5*/, "Mao " /*9ae6*/, "Dan " /*9ae7*/, "Kun " /*9ae8*/, "Bin " /*9ae9*/, "Fa " /*9aea*/, "Tiao " /*9aeb*/, "Peng " /*9aec*/, "Zi " /*9aed*/, "Fa " /*9aee*/, "Ran " /*9aef*/, "Ti " /*9af0*/, "Pao " /*9af1*/, "Pi " /*9af2*/, "Mao " /*9af3*/, "Fu " /*9af4*/, "Er " /*9af5*/, "Rong " /*9af6*/, "Qu " /*9af7*/, "Gong " /*9af8*/, "Xiu " /*9af9*/, "Gua " /*9afa*/, "Ji " /*9afb*/, "Peng " /*9afc*/, "Zhua " /*9afd*/, "Shao " /*9afe*/, "Sha " /*9aff*/ 
			});
						characters.TryAdd(155 /*39680 9b*/, new string[] {
				"Ti " /*9b00*/, "Li " /*9b01*/, "Bin " /*9b02*/, "Zong " /*9b03*/, "Ti " /*9b04*/, "Peng " /*9b05*/, "Song " /*9b06*/, "Zheng " /*9b07*/, "Quan " /*9b08*/, "Zong " /*9b09*/, "Shun " /*9b0a*/, "Jian " /*9b0b*/, "Duo " /*9b0c*/, "Hu " /*9b0d*/, "La " /*9b0e*/, "Jiu " /*9b0f*/, "Qi " /*9b10*/, "Lian " /*9b11*/, "Zhen " /*9b12*/, "Bin " /*9b13*/, "Peng " /*9b14*/, "Mo " /*9b15*/, "San " /*9b16*/, "Man " /*9b17*/, "Man " /*9b18*/, "Seng " /*9b19*/, "Xu " /*9b1a*/, "Lie " /*9b1b*/, "Qian " /*9b1c*/, "Qian " /*9b1d*/, "Nong " /*9b1e*/, "Huan " /*9b1f*/, "Kuai " /*9b20*/, "Ning " /*9b21*/, "Bin " /*9b22*/, "Lie " /*9b23*/, "Rang " /*9b24*/, "Dou " /*9b25*/, "Dou " /*9b26*/, "Nao " /*9b27*/, "Hong " /*9b28*/, "Xi " /*9b29*/, "Dou " /*9b2a*/, "Han " /*9b2b*/, "Dou " /*9b2c*/, "Dou " /*9b2d*/, "Jiu " /*9b2e*/, "Chang " /*9b2f*/, "Yu " /*9b30*/, "Yu " /*9b31*/, "Li " /*9b32*/, "Juan " /*9b33*/, "Fu " /*9b34*/, "Qian " /*9b35*/, "Gui " /*9b36*/, "Zong " /*9b37*/, "Liu " /*9b38*/, "Gui " /*9b39*/, "Shang " /*9b3a*/, "Yu " /*9b3b*/, "Gui " /*9b3c*/, "Mei " /*9b3d*/, "Ji " /*9b3e*/, "Qi " /*9b3f*/, "Jie " /*9b40*/, "Kui " /*9b41*/, "Hun " /*9b42*/, "Ba " /*9b43*/, "Po " /*9b44*/, "Mei " /*9b45*/, "Xu " /*9b46*/, "Yan " /*9b47*/, "Xiao " /*9b48*/, "Liang " /*9b49*/, "Yu " /*9b4a*/, "Tui " /*9b4b*/, "Qi " /*9b4c*/, "Wang " /*9b4d*/, "Liang " /*9b4e*/, "Wei " /*9b4f*/, "Jian " /*9b50*/, "Chi " /*9b51*/, "Piao " /*9b52*/, "Bi " /*9b53*/, "Mo " /*9b54*/, "Ji " /*9b55*/, "Xu " /*9b56*/, "Chou " /*9b57*/, "Yan " /*9b58*/, "Zhan " /*9b59*/, "Yu " /*9b5a*/, "Dao " /*9b5b*/, "Ren " /*9b5c*/, "Ji " /*9b5d*/, "Eri " /*9b5e*/, "Gong " /*9b5f*/, "Tuo " /*9b60*/, "Diao " /*9b61*/, "Ji " /*9b62*/, "Xu " /*9b63*/, "E " /*9b64*/, "E " /*9b65*/, "Sha " /*9b66*/, "Hang " /*9b67*/, "Tun " /*9b68*/, "Mo " /*9b69*/, "Jie " /*9b6a*/, "Shen " /*9b6b*/, "Fan " /*9b6c*/, "Yuan " /*9b6d*/, "Bi " /*9b6e*/, "Lu " /*9b6f*/, "Wen " /*9b70*/, "Hu " /*9b71*/, "Lu " /*9b72*/, "Za " /*9b73*/, "Fang " /*9b74*/, "Fen " /*9b75*/, "Na " /*9b76*/, "You " /*9b77*/, "Namazu " /*9b78*/, "Todo " /*9b79*/, "He " /*9b7a*/, "Xia " /*9b7b*/, "Qu " /*9b7c*/, "Han " /*9b7d*/, "Pi " /*9b7e*/, "Ling " /*9b7f*/, "Tuo " /*9b80*/, "Bo " /*9b81*/, "Qiu " /*9b82*/, "Ping " /*9b83*/, "Fu " /*9b84*/, "Bi " /*9b85*/, "Ji " /*9b86*/, "Wei " /*9b87*/, "Ju " /*9b88*/, "Diao " /*9b89*/, "Bo " /*9b8a*/, "You " /*9b8b*/, "Gun " /*9b8c*/, "Pi " /*9b8d*/, "Nian " /*9b8e*/, "Xing " /*9b8f*/, "Tai " /*9b90*/, "Bao " /*9b91*/, "Fu " /*9b92*/, "Zha " /*9b93*/, "Ju " /*9b94*/, "Gu " /*9b95*/, "Kajika " /*9b96*/, "Tong " /*9b97*/, "[?] " /*9b98*/, "Ta " /*9b99*/, "Jie " /*9b9a*/, "Shu " /*9b9b*/, "Hou " /*9b9c*/, "Xiang " /*9b9d*/, "Er " /*9b9e*/, "An " /*9b9f*/, "Wei " /*9ba0*/, "Tiao " /*9ba1*/, "Zhu " /*9ba2*/, "Yin " /*9ba3*/, "Lie " /*9ba4*/, "Luo " /*9ba5*/, "Tong " /*9ba6*/, "Yi " /*9ba7*/, "Qi " /*9ba8*/, "Bing " /*9ba9*/, "Wei " /*9baa*/, "Jiao " /*9bab*/, "Bu " /*9bac*/, "Gui " /*9bad*/, "Xian " /*9bae*/, "Ge " /*9baf*/, "Hui " /*9bb0*/, "Bora " /*9bb1*/, "Mate " /*9bb2*/, "Kao " /*9bb3*/, "Gori " /*9bb4*/, "Duo " /*9bb5*/, "Jun " /*9bb6*/, "Ti " /*9bb7*/, "Man " /*9bb8*/, "Xiao " /*9bb9*/, "Za " /*9bba*/, "Sha " /*9bbb*/, "Qin " /*9bbc*/, "Yu " /*9bbd*/, "Nei " /*9bbe*/, "Zhe " /*9bbf*/, "Gun " /*9bc0*/, "Geng " /*9bc1*/, "Su " /*9bc2*/, "Wu " /*9bc3*/, "Qiu " /*9bc4*/, "Ting " /*9bc5*/, "Fu " /*9bc6*/, "Wan " /*9bc7*/, "You " /*9bc8*/, "Li " /*9bc9*/, "Sha " /*9bca*/, "Sha " /*9bcb*/, "Gao " /*9bcc*/, "Meng " /*9bcd*/, "Ugui " /*9bce*/, "Asari " /*9bcf*/, "Subashiri " /*9bd0*/, "Kazunoko " /*9bd1*/, "Yong " /*9bd2*/, "Ni " /*9bd3*/, "Zi " /*9bd4*/, "Qi " /*9bd5*/, "Qing " /*9bd6*/, "Xiang " /*9bd7*/, "Nei " /*9bd8*/, "Chun " /*9bd9*/, "Ji " /*9bda*/, "Diao " /*9bdb*/, "Qie " /*9bdc*/, "Gu " /*9bdd*/, "Zhou " /*9bde*/, "Dong " /*9bdf*/, "Lai " /*9be0*/, "Fei " /*9be1*/, "Ni " /*9be2*/, "Yi " /*9be3*/, "Kun " /*9be4*/, "Lu " /*9be5*/, "Jiu " /*9be6*/, "Chang " /*9be7*/, "Jing " /*9be8*/, "Lun " /*9be9*/, "Ling " /*9bea*/, "Zou " /*9beb*/, "Li " /*9bec*/, "Meng " /*9bed*/, "Zong " /*9bee*/, "Zhi " /*9bef*/, "Nian " /*9bf0*/, "Shachi " /*9bf1*/, "Dojou " /*9bf2*/, "Sukesou " /*9bf3*/, "Shi " /*9bf4*/, "Shen " /*9bf5*/, "Hun " /*9bf6*/, "Shi " /*9bf7*/, "Hou " /*9bf8*/, "Xing " /*9bf9*/, "Zhu " /*9bfa*/, "La " /*9bfb*/, "Zong " /*9bfc*/, "Ji " /*9bfd*/, "Bian " /*9bfe*/, "Bian " /*9bff*/ 
			});
						characters.TryAdd(156 /*39936 9c*/, new string[] {
				"Huan " /*9c00*/, "Quan " /*9c01*/, "Ze " /*9c02*/, "Wei " /*9c03*/, "Wei " /*9c04*/, "Yu " /*9c05*/, "Qun " /*9c06*/, "Rou " /*9c07*/, "Die " /*9c08*/, "Huang " /*9c09*/, "Lian " /*9c0a*/, "Yan " /*9c0b*/, "Qiu " /*9c0c*/, "Qiu " /*9c0d*/, "Jian " /*9c0e*/, "Bi " /*9c0f*/, "E " /*9c10*/, "Yang " /*9c11*/, "Fu " /*9c12*/, "Sai " /*9c13*/, "Jian " /*9c14*/, "Xia " /*9c15*/, "Tuo " /*9c16*/, "Hu " /*9c17*/, "Muroaji " /*9c18*/, "Ruo " /*9c19*/, "Haraka " /*9c1a*/, "Wen " /*9c1b*/, "Jian " /*9c1c*/, "Hao " /*9c1d*/, "Wu " /*9c1e*/, "Fang " /*9c1f*/, "Sao " /*9c20*/, "Liu " /*9c21*/, "Ma " /*9c22*/, "Shi " /*9c23*/, "Shi " /*9c24*/, "Yin " /*9c25*/, "Z " /*9c26*/, "Teng " /*9c27*/, "Ta " /*9c28*/, "Yao " /*9c29*/, "Ge " /*9c2a*/, "Rong " /*9c2b*/, "Qian " /*9c2c*/, "Qi " /*9c2d*/, "Wen " /*9c2e*/, "Ruo " /*9c2f*/, "Hatahata " /*9c30*/, "Lian " /*9c31*/, "Ao " /*9c32*/, "Le " /*9c33*/, "Hui " /*9c34*/, "Min " /*9c35*/, "Ji " /*9c36*/, "Tiao " /*9c37*/, "Qu " /*9c38*/, "Jian " /*9c39*/, "Sao " /*9c3a*/, "Man " /*9c3b*/, "Xi " /*9c3c*/, "Qiu " /*9c3d*/, "Biao " /*9c3e*/, "Ji " /*9c3f*/, "Ji " /*9c40*/, "Zhu " /*9c41*/, "Jiang " /*9c42*/, "Qiu " /*9c43*/, "Zhuan " /*9c44*/, "Yong " /*9c45*/, "Zhang " /*9c46*/, "Kang " /*9c47*/, "Xue " /*9c48*/, "Bie " /*9c49*/, "Jue " /*9c4a*/, "Qu " /*9c4b*/, "Xiang " /*9c4c*/, "Bo " /*9c4d*/, "Jiao " /*9c4e*/, "Xun " /*9c4f*/, "Su " /*9c50*/, "Huang " /*9c51*/, "Zun " /*9c52*/, "Shan " /*9c53*/, "Shan " /*9c54*/, "Fan " /*9c55*/, "Jue " /*9c56*/, "Lin " /*9c57*/, "Xun " /*9c58*/, "Miao " /*9c59*/, "Xi " /*9c5a*/, "Eso " /*9c5b*/, "Kyou " /*9c5c*/, "Fen " /*9c5d*/, "Guan " /*9c5e*/, "Hou " /*9c5f*/, "Kuai " /*9c60*/, "Zei " /*9c61*/, "Sao " /*9c62*/, "Zhan " /*9c63*/, "Gan " /*9c64*/, "Gui " /*9c65*/, "Sheng " /*9c66*/, "Li " /*9c67*/, "Chang " /*9c68*/, "Hatahata " /*9c69*/, "Shiira " /*9c6a*/, "Mutsu " /*9c6b*/, "Ru " /*9c6c*/, "Ji " /*9c6d*/, "Xu " /*9c6e*/, "Huo " /*9c6f*/, "Shiira " /*9c70*/, "Li " /*9c71*/, "Lie " /*9c72*/, "Li " /*9c73*/, "Mie " /*9c74*/, "Zhen " /*9c75*/, "Xiang " /*9c76*/, "E " /*9c77*/, "Lu " /*9c78*/, "Guan " /*9c79*/, "Li " /*9c7a*/, "Xian " /*9c7b*/, "Yu " /*9c7c*/, "Dao " /*9c7d*/, "Ji " /*9c7e*/, "You " /*9c7f*/, "Tun " /*9c80*/, "Lu " /*9c81*/, "Fang " /*9c82*/, "Ba " /*9c83*/, "He " /*9c84*/, "Bo " /*9c85*/, "Ping " /*9c86*/, "Nian " /*9c87*/, "Lu " /*9c88*/, "You " /*9c89*/, "Zha " /*9c8a*/, "Fu " /*9c8b*/, "Bo " /*9c8c*/, "Bao " /*9c8d*/, "Hou " /*9c8e*/, "Pi " /*9c8f*/, "Tai " /*9c90*/, "Gui " /*9c91*/, "Jie " /*9c92*/, "Kao " /*9c93*/, "Wei " /*9c94*/, "Er " /*9c95*/, "Tong " /*9c96*/, "Ze " /*9c97*/, "Hou " /*9c98*/, "Kuai " /*9c99*/, "Ji " /*9c9a*/, "Jiao " /*9c9b*/, "Xian " /*9c9c*/, "Za " /*9c9d*/, "Xiang " /*9c9e*/, "Xun " /*9c9f*/, "Geng " /*9ca0*/, "Li " /*9ca1*/, "Lian " /*9ca2*/, "Jian " /*9ca3*/, "Li " /*9ca4*/, "Shi " /*9ca5*/, "Tiao " /*9ca6*/, "Gun " /*9ca7*/, "Sha " /*9ca8*/, "Wan " /*9ca9*/, "Jun " /*9caa*/, "Ji " /*9cab*/, "Yong " /*9cac*/, "Qing " /*9cad*/, "Ling " /*9cae*/, "Qi " /*9caf*/, "Zou " /*9cb0*/, "Fei " /*9cb1*/, "Kun " /*9cb2*/, "Chang " /*9cb3*/, "Gu " /*9cb4*/, "Ni " /*9cb5*/, "Nian " /*9cb6*/, "Diao " /*9cb7*/, "Jing " /*9cb8*/, "Shen " /*9cb9*/, "Shi " /*9cba*/, "Zi " /*9cbb*/, "Fen " /*9cbc*/, "Die " /*9cbd*/, "Bi " /*9cbe*/, "Chang " /*9cbf*/, "Shi " /*9cc0*/, "Wen " /*9cc1*/, "Wei " /*9cc2*/, "Sai " /*9cc3*/, "E " /*9cc4*/, "Qiu " /*9cc5*/, "Fu " /*9cc6*/, "Huang " /*9cc7*/, "Quan " /*9cc8*/, "Jiang " /*9cc9*/, "Bian " /*9cca*/, "Sao " /*9ccb*/, "Ao " /*9ccc*/, "Qi " /*9ccd*/, "Ta " /*9cce*/, "Yin " /*9ccf*/, "Yao " /*9cd0*/, "Fang " /*9cd1*/, "Jian " /*9cd2*/, "Le " /*9cd3*/, "Biao " /*9cd4*/, "Xue " /*9cd5*/, "Bie " /*9cd6*/, "Man " /*9cd7*/, "Min " /*9cd8*/, "Yong " /*9cd9*/, "Wei " /*9cda*/, "Xi " /*9cdb*/, "Jue " /*9cdc*/, "Shan " /*9cdd*/, "Lin " /*9cde*/, "Zun " /*9cdf*/, "Huo " /*9ce0*/, "Gan " /*9ce1*/, "Li " /*9ce2*/, "Zhan " /*9ce3*/, "Guan " /*9ce4*/, "Niao " /*9ce5*/, "Yi " /*9ce6*/, "Fu " /*9ce7*/, "Li " /*9ce8*/, "Jiu " /*9ce9*/, "Bu " /*9cea*/, "Yan " /*9ceb*/, "Fu " /*9cec*/, "Diao " /*9ced*/, "Ji " /*9cee*/, "Feng " /*9cef*/, "Nio " /*9cf0*/, "Gan " /*9cf1*/, "Shi " /*9cf2*/, "Feng " /*9cf3*/, "Ming " /*9cf4*/, "Bao " /*9cf5*/, "Yuan " /*9cf6*/, "Zhi " /*9cf7*/, "Hu " /*9cf8*/, "Qin " /*9cf9*/, "Fu " /*9cfa*/, "Fen " /*9cfb*/, "Wen " /*9cfc*/, "Jian " /*9cfd*/, "Shi " /*9cfe*/, "Yu " /*9cff*/ 
			});
						characters.TryAdd(157 /*40192 9d*/, new string[] {
				"Fou " /*9d00*/, "Yiao " /*9d01*/, "Jue " /*9d02*/, "Jue " /*9d03*/, "Pi " /*9d04*/, "Huan " /*9d05*/, "Zhen " /*9d06*/, "Bao " /*9d07*/, "Yan " /*9d08*/, "Ya " /*9d09*/, "Zheng " /*9d0a*/, "Fang " /*9d0b*/, "Feng " /*9d0c*/, "Wen " /*9d0d*/, "Ou " /*9d0e*/, "Te " /*9d0f*/, "Jia " /*9d10*/, "Nu " /*9d11*/, "Ling " /*9d12*/, "Mie " /*9d13*/, "Fu " /*9d14*/, "Tuo " /*9d15*/, "Wen " /*9d16*/, "Li " /*9d17*/, "Bian " /*9d18*/, "Zhi " /*9d19*/, "Ge " /*9d1a*/, "Yuan " /*9d1b*/, "Zi " /*9d1c*/, "Qu " /*9d1d*/, "Xiao " /*9d1e*/, "Zhi " /*9d1f*/, "Dan " /*9d20*/, "Ju " /*9d21*/, "You " /*9d22*/, "Gu " /*9d23*/, "Zhong " /*9d24*/, "Yu " /*9d25*/, "Yang " /*9d26*/, "Rong " /*9d27*/, "Ya " /*9d28*/, "Tie " /*9d29*/, "Yu " /*9d2a*/, "Shigi " /*9d2b*/, "Ying " /*9d2c*/, "Zhui " /*9d2d*/, "Wu " /*9d2e*/, "Er " /*9d2f*/, "Gua " /*9d30*/, "Ai " /*9d31*/, "Zhi " /*9d32*/, "Yan " /*9d33*/, "Heng " /*9d34*/, "Jiao " /*9d35*/, "Ji " /*9d36*/, "Lie " /*9d37*/, "Zhu " /*9d38*/, "Ren " /*9d39*/, "Yi " /*9d3a*/, "Hong " /*9d3b*/, "Luo " /*9d3c*/, "Ru " /*9d3d*/, "Mou " /*9d3e*/, "Ge " /*9d3f*/, "Ren " /*9d40*/, "Jiao " /*9d41*/, "Xiu " /*9d42*/, "Zhou " /*9d43*/, "Zhi " /*9d44*/, "Luo " /*9d45*/, "Chidori " /*9d46*/, "Toki " /*9d47*/, "Ten " /*9d48*/, "Luan " /*9d49*/, "Jia " /*9d4a*/, "Ji " /*9d4b*/, "Yu " /*9d4c*/, "Huan " /*9d4d*/, "Tuo " /*9d4e*/, "Bu " /*9d4f*/, "Wu " /*9d50*/, "Juan " /*9d51*/, "Yu " /*9d52*/, "Bo " /*9d53*/, "Xun " /*9d54*/, "Xun " /*9d55*/, "Bi " /*9d56*/, "Xi " /*9d57*/, "Jun " /*9d58*/, "Ju " /*9d59*/, "Tu " /*9d5a*/, "Jing " /*9d5b*/, "Ti " /*9d5c*/, "E " /*9d5d*/, "E " /*9d5e*/, "Kuang " /*9d5f*/, "Hu " /*9d60*/, "Wu " /*9d61*/, "Shen " /*9d62*/, "Lai " /*9d63*/, "Ikaruga " /*9d64*/, "Kakesu " /*9d65*/, "Lu " /*9d66*/, "Ping " /*9d67*/, "Shu " /*9d68*/, "Fu " /*9d69*/, "An " /*9d6a*/, "Zhao " /*9d6b*/, "Peng " /*9d6c*/, "Qin " /*9d6d*/, "Qian " /*9d6e*/, "Bei " /*9d6f*/, "Diao " /*9d70*/, "Lu " /*9d71*/, "Que " /*9d72*/, "Jian " /*9d73*/, "Ju " /*9d74*/, "Tu " /*9d75*/, "Ya " /*9d76*/, "Yuan " /*9d77*/, "Qi " /*9d78*/, "Li " /*9d79*/, "Ye " /*9d7a*/, "Zhui " /*9d7b*/, "Kong " /*9d7c*/, "Zhui " /*9d7d*/, "Kun " /*9d7e*/, "Sheng " /*9d7f*/, "Qi " /*9d80*/, "Jing " /*9d81*/, "Yi " /*9d82*/, "Yi " /*9d83*/, "Jing " /*9d84*/, "Zi " /*9d85*/, "Lai " /*9d86*/, "Dong " /*9d87*/, "Qi " /*9d88*/, "Chun " /*9d89*/, "Geng " /*9d8a*/, "Ju " /*9d8b*/, "Qu " /*9d8c*/, "Isuka " /*9d8d*/, "Kikuitadaki " /*9d8e*/, "Ji " /*9d8f*/, "Shu " /*9d90*/, "[?] " /*9d91*/, "Chi " /*9d92*/, "Miao " /*9d93*/, "Rou " /*9d94*/, "An " /*9d95*/, "Qiu " /*9d96*/, "Ti " /*9d97*/, "Hu " /*9d98*/, "Ti " /*9d99*/, "E " /*9d9a*/, "Jie " /*9d9b*/, "Mao " /*9d9c*/, "Fu " /*9d9d*/, "Chun " /*9d9e*/, "Tu " /*9d9f*/, "Yan " /*9da0*/, "He " /*9da1*/, "Yuan " /*9da2*/, "Pian " /*9da3*/, "Yun " /*9da4*/, "Mei " /*9da5*/, "Hu " /*9da6*/, "Ying " /*9da7*/, "Dun " /*9da8*/, "Mu " /*9da9*/, "Ju " /*9daa*/, "Tsugumi " /*9dab*/, "Cang " /*9dac*/, "Fang " /*9dad*/, "Gu " /*9dae*/, "Ying " /*9daf*/, "Yuan " /*9db0*/, "Xuan " /*9db1*/, "Weng " /*9db2*/, "Shi " /*9db3*/, "He " /*9db4*/, "Chu " /*9db5*/, "Tang " /*9db6*/, "Xia " /*9db7*/, "Ruo " /*9db8*/, "Liu " /*9db9*/, "Ji " /*9dba*/, "Gu " /*9dbb*/, "Jian " /*9dbc*/, "Zhun " /*9dbd*/, "Han " /*9dbe*/, "Zi " /*9dbf*/, "Zi " /*9dc0*/, "Ni " /*9dc1*/, "Yao " /*9dc2*/, "Yan " /*9dc3*/, "Ji " /*9dc4*/, "Li " /*9dc5*/, "Tian " /*9dc6*/, "Kou " /*9dc7*/, "Ti " /*9dc8*/, "Ti " /*9dc9*/, "Ni " /*9dca*/, "Tu " /*9dcb*/, "Ma " /*9dcc*/, "Jiao " /*9dcd*/, "Gao " /*9dce*/, "Tian " /*9dcf*/, "Chen " /*9dd0*/, "Li " /*9dd1*/, "Zhuan " /*9dd2*/, "Zhe " /*9dd3*/, "Ao " /*9dd4*/, "Yao " /*9dd5*/, "Yi " /*9dd6*/, "Ou " /*9dd7*/, "Chi " /*9dd8*/, "Zhi " /*9dd9*/, "Liao " /*9dda*/, "Rong " /*9ddb*/, "Lou " /*9ddc*/, "Bi " /*9ddd*/, "Shuang " /*9dde*/, "Zhuo " /*9ddf*/, "Yu " /*9de0*/, "Wu " /*9de1*/, "Jue " /*9de2*/, "Yin " /*9de3*/, "Quan " /*9de4*/, "Si " /*9de5*/, "Jiao " /*9de6*/, "Yi " /*9de7*/, "Hua " /*9de8*/, "Bi " /*9de9*/, "Ying " /*9dea*/, "Su " /*9deb*/, "Huang " /*9dec*/, "Fan " /*9ded*/, "Jiao " /*9dee*/, "Liao " /*9def*/, "Yan " /*9df0*/, "Kao " /*9df1*/, "Jiu " /*9df2*/, "Xian " /*9df3*/, "Xian " /*9df4*/, "Tu " /*9df5*/, "Mai " /*9df6*/, "Zun " /*9df7*/, "Yu " /*9df8*/, "Ying " /*9df9*/, "Lu " /*9dfa*/, "Tuan " /*9dfb*/, "Xian " /*9dfc*/, "Xue " /*9dfd*/, "Yi " /*9dfe*/, "Pi " /*9dff*/ 
			});
						characters.TryAdd(158 /*40448 9e*/, new string[] {
				"Shu " /*9e00*/, "Luo " /*9e01*/, "Qi " /*9e02*/, "Yi " /*9e03*/, "Ji " /*9e04*/, "Zhe " /*9e05*/, "Yu " /*9e06*/, "Zhan " /*9e07*/, "Ye " /*9e08*/, "Yang " /*9e09*/, "Pi " /*9e0a*/, "Ning " /*9e0b*/, "Huo " /*9e0c*/, "Mi " /*9e0d*/, "Ying " /*9e0e*/, "Meng " /*9e0f*/, "Di " /*9e10*/, "Yue " /*9e11*/, "Yu " /*9e12*/, "Lei " /*9e13*/, "Bao " /*9e14*/, "Lu " /*9e15*/, "He " /*9e16*/, "Long " /*9e17*/, "Shuang " /*9e18*/, "Yue " /*9e19*/, "Ying " /*9e1a*/, "Guan " /*9e1b*/, "Qu " /*9e1c*/, "Li " /*9e1d*/, "Luan " /*9e1e*/, "Niao " /*9e1f*/, "Jiu " /*9e20*/, "Ji " /*9e21*/, "Yuan " /*9e22*/, "Ming " /*9e23*/, "Shi " /*9e24*/, "Ou " /*9e25*/, "Ya " /*9e26*/, "Cang " /*9e27*/, "Bao " /*9e28*/, "Zhen " /*9e29*/, "Gu " /*9e2a*/, "Dong " /*9e2b*/, "Lu " /*9e2c*/, "Ya " /*9e2d*/, "Xiao " /*9e2e*/, "Yang " /*9e2f*/, "Ling " /*9e30*/, "Zhi " /*9e31*/, "Qu " /*9e32*/, "Yuan " /*9e33*/, "Xue " /*9e34*/, "Tuo " /*9e35*/, "Si " /*9e36*/, "Zhi " /*9e37*/, "Er " /*9e38*/, "Gua " /*9e39*/, "Xiu " /*9e3a*/, "Heng " /*9e3b*/, "Zhou " /*9e3c*/, "Ge " /*9e3d*/, "Luan " /*9e3e*/, "Hong " /*9e3f*/, "Wu " /*9e40*/, "Bo " /*9e41*/, "Li " /*9e42*/, "Juan " /*9e43*/, "Hu " /*9e44*/, "E " /*9e45*/, "Yu " /*9e46*/, "Xian " /*9e47*/, "Ti " /*9e48*/, "Wu " /*9e49*/, "Que " /*9e4a*/, "Miao " /*9e4b*/, "An " /*9e4c*/, "Kun " /*9e4d*/, "Bei " /*9e4e*/, "Peng " /*9e4f*/, "Qian " /*9e50*/, "Chun " /*9e51*/, "Geng " /*9e52*/, "Yuan " /*9e53*/, "Su " /*9e54*/, "Hu " /*9e55*/, "He " /*9e56*/, "E " /*9e57*/, "Gu " /*9e58*/, "Qiu " /*9e59*/, "Zi " /*9e5a*/, "Mei " /*9e5b*/, "Mu " /*9e5c*/, "Ni " /*9e5d*/, "Yao " /*9e5e*/, "Weng " /*9e5f*/, "Liu " /*9e60*/, "Ji " /*9e61*/, "Ni " /*9e62*/, "Jian " /*9e63*/, "He " /*9e64*/, "Yi " /*9e65*/, "Ying " /*9e66*/, "Zhe " /*9e67*/, "Liao " /*9e68*/, "Liao " /*9e69*/, "Jiao " /*9e6a*/, "Jiu " /*9e6b*/, "Yu " /*9e6c*/, "Lu " /*9e6d*/, "Xuan " /*9e6e*/, "Zhan " /*9e6f*/, "Ying " /*9e70*/, "Huo " /*9e71*/, "Meng " /*9e72*/, "Guan " /*9e73*/, "Shuang " /*9e74*/, "Lu " /*9e75*/, "Jin " /*9e76*/, "Ling " /*9e77*/, "Jian " /*9e78*/, "Xian " /*9e79*/, "Cuo " /*9e7a*/, "Jian " /*9e7b*/, "Jian " /*9e7c*/, "Yan " /*9e7d*/, "Cuo " /*9e7e*/, "Lu " /*9e7f*/, "You " /*9e80*/, "Cu " /*9e81*/, "Ji " /*9e82*/, "Biao " /*9e83*/, "Cu " /*9e84*/, "Biao " /*9e85*/, "Zhu " /*9e86*/, "Jun " /*9e87*/, "Zhu " /*9e88*/, "Jian " /*9e89*/, "Mi " /*9e8a*/, "Mi " /*9e8b*/, "Wu " /*9e8c*/, "Liu " /*9e8d*/, "Chen " /*9e8e*/, "Jun " /*9e8f*/, "Lin " /*9e90*/, "Ni " /*9e91*/, "Qi " /*9e92*/, "Lu " /*9e93*/, "Jiu " /*9e94*/, "Jun " /*9e95*/, "Jing " /*9e96*/, "Li " /*9e97*/, "Xiang " /*9e98*/, "Yan " /*9e99*/, "Jia " /*9e9a*/, "Mi " /*9e9b*/, "Li " /*9e9c*/, "She " /*9e9d*/, "Zhang " /*9e9e*/, "Lin " /*9e9f*/, "Jing " /*9ea0*/, "Ji " /*9ea1*/, "Ling " /*9ea2*/, "Yan " /*9ea3*/, "Cu " /*9ea4*/, "Mai " /*9ea5*/, "Mai " /*9ea6*/, "Ge " /*9ea7*/, "Chao " /*9ea8*/, "Fu " /*9ea9*/, "Mian " /*9eaa*/, "Mian " /*9eab*/, "Fu " /*9eac*/, "Pao " /*9ead*/, "Qu " /*9eae*/, "Qu " /*9eaf*/, "Mou " /*9eb0*/, "Fu " /*9eb1*/, "Xian " /*9eb2*/, "Lai " /*9eb3*/, "Qu " /*9eb4*/, "Mian " /*9eb5*/, "[?] " /*9eb6*/, "Feng " /*9eb7*/, "Fu " /*9eb8*/, "Qu " /*9eb9*/, "Mian " /*9eba*/, "Ma " /*9ebb*/, "Mo " /*9ebc*/, "Mo " /*9ebd*/, "Hui " /*9ebe*/, "Ma " /*9ebf*/, "Zou " /*9ec0*/, "Nen " /*9ec1*/, "Fen " /*9ec2*/, "Huang " /*9ec3*/, "Huang " /*9ec4*/, "Jin " /*9ec5*/, "Guang " /*9ec6*/, "Tian " /*9ec7*/, "Tou " /*9ec8*/, "Heng " /*9ec9*/, "Xi " /*9eca*/, "Kuang " /*9ecb*/, "Heng " /*9ecc*/, "Shu " /*9ecd*/, "Li " /*9ece*/, "Nian " /*9ecf*/, "Chi " /*9ed0*/, "Hei " /*9ed1*/, "Hei " /*9ed2*/, "Yi " /*9ed3*/, "Qian " /*9ed4*/, "Dan " /*9ed5*/, "Xi " /*9ed6*/, "Tuan " /*9ed7*/, "Mo " /*9ed8*/, "Mo " /*9ed9*/, "Qian " /*9eda*/, "Dai " /*9edb*/, "Chu " /*9edc*/, "You " /*9edd*/, "Dian " /*9ede*/, "Yi " /*9edf*/, "Xia " /*9ee0*/, "Yan " /*9ee1*/, "Qu " /*9ee2*/, "Mei " /*9ee3*/, "Yan " /*9ee4*/, "Jing " /*9ee5*/, "Yu " /*9ee6*/, "Li " /*9ee7*/, "Dang " /*9ee8*/, "Du " /*9ee9*/, "Can " /*9eea*/, "Yin " /*9eeb*/, "An " /*9eec*/, "Yan " /*9eed*/, "Tan " /*9eee*/, "An " /*9eef*/, "Zhen " /*9ef0*/, "Dai " /*9ef1*/, "Can " /*9ef2*/, "Yi " /*9ef3*/, "Mei " /*9ef4*/, "Dan " /*9ef5*/, "Yan " /*9ef6*/, "Du " /*9ef7*/, "Lu " /*9ef8*/, "Zhi " /*9ef9*/, "Fen " /*9efa*/, "Fu " /*9efb*/, "Fu " /*9efc*/, "Min " /*9efd*/, "Min " /*9efe*/, "Yuan " /*9eff*/ 
			});
						characters.TryAdd(159 /*40704 9f*/, new string[] {
				"Cu " /*9f00*/, "Qu " /*9f01*/, "Chao " /*9f02*/, "Wa " /*9f03*/, "Zhu " /*9f04*/, "Zhi " /*9f05*/, "Mang " /*9f06*/, "Ao " /*9f07*/, "Bie " /*9f08*/, "Tuo " /*9f09*/, "Bi " /*9f0a*/, "Yuan " /*9f0b*/, "Chao " /*9f0c*/, "Tuo " /*9f0d*/, "Ding " /*9f0e*/, "Mi " /*9f0f*/, "Nai " /*9f10*/, "Ding " /*9f11*/, "Zi " /*9f12*/, "Gu " /*9f13*/, "Gu " /*9f14*/, "Dong " /*9f15*/, "Fen " /*9f16*/, "Tao " /*9f17*/, "Yuan " /*9f18*/, "Pi " /*9f19*/, "Chang " /*9f1a*/, "Gao " /*9f1b*/, "Qi " /*9f1c*/, "Yuan " /*9f1d*/, "Tang " /*9f1e*/, "Teng " /*9f1f*/, "Shu " /*9f20*/, "Shu " /*9f21*/, "Fen " /*9f22*/, "Fei " /*9f23*/, "Wen " /*9f24*/, "Ba " /*9f25*/, "Diao " /*9f26*/, "Tuo " /*9f27*/, "Tong " /*9f28*/, "Qu " /*9f29*/, "Sheng " /*9f2a*/, "Shi " /*9f2b*/, "You " /*9f2c*/, "Shi " /*9f2d*/, "Ting " /*9f2e*/, "Wu " /*9f2f*/, "Nian " /*9f30*/, "Jing " /*9f31*/, "Hun " /*9f32*/, "Ju " /*9f33*/, "Yan " /*9f34*/, "Tu " /*9f35*/, "Ti " /*9f36*/, "Xi " /*9f37*/, "Xian " /*9f38*/, "Yan " /*9f39*/, "Lei " /*9f3a*/, "Bi " /*9f3b*/, "Yao " /*9f3c*/, "Qiu " /*9f3d*/, "Han " /*9f3e*/, "Wu " /*9f3f*/, "Wu " /*9f40*/, "Hou " /*9f41*/, "Xi " /*9f42*/, "Ge " /*9f43*/, "Zha " /*9f44*/, "Xiu " /*9f45*/, "Weng " /*9f46*/, "Zha " /*9f47*/, "Nong " /*9f48*/, "Nang " /*9f49*/, "Qi " /*9f4a*/, "Zhai " /*9f4b*/, "Ji " /*9f4c*/, "Zi " /*9f4d*/, "Ji " /*9f4e*/, "Ji " /*9f4f*/, "Qi " /*9f50*/, "Ji " /*9f51*/, "Chi " /*9f52*/, "Chen " /*9f53*/, "Chen " /*9f54*/, "He " /*9f55*/, "Ya " /*9f56*/, "Ken " /*9f57*/, "Xie " /*9f58*/, "Pao " /*9f59*/, "Cuo " /*9f5a*/, "Shi " /*9f5b*/, "Zi " /*9f5c*/, "Chi " /*9f5d*/, "Nian " /*9f5e*/, "Ju " /*9f5f*/, "Tiao " /*9f60*/, "Ling " /*9f61*/, "Ling " /*9f62*/, "Chu " /*9f63*/, "Quan " /*9f64*/, "Xie " /*9f65*/, "Ken " /*9f66*/, "Nie " /*9f67*/, "Jiu " /*9f68*/, "Yao " /*9f69*/, "Chuo " /*9f6a*/, "Kun " /*9f6b*/, "Yu " /*9f6c*/, "Chu " /*9f6d*/, "Yi " /*9f6e*/, "Ni " /*9f6f*/, "Cuo " /*9f70*/, "Zou " /*9f71*/, "Qu " /*9f72*/, "Nen " /*9f73*/, "Xian " /*9f74*/, "Ou " /*9f75*/, "E " /*9f76*/, "Wo " /*9f77*/, "Yi " /*9f78*/, "Chuo " /*9f79*/, "Zou " /*9f7a*/, "Dian " /*9f7b*/, "Chu " /*9f7c*/, "Jin " /*9f7d*/, "Ya " /*9f7e*/, "Chi " /*9f7f*/, "Chen " /*9f80*/, "He " /*9f81*/, "Ken " /*9f82*/, "Ju " /*9f83*/, "Ling " /*9f84*/, "Pao " /*9f85*/, "Tiao " /*9f86*/, "Zi " /*9f87*/, "Ken " /*9f88*/, "Yu " /*9f89*/, "Chuo " /*9f8a*/, "Qu " /*9f8b*/, "Wo " /*9f8c*/, "Long " /*9f8d*/, "Pang " /*9f8e*/, "Gong " /*9f8f*/, "Pang " /*9f90*/, "Yan " /*9f91*/, "Long " /*9f92*/, "Long " /*9f93*/, "Gong " /*9f94*/, "Kan " /*9f95*/, "Ta " /*9f96*/, "Ling " /*9f97*/, "Ta " /*9f98*/, "Long " /*9f99*/, "Gong " /*9f9a*/, "Kan " /*9f9b*/, "Gui " /*9f9c*/, "Qiu " /*9f9d*/, "Bie " /*9f9e*/, "Gui " /*9f9f*/, "Yue " /*9fa0*/, "Chui " /*9fa1*/, "He " /*9fa2*/, "Jue " /*9fa3*/, "Xie " /*9fa4*/, "Yu " /*9fa5*/, "[?]" /*9fa6*/, "[?]" /*9fa7*/, "[?]" /*9fa8*/, "[?]" /*9fa9*/, "[?]" /*9faa*/, "[?]" /*9fab*/, "[?]" /*9fac*/, "[?]" /*9fad*/, "[?]" /*9fae*/, "[?]" /*9faf*/, "[?]" /*9fb0*/, "[?]" /*9fb1*/, "[?]" /*9fb2*/, "[?]" /*9fb3*/, "[?]" /*9fb4*/, "[?]" /*9fb5*/, "[?]" /*9fb6*/, "[?]" /*9fb7*/, "[?]" /*9fb8*/, "[?]" /*9fb9*/, "[?]" /*9fba*/, "[?]" /*9fbb*/, "[?]" /*9fbc*/, "[?]" /*9fbd*/, "[?]" /*9fbe*/, "[?]" /*9fbf*/, "[?]" /*9fc0*/, "[?]" /*9fc1*/, "[?]" /*9fc2*/, "[?]" /*9fc3*/, "[?]" /*9fc4*/, "[?]" /*9fc5*/, "[?]" /*9fc6*/, "[?]" /*9fc7*/, "[?]" /*9fc8*/, "[?]" /*9fc9*/, "[?]" /*9fca*/, "[?]" /*9fcb*/, "[?]" /*9fcc*/, "[?]" /*9fcd*/, "[?]" /*9fce*/, "[?]" /*9fcf*/, "[?]" /*9fd0*/, "[?]" /*9fd1*/, "[?]" /*9fd2*/, "[?]" /*9fd3*/, "[?]" /*9fd4*/, "[?]" /*9fd5*/, "[?]" /*9fd6*/, "[?]" /*9fd7*/, "[?]" /*9fd8*/, "[?]" /*9fd9*/, "[?]" /*9fda*/, "[?]" /*9fdb*/, "[?]" /*9fdc*/, "[?]" /*9fdd*/, "[?]" /*9fde*/, "[?]" /*9fdf*/, "[?]" /*9fe0*/, "[?]" /*9fe1*/, "[?]" /*9fe2*/, "[?]" /*9fe3*/, "[?]" /*9fe4*/, "[?]" /*9fe5*/, "[?]" /*9fe6*/, "[?]" /*9fe7*/, "[?]" /*9fe8*/, "[?]" /*9fe9*/, "[?]" /*9fea*/, "[?]" /*9feb*/, "[?]" /*9fec*/, "[?]" /*9fed*/, "[?]" /*9fee*/, "[?]" /*9fef*/, "[?]" /*9ff0*/, "[?]" /*9ff1*/, "[?]" /*9ff2*/, "[?]" /*9ff3*/, "[?]" /*9ff4*/, "[?]" /*9ff5*/, "[?]" /*9ff6*/, "[?]" /*9ff7*/, "[?]" /*9ff8*/, "[?]" /*9ff9*/, "[?]" /*9ffa*/, "[?]" /*9ffb*/, "[?]" /*9ffc*/, "[?]" /*9ffd*/, "[?]" /*9ffe*/, 
			});
						characters.TryAdd(160 /*40960 a0*/, new string[] {
				"it" /*a000*/, "ix" /*a001*/, "i" /*a002*/, "ip" /*a003*/, "iet" /*a004*/, "iex" /*a005*/, "ie" /*a006*/, "iep" /*a007*/, "at" /*a008*/, "ax" /*a009*/, "a" /*a00a*/, "ap" /*a00b*/, "uox" /*a00c*/, "uo" /*a00d*/, "uop" /*a00e*/, "ot" /*a00f*/, "ox" /*a010*/, "o" /*a011*/, "op" /*a012*/, "ex" /*a013*/, "e" /*a014*/, "wu" /*a015*/, "bit" /*a016*/, "bix" /*a017*/, "bi" /*a018*/, "bip" /*a019*/, "biet" /*a01a*/, "biex" /*a01b*/, "bie" /*a01c*/, "biep" /*a01d*/, "bat" /*a01e*/, "bax" /*a01f*/, "ba" /*a020*/, "bap" /*a021*/, "buox" /*a022*/, "buo" /*a023*/, "buop" /*a024*/, "bot" /*a025*/, "box" /*a026*/, "bo" /*a027*/, "bop" /*a028*/, "bex" /*a029*/, "be" /*a02a*/, "bep" /*a02b*/, "but" /*a02c*/, "bux" /*a02d*/, "bu" /*a02e*/, "bup" /*a02f*/, "burx" /*a030*/, "bur" /*a031*/, "byt" /*a032*/, "byx" /*a033*/, "by" /*a034*/, "byp" /*a035*/, "byrx" /*a036*/, "byr" /*a037*/, "pit" /*a038*/, "pix" /*a039*/, "pi" /*a03a*/, "pip" /*a03b*/, "piex" /*a03c*/, "pie" /*a03d*/, "piep" /*a03e*/, "pat" /*a03f*/, "pax" /*a040*/, "pa" /*a041*/, "pap" /*a042*/, "puox" /*a043*/, "puo" /*a044*/, "puop" /*a045*/, "pot" /*a046*/, "pox" /*a047*/, "po" /*a048*/, "pop" /*a049*/, "put" /*a04a*/, "pux" /*a04b*/, "pu" /*a04c*/, "pup" /*a04d*/, "purx" /*a04e*/, "pur" /*a04f*/, "pyt" /*a050*/, "pyx" /*a051*/, "py" /*a052*/, "pyp" /*a053*/, "pyrx" /*a054*/, "pyr" /*a055*/, "bbit" /*a056*/, "bbix" /*a057*/, "bbi" /*a058*/, "bbip" /*a059*/, "bbiet" /*a05a*/, "bbiex" /*a05b*/, "bbie" /*a05c*/, "bbiep" /*a05d*/, "bbat" /*a05e*/, "bbax" /*a05f*/, "bba" /*a060*/, "bbap" /*a061*/, "bbuox" /*a062*/, "bbuo" /*a063*/, "bbuop" /*a064*/, "bbot" /*a065*/, "bbox" /*a066*/, "bbo" /*a067*/, "bbop" /*a068*/, "bbex" /*a069*/, "bbe" /*a06a*/, "bbep" /*a06b*/, "bbut" /*a06c*/, "bbux" /*a06d*/, "bbu" /*a06e*/, "bbup" /*a06f*/, "bburx" /*a070*/, "bbur" /*a071*/, "bbyt" /*a072*/, "bbyx" /*a073*/, "bby" /*a074*/, "bbyp" /*a075*/, "nbit" /*a076*/, "nbix" /*a077*/, "nbi" /*a078*/, "nbip" /*a079*/, "nbiex" /*a07a*/, "nbie" /*a07b*/, "nbiep" /*a07c*/, "nbat" /*a07d*/, "nbax" /*a07e*/, "nba" /*a07f*/, "nbap" /*a080*/, "nbot" /*a081*/, "nbox" /*a082*/, "nbo" /*a083*/, "nbop" /*a084*/, "nbut" /*a085*/, "nbux" /*a086*/, "nbu" /*a087*/, "nbup" /*a088*/, "nburx" /*a089*/, "nbur" /*a08a*/, "nbyt" /*a08b*/, "nbyx" /*a08c*/, "nby" /*a08d*/, "nbyp" /*a08e*/, "nbyrx" /*a08f*/, "nbyr" /*a090*/, "hmit" /*a091*/, "hmix" /*a092*/, "hmi" /*a093*/, "hmip" /*a094*/, "hmiex" /*a095*/, "hmie" /*a096*/, "hmiep" /*a097*/, "hmat" /*a098*/, "hmax" /*a099*/, "hma" /*a09a*/, "hmap" /*a09b*/, "hmuox" /*a09c*/, "hmuo" /*a09d*/, "hmuop" /*a09e*/, "hmot" /*a09f*/, "hmox" /*a0a0*/, "hmo" /*a0a1*/, "hmop" /*a0a2*/, "hmut" /*a0a3*/, "hmux" /*a0a4*/, "hmu" /*a0a5*/, "hmup" /*a0a6*/, "hmurx" /*a0a7*/, "hmur" /*a0a8*/, "hmyx" /*a0a9*/, "hmy" /*a0aa*/, "hmyp" /*a0ab*/, "hmyrx" /*a0ac*/, "hmyr" /*a0ad*/, "mit" /*a0ae*/, "mix" /*a0af*/, "mi" /*a0b0*/, "mip" /*a0b1*/, "miex" /*a0b2*/, "mie" /*a0b3*/, "miep" /*a0b4*/, "mat" /*a0b5*/, "max" /*a0b6*/, "ma" /*a0b7*/, "map" /*a0b8*/, "muot" /*a0b9*/, "muox" /*a0ba*/, "muo" /*a0bb*/, "muop" /*a0bc*/, "mot" /*a0bd*/, "mox" /*a0be*/, "mo" /*a0bf*/, "mop" /*a0c0*/, "mex" /*a0c1*/, "me" /*a0c2*/, "mut" /*a0c3*/, "mux" /*a0c4*/, "mu" /*a0c5*/, "mup" /*a0c6*/, "murx" /*a0c7*/, "mur" /*a0c8*/, "myt" /*a0c9*/, "myx" /*a0ca*/, "my" /*a0cb*/, "myp" /*a0cc*/, "fit" /*a0cd*/, "fix" /*a0ce*/, "fi" /*a0cf*/, "fip" /*a0d0*/, "fat" /*a0d1*/, "fax" /*a0d2*/, "fa" /*a0d3*/, "fap" /*a0d4*/, "fox" /*a0d5*/, "fo" /*a0d6*/, "fop" /*a0d7*/, "fut" /*a0d8*/, "fux" /*a0d9*/, "fu" /*a0da*/, "fup" /*a0db*/, "furx" /*a0dc*/, "fur" /*a0dd*/, "fyt" /*a0de*/, "fyx" /*a0df*/, "fy" /*a0e0*/, "fyp" /*a0e1*/, "vit" /*a0e2*/, "vix" /*a0e3*/, "vi" /*a0e4*/, "vip" /*a0e5*/, "viet" /*a0e6*/, "viex" /*a0e7*/, "vie" /*a0e8*/, "viep" /*a0e9*/, "vat" /*a0ea*/, "vax" /*a0eb*/, "va" /*a0ec*/, "vap" /*a0ed*/, "vot" /*a0ee*/, "vox" /*a0ef*/, "vo" /*a0f0*/, "vop" /*a0f1*/, "vex" /*a0f2*/, "vep" /*a0f3*/, "vut" /*a0f4*/, "vux" /*a0f5*/, "vu" /*a0f6*/, "vup" /*a0f7*/, "vurx" /*a0f8*/, "vur" /*a0f9*/, "vyt" /*a0fa*/, "vyx" /*a0fb*/, "vy" /*a0fc*/, "vyp" /*a0fd*/, "vyrx" /*a0fe*/, "vyr" /*a0ff*/ 
			});
						characters.TryAdd(161 /*41216 a1*/, new string[] {
				"dit" /*a100*/, "dix" /*a101*/, "di" /*a102*/, "dip" /*a103*/, "diex" /*a104*/, "die" /*a105*/, "diep" /*a106*/, "dat" /*a107*/, "dax" /*a108*/, "da" /*a109*/, "dap" /*a10a*/, "duox" /*a10b*/, "duo" /*a10c*/, "dot" /*a10d*/, "dox" /*a10e*/, "do" /*a10f*/, "dop" /*a110*/, "dex" /*a111*/, "de" /*a112*/, "dep" /*a113*/, "dut" /*a114*/, "dux" /*a115*/, "du" /*a116*/, "dup" /*a117*/, "durx" /*a118*/, "dur" /*a119*/, "tit" /*a11a*/, "tix" /*a11b*/, "ti" /*a11c*/, "tip" /*a11d*/, "tiex" /*a11e*/, "tie" /*a11f*/, "tiep" /*a120*/, "tat" /*a121*/, "tax" /*a122*/, "ta" /*a123*/, "tap" /*a124*/, "tuot" /*a125*/, "tuox" /*a126*/, "tuo" /*a127*/, "tuop" /*a128*/, "tot" /*a129*/, "tox" /*a12a*/, "to" /*a12b*/, "top" /*a12c*/, "tex" /*a12d*/, "te" /*a12e*/, "tep" /*a12f*/, "tut" /*a130*/, "tux" /*a131*/, "tu" /*a132*/, "tup" /*a133*/, "turx" /*a134*/, "tur" /*a135*/, "ddit" /*a136*/, "ddix" /*a137*/, "ddi" /*a138*/, "ddip" /*a139*/, "ddiex" /*a13a*/, "ddie" /*a13b*/, "ddiep" /*a13c*/, "ddat" /*a13d*/, "ddax" /*a13e*/, "dda" /*a13f*/, "ddap" /*a140*/, "dduox" /*a141*/, "dduo" /*a142*/, "dduop" /*a143*/, "ddot" /*a144*/, "ddox" /*a145*/, "ddo" /*a146*/, "ddop" /*a147*/, "ddex" /*a148*/, "dde" /*a149*/, "ddep" /*a14a*/, "ddut" /*a14b*/, "ddux" /*a14c*/, "ddu" /*a14d*/, "ddup" /*a14e*/, "ddurx" /*a14f*/, "ddur" /*a150*/, "ndit" /*a151*/, "ndix" /*a152*/, "ndi" /*a153*/, "ndip" /*a154*/, "ndiex" /*a155*/, "ndie" /*a156*/, "ndat" /*a157*/, "ndax" /*a158*/, "nda" /*a159*/, "ndap" /*a15a*/, "ndot" /*a15b*/, "ndox" /*a15c*/, "ndo" /*a15d*/, "ndop" /*a15e*/, "ndex" /*a15f*/, "nde" /*a160*/, "ndep" /*a161*/, "ndut" /*a162*/, "ndux" /*a163*/, "ndu" /*a164*/, "ndup" /*a165*/, "ndurx" /*a166*/, "ndur" /*a167*/, "hnit" /*a168*/, "hnix" /*a169*/, "hni" /*a16a*/, "hnip" /*a16b*/, "hniet" /*a16c*/, "hniex" /*a16d*/, "hnie" /*a16e*/, "hniep" /*a16f*/, "hnat" /*a170*/, "hnax" /*a171*/, "hna" /*a172*/, "hnap" /*a173*/, "hnuox" /*a174*/, "hnuo" /*a175*/, "hnot" /*a176*/, "hnox" /*a177*/, "hnop" /*a178*/, "hnex" /*a179*/, "hne" /*a17a*/, "hnep" /*a17b*/, "hnut" /*a17c*/, "nit" /*a17d*/, "nix" /*a17e*/, "ni" /*a17f*/, "nip" /*a180*/, "niex" /*a181*/, "nie" /*a182*/, "niep" /*a183*/, "nax" /*a184*/, "na" /*a185*/, "nap" /*a186*/, "nuox" /*a187*/, "nuo" /*a188*/, "nuop" /*a189*/, "not" /*a18a*/, "nox" /*a18b*/, "no" /*a18c*/, "nop" /*a18d*/, "nex" /*a18e*/, "ne" /*a18f*/, "nep" /*a190*/, "nut" /*a191*/, "nux" /*a192*/, "nu" /*a193*/, "nup" /*a194*/, "nurx" /*a195*/, "nur" /*a196*/, "hlit" /*a197*/, "hlix" /*a198*/, "hli" /*a199*/, "hlip" /*a19a*/, "hliex" /*a19b*/, "hlie" /*a19c*/, "hliep" /*a19d*/, "hlat" /*a19e*/, "hlax" /*a19f*/, "hla" /*a1a0*/, "hlap" /*a1a1*/, "hluox" /*a1a2*/, "hluo" /*a1a3*/, "hluop" /*a1a4*/, "hlox" /*a1a5*/, "hlo" /*a1a6*/, "hlop" /*a1a7*/, "hlex" /*a1a8*/, "hle" /*a1a9*/, "hlep" /*a1aa*/, "hlut" /*a1ab*/, "hlux" /*a1ac*/, "hlu" /*a1ad*/, "hlup" /*a1ae*/, "hlurx" /*a1af*/, "hlur" /*a1b0*/, "hlyt" /*a1b1*/, "hlyx" /*a1b2*/, "hly" /*a1b3*/, "hlyp" /*a1b4*/, "hlyrx" /*a1b5*/, "hlyr" /*a1b6*/, "lit" /*a1b7*/, "lix" /*a1b8*/, "li" /*a1b9*/, "lip" /*a1ba*/, "liet" /*a1bb*/, "liex" /*a1bc*/, "lie" /*a1bd*/, "liep" /*a1be*/, "lat" /*a1bf*/, "lax" /*a1c0*/, "la" /*a1c1*/, "lap" /*a1c2*/, "luot" /*a1c3*/, "luox" /*a1c4*/, "luo" /*a1c5*/, "luop" /*a1c6*/, "lot" /*a1c7*/, "lox" /*a1c8*/, "lo" /*a1c9*/, "lop" /*a1ca*/, "lex" /*a1cb*/, "le" /*a1cc*/, "lep" /*a1cd*/, "lut" /*a1ce*/, "lux" /*a1cf*/, "lu" /*a1d0*/, "lup" /*a1d1*/, "lurx" /*a1d2*/, "lur" /*a1d3*/, "lyt" /*a1d4*/, "lyx" /*a1d5*/, "ly" /*a1d6*/, "lyp" /*a1d7*/, "lyrx" /*a1d8*/, "lyr" /*a1d9*/, "git" /*a1da*/, "gix" /*a1db*/, "gi" /*a1dc*/, "gip" /*a1dd*/, "giet" /*a1de*/, "giex" /*a1df*/, "gie" /*a1e0*/, "giep" /*a1e1*/, "gat" /*a1e2*/, "gax" /*a1e3*/, "ga" /*a1e4*/, "gap" /*a1e5*/, "guot" /*a1e6*/, "guox" /*a1e7*/, "guo" /*a1e8*/, "guop" /*a1e9*/, "got" /*a1ea*/, "gox" /*a1eb*/, "go" /*a1ec*/, "gop" /*a1ed*/, "get" /*a1ee*/, "gex" /*a1ef*/, "ge" /*a1f0*/, "gep" /*a1f1*/, "gut" /*a1f2*/, "gux" /*a1f3*/, "gu" /*a1f4*/, "gup" /*a1f5*/, "gurx" /*a1f6*/, "gur" /*a1f7*/, "kit" /*a1f8*/, "kix" /*a1f9*/, "ki" /*a1fa*/, "kip" /*a1fb*/, "kiex" /*a1fc*/, "kie" /*a1fd*/, "kiep" /*a1fe*/, "kat" /*a1ff*/ 
			});
						characters.TryAdd(162 /*41472 a2*/, new string[] {
				"kax" /*a200*/, "ka" /*a201*/, "kap" /*a202*/, "kuox" /*a203*/, "kuo" /*a204*/, "kuop" /*a205*/, "kot" /*a206*/, "kox" /*a207*/, "ko" /*a208*/, "kop" /*a209*/, "ket" /*a20a*/, "kex" /*a20b*/, "ke" /*a20c*/, "kep" /*a20d*/, "kut" /*a20e*/, "kux" /*a20f*/, "ku" /*a210*/, "kup" /*a211*/, "kurx" /*a212*/, "kur" /*a213*/, "ggit" /*a214*/, "ggix" /*a215*/, "ggi" /*a216*/, "ggiex" /*a217*/, "ggie" /*a218*/, "ggiep" /*a219*/, "ggat" /*a21a*/, "ggax" /*a21b*/, "gga" /*a21c*/, "ggap" /*a21d*/, "gguot" /*a21e*/, "gguox" /*a21f*/, "gguo" /*a220*/, "gguop" /*a221*/, "ggot" /*a222*/, "ggox" /*a223*/, "ggo" /*a224*/, "ggop" /*a225*/, "gget" /*a226*/, "ggex" /*a227*/, "gge" /*a228*/, "ggep" /*a229*/, "ggut" /*a22a*/, "ggux" /*a22b*/, "ggu" /*a22c*/, "ggup" /*a22d*/, "ggurx" /*a22e*/, "ggur" /*a22f*/, "mgiex" /*a230*/, "mgie" /*a231*/, "mgat" /*a232*/, "mgax" /*a233*/, "mga" /*a234*/, "mgap" /*a235*/, "mguox" /*a236*/, "mguo" /*a237*/, "mguop" /*a238*/, "mgot" /*a239*/, "mgox" /*a23a*/, "mgo" /*a23b*/, "mgop" /*a23c*/, "mgex" /*a23d*/, "mge" /*a23e*/, "mgep" /*a23f*/, "mgut" /*a240*/, "mgux" /*a241*/, "mgu" /*a242*/, "mgup" /*a243*/, "mgurx" /*a244*/, "mgur" /*a245*/, "hxit" /*a246*/, "hxix" /*a247*/, "hxi" /*a248*/, "hxip" /*a249*/, "hxiet" /*a24a*/, "hxiex" /*a24b*/, "hxie" /*a24c*/, "hxiep" /*a24d*/, "hxat" /*a24e*/, "hxax" /*a24f*/, "hxa" /*a250*/, "hxap" /*a251*/, "hxuot" /*a252*/, "hxuox" /*a253*/, "hxuo" /*a254*/, "hxuop" /*a255*/, "hxot" /*a256*/, "hxox" /*a257*/, "hxo" /*a258*/, "hxop" /*a259*/, "hxex" /*a25a*/, "hxe" /*a25b*/, "hxep" /*a25c*/, "ngiex" /*a25d*/, "ngie" /*a25e*/, "ngiep" /*a25f*/, "ngat" /*a260*/, "ngax" /*a261*/, "nga" /*a262*/, "ngap" /*a263*/, "nguot" /*a264*/, "nguox" /*a265*/, "nguo" /*a266*/, "ngot" /*a267*/, "ngox" /*a268*/, "ngo" /*a269*/, "ngop" /*a26a*/, "ngex" /*a26b*/, "nge" /*a26c*/, "ngep" /*a26d*/, "hit" /*a26e*/, "hiex" /*a26f*/, "hie" /*a270*/, "hat" /*a271*/, "hax" /*a272*/, "ha" /*a273*/, "hap" /*a274*/, "huot" /*a275*/, "huox" /*a276*/, "huo" /*a277*/, "huop" /*a278*/, "hot" /*a279*/, "hox" /*a27a*/, "ho" /*a27b*/, "hop" /*a27c*/, "hex" /*a27d*/, "he" /*a27e*/, "hep" /*a27f*/, "wat" /*a280*/, "wax" /*a281*/, "wa" /*a282*/, "wap" /*a283*/, "wuox" /*a284*/, "wuo" /*a285*/, "wuop" /*a286*/, "wox" /*a287*/, "wo" /*a288*/, "wop" /*a289*/, "wex" /*a28a*/, "we" /*a28b*/, "wep" /*a28c*/, "zit" /*a28d*/, "zix" /*a28e*/, "zi" /*a28f*/, "zip" /*a290*/, "ziex" /*a291*/, "zie" /*a292*/, "ziep" /*a293*/, "zat" /*a294*/, "zax" /*a295*/, "za" /*a296*/, "zap" /*a297*/, "zuox" /*a298*/, "zuo" /*a299*/, "zuop" /*a29a*/, "zot" /*a29b*/, "zox" /*a29c*/, "zo" /*a29d*/, "zop" /*a29e*/, "zex" /*a29f*/, "ze" /*a2a0*/, "zep" /*a2a1*/, "zut" /*a2a2*/, "zux" /*a2a3*/, "zu" /*a2a4*/, "zup" /*a2a5*/, "zurx" /*a2a6*/, "zur" /*a2a7*/, "zyt" /*a2a8*/, "zyx" /*a2a9*/, "zy" /*a2aa*/, "zyp" /*a2ab*/, "zyrx" /*a2ac*/, "zyr" /*a2ad*/, "cit" /*a2ae*/, "cix" /*a2af*/, "ci" /*a2b0*/, "cip" /*a2b1*/, "ciet" /*a2b2*/, "ciex" /*a2b3*/, "cie" /*a2b4*/, "ciep" /*a2b5*/, "cat" /*a2b6*/, "cax" /*a2b7*/, "ca" /*a2b8*/, "cap" /*a2b9*/, "cuox" /*a2ba*/, "cuo" /*a2bb*/, "cuop" /*a2bc*/, "cot" /*a2bd*/, "cox" /*a2be*/, "co" /*a2bf*/, "cop" /*a2c0*/, "cex" /*a2c1*/, "ce" /*a2c2*/, "cep" /*a2c3*/, "cut" /*a2c4*/, "cux" /*a2c5*/, "cu" /*a2c6*/, "cup" /*a2c7*/, "curx" /*a2c8*/, "cur" /*a2c9*/, "cyt" /*a2ca*/, "cyx" /*a2cb*/, "cy" /*a2cc*/, "cyp" /*a2cd*/, "cyrx" /*a2ce*/, "cyr" /*a2cf*/, "zzit" /*a2d0*/, "zzix" /*a2d1*/, "zzi" /*a2d2*/, "zzip" /*a2d3*/, "zziet" /*a2d4*/, "zziex" /*a2d5*/, "zzie" /*a2d6*/, "zziep" /*a2d7*/, "zzat" /*a2d8*/, "zzax" /*a2d9*/, "zza" /*a2da*/, "zzap" /*a2db*/, "zzox" /*a2dc*/, "zzo" /*a2dd*/, "zzop" /*a2de*/, "zzex" /*a2df*/, "zze" /*a2e0*/, "zzep" /*a2e1*/, "zzux" /*a2e2*/, "zzu" /*a2e3*/, "zzup" /*a2e4*/, "zzurx" /*a2e5*/, "zzur" /*a2e6*/, "zzyt" /*a2e7*/, "zzyx" /*a2e8*/, "zzy" /*a2e9*/, "zzyp" /*a2ea*/, "zzyrx" /*a2eb*/, "zzyr" /*a2ec*/, "nzit" /*a2ed*/, "nzix" /*a2ee*/, "nzi" /*a2ef*/, "nzip" /*a2f0*/, "nziex" /*a2f1*/, "nzie" /*a2f2*/, "nziep" /*a2f3*/, "nzat" /*a2f4*/, "nzax" /*a2f5*/, "nza" /*a2f6*/, "nzap" /*a2f7*/, "nzuox" /*a2f8*/, "nzuo" /*a2f9*/, "nzox" /*a2fa*/, "nzop" /*a2fb*/, "nzex" /*a2fc*/, "nze" /*a2fd*/, "nzux" /*a2fe*/, "nzu" /*a2ff*/ 
			});
						characters.TryAdd(163 /*41728 a3*/, new string[] {
				"nzup" /*a300*/, "nzurx" /*a301*/, "nzur" /*a302*/, "nzyt" /*a303*/, "nzyx" /*a304*/, "nzy" /*a305*/, "nzyp" /*a306*/, "nzyrx" /*a307*/, "nzyr" /*a308*/, "sit" /*a309*/, "six" /*a30a*/, "si" /*a30b*/, "sip" /*a30c*/, "siex" /*a30d*/, "sie" /*a30e*/, "siep" /*a30f*/, "sat" /*a310*/, "sax" /*a311*/, "sa" /*a312*/, "sap" /*a313*/, "suox" /*a314*/, "suo" /*a315*/, "suop" /*a316*/, "sot" /*a317*/, "sox" /*a318*/, "so" /*a319*/, "sop" /*a31a*/, "sex" /*a31b*/, "se" /*a31c*/, "sep" /*a31d*/, "sut" /*a31e*/, "sux" /*a31f*/, "su" /*a320*/, "sup" /*a321*/, "surx" /*a322*/, "sur" /*a323*/, "syt" /*a324*/, "syx" /*a325*/, "sy" /*a326*/, "syp" /*a327*/, "syrx" /*a328*/, "syr" /*a329*/, "ssit" /*a32a*/, "ssix" /*a32b*/, "ssi" /*a32c*/, "ssip" /*a32d*/, "ssiex" /*a32e*/, "ssie" /*a32f*/, "ssiep" /*a330*/, "ssat" /*a331*/, "ssax" /*a332*/, "ssa" /*a333*/, "ssap" /*a334*/, "ssot" /*a335*/, "ssox" /*a336*/, "sso" /*a337*/, "ssop" /*a338*/, "ssex" /*a339*/, "sse" /*a33a*/, "ssep" /*a33b*/, "ssut" /*a33c*/, "ssux" /*a33d*/, "ssu" /*a33e*/, "ssup" /*a33f*/, "ssyt" /*a340*/, "ssyx" /*a341*/, "ssy" /*a342*/, "ssyp" /*a343*/, "ssyrx" /*a344*/, "ssyr" /*a345*/, "zhat" /*a346*/, "zhax" /*a347*/, "zha" /*a348*/, "zhap" /*a349*/, "zhuox" /*a34a*/, "zhuo" /*a34b*/, "zhuop" /*a34c*/, "zhot" /*a34d*/, "zhox" /*a34e*/, "zho" /*a34f*/, "zhop" /*a350*/, "zhet" /*a351*/, "zhex" /*a352*/, "zhe" /*a353*/, "zhep" /*a354*/, "zhut" /*a355*/, "zhux" /*a356*/, "zhu" /*a357*/, "zhup" /*a358*/, "zhurx" /*a359*/, "zhur" /*a35a*/, "zhyt" /*a35b*/, "zhyx" /*a35c*/, "zhy" /*a35d*/, "zhyp" /*a35e*/, "zhyrx" /*a35f*/, "zhyr" /*a360*/, "chat" /*a361*/, "chax" /*a362*/, "cha" /*a363*/, "chap" /*a364*/, "chuot" /*a365*/, "chuox" /*a366*/, "chuo" /*a367*/, "chuop" /*a368*/, "chot" /*a369*/, "chox" /*a36a*/, "cho" /*a36b*/, "chop" /*a36c*/, "chet" /*a36d*/, "chex" /*a36e*/, "che" /*a36f*/, "chep" /*a370*/, "chux" /*a371*/, "chu" /*a372*/, "chup" /*a373*/, "churx" /*a374*/, "chur" /*a375*/, "chyt" /*a376*/, "chyx" /*a377*/, "chy" /*a378*/, "chyp" /*a379*/, "chyrx" /*a37a*/, "chyr" /*a37b*/, "rrax" /*a37c*/, "rra" /*a37d*/, "rruox" /*a37e*/, "rruo" /*a37f*/, "rrot" /*a380*/, "rrox" /*a381*/, "rro" /*a382*/, "rrop" /*a383*/, "rret" /*a384*/, "rrex" /*a385*/, "rre" /*a386*/, "rrep" /*a387*/, "rrut" /*a388*/, "rrux" /*a389*/, "rru" /*a38a*/, "rrup" /*a38b*/, "rrurx" /*a38c*/, "rrur" /*a38d*/, "rryt" /*a38e*/, "rryx" /*a38f*/, "rry" /*a390*/, "rryp" /*a391*/, "rryrx" /*a392*/, "rryr" /*a393*/, "nrat" /*a394*/, "nrax" /*a395*/, "nra" /*a396*/, "nrap" /*a397*/, "nrox" /*a398*/, "nro" /*a399*/, "nrop" /*a39a*/, "nret" /*a39b*/, "nrex" /*a39c*/, "nre" /*a39d*/, "nrep" /*a39e*/, "nrut" /*a39f*/, "nrux" /*a3a0*/, "nru" /*a3a1*/, "nrup" /*a3a2*/, "nrurx" /*a3a3*/, "nrur" /*a3a4*/, "nryt" /*a3a5*/, "nryx" /*a3a6*/, "nry" /*a3a7*/, "nryp" /*a3a8*/, "nryrx" /*a3a9*/, "nryr" /*a3aa*/, "shat" /*a3ab*/, "shax" /*a3ac*/, "sha" /*a3ad*/, "shap" /*a3ae*/, "shuox" /*a3af*/, "shuo" /*a3b0*/, "shuop" /*a3b1*/, "shot" /*a3b2*/, "shox" /*a3b3*/, "sho" /*a3b4*/, "shop" /*a3b5*/, "shet" /*a3b6*/, "shex" /*a3b7*/, "she" /*a3b8*/, "shep" /*a3b9*/, "shut" /*a3ba*/, "shux" /*a3bb*/, "shu" /*a3bc*/, "shup" /*a3bd*/, "shurx" /*a3be*/, "shur" /*a3bf*/, "shyt" /*a3c0*/, "shyx" /*a3c1*/, "shy" /*a3c2*/, "shyp" /*a3c3*/, "shyrx" /*a3c4*/, "shyr" /*a3c5*/, "rat" /*a3c6*/, "rax" /*a3c7*/, "ra" /*a3c8*/, "rap" /*a3c9*/, "ruox" /*a3ca*/, "ruo" /*a3cb*/, "ruop" /*a3cc*/, "rot" /*a3cd*/, "rox" /*a3ce*/, "ro" /*a3cf*/, "rop" /*a3d0*/, "rex" /*a3d1*/, "re" /*a3d2*/, "rep" /*a3d3*/, "rut" /*a3d4*/, "rux" /*a3d5*/, "ru" /*a3d6*/, "rup" /*a3d7*/, "rurx" /*a3d8*/, "rur" /*a3d9*/, "ryt" /*a3da*/, "ryx" /*a3db*/, "ry" /*a3dc*/, "ryp" /*a3dd*/, "ryrx" /*a3de*/, "ryr" /*a3df*/, "jit" /*a3e0*/, "jix" /*a3e1*/, "ji" /*a3e2*/, "jip" /*a3e3*/, "jiet" /*a3e4*/, "jiex" /*a3e5*/, "jie" /*a3e6*/, "jiep" /*a3e7*/, "juot" /*a3e8*/, "juox" /*a3e9*/, "juo" /*a3ea*/, "juop" /*a3eb*/, "jot" /*a3ec*/, "jox" /*a3ed*/, "jo" /*a3ee*/, "jop" /*a3ef*/, "jut" /*a3f0*/, "jux" /*a3f1*/, "ju" /*a3f2*/, "jup" /*a3f3*/, "jurx" /*a3f4*/, "jur" /*a3f5*/, "jyt" /*a3f6*/, "jyx" /*a3f7*/, "jy" /*a3f8*/, "jyp" /*a3f9*/, "jyrx" /*a3fa*/, "jyr" /*a3fb*/, "qit" /*a3fc*/, "qix" /*a3fd*/, "qi" /*a3fe*/, "qip" /*a3ff*/ 
			});
						characters.TryAdd(164 /*41984 a4*/, new string[] {
				"qiet" /*a400*/, "qiex" /*a401*/, "qie" /*a402*/, "qiep" /*a403*/, "quot" /*a404*/, "quox" /*a405*/, "quo" /*a406*/, "quop" /*a407*/, "qot" /*a408*/, "qox" /*a409*/, "qo" /*a40a*/, "qop" /*a40b*/, "qut" /*a40c*/, "qux" /*a40d*/, "qu" /*a40e*/, "qup" /*a40f*/, "qurx" /*a410*/, "qur" /*a411*/, "qyt" /*a412*/, "qyx" /*a413*/, "qy" /*a414*/, "qyp" /*a415*/, "qyrx" /*a416*/, "qyr" /*a417*/, "jjit" /*a418*/, "jjix" /*a419*/, "jji" /*a41a*/, "jjip" /*a41b*/, "jjiet" /*a41c*/, "jjiex" /*a41d*/, "jjie" /*a41e*/, "jjiep" /*a41f*/, "jjuox" /*a420*/, "jjuo" /*a421*/, "jjuop" /*a422*/, "jjot" /*a423*/, "jjox" /*a424*/, "jjo" /*a425*/, "jjop" /*a426*/, "jjut" /*a427*/, "jjux" /*a428*/, "jju" /*a429*/, "jjup" /*a42a*/, "jjurx" /*a42b*/, "jjur" /*a42c*/, "jjyt" /*a42d*/, "jjyx" /*a42e*/, "jjy" /*a42f*/, "jjyp" /*a430*/, "njit" /*a431*/, "njix" /*a432*/, "nji" /*a433*/, "njip" /*a434*/, "njiet" /*a435*/, "njiex" /*a436*/, "njie" /*a437*/, "njiep" /*a438*/, "njuox" /*a439*/, "njuo" /*a43a*/, "njot" /*a43b*/, "njox" /*a43c*/, "njo" /*a43d*/, "njop" /*a43e*/, "njux" /*a43f*/, "nju" /*a440*/, "njup" /*a441*/, "njurx" /*a442*/, "njur" /*a443*/, "njyt" /*a444*/, "njyx" /*a445*/, "njy" /*a446*/, "njyp" /*a447*/, "njyrx" /*a448*/, "njyr" /*a449*/, "nyit" /*a44a*/, "nyix" /*a44b*/, "nyi" /*a44c*/, "nyip" /*a44d*/, "nyiet" /*a44e*/, "nyiex" /*a44f*/, "nyie" /*a450*/, "nyiep" /*a451*/, "nyuox" /*a452*/, "nyuo" /*a453*/, "nyuop" /*a454*/, "nyot" /*a455*/, "nyox" /*a456*/, "nyo" /*a457*/, "nyop" /*a458*/, "nyut" /*a459*/, "nyux" /*a45a*/, "nyu" /*a45b*/, "nyup" /*a45c*/, "xit" /*a45d*/, "xix" /*a45e*/, "xi" /*a45f*/, "xip" /*a460*/, "xiet" /*a461*/, "xiex" /*a462*/, "xie" /*a463*/, "xiep" /*a464*/, "xuox" /*a465*/, "xuo" /*a466*/, "xot" /*a467*/, "xox" /*a468*/, "xo" /*a469*/, "xop" /*a46a*/, "xyt" /*a46b*/, "xyx" /*a46c*/, "xy" /*a46d*/, "xyp" /*a46e*/, "xyrx" /*a46f*/, "xyr" /*a470*/, "yit" /*a471*/, "yix" /*a472*/, "yi" /*a473*/, "yip" /*a474*/, "yiet" /*a475*/, "yiex" /*a476*/, "yie" /*a477*/, "yiep" /*a478*/, "yuot" /*a479*/, "yuox" /*a47a*/, "yuo" /*a47b*/, "yuop" /*a47c*/, "yot" /*a47d*/, "yox" /*a47e*/, "yo" /*a47f*/, "yop" /*a480*/, "yut" /*a481*/, "yux" /*a482*/, "yu" /*a483*/, "yup" /*a484*/, "yurx" /*a485*/, "yur" /*a486*/, "yyt" /*a487*/, "yyx" /*a488*/, "yy" /*a489*/, "yyp" /*a48a*/, "yyrx" /*a48b*/, "yyr" /*a48c*/, "[?]" /*a48d*/, "[?]" /*a48e*/, "[?]" /*a48f*/, "Qot" /*a490*/, "Li" /*a491*/, "Kit" /*a492*/, "Nyip" /*a493*/, "Cyp" /*a494*/, "Ssi" /*a495*/, "Ggop" /*a496*/, "Gep" /*a497*/, "Mi" /*a498*/, "Hxit" /*a499*/, "Lyr" /*a49a*/, "Bbut" /*a49b*/, "Mop" /*a49c*/, "Yo" /*a49d*/, "Put" /*a49e*/, "Hxuo" /*a49f*/, "Tat" /*a4a0*/, "Ga" /*a4a1*/, "[?]" /*a4a2*/, "[?]" /*a4a3*/, "Ddur" /*a4a4*/, "Bur" /*a4a5*/, "Gguo" /*a4a6*/, "Nyop" /*a4a7*/, "Tu" /*a4a8*/, "Op" /*a4a9*/, "Jjut" /*a4aa*/, "Zot" /*a4ab*/, "Pyt" /*a4ac*/, "Hmo" /*a4ad*/, "Yit" /*a4ae*/, "Vur" /*a4af*/, "Shy" /*a4b0*/, "Vep" /*a4b1*/, "Za" /*a4b2*/, "Jo" /*a4b3*/, "[?]" /*a4b4*/, "Jjy" /*a4b5*/, "Got" /*a4b6*/, "Jjie" /*a4b7*/, "Wo" /*a4b8*/, "Du" /*a4b9*/, "Shur" /*a4ba*/, "Lie" /*a4bb*/, "Cy" /*a4bc*/, "Cuop" /*a4bd*/, "Cip" /*a4be*/, "Hxop" /*a4bf*/, "Shat" /*a4c0*/, "[?]" /*a4c1*/, "Shop" /*a4c2*/, "Che" /*a4c3*/, "Zziet" /*a4c4*/, "[?]" /*a4c5*/, "Ke" /*a4c6*/, "[?]" /*a4c7*/, "[?]" /*a4c8*/, "[?]" /*a4c9*/, "[?]" /*a4ca*/, "[?]" /*a4cb*/, "[?]" /*a4cc*/, "[?]" /*a4cd*/, "[?]" /*a4ce*/, "[?]" /*a4cf*/, "[?]" /*a4d0*/, "[?]" /*a4d1*/, "[?]" /*a4d2*/, "[?]" /*a4d3*/, "[?]" /*a4d4*/, "[?]" /*a4d5*/, "[?]" /*a4d6*/, "[?]" /*a4d7*/, "[?]" /*a4d8*/, "[?]" /*a4d9*/, "[?]" /*a4da*/, "[?]" /*a4db*/, "[?]" /*a4dc*/, "[?]" /*a4dd*/, "[?]" /*a4de*/, "[?]" /*a4df*/, "[?]" /*a4e0*/, "[?]" /*a4e1*/, "[?]" /*a4e2*/, "[?]" /*a4e3*/, "[?]" /*a4e4*/, "[?]" /*a4e5*/, "[?]" /*a4e6*/, "[?]" /*a4e7*/, "[?]" /*a4e8*/, "[?]" /*a4e9*/, "[?]" /*a4ea*/, "[?]" /*a4eb*/, "[?]" /*a4ec*/, "[?]" /*a4ed*/, "[?]" /*a4ee*/, "[?]" /*a4ef*/, "[?]" /*a4f0*/, "[?]" /*a4f1*/, "[?]" /*a4f2*/, "[?]" /*a4f3*/, "[?]" /*a4f4*/, "[?]" /*a4f5*/, "[?]" /*a4f6*/, "[?]" /*a4f7*/, "[?]" /*a4f8*/, "[?]" /*a4f9*/, "[?]" /*a4fa*/, "[?]" /*a4fb*/, "[?]" /*a4fc*/, "[?]" /*a4fd*/, "[?]" /*a4fe*/, 
			});
						characters.TryAdd(172 /*44032 ac*/, new string[] {
				"ga" /*ac00*/, "gag" /*ac01*/, "gagg" /*ac02*/, "gags" /*ac03*/, "gan" /*ac04*/, "ganj" /*ac05*/, "ganh" /*ac06*/, "gad" /*ac07*/, "gal" /*ac08*/, "galg" /*ac09*/, "galm" /*ac0a*/, "galb" /*ac0b*/, "gals" /*ac0c*/, "galt" /*ac0d*/, "galp" /*ac0e*/, "galh" /*ac0f*/, "gam" /*ac10*/, "gab" /*ac11*/, "gabs" /*ac12*/, "gas" /*ac13*/, "gass" /*ac14*/, "gang" /*ac15*/, "gaj" /*ac16*/, "gac" /*ac17*/, "gak" /*ac18*/, "gat" /*ac19*/, "gap" /*ac1a*/, "gah" /*ac1b*/, "gae" /*ac1c*/, "gaeg" /*ac1d*/, "gaegg" /*ac1e*/, "gaegs" /*ac1f*/, "gaen" /*ac20*/, "gaenj" /*ac21*/, "gaenh" /*ac22*/, "gaed" /*ac23*/, "gael" /*ac24*/, "gaelg" /*ac25*/, "gaelm" /*ac26*/, "gaelb" /*ac27*/, "gaels" /*ac28*/, "gaelt" /*ac29*/, "gaelp" /*ac2a*/, "gaelh" /*ac2b*/, "gaem" /*ac2c*/, "gaeb" /*ac2d*/, "gaebs" /*ac2e*/, "gaes" /*ac2f*/, "gaess" /*ac30*/, "gaeng" /*ac31*/, "gaej" /*ac32*/, "gaec" /*ac33*/, "gaek" /*ac34*/, "gaet" /*ac35*/, "gaep" /*ac36*/, "gaeh" /*ac37*/, "gya" /*ac38*/, "gyag" /*ac39*/, "gyagg" /*ac3a*/, "gyags" /*ac3b*/, "gyan" /*ac3c*/, "gyanj" /*ac3d*/, "gyanh" /*ac3e*/, "gyad" /*ac3f*/, "gyal" /*ac40*/, "gyalg" /*ac41*/, "gyalm" /*ac42*/, "gyalb" /*ac43*/, "gyals" /*ac44*/, "gyalt" /*ac45*/, "gyalp" /*ac46*/, "gyalh" /*ac47*/, "gyam" /*ac48*/, "gyab" /*ac49*/, "gyabs" /*ac4a*/, "gyas" /*ac4b*/, "gyass" /*ac4c*/, "gyang" /*ac4d*/, "gyaj" /*ac4e*/, "gyac" /*ac4f*/, "gyak" /*ac50*/, "gyat" /*ac51*/, "gyap" /*ac52*/, "gyah" /*ac53*/, "gyae" /*ac54*/, "gyaeg" /*ac55*/, "gyaegg" /*ac56*/, "gyaegs" /*ac57*/, "gyaen" /*ac58*/, "gyaenj" /*ac59*/, "gyaenh" /*ac5a*/, "gyaed" /*ac5b*/, "gyael" /*ac5c*/, "gyaelg" /*ac5d*/, "gyaelm" /*ac5e*/, "gyaelb" /*ac5f*/, "gyaels" /*ac60*/, "gyaelt" /*ac61*/, "gyaelp" /*ac62*/, "gyaelh" /*ac63*/, "gyaem" /*ac64*/, "gyaeb" /*ac65*/, "gyaebs" /*ac66*/, "gyaes" /*ac67*/, "gyaess" /*ac68*/, "gyaeng" /*ac69*/, "gyaej" /*ac6a*/, "gyaec" /*ac6b*/, "gyaek" /*ac6c*/, "gyaet" /*ac6d*/, "gyaep" /*ac6e*/, "gyaeh" /*ac6f*/, "geo" /*ac70*/, "geog" /*ac71*/, "geogg" /*ac72*/, "geogs" /*ac73*/, "geon" /*ac74*/, "geonj" /*ac75*/, "geonh" /*ac76*/, "geod" /*ac77*/, "geol" /*ac78*/, "geolg" /*ac79*/, "geolm" /*ac7a*/, "geolb" /*ac7b*/, "geols" /*ac7c*/, "geolt" /*ac7d*/, "geolp" /*ac7e*/, "geolh" /*ac7f*/, "geom" /*ac80*/, "geob" /*ac81*/, "geobs" /*ac82*/, "geos" /*ac83*/, "geoss" /*ac84*/, "geong" /*ac85*/, "geoj" /*ac86*/, "geoc" /*ac87*/, "geok" /*ac88*/, "geot" /*ac89*/, "geop" /*ac8a*/, "geoh" /*ac8b*/, "ge" /*ac8c*/, "geg" /*ac8d*/, "gegg" /*ac8e*/, "gegs" /*ac8f*/, "gen" /*ac90*/, "genj" /*ac91*/, "genh" /*ac92*/, "ged" /*ac93*/, "gel" /*ac94*/, "gelg" /*ac95*/, "gelm" /*ac96*/, "gelb" /*ac97*/, "gels" /*ac98*/, "gelt" /*ac99*/, "gelp" /*ac9a*/, "gelh" /*ac9b*/, "gem" /*ac9c*/, "geb" /*ac9d*/, "gebs" /*ac9e*/, "ges" /*ac9f*/, "gess" /*aca0*/, "geng" /*aca1*/, "gej" /*aca2*/, "gec" /*aca3*/, "gek" /*aca4*/, "get" /*aca5*/, "gep" /*aca6*/, "geh" /*aca7*/, "gyeo" /*aca8*/, "gyeog" /*aca9*/, "gyeogg" /*acaa*/, "gyeogs" /*acab*/, "gyeon" /*acac*/, "gyeonj" /*acad*/, "gyeonh" /*acae*/, "gyeod" /*acaf*/, "gyeol" /*acb0*/, "gyeolg" /*acb1*/, "gyeolm" /*acb2*/, "gyeolb" /*acb3*/, "gyeols" /*acb4*/, "gyeolt" /*acb5*/, "gyeolp" /*acb6*/, "gyeolh" /*acb7*/, "gyeom" /*acb8*/, "gyeob" /*acb9*/, "gyeobs" /*acba*/, "gyeos" /*acbb*/, "gyeoss" /*acbc*/, "gyeong" /*acbd*/, "gyeoj" /*acbe*/, "gyeoc" /*acbf*/, "gyeok" /*acc0*/, "gyeot" /*acc1*/, "gyeop" /*acc2*/, "gyeoh" /*acc3*/, "gye" /*acc4*/, "gyeg" /*acc5*/, "gyegg" /*acc6*/, "gyegs" /*acc7*/, "gyen" /*acc8*/, "gyenj" /*acc9*/, "gyenh" /*acca*/, "gyed" /*accb*/, "gyel" /*accc*/, "gyelg" /*accd*/, "gyelm" /*acce*/, "gyelb" /*accf*/, "gyels" /*acd0*/, "gyelt" /*acd1*/, "gyelp" /*acd2*/, "gyelh" /*acd3*/, "gyem" /*acd4*/, "gyeb" /*acd5*/, "gyebs" /*acd6*/, "gyes" /*acd7*/, "gyess" /*acd8*/, "gyeng" /*acd9*/, "gyej" /*acda*/, "gyec" /*acdb*/, "gyek" /*acdc*/, "gyet" /*acdd*/, "gyep" /*acde*/, "gyeh" /*acdf*/, "go" /*ace0*/, "gog" /*ace1*/, "gogg" /*ace2*/, "gogs" /*ace3*/, "gon" /*ace4*/, "gonj" /*ace5*/, "gonh" /*ace6*/, "god" /*ace7*/, "gol" /*ace8*/, "golg" /*ace9*/, "golm" /*acea*/, "golb" /*aceb*/, "gols" /*acec*/, "golt" /*aced*/, "golp" /*acee*/, "golh" /*acef*/, "gom" /*acf0*/, "gob" /*acf1*/, "gobs" /*acf2*/, "gos" /*acf3*/, "goss" /*acf4*/, "gong" /*acf5*/, "goj" /*acf6*/, "goc" /*acf7*/, "gok" /*acf8*/, "got" /*acf9*/, "gop" /*acfa*/, "goh" /*acfb*/, "gwa" /*acfc*/, "gwag" /*acfd*/, "gwagg" /*acfe*/, "gwags" /*acff*/ 
			});
						characters.TryAdd(173 /*44288 ad*/, new string[] {
				"gwan" /*ad00*/, "gwanj" /*ad01*/, "gwanh" /*ad02*/, "gwad" /*ad03*/, "gwal" /*ad04*/, "gwalg" /*ad05*/, "gwalm" /*ad06*/, "gwalb" /*ad07*/, "gwals" /*ad08*/, "gwalt" /*ad09*/, "gwalp" /*ad0a*/, "gwalh" /*ad0b*/, "gwam" /*ad0c*/, "gwab" /*ad0d*/, "gwabs" /*ad0e*/, "gwas" /*ad0f*/, "gwass" /*ad10*/, "gwang" /*ad11*/, "gwaj" /*ad12*/, "gwac" /*ad13*/, "gwak" /*ad14*/, "gwat" /*ad15*/, "gwap" /*ad16*/, "gwah" /*ad17*/, "gwae" /*ad18*/, "gwaeg" /*ad19*/, "gwaegg" /*ad1a*/, "gwaegs" /*ad1b*/, "gwaen" /*ad1c*/, "gwaenj" /*ad1d*/, "gwaenh" /*ad1e*/, "gwaed" /*ad1f*/, "gwael" /*ad20*/, "gwaelg" /*ad21*/, "gwaelm" /*ad22*/, "gwaelb" /*ad23*/, "gwaels" /*ad24*/, "gwaelt" /*ad25*/, "gwaelp" /*ad26*/, "gwaelh" /*ad27*/, "gwaem" /*ad28*/, "gwaeb" /*ad29*/, "gwaebs" /*ad2a*/, "gwaes" /*ad2b*/, "gwaess" /*ad2c*/, "gwaeng" /*ad2d*/, "gwaej" /*ad2e*/, "gwaec" /*ad2f*/, "gwaek" /*ad30*/, "gwaet" /*ad31*/, "gwaep" /*ad32*/, "gwaeh" /*ad33*/, "goe" /*ad34*/, "goeg" /*ad35*/, "goegg" /*ad36*/, "goegs" /*ad37*/, "goen" /*ad38*/, "goenj" /*ad39*/, "goenh" /*ad3a*/, "goed" /*ad3b*/, "goel" /*ad3c*/, "goelg" /*ad3d*/, "goelm" /*ad3e*/, "goelb" /*ad3f*/, "goels" /*ad40*/, "goelt" /*ad41*/, "goelp" /*ad42*/, "goelh" /*ad43*/, "goem" /*ad44*/, "goeb" /*ad45*/, "goebs" /*ad46*/, "goes" /*ad47*/, "goess" /*ad48*/, "goeng" /*ad49*/, "goej" /*ad4a*/, "goec" /*ad4b*/, "goek" /*ad4c*/, "goet" /*ad4d*/, "goep" /*ad4e*/, "goeh" /*ad4f*/, "gyo" /*ad50*/, "gyog" /*ad51*/, "gyogg" /*ad52*/, "gyogs" /*ad53*/, "gyon" /*ad54*/, "gyonj" /*ad55*/, "gyonh" /*ad56*/, "gyod" /*ad57*/, "gyol" /*ad58*/, "gyolg" /*ad59*/, "gyolm" /*ad5a*/, "gyolb" /*ad5b*/, "gyols" /*ad5c*/, "gyolt" /*ad5d*/, "gyolp" /*ad5e*/, "gyolh" /*ad5f*/, "gyom" /*ad60*/, "gyob" /*ad61*/, "gyobs" /*ad62*/, "gyos" /*ad63*/, "gyoss" /*ad64*/, "gyong" /*ad65*/, "gyoj" /*ad66*/, "gyoc" /*ad67*/, "gyok" /*ad68*/, "gyot" /*ad69*/, "gyop" /*ad6a*/, "gyoh" /*ad6b*/, "gu" /*ad6c*/, "gug" /*ad6d*/, "gugg" /*ad6e*/, "gugs" /*ad6f*/, "gun" /*ad70*/, "gunj" /*ad71*/, "gunh" /*ad72*/, "gud" /*ad73*/, "gul" /*ad74*/, "gulg" /*ad75*/, "gulm" /*ad76*/, "gulb" /*ad77*/, "guls" /*ad78*/, "gult" /*ad79*/, "gulp" /*ad7a*/, "gulh" /*ad7b*/, "gum" /*ad7c*/, "gub" /*ad7d*/, "gubs" /*ad7e*/, "gus" /*ad7f*/, "guss" /*ad80*/, "gung" /*ad81*/, "guj" /*ad82*/, "guc" /*ad83*/, "guk" /*ad84*/, "gut" /*ad85*/, "gup" /*ad86*/, "guh" /*ad87*/, "gweo" /*ad88*/, "gweog" /*ad89*/, "gweogg" /*ad8a*/, "gweogs" /*ad8b*/, "gweon" /*ad8c*/, "gweonj" /*ad8d*/, "gweonh" /*ad8e*/, "gweod" /*ad8f*/, "gweol" /*ad90*/, "gweolg" /*ad91*/, "gweolm" /*ad92*/, "gweolb" /*ad93*/, "gweols" /*ad94*/, "gweolt" /*ad95*/, "gweolp" /*ad96*/, "gweolh" /*ad97*/, "gweom" /*ad98*/, "gweob" /*ad99*/, "gweobs" /*ad9a*/, "gweos" /*ad9b*/, "gweoss" /*ad9c*/, "gweong" /*ad9d*/, "gweoj" /*ad9e*/, "gweoc" /*ad9f*/, "gweok" /*ada0*/, "gweot" /*ada1*/, "gweop" /*ada2*/, "gweoh" /*ada3*/, "gwe" /*ada4*/, "gweg" /*ada5*/, "gwegg" /*ada6*/, "gwegs" /*ada7*/, "gwen" /*ada8*/, "gwenj" /*ada9*/, "gwenh" /*adaa*/, "gwed" /*adab*/, "gwel" /*adac*/, "gwelg" /*adad*/, "gwelm" /*adae*/, "gwelb" /*adaf*/, "gwels" /*adb0*/, "gwelt" /*adb1*/, "gwelp" /*adb2*/, "gwelh" /*adb3*/, "gwem" /*adb4*/, "gweb" /*adb5*/, "gwebs" /*adb6*/, "gwes" /*adb7*/, "gwess" /*adb8*/, "gweng" /*adb9*/, "gwej" /*adba*/, "gwec" /*adbb*/, "gwek" /*adbc*/, "gwet" /*adbd*/, "gwep" /*adbe*/, "gweh" /*adbf*/, "gwi" /*adc0*/, "gwig" /*adc1*/, "gwigg" /*adc2*/, "gwigs" /*adc3*/, "gwin" /*adc4*/, "gwinj" /*adc5*/, "gwinh" /*adc6*/, "gwid" /*adc7*/, "gwil" /*adc8*/, "gwilg" /*adc9*/, "gwilm" /*adca*/, "gwilb" /*adcb*/, "gwils" /*adcc*/, "gwilt" /*adcd*/, "gwilp" /*adce*/, "gwilh" /*adcf*/, "gwim" /*add0*/, "gwib" /*add1*/, "gwibs" /*add2*/, "gwis" /*add3*/, "gwiss" /*add4*/, "gwing" /*add5*/, "gwij" /*add6*/, "gwic" /*add7*/, "gwik" /*add8*/, "gwit" /*add9*/, "gwip" /*adda*/, "gwih" /*addb*/, "gyu" /*addc*/, "gyug" /*addd*/, "gyugg" /*adde*/, "gyugs" /*addf*/, "gyun" /*ade0*/, "gyunj" /*ade1*/, "gyunh" /*ade2*/, "gyud" /*ade3*/, "gyul" /*ade4*/, "gyulg" /*ade5*/, "gyulm" /*ade6*/, "gyulb" /*ade7*/, "gyuls" /*ade8*/, "gyult" /*ade9*/, "gyulp" /*adea*/, "gyulh" /*adeb*/, "gyum" /*adec*/, "gyub" /*aded*/, "gyubs" /*adee*/, "gyus" /*adef*/, "gyuss" /*adf0*/, "gyung" /*adf1*/, "gyuj" /*adf2*/, "gyuc" /*adf3*/, "gyuk" /*adf4*/, "gyut" /*adf5*/, "gyup" /*adf6*/, "gyuh" /*adf7*/, "geu" /*adf8*/, "geug" /*adf9*/, "geugg" /*adfa*/, "geugs" /*adfb*/, "geun" /*adfc*/, "geunj" /*adfd*/, "geunh" /*adfe*/, "geud" /*adff*/ 
			});
						characters.TryAdd(174 /*44544 ae*/, new string[] {
				"geul" /*ae00*/, "geulg" /*ae01*/, "geulm" /*ae02*/, "geulb" /*ae03*/, "geuls" /*ae04*/, "geult" /*ae05*/, "geulp" /*ae06*/, "geulh" /*ae07*/, "geum" /*ae08*/, "geub" /*ae09*/, "geubs" /*ae0a*/, "geus" /*ae0b*/, "geuss" /*ae0c*/, "geung" /*ae0d*/, "geuj" /*ae0e*/, "geuc" /*ae0f*/, "geuk" /*ae10*/, "geut" /*ae11*/, "geup" /*ae12*/, "geuh" /*ae13*/, "gyi" /*ae14*/, "gyig" /*ae15*/, "gyigg" /*ae16*/, "gyigs" /*ae17*/, "gyin" /*ae18*/, "gyinj" /*ae19*/, "gyinh" /*ae1a*/, "gyid" /*ae1b*/, "gyil" /*ae1c*/, "gyilg" /*ae1d*/, "gyilm" /*ae1e*/, "gyilb" /*ae1f*/, "gyils" /*ae20*/, "gyilt" /*ae21*/, "gyilp" /*ae22*/, "gyilh" /*ae23*/, "gyim" /*ae24*/, "gyib" /*ae25*/, "gyibs" /*ae26*/, "gyis" /*ae27*/, "gyiss" /*ae28*/, "gying" /*ae29*/, "gyij" /*ae2a*/, "gyic" /*ae2b*/, "gyik" /*ae2c*/, "gyit" /*ae2d*/, "gyip" /*ae2e*/, "gyih" /*ae2f*/, "gi" /*ae30*/, "gig" /*ae31*/, "gigg" /*ae32*/, "gigs" /*ae33*/, "gin" /*ae34*/, "ginj" /*ae35*/, "ginh" /*ae36*/, "gid" /*ae37*/, "gil" /*ae38*/, "gilg" /*ae39*/, "gilm" /*ae3a*/, "gilb" /*ae3b*/, "gils" /*ae3c*/, "gilt" /*ae3d*/, "gilp" /*ae3e*/, "gilh" /*ae3f*/, "gim" /*ae40*/, "gib" /*ae41*/, "gibs" /*ae42*/, "gis" /*ae43*/, "giss" /*ae44*/, "ging" /*ae45*/, "gij" /*ae46*/, "gic" /*ae47*/, "gik" /*ae48*/, "git" /*ae49*/, "gip" /*ae4a*/, "gih" /*ae4b*/, "gga" /*ae4c*/, "ggag" /*ae4d*/, "ggagg" /*ae4e*/, "ggags" /*ae4f*/, "ggan" /*ae50*/, "gganj" /*ae51*/, "gganh" /*ae52*/, "ggad" /*ae53*/, "ggal" /*ae54*/, "ggalg" /*ae55*/, "ggalm" /*ae56*/, "ggalb" /*ae57*/, "ggals" /*ae58*/, "ggalt" /*ae59*/, "ggalp" /*ae5a*/, "ggalh" /*ae5b*/, "ggam" /*ae5c*/, "ggab" /*ae5d*/, "ggabs" /*ae5e*/, "ggas" /*ae5f*/, "ggass" /*ae60*/, "ggang" /*ae61*/, "ggaj" /*ae62*/, "ggac" /*ae63*/, "ggak" /*ae64*/, "ggat" /*ae65*/, "ggap" /*ae66*/, "ggah" /*ae67*/, "ggae" /*ae68*/, "ggaeg" /*ae69*/, "ggaegg" /*ae6a*/, "ggaegs" /*ae6b*/, "ggaen" /*ae6c*/, "ggaenj" /*ae6d*/, "ggaenh" /*ae6e*/, "ggaed" /*ae6f*/, "ggael" /*ae70*/, "ggaelg" /*ae71*/, "ggaelm" /*ae72*/, "ggaelb" /*ae73*/, "ggaels" /*ae74*/, "ggaelt" /*ae75*/, "ggaelp" /*ae76*/, "ggaelh" /*ae77*/, "ggaem" /*ae78*/, "ggaeb" /*ae79*/, "ggaebs" /*ae7a*/, "ggaes" /*ae7b*/, "ggaess" /*ae7c*/, "ggaeng" /*ae7d*/, "ggaej" /*ae7e*/, "ggaec" /*ae7f*/, "ggaek" /*ae80*/, "ggaet" /*ae81*/, "ggaep" /*ae82*/, "ggaeh" /*ae83*/, "ggya" /*ae84*/, "ggyag" /*ae85*/, "ggyagg" /*ae86*/, "ggyags" /*ae87*/, "ggyan" /*ae88*/, "ggyanj" /*ae89*/, "ggyanh" /*ae8a*/, "ggyad" /*ae8b*/, "ggyal" /*ae8c*/, "ggyalg" /*ae8d*/, "ggyalm" /*ae8e*/, "ggyalb" /*ae8f*/, "ggyals" /*ae90*/, "ggyalt" /*ae91*/, "ggyalp" /*ae92*/, "ggyalh" /*ae93*/, "ggyam" /*ae94*/, "ggyab" /*ae95*/, "ggyabs" /*ae96*/, "ggyas" /*ae97*/, "ggyass" /*ae98*/, "ggyang" /*ae99*/, "ggyaj" /*ae9a*/, "ggyac" /*ae9b*/, "ggyak" /*ae9c*/, "ggyat" /*ae9d*/, "ggyap" /*ae9e*/, "ggyah" /*ae9f*/, "ggyae" /*aea0*/, "ggyaeg" /*aea1*/, "ggyaegg" /*aea2*/, "ggyaegs" /*aea3*/, "ggyaen" /*aea4*/, "ggyaenj" /*aea5*/, "ggyaenh" /*aea6*/, "ggyaed" /*aea7*/, "ggyael" /*aea8*/, "ggyaelg" /*aea9*/, "ggyaelm" /*aeaa*/, "ggyaelb" /*aeab*/, "ggyaels" /*aeac*/, "ggyaelt" /*aead*/, "ggyaelp" /*aeae*/, "ggyaelh" /*aeaf*/, "ggyaem" /*aeb0*/, "ggyaeb" /*aeb1*/, "ggyaebs" /*aeb2*/, "ggyaes" /*aeb3*/, "ggyaess" /*aeb4*/, "ggyaeng" /*aeb5*/, "ggyaej" /*aeb6*/, "ggyaec" /*aeb7*/, "ggyaek" /*aeb8*/, "ggyaet" /*aeb9*/, "ggyaep" /*aeba*/, "ggyaeh" /*aebb*/, "ggeo" /*aebc*/, "ggeog" /*aebd*/, "ggeogg" /*aebe*/, "ggeogs" /*aebf*/, "ggeon" /*aec0*/, "ggeonj" /*aec1*/, "ggeonh" /*aec2*/, "ggeod" /*aec3*/, "ggeol" /*aec4*/, "ggeolg" /*aec5*/, "ggeolm" /*aec6*/, "ggeolb" /*aec7*/, "ggeols" /*aec8*/, "ggeolt" /*aec9*/, "ggeolp" /*aeca*/, "ggeolh" /*aecb*/, "ggeom" /*aecc*/, "ggeob" /*aecd*/, "ggeobs" /*aece*/, "ggeos" /*aecf*/, "ggeoss" /*aed0*/, "ggeong" /*aed1*/, "ggeoj" /*aed2*/, "ggeoc" /*aed3*/, "ggeok" /*aed4*/, "ggeot" /*aed5*/, "ggeop" /*aed6*/, "ggeoh" /*aed7*/, "gge" /*aed8*/, "ggeg" /*aed9*/, "ggegg" /*aeda*/, "ggegs" /*aedb*/, "ggen" /*aedc*/, "ggenj" /*aedd*/, "ggenh" /*aede*/, "gged" /*aedf*/, "ggel" /*aee0*/, "ggelg" /*aee1*/, "ggelm" /*aee2*/, "ggelb" /*aee3*/, "ggels" /*aee4*/, "ggelt" /*aee5*/, "ggelp" /*aee6*/, "ggelh" /*aee7*/, "ggem" /*aee8*/, "ggeb" /*aee9*/, "ggebs" /*aeea*/, "gges" /*aeeb*/, "ggess" /*aeec*/, "ggeng" /*aeed*/, "ggej" /*aeee*/, "ggec" /*aeef*/, "ggek" /*aef0*/, "gget" /*aef1*/, "ggep" /*aef2*/, "ggeh" /*aef3*/, "ggyeo" /*aef4*/, "ggyeog" /*aef5*/, "ggyeogg" /*aef6*/, "ggyeogs" /*aef7*/, "ggyeon" /*aef8*/, "ggyeonj" /*aef9*/, "ggyeonh" /*aefa*/, "ggyeod" /*aefb*/, "ggyeol" /*aefc*/, "ggyeolg" /*aefd*/, "ggyeolm" /*aefe*/, "ggyeolb" /*aeff*/ 
			});
						characters.TryAdd(175 /*44800 af*/, new string[] {
				"ggyeols" /*af00*/, "ggyeolt" /*af01*/, "ggyeolp" /*af02*/, "ggyeolh" /*af03*/, "ggyeom" /*af04*/, "ggyeob" /*af05*/, "ggyeobs" /*af06*/, "ggyeos" /*af07*/, "ggyeoss" /*af08*/, "ggyeong" /*af09*/, "ggyeoj" /*af0a*/, "ggyeoc" /*af0b*/, "ggyeok" /*af0c*/, "ggyeot" /*af0d*/, "ggyeop" /*af0e*/, "ggyeoh" /*af0f*/, "ggye" /*af10*/, "ggyeg" /*af11*/, "ggyegg" /*af12*/, "ggyegs" /*af13*/, "ggyen" /*af14*/, "ggyenj" /*af15*/, "ggyenh" /*af16*/, "ggyed" /*af17*/, "ggyel" /*af18*/, "ggyelg" /*af19*/, "ggyelm" /*af1a*/, "ggyelb" /*af1b*/, "ggyels" /*af1c*/, "ggyelt" /*af1d*/, "ggyelp" /*af1e*/, "ggyelh" /*af1f*/, "ggyem" /*af20*/, "ggyeb" /*af21*/, "ggyebs" /*af22*/, "ggyes" /*af23*/, "ggyess" /*af24*/, "ggyeng" /*af25*/, "ggyej" /*af26*/, "ggyec" /*af27*/, "ggyek" /*af28*/, "ggyet" /*af29*/, "ggyep" /*af2a*/, "ggyeh" /*af2b*/, "ggo" /*af2c*/, "ggog" /*af2d*/, "ggogg" /*af2e*/, "ggogs" /*af2f*/, "ggon" /*af30*/, "ggonj" /*af31*/, "ggonh" /*af32*/, "ggod" /*af33*/, "ggol" /*af34*/, "ggolg" /*af35*/, "ggolm" /*af36*/, "ggolb" /*af37*/, "ggols" /*af38*/, "ggolt" /*af39*/, "ggolp" /*af3a*/, "ggolh" /*af3b*/, "ggom" /*af3c*/, "ggob" /*af3d*/, "ggobs" /*af3e*/, "ggos" /*af3f*/, "ggoss" /*af40*/, "ggong" /*af41*/, "ggoj" /*af42*/, "ggoc" /*af43*/, "ggok" /*af44*/, "ggot" /*af45*/, "ggop" /*af46*/, "ggoh" /*af47*/, "ggwa" /*af48*/, "ggwag" /*af49*/, "ggwagg" /*af4a*/, "ggwags" /*af4b*/, "ggwan" /*af4c*/, "ggwanj" /*af4d*/, "ggwanh" /*af4e*/, "ggwad" /*af4f*/, "ggwal" /*af50*/, "ggwalg" /*af51*/, "ggwalm" /*af52*/, "ggwalb" /*af53*/, "ggwals" /*af54*/, "ggwalt" /*af55*/, "ggwalp" /*af56*/, "ggwalh" /*af57*/, "ggwam" /*af58*/, "ggwab" /*af59*/, "ggwabs" /*af5a*/, "ggwas" /*af5b*/, "ggwass" /*af5c*/, "ggwang" /*af5d*/, "ggwaj" /*af5e*/, "ggwac" /*af5f*/, "ggwak" /*af60*/, "ggwat" /*af61*/, "ggwap" /*af62*/, "ggwah" /*af63*/, "ggwae" /*af64*/, "ggwaeg" /*af65*/, "ggwaegg" /*af66*/, "ggwaegs" /*af67*/, "ggwaen" /*af68*/, "ggwaenj" /*af69*/, "ggwaenh" /*af6a*/, "ggwaed" /*af6b*/, "ggwael" /*af6c*/, "ggwaelg" /*af6d*/, "ggwaelm" /*af6e*/, "ggwaelb" /*af6f*/, "ggwaels" /*af70*/, "ggwaelt" /*af71*/, "ggwaelp" /*af72*/, "ggwaelh" /*af73*/, "ggwaem" /*af74*/, "ggwaeb" /*af75*/, "ggwaebs" /*af76*/, "ggwaes" /*af77*/, "ggwaess" /*af78*/, "ggwaeng" /*af79*/, "ggwaej" /*af7a*/, "ggwaec" /*af7b*/, "ggwaek" /*af7c*/, "ggwaet" /*af7d*/, "ggwaep" /*af7e*/, "ggwaeh" /*af7f*/, "ggoe" /*af80*/, "ggoeg" /*af81*/, "ggoegg" /*af82*/, "ggoegs" /*af83*/, "ggoen" /*af84*/, "ggoenj" /*af85*/, "ggoenh" /*af86*/, "ggoed" /*af87*/, "ggoel" /*af88*/, "ggoelg" /*af89*/, "ggoelm" /*af8a*/, "ggoelb" /*af8b*/, "ggoels" /*af8c*/, "ggoelt" /*af8d*/, "ggoelp" /*af8e*/, "ggoelh" /*af8f*/, "ggoem" /*af90*/, "ggoeb" /*af91*/, "ggoebs" /*af92*/, "ggoes" /*af93*/, "ggoess" /*af94*/, "ggoeng" /*af95*/, "ggoej" /*af96*/, "ggoec" /*af97*/, "ggoek" /*af98*/, "ggoet" /*af99*/, "ggoep" /*af9a*/, "ggoeh" /*af9b*/, "ggyo" /*af9c*/, "ggyog" /*af9d*/, "ggyogg" /*af9e*/, "ggyogs" /*af9f*/, "ggyon" /*afa0*/, "ggyonj" /*afa1*/, "ggyonh" /*afa2*/, "ggyod" /*afa3*/, "ggyol" /*afa4*/, "ggyolg" /*afa5*/, "ggyolm" /*afa6*/, "ggyolb" /*afa7*/, "ggyols" /*afa8*/, "ggyolt" /*afa9*/, "ggyolp" /*afaa*/, "ggyolh" /*afab*/, "ggyom" /*afac*/, "ggyob" /*afad*/, "ggyobs" /*afae*/, "ggyos" /*afaf*/, "ggyoss" /*afb0*/, "ggyong" /*afb1*/, "ggyoj" /*afb2*/, "ggyoc" /*afb3*/, "ggyok" /*afb4*/, "ggyot" /*afb5*/, "ggyop" /*afb6*/, "ggyoh" /*afb7*/, "ggu" /*afb8*/, "ggug" /*afb9*/, "ggugg" /*afba*/, "ggugs" /*afbb*/, "ggun" /*afbc*/, "ggunj" /*afbd*/, "ggunh" /*afbe*/, "ggud" /*afbf*/, "ggul" /*afc0*/, "ggulg" /*afc1*/, "ggulm" /*afc2*/, "ggulb" /*afc3*/, "gguls" /*afc4*/, "ggult" /*afc5*/, "ggulp" /*afc6*/, "ggulh" /*afc7*/, "ggum" /*afc8*/, "ggub" /*afc9*/, "ggubs" /*afca*/, "ggus" /*afcb*/, "gguss" /*afcc*/, "ggung" /*afcd*/, "gguj" /*afce*/, "gguc" /*afcf*/, "gguk" /*afd0*/, "ggut" /*afd1*/, "ggup" /*afd2*/, "gguh" /*afd3*/, "ggweo" /*afd4*/, "ggweog" /*afd5*/, "ggweogg" /*afd6*/, "ggweogs" /*afd7*/, "ggweon" /*afd8*/, "ggweonj" /*afd9*/, "ggweonh" /*afda*/, "ggweod" /*afdb*/, "ggweol" /*afdc*/, "ggweolg" /*afdd*/, "ggweolm" /*afde*/, "ggweolb" /*afdf*/, "ggweols" /*afe0*/, "ggweolt" /*afe1*/, "ggweolp" /*afe2*/, "ggweolh" /*afe3*/, "ggweom" /*afe4*/, "ggweob" /*afe5*/, "ggweobs" /*afe6*/, "ggweos" /*afe7*/, "ggweoss" /*afe8*/, "ggweong" /*afe9*/, "ggweoj" /*afea*/, "ggweoc" /*afeb*/, "ggweok" /*afec*/, "ggweot" /*afed*/, "ggweop" /*afee*/, "ggweoh" /*afef*/, "ggwe" /*aff0*/, "ggweg" /*aff1*/, "ggwegg" /*aff2*/, "ggwegs" /*aff3*/, "ggwen" /*aff4*/, "ggwenj" /*aff5*/, "ggwenh" /*aff6*/, "ggwed" /*aff7*/, "ggwel" /*aff8*/, "ggwelg" /*aff9*/, "ggwelm" /*affa*/, "ggwelb" /*affb*/, "ggwels" /*affc*/, "ggwelt" /*affd*/, "ggwelp" /*affe*/, "ggwelh" /*afff*/ 
			});
						characters.TryAdd(176 /*45056 b0*/, new string[] {
				"ggwem" /*b000*/, "ggweb" /*b001*/, "ggwebs" /*b002*/, "ggwes" /*b003*/, "ggwess" /*b004*/, "ggweng" /*b005*/, "ggwej" /*b006*/, "ggwec" /*b007*/, "ggwek" /*b008*/, "ggwet" /*b009*/, "ggwep" /*b00a*/, "ggweh" /*b00b*/, "ggwi" /*b00c*/, "ggwig" /*b00d*/, "ggwigg" /*b00e*/, "ggwigs" /*b00f*/, "ggwin" /*b010*/, "ggwinj" /*b011*/, "ggwinh" /*b012*/, "ggwid" /*b013*/, "ggwil" /*b014*/, "ggwilg" /*b015*/, "ggwilm" /*b016*/, "ggwilb" /*b017*/, "ggwils" /*b018*/, "ggwilt" /*b019*/, "ggwilp" /*b01a*/, "ggwilh" /*b01b*/, "ggwim" /*b01c*/, "ggwib" /*b01d*/, "ggwibs" /*b01e*/, "ggwis" /*b01f*/, "ggwiss" /*b020*/, "ggwing" /*b021*/, "ggwij" /*b022*/, "ggwic" /*b023*/, "ggwik" /*b024*/, "ggwit" /*b025*/, "ggwip" /*b026*/, "ggwih" /*b027*/, "ggyu" /*b028*/, "ggyug" /*b029*/, "ggyugg" /*b02a*/, "ggyugs" /*b02b*/, "ggyun" /*b02c*/, "ggyunj" /*b02d*/, "ggyunh" /*b02e*/, "ggyud" /*b02f*/, "ggyul" /*b030*/, "ggyulg" /*b031*/, "ggyulm" /*b032*/, "ggyulb" /*b033*/, "ggyuls" /*b034*/, "ggyult" /*b035*/, "ggyulp" /*b036*/, "ggyulh" /*b037*/, "ggyum" /*b038*/, "ggyub" /*b039*/, "ggyubs" /*b03a*/, "ggyus" /*b03b*/, "ggyuss" /*b03c*/, "ggyung" /*b03d*/, "ggyuj" /*b03e*/, "ggyuc" /*b03f*/, "ggyuk" /*b040*/, "ggyut" /*b041*/, "ggyup" /*b042*/, "ggyuh" /*b043*/, "ggeu" /*b044*/, "ggeug" /*b045*/, "ggeugg" /*b046*/, "ggeugs" /*b047*/, "ggeun" /*b048*/, "ggeunj" /*b049*/, "ggeunh" /*b04a*/, "ggeud" /*b04b*/, "ggeul" /*b04c*/, "ggeulg" /*b04d*/, "ggeulm" /*b04e*/, "ggeulb" /*b04f*/, "ggeuls" /*b050*/, "ggeult" /*b051*/, "ggeulp" /*b052*/, "ggeulh" /*b053*/, "ggeum" /*b054*/, "ggeub" /*b055*/, "ggeubs" /*b056*/, "ggeus" /*b057*/, "ggeuss" /*b058*/, "ggeung" /*b059*/, "ggeuj" /*b05a*/, "ggeuc" /*b05b*/, "ggeuk" /*b05c*/, "ggeut" /*b05d*/, "ggeup" /*b05e*/, "ggeuh" /*b05f*/, "ggyi" /*b060*/, "ggyig" /*b061*/, "ggyigg" /*b062*/, "ggyigs" /*b063*/, "ggyin" /*b064*/, "ggyinj" /*b065*/, "ggyinh" /*b066*/, "ggyid" /*b067*/, "ggyil" /*b068*/, "ggyilg" /*b069*/, "ggyilm" /*b06a*/, "ggyilb" /*b06b*/, "ggyils" /*b06c*/, "ggyilt" /*b06d*/, "ggyilp" /*b06e*/, "ggyilh" /*b06f*/, "ggyim" /*b070*/, "ggyib" /*b071*/, "ggyibs" /*b072*/, "ggyis" /*b073*/, "ggyiss" /*b074*/, "ggying" /*b075*/, "ggyij" /*b076*/, "ggyic" /*b077*/, "ggyik" /*b078*/, "ggyit" /*b079*/, "ggyip" /*b07a*/, "ggyih" /*b07b*/, "ggi" /*b07c*/, "ggig" /*b07d*/, "ggigg" /*b07e*/, "ggigs" /*b07f*/, "ggin" /*b080*/, "gginj" /*b081*/, "gginh" /*b082*/, "ggid" /*b083*/, "ggil" /*b084*/, "ggilg" /*b085*/, "ggilm" /*b086*/, "ggilb" /*b087*/, "ggils" /*b088*/, "ggilt" /*b089*/, "ggilp" /*b08a*/, "ggilh" /*b08b*/, "ggim" /*b08c*/, "ggib" /*b08d*/, "ggibs" /*b08e*/, "ggis" /*b08f*/, "ggiss" /*b090*/, "gging" /*b091*/, "ggij" /*b092*/, "ggic" /*b093*/, "ggik" /*b094*/, "ggit" /*b095*/, "ggip" /*b096*/, "ggih" /*b097*/, "na" /*b098*/, "nag" /*b099*/, "nagg" /*b09a*/, "nags" /*b09b*/, "nan" /*b09c*/, "nanj" /*b09d*/, "nanh" /*b09e*/, "nad" /*b09f*/, "nal" /*b0a0*/, "nalg" /*b0a1*/, "nalm" /*b0a2*/, "nalb" /*b0a3*/, "nals" /*b0a4*/, "nalt" /*b0a5*/, "nalp" /*b0a6*/, "nalh" /*b0a7*/, "nam" /*b0a8*/, "nab" /*b0a9*/, "nabs" /*b0aa*/, "nas" /*b0ab*/, "nass" /*b0ac*/, "nang" /*b0ad*/, "naj" /*b0ae*/, "nac" /*b0af*/, "nak" /*b0b0*/, "nat" /*b0b1*/, "nap" /*b0b2*/, "nah" /*b0b3*/, "nae" /*b0b4*/, "naeg" /*b0b5*/, "naegg" /*b0b6*/, "naegs" /*b0b7*/, "naen" /*b0b8*/, "naenj" /*b0b9*/, "naenh" /*b0ba*/, "naed" /*b0bb*/, "nael" /*b0bc*/, "naelg" /*b0bd*/, "naelm" /*b0be*/, "naelb" /*b0bf*/, "naels" /*b0c0*/, "naelt" /*b0c1*/, "naelp" /*b0c2*/, "naelh" /*b0c3*/, "naem" /*b0c4*/, "naeb" /*b0c5*/, "naebs" /*b0c6*/, "naes" /*b0c7*/, "naess" /*b0c8*/, "naeng" /*b0c9*/, "naej" /*b0ca*/, "naec" /*b0cb*/, "naek" /*b0cc*/, "naet" /*b0cd*/, "naep" /*b0ce*/, "naeh" /*b0cf*/, "nya" /*b0d0*/, "nyag" /*b0d1*/, "nyagg" /*b0d2*/, "nyags" /*b0d3*/, "nyan" /*b0d4*/, "nyanj" /*b0d5*/, "nyanh" /*b0d6*/, "nyad" /*b0d7*/, "nyal" /*b0d8*/, "nyalg" /*b0d9*/, "nyalm" /*b0da*/, "nyalb" /*b0db*/, "nyals" /*b0dc*/, "nyalt" /*b0dd*/, "nyalp" /*b0de*/, "nyalh" /*b0df*/, "nyam" /*b0e0*/, "nyab" /*b0e1*/, "nyabs" /*b0e2*/, "nyas" /*b0e3*/, "nyass" /*b0e4*/, "nyang" /*b0e5*/, "nyaj" /*b0e6*/, "nyac" /*b0e7*/, "nyak" /*b0e8*/, "nyat" /*b0e9*/, "nyap" /*b0ea*/, "nyah" /*b0eb*/, "nyae" /*b0ec*/, "nyaeg" /*b0ed*/, "nyaegg" /*b0ee*/, "nyaegs" /*b0ef*/, "nyaen" /*b0f0*/, "nyaenj" /*b0f1*/, "nyaenh" /*b0f2*/, "nyaed" /*b0f3*/, "nyael" /*b0f4*/, "nyaelg" /*b0f5*/, "nyaelm" /*b0f6*/, "nyaelb" /*b0f7*/, "nyaels" /*b0f8*/, "nyaelt" /*b0f9*/, "nyaelp" /*b0fa*/, "nyaelh" /*b0fb*/, "nyaem" /*b0fc*/, "nyaeb" /*b0fd*/, "nyaebs" /*b0fe*/, "nyaes" /*b0ff*/ 
			});
						characters.TryAdd(177 /*45312 b1*/, new string[] {
				"nyaess" /*b100*/, "nyaeng" /*b101*/, "nyaej" /*b102*/, "nyaec" /*b103*/, "nyaek" /*b104*/, "nyaet" /*b105*/, "nyaep" /*b106*/, "nyaeh" /*b107*/, "neo" /*b108*/, "neog" /*b109*/, "neogg" /*b10a*/, "neogs" /*b10b*/, "neon" /*b10c*/, "neonj" /*b10d*/, "neonh" /*b10e*/, "neod" /*b10f*/, "neol" /*b110*/, "neolg" /*b111*/, "neolm" /*b112*/, "neolb" /*b113*/, "neols" /*b114*/, "neolt" /*b115*/, "neolp" /*b116*/, "neolh" /*b117*/, "neom" /*b118*/, "neob" /*b119*/, "neobs" /*b11a*/, "neos" /*b11b*/, "neoss" /*b11c*/, "neong" /*b11d*/, "neoj" /*b11e*/, "neoc" /*b11f*/, "neok" /*b120*/, "neot" /*b121*/, "neop" /*b122*/, "neoh" /*b123*/, "ne" /*b124*/, "neg" /*b125*/, "negg" /*b126*/, "negs" /*b127*/, "nen" /*b128*/, "nenj" /*b129*/, "nenh" /*b12a*/, "ned" /*b12b*/, "nel" /*b12c*/, "nelg" /*b12d*/, "nelm" /*b12e*/, "nelb" /*b12f*/, "nels" /*b130*/, "nelt" /*b131*/, "nelp" /*b132*/, "nelh" /*b133*/, "nem" /*b134*/, "neb" /*b135*/, "nebs" /*b136*/, "nes" /*b137*/, "ness" /*b138*/, "neng" /*b139*/, "nej" /*b13a*/, "nec" /*b13b*/, "nek" /*b13c*/, "net" /*b13d*/, "nep" /*b13e*/, "neh" /*b13f*/, "nyeo" /*b140*/, "nyeog" /*b141*/, "nyeogg" /*b142*/, "nyeogs" /*b143*/, "nyeon" /*b144*/, "nyeonj" /*b145*/, "nyeonh" /*b146*/, "nyeod" /*b147*/, "nyeol" /*b148*/, "nyeolg" /*b149*/, "nyeolm" /*b14a*/, "nyeolb" /*b14b*/, "nyeols" /*b14c*/, "nyeolt" /*b14d*/, "nyeolp" /*b14e*/, "nyeolh" /*b14f*/, "nyeom" /*b150*/, "nyeob" /*b151*/, "nyeobs" /*b152*/, "nyeos" /*b153*/, "nyeoss" /*b154*/, "nyeong" /*b155*/, "nyeoj" /*b156*/, "nyeoc" /*b157*/, "nyeok" /*b158*/, "nyeot" /*b159*/, "nyeop" /*b15a*/, "nyeoh" /*b15b*/, "nye" /*b15c*/, "nyeg" /*b15d*/, "nyegg" /*b15e*/, "nyegs" /*b15f*/, "nyen" /*b160*/, "nyenj" /*b161*/, "nyenh" /*b162*/, "nyed" /*b163*/, "nyel" /*b164*/, "nyelg" /*b165*/, "nyelm" /*b166*/, "nyelb" /*b167*/, "nyels" /*b168*/, "nyelt" /*b169*/, "nyelp" /*b16a*/, "nyelh" /*b16b*/, "nyem" /*b16c*/, "nyeb" /*b16d*/, "nyebs" /*b16e*/, "nyes" /*b16f*/, "nyess" /*b170*/, "nyeng" /*b171*/, "nyej" /*b172*/, "nyec" /*b173*/, "nyek" /*b174*/, "nyet" /*b175*/, "nyep" /*b176*/, "nyeh" /*b177*/, "no" /*b178*/, "nog" /*b179*/, "nogg" /*b17a*/, "nogs" /*b17b*/, "non" /*b17c*/, "nonj" /*b17d*/, "nonh" /*b17e*/, "nod" /*b17f*/, "nol" /*b180*/, "nolg" /*b181*/, "nolm" /*b182*/, "nolb" /*b183*/, "nols" /*b184*/, "nolt" /*b185*/, "nolp" /*b186*/, "nolh" /*b187*/, "nom" /*b188*/, "nob" /*b189*/, "nobs" /*b18a*/, "nos" /*b18b*/, "noss" /*b18c*/, "nong" /*b18d*/, "noj" /*b18e*/, "noc" /*b18f*/, "nok" /*b190*/, "not" /*b191*/, "nop" /*b192*/, "noh" /*b193*/, "nwa" /*b194*/, "nwag" /*b195*/, "nwagg" /*b196*/, "nwags" /*b197*/, "nwan" /*b198*/, "nwanj" /*b199*/, "nwanh" /*b19a*/, "nwad" /*b19b*/, "nwal" /*b19c*/, "nwalg" /*b19d*/, "nwalm" /*b19e*/, "nwalb" /*b19f*/, "nwals" /*b1a0*/, "nwalt" /*b1a1*/, "nwalp" /*b1a2*/, "nwalh" /*b1a3*/, "nwam" /*b1a4*/, "nwab" /*b1a5*/, "nwabs" /*b1a6*/, "nwas" /*b1a7*/, "nwass" /*b1a8*/, "nwang" /*b1a9*/, "nwaj" /*b1aa*/, "nwac" /*b1ab*/, "nwak" /*b1ac*/, "nwat" /*b1ad*/, "nwap" /*b1ae*/, "nwah" /*b1af*/, "nwae" /*b1b0*/, "nwaeg" /*b1b1*/, "nwaegg" /*b1b2*/, "nwaegs" /*b1b3*/, "nwaen" /*b1b4*/, "nwaenj" /*b1b5*/, "nwaenh" /*b1b6*/, "nwaed" /*b1b7*/, "nwael" /*b1b8*/, "nwaelg" /*b1b9*/, "nwaelm" /*b1ba*/, "nwaelb" /*b1bb*/, "nwaels" /*b1bc*/, "nwaelt" /*b1bd*/, "nwaelp" /*b1be*/, "nwaelh" /*b1bf*/, "nwaem" /*b1c0*/, "nwaeb" /*b1c1*/, "nwaebs" /*b1c2*/, "nwaes" /*b1c3*/, "nwaess" /*b1c4*/, "nwaeng" /*b1c5*/, "nwaej" /*b1c6*/, "nwaec" /*b1c7*/, "nwaek" /*b1c8*/, "nwaet" /*b1c9*/, "nwaep" /*b1ca*/, "nwaeh" /*b1cb*/, "noe" /*b1cc*/, "noeg" /*b1cd*/, "noegg" /*b1ce*/, "noegs" /*b1cf*/, "noen" /*b1d0*/, "noenj" /*b1d1*/, "noenh" /*b1d2*/, "noed" /*b1d3*/, "noel" /*b1d4*/, "noelg" /*b1d5*/, "noelm" /*b1d6*/, "noelb" /*b1d7*/, "noels" /*b1d8*/, "noelt" /*b1d9*/, "noelp" /*b1da*/, "noelh" /*b1db*/, "noem" /*b1dc*/, "noeb" /*b1dd*/, "noebs" /*b1de*/, "noes" /*b1df*/, "noess" /*b1e0*/, "noeng" /*b1e1*/, "noej" /*b1e2*/, "noec" /*b1e3*/, "noek" /*b1e4*/, "noet" /*b1e5*/, "noep" /*b1e6*/, "noeh" /*b1e7*/, "nyo" /*b1e8*/, "nyog" /*b1e9*/, "nyogg" /*b1ea*/, "nyogs" /*b1eb*/, "nyon" /*b1ec*/, "nyonj" /*b1ed*/, "nyonh" /*b1ee*/, "nyod" /*b1ef*/, "nyol" /*b1f0*/, "nyolg" /*b1f1*/, "nyolm" /*b1f2*/, "nyolb" /*b1f3*/, "nyols" /*b1f4*/, "nyolt" /*b1f5*/, "nyolp" /*b1f6*/, "nyolh" /*b1f7*/, "nyom" /*b1f8*/, "nyob" /*b1f9*/, "nyobs" /*b1fa*/, "nyos" /*b1fb*/, "nyoss" /*b1fc*/, "nyong" /*b1fd*/, "nyoj" /*b1fe*/, "nyoc" /*b1ff*/ 
			});
						characters.TryAdd(178 /*45568 b2*/, new string[] {
				"nyok" /*b200*/, "nyot" /*b201*/, "nyop" /*b202*/, "nyoh" /*b203*/, "nu" /*b204*/, "nug" /*b205*/, "nugg" /*b206*/, "nugs" /*b207*/, "nun" /*b208*/, "nunj" /*b209*/, "nunh" /*b20a*/, "nud" /*b20b*/, "nul" /*b20c*/, "nulg" /*b20d*/, "nulm" /*b20e*/, "nulb" /*b20f*/, "nuls" /*b210*/, "nult" /*b211*/, "nulp" /*b212*/, "nulh" /*b213*/, "num" /*b214*/, "nub" /*b215*/, "nubs" /*b216*/, "nus" /*b217*/, "nuss" /*b218*/, "nung" /*b219*/, "nuj" /*b21a*/, "nuc" /*b21b*/, "nuk" /*b21c*/, "nut" /*b21d*/, "nup" /*b21e*/, "nuh" /*b21f*/, "nweo" /*b220*/, "nweog" /*b221*/, "nweogg" /*b222*/, "nweogs" /*b223*/, "nweon" /*b224*/, "nweonj" /*b225*/, "nweonh" /*b226*/, "nweod" /*b227*/, "nweol" /*b228*/, "nweolg" /*b229*/, "nweolm" /*b22a*/, "nweolb" /*b22b*/, "nweols" /*b22c*/, "nweolt" /*b22d*/, "nweolp" /*b22e*/, "nweolh" /*b22f*/, "nweom" /*b230*/, "nweob" /*b231*/, "nweobs" /*b232*/, "nweos" /*b233*/, "nweoss" /*b234*/, "nweong" /*b235*/, "nweoj" /*b236*/, "nweoc" /*b237*/, "nweok" /*b238*/, "nweot" /*b239*/, "nweop" /*b23a*/, "nweoh" /*b23b*/, "nwe" /*b23c*/, "nweg" /*b23d*/, "nwegg" /*b23e*/, "nwegs" /*b23f*/, "nwen" /*b240*/, "nwenj" /*b241*/, "nwenh" /*b242*/, "nwed" /*b243*/, "nwel" /*b244*/, "nwelg" /*b245*/, "nwelm" /*b246*/, "nwelb" /*b247*/, "nwels" /*b248*/, "nwelt" /*b249*/, "nwelp" /*b24a*/, "nwelh" /*b24b*/, "nwem" /*b24c*/, "nweb" /*b24d*/, "nwebs" /*b24e*/, "nwes" /*b24f*/, "nwess" /*b250*/, "nweng" /*b251*/, "nwej" /*b252*/, "nwec" /*b253*/, "nwek" /*b254*/, "nwet" /*b255*/, "nwep" /*b256*/, "nweh" /*b257*/, "nwi" /*b258*/, "nwig" /*b259*/, "nwigg" /*b25a*/, "nwigs" /*b25b*/, "nwin" /*b25c*/, "nwinj" /*b25d*/, "nwinh" /*b25e*/, "nwid" /*b25f*/, "nwil" /*b260*/, "nwilg" /*b261*/, "nwilm" /*b262*/, "nwilb" /*b263*/, "nwils" /*b264*/, "nwilt" /*b265*/, "nwilp" /*b266*/, "nwilh" /*b267*/, "nwim" /*b268*/, "nwib" /*b269*/, "nwibs" /*b26a*/, "nwis" /*b26b*/, "nwiss" /*b26c*/, "nwing" /*b26d*/, "nwij" /*b26e*/, "nwic" /*b26f*/, "nwik" /*b270*/, "nwit" /*b271*/, "nwip" /*b272*/, "nwih" /*b273*/, "nyu" /*b274*/, "nyug" /*b275*/, "nyugg" /*b276*/, "nyugs" /*b277*/, "nyun" /*b278*/, "nyunj" /*b279*/, "nyunh" /*b27a*/, "nyud" /*b27b*/, "nyul" /*b27c*/, "nyulg" /*b27d*/, "nyulm" /*b27e*/, "nyulb" /*b27f*/, "nyuls" /*b280*/, "nyult" /*b281*/, "nyulp" /*b282*/, "nyulh" /*b283*/, "nyum" /*b284*/, "nyub" /*b285*/, "nyubs" /*b286*/, "nyus" /*b287*/, "nyuss" /*b288*/, "nyung" /*b289*/, "nyuj" /*b28a*/, "nyuc" /*b28b*/, "nyuk" /*b28c*/, "nyut" /*b28d*/, "nyup" /*b28e*/, "nyuh" /*b28f*/, "neu" /*b290*/, "neug" /*b291*/, "neugg" /*b292*/, "neugs" /*b293*/, "neun" /*b294*/, "neunj" /*b295*/, "neunh" /*b296*/, "neud" /*b297*/, "neul" /*b298*/, "neulg" /*b299*/, "neulm" /*b29a*/, "neulb" /*b29b*/, "neuls" /*b29c*/, "neult" /*b29d*/, "neulp" /*b29e*/, "neulh" /*b29f*/, "neum" /*b2a0*/, "neub" /*b2a1*/, "neubs" /*b2a2*/, "neus" /*b2a3*/, "neuss" /*b2a4*/, "neung" /*b2a5*/, "neuj" /*b2a6*/, "neuc" /*b2a7*/, "neuk" /*b2a8*/, "neut" /*b2a9*/, "neup" /*b2aa*/, "neuh" /*b2ab*/, "nyi" /*b2ac*/, "nyig" /*b2ad*/, "nyigg" /*b2ae*/, "nyigs" /*b2af*/, "nyin" /*b2b0*/, "nyinj" /*b2b1*/, "nyinh" /*b2b2*/, "nyid" /*b2b3*/, "nyil" /*b2b4*/, "nyilg" /*b2b5*/, "nyilm" /*b2b6*/, "nyilb" /*b2b7*/, "nyils" /*b2b8*/, "nyilt" /*b2b9*/, "nyilp" /*b2ba*/, "nyilh" /*b2bb*/, "nyim" /*b2bc*/, "nyib" /*b2bd*/, "nyibs" /*b2be*/, "nyis" /*b2bf*/, "nyiss" /*b2c0*/, "nying" /*b2c1*/, "nyij" /*b2c2*/, "nyic" /*b2c3*/, "nyik" /*b2c4*/, "nyit" /*b2c5*/, "nyip" /*b2c6*/, "nyih" /*b2c7*/, "ni" /*b2c8*/, "nig" /*b2c9*/, "nigg" /*b2ca*/, "nigs" /*b2cb*/, "nin" /*b2cc*/, "ninj" /*b2cd*/, "ninh" /*b2ce*/, "nid" /*b2cf*/, "nil" /*b2d0*/, "nilg" /*b2d1*/, "nilm" /*b2d2*/, "nilb" /*b2d3*/, "nils" /*b2d4*/, "nilt" /*b2d5*/, "nilp" /*b2d6*/, "nilh" /*b2d7*/, "nim" /*b2d8*/, "nib" /*b2d9*/, "nibs" /*b2da*/, "nis" /*b2db*/, "niss" /*b2dc*/, "ning" /*b2dd*/, "nij" /*b2de*/, "nic" /*b2df*/, "nik" /*b2e0*/, "nit" /*b2e1*/, "nip" /*b2e2*/, "nih" /*b2e3*/, "da" /*b2e4*/, "dag" /*b2e5*/, "dagg" /*b2e6*/, "dags" /*b2e7*/, "dan" /*b2e8*/, "danj" /*b2e9*/, "danh" /*b2ea*/, "dad" /*b2eb*/, "dal" /*b2ec*/, "dalg" /*b2ed*/, "dalm" /*b2ee*/, "dalb" /*b2ef*/, "dals" /*b2f0*/, "dalt" /*b2f1*/, "dalp" /*b2f2*/, "dalh" /*b2f3*/, "dam" /*b2f4*/, "dab" /*b2f5*/, "dabs" /*b2f6*/, "das" /*b2f7*/, "dass" /*b2f8*/, "dang" /*b2f9*/, "daj" /*b2fa*/, "dac" /*b2fb*/, "dak" /*b2fc*/, "dat" /*b2fd*/, "dap" /*b2fe*/, "dah" /*b2ff*/ 
			});
						characters.TryAdd(179 /*45824 b3*/, new string[] {
				"dae" /*b300*/, "daeg" /*b301*/, "daegg" /*b302*/, "daegs" /*b303*/, "daen" /*b304*/, "daenj" /*b305*/, "daenh" /*b306*/, "daed" /*b307*/, "dael" /*b308*/, "daelg" /*b309*/, "daelm" /*b30a*/, "daelb" /*b30b*/, "daels" /*b30c*/, "daelt" /*b30d*/, "daelp" /*b30e*/, "daelh" /*b30f*/, "daem" /*b310*/, "daeb" /*b311*/, "daebs" /*b312*/, "daes" /*b313*/, "daess" /*b314*/, "daeng" /*b315*/, "daej" /*b316*/, "daec" /*b317*/, "daek" /*b318*/, "daet" /*b319*/, "daep" /*b31a*/, "daeh" /*b31b*/, "dya" /*b31c*/, "dyag" /*b31d*/, "dyagg" /*b31e*/, "dyags" /*b31f*/, "dyan" /*b320*/, "dyanj" /*b321*/, "dyanh" /*b322*/, "dyad" /*b323*/, "dyal" /*b324*/, "dyalg" /*b325*/, "dyalm" /*b326*/, "dyalb" /*b327*/, "dyals" /*b328*/, "dyalt" /*b329*/, "dyalp" /*b32a*/, "dyalh" /*b32b*/, "dyam" /*b32c*/, "dyab" /*b32d*/, "dyabs" /*b32e*/, "dyas" /*b32f*/, "dyass" /*b330*/, "dyang" /*b331*/, "dyaj" /*b332*/, "dyac" /*b333*/, "dyak" /*b334*/, "dyat" /*b335*/, "dyap" /*b336*/, "dyah" /*b337*/, "dyae" /*b338*/, "dyaeg" /*b339*/, "dyaegg" /*b33a*/, "dyaegs" /*b33b*/, "dyaen" /*b33c*/, "dyaenj" /*b33d*/, "dyaenh" /*b33e*/, "dyaed" /*b33f*/, "dyael" /*b340*/, "dyaelg" /*b341*/, "dyaelm" /*b342*/, "dyaelb" /*b343*/, "dyaels" /*b344*/, "dyaelt" /*b345*/, "dyaelp" /*b346*/, "dyaelh" /*b347*/, "dyaem" /*b348*/, "dyaeb" /*b349*/, "dyaebs" /*b34a*/, "dyaes" /*b34b*/, "dyaess" /*b34c*/, "dyaeng" /*b34d*/, "dyaej" /*b34e*/, "dyaec" /*b34f*/, "dyaek" /*b350*/, "dyaet" /*b351*/, "dyaep" /*b352*/, "dyaeh" /*b353*/, "deo" /*b354*/, "deog" /*b355*/, "deogg" /*b356*/, "deogs" /*b357*/, "deon" /*b358*/, "deonj" /*b359*/, "deonh" /*b35a*/, "deod" /*b35b*/, "deol" /*b35c*/, "deolg" /*b35d*/, "deolm" /*b35e*/, "deolb" /*b35f*/, "deols" /*b360*/, "deolt" /*b361*/, "deolp" /*b362*/, "deolh" /*b363*/, "deom" /*b364*/, "deob" /*b365*/, "deobs" /*b366*/, "deos" /*b367*/, "deoss" /*b368*/, "deong" /*b369*/, "deoj" /*b36a*/, "deoc" /*b36b*/, "deok" /*b36c*/, "deot" /*b36d*/, "deop" /*b36e*/, "deoh" /*b36f*/, "de" /*b370*/, "deg" /*b371*/, "degg" /*b372*/, "degs" /*b373*/, "den" /*b374*/, "denj" /*b375*/, "denh" /*b376*/, "ded" /*b377*/, "del" /*b378*/, "delg" /*b379*/, "delm" /*b37a*/, "delb" /*b37b*/, "dels" /*b37c*/, "delt" /*b37d*/, "delp" /*b37e*/, "delh" /*b37f*/, "dem" /*b380*/, "deb" /*b381*/, "debs" /*b382*/, "des" /*b383*/, "dess" /*b384*/, "deng" /*b385*/, "dej" /*b386*/, "dec" /*b387*/, "dek" /*b388*/, "det" /*b389*/, "dep" /*b38a*/, "deh" /*b38b*/, "dyeo" /*b38c*/, "dyeog" /*b38d*/, "dyeogg" /*b38e*/, "dyeogs" /*b38f*/, "dyeon" /*b390*/, "dyeonj" /*b391*/, "dyeonh" /*b392*/, "dyeod" /*b393*/, "dyeol" /*b394*/, "dyeolg" /*b395*/, "dyeolm" /*b396*/, "dyeolb" /*b397*/, "dyeols" /*b398*/, "dyeolt" /*b399*/, "dyeolp" /*b39a*/, "dyeolh" /*b39b*/, "dyeom" /*b39c*/, "dyeob" /*b39d*/, "dyeobs" /*b39e*/, "dyeos" /*b39f*/, "dyeoss" /*b3a0*/, "dyeong" /*b3a1*/, "dyeoj" /*b3a2*/, "dyeoc" /*b3a3*/, "dyeok" /*b3a4*/, "dyeot" /*b3a5*/, "dyeop" /*b3a6*/, "dyeoh" /*b3a7*/, "dye" /*b3a8*/, "dyeg" /*b3a9*/, "dyegg" /*b3aa*/, "dyegs" /*b3ab*/, "dyen" /*b3ac*/, "dyenj" /*b3ad*/, "dyenh" /*b3ae*/, "dyed" /*b3af*/, "dyel" /*b3b0*/, "dyelg" /*b3b1*/, "dyelm" /*b3b2*/, "dyelb" /*b3b3*/, "dyels" /*b3b4*/, "dyelt" /*b3b5*/, "dyelp" /*b3b6*/, "dyelh" /*b3b7*/, "dyem" /*b3b8*/, "dyeb" /*b3b9*/, "dyebs" /*b3ba*/, "dyes" /*b3bb*/, "dyess" /*b3bc*/, "dyeng" /*b3bd*/, "dyej" /*b3be*/, "dyec" /*b3bf*/, "dyek" /*b3c0*/, "dyet" /*b3c1*/, "dyep" /*b3c2*/, "dyeh" /*b3c3*/, "do" /*b3c4*/, "dog" /*b3c5*/, "dogg" /*b3c6*/, "dogs" /*b3c7*/, "don" /*b3c8*/, "donj" /*b3c9*/, "donh" /*b3ca*/, "dod" /*b3cb*/, "dol" /*b3cc*/, "dolg" /*b3cd*/, "dolm" /*b3ce*/, "dolb" /*b3cf*/, "dols" /*b3d0*/, "dolt" /*b3d1*/, "dolp" /*b3d2*/, "dolh" /*b3d3*/, "dom" /*b3d4*/, "dob" /*b3d5*/, "dobs" /*b3d6*/, "dos" /*b3d7*/, "doss" /*b3d8*/, "dong" /*b3d9*/, "doj" /*b3da*/, "doc" /*b3db*/, "dok" /*b3dc*/, "dot" /*b3dd*/, "dop" /*b3de*/, "doh" /*b3df*/, "dwa" /*b3e0*/, "dwag" /*b3e1*/, "dwagg" /*b3e2*/, "dwags" /*b3e3*/, "dwan" /*b3e4*/, "dwanj" /*b3e5*/, "dwanh" /*b3e6*/, "dwad" /*b3e7*/, "dwal" /*b3e8*/, "dwalg" /*b3e9*/, "dwalm" /*b3ea*/, "dwalb" /*b3eb*/, "dwals" /*b3ec*/, "dwalt" /*b3ed*/, "dwalp" /*b3ee*/, "dwalh" /*b3ef*/, "dwam" /*b3f0*/, "dwab" /*b3f1*/, "dwabs" /*b3f2*/, "dwas" /*b3f3*/, "dwass" /*b3f4*/, "dwang" /*b3f5*/, "dwaj" /*b3f6*/, "dwac" /*b3f7*/, "dwak" /*b3f8*/, "dwat" /*b3f9*/, "dwap" /*b3fa*/, "dwah" /*b3fb*/, "dwae" /*b3fc*/, "dwaeg" /*b3fd*/, "dwaegg" /*b3fe*/, "dwaegs" /*b3ff*/ 
			});
						characters.TryAdd(180 /*46080 b4*/, new string[] {
				"dwaen" /*b400*/, "dwaenj" /*b401*/, "dwaenh" /*b402*/, "dwaed" /*b403*/, "dwael" /*b404*/, "dwaelg" /*b405*/, "dwaelm" /*b406*/, "dwaelb" /*b407*/, "dwaels" /*b408*/, "dwaelt" /*b409*/, "dwaelp" /*b40a*/, "dwaelh" /*b40b*/, "dwaem" /*b40c*/, "dwaeb" /*b40d*/, "dwaebs" /*b40e*/, "dwaes" /*b40f*/, "dwaess" /*b410*/, "dwaeng" /*b411*/, "dwaej" /*b412*/, "dwaec" /*b413*/, "dwaek" /*b414*/, "dwaet" /*b415*/, "dwaep" /*b416*/, "dwaeh" /*b417*/, "doe" /*b418*/, "doeg" /*b419*/, "doegg" /*b41a*/, "doegs" /*b41b*/, "doen" /*b41c*/, "doenj" /*b41d*/, "doenh" /*b41e*/, "doed" /*b41f*/, "doel" /*b420*/, "doelg" /*b421*/, "doelm" /*b422*/, "doelb" /*b423*/, "doels" /*b424*/, "doelt" /*b425*/, "doelp" /*b426*/, "doelh" /*b427*/, "doem" /*b428*/, "doeb" /*b429*/, "doebs" /*b42a*/, "does" /*b42b*/, "doess" /*b42c*/, "doeng" /*b42d*/, "doej" /*b42e*/, "doec" /*b42f*/, "doek" /*b430*/, "doet" /*b431*/, "doep" /*b432*/, "doeh" /*b433*/, "dyo" /*b434*/, "dyog" /*b435*/, "dyogg" /*b436*/, "dyogs" /*b437*/, "dyon" /*b438*/, "dyonj" /*b439*/, "dyonh" /*b43a*/, "dyod" /*b43b*/, "dyol" /*b43c*/, "dyolg" /*b43d*/, "dyolm" /*b43e*/, "dyolb" /*b43f*/, "dyols" /*b440*/, "dyolt" /*b441*/, "dyolp" /*b442*/, "dyolh" /*b443*/, "dyom" /*b444*/, "dyob" /*b445*/, "dyobs" /*b446*/, "dyos" /*b447*/, "dyoss" /*b448*/, "dyong" /*b449*/, "dyoj" /*b44a*/, "dyoc" /*b44b*/, "dyok" /*b44c*/, "dyot" /*b44d*/, "dyop" /*b44e*/, "dyoh" /*b44f*/, "du" /*b450*/, "dug" /*b451*/, "dugg" /*b452*/, "dugs" /*b453*/, "dun" /*b454*/, "dunj" /*b455*/, "dunh" /*b456*/, "dud" /*b457*/, "dul" /*b458*/, "dulg" /*b459*/, "dulm" /*b45a*/, "dulb" /*b45b*/, "duls" /*b45c*/, "dult" /*b45d*/, "dulp" /*b45e*/, "dulh" /*b45f*/, "dum" /*b460*/, "dub" /*b461*/, "dubs" /*b462*/, "dus" /*b463*/, "duss" /*b464*/, "dung" /*b465*/, "duj" /*b466*/, "duc" /*b467*/, "duk" /*b468*/, "dut" /*b469*/, "dup" /*b46a*/, "duh" /*b46b*/, "dweo" /*b46c*/, "dweog" /*b46d*/, "dweogg" /*b46e*/, "dweogs" /*b46f*/, "dweon" /*b470*/, "dweonj" /*b471*/, "dweonh" /*b472*/, "dweod" /*b473*/, "dweol" /*b474*/, "dweolg" /*b475*/, "dweolm" /*b476*/, "dweolb" /*b477*/, "dweols" /*b478*/, "dweolt" /*b479*/, "dweolp" /*b47a*/, "dweolh" /*b47b*/, "dweom" /*b47c*/, "dweob" /*b47d*/, "dweobs" /*b47e*/, "dweos" /*b47f*/, "dweoss" /*b480*/, "dweong" /*b481*/, "dweoj" /*b482*/, "dweoc" /*b483*/, "dweok" /*b484*/, "dweot" /*b485*/, "dweop" /*b486*/, "dweoh" /*b487*/, "dwe" /*b488*/, "dweg" /*b489*/, "dwegg" /*b48a*/, "dwegs" /*b48b*/, "dwen" /*b48c*/, "dwenj" /*b48d*/, "dwenh" /*b48e*/, "dwed" /*b48f*/, "dwel" /*b490*/, "dwelg" /*b491*/, "dwelm" /*b492*/, "dwelb" /*b493*/, "dwels" /*b494*/, "dwelt" /*b495*/, "dwelp" /*b496*/, "dwelh" /*b497*/, "dwem" /*b498*/, "dweb" /*b499*/, "dwebs" /*b49a*/, "dwes" /*b49b*/, "dwess" /*b49c*/, "dweng" /*b49d*/, "dwej" /*b49e*/, "dwec" /*b49f*/, "dwek" /*b4a0*/, "dwet" /*b4a1*/, "dwep" /*b4a2*/, "dweh" /*b4a3*/, "dwi" /*b4a4*/, "dwig" /*b4a5*/, "dwigg" /*b4a6*/, "dwigs" /*b4a7*/, "dwin" /*b4a8*/, "dwinj" /*b4a9*/, "dwinh" /*b4aa*/, "dwid" /*b4ab*/, "dwil" /*b4ac*/, "dwilg" /*b4ad*/, "dwilm" /*b4ae*/, "dwilb" /*b4af*/, "dwils" /*b4b0*/, "dwilt" /*b4b1*/, "dwilp" /*b4b2*/, "dwilh" /*b4b3*/, "dwim" /*b4b4*/, "dwib" /*b4b5*/, "dwibs" /*b4b6*/, "dwis" /*b4b7*/, "dwiss" /*b4b8*/, "dwing" /*b4b9*/, "dwij" /*b4ba*/, "dwic" /*b4bb*/, "dwik" /*b4bc*/, "dwit" /*b4bd*/, "dwip" /*b4be*/, "dwih" /*b4bf*/, "dyu" /*b4c0*/, "dyug" /*b4c1*/, "dyugg" /*b4c2*/, "dyugs" /*b4c3*/, "dyun" /*b4c4*/, "dyunj" /*b4c5*/, "dyunh" /*b4c6*/, "dyud" /*b4c7*/, "dyul" /*b4c8*/, "dyulg" /*b4c9*/, "dyulm" /*b4ca*/, "dyulb" /*b4cb*/, "dyuls" /*b4cc*/, "dyult" /*b4cd*/, "dyulp" /*b4ce*/, "dyulh" /*b4cf*/, "dyum" /*b4d0*/, "dyub" /*b4d1*/, "dyubs" /*b4d2*/, "dyus" /*b4d3*/, "dyuss" /*b4d4*/, "dyung" /*b4d5*/, "dyuj" /*b4d6*/, "dyuc" /*b4d7*/, "dyuk" /*b4d8*/, "dyut" /*b4d9*/, "dyup" /*b4da*/, "dyuh" /*b4db*/, "deu" /*b4dc*/, "deug" /*b4dd*/, "deugg" /*b4de*/, "deugs" /*b4df*/, "deun" /*b4e0*/, "deunj" /*b4e1*/, "deunh" /*b4e2*/, "deud" /*b4e3*/, "deul" /*b4e4*/, "deulg" /*b4e5*/, "deulm" /*b4e6*/, "deulb" /*b4e7*/, "deuls" /*b4e8*/, "deult" /*b4e9*/, "deulp" /*b4ea*/, "deulh" /*b4eb*/, "deum" /*b4ec*/, "deub" /*b4ed*/, "deubs" /*b4ee*/, "deus" /*b4ef*/, "deuss" /*b4f0*/, "deung" /*b4f1*/, "deuj" /*b4f2*/, "deuc" /*b4f3*/, "deuk" /*b4f4*/, "deut" /*b4f5*/, "deup" /*b4f6*/, "deuh" /*b4f7*/, "dyi" /*b4f8*/, "dyig" /*b4f9*/, "dyigg" /*b4fa*/, "dyigs" /*b4fb*/, "dyin" /*b4fc*/, "dyinj" /*b4fd*/, "dyinh" /*b4fe*/, "dyid" /*b4ff*/ 
			});
						characters.TryAdd(181 /*46336 b5*/, new string[] {
				"dyil" /*b500*/, "dyilg" /*b501*/, "dyilm" /*b502*/, "dyilb" /*b503*/, "dyils" /*b504*/, "dyilt" /*b505*/, "dyilp" /*b506*/, "dyilh" /*b507*/, "dyim" /*b508*/, "dyib" /*b509*/, "dyibs" /*b50a*/, "dyis" /*b50b*/, "dyiss" /*b50c*/, "dying" /*b50d*/, "dyij" /*b50e*/, "dyic" /*b50f*/, "dyik" /*b510*/, "dyit" /*b511*/, "dyip" /*b512*/, "dyih" /*b513*/, "di" /*b514*/, "dig" /*b515*/, "digg" /*b516*/, "digs" /*b517*/, "din" /*b518*/, "dinj" /*b519*/, "dinh" /*b51a*/, "did" /*b51b*/, "dil" /*b51c*/, "dilg" /*b51d*/, "dilm" /*b51e*/, "dilb" /*b51f*/, "dils" /*b520*/, "dilt" /*b521*/, "dilp" /*b522*/, "dilh" /*b523*/, "dim" /*b524*/, "dib" /*b525*/, "dibs" /*b526*/, "dis" /*b527*/, "diss" /*b528*/, "ding" /*b529*/, "dij" /*b52a*/, "dic" /*b52b*/, "dik" /*b52c*/, "dit" /*b52d*/, "dip" /*b52e*/, "dih" /*b52f*/, "dda" /*b530*/, "ddag" /*b531*/, "ddagg" /*b532*/, "ddags" /*b533*/, "ddan" /*b534*/, "ddanj" /*b535*/, "ddanh" /*b536*/, "ddad" /*b537*/, "ddal" /*b538*/, "ddalg" /*b539*/, "ddalm" /*b53a*/, "ddalb" /*b53b*/, "ddals" /*b53c*/, "ddalt" /*b53d*/, "ddalp" /*b53e*/, "ddalh" /*b53f*/, "ddam" /*b540*/, "ddab" /*b541*/, "ddabs" /*b542*/, "ddas" /*b543*/, "ddass" /*b544*/, "ddang" /*b545*/, "ddaj" /*b546*/, "ddac" /*b547*/, "ddak" /*b548*/, "ddat" /*b549*/, "ddap" /*b54a*/, "ddah" /*b54b*/, "ddae" /*b54c*/, "ddaeg" /*b54d*/, "ddaegg" /*b54e*/, "ddaegs" /*b54f*/, "ddaen" /*b550*/, "ddaenj" /*b551*/, "ddaenh" /*b552*/, "ddaed" /*b553*/, "ddael" /*b554*/, "ddaelg" /*b555*/, "ddaelm" /*b556*/, "ddaelb" /*b557*/, "ddaels" /*b558*/, "ddaelt" /*b559*/, "ddaelp" /*b55a*/, "ddaelh" /*b55b*/, "ddaem" /*b55c*/, "ddaeb" /*b55d*/, "ddaebs" /*b55e*/, "ddaes" /*b55f*/, "ddaess" /*b560*/, "ddaeng" /*b561*/, "ddaej" /*b562*/, "ddaec" /*b563*/, "ddaek" /*b564*/, "ddaet" /*b565*/, "ddaep" /*b566*/, "ddaeh" /*b567*/, "ddya" /*b568*/, "ddyag" /*b569*/, "ddyagg" /*b56a*/, "ddyags" /*b56b*/, "ddyan" /*b56c*/, "ddyanj" /*b56d*/, "ddyanh" /*b56e*/, "ddyad" /*b56f*/, "ddyal" /*b570*/, "ddyalg" /*b571*/, "ddyalm" /*b572*/, "ddyalb" /*b573*/, "ddyals" /*b574*/, "ddyalt" /*b575*/, "ddyalp" /*b576*/, "ddyalh" /*b577*/, "ddyam" /*b578*/, "ddyab" /*b579*/, "ddyabs" /*b57a*/, "ddyas" /*b57b*/, "ddyass" /*b57c*/, "ddyang" /*b57d*/, "ddyaj" /*b57e*/, "ddyac" /*b57f*/, "ddyak" /*b580*/, "ddyat" /*b581*/, "ddyap" /*b582*/, "ddyah" /*b583*/, "ddyae" /*b584*/, "ddyaeg" /*b585*/, "ddyaegg" /*b586*/, "ddyaegs" /*b587*/, "ddyaen" /*b588*/, "ddyaenj" /*b589*/, "ddyaenh" /*b58a*/, "ddyaed" /*b58b*/, "ddyael" /*b58c*/, "ddyaelg" /*b58d*/, "ddyaelm" /*b58e*/, "ddyaelb" /*b58f*/, "ddyaels" /*b590*/, "ddyaelt" /*b591*/, "ddyaelp" /*b592*/, "ddyaelh" /*b593*/, "ddyaem" /*b594*/, "ddyaeb" /*b595*/, "ddyaebs" /*b596*/, "ddyaes" /*b597*/, "ddyaess" /*b598*/, "ddyaeng" /*b599*/, "ddyaej" /*b59a*/, "ddyaec" /*b59b*/, "ddyaek" /*b59c*/, "ddyaet" /*b59d*/, "ddyaep" /*b59e*/, "ddyaeh" /*b59f*/, "ddeo" /*b5a0*/, "ddeog" /*b5a1*/, "ddeogg" /*b5a2*/, "ddeogs" /*b5a3*/, "ddeon" /*b5a4*/, "ddeonj" /*b5a5*/, "ddeonh" /*b5a6*/, "ddeod" /*b5a7*/, "ddeol" /*b5a8*/, "ddeolg" /*b5a9*/, "ddeolm" /*b5aa*/, "ddeolb" /*b5ab*/, "ddeols" /*b5ac*/, "ddeolt" /*b5ad*/, "ddeolp" /*b5ae*/, "ddeolh" /*b5af*/, "ddeom" /*b5b0*/, "ddeob" /*b5b1*/, "ddeobs" /*b5b2*/, "ddeos" /*b5b3*/, "ddeoss" /*b5b4*/, "ddeong" /*b5b5*/, "ddeoj" /*b5b6*/, "ddeoc" /*b5b7*/, "ddeok" /*b5b8*/, "ddeot" /*b5b9*/, "ddeop" /*b5ba*/, "ddeoh" /*b5bb*/, "dde" /*b5bc*/, "ddeg" /*b5bd*/, "ddegg" /*b5be*/, "ddegs" /*b5bf*/, "dden" /*b5c0*/, "ddenj" /*b5c1*/, "ddenh" /*b5c2*/, "dded" /*b5c3*/, "ddel" /*b5c4*/, "ddelg" /*b5c5*/, "ddelm" /*b5c6*/, "ddelb" /*b5c7*/, "ddels" /*b5c8*/, "ddelt" /*b5c9*/, "ddelp" /*b5ca*/, "ddelh" /*b5cb*/, "ddem" /*b5cc*/, "ddeb" /*b5cd*/, "ddebs" /*b5ce*/, "ddes" /*b5cf*/, "ddess" /*b5d0*/, "ddeng" /*b5d1*/, "ddej" /*b5d2*/, "ddec" /*b5d3*/, "ddek" /*b5d4*/, "ddet" /*b5d5*/, "ddep" /*b5d6*/, "ddeh" /*b5d7*/, "ddyeo" /*b5d8*/, "ddyeog" /*b5d9*/, "ddyeogg" /*b5da*/, "ddyeogs" /*b5db*/, "ddyeon" /*b5dc*/, "ddyeonj" /*b5dd*/, "ddyeonh" /*b5de*/, "ddyeod" /*b5df*/, "ddyeol" /*b5e0*/, "ddyeolg" /*b5e1*/, "ddyeolm" /*b5e2*/, "ddyeolb" /*b5e3*/, "ddyeols" /*b5e4*/, "ddyeolt" /*b5e5*/, "ddyeolp" /*b5e6*/, "ddyeolh" /*b5e7*/, "ddyeom" /*b5e8*/, "ddyeob" /*b5e9*/, "ddyeobs" /*b5ea*/, "ddyeos" /*b5eb*/, "ddyeoss" /*b5ec*/, "ddyeong" /*b5ed*/, "ddyeoj" /*b5ee*/, "ddyeoc" /*b5ef*/, "ddyeok" /*b5f0*/, "ddyeot" /*b5f1*/, "ddyeop" /*b5f2*/, "ddyeoh" /*b5f3*/, "ddye" /*b5f4*/, "ddyeg" /*b5f5*/, "ddyegg" /*b5f6*/, "ddyegs" /*b5f7*/, "ddyen" /*b5f8*/, "ddyenj" /*b5f9*/, "ddyenh" /*b5fa*/, "ddyed" /*b5fb*/, "ddyel" /*b5fc*/, "ddyelg" /*b5fd*/, "ddyelm" /*b5fe*/, "ddyelb" /*b5ff*/ 
			});
						characters.TryAdd(182 /*46592 b6*/, new string[] {
				"ddyels" /*b600*/, "ddyelt" /*b601*/, "ddyelp" /*b602*/, "ddyelh" /*b603*/, "ddyem" /*b604*/, "ddyeb" /*b605*/, "ddyebs" /*b606*/, "ddyes" /*b607*/, "ddyess" /*b608*/, "ddyeng" /*b609*/, "ddyej" /*b60a*/, "ddyec" /*b60b*/, "ddyek" /*b60c*/, "ddyet" /*b60d*/, "ddyep" /*b60e*/, "ddyeh" /*b60f*/, "ddo" /*b610*/, "ddog" /*b611*/, "ddogg" /*b612*/, "ddogs" /*b613*/, "ddon" /*b614*/, "ddonj" /*b615*/, "ddonh" /*b616*/, "ddod" /*b617*/, "ddol" /*b618*/, "ddolg" /*b619*/, "ddolm" /*b61a*/, "ddolb" /*b61b*/, "ddols" /*b61c*/, "ddolt" /*b61d*/, "ddolp" /*b61e*/, "ddolh" /*b61f*/, "ddom" /*b620*/, "ddob" /*b621*/, "ddobs" /*b622*/, "ddos" /*b623*/, "ddoss" /*b624*/, "ddong" /*b625*/, "ddoj" /*b626*/, "ddoc" /*b627*/, "ddok" /*b628*/, "ddot" /*b629*/, "ddop" /*b62a*/, "ddoh" /*b62b*/, "ddwa" /*b62c*/, "ddwag" /*b62d*/, "ddwagg" /*b62e*/, "ddwags" /*b62f*/, "ddwan" /*b630*/, "ddwanj" /*b631*/, "ddwanh" /*b632*/, "ddwad" /*b633*/, "ddwal" /*b634*/, "ddwalg" /*b635*/, "ddwalm" /*b636*/, "ddwalb" /*b637*/, "ddwals" /*b638*/, "ddwalt" /*b639*/, "ddwalp" /*b63a*/, "ddwalh" /*b63b*/, "ddwam" /*b63c*/, "ddwab" /*b63d*/, "ddwabs" /*b63e*/, "ddwas" /*b63f*/, "ddwass" /*b640*/, "ddwang" /*b641*/, "ddwaj" /*b642*/, "ddwac" /*b643*/, "ddwak" /*b644*/, "ddwat" /*b645*/, "ddwap" /*b646*/, "ddwah" /*b647*/, "ddwae" /*b648*/, "ddwaeg" /*b649*/, "ddwaegg" /*b64a*/, "ddwaegs" /*b64b*/, "ddwaen" /*b64c*/, "ddwaenj" /*b64d*/, "ddwaenh" /*b64e*/, "ddwaed" /*b64f*/, "ddwael" /*b650*/, "ddwaelg" /*b651*/, "ddwaelm" /*b652*/, "ddwaelb" /*b653*/, "ddwaels" /*b654*/, "ddwaelt" /*b655*/, "ddwaelp" /*b656*/, "ddwaelh" /*b657*/, "ddwaem" /*b658*/, "ddwaeb" /*b659*/, "ddwaebs" /*b65a*/, "ddwaes" /*b65b*/, "ddwaess" /*b65c*/, "ddwaeng" /*b65d*/, "ddwaej" /*b65e*/, "ddwaec" /*b65f*/, "ddwaek" /*b660*/, "ddwaet" /*b661*/, "ddwaep" /*b662*/, "ddwaeh" /*b663*/, "ddoe" /*b664*/, "ddoeg" /*b665*/, "ddoegg" /*b666*/, "ddoegs" /*b667*/, "ddoen" /*b668*/, "ddoenj" /*b669*/, "ddoenh" /*b66a*/, "ddoed" /*b66b*/, "ddoel" /*b66c*/, "ddoelg" /*b66d*/, "ddoelm" /*b66e*/, "ddoelb" /*b66f*/, "ddoels" /*b670*/, "ddoelt" /*b671*/, "ddoelp" /*b672*/, "ddoelh" /*b673*/, "ddoem" /*b674*/, "ddoeb" /*b675*/, "ddoebs" /*b676*/, "ddoes" /*b677*/, "ddoess" /*b678*/, "ddoeng" /*b679*/, "ddoej" /*b67a*/, "ddoec" /*b67b*/, "ddoek" /*b67c*/, "ddoet" /*b67d*/, "ddoep" /*b67e*/, "ddoeh" /*b67f*/, "ddyo" /*b680*/, "ddyog" /*b681*/, "ddyogg" /*b682*/, "ddyogs" /*b683*/, "ddyon" /*b684*/, "ddyonj" /*b685*/, "ddyonh" /*b686*/, "ddyod" /*b687*/, "ddyol" /*b688*/, "ddyolg" /*b689*/, "ddyolm" /*b68a*/, "ddyolb" /*b68b*/, "ddyols" /*b68c*/, "ddyolt" /*b68d*/, "ddyolp" /*b68e*/, "ddyolh" /*b68f*/, "ddyom" /*b690*/, "ddyob" /*b691*/, "ddyobs" /*b692*/, "ddyos" /*b693*/, "ddyoss" /*b694*/, "ddyong" /*b695*/, "ddyoj" /*b696*/, "ddyoc" /*b697*/, "ddyok" /*b698*/, "ddyot" /*b699*/, "ddyop" /*b69a*/, "ddyoh" /*b69b*/, "ddu" /*b69c*/, "ddug" /*b69d*/, "ddugg" /*b69e*/, "ddugs" /*b69f*/, "ddun" /*b6a0*/, "ddunj" /*b6a1*/, "ddunh" /*b6a2*/, "ddud" /*b6a3*/, "ddul" /*b6a4*/, "ddulg" /*b6a5*/, "ddulm" /*b6a6*/, "ddulb" /*b6a7*/, "dduls" /*b6a8*/, "ddult" /*b6a9*/, "ddulp" /*b6aa*/, "ddulh" /*b6ab*/, "ddum" /*b6ac*/, "ddub" /*b6ad*/, "ddubs" /*b6ae*/, "ddus" /*b6af*/, "dduss" /*b6b0*/, "ddung" /*b6b1*/, "dduj" /*b6b2*/, "dduc" /*b6b3*/, "dduk" /*b6b4*/, "ddut" /*b6b5*/, "ddup" /*b6b6*/, "dduh" /*b6b7*/, "ddweo" /*b6b8*/, "ddweog" /*b6b9*/, "ddweogg" /*b6ba*/, "ddweogs" /*b6bb*/, "ddweon" /*b6bc*/, "ddweonj" /*b6bd*/, "ddweonh" /*b6be*/, "ddweod" /*b6bf*/, "ddweol" /*b6c0*/, "ddweolg" /*b6c1*/, "ddweolm" /*b6c2*/, "ddweolb" /*b6c3*/, "ddweols" /*b6c4*/, "ddweolt" /*b6c5*/, "ddweolp" /*b6c6*/, "ddweolh" /*b6c7*/, "ddweom" /*b6c8*/, "ddweob" /*b6c9*/, "ddweobs" /*b6ca*/, "ddweos" /*b6cb*/, "ddweoss" /*b6cc*/, "ddweong" /*b6cd*/, "ddweoj" /*b6ce*/, "ddweoc" /*b6cf*/, "ddweok" /*b6d0*/, "ddweot" /*b6d1*/, "ddweop" /*b6d2*/, "ddweoh" /*b6d3*/, "ddwe" /*b6d4*/, "ddweg" /*b6d5*/, "ddwegg" /*b6d6*/, "ddwegs" /*b6d7*/, "ddwen" /*b6d8*/, "ddwenj" /*b6d9*/, "ddwenh" /*b6da*/, "ddwed" /*b6db*/, "ddwel" /*b6dc*/, "ddwelg" /*b6dd*/, "ddwelm" /*b6de*/, "ddwelb" /*b6df*/, "ddwels" /*b6e0*/, "ddwelt" /*b6e1*/, "ddwelp" /*b6e2*/, "ddwelh" /*b6e3*/, "ddwem" /*b6e4*/, "ddweb" /*b6e5*/, "ddwebs" /*b6e6*/, "ddwes" /*b6e7*/, "ddwess" /*b6e8*/, "ddweng" /*b6e9*/, "ddwej" /*b6ea*/, "ddwec" /*b6eb*/, "ddwek" /*b6ec*/, "ddwet" /*b6ed*/, "ddwep" /*b6ee*/, "ddweh" /*b6ef*/, "ddwi" /*b6f0*/, "ddwig" /*b6f1*/, "ddwigg" /*b6f2*/, "ddwigs" /*b6f3*/, "ddwin" /*b6f4*/, "ddwinj" /*b6f5*/, "ddwinh" /*b6f6*/, "ddwid" /*b6f7*/, "ddwil" /*b6f8*/, "ddwilg" /*b6f9*/, "ddwilm" /*b6fa*/, "ddwilb" /*b6fb*/, "ddwils" /*b6fc*/, "ddwilt" /*b6fd*/, "ddwilp" /*b6fe*/, "ddwilh" /*b6ff*/ 
			});
						characters.TryAdd(183 /*46848 b7*/, new string[] {
				"ddwim" /*b700*/, "ddwib" /*b701*/, "ddwibs" /*b702*/, "ddwis" /*b703*/, "ddwiss" /*b704*/, "ddwing" /*b705*/, "ddwij" /*b706*/, "ddwic" /*b707*/, "ddwik" /*b708*/, "ddwit" /*b709*/, "ddwip" /*b70a*/, "ddwih" /*b70b*/, "ddyu" /*b70c*/, "ddyug" /*b70d*/, "ddyugg" /*b70e*/, "ddyugs" /*b70f*/, "ddyun" /*b710*/, "ddyunj" /*b711*/, "ddyunh" /*b712*/, "ddyud" /*b713*/, "ddyul" /*b714*/, "ddyulg" /*b715*/, "ddyulm" /*b716*/, "ddyulb" /*b717*/, "ddyuls" /*b718*/, "ddyult" /*b719*/, "ddyulp" /*b71a*/, "ddyulh" /*b71b*/, "ddyum" /*b71c*/, "ddyub" /*b71d*/, "ddyubs" /*b71e*/, "ddyus" /*b71f*/, "ddyuss" /*b720*/, "ddyung" /*b721*/, "ddyuj" /*b722*/, "ddyuc" /*b723*/, "ddyuk" /*b724*/, "ddyut" /*b725*/, "ddyup" /*b726*/, "ddyuh" /*b727*/, "ddeu" /*b728*/, "ddeug" /*b729*/, "ddeugg" /*b72a*/, "ddeugs" /*b72b*/, "ddeun" /*b72c*/, "ddeunj" /*b72d*/, "ddeunh" /*b72e*/, "ddeud" /*b72f*/, "ddeul" /*b730*/, "ddeulg" /*b731*/, "ddeulm" /*b732*/, "ddeulb" /*b733*/, "ddeuls" /*b734*/, "ddeult" /*b735*/, "ddeulp" /*b736*/, "ddeulh" /*b737*/, "ddeum" /*b738*/, "ddeub" /*b739*/, "ddeubs" /*b73a*/, "ddeus" /*b73b*/, "ddeuss" /*b73c*/, "ddeung" /*b73d*/, "ddeuj" /*b73e*/, "ddeuc" /*b73f*/, "ddeuk" /*b740*/, "ddeut" /*b741*/, "ddeup" /*b742*/, "ddeuh" /*b743*/, "ddyi" /*b744*/, "ddyig" /*b745*/, "ddyigg" /*b746*/, "ddyigs" /*b747*/, "ddyin" /*b748*/, "ddyinj" /*b749*/, "ddyinh" /*b74a*/, "ddyid" /*b74b*/, "ddyil" /*b74c*/, "ddyilg" /*b74d*/, "ddyilm" /*b74e*/, "ddyilb" /*b74f*/, "ddyils" /*b750*/, "ddyilt" /*b751*/, "ddyilp" /*b752*/, "ddyilh" /*b753*/, "ddyim" /*b754*/, "ddyib" /*b755*/, "ddyibs" /*b756*/, "ddyis" /*b757*/, "ddyiss" /*b758*/, "ddying" /*b759*/, "ddyij" /*b75a*/, "ddyic" /*b75b*/, "ddyik" /*b75c*/, "ddyit" /*b75d*/, "ddyip" /*b75e*/, "ddyih" /*b75f*/, "ddi" /*b760*/, "ddig" /*b761*/, "ddigg" /*b762*/, "ddigs" /*b763*/, "ddin" /*b764*/, "ddinj" /*b765*/, "ddinh" /*b766*/, "ddid" /*b767*/, "ddil" /*b768*/, "ddilg" /*b769*/, "ddilm" /*b76a*/, "ddilb" /*b76b*/, "ddils" /*b76c*/, "ddilt" /*b76d*/, "ddilp" /*b76e*/, "ddilh" /*b76f*/, "ddim" /*b770*/, "ddib" /*b771*/, "ddibs" /*b772*/, "ddis" /*b773*/, "ddiss" /*b774*/, "dding" /*b775*/, "ddij" /*b776*/, "ddic" /*b777*/, "ddik" /*b778*/, "ddit" /*b779*/, "ddip" /*b77a*/, "ddih" /*b77b*/, "ra" /*b77c*/, "rag" /*b77d*/, "ragg" /*b77e*/, "rags" /*b77f*/, "ran" /*b780*/, "ranj" /*b781*/, "ranh" /*b782*/, "rad" /*b783*/, "ral" /*b784*/, "ralg" /*b785*/, "ralm" /*b786*/, "ralb" /*b787*/, "rals" /*b788*/, "ralt" /*b789*/, "ralp" /*b78a*/, "ralh" /*b78b*/, "ram" /*b78c*/, "rab" /*b78d*/, "rabs" /*b78e*/, "ras" /*b78f*/, "rass" /*b790*/, "rang" /*b791*/, "raj" /*b792*/, "rac" /*b793*/, "rak" /*b794*/, "rat" /*b795*/, "rap" /*b796*/, "rah" /*b797*/, "rae" /*b798*/, "raeg" /*b799*/, "raegg" /*b79a*/, "raegs" /*b79b*/, "raen" /*b79c*/, "raenj" /*b79d*/, "raenh" /*b79e*/, "raed" /*b79f*/, "rael" /*b7a0*/, "raelg" /*b7a1*/, "raelm" /*b7a2*/, "raelb" /*b7a3*/, "raels" /*b7a4*/, "raelt" /*b7a5*/, "raelp" /*b7a6*/, "raelh" /*b7a7*/, "raem" /*b7a8*/, "raeb" /*b7a9*/, "raebs" /*b7aa*/, "raes" /*b7ab*/, "raess" /*b7ac*/, "raeng" /*b7ad*/, "raej" /*b7ae*/, "raec" /*b7af*/, "raek" /*b7b0*/, "raet" /*b7b1*/, "raep" /*b7b2*/, "raeh" /*b7b3*/, "rya" /*b7b4*/, "ryag" /*b7b5*/, "ryagg" /*b7b6*/, "ryags" /*b7b7*/, "ryan" /*b7b8*/, "ryanj" /*b7b9*/, "ryanh" /*b7ba*/, "ryad" /*b7bb*/, "ryal" /*b7bc*/, "ryalg" /*b7bd*/, "ryalm" /*b7be*/, "ryalb" /*b7bf*/, "ryals" /*b7c0*/, "ryalt" /*b7c1*/, "ryalp" /*b7c2*/, "ryalh" /*b7c3*/, "ryam" /*b7c4*/, "ryab" /*b7c5*/, "ryabs" /*b7c6*/, "ryas" /*b7c7*/, "ryass" /*b7c8*/, "ryang" /*b7c9*/, "ryaj" /*b7ca*/, "ryac" /*b7cb*/, "ryak" /*b7cc*/, "ryat" /*b7cd*/, "ryap" /*b7ce*/, "ryah" /*b7cf*/, "ryae" /*b7d0*/, "ryaeg" /*b7d1*/, "ryaegg" /*b7d2*/, "ryaegs" /*b7d3*/, "ryaen" /*b7d4*/, "ryaenj" /*b7d5*/, "ryaenh" /*b7d6*/, "ryaed" /*b7d7*/, "ryael" /*b7d8*/, "ryaelg" /*b7d9*/, "ryaelm" /*b7da*/, "ryaelb" /*b7db*/, "ryaels" /*b7dc*/, "ryaelt" /*b7dd*/, "ryaelp" /*b7de*/, "ryaelh" /*b7df*/, "ryaem" /*b7e0*/, "ryaeb" /*b7e1*/, "ryaebs" /*b7e2*/, "ryaes" /*b7e3*/, "ryaess" /*b7e4*/, "ryaeng" /*b7e5*/, "ryaej" /*b7e6*/, "ryaec" /*b7e7*/, "ryaek" /*b7e8*/, "ryaet" /*b7e9*/, "ryaep" /*b7ea*/, "ryaeh" /*b7eb*/, "reo" /*b7ec*/, "reog" /*b7ed*/, "reogg" /*b7ee*/, "reogs" /*b7ef*/, "reon" /*b7f0*/, "reonj" /*b7f1*/, "reonh" /*b7f2*/, "reod" /*b7f3*/, "reol" /*b7f4*/, "reolg" /*b7f5*/, "reolm" /*b7f6*/, "reolb" /*b7f7*/, "reols" /*b7f8*/, "reolt" /*b7f9*/, "reolp" /*b7fa*/, "reolh" /*b7fb*/, "reom" /*b7fc*/, "reob" /*b7fd*/, "reobs" /*b7fe*/, "reos" /*b7ff*/ 
			});
						characters.TryAdd(184 /*47104 b8*/, new string[] {
				"reoss" /*b800*/, "reong" /*b801*/, "reoj" /*b802*/, "reoc" /*b803*/, "reok" /*b804*/, "reot" /*b805*/, "reop" /*b806*/, "reoh" /*b807*/, "re" /*b808*/, "reg" /*b809*/, "regg" /*b80a*/, "regs" /*b80b*/, "ren" /*b80c*/, "renj" /*b80d*/, "renh" /*b80e*/, "red" /*b80f*/, "rel" /*b810*/, "relg" /*b811*/, "relm" /*b812*/, "relb" /*b813*/, "rels" /*b814*/, "relt" /*b815*/, "relp" /*b816*/, "relh" /*b817*/, "rem" /*b818*/, "reb" /*b819*/, "rebs" /*b81a*/, "res" /*b81b*/, "ress" /*b81c*/, "reng" /*b81d*/, "rej" /*b81e*/, "rec" /*b81f*/, "rek" /*b820*/, "ret" /*b821*/, "rep" /*b822*/, "reh" /*b823*/, "ryeo" /*b824*/, "ryeog" /*b825*/, "ryeogg" /*b826*/, "ryeogs" /*b827*/, "ryeon" /*b828*/, "ryeonj" /*b829*/, "ryeonh" /*b82a*/, "ryeod" /*b82b*/, "ryeol" /*b82c*/, "ryeolg" /*b82d*/, "ryeolm" /*b82e*/, "ryeolb" /*b82f*/, "ryeols" /*b830*/, "ryeolt" /*b831*/, "ryeolp" /*b832*/, "ryeolh" /*b833*/, "ryeom" /*b834*/, "ryeob" /*b835*/, "ryeobs" /*b836*/, "ryeos" /*b837*/, "ryeoss" /*b838*/, "ryeong" /*b839*/, "ryeoj" /*b83a*/, "ryeoc" /*b83b*/, "ryeok" /*b83c*/, "ryeot" /*b83d*/, "ryeop" /*b83e*/, "ryeoh" /*b83f*/, "rye" /*b840*/, "ryeg" /*b841*/, "ryegg" /*b842*/, "ryegs" /*b843*/, "ryen" /*b844*/, "ryenj" /*b845*/, "ryenh" /*b846*/, "ryed" /*b847*/, "ryel" /*b848*/, "ryelg" /*b849*/, "ryelm" /*b84a*/, "ryelb" /*b84b*/, "ryels" /*b84c*/, "ryelt" /*b84d*/, "ryelp" /*b84e*/, "ryelh" /*b84f*/, "ryem" /*b850*/, "ryeb" /*b851*/, "ryebs" /*b852*/, "ryes" /*b853*/, "ryess" /*b854*/, "ryeng" /*b855*/, "ryej" /*b856*/, "ryec" /*b857*/, "ryek" /*b858*/, "ryet" /*b859*/, "ryep" /*b85a*/, "ryeh" /*b85b*/, "ro" /*b85c*/, "rog" /*b85d*/, "rogg" /*b85e*/, "rogs" /*b85f*/, "ron" /*b860*/, "ronj" /*b861*/, "ronh" /*b862*/, "rod" /*b863*/, "rol" /*b864*/, "rolg" /*b865*/, "rolm" /*b866*/, "rolb" /*b867*/, "rols" /*b868*/, "rolt" /*b869*/, "rolp" /*b86a*/, "rolh" /*b86b*/, "rom" /*b86c*/, "rob" /*b86d*/, "robs" /*b86e*/, "ros" /*b86f*/, "ross" /*b870*/, "rong" /*b871*/, "roj" /*b872*/, "roc" /*b873*/, "rok" /*b874*/, "rot" /*b875*/, "rop" /*b876*/, "roh" /*b877*/, "rwa" /*b878*/, "rwag" /*b879*/, "rwagg" /*b87a*/, "rwags" /*b87b*/, "rwan" /*b87c*/, "rwanj" /*b87d*/, "rwanh" /*b87e*/, "rwad" /*b87f*/, "rwal" /*b880*/, "rwalg" /*b881*/, "rwalm" /*b882*/, "rwalb" /*b883*/, "rwals" /*b884*/, "rwalt" /*b885*/, "rwalp" /*b886*/, "rwalh" /*b887*/, "rwam" /*b888*/, "rwab" /*b889*/, "rwabs" /*b88a*/, "rwas" /*b88b*/, "rwass" /*b88c*/, "rwang" /*b88d*/, "rwaj" /*b88e*/, "rwac" /*b88f*/, "rwak" /*b890*/, "rwat" /*b891*/, "rwap" /*b892*/, "rwah" /*b893*/, "rwae" /*b894*/, "rwaeg" /*b895*/, "rwaegg" /*b896*/, "rwaegs" /*b897*/, "rwaen" /*b898*/, "rwaenj" /*b899*/, "rwaenh" /*b89a*/, "rwaed" /*b89b*/, "rwael" /*b89c*/, "rwaelg" /*b89d*/, "rwaelm" /*b89e*/, "rwaelb" /*b89f*/, "rwaels" /*b8a0*/, "rwaelt" /*b8a1*/, "rwaelp" /*b8a2*/, "rwaelh" /*b8a3*/, "rwaem" /*b8a4*/, "rwaeb" /*b8a5*/, "rwaebs" /*b8a6*/, "rwaes" /*b8a7*/, "rwaess" /*b8a8*/, "rwaeng" /*b8a9*/, "rwaej" /*b8aa*/, "rwaec" /*b8ab*/, "rwaek" /*b8ac*/, "rwaet" /*b8ad*/, "rwaep" /*b8ae*/, "rwaeh" /*b8af*/, "roe" /*b8b0*/, "roeg" /*b8b1*/, "roegg" /*b8b2*/, "roegs" /*b8b3*/, "roen" /*b8b4*/, "roenj" /*b8b5*/, "roenh" /*b8b6*/, "roed" /*b8b7*/, "roel" /*b8b8*/, "roelg" /*b8b9*/, "roelm" /*b8ba*/, "roelb" /*b8bb*/, "roels" /*b8bc*/, "roelt" /*b8bd*/, "roelp" /*b8be*/, "roelh" /*b8bf*/, "roem" /*b8c0*/, "roeb" /*b8c1*/, "roebs" /*b8c2*/, "roes" /*b8c3*/, "roess" /*b8c4*/, "roeng" /*b8c5*/, "roej" /*b8c6*/, "roec" /*b8c7*/, "roek" /*b8c8*/, "roet" /*b8c9*/, "roep" /*b8ca*/, "roeh" /*b8cb*/, "ryo" /*b8cc*/, "ryog" /*b8cd*/, "ryogg" /*b8ce*/, "ryogs" /*b8cf*/, "ryon" /*b8d0*/, "ryonj" /*b8d1*/, "ryonh" /*b8d2*/, "ryod" /*b8d3*/, "ryol" /*b8d4*/, "ryolg" /*b8d5*/, "ryolm" /*b8d6*/, "ryolb" /*b8d7*/, "ryols" /*b8d8*/, "ryolt" /*b8d9*/, "ryolp" /*b8da*/, "ryolh" /*b8db*/, "ryom" /*b8dc*/, "ryob" /*b8dd*/, "ryobs" /*b8de*/, "ryos" /*b8df*/, "ryoss" /*b8e0*/, "ryong" /*b8e1*/, "ryoj" /*b8e2*/, "ryoc" /*b8e3*/, "ryok" /*b8e4*/, "ryot" /*b8e5*/, "ryop" /*b8e6*/, "ryoh" /*b8e7*/, "ru" /*b8e8*/, "rug" /*b8e9*/, "rugg" /*b8ea*/, "rugs" /*b8eb*/, "run" /*b8ec*/, "runj" /*b8ed*/, "runh" /*b8ee*/, "rud" /*b8ef*/, "rul" /*b8f0*/, "rulg" /*b8f1*/, "rulm" /*b8f2*/, "rulb" /*b8f3*/, "ruls" /*b8f4*/, "rult" /*b8f5*/, "rulp" /*b8f6*/, "rulh" /*b8f7*/, "rum" /*b8f8*/, "rub" /*b8f9*/, "rubs" /*b8fa*/, "rus" /*b8fb*/, "russ" /*b8fc*/, "rung" /*b8fd*/, "ruj" /*b8fe*/, "ruc" /*b8ff*/ 
			});
						characters.TryAdd(185 /*47360 b9*/, new string[] {
				"ruk" /*b900*/, "rut" /*b901*/, "rup" /*b902*/, "ruh" /*b903*/, "rweo" /*b904*/, "rweog" /*b905*/, "rweogg" /*b906*/, "rweogs" /*b907*/, "rweon" /*b908*/, "rweonj" /*b909*/, "rweonh" /*b90a*/, "rweod" /*b90b*/, "rweol" /*b90c*/, "rweolg" /*b90d*/, "rweolm" /*b90e*/, "rweolb" /*b90f*/, "rweols" /*b910*/, "rweolt" /*b911*/, "rweolp" /*b912*/, "rweolh" /*b913*/, "rweom" /*b914*/, "rweob" /*b915*/, "rweobs" /*b916*/, "rweos" /*b917*/, "rweoss" /*b918*/, "rweong" /*b919*/, "rweoj" /*b91a*/, "rweoc" /*b91b*/, "rweok" /*b91c*/, "rweot" /*b91d*/, "rweop" /*b91e*/, "rweoh" /*b91f*/, "rwe" /*b920*/, "rweg" /*b921*/, "rwegg" /*b922*/, "rwegs" /*b923*/, "rwen" /*b924*/, "rwenj" /*b925*/, "rwenh" /*b926*/, "rwed" /*b927*/, "rwel" /*b928*/, "rwelg" /*b929*/, "rwelm" /*b92a*/, "rwelb" /*b92b*/, "rwels" /*b92c*/, "rwelt" /*b92d*/, "rwelp" /*b92e*/, "rwelh" /*b92f*/, "rwem" /*b930*/, "rweb" /*b931*/, "rwebs" /*b932*/, "rwes" /*b933*/, "rwess" /*b934*/, "rweng" /*b935*/, "rwej" /*b936*/, "rwec" /*b937*/, "rwek" /*b938*/, "rwet" /*b939*/, "rwep" /*b93a*/, "rweh" /*b93b*/, "rwi" /*b93c*/, "rwig" /*b93d*/, "rwigg" /*b93e*/, "rwigs" /*b93f*/, "rwin" /*b940*/, "rwinj" /*b941*/, "rwinh" /*b942*/, "rwid" /*b943*/, "rwil" /*b944*/, "rwilg" /*b945*/, "rwilm" /*b946*/, "rwilb" /*b947*/, "rwils" /*b948*/, "rwilt" /*b949*/, "rwilp" /*b94a*/, "rwilh" /*b94b*/, "rwim" /*b94c*/, "rwib" /*b94d*/, "rwibs" /*b94e*/, "rwis" /*b94f*/, "rwiss" /*b950*/, "rwing" /*b951*/, "rwij" /*b952*/, "rwic" /*b953*/, "rwik" /*b954*/, "rwit" /*b955*/, "rwip" /*b956*/, "rwih" /*b957*/, "ryu" /*b958*/, "ryug" /*b959*/, "ryugg" /*b95a*/, "ryugs" /*b95b*/, "ryun" /*b95c*/, "ryunj" /*b95d*/, "ryunh" /*b95e*/, "ryud" /*b95f*/, "ryul" /*b960*/, "ryulg" /*b961*/, "ryulm" /*b962*/, "ryulb" /*b963*/, "ryuls" /*b964*/, "ryult" /*b965*/, "ryulp" /*b966*/, "ryulh" /*b967*/, "ryum" /*b968*/, "ryub" /*b969*/, "ryubs" /*b96a*/, "ryus" /*b96b*/, "ryuss" /*b96c*/, "ryung" /*b96d*/, "ryuj" /*b96e*/, "ryuc" /*b96f*/, "ryuk" /*b970*/, "ryut" /*b971*/, "ryup" /*b972*/, "ryuh" /*b973*/, "reu" /*b974*/, "reug" /*b975*/, "reugg" /*b976*/, "reugs" /*b977*/, "reun" /*b978*/, "reunj" /*b979*/, "reunh" /*b97a*/, "reud" /*b97b*/, "reul" /*b97c*/, "reulg" /*b97d*/, "reulm" /*b97e*/, "reulb" /*b97f*/, "reuls" /*b980*/, "reult" /*b981*/, "reulp" /*b982*/, "reulh" /*b983*/, "reum" /*b984*/, "reub" /*b985*/, "reubs" /*b986*/, "reus" /*b987*/, "reuss" /*b988*/, "reung" /*b989*/, "reuj" /*b98a*/, "reuc" /*b98b*/, "reuk" /*b98c*/, "reut" /*b98d*/, "reup" /*b98e*/, "reuh" /*b98f*/, "ryi" /*b990*/, "ryig" /*b991*/, "ryigg" /*b992*/, "ryigs" /*b993*/, "ryin" /*b994*/, "ryinj" /*b995*/, "ryinh" /*b996*/, "ryid" /*b997*/, "ryil" /*b998*/, "ryilg" /*b999*/, "ryilm" /*b99a*/, "ryilb" /*b99b*/, "ryils" /*b99c*/, "ryilt" /*b99d*/, "ryilp" /*b99e*/, "ryilh" /*b99f*/, "ryim" /*b9a0*/, "ryib" /*b9a1*/, "ryibs" /*b9a2*/, "ryis" /*b9a3*/, "ryiss" /*b9a4*/, "rying" /*b9a5*/, "ryij" /*b9a6*/, "ryic" /*b9a7*/, "ryik" /*b9a8*/, "ryit" /*b9a9*/, "ryip" /*b9aa*/, "ryih" /*b9ab*/, "ri" /*b9ac*/, "rig" /*b9ad*/, "rigg" /*b9ae*/, "rigs" /*b9af*/, "rin" /*b9b0*/, "rinj" /*b9b1*/, "rinh" /*b9b2*/, "rid" /*b9b3*/, "ril" /*b9b4*/, "rilg" /*b9b5*/, "rilm" /*b9b6*/, "rilb" /*b9b7*/, "rils" /*b9b8*/, "rilt" /*b9b9*/, "rilp" /*b9ba*/, "rilh" /*b9bb*/, "rim" /*b9bc*/, "rib" /*b9bd*/, "ribs" /*b9be*/, "ris" /*b9bf*/, "riss" /*b9c0*/, "ring" /*b9c1*/, "rij" /*b9c2*/, "ric" /*b9c3*/, "rik" /*b9c4*/, "rit" /*b9c5*/, "rip" /*b9c6*/, "rih" /*b9c7*/, "ma" /*b9c8*/, "mag" /*b9c9*/, "magg" /*b9ca*/, "mags" /*b9cb*/, "man" /*b9cc*/, "manj" /*b9cd*/, "manh" /*b9ce*/, "mad" /*b9cf*/, "mal" /*b9d0*/, "malg" /*b9d1*/, "malm" /*b9d2*/, "malb" /*b9d3*/, "mals" /*b9d4*/, "malt" /*b9d5*/, "malp" /*b9d6*/, "malh" /*b9d7*/, "mam" /*b9d8*/, "mab" /*b9d9*/, "mabs" /*b9da*/, "mas" /*b9db*/, "mass" /*b9dc*/, "mang" /*b9dd*/, "maj" /*b9de*/, "mac" /*b9df*/, "mak" /*b9e0*/, "mat" /*b9e1*/, "map" /*b9e2*/, "mah" /*b9e3*/, "mae" /*b9e4*/, "maeg" /*b9e5*/, "maegg" /*b9e6*/, "maegs" /*b9e7*/, "maen" /*b9e8*/, "maenj" /*b9e9*/, "maenh" /*b9ea*/, "maed" /*b9eb*/, "mael" /*b9ec*/, "maelg" /*b9ed*/, "maelm" /*b9ee*/, "maelb" /*b9ef*/, "maels" /*b9f0*/, "maelt" /*b9f1*/, "maelp" /*b9f2*/, "maelh" /*b9f3*/, "maem" /*b9f4*/, "maeb" /*b9f5*/, "maebs" /*b9f6*/, "maes" /*b9f7*/, "maess" /*b9f8*/, "maeng" /*b9f9*/, "maej" /*b9fa*/, "maec" /*b9fb*/, "maek" /*b9fc*/, "maet" /*b9fd*/, "maep" /*b9fe*/, "maeh" /*b9ff*/ 
			});
						characters.TryAdd(186 /*47616 ba*/, new string[] {
				"mya" /*ba00*/, "myag" /*ba01*/, "myagg" /*ba02*/, "myags" /*ba03*/, "myan" /*ba04*/, "myanj" /*ba05*/, "myanh" /*ba06*/, "myad" /*ba07*/, "myal" /*ba08*/, "myalg" /*ba09*/, "myalm" /*ba0a*/, "myalb" /*ba0b*/, "myals" /*ba0c*/, "myalt" /*ba0d*/, "myalp" /*ba0e*/, "myalh" /*ba0f*/, "myam" /*ba10*/, "myab" /*ba11*/, "myabs" /*ba12*/, "myas" /*ba13*/, "myass" /*ba14*/, "myang" /*ba15*/, "myaj" /*ba16*/, "myac" /*ba17*/, "myak" /*ba18*/, "myat" /*ba19*/, "myap" /*ba1a*/, "myah" /*ba1b*/, "myae" /*ba1c*/, "myaeg" /*ba1d*/, "myaegg" /*ba1e*/, "myaegs" /*ba1f*/, "myaen" /*ba20*/, "myaenj" /*ba21*/, "myaenh" /*ba22*/, "myaed" /*ba23*/, "myael" /*ba24*/, "myaelg" /*ba25*/, "myaelm" /*ba26*/, "myaelb" /*ba27*/, "myaels" /*ba28*/, "myaelt" /*ba29*/, "myaelp" /*ba2a*/, "myaelh" /*ba2b*/, "myaem" /*ba2c*/, "myaeb" /*ba2d*/, "myaebs" /*ba2e*/, "myaes" /*ba2f*/, "myaess" /*ba30*/, "myaeng" /*ba31*/, "myaej" /*ba32*/, "myaec" /*ba33*/, "myaek" /*ba34*/, "myaet" /*ba35*/, "myaep" /*ba36*/, "myaeh" /*ba37*/, "meo" /*ba38*/, "meog" /*ba39*/, "meogg" /*ba3a*/, "meogs" /*ba3b*/, "meon" /*ba3c*/, "meonj" /*ba3d*/, "meonh" /*ba3e*/, "meod" /*ba3f*/, "meol" /*ba40*/, "meolg" /*ba41*/, "meolm" /*ba42*/, "meolb" /*ba43*/, "meols" /*ba44*/, "meolt" /*ba45*/, "meolp" /*ba46*/, "meolh" /*ba47*/, "meom" /*ba48*/, "meob" /*ba49*/, "meobs" /*ba4a*/, "meos" /*ba4b*/, "meoss" /*ba4c*/, "meong" /*ba4d*/, "meoj" /*ba4e*/, "meoc" /*ba4f*/, "meok" /*ba50*/, "meot" /*ba51*/, "meop" /*ba52*/, "meoh" /*ba53*/, "me" /*ba54*/, "meg" /*ba55*/, "megg" /*ba56*/, "megs" /*ba57*/, "men" /*ba58*/, "menj" /*ba59*/, "menh" /*ba5a*/, "med" /*ba5b*/, "mel" /*ba5c*/, "melg" /*ba5d*/, "melm" /*ba5e*/, "melb" /*ba5f*/, "mels" /*ba60*/, "melt" /*ba61*/, "melp" /*ba62*/, "melh" /*ba63*/, "mem" /*ba64*/, "meb" /*ba65*/, "mebs" /*ba66*/, "mes" /*ba67*/, "mess" /*ba68*/, "meng" /*ba69*/, "mej" /*ba6a*/, "mec" /*ba6b*/, "mek" /*ba6c*/, "met" /*ba6d*/, "mep" /*ba6e*/, "meh" /*ba6f*/, "myeo" /*ba70*/, "myeog" /*ba71*/, "myeogg" /*ba72*/, "myeogs" /*ba73*/, "myeon" /*ba74*/, "myeonj" /*ba75*/, "myeonh" /*ba76*/, "myeod" /*ba77*/, "myeol" /*ba78*/, "myeolg" /*ba79*/, "myeolm" /*ba7a*/, "myeolb" /*ba7b*/, "myeols" /*ba7c*/, "myeolt" /*ba7d*/, "myeolp" /*ba7e*/, "myeolh" /*ba7f*/, "myeom" /*ba80*/, "myeob" /*ba81*/, "myeobs" /*ba82*/, "myeos" /*ba83*/, "myeoss" /*ba84*/, "myeong" /*ba85*/, "myeoj" /*ba86*/, "myeoc" /*ba87*/, "myeok" /*ba88*/, "myeot" /*ba89*/, "myeop" /*ba8a*/, "myeoh" /*ba8b*/, "mye" /*ba8c*/, "myeg" /*ba8d*/, "myegg" /*ba8e*/, "myegs" /*ba8f*/, "myen" /*ba90*/, "myenj" /*ba91*/, "myenh" /*ba92*/, "myed" /*ba93*/, "myel" /*ba94*/, "myelg" /*ba95*/, "myelm" /*ba96*/, "myelb" /*ba97*/, "myels" /*ba98*/, "myelt" /*ba99*/, "myelp" /*ba9a*/, "myelh" /*ba9b*/, "myem" /*ba9c*/, "myeb" /*ba9d*/, "myebs" /*ba9e*/, "myes" /*ba9f*/, "myess" /*baa0*/, "myeng" /*baa1*/, "myej" /*baa2*/, "myec" /*baa3*/, "myek" /*baa4*/, "myet" /*baa5*/, "myep" /*baa6*/, "myeh" /*baa7*/, "mo" /*baa8*/, "mog" /*baa9*/, "mogg" /*baaa*/, "mogs" /*baab*/, "mon" /*baac*/, "monj" /*baad*/, "monh" /*baae*/, "mod" /*baaf*/, "mol" /*bab0*/, "molg" /*bab1*/, "molm" /*bab2*/, "molb" /*bab3*/, "mols" /*bab4*/, "molt" /*bab5*/, "molp" /*bab6*/, "molh" /*bab7*/, "mom" /*bab8*/, "mob" /*bab9*/, "mobs" /*baba*/, "mos" /*babb*/, "moss" /*babc*/, "mong" /*babd*/, "moj" /*babe*/, "moc" /*babf*/, "mok" /*bac0*/, "mot" /*bac1*/, "mop" /*bac2*/, "moh" /*bac3*/, "mwa" /*bac4*/, "mwag" /*bac5*/, "mwagg" /*bac6*/, "mwags" /*bac7*/, "mwan" /*bac8*/, "mwanj" /*bac9*/, "mwanh" /*baca*/, "mwad" /*bacb*/, "mwal" /*bacc*/, "mwalg" /*bacd*/, "mwalm" /*bace*/, "mwalb" /*bacf*/, "mwals" /*bad0*/, "mwalt" /*bad1*/, "mwalp" /*bad2*/, "mwalh" /*bad3*/, "mwam" /*bad4*/, "mwab" /*bad5*/, "mwabs" /*bad6*/, "mwas" /*bad7*/, "mwass" /*bad8*/, "mwang" /*bad9*/, "mwaj" /*bada*/, "mwac" /*badb*/, "mwak" /*badc*/, "mwat" /*badd*/, "mwap" /*bade*/, "mwah" /*badf*/, "mwae" /*bae0*/, "mwaeg" /*bae1*/, "mwaegg" /*bae2*/, "mwaegs" /*bae3*/, "mwaen" /*bae4*/, "mwaenj" /*bae5*/, "mwaenh" /*bae6*/, "mwaed" /*bae7*/, "mwael" /*bae8*/, "mwaelg" /*bae9*/, "mwaelm" /*baea*/, "mwaelb" /*baeb*/, "mwaels" /*baec*/, "mwaelt" /*baed*/, "mwaelp" /*baee*/, "mwaelh" /*baef*/, "mwaem" /*baf0*/, "mwaeb" /*baf1*/, "mwaebs" /*baf2*/, "mwaes" /*baf3*/, "mwaess" /*baf4*/, "mwaeng" /*baf5*/, "mwaej" /*baf6*/, "mwaec" /*baf7*/, "mwaek" /*baf8*/, "mwaet" /*baf9*/, "mwaep" /*bafa*/, "mwaeh" /*bafb*/, "moe" /*bafc*/, "moeg" /*bafd*/, "moegg" /*bafe*/, "moegs" /*baff*/ 
			});
						characters.TryAdd(187 /*47872 bb*/, new string[] {
				"moen" /*bb00*/, "moenj" /*bb01*/, "moenh" /*bb02*/, "moed" /*bb03*/, "moel" /*bb04*/, "moelg" /*bb05*/, "moelm" /*bb06*/, "moelb" /*bb07*/, "moels" /*bb08*/, "moelt" /*bb09*/, "moelp" /*bb0a*/, "moelh" /*bb0b*/, "moem" /*bb0c*/, "moeb" /*bb0d*/, "moebs" /*bb0e*/, "moes" /*bb0f*/, "moess" /*bb10*/, "moeng" /*bb11*/, "moej" /*bb12*/, "moec" /*bb13*/, "moek" /*bb14*/, "moet" /*bb15*/, "moep" /*bb16*/, "moeh" /*bb17*/, "myo" /*bb18*/, "myog" /*bb19*/, "myogg" /*bb1a*/, "myogs" /*bb1b*/, "myon" /*bb1c*/, "myonj" /*bb1d*/, "myonh" /*bb1e*/, "myod" /*bb1f*/, "myol" /*bb20*/, "myolg" /*bb21*/, "myolm" /*bb22*/, "myolb" /*bb23*/, "myols" /*bb24*/, "myolt" /*bb25*/, "myolp" /*bb26*/, "myolh" /*bb27*/, "myom" /*bb28*/, "myob" /*bb29*/, "myobs" /*bb2a*/, "myos" /*bb2b*/, "myoss" /*bb2c*/, "myong" /*bb2d*/, "myoj" /*bb2e*/, "myoc" /*bb2f*/, "myok" /*bb30*/, "myot" /*bb31*/, "myop" /*bb32*/, "myoh" /*bb33*/, "mu" /*bb34*/, "mug" /*bb35*/, "mugg" /*bb36*/, "mugs" /*bb37*/, "mun" /*bb38*/, "munj" /*bb39*/, "munh" /*bb3a*/, "mud" /*bb3b*/, "mul" /*bb3c*/, "mulg" /*bb3d*/, "mulm" /*bb3e*/, "mulb" /*bb3f*/, "muls" /*bb40*/, "mult" /*bb41*/, "mulp" /*bb42*/, "mulh" /*bb43*/, "mum" /*bb44*/, "mub" /*bb45*/, "mubs" /*bb46*/, "mus" /*bb47*/, "muss" /*bb48*/, "mung" /*bb49*/, "muj" /*bb4a*/, "muc" /*bb4b*/, "muk" /*bb4c*/, "mut" /*bb4d*/, "mup" /*bb4e*/, "muh" /*bb4f*/, "mweo" /*bb50*/, "mweog" /*bb51*/, "mweogg" /*bb52*/, "mweogs" /*bb53*/, "mweon" /*bb54*/, "mweonj" /*bb55*/, "mweonh" /*bb56*/, "mweod" /*bb57*/, "mweol" /*bb58*/, "mweolg" /*bb59*/, "mweolm" /*bb5a*/, "mweolb" /*bb5b*/, "mweols" /*bb5c*/, "mweolt" /*bb5d*/, "mweolp" /*bb5e*/, "mweolh" /*bb5f*/, "mweom" /*bb60*/, "mweob" /*bb61*/, "mweobs" /*bb62*/, "mweos" /*bb63*/, "mweoss" /*bb64*/, "mweong" /*bb65*/, "mweoj" /*bb66*/, "mweoc" /*bb67*/, "mweok" /*bb68*/, "mweot" /*bb69*/, "mweop" /*bb6a*/, "mweoh" /*bb6b*/, "mwe" /*bb6c*/, "mweg" /*bb6d*/, "mwegg" /*bb6e*/, "mwegs" /*bb6f*/, "mwen" /*bb70*/, "mwenj" /*bb71*/, "mwenh" /*bb72*/, "mwed" /*bb73*/, "mwel" /*bb74*/, "mwelg" /*bb75*/, "mwelm" /*bb76*/, "mwelb" /*bb77*/, "mwels" /*bb78*/, "mwelt" /*bb79*/, "mwelp" /*bb7a*/, "mwelh" /*bb7b*/, "mwem" /*bb7c*/, "mweb" /*bb7d*/, "mwebs" /*bb7e*/, "mwes" /*bb7f*/, "mwess" /*bb80*/, "mweng" /*bb81*/, "mwej" /*bb82*/, "mwec" /*bb83*/, "mwek" /*bb84*/, "mwet" /*bb85*/, "mwep" /*bb86*/, "mweh" /*bb87*/, "mwi" /*bb88*/, "mwig" /*bb89*/, "mwigg" /*bb8a*/, "mwigs" /*bb8b*/, "mwin" /*bb8c*/, "mwinj" /*bb8d*/, "mwinh" /*bb8e*/, "mwid" /*bb8f*/, "mwil" /*bb90*/, "mwilg" /*bb91*/, "mwilm" /*bb92*/, "mwilb" /*bb93*/, "mwils" /*bb94*/, "mwilt" /*bb95*/, "mwilp" /*bb96*/, "mwilh" /*bb97*/, "mwim" /*bb98*/, "mwib" /*bb99*/, "mwibs" /*bb9a*/, "mwis" /*bb9b*/, "mwiss" /*bb9c*/, "mwing" /*bb9d*/, "mwij" /*bb9e*/, "mwic" /*bb9f*/, "mwik" /*bba0*/, "mwit" /*bba1*/, "mwip" /*bba2*/, "mwih" /*bba3*/, "myu" /*bba4*/, "myug" /*bba5*/, "myugg" /*bba6*/, "myugs" /*bba7*/, "myun" /*bba8*/, "myunj" /*bba9*/, "myunh" /*bbaa*/, "myud" /*bbab*/, "myul" /*bbac*/, "myulg" /*bbad*/, "myulm" /*bbae*/, "myulb" /*bbaf*/, "myuls" /*bbb0*/, "myult" /*bbb1*/, "myulp" /*bbb2*/, "myulh" /*bbb3*/, "myum" /*bbb4*/, "myub" /*bbb5*/, "myubs" /*bbb6*/, "myus" /*bbb7*/, "myuss" /*bbb8*/, "myung" /*bbb9*/, "myuj" /*bbba*/, "myuc" /*bbbb*/, "myuk" /*bbbc*/, "myut" /*bbbd*/, "myup" /*bbbe*/, "myuh" /*bbbf*/, "meu" /*bbc0*/, "meug" /*bbc1*/, "meugg" /*bbc2*/, "meugs" /*bbc3*/, "meun" /*bbc4*/, "meunj" /*bbc5*/, "meunh" /*bbc6*/, "meud" /*bbc7*/, "meul" /*bbc8*/, "meulg" /*bbc9*/, "meulm" /*bbca*/, "meulb" /*bbcb*/, "meuls" /*bbcc*/, "meult" /*bbcd*/, "meulp" /*bbce*/, "meulh" /*bbcf*/, "meum" /*bbd0*/, "meub" /*bbd1*/, "meubs" /*bbd2*/, "meus" /*bbd3*/, "meuss" /*bbd4*/, "meung" /*bbd5*/, "meuj" /*bbd6*/, "meuc" /*bbd7*/, "meuk" /*bbd8*/, "meut" /*bbd9*/, "meup" /*bbda*/, "meuh" /*bbdb*/, "myi" /*bbdc*/, "myig" /*bbdd*/, "myigg" /*bbde*/, "myigs" /*bbdf*/, "myin" /*bbe0*/, "myinj" /*bbe1*/, "myinh" /*bbe2*/, "myid" /*bbe3*/, "myil" /*bbe4*/, "myilg" /*bbe5*/, "myilm" /*bbe6*/, "myilb" /*bbe7*/, "myils" /*bbe8*/, "myilt" /*bbe9*/, "myilp" /*bbea*/, "myilh" /*bbeb*/, "myim" /*bbec*/, "myib" /*bbed*/, "myibs" /*bbee*/, "myis" /*bbef*/, "myiss" /*bbf0*/, "mying" /*bbf1*/, "myij" /*bbf2*/, "myic" /*bbf3*/, "myik" /*bbf4*/, "myit" /*bbf5*/, "myip" /*bbf6*/, "myih" /*bbf7*/, "mi" /*bbf8*/, "mig" /*bbf9*/, "migg" /*bbfa*/, "migs" /*bbfb*/, "min" /*bbfc*/, "minj" /*bbfd*/, "minh" /*bbfe*/, "mid" /*bbff*/ 
			});
						characters.TryAdd(188 /*48128 bc*/, new string[] {
				"mil" /*bc00*/, "milg" /*bc01*/, "milm" /*bc02*/, "milb" /*bc03*/, "mils" /*bc04*/, "milt" /*bc05*/, "milp" /*bc06*/, "milh" /*bc07*/, "mim" /*bc08*/, "mib" /*bc09*/, "mibs" /*bc0a*/, "mis" /*bc0b*/, "miss" /*bc0c*/, "ming" /*bc0d*/, "mij" /*bc0e*/, "mic" /*bc0f*/, "mik" /*bc10*/, "mit" /*bc11*/, "mip" /*bc12*/, "mih" /*bc13*/, "ba" /*bc14*/, "bag" /*bc15*/, "bagg" /*bc16*/, "bags" /*bc17*/, "ban" /*bc18*/, "banj" /*bc19*/, "banh" /*bc1a*/, "bad" /*bc1b*/, "bal" /*bc1c*/, "balg" /*bc1d*/, "balm" /*bc1e*/, "balb" /*bc1f*/, "bals" /*bc20*/, "balt" /*bc21*/, "balp" /*bc22*/, "balh" /*bc23*/, "bam" /*bc24*/, "bab" /*bc25*/, "babs" /*bc26*/, "bas" /*bc27*/, "bass" /*bc28*/, "bang" /*bc29*/, "baj" /*bc2a*/, "bac" /*bc2b*/, "bak" /*bc2c*/, "bat" /*bc2d*/, "bap" /*bc2e*/, "bah" /*bc2f*/, "bae" /*bc30*/, "baeg" /*bc31*/, "baegg" /*bc32*/, "baegs" /*bc33*/, "baen" /*bc34*/, "baenj" /*bc35*/, "baenh" /*bc36*/, "baed" /*bc37*/, "bael" /*bc38*/, "baelg" /*bc39*/, "baelm" /*bc3a*/, "baelb" /*bc3b*/, "baels" /*bc3c*/, "baelt" /*bc3d*/, "baelp" /*bc3e*/, "baelh" /*bc3f*/, "baem" /*bc40*/, "baeb" /*bc41*/, "baebs" /*bc42*/, "baes" /*bc43*/, "baess" /*bc44*/, "baeng" /*bc45*/, "baej" /*bc46*/, "baec" /*bc47*/, "baek" /*bc48*/, "baet" /*bc49*/, "baep" /*bc4a*/, "baeh" /*bc4b*/, "bya" /*bc4c*/, "byag" /*bc4d*/, "byagg" /*bc4e*/, "byags" /*bc4f*/, "byan" /*bc50*/, "byanj" /*bc51*/, "byanh" /*bc52*/, "byad" /*bc53*/, "byal" /*bc54*/, "byalg" /*bc55*/, "byalm" /*bc56*/, "byalb" /*bc57*/, "byals" /*bc58*/, "byalt" /*bc59*/, "byalp" /*bc5a*/, "byalh" /*bc5b*/, "byam" /*bc5c*/, "byab" /*bc5d*/, "byabs" /*bc5e*/, "byas" /*bc5f*/, "byass" /*bc60*/, "byang" /*bc61*/, "byaj" /*bc62*/, "byac" /*bc63*/, "byak" /*bc64*/, "byat" /*bc65*/, "byap" /*bc66*/, "byah" /*bc67*/, "byae" /*bc68*/, "byaeg" /*bc69*/, "byaegg" /*bc6a*/, "byaegs" /*bc6b*/, "byaen" /*bc6c*/, "byaenj" /*bc6d*/, "byaenh" /*bc6e*/, "byaed" /*bc6f*/, "byael" /*bc70*/, "byaelg" /*bc71*/, "byaelm" /*bc72*/, "byaelb" /*bc73*/, "byaels" /*bc74*/, "byaelt" /*bc75*/, "byaelp" /*bc76*/, "byaelh" /*bc77*/, "byaem" /*bc78*/, "byaeb" /*bc79*/, "byaebs" /*bc7a*/, "byaes" /*bc7b*/, "byaess" /*bc7c*/, "byaeng" /*bc7d*/, "byaej" /*bc7e*/, "byaec" /*bc7f*/, "byaek" /*bc80*/, "byaet" /*bc81*/, "byaep" /*bc82*/, "byaeh" /*bc83*/, "beo" /*bc84*/, "beog" /*bc85*/, "beogg" /*bc86*/, "beogs" /*bc87*/, "beon" /*bc88*/, "beonj" /*bc89*/, "beonh" /*bc8a*/, "beod" /*bc8b*/, "beol" /*bc8c*/, "beolg" /*bc8d*/, "beolm" /*bc8e*/, "beolb" /*bc8f*/, "beols" /*bc90*/, "beolt" /*bc91*/, "beolp" /*bc92*/, "beolh" /*bc93*/, "beom" /*bc94*/, "beob" /*bc95*/, "beobs" /*bc96*/, "beos" /*bc97*/, "beoss" /*bc98*/, "beong" /*bc99*/, "beoj" /*bc9a*/, "beoc" /*bc9b*/, "beok" /*bc9c*/, "beot" /*bc9d*/, "beop" /*bc9e*/, "beoh" /*bc9f*/, "be" /*bca0*/, "beg" /*bca1*/, "begg" /*bca2*/, "begs" /*bca3*/, "ben" /*bca4*/, "benj" /*bca5*/, "benh" /*bca6*/, "bed" /*bca7*/, "bel" /*bca8*/, "belg" /*bca9*/, "belm" /*bcaa*/, "belb" /*bcab*/, "bels" /*bcac*/, "belt" /*bcad*/, "belp" /*bcae*/, "belh" /*bcaf*/, "bem" /*bcb0*/, "beb" /*bcb1*/, "bebs" /*bcb2*/, "bes" /*bcb3*/, "bess" /*bcb4*/, "beng" /*bcb5*/, "bej" /*bcb6*/, "bec" /*bcb7*/, "bek" /*bcb8*/, "bet" /*bcb9*/, "bep" /*bcba*/, "beh" /*bcbb*/, "byeo" /*bcbc*/, "byeog" /*bcbd*/, "byeogg" /*bcbe*/, "byeogs" /*bcbf*/, "byeon" /*bcc0*/, "byeonj" /*bcc1*/, "byeonh" /*bcc2*/, "byeod" /*bcc3*/, "byeol" /*bcc4*/, "byeolg" /*bcc5*/, "byeolm" /*bcc6*/, "byeolb" /*bcc7*/, "byeols" /*bcc8*/, "byeolt" /*bcc9*/, "byeolp" /*bcca*/, "byeolh" /*bccb*/, "byeom" /*bccc*/, "byeob" /*bccd*/, "byeobs" /*bcce*/, "byeos" /*bccf*/, "byeoss" /*bcd0*/, "byeong" /*bcd1*/, "byeoj" /*bcd2*/, "byeoc" /*bcd3*/, "byeok" /*bcd4*/, "byeot" /*bcd5*/, "byeop" /*bcd6*/, "byeoh" /*bcd7*/, "bye" /*bcd8*/, "byeg" /*bcd9*/, "byegg" /*bcda*/, "byegs" /*bcdb*/, "byen" /*bcdc*/, "byenj" /*bcdd*/, "byenh" /*bcde*/, "byed" /*bcdf*/, "byel" /*bce0*/, "byelg" /*bce1*/, "byelm" /*bce2*/, "byelb" /*bce3*/, "byels" /*bce4*/, "byelt" /*bce5*/, "byelp" /*bce6*/, "byelh" /*bce7*/, "byem" /*bce8*/, "byeb" /*bce9*/, "byebs" /*bcea*/, "byes" /*bceb*/, "byess" /*bcec*/, "byeng" /*bced*/, "byej" /*bcee*/, "byec" /*bcef*/, "byek" /*bcf0*/, "byet" /*bcf1*/, "byep" /*bcf2*/, "byeh" /*bcf3*/, "bo" /*bcf4*/, "bog" /*bcf5*/, "bogg" /*bcf6*/, "bogs" /*bcf7*/, "bon" /*bcf8*/, "bonj" /*bcf9*/, "bonh" /*bcfa*/, "bod" /*bcfb*/, "bol" /*bcfc*/, "bolg" /*bcfd*/, "bolm" /*bcfe*/, "bolb" /*bcff*/ 
			});
						characters.TryAdd(189 /*48384 bd*/, new string[] {
				"bols" /*bd00*/, "bolt" /*bd01*/, "bolp" /*bd02*/, "bolh" /*bd03*/, "bom" /*bd04*/, "bob" /*bd05*/, "bobs" /*bd06*/, "bos" /*bd07*/, "boss" /*bd08*/, "bong" /*bd09*/, "boj" /*bd0a*/, "boc" /*bd0b*/, "bok" /*bd0c*/, "bot" /*bd0d*/, "bop" /*bd0e*/, "boh" /*bd0f*/, "bwa" /*bd10*/, "bwag" /*bd11*/, "bwagg" /*bd12*/, "bwags" /*bd13*/, "bwan" /*bd14*/, "bwanj" /*bd15*/, "bwanh" /*bd16*/, "bwad" /*bd17*/, "bwal" /*bd18*/, "bwalg" /*bd19*/, "bwalm" /*bd1a*/, "bwalb" /*bd1b*/, "bwals" /*bd1c*/, "bwalt" /*bd1d*/, "bwalp" /*bd1e*/, "bwalh" /*bd1f*/, "bwam" /*bd20*/, "bwab" /*bd21*/, "bwabs" /*bd22*/, "bwas" /*bd23*/, "bwass" /*bd24*/, "bwang" /*bd25*/, "bwaj" /*bd26*/, "bwac" /*bd27*/, "bwak" /*bd28*/, "bwat" /*bd29*/, "bwap" /*bd2a*/, "bwah" /*bd2b*/, "bwae" /*bd2c*/, "bwaeg" /*bd2d*/, "bwaegg" /*bd2e*/, "bwaegs" /*bd2f*/, "bwaen" /*bd30*/, "bwaenj" /*bd31*/, "bwaenh" /*bd32*/, "bwaed" /*bd33*/, "bwael" /*bd34*/, "bwaelg" /*bd35*/, "bwaelm" /*bd36*/, "bwaelb" /*bd37*/, "bwaels" /*bd38*/, "bwaelt" /*bd39*/, "bwaelp" /*bd3a*/, "bwaelh" /*bd3b*/, "bwaem" /*bd3c*/, "bwaeb" /*bd3d*/, "bwaebs" /*bd3e*/, "bwaes" /*bd3f*/, "bwaess" /*bd40*/, "bwaeng" /*bd41*/, "bwaej" /*bd42*/, "bwaec" /*bd43*/, "bwaek" /*bd44*/, "bwaet" /*bd45*/, "bwaep" /*bd46*/, "bwaeh" /*bd47*/, "boe" /*bd48*/, "boeg" /*bd49*/, "boegg" /*bd4a*/, "boegs" /*bd4b*/, "boen" /*bd4c*/, "boenj" /*bd4d*/, "boenh" /*bd4e*/, "boed" /*bd4f*/, "boel" /*bd50*/, "boelg" /*bd51*/, "boelm" /*bd52*/, "boelb" /*bd53*/, "boels" /*bd54*/, "boelt" /*bd55*/, "boelp" /*bd56*/, "boelh" /*bd57*/, "boem" /*bd58*/, "boeb" /*bd59*/, "boebs" /*bd5a*/, "boes" /*bd5b*/, "boess" /*bd5c*/, "boeng" /*bd5d*/, "boej" /*bd5e*/, "boec" /*bd5f*/, "boek" /*bd60*/, "boet" /*bd61*/, "boep" /*bd62*/, "boeh" /*bd63*/, "byo" /*bd64*/, "byog" /*bd65*/, "byogg" /*bd66*/, "byogs" /*bd67*/, "byon" /*bd68*/, "byonj" /*bd69*/, "byonh" /*bd6a*/, "byod" /*bd6b*/, "byol" /*bd6c*/, "byolg" /*bd6d*/, "byolm" /*bd6e*/, "byolb" /*bd6f*/, "byols" /*bd70*/, "byolt" /*bd71*/, "byolp" /*bd72*/, "byolh" /*bd73*/, "byom" /*bd74*/, "byob" /*bd75*/, "byobs" /*bd76*/, "byos" /*bd77*/, "byoss" /*bd78*/, "byong" /*bd79*/, "byoj" /*bd7a*/, "byoc" /*bd7b*/, "byok" /*bd7c*/, "byot" /*bd7d*/, "byop" /*bd7e*/, "byoh" /*bd7f*/, "bu" /*bd80*/, "bug" /*bd81*/, "bugg" /*bd82*/, "bugs" /*bd83*/, "bun" /*bd84*/, "bunj" /*bd85*/, "bunh" /*bd86*/, "bud" /*bd87*/, "bul" /*bd88*/, "bulg" /*bd89*/, "bulm" /*bd8a*/, "bulb" /*bd8b*/, "buls" /*bd8c*/, "bult" /*bd8d*/, "bulp" /*bd8e*/, "bulh" /*bd8f*/, "bum" /*bd90*/, "bub" /*bd91*/, "bubs" /*bd92*/, "bus" /*bd93*/, "buss" /*bd94*/, "bung" /*bd95*/, "buj" /*bd96*/, "buc" /*bd97*/, "buk" /*bd98*/, "but" /*bd99*/, "bup" /*bd9a*/, "buh" /*bd9b*/, "bweo" /*bd9c*/, "bweog" /*bd9d*/, "bweogg" /*bd9e*/, "bweogs" /*bd9f*/, "bweon" /*bda0*/, "bweonj" /*bda1*/, "bweonh" /*bda2*/, "bweod" /*bda3*/, "bweol" /*bda4*/, "bweolg" /*bda5*/, "bweolm" /*bda6*/, "bweolb" /*bda7*/, "bweols" /*bda8*/, "bweolt" /*bda9*/, "bweolp" /*bdaa*/, "bweolh" /*bdab*/, "bweom" /*bdac*/, "bweob" /*bdad*/, "bweobs" /*bdae*/, "bweos" /*bdaf*/, "bweoss" /*bdb0*/, "bweong" /*bdb1*/, "bweoj" /*bdb2*/, "bweoc" /*bdb3*/, "bweok" /*bdb4*/, "bweot" /*bdb5*/, "bweop" /*bdb6*/, "bweoh" /*bdb7*/, "bwe" /*bdb8*/, "bweg" /*bdb9*/, "bwegg" /*bdba*/, "bwegs" /*bdbb*/, "bwen" /*bdbc*/, "bwenj" /*bdbd*/, "bwenh" /*bdbe*/, "bwed" /*bdbf*/, "bwel" /*bdc0*/, "bwelg" /*bdc1*/, "bwelm" /*bdc2*/, "bwelb" /*bdc3*/, "bwels" /*bdc4*/, "bwelt" /*bdc5*/, "bwelp" /*bdc6*/, "bwelh" /*bdc7*/, "bwem" /*bdc8*/, "bweb" /*bdc9*/, "bwebs" /*bdca*/, "bwes" /*bdcb*/, "bwess" /*bdcc*/, "bweng" /*bdcd*/, "bwej" /*bdce*/, "bwec" /*bdcf*/, "bwek" /*bdd0*/, "bwet" /*bdd1*/, "bwep" /*bdd2*/, "bweh" /*bdd3*/, "bwi" /*bdd4*/, "bwig" /*bdd5*/, "bwigg" /*bdd6*/, "bwigs" /*bdd7*/, "bwin" /*bdd8*/, "bwinj" /*bdd9*/, "bwinh" /*bdda*/, "bwid" /*bddb*/, "bwil" /*bddc*/, "bwilg" /*bddd*/, "bwilm" /*bdde*/, "bwilb" /*bddf*/, "bwils" /*bde0*/, "bwilt" /*bde1*/, "bwilp" /*bde2*/, "bwilh" /*bde3*/, "bwim" /*bde4*/, "bwib" /*bde5*/, "bwibs" /*bde6*/, "bwis" /*bde7*/, "bwiss" /*bde8*/, "bwing" /*bde9*/, "bwij" /*bdea*/, "bwic" /*bdeb*/, "bwik" /*bdec*/, "bwit" /*bded*/, "bwip" /*bdee*/, "bwih" /*bdef*/, "byu" /*bdf0*/, "byug" /*bdf1*/, "byugg" /*bdf2*/, "byugs" /*bdf3*/, "byun" /*bdf4*/, "byunj" /*bdf5*/, "byunh" /*bdf6*/, "byud" /*bdf7*/, "byul" /*bdf8*/, "byulg" /*bdf9*/, "byulm" /*bdfa*/, "byulb" /*bdfb*/, "byuls" /*bdfc*/, "byult" /*bdfd*/, "byulp" /*bdfe*/, "byulh" /*bdff*/ 
			});
						characters.TryAdd(190 /*48640 be*/, new string[] {
				"byum" /*be00*/, "byub" /*be01*/, "byubs" /*be02*/, "byus" /*be03*/, "byuss" /*be04*/, "byung" /*be05*/, "byuj" /*be06*/, "byuc" /*be07*/, "byuk" /*be08*/, "byut" /*be09*/, "byup" /*be0a*/, "byuh" /*be0b*/, "beu" /*be0c*/, "beug" /*be0d*/, "beugg" /*be0e*/, "beugs" /*be0f*/, "beun" /*be10*/, "beunj" /*be11*/, "beunh" /*be12*/, "beud" /*be13*/, "beul" /*be14*/, "beulg" /*be15*/, "beulm" /*be16*/, "beulb" /*be17*/, "beuls" /*be18*/, "beult" /*be19*/, "beulp" /*be1a*/, "beulh" /*be1b*/, "beum" /*be1c*/, "beub" /*be1d*/, "beubs" /*be1e*/, "beus" /*be1f*/, "beuss" /*be20*/, "beung" /*be21*/, "beuj" /*be22*/, "beuc" /*be23*/, "beuk" /*be24*/, "beut" /*be25*/, "beup" /*be26*/, "beuh" /*be27*/, "byi" /*be28*/, "byig" /*be29*/, "byigg" /*be2a*/, "byigs" /*be2b*/, "byin" /*be2c*/, "byinj" /*be2d*/, "byinh" /*be2e*/, "byid" /*be2f*/, "byil" /*be30*/, "byilg" /*be31*/, "byilm" /*be32*/, "byilb" /*be33*/, "byils" /*be34*/, "byilt" /*be35*/, "byilp" /*be36*/, "byilh" /*be37*/, "byim" /*be38*/, "byib" /*be39*/, "byibs" /*be3a*/, "byis" /*be3b*/, "byiss" /*be3c*/, "bying" /*be3d*/, "byij" /*be3e*/, "byic" /*be3f*/, "byik" /*be40*/, "byit" /*be41*/, "byip" /*be42*/, "byih" /*be43*/, "bi" /*be44*/, "big" /*be45*/, "bigg" /*be46*/, "bigs" /*be47*/, "bin" /*be48*/, "binj" /*be49*/, "binh" /*be4a*/, "bid" /*be4b*/, "bil" /*be4c*/, "bilg" /*be4d*/, "bilm" /*be4e*/, "bilb" /*be4f*/, "bils" /*be50*/, "bilt" /*be51*/, "bilp" /*be52*/, "bilh" /*be53*/, "bim" /*be54*/, "bib" /*be55*/, "bibs" /*be56*/, "bis" /*be57*/, "biss" /*be58*/, "bing" /*be59*/, "bij" /*be5a*/, "bic" /*be5b*/, "bik" /*be5c*/, "bit" /*be5d*/, "bip" /*be5e*/, "bih" /*be5f*/, "bba" /*be60*/, "bbag" /*be61*/, "bbagg" /*be62*/, "bbags" /*be63*/, "bban" /*be64*/, "bbanj" /*be65*/, "bbanh" /*be66*/, "bbad" /*be67*/, "bbal" /*be68*/, "bbalg" /*be69*/, "bbalm" /*be6a*/, "bbalb" /*be6b*/, "bbals" /*be6c*/, "bbalt" /*be6d*/, "bbalp" /*be6e*/, "bbalh" /*be6f*/, "bbam" /*be70*/, "bbab" /*be71*/, "bbabs" /*be72*/, "bbas" /*be73*/, "bbass" /*be74*/, "bbang" /*be75*/, "bbaj" /*be76*/, "bbac" /*be77*/, "bbak" /*be78*/, "bbat" /*be79*/, "bbap" /*be7a*/, "bbah" /*be7b*/, "bbae" /*be7c*/, "bbaeg" /*be7d*/, "bbaegg" /*be7e*/, "bbaegs" /*be7f*/, "bbaen" /*be80*/, "bbaenj" /*be81*/, "bbaenh" /*be82*/, "bbaed" /*be83*/, "bbael" /*be84*/, "bbaelg" /*be85*/, "bbaelm" /*be86*/, "bbaelb" /*be87*/, "bbaels" /*be88*/, "bbaelt" /*be89*/, "bbaelp" /*be8a*/, "bbaelh" /*be8b*/, "bbaem" /*be8c*/, "bbaeb" /*be8d*/, "bbaebs" /*be8e*/, "bbaes" /*be8f*/, "bbaess" /*be90*/, "bbaeng" /*be91*/, "bbaej" /*be92*/, "bbaec" /*be93*/, "bbaek" /*be94*/, "bbaet" /*be95*/, "bbaep" /*be96*/, "bbaeh" /*be97*/, "bbya" /*be98*/, "bbyag" /*be99*/, "bbyagg" /*be9a*/, "bbyags" /*be9b*/, "bbyan" /*be9c*/, "bbyanj" /*be9d*/, "bbyanh" /*be9e*/, "bbyad" /*be9f*/, "bbyal" /*bea0*/, "bbyalg" /*bea1*/, "bbyalm" /*bea2*/, "bbyalb" /*bea3*/, "bbyals" /*bea4*/, "bbyalt" /*bea5*/, "bbyalp" /*bea6*/, "bbyalh" /*bea7*/, "bbyam" /*bea8*/, "bbyab" /*bea9*/, "bbyabs" /*beaa*/, "bbyas" /*beab*/, "bbyass" /*beac*/, "bbyang" /*bead*/, "bbyaj" /*beae*/, "bbyac" /*beaf*/, "bbyak" /*beb0*/, "bbyat" /*beb1*/, "bbyap" /*beb2*/, "bbyah" /*beb3*/, "bbyae" /*beb4*/, "bbyaeg" /*beb5*/, "bbyaegg" /*beb6*/, "bbyaegs" /*beb7*/, "bbyaen" /*beb8*/, "bbyaenj" /*beb9*/, "bbyaenh" /*beba*/, "bbyaed" /*bebb*/, "bbyael" /*bebc*/, "bbyaelg" /*bebd*/, "bbyaelm" /*bebe*/, "bbyaelb" /*bebf*/, "bbyaels" /*bec0*/, "bbyaelt" /*bec1*/, "bbyaelp" /*bec2*/, "bbyaelh" /*bec3*/, "bbyaem" /*bec4*/, "bbyaeb" /*bec5*/, "bbyaebs" /*bec6*/, "bbyaes" /*bec7*/, "bbyaess" /*bec8*/, "bbyaeng" /*bec9*/, "bbyaej" /*beca*/, "bbyaec" /*becb*/, "bbyaek" /*becc*/, "bbyaet" /*becd*/, "bbyaep" /*bece*/, "bbyaeh" /*becf*/, "bbeo" /*bed0*/, "bbeog" /*bed1*/, "bbeogg" /*bed2*/, "bbeogs" /*bed3*/, "bbeon" /*bed4*/, "bbeonj" /*bed5*/, "bbeonh" /*bed6*/, "bbeod" /*bed7*/, "bbeol" /*bed8*/, "bbeolg" /*bed9*/, "bbeolm" /*beda*/, "bbeolb" /*bedb*/, "bbeols" /*bedc*/, "bbeolt" /*bedd*/, "bbeolp" /*bede*/, "bbeolh" /*bedf*/, "bbeom" /*bee0*/, "bbeob" /*bee1*/, "bbeobs" /*bee2*/, "bbeos" /*bee3*/, "bbeoss" /*bee4*/, "bbeong" /*bee5*/, "bbeoj" /*bee6*/, "bbeoc" /*bee7*/, "bbeok" /*bee8*/, "bbeot" /*bee9*/, "bbeop" /*beea*/, "bbeoh" /*beeb*/, "bbe" /*beec*/, "bbeg" /*beed*/, "bbegg" /*beee*/, "bbegs" /*beef*/, "bben" /*bef0*/, "bbenj" /*bef1*/, "bbenh" /*bef2*/, "bbed" /*bef3*/, "bbel" /*bef4*/, "bbelg" /*bef5*/, "bbelm" /*bef6*/, "bbelb" /*bef7*/, "bbels" /*bef8*/, "bbelt" /*bef9*/, "bbelp" /*befa*/, "bbelh" /*befb*/, "bbem" /*befc*/, "bbeb" /*befd*/, "bbebs" /*befe*/, "bbes" /*beff*/ 
			});
						characters.TryAdd(191 /*48896 bf*/, new string[] {
				"bbess" /*bf00*/, "bbeng" /*bf01*/, "bbej" /*bf02*/, "bbec" /*bf03*/, "bbek" /*bf04*/, "bbet" /*bf05*/, "bbep" /*bf06*/, "bbeh" /*bf07*/, "bbyeo" /*bf08*/, "bbyeog" /*bf09*/, "bbyeogg" /*bf0a*/, "bbyeogs" /*bf0b*/, "bbyeon" /*bf0c*/, "bbyeonj" /*bf0d*/, "bbyeonh" /*bf0e*/, "bbyeod" /*bf0f*/, "bbyeol" /*bf10*/, "bbyeolg" /*bf11*/, "bbyeolm" /*bf12*/, "bbyeolb" /*bf13*/, "bbyeols" /*bf14*/, "bbyeolt" /*bf15*/, "bbyeolp" /*bf16*/, "bbyeolh" /*bf17*/, "bbyeom" /*bf18*/, "bbyeob" /*bf19*/, "bbyeobs" /*bf1a*/, "bbyeos" /*bf1b*/, "bbyeoss" /*bf1c*/, "bbyeong" /*bf1d*/, "bbyeoj" /*bf1e*/, "bbyeoc" /*bf1f*/, "bbyeok" /*bf20*/, "bbyeot" /*bf21*/, "bbyeop" /*bf22*/, "bbyeoh" /*bf23*/, "bbye" /*bf24*/, "bbyeg" /*bf25*/, "bbyegg" /*bf26*/, "bbyegs" /*bf27*/, "bbyen" /*bf28*/, "bbyenj" /*bf29*/, "bbyenh" /*bf2a*/, "bbyed" /*bf2b*/, "bbyel" /*bf2c*/, "bbyelg" /*bf2d*/, "bbyelm" /*bf2e*/, "bbyelb" /*bf2f*/, "bbyels" /*bf30*/, "bbyelt" /*bf31*/, "bbyelp" /*bf32*/, "bbyelh" /*bf33*/, "bbyem" /*bf34*/, "bbyeb" /*bf35*/, "bbyebs" /*bf36*/, "bbyes" /*bf37*/, "bbyess" /*bf38*/, "bbyeng" /*bf39*/, "bbyej" /*bf3a*/, "bbyec" /*bf3b*/, "bbyek" /*bf3c*/, "bbyet" /*bf3d*/, "bbyep" /*bf3e*/, "bbyeh" /*bf3f*/, "bbo" /*bf40*/, "bbog" /*bf41*/, "bbogg" /*bf42*/, "bbogs" /*bf43*/, "bbon" /*bf44*/, "bbonj" /*bf45*/, "bbonh" /*bf46*/, "bbod" /*bf47*/, "bbol" /*bf48*/, "bbolg" /*bf49*/, "bbolm" /*bf4a*/, "bbolb" /*bf4b*/, "bbols" /*bf4c*/, "bbolt" /*bf4d*/, "bbolp" /*bf4e*/, "bbolh" /*bf4f*/, "bbom" /*bf50*/, "bbob" /*bf51*/, "bbobs" /*bf52*/, "bbos" /*bf53*/, "bboss" /*bf54*/, "bbong" /*bf55*/, "bboj" /*bf56*/, "bboc" /*bf57*/, "bbok" /*bf58*/, "bbot" /*bf59*/, "bbop" /*bf5a*/, "bboh" /*bf5b*/, "bbwa" /*bf5c*/, "bbwag" /*bf5d*/, "bbwagg" /*bf5e*/, "bbwags" /*bf5f*/, "bbwan" /*bf60*/, "bbwanj" /*bf61*/, "bbwanh" /*bf62*/, "bbwad" /*bf63*/, "bbwal" /*bf64*/, "bbwalg" /*bf65*/, "bbwalm" /*bf66*/, "bbwalb" /*bf67*/, "bbwals" /*bf68*/, "bbwalt" /*bf69*/, "bbwalp" /*bf6a*/, "bbwalh" /*bf6b*/, "bbwam" /*bf6c*/, "bbwab" /*bf6d*/, "bbwabs" /*bf6e*/, "bbwas" /*bf6f*/, "bbwass" /*bf70*/, "bbwang" /*bf71*/, "bbwaj" /*bf72*/, "bbwac" /*bf73*/, "bbwak" /*bf74*/, "bbwat" /*bf75*/, "bbwap" /*bf76*/, "bbwah" /*bf77*/, "bbwae" /*bf78*/, "bbwaeg" /*bf79*/, "bbwaegg" /*bf7a*/, "bbwaegs" /*bf7b*/, "bbwaen" /*bf7c*/, "bbwaenj" /*bf7d*/, "bbwaenh" /*bf7e*/, "bbwaed" /*bf7f*/, "bbwael" /*bf80*/, "bbwaelg" /*bf81*/, "bbwaelm" /*bf82*/, "bbwaelb" /*bf83*/, "bbwaels" /*bf84*/, "bbwaelt" /*bf85*/, "bbwaelp" /*bf86*/, "bbwaelh" /*bf87*/, "bbwaem" /*bf88*/, "bbwaeb" /*bf89*/, "bbwaebs" /*bf8a*/, "bbwaes" /*bf8b*/, "bbwaess" /*bf8c*/, "bbwaeng" /*bf8d*/, "bbwaej" /*bf8e*/, "bbwaec" /*bf8f*/, "bbwaek" /*bf90*/, "bbwaet" /*bf91*/, "bbwaep" /*bf92*/, "bbwaeh" /*bf93*/, "bboe" /*bf94*/, "bboeg" /*bf95*/, "bboegg" /*bf96*/, "bboegs" /*bf97*/, "bboen" /*bf98*/, "bboenj" /*bf99*/, "bboenh" /*bf9a*/, "bboed" /*bf9b*/, "bboel" /*bf9c*/, "bboelg" /*bf9d*/, "bboelm" /*bf9e*/, "bboelb" /*bf9f*/, "bboels" /*bfa0*/, "bboelt" /*bfa1*/, "bboelp" /*bfa2*/, "bboelh" /*bfa3*/, "bboem" /*bfa4*/, "bboeb" /*bfa5*/, "bboebs" /*bfa6*/, "bboes" /*bfa7*/, "bboess" /*bfa8*/, "bboeng" /*bfa9*/, "bboej" /*bfaa*/, "bboec" /*bfab*/, "bboek" /*bfac*/, "bboet" /*bfad*/, "bboep" /*bfae*/, "bboeh" /*bfaf*/, "bbyo" /*bfb0*/, "bbyog" /*bfb1*/, "bbyogg" /*bfb2*/, "bbyogs" /*bfb3*/, "bbyon" /*bfb4*/, "bbyonj" /*bfb5*/, "bbyonh" /*bfb6*/, "bbyod" /*bfb7*/, "bbyol" /*bfb8*/, "bbyolg" /*bfb9*/, "bbyolm" /*bfba*/, "bbyolb" /*bfbb*/, "bbyols" /*bfbc*/, "bbyolt" /*bfbd*/, "bbyolp" /*bfbe*/, "bbyolh" /*bfbf*/, "bbyom" /*bfc0*/, "bbyob" /*bfc1*/, "bbyobs" /*bfc2*/, "bbyos" /*bfc3*/, "bbyoss" /*bfc4*/, "bbyong" /*bfc5*/, "bbyoj" /*bfc6*/, "bbyoc" /*bfc7*/, "bbyok" /*bfc8*/, "bbyot" /*bfc9*/, "bbyop" /*bfca*/, "bbyoh" /*bfcb*/, "bbu" /*bfcc*/, "bbug" /*bfcd*/, "bbugg" /*bfce*/, "bbugs" /*bfcf*/, "bbun" /*bfd0*/, "bbunj" /*bfd1*/, "bbunh" /*bfd2*/, "bbud" /*bfd3*/, "bbul" /*bfd4*/, "bbulg" /*bfd5*/, "bbulm" /*bfd6*/, "bbulb" /*bfd7*/, "bbuls" /*bfd8*/, "bbult" /*bfd9*/, "bbulp" /*bfda*/, "bbulh" /*bfdb*/, "bbum" /*bfdc*/, "bbub" /*bfdd*/, "bbubs" /*bfde*/, "bbus" /*bfdf*/, "bbuss" /*bfe0*/, "bbung" /*bfe1*/, "bbuj" /*bfe2*/, "bbuc" /*bfe3*/, "bbuk" /*bfe4*/, "bbut" /*bfe5*/, "bbup" /*bfe6*/, "bbuh" /*bfe7*/, "bbweo" /*bfe8*/, "bbweog" /*bfe9*/, "bbweogg" /*bfea*/, "bbweogs" /*bfeb*/, "bbweon" /*bfec*/, "bbweonj" /*bfed*/, "bbweonh" /*bfee*/, "bbweod" /*bfef*/, "bbweol" /*bff0*/, "bbweolg" /*bff1*/, "bbweolm" /*bff2*/, "bbweolb" /*bff3*/, "bbweols" /*bff4*/, "bbweolt" /*bff5*/, "bbweolp" /*bff6*/, "bbweolh" /*bff7*/, "bbweom" /*bff8*/, "bbweob" /*bff9*/, "bbweobs" /*bffa*/, "bbweos" /*bffb*/, "bbweoss" /*bffc*/, "bbweong" /*bffd*/, "bbweoj" /*bffe*/, "bbweoc" /*bfff*/ 
			});
						characters.TryAdd(192 /*49152 c0*/, new string[] {
				"bbweok" /*c000*/, "bbweot" /*c001*/, "bbweop" /*c002*/, "bbweoh" /*c003*/, "bbwe" /*c004*/, "bbweg" /*c005*/, "bbwegg" /*c006*/, "bbwegs" /*c007*/, "bbwen" /*c008*/, "bbwenj" /*c009*/, "bbwenh" /*c00a*/, "bbwed" /*c00b*/, "bbwel" /*c00c*/, "bbwelg" /*c00d*/, "bbwelm" /*c00e*/, "bbwelb" /*c00f*/, "bbwels" /*c010*/, "bbwelt" /*c011*/, "bbwelp" /*c012*/, "bbwelh" /*c013*/, "bbwem" /*c014*/, "bbweb" /*c015*/, "bbwebs" /*c016*/, "bbwes" /*c017*/, "bbwess" /*c018*/, "bbweng" /*c019*/, "bbwej" /*c01a*/, "bbwec" /*c01b*/, "bbwek" /*c01c*/, "bbwet" /*c01d*/, "bbwep" /*c01e*/, "bbweh" /*c01f*/, "bbwi" /*c020*/, "bbwig" /*c021*/, "bbwigg" /*c022*/, "bbwigs" /*c023*/, "bbwin" /*c024*/, "bbwinj" /*c025*/, "bbwinh" /*c026*/, "bbwid" /*c027*/, "bbwil" /*c028*/, "bbwilg" /*c029*/, "bbwilm" /*c02a*/, "bbwilb" /*c02b*/, "bbwils" /*c02c*/, "bbwilt" /*c02d*/, "bbwilp" /*c02e*/, "bbwilh" /*c02f*/, "bbwim" /*c030*/, "bbwib" /*c031*/, "bbwibs" /*c032*/, "bbwis" /*c033*/, "bbwiss" /*c034*/, "bbwing" /*c035*/, "bbwij" /*c036*/, "bbwic" /*c037*/, "bbwik" /*c038*/, "bbwit" /*c039*/, "bbwip" /*c03a*/, "bbwih" /*c03b*/, "bbyu" /*c03c*/, "bbyug" /*c03d*/, "bbyugg" /*c03e*/, "bbyugs" /*c03f*/, "bbyun" /*c040*/, "bbyunj" /*c041*/, "bbyunh" /*c042*/, "bbyud" /*c043*/, "bbyul" /*c044*/, "bbyulg" /*c045*/, "bbyulm" /*c046*/, "bbyulb" /*c047*/, "bbyuls" /*c048*/, "bbyult" /*c049*/, "bbyulp" /*c04a*/, "bbyulh" /*c04b*/, "bbyum" /*c04c*/, "bbyub" /*c04d*/, "bbyubs" /*c04e*/, "bbyus" /*c04f*/, "bbyuss" /*c050*/, "bbyung" /*c051*/, "bbyuj" /*c052*/, "bbyuc" /*c053*/, "bbyuk" /*c054*/, "bbyut" /*c055*/, "bbyup" /*c056*/, "bbyuh" /*c057*/, "bbeu" /*c058*/, "bbeug" /*c059*/, "bbeugg" /*c05a*/, "bbeugs" /*c05b*/, "bbeun" /*c05c*/, "bbeunj" /*c05d*/, "bbeunh" /*c05e*/, "bbeud" /*c05f*/, "bbeul" /*c060*/, "bbeulg" /*c061*/, "bbeulm" /*c062*/, "bbeulb" /*c063*/, "bbeuls" /*c064*/, "bbeult" /*c065*/, "bbeulp" /*c066*/, "bbeulh" /*c067*/, "bbeum" /*c068*/, "bbeub" /*c069*/, "bbeubs" /*c06a*/, "bbeus" /*c06b*/, "bbeuss" /*c06c*/, "bbeung" /*c06d*/, "bbeuj" /*c06e*/, "bbeuc" /*c06f*/, "bbeuk" /*c070*/, "bbeut" /*c071*/, "bbeup" /*c072*/, "bbeuh" /*c073*/, "bbyi" /*c074*/, "bbyig" /*c075*/, "bbyigg" /*c076*/, "bbyigs" /*c077*/, "bbyin" /*c078*/, "bbyinj" /*c079*/, "bbyinh" /*c07a*/, "bbyid" /*c07b*/, "bbyil" /*c07c*/, "bbyilg" /*c07d*/, "bbyilm" /*c07e*/, "bbyilb" /*c07f*/, "bbyils" /*c080*/, "bbyilt" /*c081*/, "bbyilp" /*c082*/, "bbyilh" /*c083*/, "bbyim" /*c084*/, "bbyib" /*c085*/, "bbyibs" /*c086*/, "bbyis" /*c087*/, "bbyiss" /*c088*/, "bbying" /*c089*/, "bbyij" /*c08a*/, "bbyic" /*c08b*/, "bbyik" /*c08c*/, "bbyit" /*c08d*/, "bbyip" /*c08e*/, "bbyih" /*c08f*/, "bbi" /*c090*/, "bbig" /*c091*/, "bbigg" /*c092*/, "bbigs" /*c093*/, "bbin" /*c094*/, "bbinj" /*c095*/, "bbinh" /*c096*/, "bbid" /*c097*/, "bbil" /*c098*/, "bbilg" /*c099*/, "bbilm" /*c09a*/, "bbilb" /*c09b*/, "bbils" /*c09c*/, "bbilt" /*c09d*/, "bbilp" /*c09e*/, "bbilh" /*c09f*/, "bbim" /*c0a0*/, "bbib" /*c0a1*/, "bbibs" /*c0a2*/, "bbis" /*c0a3*/, "bbiss" /*c0a4*/, "bbing" /*c0a5*/, "bbij" /*c0a6*/, "bbic" /*c0a7*/, "bbik" /*c0a8*/, "bbit" /*c0a9*/, "bbip" /*c0aa*/, "bbih" /*c0ab*/, "sa" /*c0ac*/, "sag" /*c0ad*/, "sagg" /*c0ae*/, "sags" /*c0af*/, "san" /*c0b0*/, "sanj" /*c0b1*/, "sanh" /*c0b2*/, "sad" /*c0b3*/, "sal" /*c0b4*/, "salg" /*c0b5*/, "salm" /*c0b6*/, "salb" /*c0b7*/, "sals" /*c0b8*/, "salt" /*c0b9*/, "salp" /*c0ba*/, "salh" /*c0bb*/, "sam" /*c0bc*/, "sab" /*c0bd*/, "sabs" /*c0be*/, "sas" /*c0bf*/, "sass" /*c0c0*/, "sang" /*c0c1*/, "saj" /*c0c2*/, "sac" /*c0c3*/, "sak" /*c0c4*/, "sat" /*c0c5*/, "sap" /*c0c6*/, "sah" /*c0c7*/, "sae" /*c0c8*/, "saeg" /*c0c9*/, "saegg" /*c0ca*/, "saegs" /*c0cb*/, "saen" /*c0cc*/, "saenj" /*c0cd*/, "saenh" /*c0ce*/, "saed" /*c0cf*/, "sael" /*c0d0*/, "saelg" /*c0d1*/, "saelm" /*c0d2*/, "saelb" /*c0d3*/, "saels" /*c0d4*/, "saelt" /*c0d5*/, "saelp" /*c0d6*/, "saelh" /*c0d7*/, "saem" /*c0d8*/, "saeb" /*c0d9*/, "saebs" /*c0da*/, "saes" /*c0db*/, "saess" /*c0dc*/, "saeng" /*c0dd*/, "saej" /*c0de*/, "saec" /*c0df*/, "saek" /*c0e0*/, "saet" /*c0e1*/, "saep" /*c0e2*/, "saeh" /*c0e3*/, "sya" /*c0e4*/, "syag" /*c0e5*/, "syagg" /*c0e6*/, "syags" /*c0e7*/, "syan" /*c0e8*/, "syanj" /*c0e9*/, "syanh" /*c0ea*/, "syad" /*c0eb*/, "syal" /*c0ec*/, "syalg" /*c0ed*/, "syalm" /*c0ee*/, "syalb" /*c0ef*/, "syals" /*c0f0*/, "syalt" /*c0f1*/, "syalp" /*c0f2*/, "syalh" /*c0f3*/, "syam" /*c0f4*/, "syab" /*c0f5*/, "syabs" /*c0f6*/, "syas" /*c0f7*/, "syass" /*c0f8*/, "syang" /*c0f9*/, "syaj" /*c0fa*/, "syac" /*c0fb*/, "syak" /*c0fc*/, "syat" /*c0fd*/, "syap" /*c0fe*/, "syah" /*c0ff*/ 
			});
						characters.TryAdd(193 /*49408 c1*/, new string[] {
				"syae" /*c100*/, "syaeg" /*c101*/, "syaegg" /*c102*/, "syaegs" /*c103*/, "syaen" /*c104*/, "syaenj" /*c105*/, "syaenh" /*c106*/, "syaed" /*c107*/, "syael" /*c108*/, "syaelg" /*c109*/, "syaelm" /*c10a*/, "syaelb" /*c10b*/, "syaels" /*c10c*/, "syaelt" /*c10d*/, "syaelp" /*c10e*/, "syaelh" /*c10f*/, "syaem" /*c110*/, "syaeb" /*c111*/, "syaebs" /*c112*/, "syaes" /*c113*/, "syaess" /*c114*/, "syaeng" /*c115*/, "syaej" /*c116*/, "syaec" /*c117*/, "syaek" /*c118*/, "syaet" /*c119*/, "syaep" /*c11a*/, "syaeh" /*c11b*/, "seo" /*c11c*/, "seog" /*c11d*/, "seogg" /*c11e*/, "seogs" /*c11f*/, "seon" /*c120*/, "seonj" /*c121*/, "seonh" /*c122*/, "seod" /*c123*/, "seol" /*c124*/, "seolg" /*c125*/, "seolm" /*c126*/, "seolb" /*c127*/, "seols" /*c128*/, "seolt" /*c129*/, "seolp" /*c12a*/, "seolh" /*c12b*/, "seom" /*c12c*/, "seob" /*c12d*/, "seobs" /*c12e*/, "seos" /*c12f*/, "seoss" /*c130*/, "seong" /*c131*/, "seoj" /*c132*/, "seoc" /*c133*/, "seok" /*c134*/, "seot" /*c135*/, "seop" /*c136*/, "seoh" /*c137*/, "se" /*c138*/, "seg" /*c139*/, "segg" /*c13a*/, "segs" /*c13b*/, "sen" /*c13c*/, "senj" /*c13d*/, "senh" /*c13e*/, "sed" /*c13f*/, "sel" /*c140*/, "selg" /*c141*/, "selm" /*c142*/, "selb" /*c143*/, "sels" /*c144*/, "selt" /*c145*/, "selp" /*c146*/, "selh" /*c147*/, "sem" /*c148*/, "seb" /*c149*/, "sebs" /*c14a*/, "ses" /*c14b*/, "sess" /*c14c*/, "seng" /*c14d*/, "sej" /*c14e*/, "sec" /*c14f*/, "sek" /*c150*/, "set" /*c151*/, "sep" /*c152*/, "seh" /*c153*/, "syeo" /*c154*/, "syeog" /*c155*/, "syeogg" /*c156*/, "syeogs" /*c157*/, "syeon" /*c158*/, "syeonj" /*c159*/, "syeonh" /*c15a*/, "syeod" /*c15b*/, "syeol" /*c15c*/, "syeolg" /*c15d*/, "syeolm" /*c15e*/, "syeolb" /*c15f*/, "syeols" /*c160*/, "syeolt" /*c161*/, "syeolp" /*c162*/, "syeolh" /*c163*/, "syeom" /*c164*/, "syeob" /*c165*/, "syeobs" /*c166*/, "syeos" /*c167*/, "syeoss" /*c168*/, "syeong" /*c169*/, "syeoj" /*c16a*/, "syeoc" /*c16b*/, "syeok" /*c16c*/, "syeot" /*c16d*/, "syeop" /*c16e*/, "syeoh" /*c16f*/, "sye" /*c170*/, "syeg" /*c171*/, "syegg" /*c172*/, "syegs" /*c173*/, "syen" /*c174*/, "syenj" /*c175*/, "syenh" /*c176*/, "syed" /*c177*/, "syel" /*c178*/, "syelg" /*c179*/, "syelm" /*c17a*/, "syelb" /*c17b*/, "syels" /*c17c*/, "syelt" /*c17d*/, "syelp" /*c17e*/, "syelh" /*c17f*/, "syem" /*c180*/, "syeb" /*c181*/, "syebs" /*c182*/, "syes" /*c183*/, "syess" /*c184*/, "syeng" /*c185*/, "syej" /*c186*/, "syec" /*c187*/, "syek" /*c188*/, "syet" /*c189*/, "syep" /*c18a*/, "syeh" /*c18b*/, "so" /*c18c*/, "sog" /*c18d*/, "sogg" /*c18e*/, "sogs" /*c18f*/, "son" /*c190*/, "sonj" /*c191*/, "sonh" /*c192*/, "sod" /*c193*/, "sol" /*c194*/, "solg" /*c195*/, "solm" /*c196*/, "solb" /*c197*/, "sols" /*c198*/, "solt" /*c199*/, "solp" /*c19a*/, "solh" /*c19b*/, "som" /*c19c*/, "sob" /*c19d*/, "sobs" /*c19e*/, "sos" /*c19f*/, "soss" /*c1a0*/, "song" /*c1a1*/, "soj" /*c1a2*/, "soc" /*c1a3*/, "sok" /*c1a4*/, "sot" /*c1a5*/, "sop" /*c1a6*/, "soh" /*c1a7*/, "swa" /*c1a8*/, "swag" /*c1a9*/, "swagg" /*c1aa*/, "swags" /*c1ab*/, "swan" /*c1ac*/, "swanj" /*c1ad*/, "swanh" /*c1ae*/, "swad" /*c1af*/, "swal" /*c1b0*/, "swalg" /*c1b1*/, "swalm" /*c1b2*/, "swalb" /*c1b3*/, "swals" /*c1b4*/, "swalt" /*c1b5*/, "swalp" /*c1b6*/, "swalh" /*c1b7*/, "swam" /*c1b8*/, "swab" /*c1b9*/, "swabs" /*c1ba*/, "swas" /*c1bb*/, "swass" /*c1bc*/, "swang" /*c1bd*/, "swaj" /*c1be*/, "swac" /*c1bf*/, "swak" /*c1c0*/, "swat" /*c1c1*/, "swap" /*c1c2*/, "swah" /*c1c3*/, "swae" /*c1c4*/, "swaeg" /*c1c5*/, "swaegg" /*c1c6*/, "swaegs" /*c1c7*/, "swaen" /*c1c8*/, "swaenj" /*c1c9*/, "swaenh" /*c1ca*/, "swaed" /*c1cb*/, "swael" /*c1cc*/, "swaelg" /*c1cd*/, "swaelm" /*c1ce*/, "swaelb" /*c1cf*/, "swaels" /*c1d0*/, "swaelt" /*c1d1*/, "swaelp" /*c1d2*/, "swaelh" /*c1d3*/, "swaem" /*c1d4*/, "swaeb" /*c1d5*/, "swaebs" /*c1d6*/, "swaes" /*c1d7*/, "swaess" /*c1d8*/, "swaeng" /*c1d9*/, "swaej" /*c1da*/, "swaec" /*c1db*/, "swaek" /*c1dc*/, "swaet" /*c1dd*/, "swaep" /*c1de*/, "swaeh" /*c1df*/, "soe" /*c1e0*/, "soeg" /*c1e1*/, "soegg" /*c1e2*/, "soegs" /*c1e3*/, "soen" /*c1e4*/, "soenj" /*c1e5*/, "soenh" /*c1e6*/, "soed" /*c1e7*/, "soel" /*c1e8*/, "soelg" /*c1e9*/, "soelm" /*c1ea*/, "soelb" /*c1eb*/, "soels" /*c1ec*/, "soelt" /*c1ed*/, "soelp" /*c1ee*/, "soelh" /*c1ef*/, "soem" /*c1f0*/, "soeb" /*c1f1*/, "soebs" /*c1f2*/, "soes" /*c1f3*/, "soess" /*c1f4*/, "soeng" /*c1f5*/, "soej" /*c1f6*/, "soec" /*c1f7*/, "soek" /*c1f8*/, "soet" /*c1f9*/, "soep" /*c1fa*/, "soeh" /*c1fb*/, "syo" /*c1fc*/, "syog" /*c1fd*/, "syogg" /*c1fe*/, "syogs" /*c1ff*/ 
			});
						characters.TryAdd(194 /*49664 c2*/, new string[] {
				"syon" /*c200*/, "syonj" /*c201*/, "syonh" /*c202*/, "syod" /*c203*/, "syol" /*c204*/, "syolg" /*c205*/, "syolm" /*c206*/, "syolb" /*c207*/, "syols" /*c208*/, "syolt" /*c209*/, "syolp" /*c20a*/, "syolh" /*c20b*/, "syom" /*c20c*/, "syob" /*c20d*/, "syobs" /*c20e*/, "syos" /*c20f*/, "syoss" /*c210*/, "syong" /*c211*/, "syoj" /*c212*/, "syoc" /*c213*/, "syok" /*c214*/, "syot" /*c215*/, "syop" /*c216*/, "syoh" /*c217*/, "su" /*c218*/, "sug" /*c219*/, "sugg" /*c21a*/, "sugs" /*c21b*/, "sun" /*c21c*/, "sunj" /*c21d*/, "sunh" /*c21e*/, "sud" /*c21f*/, "sul" /*c220*/, "sulg" /*c221*/, "sulm" /*c222*/, "sulb" /*c223*/, "suls" /*c224*/, "sult" /*c225*/, "sulp" /*c226*/, "sulh" /*c227*/, "sum" /*c228*/, "sub" /*c229*/, "subs" /*c22a*/, "sus" /*c22b*/, "suss" /*c22c*/, "sung" /*c22d*/, "suj" /*c22e*/, "suc" /*c22f*/, "suk" /*c230*/, "sut" /*c231*/, "sup" /*c232*/, "suh" /*c233*/, "sweo" /*c234*/, "sweog" /*c235*/, "sweogg" /*c236*/, "sweogs" /*c237*/, "sweon" /*c238*/, "sweonj" /*c239*/, "sweonh" /*c23a*/, "sweod" /*c23b*/, "sweol" /*c23c*/, "sweolg" /*c23d*/, "sweolm" /*c23e*/, "sweolb" /*c23f*/, "sweols" /*c240*/, "sweolt" /*c241*/, "sweolp" /*c242*/, "sweolh" /*c243*/, "sweom" /*c244*/, "sweob" /*c245*/, "sweobs" /*c246*/, "sweos" /*c247*/, "sweoss" /*c248*/, "sweong" /*c249*/, "sweoj" /*c24a*/, "sweoc" /*c24b*/, "sweok" /*c24c*/, "sweot" /*c24d*/, "sweop" /*c24e*/, "sweoh" /*c24f*/, "swe" /*c250*/, "sweg" /*c251*/, "swegg" /*c252*/, "swegs" /*c253*/, "swen" /*c254*/, "swenj" /*c255*/, "swenh" /*c256*/, "swed" /*c257*/, "swel" /*c258*/, "swelg" /*c259*/, "swelm" /*c25a*/, "swelb" /*c25b*/, "swels" /*c25c*/, "swelt" /*c25d*/, "swelp" /*c25e*/, "swelh" /*c25f*/, "swem" /*c260*/, "sweb" /*c261*/, "swebs" /*c262*/, "swes" /*c263*/, "swess" /*c264*/, "sweng" /*c265*/, "swej" /*c266*/, "swec" /*c267*/, "swek" /*c268*/, "swet" /*c269*/, "swep" /*c26a*/, "sweh" /*c26b*/, "swi" /*c26c*/, "swig" /*c26d*/, "swigg" /*c26e*/, "swigs" /*c26f*/, "swin" /*c270*/, "swinj" /*c271*/, "swinh" /*c272*/, "swid" /*c273*/, "swil" /*c274*/, "swilg" /*c275*/, "swilm" /*c276*/, "swilb" /*c277*/, "swils" /*c278*/, "swilt" /*c279*/, "swilp" /*c27a*/, "swilh" /*c27b*/, "swim" /*c27c*/, "swib" /*c27d*/, "swibs" /*c27e*/, "swis" /*c27f*/, "swiss" /*c280*/, "swing" /*c281*/, "swij" /*c282*/, "swic" /*c283*/, "swik" /*c284*/, "swit" /*c285*/, "swip" /*c286*/, "swih" /*c287*/, "syu" /*c288*/, "syug" /*c289*/, "syugg" /*c28a*/, "syugs" /*c28b*/, "syun" /*c28c*/, "syunj" /*c28d*/, "syunh" /*c28e*/, "syud" /*c28f*/, "syul" /*c290*/, "syulg" /*c291*/, "syulm" /*c292*/, "syulb" /*c293*/, "syuls" /*c294*/, "syult" /*c295*/, "syulp" /*c296*/, "syulh" /*c297*/, "syum" /*c298*/, "syub" /*c299*/, "syubs" /*c29a*/, "syus" /*c29b*/, "syuss" /*c29c*/, "syung" /*c29d*/, "syuj" /*c29e*/, "syuc" /*c29f*/, "syuk" /*c2a0*/, "syut" /*c2a1*/, "syup" /*c2a2*/, "syuh" /*c2a3*/, "seu" /*c2a4*/, "seug" /*c2a5*/, "seugg" /*c2a6*/, "seugs" /*c2a7*/, "seun" /*c2a8*/, "seunj" /*c2a9*/, "seunh" /*c2aa*/, "seud" /*c2ab*/, "seul" /*c2ac*/, "seulg" /*c2ad*/, "seulm" /*c2ae*/, "seulb" /*c2af*/, "seuls" /*c2b0*/, "seult" /*c2b1*/, "seulp" /*c2b2*/, "seulh" /*c2b3*/, "seum" /*c2b4*/, "seub" /*c2b5*/, "seubs" /*c2b6*/, "seus" /*c2b7*/, "seuss" /*c2b8*/, "seung" /*c2b9*/, "seuj" /*c2ba*/, "seuc" /*c2bb*/, "seuk" /*c2bc*/, "seut" /*c2bd*/, "seup" /*c2be*/, "seuh" /*c2bf*/, "syi" /*c2c0*/, "syig" /*c2c1*/, "syigg" /*c2c2*/, "syigs" /*c2c3*/, "syin" /*c2c4*/, "syinj" /*c2c5*/, "syinh" /*c2c6*/, "syid" /*c2c7*/, "syil" /*c2c8*/, "syilg" /*c2c9*/, "syilm" /*c2ca*/, "syilb" /*c2cb*/, "syils" /*c2cc*/, "syilt" /*c2cd*/, "syilp" /*c2ce*/, "syilh" /*c2cf*/, "syim" /*c2d0*/, "syib" /*c2d1*/, "syibs" /*c2d2*/, "syis" /*c2d3*/, "syiss" /*c2d4*/, "sying" /*c2d5*/, "syij" /*c2d6*/, "syic" /*c2d7*/, "syik" /*c2d8*/, "syit" /*c2d9*/, "syip" /*c2da*/, "syih" /*c2db*/, "si" /*c2dc*/, "sig" /*c2dd*/, "sigg" /*c2de*/, "sigs" /*c2df*/, "sin" /*c2e0*/, "sinj" /*c2e1*/, "sinh" /*c2e2*/, "sid" /*c2e3*/, "sil" /*c2e4*/, "silg" /*c2e5*/, "silm" /*c2e6*/, "silb" /*c2e7*/, "sils" /*c2e8*/, "silt" /*c2e9*/, "silp" /*c2ea*/, "silh" /*c2eb*/, "sim" /*c2ec*/, "sib" /*c2ed*/, "sibs" /*c2ee*/, "sis" /*c2ef*/, "siss" /*c2f0*/, "sing" /*c2f1*/, "sij" /*c2f2*/, "sic" /*c2f3*/, "sik" /*c2f4*/, "sit" /*c2f5*/, "sip" /*c2f6*/, "sih" /*c2f7*/, "ssa" /*c2f8*/, "ssag" /*c2f9*/, "ssagg" /*c2fa*/, "ssags" /*c2fb*/, "ssan" /*c2fc*/, "ssanj" /*c2fd*/, "ssanh" /*c2fe*/, "ssad" /*c2ff*/ 
			});
						characters.TryAdd(195 /*49920 c3*/, new string[] {
				"ssal" /*c300*/, "ssalg" /*c301*/, "ssalm" /*c302*/, "ssalb" /*c303*/, "ssals" /*c304*/, "ssalt" /*c305*/, "ssalp" /*c306*/, "ssalh" /*c307*/, "ssam" /*c308*/, "ssab" /*c309*/, "ssabs" /*c30a*/, "ssas" /*c30b*/, "ssass" /*c30c*/, "ssang" /*c30d*/, "ssaj" /*c30e*/, "ssac" /*c30f*/, "ssak" /*c310*/, "ssat" /*c311*/, "ssap" /*c312*/, "ssah" /*c313*/, "ssae" /*c314*/, "ssaeg" /*c315*/, "ssaegg" /*c316*/, "ssaegs" /*c317*/, "ssaen" /*c318*/, "ssaenj" /*c319*/, "ssaenh" /*c31a*/, "ssaed" /*c31b*/, "ssael" /*c31c*/, "ssaelg" /*c31d*/, "ssaelm" /*c31e*/, "ssaelb" /*c31f*/, "ssaels" /*c320*/, "ssaelt" /*c321*/, "ssaelp" /*c322*/, "ssaelh" /*c323*/, "ssaem" /*c324*/, "ssaeb" /*c325*/, "ssaebs" /*c326*/, "ssaes" /*c327*/, "ssaess" /*c328*/, "ssaeng" /*c329*/, "ssaej" /*c32a*/, "ssaec" /*c32b*/, "ssaek" /*c32c*/, "ssaet" /*c32d*/, "ssaep" /*c32e*/, "ssaeh" /*c32f*/, "ssya" /*c330*/, "ssyag" /*c331*/, "ssyagg" /*c332*/, "ssyags" /*c333*/, "ssyan" /*c334*/, "ssyanj" /*c335*/, "ssyanh" /*c336*/, "ssyad" /*c337*/, "ssyal" /*c338*/, "ssyalg" /*c339*/, "ssyalm" /*c33a*/, "ssyalb" /*c33b*/, "ssyals" /*c33c*/, "ssyalt" /*c33d*/, "ssyalp" /*c33e*/, "ssyalh" /*c33f*/, "ssyam" /*c340*/, "ssyab" /*c341*/, "ssyabs" /*c342*/, "ssyas" /*c343*/, "ssyass" /*c344*/, "ssyang" /*c345*/, "ssyaj" /*c346*/, "ssyac" /*c347*/, "ssyak" /*c348*/, "ssyat" /*c349*/, "ssyap" /*c34a*/, "ssyah" /*c34b*/, "ssyae" /*c34c*/, "ssyaeg" /*c34d*/, "ssyaegg" /*c34e*/, "ssyaegs" /*c34f*/, "ssyaen" /*c350*/, "ssyaenj" /*c351*/, "ssyaenh" /*c352*/, "ssyaed" /*c353*/, "ssyael" /*c354*/, "ssyaelg" /*c355*/, "ssyaelm" /*c356*/, "ssyaelb" /*c357*/, "ssyaels" /*c358*/, "ssyaelt" /*c359*/, "ssyaelp" /*c35a*/, "ssyaelh" /*c35b*/, "ssyaem" /*c35c*/, "ssyaeb" /*c35d*/, "ssyaebs" /*c35e*/, "ssyaes" /*c35f*/, "ssyaess" /*c360*/, "ssyaeng" /*c361*/, "ssyaej" /*c362*/, "ssyaec" /*c363*/, "ssyaek" /*c364*/, "ssyaet" /*c365*/, "ssyaep" /*c366*/, "ssyaeh" /*c367*/, "sseo" /*c368*/, "sseog" /*c369*/, "sseogg" /*c36a*/, "sseogs" /*c36b*/, "sseon" /*c36c*/, "sseonj" /*c36d*/, "sseonh" /*c36e*/, "sseod" /*c36f*/, "sseol" /*c370*/, "sseolg" /*c371*/, "sseolm" /*c372*/, "sseolb" /*c373*/, "sseols" /*c374*/, "sseolt" /*c375*/, "sseolp" /*c376*/, "sseolh" /*c377*/, "sseom" /*c378*/, "sseob" /*c379*/, "sseobs" /*c37a*/, "sseos" /*c37b*/, "sseoss" /*c37c*/, "sseong" /*c37d*/, "sseoj" /*c37e*/, "sseoc" /*c37f*/, "sseok" /*c380*/, "sseot" /*c381*/, "sseop" /*c382*/, "sseoh" /*c383*/, "sse" /*c384*/, "sseg" /*c385*/, "ssegg" /*c386*/, "ssegs" /*c387*/, "ssen" /*c388*/, "ssenj" /*c389*/, "ssenh" /*c38a*/, "ssed" /*c38b*/, "ssel" /*c38c*/, "sselg" /*c38d*/, "sselm" /*c38e*/, "sselb" /*c38f*/, "ssels" /*c390*/, "sselt" /*c391*/, "sselp" /*c392*/, "sselh" /*c393*/, "ssem" /*c394*/, "sseb" /*c395*/, "ssebs" /*c396*/, "sses" /*c397*/, "ssess" /*c398*/, "sseng" /*c399*/, "ssej" /*c39a*/, "ssec" /*c39b*/, "ssek" /*c39c*/, "sset" /*c39d*/, "ssep" /*c39e*/, "sseh" /*c39f*/, "ssyeo" /*c3a0*/, "ssyeog" /*c3a1*/, "ssyeogg" /*c3a2*/, "ssyeogs" /*c3a3*/, "ssyeon" /*c3a4*/, "ssyeonj" /*c3a5*/, "ssyeonh" /*c3a6*/, "ssyeod" /*c3a7*/, "ssyeol" /*c3a8*/, "ssyeolg" /*c3a9*/, "ssyeolm" /*c3aa*/, "ssyeolb" /*c3ab*/, "ssyeols" /*c3ac*/, "ssyeolt" /*c3ad*/, "ssyeolp" /*c3ae*/, "ssyeolh" /*c3af*/, "ssyeom" /*c3b0*/, "ssyeob" /*c3b1*/, "ssyeobs" /*c3b2*/, "ssyeos" /*c3b3*/, "ssyeoss" /*c3b4*/, "ssyeong" /*c3b5*/, "ssyeoj" /*c3b6*/, "ssyeoc" /*c3b7*/, "ssyeok" /*c3b8*/, "ssyeot" /*c3b9*/, "ssyeop" /*c3ba*/, "ssyeoh" /*c3bb*/, "ssye" /*c3bc*/, "ssyeg" /*c3bd*/, "ssyegg" /*c3be*/, "ssyegs" /*c3bf*/, "ssyen" /*c3c0*/, "ssyenj" /*c3c1*/, "ssyenh" /*c3c2*/, "ssyed" /*c3c3*/, "ssyel" /*c3c4*/, "ssyelg" /*c3c5*/, "ssyelm" /*c3c6*/, "ssyelb" /*c3c7*/, "ssyels" /*c3c8*/, "ssyelt" /*c3c9*/, "ssyelp" /*c3ca*/, "ssyelh" /*c3cb*/, "ssyem" /*c3cc*/, "ssyeb" /*c3cd*/, "ssyebs" /*c3ce*/, "ssyes" /*c3cf*/, "ssyess" /*c3d0*/, "ssyeng" /*c3d1*/, "ssyej" /*c3d2*/, "ssyec" /*c3d3*/, "ssyek" /*c3d4*/, "ssyet" /*c3d5*/, "ssyep" /*c3d6*/, "ssyeh" /*c3d7*/, "sso" /*c3d8*/, "ssog" /*c3d9*/, "ssogg" /*c3da*/, "ssogs" /*c3db*/, "sson" /*c3dc*/, "ssonj" /*c3dd*/, "ssonh" /*c3de*/, "ssod" /*c3df*/, "ssol" /*c3e0*/, "ssolg" /*c3e1*/, "ssolm" /*c3e2*/, "ssolb" /*c3e3*/, "ssols" /*c3e4*/, "ssolt" /*c3e5*/, "ssolp" /*c3e6*/, "ssolh" /*c3e7*/, "ssom" /*c3e8*/, "ssob" /*c3e9*/, "ssobs" /*c3ea*/, "ssos" /*c3eb*/, "ssoss" /*c3ec*/, "ssong" /*c3ed*/, "ssoj" /*c3ee*/, "ssoc" /*c3ef*/, "ssok" /*c3f0*/, "ssot" /*c3f1*/, "ssop" /*c3f2*/, "ssoh" /*c3f3*/, "sswa" /*c3f4*/, "sswag" /*c3f5*/, "sswagg" /*c3f6*/, "sswags" /*c3f7*/, "sswan" /*c3f8*/, "sswanj" /*c3f9*/, "sswanh" /*c3fa*/, "sswad" /*c3fb*/, "sswal" /*c3fc*/, "sswalg" /*c3fd*/, "sswalm" /*c3fe*/, "sswalb" /*c3ff*/ 
			});
						characters.TryAdd(196 /*50176 c4*/, new string[] {
				"sswals" /*c400*/, "sswalt" /*c401*/, "sswalp" /*c402*/, "sswalh" /*c403*/, "sswam" /*c404*/, "sswab" /*c405*/, "sswabs" /*c406*/, "sswas" /*c407*/, "sswass" /*c408*/, "sswang" /*c409*/, "sswaj" /*c40a*/, "sswac" /*c40b*/, "sswak" /*c40c*/, "sswat" /*c40d*/, "sswap" /*c40e*/, "sswah" /*c40f*/, "sswae" /*c410*/, "sswaeg" /*c411*/, "sswaegg" /*c412*/, "sswaegs" /*c413*/, "sswaen" /*c414*/, "sswaenj" /*c415*/, "sswaenh" /*c416*/, "sswaed" /*c417*/, "sswael" /*c418*/, "sswaelg" /*c419*/, "sswaelm" /*c41a*/, "sswaelb" /*c41b*/, "sswaels" /*c41c*/, "sswaelt" /*c41d*/, "sswaelp" /*c41e*/, "sswaelh" /*c41f*/, "sswaem" /*c420*/, "sswaeb" /*c421*/, "sswaebs" /*c422*/, "sswaes" /*c423*/, "sswaess" /*c424*/, "sswaeng" /*c425*/, "sswaej" /*c426*/, "sswaec" /*c427*/, "sswaek" /*c428*/, "sswaet" /*c429*/, "sswaep" /*c42a*/, "sswaeh" /*c42b*/, "ssoe" /*c42c*/, "ssoeg" /*c42d*/, "ssoegg" /*c42e*/, "ssoegs" /*c42f*/, "ssoen" /*c430*/, "ssoenj" /*c431*/, "ssoenh" /*c432*/, "ssoed" /*c433*/, "ssoel" /*c434*/, "ssoelg" /*c435*/, "ssoelm" /*c436*/, "ssoelb" /*c437*/, "ssoels" /*c438*/, "ssoelt" /*c439*/, "ssoelp" /*c43a*/, "ssoelh" /*c43b*/, "ssoem" /*c43c*/, "ssoeb" /*c43d*/, "ssoebs" /*c43e*/, "ssoes" /*c43f*/, "ssoess" /*c440*/, "ssoeng" /*c441*/, "ssoej" /*c442*/, "ssoec" /*c443*/, "ssoek" /*c444*/, "ssoet" /*c445*/, "ssoep" /*c446*/, "ssoeh" /*c447*/, "ssyo" /*c448*/, "ssyog" /*c449*/, "ssyogg" /*c44a*/, "ssyogs" /*c44b*/, "ssyon" /*c44c*/, "ssyonj" /*c44d*/, "ssyonh" /*c44e*/, "ssyod" /*c44f*/, "ssyol" /*c450*/, "ssyolg" /*c451*/, "ssyolm" /*c452*/, "ssyolb" /*c453*/, "ssyols" /*c454*/, "ssyolt" /*c455*/, "ssyolp" /*c456*/, "ssyolh" /*c457*/, "ssyom" /*c458*/, "ssyob" /*c459*/, "ssyobs" /*c45a*/, "ssyos" /*c45b*/, "ssyoss" /*c45c*/, "ssyong" /*c45d*/, "ssyoj" /*c45e*/, "ssyoc" /*c45f*/, "ssyok" /*c460*/, "ssyot" /*c461*/, "ssyop" /*c462*/, "ssyoh" /*c463*/, "ssu" /*c464*/, "ssug" /*c465*/, "ssugg" /*c466*/, "ssugs" /*c467*/, "ssun" /*c468*/, "ssunj" /*c469*/, "ssunh" /*c46a*/, "ssud" /*c46b*/, "ssul" /*c46c*/, "ssulg" /*c46d*/, "ssulm" /*c46e*/, "ssulb" /*c46f*/, "ssuls" /*c470*/, "ssult" /*c471*/, "ssulp" /*c472*/, "ssulh" /*c473*/, "ssum" /*c474*/, "ssub" /*c475*/, "ssubs" /*c476*/, "ssus" /*c477*/, "ssuss" /*c478*/, "ssung" /*c479*/, "ssuj" /*c47a*/, "ssuc" /*c47b*/, "ssuk" /*c47c*/, "ssut" /*c47d*/, "ssup" /*c47e*/, "ssuh" /*c47f*/, "ssweo" /*c480*/, "ssweog" /*c481*/, "ssweogg" /*c482*/, "ssweogs" /*c483*/, "ssweon" /*c484*/, "ssweonj" /*c485*/, "ssweonh" /*c486*/, "ssweod" /*c487*/, "ssweol" /*c488*/, "ssweolg" /*c489*/, "ssweolm" /*c48a*/, "ssweolb" /*c48b*/, "ssweols" /*c48c*/, "ssweolt" /*c48d*/, "ssweolp" /*c48e*/, "ssweolh" /*c48f*/, "ssweom" /*c490*/, "ssweob" /*c491*/, "ssweobs" /*c492*/, "ssweos" /*c493*/, "ssweoss" /*c494*/, "ssweong" /*c495*/, "ssweoj" /*c496*/, "ssweoc" /*c497*/, "ssweok" /*c498*/, "ssweot" /*c499*/, "ssweop" /*c49a*/, "ssweoh" /*c49b*/, "sswe" /*c49c*/, "ssweg" /*c49d*/, "sswegg" /*c49e*/, "sswegs" /*c49f*/, "sswen" /*c4a0*/, "sswenj" /*c4a1*/, "sswenh" /*c4a2*/, "sswed" /*c4a3*/, "sswel" /*c4a4*/, "sswelg" /*c4a5*/, "sswelm" /*c4a6*/, "sswelb" /*c4a7*/, "sswels" /*c4a8*/, "sswelt" /*c4a9*/, "sswelp" /*c4aa*/, "sswelh" /*c4ab*/, "sswem" /*c4ac*/, "ssweb" /*c4ad*/, "sswebs" /*c4ae*/, "sswes" /*c4af*/, "sswess" /*c4b0*/, "ssweng" /*c4b1*/, "sswej" /*c4b2*/, "sswec" /*c4b3*/, "sswek" /*c4b4*/, "sswet" /*c4b5*/, "sswep" /*c4b6*/, "ssweh" /*c4b7*/, "sswi" /*c4b8*/, "sswig" /*c4b9*/, "sswigg" /*c4ba*/, "sswigs" /*c4bb*/, "sswin" /*c4bc*/, "sswinj" /*c4bd*/, "sswinh" /*c4be*/, "sswid" /*c4bf*/, "sswil" /*c4c0*/, "sswilg" /*c4c1*/, "sswilm" /*c4c2*/, "sswilb" /*c4c3*/, "sswils" /*c4c4*/, "sswilt" /*c4c5*/, "sswilp" /*c4c6*/, "sswilh" /*c4c7*/, "sswim" /*c4c8*/, "sswib" /*c4c9*/, "sswibs" /*c4ca*/, "sswis" /*c4cb*/, "sswiss" /*c4cc*/, "sswing" /*c4cd*/, "sswij" /*c4ce*/, "sswic" /*c4cf*/, "sswik" /*c4d0*/, "sswit" /*c4d1*/, "sswip" /*c4d2*/, "sswih" /*c4d3*/, "ssyu" /*c4d4*/, "ssyug" /*c4d5*/, "ssyugg" /*c4d6*/, "ssyugs" /*c4d7*/, "ssyun" /*c4d8*/, "ssyunj" /*c4d9*/, "ssyunh" /*c4da*/, "ssyud" /*c4db*/, "ssyul" /*c4dc*/, "ssyulg" /*c4dd*/, "ssyulm" /*c4de*/, "ssyulb" /*c4df*/, "ssyuls" /*c4e0*/, "ssyult" /*c4e1*/, "ssyulp" /*c4e2*/, "ssyulh" /*c4e3*/, "ssyum" /*c4e4*/, "ssyub" /*c4e5*/, "ssyubs" /*c4e6*/, "ssyus" /*c4e7*/, "ssyuss" /*c4e8*/, "ssyung" /*c4e9*/, "ssyuj" /*c4ea*/, "ssyuc" /*c4eb*/, "ssyuk" /*c4ec*/, "ssyut" /*c4ed*/, "ssyup" /*c4ee*/, "ssyuh" /*c4ef*/, "sseu" /*c4f0*/, "sseug" /*c4f1*/, "sseugg" /*c4f2*/, "sseugs" /*c4f3*/, "sseun" /*c4f4*/, "sseunj" /*c4f5*/, "sseunh" /*c4f6*/, "sseud" /*c4f7*/, "sseul" /*c4f8*/, "sseulg" /*c4f9*/, "sseulm" /*c4fa*/, "sseulb" /*c4fb*/, "sseuls" /*c4fc*/, "sseult" /*c4fd*/, "sseulp" /*c4fe*/, "sseulh" /*c4ff*/ 
			});
						characters.TryAdd(197 /*50432 c5*/, new string[] {
				"sseum" /*c500*/, "sseub" /*c501*/, "sseubs" /*c502*/, "sseus" /*c503*/, "sseuss" /*c504*/, "sseung" /*c505*/, "sseuj" /*c506*/, "sseuc" /*c507*/, "sseuk" /*c508*/, "sseut" /*c509*/, "sseup" /*c50a*/, "sseuh" /*c50b*/, "ssyi" /*c50c*/, "ssyig" /*c50d*/, "ssyigg" /*c50e*/, "ssyigs" /*c50f*/, "ssyin" /*c510*/, "ssyinj" /*c511*/, "ssyinh" /*c512*/, "ssyid" /*c513*/, "ssyil" /*c514*/, "ssyilg" /*c515*/, "ssyilm" /*c516*/, "ssyilb" /*c517*/, "ssyils" /*c518*/, "ssyilt" /*c519*/, "ssyilp" /*c51a*/, "ssyilh" /*c51b*/, "ssyim" /*c51c*/, "ssyib" /*c51d*/, "ssyibs" /*c51e*/, "ssyis" /*c51f*/, "ssyiss" /*c520*/, "ssying" /*c521*/, "ssyij" /*c522*/, "ssyic" /*c523*/, "ssyik" /*c524*/, "ssyit" /*c525*/, "ssyip" /*c526*/, "ssyih" /*c527*/, "ssi" /*c528*/, "ssig" /*c529*/, "ssigg" /*c52a*/, "ssigs" /*c52b*/, "ssin" /*c52c*/, "ssinj" /*c52d*/, "ssinh" /*c52e*/, "ssid" /*c52f*/, "ssil" /*c530*/, "ssilg" /*c531*/, "ssilm" /*c532*/, "ssilb" /*c533*/, "ssils" /*c534*/, "ssilt" /*c535*/, "ssilp" /*c536*/, "ssilh" /*c537*/, "ssim" /*c538*/, "ssib" /*c539*/, "ssibs" /*c53a*/, "ssis" /*c53b*/, "ssiss" /*c53c*/, "ssing" /*c53d*/, "ssij" /*c53e*/, "ssic" /*c53f*/, "ssik" /*c540*/, "ssit" /*c541*/, "ssip" /*c542*/, "ssih" /*c543*/, "a" /*c544*/, "ag" /*c545*/, "agg" /*c546*/, "ags" /*c547*/, "an" /*c548*/, "anj" /*c549*/, "anh" /*c54a*/, "ad" /*c54b*/, "al" /*c54c*/, "alg" /*c54d*/, "alm" /*c54e*/, "alb" /*c54f*/, "als" /*c550*/, "alt" /*c551*/, "alp" /*c552*/, "alh" /*c553*/, "am" /*c554*/, "ab" /*c555*/, "abs" /*c556*/, "as" /*c557*/, "ass" /*c558*/, "ang" /*c559*/, "aj" /*c55a*/, "ac" /*c55b*/, "ak" /*c55c*/, "at" /*c55d*/, "ap" /*c55e*/, "ah" /*c55f*/, "ae" /*c560*/, "aeg" /*c561*/, "aegg" /*c562*/, "aegs" /*c563*/, "aen" /*c564*/, "aenj" /*c565*/, "aenh" /*c566*/, "aed" /*c567*/, "ael" /*c568*/, "aelg" /*c569*/, "aelm" /*c56a*/, "aelb" /*c56b*/, "aels" /*c56c*/, "aelt" /*c56d*/, "aelp" /*c56e*/, "aelh" /*c56f*/, "aem" /*c570*/, "aeb" /*c571*/, "aebs" /*c572*/, "aes" /*c573*/, "aess" /*c574*/, "aeng" /*c575*/, "aej" /*c576*/, "aec" /*c577*/, "aek" /*c578*/, "aet" /*c579*/, "aep" /*c57a*/, "aeh" /*c57b*/, "ya" /*c57c*/, "yag" /*c57d*/, "yagg" /*c57e*/, "yags" /*c57f*/, "yan" /*c580*/, "yanj" /*c581*/, "yanh" /*c582*/, "yad" /*c583*/, "yal" /*c584*/, "yalg" /*c585*/, "yalm" /*c586*/, "yalb" /*c587*/, "yals" /*c588*/, "yalt" /*c589*/, "yalp" /*c58a*/, "yalh" /*c58b*/, "yam" /*c58c*/, "yab" /*c58d*/, "yabs" /*c58e*/, "yas" /*c58f*/, "yass" /*c590*/, "yang" /*c591*/, "yaj" /*c592*/, "yac" /*c593*/, "yak" /*c594*/, "yat" /*c595*/, "yap" /*c596*/, "yah" /*c597*/, "yae" /*c598*/, "yaeg" /*c599*/, "yaegg" /*c59a*/, "yaegs" /*c59b*/, "yaen" /*c59c*/, "yaenj" /*c59d*/, "yaenh" /*c59e*/, "yaed" /*c59f*/, "yael" /*c5a0*/, "yaelg" /*c5a1*/, "yaelm" /*c5a2*/, "yaelb" /*c5a3*/, "yaels" /*c5a4*/, "yaelt" /*c5a5*/, "yaelp" /*c5a6*/, "yaelh" /*c5a7*/, "yaem" /*c5a8*/, "yaeb" /*c5a9*/, "yaebs" /*c5aa*/, "yaes" /*c5ab*/, "yaess" /*c5ac*/, "yaeng" /*c5ad*/, "yaej" /*c5ae*/, "yaec" /*c5af*/, "yaek" /*c5b0*/, "yaet" /*c5b1*/, "yaep" /*c5b2*/, "yaeh" /*c5b3*/, "eo" /*c5b4*/, "eog" /*c5b5*/, "eogg" /*c5b6*/, "eogs" /*c5b7*/, "eon" /*c5b8*/, "eonj" /*c5b9*/, "eonh" /*c5ba*/, "eod" /*c5bb*/, "eol" /*c5bc*/, "eolg" /*c5bd*/, "eolm" /*c5be*/, "eolb" /*c5bf*/, "eols" /*c5c0*/, "eolt" /*c5c1*/, "eolp" /*c5c2*/, "eolh" /*c5c3*/, "eom" /*c5c4*/, "eob" /*c5c5*/, "eobs" /*c5c6*/, "eos" /*c5c7*/, "eoss" /*c5c8*/, "eong" /*c5c9*/, "eoj" /*c5ca*/, "eoc" /*c5cb*/, "eok" /*c5cc*/, "eot" /*c5cd*/, "eop" /*c5ce*/, "eoh" /*c5cf*/, "e" /*c5d0*/, "eg" /*c5d1*/, "egg" /*c5d2*/, "egs" /*c5d3*/, "en" /*c5d4*/, "enj" /*c5d5*/, "enh" /*c5d6*/, "ed" /*c5d7*/, "el" /*c5d8*/, "elg" /*c5d9*/, "elm" /*c5da*/, "elb" /*c5db*/, "els" /*c5dc*/, "elt" /*c5dd*/, "elp" /*c5de*/, "elh" /*c5df*/, "em" /*c5e0*/, "eb" /*c5e1*/, "ebs" /*c5e2*/, "es" /*c5e3*/, "ess" /*c5e4*/, "eng" /*c5e5*/, "ej" /*c5e6*/, "ec" /*c5e7*/, "ek" /*c5e8*/, "et" /*c5e9*/, "ep" /*c5ea*/, "eh" /*c5eb*/, "yeo" /*c5ec*/, "yeog" /*c5ed*/, "yeogg" /*c5ee*/, "yeogs" /*c5ef*/, "yeon" /*c5f0*/, "yeonj" /*c5f1*/, "yeonh" /*c5f2*/, "yeod" /*c5f3*/, "yeol" /*c5f4*/, "yeolg" /*c5f5*/, "yeolm" /*c5f6*/, "yeolb" /*c5f7*/, "yeols" /*c5f8*/, "yeolt" /*c5f9*/, "yeolp" /*c5fa*/, "yeolh" /*c5fb*/, "yeom" /*c5fc*/, "yeob" /*c5fd*/, "yeobs" /*c5fe*/, "yeos" /*c5ff*/ 
			});
						characters.TryAdd(198 /*50688 c6*/, new string[] {
				"yeoss" /*c600*/, "yeong" /*c601*/, "yeoj" /*c602*/, "yeoc" /*c603*/, "yeok" /*c604*/, "yeot" /*c605*/, "yeop" /*c606*/, "yeoh" /*c607*/, "ye" /*c608*/, "yeg" /*c609*/, "yegg" /*c60a*/, "yegs" /*c60b*/, "yen" /*c60c*/, "yenj" /*c60d*/, "yenh" /*c60e*/, "yed" /*c60f*/, "yel" /*c610*/, "yelg" /*c611*/, "yelm" /*c612*/, "yelb" /*c613*/, "yels" /*c614*/, "yelt" /*c615*/, "yelp" /*c616*/, "yelh" /*c617*/, "yem" /*c618*/, "yeb" /*c619*/, "yebs" /*c61a*/, "yes" /*c61b*/, "yess" /*c61c*/, "yeng" /*c61d*/, "yej" /*c61e*/, "yec" /*c61f*/, "yek" /*c620*/, "yet" /*c621*/, "yep" /*c622*/, "yeh" /*c623*/, "o" /*c624*/, "og" /*c625*/, "ogg" /*c626*/, "ogs" /*c627*/, "on" /*c628*/, "onj" /*c629*/, "onh" /*c62a*/, "od" /*c62b*/, "ol" /*c62c*/, "olg" /*c62d*/, "olm" /*c62e*/, "olb" /*c62f*/, "ols" /*c630*/, "olt" /*c631*/, "olp" /*c632*/, "olh" /*c633*/, "om" /*c634*/, "ob" /*c635*/, "obs" /*c636*/, "os" /*c637*/, "oss" /*c638*/, "ong" /*c639*/, "oj" /*c63a*/, "oc" /*c63b*/, "ok" /*c63c*/, "ot" /*c63d*/, "op" /*c63e*/, "oh" /*c63f*/, "wa" /*c640*/, "wag" /*c641*/, "wagg" /*c642*/, "wags" /*c643*/, "wan" /*c644*/, "wanj" /*c645*/, "wanh" /*c646*/, "wad" /*c647*/, "wal" /*c648*/, "walg" /*c649*/, "walm" /*c64a*/, "walb" /*c64b*/, "wals" /*c64c*/, "walt" /*c64d*/, "walp" /*c64e*/, "walh" /*c64f*/, "wam" /*c650*/, "wab" /*c651*/, "wabs" /*c652*/, "was" /*c653*/, "wass" /*c654*/, "wang" /*c655*/, "waj" /*c656*/, "wac" /*c657*/, "wak" /*c658*/, "wat" /*c659*/, "wap" /*c65a*/, "wah" /*c65b*/, "wae" /*c65c*/, "waeg" /*c65d*/, "waegg" /*c65e*/, "waegs" /*c65f*/, "waen" /*c660*/, "waenj" /*c661*/, "waenh" /*c662*/, "waed" /*c663*/, "wael" /*c664*/, "waelg" /*c665*/, "waelm" /*c666*/, "waelb" /*c667*/, "waels" /*c668*/, "waelt" /*c669*/, "waelp" /*c66a*/, "waelh" /*c66b*/, "waem" /*c66c*/, "waeb" /*c66d*/, "waebs" /*c66e*/, "waes" /*c66f*/, "waess" /*c670*/, "waeng" /*c671*/, "waej" /*c672*/, "waec" /*c673*/, "waek" /*c674*/, "waet" /*c675*/, "waep" /*c676*/, "waeh" /*c677*/, "oe" /*c678*/, "oeg" /*c679*/, "oegg" /*c67a*/, "oegs" /*c67b*/, "oen" /*c67c*/, "oenj" /*c67d*/, "oenh" /*c67e*/, "oed" /*c67f*/, "oel" /*c680*/, "oelg" /*c681*/, "oelm" /*c682*/, "oelb" /*c683*/, "oels" /*c684*/, "oelt" /*c685*/, "oelp" /*c686*/, "oelh" /*c687*/, "oem" /*c688*/, "oeb" /*c689*/, "oebs" /*c68a*/, "oes" /*c68b*/, "oess" /*c68c*/, "oeng" /*c68d*/, "oej" /*c68e*/, "oec" /*c68f*/, "oek" /*c690*/, "oet" /*c691*/, "oep" /*c692*/, "oeh" /*c693*/, "yo" /*c694*/, "yog" /*c695*/, "yogg" /*c696*/, "yogs" /*c697*/, "yon" /*c698*/, "yonj" /*c699*/, "yonh" /*c69a*/, "yod" /*c69b*/, "yol" /*c69c*/, "yolg" /*c69d*/, "yolm" /*c69e*/, "yolb" /*c69f*/, "yols" /*c6a0*/, "yolt" /*c6a1*/, "yolp" /*c6a2*/, "yolh" /*c6a3*/, "yom" /*c6a4*/, "yob" /*c6a5*/, "yobs" /*c6a6*/, "yos" /*c6a7*/, "yoss" /*c6a8*/, "yong" /*c6a9*/, "yoj" /*c6aa*/, "yoc" /*c6ab*/, "yok" /*c6ac*/, "yot" /*c6ad*/, "yop" /*c6ae*/, "yoh" /*c6af*/, "u" /*c6b0*/, "ug" /*c6b1*/, "ugg" /*c6b2*/, "ugs" /*c6b3*/, "un" /*c6b4*/, "unj" /*c6b5*/, "unh" /*c6b6*/, "ud" /*c6b7*/, "ul" /*c6b8*/, "ulg" /*c6b9*/, "ulm" /*c6ba*/, "ulb" /*c6bb*/, "uls" /*c6bc*/, "ult" /*c6bd*/, "ulp" /*c6be*/, "ulh" /*c6bf*/, "um" /*c6c0*/, "ub" /*c6c1*/, "ubs" /*c6c2*/, "us" /*c6c3*/, "uss" /*c6c4*/, "ung" /*c6c5*/, "uj" /*c6c6*/, "uc" /*c6c7*/, "uk" /*c6c8*/, "ut" /*c6c9*/, "up" /*c6ca*/, "uh" /*c6cb*/, "weo" /*c6cc*/, "weog" /*c6cd*/, "weogg" /*c6ce*/, "weogs" /*c6cf*/, "weon" /*c6d0*/, "weonj" /*c6d1*/, "weonh" /*c6d2*/, "weod" /*c6d3*/, "weol" /*c6d4*/, "weolg" /*c6d5*/, "weolm" /*c6d6*/, "weolb" /*c6d7*/, "weols" /*c6d8*/, "weolt" /*c6d9*/, "weolp" /*c6da*/, "weolh" /*c6db*/, "weom" /*c6dc*/, "weob" /*c6dd*/, "weobs" /*c6de*/, "weos" /*c6df*/, "weoss" /*c6e0*/, "weong" /*c6e1*/, "weoj" /*c6e2*/, "weoc" /*c6e3*/, "weok" /*c6e4*/, "weot" /*c6e5*/, "weop" /*c6e6*/, "weoh" /*c6e7*/, "we" /*c6e8*/, "weg" /*c6e9*/, "wegg" /*c6ea*/, "wegs" /*c6eb*/, "wen" /*c6ec*/, "wenj" /*c6ed*/, "wenh" /*c6ee*/, "wed" /*c6ef*/, "wel" /*c6f0*/, "welg" /*c6f1*/, "welm" /*c6f2*/, "welb" /*c6f3*/, "wels" /*c6f4*/, "welt" /*c6f5*/, "welp" /*c6f6*/, "welh" /*c6f7*/, "wem" /*c6f8*/, "web" /*c6f9*/, "webs" /*c6fa*/, "wes" /*c6fb*/, "wess" /*c6fc*/, "weng" /*c6fd*/, "wej" /*c6fe*/, "wec" /*c6ff*/ 
			});
						characters.TryAdd(199 /*50944 c7*/, new string[] {
				"wek" /*c700*/, "wet" /*c701*/, "wep" /*c702*/, "weh" /*c703*/, "wi" /*c704*/, "wig" /*c705*/, "wigg" /*c706*/, "wigs" /*c707*/, "win" /*c708*/, "winj" /*c709*/, "winh" /*c70a*/, "wid" /*c70b*/, "wil" /*c70c*/, "wilg" /*c70d*/, "wilm" /*c70e*/, "wilb" /*c70f*/, "wils" /*c710*/, "wilt" /*c711*/, "wilp" /*c712*/, "wilh" /*c713*/, "wim" /*c714*/, "wib" /*c715*/, "wibs" /*c716*/, "wis" /*c717*/, "wiss" /*c718*/, "wing" /*c719*/, "wij" /*c71a*/, "wic" /*c71b*/, "wik" /*c71c*/, "wit" /*c71d*/, "wip" /*c71e*/, "wih" /*c71f*/, "yu" /*c720*/, "yug" /*c721*/, "yugg" /*c722*/, "yugs" /*c723*/, "yun" /*c724*/, "yunj" /*c725*/, "yunh" /*c726*/, "yud" /*c727*/, "yul" /*c728*/, "yulg" /*c729*/, "yulm" /*c72a*/, "yulb" /*c72b*/, "yuls" /*c72c*/, "yult" /*c72d*/, "yulp" /*c72e*/, "yulh" /*c72f*/, "yum" /*c730*/, "yub" /*c731*/, "yubs" /*c732*/, "yus" /*c733*/, "yuss" /*c734*/, "yung" /*c735*/, "yuj" /*c736*/, "yuc" /*c737*/, "yuk" /*c738*/, "yut" /*c739*/, "yup" /*c73a*/, "yuh" /*c73b*/, "eu" /*c73c*/, "eug" /*c73d*/, "eugg" /*c73e*/, "eugs" /*c73f*/, "eun" /*c740*/, "eunj" /*c741*/, "eunh" /*c742*/, "eud" /*c743*/, "eul" /*c744*/, "eulg" /*c745*/, "eulm" /*c746*/, "eulb" /*c747*/, "euls" /*c748*/, "eult" /*c749*/, "eulp" /*c74a*/, "eulh" /*c74b*/, "eum" /*c74c*/, "eub" /*c74d*/, "eubs" /*c74e*/, "eus" /*c74f*/, "euss" /*c750*/, "eung" /*c751*/, "euj" /*c752*/, "euc" /*c753*/, "euk" /*c754*/, "eut" /*c755*/, "eup" /*c756*/, "euh" /*c757*/, "yi" /*c758*/, "yig" /*c759*/, "yigg" /*c75a*/, "yigs" /*c75b*/, "yin" /*c75c*/, "yinj" /*c75d*/, "yinh" /*c75e*/, "yid" /*c75f*/, "yil" /*c760*/, "yilg" /*c761*/, "yilm" /*c762*/, "yilb" /*c763*/, "yils" /*c764*/, "yilt" /*c765*/, "yilp" /*c766*/, "yilh" /*c767*/, "yim" /*c768*/, "yib" /*c769*/, "yibs" /*c76a*/, "yis" /*c76b*/, "yiss" /*c76c*/, "ying" /*c76d*/, "yij" /*c76e*/, "yic" /*c76f*/, "yik" /*c770*/, "yit" /*c771*/, "yip" /*c772*/, "yih" /*c773*/, "i" /*c774*/, "ig" /*c775*/, "igg" /*c776*/, "igs" /*c777*/, "in" /*c778*/, "inj" /*c779*/, "inh" /*c77a*/, "id" /*c77b*/, "il" /*c77c*/, "ilg" /*c77d*/, "ilm" /*c77e*/, "ilb" /*c77f*/, "ils" /*c780*/, "ilt" /*c781*/, "ilp" /*c782*/, "ilh" /*c783*/, "im" /*c784*/, "ib" /*c785*/, "ibs" /*c786*/, "is" /*c787*/, "iss" /*c788*/, "ing" /*c789*/, "ij" /*c78a*/, "ic" /*c78b*/, "ik" /*c78c*/, "it" /*c78d*/, "ip" /*c78e*/, "ih" /*c78f*/, "ja" /*c790*/, "jag" /*c791*/, "jagg" /*c792*/, "jags" /*c793*/, "jan" /*c794*/, "janj" /*c795*/, "janh" /*c796*/, "jad" /*c797*/, "jal" /*c798*/, "jalg" /*c799*/, "jalm" /*c79a*/, "jalb" /*c79b*/, "jals" /*c79c*/, "jalt" /*c79d*/, "jalp" /*c79e*/, "jalh" /*c79f*/, "jam" /*c7a0*/, "jab" /*c7a1*/, "jabs" /*c7a2*/, "jas" /*c7a3*/, "jass" /*c7a4*/, "jang" /*c7a5*/, "jaj" /*c7a6*/, "jac" /*c7a7*/, "jak" /*c7a8*/, "jat" /*c7a9*/, "jap" /*c7aa*/, "jah" /*c7ab*/, "jae" /*c7ac*/, "jaeg" /*c7ad*/, "jaegg" /*c7ae*/, "jaegs" /*c7af*/, "jaen" /*c7b0*/, "jaenj" /*c7b1*/, "jaenh" /*c7b2*/, "jaed" /*c7b3*/, "jael" /*c7b4*/, "jaelg" /*c7b5*/, "jaelm" /*c7b6*/, "jaelb" /*c7b7*/, "jaels" /*c7b8*/, "jaelt" /*c7b9*/, "jaelp" /*c7ba*/, "jaelh" /*c7bb*/, "jaem" /*c7bc*/, "jaeb" /*c7bd*/, "jaebs" /*c7be*/, "jaes" /*c7bf*/, "jaess" /*c7c0*/, "jaeng" /*c7c1*/, "jaej" /*c7c2*/, "jaec" /*c7c3*/, "jaek" /*c7c4*/, "jaet" /*c7c5*/, "jaep" /*c7c6*/, "jaeh" /*c7c7*/, "jya" /*c7c8*/, "jyag" /*c7c9*/, "jyagg" /*c7ca*/, "jyags" /*c7cb*/, "jyan" /*c7cc*/, "jyanj" /*c7cd*/, "jyanh" /*c7ce*/, "jyad" /*c7cf*/, "jyal" /*c7d0*/, "jyalg" /*c7d1*/, "jyalm" /*c7d2*/, "jyalb" /*c7d3*/, "jyals" /*c7d4*/, "jyalt" /*c7d5*/, "jyalp" /*c7d6*/, "jyalh" /*c7d7*/, "jyam" /*c7d8*/, "jyab" /*c7d9*/, "jyabs" /*c7da*/, "jyas" /*c7db*/, "jyass" /*c7dc*/, "jyang" /*c7dd*/, "jyaj" /*c7de*/, "jyac" /*c7df*/, "jyak" /*c7e0*/, "jyat" /*c7e1*/, "jyap" /*c7e2*/, "jyah" /*c7e3*/, "jyae" /*c7e4*/, "jyaeg" /*c7e5*/, "jyaegg" /*c7e6*/, "jyaegs" /*c7e7*/, "jyaen" /*c7e8*/, "jyaenj" /*c7e9*/, "jyaenh" /*c7ea*/, "jyaed" /*c7eb*/, "jyael" /*c7ec*/, "jyaelg" /*c7ed*/, "jyaelm" /*c7ee*/, "jyaelb" /*c7ef*/, "jyaels" /*c7f0*/, "jyaelt" /*c7f1*/, "jyaelp" /*c7f2*/, "jyaelh" /*c7f3*/, "jyaem" /*c7f4*/, "jyaeb" /*c7f5*/, "jyaebs" /*c7f6*/, "jyaes" /*c7f7*/, "jyaess" /*c7f8*/, "jyaeng" /*c7f9*/, "jyaej" /*c7fa*/, "jyaec" /*c7fb*/, "jyaek" /*c7fc*/, "jyaet" /*c7fd*/, "jyaep" /*c7fe*/, "jyaeh" /*c7ff*/ 
			});
						characters.TryAdd(200 /*51200 c8*/, new string[] {
				"jeo" /*c800*/, "jeog" /*c801*/, "jeogg" /*c802*/, "jeogs" /*c803*/, "jeon" /*c804*/, "jeonj" /*c805*/, "jeonh" /*c806*/, "jeod" /*c807*/, "jeol" /*c808*/, "jeolg" /*c809*/, "jeolm" /*c80a*/, "jeolb" /*c80b*/, "jeols" /*c80c*/, "jeolt" /*c80d*/, "jeolp" /*c80e*/, "jeolh" /*c80f*/, "jeom" /*c810*/, "jeob" /*c811*/, "jeobs" /*c812*/, "jeos" /*c813*/, "jeoss" /*c814*/, "jeong" /*c815*/, "jeoj" /*c816*/, "jeoc" /*c817*/, "jeok" /*c818*/, "jeot" /*c819*/, "jeop" /*c81a*/, "jeoh" /*c81b*/, "je" /*c81c*/, "jeg" /*c81d*/, "jegg" /*c81e*/, "jegs" /*c81f*/, "jen" /*c820*/, "jenj" /*c821*/, "jenh" /*c822*/, "jed" /*c823*/, "jel" /*c824*/, "jelg" /*c825*/, "jelm" /*c826*/, "jelb" /*c827*/, "jels" /*c828*/, "jelt" /*c829*/, "jelp" /*c82a*/, "jelh" /*c82b*/, "jem" /*c82c*/, "jeb" /*c82d*/, "jebs" /*c82e*/, "jes" /*c82f*/, "jess" /*c830*/, "jeng" /*c831*/, "jej" /*c832*/, "jec" /*c833*/, "jek" /*c834*/, "jet" /*c835*/, "jep" /*c836*/, "jeh" /*c837*/, "jyeo" /*c838*/, "jyeog" /*c839*/, "jyeogg" /*c83a*/, "jyeogs" /*c83b*/, "jyeon" /*c83c*/, "jyeonj" /*c83d*/, "jyeonh" /*c83e*/, "jyeod" /*c83f*/, "jyeol" /*c840*/, "jyeolg" /*c841*/, "jyeolm" /*c842*/, "jyeolb" /*c843*/, "jyeols" /*c844*/, "jyeolt" /*c845*/, "jyeolp" /*c846*/, "jyeolh" /*c847*/, "jyeom" /*c848*/, "jyeob" /*c849*/, "jyeobs" /*c84a*/, "jyeos" /*c84b*/, "jyeoss" /*c84c*/, "jyeong" /*c84d*/, "jyeoj" /*c84e*/, "jyeoc" /*c84f*/, "jyeok" /*c850*/, "jyeot" /*c851*/, "jyeop" /*c852*/, "jyeoh" /*c853*/, "jye" /*c854*/, "jyeg" /*c855*/, "jyegg" /*c856*/, "jyegs" /*c857*/, "jyen" /*c858*/, "jyenj" /*c859*/, "jyenh" /*c85a*/, "jyed" /*c85b*/, "jyel" /*c85c*/, "jyelg" /*c85d*/, "jyelm" /*c85e*/, "jyelb" /*c85f*/, "jyels" /*c860*/, "jyelt" /*c861*/, "jyelp" /*c862*/, "jyelh" /*c863*/, "jyem" /*c864*/, "jyeb" /*c865*/, "jyebs" /*c866*/, "jyes" /*c867*/, "jyess" /*c868*/, "jyeng" /*c869*/, "jyej" /*c86a*/, "jyec" /*c86b*/, "jyek" /*c86c*/, "jyet" /*c86d*/, "jyep" /*c86e*/, "jyeh" /*c86f*/, "jo" /*c870*/, "jog" /*c871*/, "jogg" /*c872*/, "jogs" /*c873*/, "jon" /*c874*/, "jonj" /*c875*/, "jonh" /*c876*/, "jod" /*c877*/, "jol" /*c878*/, "jolg" /*c879*/, "jolm" /*c87a*/, "jolb" /*c87b*/, "jols" /*c87c*/, "jolt" /*c87d*/, "jolp" /*c87e*/, "jolh" /*c87f*/, "jom" /*c880*/, "job" /*c881*/, "jobs" /*c882*/, "jos" /*c883*/, "joss" /*c884*/, "jong" /*c885*/, "joj" /*c886*/, "joc" /*c887*/, "jok" /*c888*/, "jot" /*c889*/, "jop" /*c88a*/, "joh" /*c88b*/, "jwa" /*c88c*/, "jwag" /*c88d*/, "jwagg" /*c88e*/, "jwags" /*c88f*/, "jwan" /*c890*/, "jwanj" /*c891*/, "jwanh" /*c892*/, "jwad" /*c893*/, "jwal" /*c894*/, "jwalg" /*c895*/, "jwalm" /*c896*/, "jwalb" /*c897*/, "jwals" /*c898*/, "jwalt" /*c899*/, "jwalp" /*c89a*/, "jwalh" /*c89b*/, "jwam" /*c89c*/, "jwab" /*c89d*/, "jwabs" /*c89e*/, "jwas" /*c89f*/, "jwass" /*c8a0*/, "jwang" /*c8a1*/, "jwaj" /*c8a2*/, "jwac" /*c8a3*/, "jwak" /*c8a4*/, "jwat" /*c8a5*/, "jwap" /*c8a6*/, "jwah" /*c8a7*/, "jwae" /*c8a8*/, "jwaeg" /*c8a9*/, "jwaegg" /*c8aa*/, "jwaegs" /*c8ab*/, "jwaen" /*c8ac*/, "jwaenj" /*c8ad*/, "jwaenh" /*c8ae*/, "jwaed" /*c8af*/, "jwael" /*c8b0*/, "jwaelg" /*c8b1*/, "jwaelm" /*c8b2*/, "jwaelb" /*c8b3*/, "jwaels" /*c8b4*/, "jwaelt" /*c8b5*/, "jwaelp" /*c8b6*/, "jwaelh" /*c8b7*/, "jwaem" /*c8b8*/, "jwaeb" /*c8b9*/, "jwaebs" /*c8ba*/, "jwaes" /*c8bb*/, "jwaess" /*c8bc*/, "jwaeng" /*c8bd*/, "jwaej" /*c8be*/, "jwaec" /*c8bf*/, "jwaek" /*c8c0*/, "jwaet" /*c8c1*/, "jwaep" /*c8c2*/, "jwaeh" /*c8c3*/, "joe" /*c8c4*/, "joeg" /*c8c5*/, "joegg" /*c8c6*/, "joegs" /*c8c7*/, "joen" /*c8c8*/, "joenj" /*c8c9*/, "joenh" /*c8ca*/, "joed" /*c8cb*/, "joel" /*c8cc*/, "joelg" /*c8cd*/, "joelm" /*c8ce*/, "joelb" /*c8cf*/, "joels" /*c8d0*/, "joelt" /*c8d1*/, "joelp" /*c8d2*/, "joelh" /*c8d3*/, "joem" /*c8d4*/, "joeb" /*c8d5*/, "joebs" /*c8d6*/, "joes" /*c8d7*/, "joess" /*c8d8*/, "joeng" /*c8d9*/, "joej" /*c8da*/, "joec" /*c8db*/, "joek" /*c8dc*/, "joet" /*c8dd*/, "joep" /*c8de*/, "joeh" /*c8df*/, "jyo" /*c8e0*/, "jyog" /*c8e1*/, "jyogg" /*c8e2*/, "jyogs" /*c8e3*/, "jyon" /*c8e4*/, "jyonj" /*c8e5*/, "jyonh" /*c8e6*/, "jyod" /*c8e7*/, "jyol" /*c8e8*/, "jyolg" /*c8e9*/, "jyolm" /*c8ea*/, "jyolb" /*c8eb*/, "jyols" /*c8ec*/, "jyolt" /*c8ed*/, "jyolp" /*c8ee*/, "jyolh" /*c8ef*/, "jyom" /*c8f0*/, "jyob" /*c8f1*/, "jyobs" /*c8f2*/, "jyos" /*c8f3*/, "jyoss" /*c8f4*/, "jyong" /*c8f5*/, "jyoj" /*c8f6*/, "jyoc" /*c8f7*/, "jyok" /*c8f8*/, "jyot" /*c8f9*/, "jyop" /*c8fa*/, "jyoh" /*c8fb*/, "ju" /*c8fc*/, "jug" /*c8fd*/, "jugg" /*c8fe*/, "jugs" /*c8ff*/ 
			});
						characters.TryAdd(201 /*51456 c9*/, new string[] {
				"jun" /*c900*/, "junj" /*c901*/, "junh" /*c902*/, "jud" /*c903*/, "jul" /*c904*/, "julg" /*c905*/, "julm" /*c906*/, "julb" /*c907*/, "juls" /*c908*/, "jult" /*c909*/, "julp" /*c90a*/, "julh" /*c90b*/, "jum" /*c90c*/, "jub" /*c90d*/, "jubs" /*c90e*/, "jus" /*c90f*/, "juss" /*c910*/, "jung" /*c911*/, "juj" /*c912*/, "juc" /*c913*/, "juk" /*c914*/, "jut" /*c915*/, "jup" /*c916*/, "juh" /*c917*/, "jweo" /*c918*/, "jweog" /*c919*/, "jweogg" /*c91a*/, "jweogs" /*c91b*/, "jweon" /*c91c*/, "jweonj" /*c91d*/, "jweonh" /*c91e*/, "jweod" /*c91f*/, "jweol" /*c920*/, "jweolg" /*c921*/, "jweolm" /*c922*/, "jweolb" /*c923*/, "jweols" /*c924*/, "jweolt" /*c925*/, "jweolp" /*c926*/, "jweolh" /*c927*/, "jweom" /*c928*/, "jweob" /*c929*/, "jweobs" /*c92a*/, "jweos" /*c92b*/, "jweoss" /*c92c*/, "jweong" /*c92d*/, "jweoj" /*c92e*/, "jweoc" /*c92f*/, "jweok" /*c930*/, "jweot" /*c931*/, "jweop" /*c932*/, "jweoh" /*c933*/, "jwe" /*c934*/, "jweg" /*c935*/, "jwegg" /*c936*/, "jwegs" /*c937*/, "jwen" /*c938*/, "jwenj" /*c939*/, "jwenh" /*c93a*/, "jwed" /*c93b*/, "jwel" /*c93c*/, "jwelg" /*c93d*/, "jwelm" /*c93e*/, "jwelb" /*c93f*/, "jwels" /*c940*/, "jwelt" /*c941*/, "jwelp" /*c942*/, "jwelh" /*c943*/, "jwem" /*c944*/, "jweb" /*c945*/, "jwebs" /*c946*/, "jwes" /*c947*/, "jwess" /*c948*/, "jweng" /*c949*/, "jwej" /*c94a*/, "jwec" /*c94b*/, "jwek" /*c94c*/, "jwet" /*c94d*/, "jwep" /*c94e*/, "jweh" /*c94f*/, "jwi" /*c950*/, "jwig" /*c951*/, "jwigg" /*c952*/, "jwigs" /*c953*/, "jwin" /*c954*/, "jwinj" /*c955*/, "jwinh" /*c956*/, "jwid" /*c957*/, "jwil" /*c958*/, "jwilg" /*c959*/, "jwilm" /*c95a*/, "jwilb" /*c95b*/, "jwils" /*c95c*/, "jwilt" /*c95d*/, "jwilp" /*c95e*/, "jwilh" /*c95f*/, "jwim" /*c960*/, "jwib" /*c961*/, "jwibs" /*c962*/, "jwis" /*c963*/, "jwiss" /*c964*/, "jwing" /*c965*/, "jwij" /*c966*/, "jwic" /*c967*/, "jwik" /*c968*/, "jwit" /*c969*/, "jwip" /*c96a*/, "jwih" /*c96b*/, "jyu" /*c96c*/, "jyug" /*c96d*/, "jyugg" /*c96e*/, "jyugs" /*c96f*/, "jyun" /*c970*/, "jyunj" /*c971*/, "jyunh" /*c972*/, "jyud" /*c973*/, "jyul" /*c974*/, "jyulg" /*c975*/, "jyulm" /*c976*/, "jyulb" /*c977*/, "jyuls" /*c978*/, "jyult" /*c979*/, "jyulp" /*c97a*/, "jyulh" /*c97b*/, "jyum" /*c97c*/, "jyub" /*c97d*/, "jyubs" /*c97e*/, "jyus" /*c97f*/, "jyuss" /*c980*/, "jyung" /*c981*/, "jyuj" /*c982*/, "jyuc" /*c983*/, "jyuk" /*c984*/, "jyut" /*c985*/, "jyup" /*c986*/, "jyuh" /*c987*/, "jeu" /*c988*/, "jeug" /*c989*/, "jeugg" /*c98a*/, "jeugs" /*c98b*/, "jeun" /*c98c*/, "jeunj" /*c98d*/, "jeunh" /*c98e*/, "jeud" /*c98f*/, "jeul" /*c990*/, "jeulg" /*c991*/, "jeulm" /*c992*/, "jeulb" /*c993*/, "jeuls" /*c994*/, "jeult" /*c995*/, "jeulp" /*c996*/, "jeulh" /*c997*/, "jeum" /*c998*/, "jeub" /*c999*/, "jeubs" /*c99a*/, "jeus" /*c99b*/, "jeuss" /*c99c*/, "jeung" /*c99d*/, "jeuj" /*c99e*/, "jeuc" /*c99f*/, "jeuk" /*c9a0*/, "jeut" /*c9a1*/, "jeup" /*c9a2*/, "jeuh" /*c9a3*/, "jyi" /*c9a4*/, "jyig" /*c9a5*/, "jyigg" /*c9a6*/, "jyigs" /*c9a7*/, "jyin" /*c9a8*/, "jyinj" /*c9a9*/, "jyinh" /*c9aa*/, "jyid" /*c9ab*/, "jyil" /*c9ac*/, "jyilg" /*c9ad*/, "jyilm" /*c9ae*/, "jyilb" /*c9af*/, "jyils" /*c9b0*/, "jyilt" /*c9b1*/, "jyilp" /*c9b2*/, "jyilh" /*c9b3*/, "jyim" /*c9b4*/, "jyib" /*c9b5*/, "jyibs" /*c9b6*/, "jyis" /*c9b7*/, "jyiss" /*c9b8*/, "jying" /*c9b9*/, "jyij" /*c9ba*/, "jyic" /*c9bb*/, "jyik" /*c9bc*/, "jyit" /*c9bd*/, "jyip" /*c9be*/, "jyih" /*c9bf*/, "ji" /*c9c0*/, "jig" /*c9c1*/, "jigg" /*c9c2*/, "jigs" /*c9c3*/, "jin" /*c9c4*/, "jinj" /*c9c5*/, "jinh" /*c9c6*/, "jid" /*c9c7*/, "jil" /*c9c8*/, "jilg" /*c9c9*/, "jilm" /*c9ca*/, "jilb" /*c9cb*/, "jils" /*c9cc*/, "jilt" /*c9cd*/, "jilp" /*c9ce*/, "jilh" /*c9cf*/, "jim" /*c9d0*/, "jib" /*c9d1*/, "jibs" /*c9d2*/, "jis" /*c9d3*/, "jiss" /*c9d4*/, "jing" /*c9d5*/, "jij" /*c9d6*/, "jic" /*c9d7*/, "jik" /*c9d8*/, "jit" /*c9d9*/, "jip" /*c9da*/, "jih" /*c9db*/, "jja" /*c9dc*/, "jjag" /*c9dd*/, "jjagg" /*c9de*/, "jjags" /*c9df*/, "jjan" /*c9e0*/, "jjanj" /*c9e1*/, "jjanh" /*c9e2*/, "jjad" /*c9e3*/, "jjal" /*c9e4*/, "jjalg" /*c9e5*/, "jjalm" /*c9e6*/, "jjalb" /*c9e7*/, "jjals" /*c9e8*/, "jjalt" /*c9e9*/, "jjalp" /*c9ea*/, "jjalh" /*c9eb*/, "jjam" /*c9ec*/, "jjab" /*c9ed*/, "jjabs" /*c9ee*/, "jjas" /*c9ef*/, "jjass" /*c9f0*/, "jjang" /*c9f1*/, "jjaj" /*c9f2*/, "jjac" /*c9f3*/, "jjak" /*c9f4*/, "jjat" /*c9f5*/, "jjap" /*c9f6*/, "jjah" /*c9f7*/, "jjae" /*c9f8*/, "jjaeg" /*c9f9*/, "jjaegg" /*c9fa*/, "jjaegs" /*c9fb*/, "jjaen" /*c9fc*/, "jjaenj" /*c9fd*/, "jjaenh" /*c9fe*/, "jjaed" /*c9ff*/ 
			});
						characters.TryAdd(202 /*51712 ca*/, new string[] {
				"jjael" /*ca00*/, "jjaelg" /*ca01*/, "jjaelm" /*ca02*/, "jjaelb" /*ca03*/, "jjaels" /*ca04*/, "jjaelt" /*ca05*/, "jjaelp" /*ca06*/, "jjaelh" /*ca07*/, "jjaem" /*ca08*/, "jjaeb" /*ca09*/, "jjaebs" /*ca0a*/, "jjaes" /*ca0b*/, "jjaess" /*ca0c*/, "jjaeng" /*ca0d*/, "jjaej" /*ca0e*/, "jjaec" /*ca0f*/, "jjaek" /*ca10*/, "jjaet" /*ca11*/, "jjaep" /*ca12*/, "jjaeh" /*ca13*/, "jjya" /*ca14*/, "jjyag" /*ca15*/, "jjyagg" /*ca16*/, "jjyags" /*ca17*/, "jjyan" /*ca18*/, "jjyanj" /*ca19*/, "jjyanh" /*ca1a*/, "jjyad" /*ca1b*/, "jjyal" /*ca1c*/, "jjyalg" /*ca1d*/, "jjyalm" /*ca1e*/, "jjyalb" /*ca1f*/, "jjyals" /*ca20*/, "jjyalt" /*ca21*/, "jjyalp" /*ca22*/, "jjyalh" /*ca23*/, "jjyam" /*ca24*/, "jjyab" /*ca25*/, "jjyabs" /*ca26*/, "jjyas" /*ca27*/, "jjyass" /*ca28*/, "jjyang" /*ca29*/, "jjyaj" /*ca2a*/, "jjyac" /*ca2b*/, "jjyak" /*ca2c*/, "jjyat" /*ca2d*/, "jjyap" /*ca2e*/, "jjyah" /*ca2f*/, "jjyae" /*ca30*/, "jjyaeg" /*ca31*/, "jjyaegg" /*ca32*/, "jjyaegs" /*ca33*/, "jjyaen" /*ca34*/, "jjyaenj" /*ca35*/, "jjyaenh" /*ca36*/, "jjyaed" /*ca37*/, "jjyael" /*ca38*/, "jjyaelg" /*ca39*/, "jjyaelm" /*ca3a*/, "jjyaelb" /*ca3b*/, "jjyaels" /*ca3c*/, "jjyaelt" /*ca3d*/, "jjyaelp" /*ca3e*/, "jjyaelh" /*ca3f*/, "jjyaem" /*ca40*/, "jjyaeb" /*ca41*/, "jjyaebs" /*ca42*/, "jjyaes" /*ca43*/, "jjyaess" /*ca44*/, "jjyaeng" /*ca45*/, "jjyaej" /*ca46*/, "jjyaec" /*ca47*/, "jjyaek" /*ca48*/, "jjyaet" /*ca49*/, "jjyaep" /*ca4a*/, "jjyaeh" /*ca4b*/, "jjeo" /*ca4c*/, "jjeog" /*ca4d*/, "jjeogg" /*ca4e*/, "jjeogs" /*ca4f*/, "jjeon" /*ca50*/, "jjeonj" /*ca51*/, "jjeonh" /*ca52*/, "jjeod" /*ca53*/, "jjeol" /*ca54*/, "jjeolg" /*ca55*/, "jjeolm" /*ca56*/, "jjeolb" /*ca57*/, "jjeols" /*ca58*/, "jjeolt" /*ca59*/, "jjeolp" /*ca5a*/, "jjeolh" /*ca5b*/, "jjeom" /*ca5c*/, "jjeob" /*ca5d*/, "jjeobs" /*ca5e*/, "jjeos" /*ca5f*/, "jjeoss" /*ca60*/, "jjeong" /*ca61*/, "jjeoj" /*ca62*/, "jjeoc" /*ca63*/, "jjeok" /*ca64*/, "jjeot" /*ca65*/, "jjeop" /*ca66*/, "jjeoh" /*ca67*/, "jje" /*ca68*/, "jjeg" /*ca69*/, "jjegg" /*ca6a*/, "jjegs" /*ca6b*/, "jjen" /*ca6c*/, "jjenj" /*ca6d*/, "jjenh" /*ca6e*/, "jjed" /*ca6f*/, "jjel" /*ca70*/, "jjelg" /*ca71*/, "jjelm" /*ca72*/, "jjelb" /*ca73*/, "jjels" /*ca74*/, "jjelt" /*ca75*/, "jjelp" /*ca76*/, "jjelh" /*ca77*/, "jjem" /*ca78*/, "jjeb" /*ca79*/, "jjebs" /*ca7a*/, "jjes" /*ca7b*/, "jjess" /*ca7c*/, "jjeng" /*ca7d*/, "jjej" /*ca7e*/, "jjec" /*ca7f*/, "jjek" /*ca80*/, "jjet" /*ca81*/, "jjep" /*ca82*/, "jjeh" /*ca83*/, "jjyeo" /*ca84*/, "jjyeog" /*ca85*/, "jjyeogg" /*ca86*/, "jjyeogs" /*ca87*/, "jjyeon" /*ca88*/, "jjyeonj" /*ca89*/, "jjyeonh" /*ca8a*/, "jjyeod" /*ca8b*/, "jjyeol" /*ca8c*/, "jjyeolg" /*ca8d*/, "jjyeolm" /*ca8e*/, "jjyeolb" /*ca8f*/, "jjyeols" /*ca90*/, "jjyeolt" /*ca91*/, "jjyeolp" /*ca92*/, "jjyeolh" /*ca93*/, "jjyeom" /*ca94*/, "jjyeob" /*ca95*/, "jjyeobs" /*ca96*/, "jjyeos" /*ca97*/, "jjyeoss" /*ca98*/, "jjyeong" /*ca99*/, "jjyeoj" /*ca9a*/, "jjyeoc" /*ca9b*/, "jjyeok" /*ca9c*/, "jjyeot" /*ca9d*/, "jjyeop" /*ca9e*/, "jjyeoh" /*ca9f*/, "jjye" /*caa0*/, "jjyeg" /*caa1*/, "jjyegg" /*caa2*/, "jjyegs" /*caa3*/, "jjyen" /*caa4*/, "jjyenj" /*caa5*/, "jjyenh" /*caa6*/, "jjyed" /*caa7*/, "jjyel" /*caa8*/, "jjyelg" /*caa9*/, "jjyelm" /*caaa*/, "jjyelb" /*caab*/, "jjyels" /*caac*/, "jjyelt" /*caad*/, "jjyelp" /*caae*/, "jjyelh" /*caaf*/, "jjyem" /*cab0*/, "jjyeb" /*cab1*/, "jjyebs" /*cab2*/, "jjyes" /*cab3*/, "jjyess" /*cab4*/, "jjyeng" /*cab5*/, "jjyej" /*cab6*/, "jjyec" /*cab7*/, "jjyek" /*cab8*/, "jjyet" /*cab9*/, "jjyep" /*caba*/, "jjyeh" /*cabb*/, "jjo" /*cabc*/, "jjog" /*cabd*/, "jjogg" /*cabe*/, "jjogs" /*cabf*/, "jjon" /*cac0*/, "jjonj" /*cac1*/, "jjonh" /*cac2*/, "jjod" /*cac3*/, "jjol" /*cac4*/, "jjolg" /*cac5*/, "jjolm" /*cac6*/, "jjolb" /*cac7*/, "jjols" /*cac8*/, "jjolt" /*cac9*/, "jjolp" /*caca*/, "jjolh" /*cacb*/, "jjom" /*cacc*/, "jjob" /*cacd*/, "jjobs" /*cace*/, "jjos" /*cacf*/, "jjoss" /*cad0*/, "jjong" /*cad1*/, "jjoj" /*cad2*/, "jjoc" /*cad3*/, "jjok" /*cad4*/, "jjot" /*cad5*/, "jjop" /*cad6*/, "jjoh" /*cad7*/, "jjwa" /*cad8*/, "jjwag" /*cad9*/, "jjwagg" /*cada*/, "jjwags" /*cadb*/, "jjwan" /*cadc*/, "jjwanj" /*cadd*/, "jjwanh" /*cade*/, "jjwad" /*cadf*/, "jjwal" /*cae0*/, "jjwalg" /*cae1*/, "jjwalm" /*cae2*/, "jjwalb" /*cae3*/, "jjwals" /*cae4*/, "jjwalt" /*cae5*/, "jjwalp" /*cae6*/, "jjwalh" /*cae7*/, "jjwam" /*cae8*/, "jjwab" /*cae9*/, "jjwabs" /*caea*/, "jjwas" /*caeb*/, "jjwass" /*caec*/, "jjwang" /*caed*/, "jjwaj" /*caee*/, "jjwac" /*caef*/, "jjwak" /*caf0*/, "jjwat" /*caf1*/, "jjwap" /*caf2*/, "jjwah" /*caf3*/, "jjwae" /*caf4*/, "jjwaeg" /*caf5*/, "jjwaegg" /*caf6*/, "jjwaegs" /*caf7*/, "jjwaen" /*caf8*/, "jjwaenj" /*caf9*/, "jjwaenh" /*cafa*/, "jjwaed" /*cafb*/, "jjwael" /*cafc*/, "jjwaelg" /*cafd*/, "jjwaelm" /*cafe*/, "jjwaelb" /*caff*/ 
			});
						characters.TryAdd(203 /*51968 cb*/, new string[] {
				"jjwaels" /*cb00*/, "jjwaelt" /*cb01*/, "jjwaelp" /*cb02*/, "jjwaelh" /*cb03*/, "jjwaem" /*cb04*/, "jjwaeb" /*cb05*/, "jjwaebs" /*cb06*/, "jjwaes" /*cb07*/, "jjwaess" /*cb08*/, "jjwaeng" /*cb09*/, "jjwaej" /*cb0a*/, "jjwaec" /*cb0b*/, "jjwaek" /*cb0c*/, "jjwaet" /*cb0d*/, "jjwaep" /*cb0e*/, "jjwaeh" /*cb0f*/, "jjoe" /*cb10*/, "jjoeg" /*cb11*/, "jjoegg" /*cb12*/, "jjoegs" /*cb13*/, "jjoen" /*cb14*/, "jjoenj" /*cb15*/, "jjoenh" /*cb16*/, "jjoed" /*cb17*/, "jjoel" /*cb18*/, "jjoelg" /*cb19*/, "jjoelm" /*cb1a*/, "jjoelb" /*cb1b*/, "jjoels" /*cb1c*/, "jjoelt" /*cb1d*/, "jjoelp" /*cb1e*/, "jjoelh" /*cb1f*/, "jjoem" /*cb20*/, "jjoeb" /*cb21*/, "jjoebs" /*cb22*/, "jjoes" /*cb23*/, "jjoess" /*cb24*/, "jjoeng" /*cb25*/, "jjoej" /*cb26*/, "jjoec" /*cb27*/, "jjoek" /*cb28*/, "jjoet" /*cb29*/, "jjoep" /*cb2a*/, "jjoeh" /*cb2b*/, "jjyo" /*cb2c*/, "jjyog" /*cb2d*/, "jjyogg" /*cb2e*/, "jjyogs" /*cb2f*/, "jjyon" /*cb30*/, "jjyonj" /*cb31*/, "jjyonh" /*cb32*/, "jjyod" /*cb33*/, "jjyol" /*cb34*/, "jjyolg" /*cb35*/, "jjyolm" /*cb36*/, "jjyolb" /*cb37*/, "jjyols" /*cb38*/, "jjyolt" /*cb39*/, "jjyolp" /*cb3a*/, "jjyolh" /*cb3b*/, "jjyom" /*cb3c*/, "jjyob" /*cb3d*/, "jjyobs" /*cb3e*/, "jjyos" /*cb3f*/, "jjyoss" /*cb40*/, "jjyong" /*cb41*/, "jjyoj" /*cb42*/, "jjyoc" /*cb43*/, "jjyok" /*cb44*/, "jjyot" /*cb45*/, "jjyop" /*cb46*/, "jjyoh" /*cb47*/, "jju" /*cb48*/, "jjug" /*cb49*/, "jjugg" /*cb4a*/, "jjugs" /*cb4b*/, "jjun" /*cb4c*/, "jjunj" /*cb4d*/, "jjunh" /*cb4e*/, "jjud" /*cb4f*/, "jjul" /*cb50*/, "jjulg" /*cb51*/, "jjulm" /*cb52*/, "jjulb" /*cb53*/, "jjuls" /*cb54*/, "jjult" /*cb55*/, "jjulp" /*cb56*/, "jjulh" /*cb57*/, "jjum" /*cb58*/, "jjub" /*cb59*/, "jjubs" /*cb5a*/, "jjus" /*cb5b*/, "jjuss" /*cb5c*/, "jjung" /*cb5d*/, "jjuj" /*cb5e*/, "jjuc" /*cb5f*/, "jjuk" /*cb60*/, "jjut" /*cb61*/, "jjup" /*cb62*/, "jjuh" /*cb63*/, "jjweo" /*cb64*/, "jjweog" /*cb65*/, "jjweogg" /*cb66*/, "jjweogs" /*cb67*/, "jjweon" /*cb68*/, "jjweonj" /*cb69*/, "jjweonh" /*cb6a*/, "jjweod" /*cb6b*/, "jjweol" /*cb6c*/, "jjweolg" /*cb6d*/, "jjweolm" /*cb6e*/, "jjweolb" /*cb6f*/, "jjweols" /*cb70*/, "jjweolt" /*cb71*/, "jjweolp" /*cb72*/, "jjweolh" /*cb73*/, "jjweom" /*cb74*/, "jjweob" /*cb75*/, "jjweobs" /*cb76*/, "jjweos" /*cb77*/, "jjweoss" /*cb78*/, "jjweong" /*cb79*/, "jjweoj" /*cb7a*/, "jjweoc" /*cb7b*/, "jjweok" /*cb7c*/, "jjweot" /*cb7d*/, "jjweop" /*cb7e*/, "jjweoh" /*cb7f*/, "jjwe" /*cb80*/, "jjweg" /*cb81*/, "jjwegg" /*cb82*/, "jjwegs" /*cb83*/, "jjwen" /*cb84*/, "jjwenj" /*cb85*/, "jjwenh" /*cb86*/, "jjwed" /*cb87*/, "jjwel" /*cb88*/, "jjwelg" /*cb89*/, "jjwelm" /*cb8a*/, "jjwelb" /*cb8b*/, "jjwels" /*cb8c*/, "jjwelt" /*cb8d*/, "jjwelp" /*cb8e*/, "jjwelh" /*cb8f*/, "jjwem" /*cb90*/, "jjweb" /*cb91*/, "jjwebs" /*cb92*/, "jjwes" /*cb93*/, "jjwess" /*cb94*/, "jjweng" /*cb95*/, "jjwej" /*cb96*/, "jjwec" /*cb97*/, "jjwek" /*cb98*/, "jjwet" /*cb99*/, "jjwep" /*cb9a*/, "jjweh" /*cb9b*/, "jjwi" /*cb9c*/, "jjwig" /*cb9d*/, "jjwigg" /*cb9e*/, "jjwigs" /*cb9f*/, "jjwin" /*cba0*/, "jjwinj" /*cba1*/, "jjwinh" /*cba2*/, "jjwid" /*cba3*/, "jjwil" /*cba4*/, "jjwilg" /*cba5*/, "jjwilm" /*cba6*/, "jjwilb" /*cba7*/, "jjwils" /*cba8*/, "jjwilt" /*cba9*/, "jjwilp" /*cbaa*/, "jjwilh" /*cbab*/, "jjwim" /*cbac*/, "jjwib" /*cbad*/, "jjwibs" /*cbae*/, "jjwis" /*cbaf*/, "jjwiss" /*cbb0*/, "jjwing" /*cbb1*/, "jjwij" /*cbb2*/, "jjwic" /*cbb3*/, "jjwik" /*cbb4*/, "jjwit" /*cbb5*/, "jjwip" /*cbb6*/, "jjwih" /*cbb7*/, "jjyu" /*cbb8*/, "jjyug" /*cbb9*/, "jjyugg" /*cbba*/, "jjyugs" /*cbbb*/, "jjyun" /*cbbc*/, "jjyunj" /*cbbd*/, "jjyunh" /*cbbe*/, "jjyud" /*cbbf*/, "jjyul" /*cbc0*/, "jjyulg" /*cbc1*/, "jjyulm" /*cbc2*/, "jjyulb" /*cbc3*/, "jjyuls" /*cbc4*/, "jjyult" /*cbc5*/, "jjyulp" /*cbc6*/, "jjyulh" /*cbc7*/, "jjyum" /*cbc8*/, "jjyub" /*cbc9*/, "jjyubs" /*cbca*/, "jjyus" /*cbcb*/, "jjyuss" /*cbcc*/, "jjyung" /*cbcd*/, "jjyuj" /*cbce*/, "jjyuc" /*cbcf*/, "jjyuk" /*cbd0*/, "jjyut" /*cbd1*/, "jjyup" /*cbd2*/, "jjyuh" /*cbd3*/, "jjeu" /*cbd4*/, "jjeug" /*cbd5*/, "jjeugg" /*cbd6*/, "jjeugs" /*cbd7*/, "jjeun" /*cbd8*/, "jjeunj" /*cbd9*/, "jjeunh" /*cbda*/, "jjeud" /*cbdb*/, "jjeul" /*cbdc*/, "jjeulg" /*cbdd*/, "jjeulm" /*cbde*/, "jjeulb" /*cbdf*/, "jjeuls" /*cbe0*/, "jjeult" /*cbe1*/, "jjeulp" /*cbe2*/, "jjeulh" /*cbe3*/, "jjeum" /*cbe4*/, "jjeub" /*cbe5*/, "jjeubs" /*cbe6*/, "jjeus" /*cbe7*/, "jjeuss" /*cbe8*/, "jjeung" /*cbe9*/, "jjeuj" /*cbea*/, "jjeuc" /*cbeb*/, "jjeuk" /*cbec*/, "jjeut" /*cbed*/, "jjeup" /*cbee*/, "jjeuh" /*cbef*/, "jjyi" /*cbf0*/, "jjyig" /*cbf1*/, "jjyigg" /*cbf2*/, "jjyigs" /*cbf3*/, "jjyin" /*cbf4*/, "jjyinj" /*cbf5*/, "jjyinh" /*cbf6*/, "jjyid" /*cbf7*/, "jjyil" /*cbf8*/, "jjyilg" /*cbf9*/, "jjyilm" /*cbfa*/, "jjyilb" /*cbfb*/, "jjyils" /*cbfc*/, "jjyilt" /*cbfd*/, "jjyilp" /*cbfe*/, "jjyilh" /*cbff*/ 
			});
						characters.TryAdd(204 /*52224 cc*/, new string[] {
				"jjyim" /*cc00*/, "jjyib" /*cc01*/, "jjyibs" /*cc02*/, "jjyis" /*cc03*/, "jjyiss" /*cc04*/, "jjying" /*cc05*/, "jjyij" /*cc06*/, "jjyic" /*cc07*/, "jjyik" /*cc08*/, "jjyit" /*cc09*/, "jjyip" /*cc0a*/, "jjyih" /*cc0b*/, "jji" /*cc0c*/, "jjig" /*cc0d*/, "jjigg" /*cc0e*/, "jjigs" /*cc0f*/, "jjin" /*cc10*/, "jjinj" /*cc11*/, "jjinh" /*cc12*/, "jjid" /*cc13*/, "jjil" /*cc14*/, "jjilg" /*cc15*/, "jjilm" /*cc16*/, "jjilb" /*cc17*/, "jjils" /*cc18*/, "jjilt" /*cc19*/, "jjilp" /*cc1a*/, "jjilh" /*cc1b*/, "jjim" /*cc1c*/, "jjib" /*cc1d*/, "jjibs" /*cc1e*/, "jjis" /*cc1f*/, "jjiss" /*cc20*/, "jjing" /*cc21*/, "jjij" /*cc22*/, "jjic" /*cc23*/, "jjik" /*cc24*/, "jjit" /*cc25*/, "jjip" /*cc26*/, "jjih" /*cc27*/, "ca" /*cc28*/, "cag" /*cc29*/, "cagg" /*cc2a*/, "cags" /*cc2b*/, "can" /*cc2c*/, "canj" /*cc2d*/, "canh" /*cc2e*/, "cad" /*cc2f*/, "cal" /*cc30*/, "calg" /*cc31*/, "calm" /*cc32*/, "calb" /*cc33*/, "cals" /*cc34*/, "calt" /*cc35*/, "calp" /*cc36*/, "calh" /*cc37*/, "cam" /*cc38*/, "cab" /*cc39*/, "cabs" /*cc3a*/, "cas" /*cc3b*/, "cass" /*cc3c*/, "cang" /*cc3d*/, "caj" /*cc3e*/, "cac" /*cc3f*/, "cak" /*cc40*/, "cat" /*cc41*/, "cap" /*cc42*/, "cah" /*cc43*/, "cae" /*cc44*/, "caeg" /*cc45*/, "caegg" /*cc46*/, "caegs" /*cc47*/, "caen" /*cc48*/, "caenj" /*cc49*/, "caenh" /*cc4a*/, "caed" /*cc4b*/, "cael" /*cc4c*/, "caelg" /*cc4d*/, "caelm" /*cc4e*/, "caelb" /*cc4f*/, "caels" /*cc50*/, "caelt" /*cc51*/, "caelp" /*cc52*/, "caelh" /*cc53*/, "caem" /*cc54*/, "caeb" /*cc55*/, "caebs" /*cc56*/, "caes" /*cc57*/, "caess" /*cc58*/, "caeng" /*cc59*/, "caej" /*cc5a*/, "caec" /*cc5b*/, "caek" /*cc5c*/, "caet" /*cc5d*/, "caep" /*cc5e*/, "caeh" /*cc5f*/, "cya" /*cc60*/, "cyag" /*cc61*/, "cyagg" /*cc62*/, "cyags" /*cc63*/, "cyan" /*cc64*/, "cyanj" /*cc65*/, "cyanh" /*cc66*/, "cyad" /*cc67*/, "cyal" /*cc68*/, "cyalg" /*cc69*/, "cyalm" /*cc6a*/, "cyalb" /*cc6b*/, "cyals" /*cc6c*/, "cyalt" /*cc6d*/, "cyalp" /*cc6e*/, "cyalh" /*cc6f*/, "cyam" /*cc70*/, "cyab" /*cc71*/, "cyabs" /*cc72*/, "cyas" /*cc73*/, "cyass" /*cc74*/, "cyang" /*cc75*/, "cyaj" /*cc76*/, "cyac" /*cc77*/, "cyak" /*cc78*/, "cyat" /*cc79*/, "cyap" /*cc7a*/, "cyah" /*cc7b*/, "cyae" /*cc7c*/, "cyaeg" /*cc7d*/, "cyaegg" /*cc7e*/, "cyaegs" /*cc7f*/, "cyaen" /*cc80*/, "cyaenj" /*cc81*/, "cyaenh" /*cc82*/, "cyaed" /*cc83*/, "cyael" /*cc84*/, "cyaelg" /*cc85*/, "cyaelm" /*cc86*/, "cyaelb" /*cc87*/, "cyaels" /*cc88*/, "cyaelt" /*cc89*/, "cyaelp" /*cc8a*/, "cyaelh" /*cc8b*/, "cyaem" /*cc8c*/, "cyaeb" /*cc8d*/, "cyaebs" /*cc8e*/, "cyaes" /*cc8f*/, "cyaess" /*cc90*/, "cyaeng" /*cc91*/, "cyaej" /*cc92*/, "cyaec" /*cc93*/, "cyaek" /*cc94*/, "cyaet" /*cc95*/, "cyaep" /*cc96*/, "cyaeh" /*cc97*/, "ceo" /*cc98*/, "ceog" /*cc99*/, "ceogg" /*cc9a*/, "ceogs" /*cc9b*/, "ceon" /*cc9c*/, "ceonj" /*cc9d*/, "ceonh" /*cc9e*/, "ceod" /*cc9f*/, "ceol" /*cca0*/, "ceolg" /*cca1*/, "ceolm" /*cca2*/, "ceolb" /*cca3*/, "ceols" /*cca4*/, "ceolt" /*cca5*/, "ceolp" /*cca6*/, "ceolh" /*cca7*/, "ceom" /*cca8*/, "ceob" /*cca9*/, "ceobs" /*ccaa*/, "ceos" /*ccab*/, "ceoss" /*ccac*/, "ceong" /*ccad*/, "ceoj" /*ccae*/, "ceoc" /*ccaf*/, "ceok" /*ccb0*/, "ceot" /*ccb1*/, "ceop" /*ccb2*/, "ceoh" /*ccb3*/, "ce" /*ccb4*/, "ceg" /*ccb5*/, "cegg" /*ccb6*/, "cegs" /*ccb7*/, "cen" /*ccb8*/, "cenj" /*ccb9*/, "cenh" /*ccba*/, "ced" /*ccbb*/, "cel" /*ccbc*/, "celg" /*ccbd*/, "celm" /*ccbe*/, "celb" /*ccbf*/, "cels" /*ccc0*/, "celt" /*ccc1*/, "celp" /*ccc2*/, "celh" /*ccc3*/, "cem" /*ccc4*/, "ceb" /*ccc5*/, "cebs" /*ccc6*/, "ces" /*ccc7*/, "cess" /*ccc8*/, "ceng" /*ccc9*/, "cej" /*ccca*/, "cec" /*cccb*/, "cek" /*cccc*/, "cet" /*cccd*/, "cep" /*ccce*/, "ceh" /*cccf*/, "cyeo" /*ccd0*/, "cyeog" /*ccd1*/, "cyeogg" /*ccd2*/, "cyeogs" /*ccd3*/, "cyeon" /*ccd4*/, "cyeonj" /*ccd5*/, "cyeonh" /*ccd6*/, "cyeod" /*ccd7*/, "cyeol" /*ccd8*/, "cyeolg" /*ccd9*/, "cyeolm" /*ccda*/, "cyeolb" /*ccdb*/, "cyeols" /*ccdc*/, "cyeolt" /*ccdd*/, "cyeolp" /*ccde*/, "cyeolh" /*ccdf*/, "cyeom" /*cce0*/, "cyeob" /*cce1*/, "cyeobs" /*cce2*/, "cyeos" /*cce3*/, "cyeoss" /*cce4*/, "cyeong" /*cce5*/, "cyeoj" /*cce6*/, "cyeoc" /*cce7*/, "cyeok" /*cce8*/, "cyeot" /*cce9*/, "cyeop" /*ccea*/, "cyeoh" /*cceb*/, "cye" /*ccec*/, "cyeg" /*cced*/, "cyegg" /*ccee*/, "cyegs" /*ccef*/, "cyen" /*ccf0*/, "cyenj" /*ccf1*/, "cyenh" /*ccf2*/, "cyed" /*ccf3*/, "cyel" /*ccf4*/, "cyelg" /*ccf5*/, "cyelm" /*ccf6*/, "cyelb" /*ccf7*/, "cyels" /*ccf8*/, "cyelt" /*ccf9*/, "cyelp" /*ccfa*/, "cyelh" /*ccfb*/, "cyem" /*ccfc*/, "cyeb" /*ccfd*/, "cyebs" /*ccfe*/, "cyes" /*ccff*/ 
			});
						characters.TryAdd(205 /*52480 cd*/, new string[] {
				"cyess" /*cd00*/, "cyeng" /*cd01*/, "cyej" /*cd02*/, "cyec" /*cd03*/, "cyek" /*cd04*/, "cyet" /*cd05*/, "cyep" /*cd06*/, "cyeh" /*cd07*/, "co" /*cd08*/, "cog" /*cd09*/, "cogg" /*cd0a*/, "cogs" /*cd0b*/, "con" /*cd0c*/, "conj" /*cd0d*/, "conh" /*cd0e*/, "cod" /*cd0f*/, "col" /*cd10*/, "colg" /*cd11*/, "colm" /*cd12*/, "colb" /*cd13*/, "cols" /*cd14*/, "colt" /*cd15*/, "colp" /*cd16*/, "colh" /*cd17*/, "com" /*cd18*/, "cob" /*cd19*/, "cobs" /*cd1a*/, "cos" /*cd1b*/, "coss" /*cd1c*/, "cong" /*cd1d*/, "coj" /*cd1e*/, "coc" /*cd1f*/, "cok" /*cd20*/, "cot" /*cd21*/, "cop" /*cd22*/, "coh" /*cd23*/, "cwa" /*cd24*/, "cwag" /*cd25*/, "cwagg" /*cd26*/, "cwags" /*cd27*/, "cwan" /*cd28*/, "cwanj" /*cd29*/, "cwanh" /*cd2a*/, "cwad" /*cd2b*/, "cwal" /*cd2c*/, "cwalg" /*cd2d*/, "cwalm" /*cd2e*/, "cwalb" /*cd2f*/, "cwals" /*cd30*/, "cwalt" /*cd31*/, "cwalp" /*cd32*/, "cwalh" /*cd33*/, "cwam" /*cd34*/, "cwab" /*cd35*/, "cwabs" /*cd36*/, "cwas" /*cd37*/, "cwass" /*cd38*/, "cwang" /*cd39*/, "cwaj" /*cd3a*/, "cwac" /*cd3b*/, "cwak" /*cd3c*/, "cwat" /*cd3d*/, "cwap" /*cd3e*/, "cwah" /*cd3f*/, "cwae" /*cd40*/, "cwaeg" /*cd41*/, "cwaegg" /*cd42*/, "cwaegs" /*cd43*/, "cwaen" /*cd44*/, "cwaenj" /*cd45*/, "cwaenh" /*cd46*/, "cwaed" /*cd47*/, "cwael" /*cd48*/, "cwaelg" /*cd49*/, "cwaelm" /*cd4a*/, "cwaelb" /*cd4b*/, "cwaels" /*cd4c*/, "cwaelt" /*cd4d*/, "cwaelp" /*cd4e*/, "cwaelh" /*cd4f*/, "cwaem" /*cd50*/, "cwaeb" /*cd51*/, "cwaebs" /*cd52*/, "cwaes" /*cd53*/, "cwaess" /*cd54*/, "cwaeng" /*cd55*/, "cwaej" /*cd56*/, "cwaec" /*cd57*/, "cwaek" /*cd58*/, "cwaet" /*cd59*/, "cwaep" /*cd5a*/, "cwaeh" /*cd5b*/, "coe" /*cd5c*/, "coeg" /*cd5d*/, "coegg" /*cd5e*/, "coegs" /*cd5f*/, "coen" /*cd60*/, "coenj" /*cd61*/, "coenh" /*cd62*/, "coed" /*cd63*/, "coel" /*cd64*/, "coelg" /*cd65*/, "coelm" /*cd66*/, "coelb" /*cd67*/, "coels" /*cd68*/, "coelt" /*cd69*/, "coelp" /*cd6a*/, "coelh" /*cd6b*/, "coem" /*cd6c*/, "coeb" /*cd6d*/, "coebs" /*cd6e*/, "coes" /*cd6f*/, "coess" /*cd70*/, "coeng" /*cd71*/, "coej" /*cd72*/, "coec" /*cd73*/, "coek" /*cd74*/, "coet" /*cd75*/, "coep" /*cd76*/, "coeh" /*cd77*/, "cyo" /*cd78*/, "cyog" /*cd79*/, "cyogg" /*cd7a*/, "cyogs" /*cd7b*/, "cyon" /*cd7c*/, "cyonj" /*cd7d*/, "cyonh" /*cd7e*/, "cyod" /*cd7f*/, "cyol" /*cd80*/, "cyolg" /*cd81*/, "cyolm" /*cd82*/, "cyolb" /*cd83*/, "cyols" /*cd84*/, "cyolt" /*cd85*/, "cyolp" /*cd86*/, "cyolh" /*cd87*/, "cyom" /*cd88*/, "cyob" /*cd89*/, "cyobs" /*cd8a*/, "cyos" /*cd8b*/, "cyoss" /*cd8c*/, "cyong" /*cd8d*/, "cyoj" /*cd8e*/, "cyoc" /*cd8f*/, "cyok" /*cd90*/, "cyot" /*cd91*/, "cyop" /*cd92*/, "cyoh" /*cd93*/, "cu" /*cd94*/, "cug" /*cd95*/, "cugg" /*cd96*/, "cugs" /*cd97*/, "cun" /*cd98*/, "cunj" /*cd99*/, "cunh" /*cd9a*/, "cud" /*cd9b*/, "cul" /*cd9c*/, "culg" /*cd9d*/, "culm" /*cd9e*/, "culb" /*cd9f*/, "culs" /*cda0*/, "cult" /*cda1*/, "culp" /*cda2*/, "culh" /*cda3*/, "cum" /*cda4*/, "cub" /*cda5*/, "cubs" /*cda6*/, "cus" /*cda7*/, "cuss" /*cda8*/, "cung" /*cda9*/, "cuj" /*cdaa*/, "cuc" /*cdab*/, "cuk" /*cdac*/, "cut" /*cdad*/, "cup" /*cdae*/, "cuh" /*cdaf*/, "cweo" /*cdb0*/, "cweog" /*cdb1*/, "cweogg" /*cdb2*/, "cweogs" /*cdb3*/, "cweon" /*cdb4*/, "cweonj" /*cdb5*/, "cweonh" /*cdb6*/, "cweod" /*cdb7*/, "cweol" /*cdb8*/, "cweolg" /*cdb9*/, "cweolm" /*cdba*/, "cweolb" /*cdbb*/, "cweols" /*cdbc*/, "cweolt" /*cdbd*/, "cweolp" /*cdbe*/, "cweolh" /*cdbf*/, "cweom" /*cdc0*/, "cweob" /*cdc1*/, "cweobs" /*cdc2*/, "cweos" /*cdc3*/, "cweoss" /*cdc4*/, "cweong" /*cdc5*/, "cweoj" /*cdc6*/, "cweoc" /*cdc7*/, "cweok" /*cdc8*/, "cweot" /*cdc9*/, "cweop" /*cdca*/, "cweoh" /*cdcb*/, "cwe" /*cdcc*/, "cweg" /*cdcd*/, "cwegg" /*cdce*/, "cwegs" /*cdcf*/, "cwen" /*cdd0*/, "cwenj" /*cdd1*/, "cwenh" /*cdd2*/, "cwed" /*cdd3*/, "cwel" /*cdd4*/, "cwelg" /*cdd5*/, "cwelm" /*cdd6*/, "cwelb" /*cdd7*/, "cwels" /*cdd8*/, "cwelt" /*cdd9*/, "cwelp" /*cdda*/, "cwelh" /*cddb*/, "cwem" /*cddc*/, "cweb" /*cddd*/, "cwebs" /*cdde*/, "cwes" /*cddf*/, "cwess" /*cde0*/, "cweng" /*cde1*/, "cwej" /*cde2*/, "cwec" /*cde3*/, "cwek" /*cde4*/, "cwet" /*cde5*/, "cwep" /*cde6*/, "cweh" /*cde7*/, "cwi" /*cde8*/, "cwig" /*cde9*/, "cwigg" /*cdea*/, "cwigs" /*cdeb*/, "cwin" /*cdec*/, "cwinj" /*cded*/, "cwinh" /*cdee*/, "cwid" /*cdef*/, "cwil" /*cdf0*/, "cwilg" /*cdf1*/, "cwilm" /*cdf2*/, "cwilb" /*cdf3*/, "cwils" /*cdf4*/, "cwilt" /*cdf5*/, "cwilp" /*cdf6*/, "cwilh" /*cdf7*/, "cwim" /*cdf8*/, "cwib" /*cdf9*/, "cwibs" /*cdfa*/, "cwis" /*cdfb*/, "cwiss" /*cdfc*/, "cwing" /*cdfd*/, "cwij" /*cdfe*/, "cwic" /*cdff*/ 
			});
						characters.TryAdd(206 /*52736 ce*/, new string[] {
				"cwik" /*ce00*/, "cwit" /*ce01*/, "cwip" /*ce02*/, "cwih" /*ce03*/, "cyu" /*ce04*/, "cyug" /*ce05*/, "cyugg" /*ce06*/, "cyugs" /*ce07*/, "cyun" /*ce08*/, "cyunj" /*ce09*/, "cyunh" /*ce0a*/, "cyud" /*ce0b*/, "cyul" /*ce0c*/, "cyulg" /*ce0d*/, "cyulm" /*ce0e*/, "cyulb" /*ce0f*/, "cyuls" /*ce10*/, "cyult" /*ce11*/, "cyulp" /*ce12*/, "cyulh" /*ce13*/, "cyum" /*ce14*/, "cyub" /*ce15*/, "cyubs" /*ce16*/, "cyus" /*ce17*/, "cyuss" /*ce18*/, "cyung" /*ce19*/, "cyuj" /*ce1a*/, "cyuc" /*ce1b*/, "cyuk" /*ce1c*/, "cyut" /*ce1d*/, "cyup" /*ce1e*/, "cyuh" /*ce1f*/, "ceu" /*ce20*/, "ceug" /*ce21*/, "ceugg" /*ce22*/, "ceugs" /*ce23*/, "ceun" /*ce24*/, "ceunj" /*ce25*/, "ceunh" /*ce26*/, "ceud" /*ce27*/, "ceul" /*ce28*/, "ceulg" /*ce29*/, "ceulm" /*ce2a*/, "ceulb" /*ce2b*/, "ceuls" /*ce2c*/, "ceult" /*ce2d*/, "ceulp" /*ce2e*/, "ceulh" /*ce2f*/, "ceum" /*ce30*/, "ceub" /*ce31*/, "ceubs" /*ce32*/, "ceus" /*ce33*/, "ceuss" /*ce34*/, "ceung" /*ce35*/, "ceuj" /*ce36*/, "ceuc" /*ce37*/, "ceuk" /*ce38*/, "ceut" /*ce39*/, "ceup" /*ce3a*/, "ceuh" /*ce3b*/, "cyi" /*ce3c*/, "cyig" /*ce3d*/, "cyigg" /*ce3e*/, "cyigs" /*ce3f*/, "cyin" /*ce40*/, "cyinj" /*ce41*/, "cyinh" /*ce42*/, "cyid" /*ce43*/, "cyil" /*ce44*/, "cyilg" /*ce45*/, "cyilm" /*ce46*/, "cyilb" /*ce47*/, "cyils" /*ce48*/, "cyilt" /*ce49*/, "cyilp" /*ce4a*/, "cyilh" /*ce4b*/, "cyim" /*ce4c*/, "cyib" /*ce4d*/, "cyibs" /*ce4e*/, "cyis" /*ce4f*/, "cyiss" /*ce50*/, "cying" /*ce51*/, "cyij" /*ce52*/, "cyic" /*ce53*/, "cyik" /*ce54*/, "cyit" /*ce55*/, "cyip" /*ce56*/, "cyih" /*ce57*/, "ci" /*ce58*/, "cig" /*ce59*/, "cigg" /*ce5a*/, "cigs" /*ce5b*/, "cin" /*ce5c*/, "cinj" /*ce5d*/, "cinh" /*ce5e*/, "cid" /*ce5f*/, "cil" /*ce60*/, "cilg" /*ce61*/, "cilm" /*ce62*/, "cilb" /*ce63*/, "cils" /*ce64*/, "cilt" /*ce65*/, "cilp" /*ce66*/, "cilh" /*ce67*/, "cim" /*ce68*/, "cib" /*ce69*/, "cibs" /*ce6a*/, "cis" /*ce6b*/, "ciss" /*ce6c*/, "cing" /*ce6d*/, "cij" /*ce6e*/, "cic" /*ce6f*/, "cik" /*ce70*/, "cit" /*ce71*/, "cip" /*ce72*/, "cih" /*ce73*/, "ka" /*ce74*/, "kag" /*ce75*/, "kagg" /*ce76*/, "kags" /*ce77*/, "kan" /*ce78*/, "kanj" /*ce79*/, "kanh" /*ce7a*/, "kad" /*ce7b*/, "kal" /*ce7c*/, "kalg" /*ce7d*/, "kalm" /*ce7e*/, "kalb" /*ce7f*/, "kals" /*ce80*/, "kalt" /*ce81*/, "kalp" /*ce82*/, "kalh" /*ce83*/, "kam" /*ce84*/, "kab" /*ce85*/, "kabs" /*ce86*/, "kas" /*ce87*/, "kass" /*ce88*/, "kang" /*ce89*/, "kaj" /*ce8a*/, "kac" /*ce8b*/, "kak" /*ce8c*/, "kat" /*ce8d*/, "kap" /*ce8e*/, "kah" /*ce8f*/, "kae" /*ce90*/, "kaeg" /*ce91*/, "kaegg" /*ce92*/, "kaegs" /*ce93*/, "kaen" /*ce94*/, "kaenj" /*ce95*/, "kaenh" /*ce96*/, "kaed" /*ce97*/, "kael" /*ce98*/, "kaelg" /*ce99*/, "kaelm" /*ce9a*/, "kaelb" /*ce9b*/, "kaels" /*ce9c*/, "kaelt" /*ce9d*/, "kaelp" /*ce9e*/, "kaelh" /*ce9f*/, "kaem" /*cea0*/, "kaeb" /*cea1*/, "kaebs" /*cea2*/, "kaes" /*cea3*/, "kaess" /*cea4*/, "kaeng" /*cea5*/, "kaej" /*cea6*/, "kaec" /*cea7*/, "kaek" /*cea8*/, "kaet" /*cea9*/, "kaep" /*ceaa*/, "kaeh" /*ceab*/, "kya" /*ceac*/, "kyag" /*cead*/, "kyagg" /*ceae*/, "kyags" /*ceaf*/, "kyan" /*ceb0*/, "kyanj" /*ceb1*/, "kyanh" /*ceb2*/, "kyad" /*ceb3*/, "kyal" /*ceb4*/, "kyalg" /*ceb5*/, "kyalm" /*ceb6*/, "kyalb" /*ceb7*/, "kyals" /*ceb8*/, "kyalt" /*ceb9*/, "kyalp" /*ceba*/, "kyalh" /*cebb*/, "kyam" /*cebc*/, "kyab" /*cebd*/, "kyabs" /*cebe*/, "kyas" /*cebf*/, "kyass" /*cec0*/, "kyang" /*cec1*/, "kyaj" /*cec2*/, "kyac" /*cec3*/, "kyak" /*cec4*/, "kyat" /*cec5*/, "kyap" /*cec6*/, "kyah" /*cec7*/, "kyae" /*cec8*/, "kyaeg" /*cec9*/, "kyaegg" /*ceca*/, "kyaegs" /*cecb*/, "kyaen" /*cecc*/, "kyaenj" /*cecd*/, "kyaenh" /*cece*/, "kyaed" /*cecf*/, "kyael" /*ced0*/, "kyaelg" /*ced1*/, "kyaelm" /*ced2*/, "kyaelb" /*ced3*/, "kyaels" /*ced4*/, "kyaelt" /*ced5*/, "kyaelp" /*ced6*/, "kyaelh" /*ced7*/, "kyaem" /*ced8*/, "kyaeb" /*ced9*/, "kyaebs" /*ceda*/, "kyaes" /*cedb*/, "kyaess" /*cedc*/, "kyaeng" /*cedd*/, "kyaej" /*cede*/, "kyaec" /*cedf*/, "kyaek" /*cee0*/, "kyaet" /*cee1*/, "kyaep" /*cee2*/, "kyaeh" /*cee3*/, "keo" /*cee4*/, "keog" /*cee5*/, "keogg" /*cee6*/, "keogs" /*cee7*/, "keon" /*cee8*/, "keonj" /*cee9*/, "keonh" /*ceea*/, "keod" /*ceeb*/, "keol" /*ceec*/, "keolg" /*ceed*/, "keolm" /*ceee*/, "keolb" /*ceef*/, "keols" /*cef0*/, "keolt" /*cef1*/, "keolp" /*cef2*/, "keolh" /*cef3*/, "keom" /*cef4*/, "keob" /*cef5*/, "keobs" /*cef6*/, "keos" /*cef7*/, "keoss" /*cef8*/, "keong" /*cef9*/, "keoj" /*cefa*/, "keoc" /*cefb*/, "keok" /*cefc*/, "keot" /*cefd*/, "keop" /*cefe*/, "keoh" /*ceff*/ 
			});
						characters.TryAdd(207 /*52992 cf*/, new string[] {
				"ke" /*cf00*/, "keg" /*cf01*/, "kegg" /*cf02*/, "kegs" /*cf03*/, "ken" /*cf04*/, "kenj" /*cf05*/, "kenh" /*cf06*/, "ked" /*cf07*/, "kel" /*cf08*/, "kelg" /*cf09*/, "kelm" /*cf0a*/, "kelb" /*cf0b*/, "kels" /*cf0c*/, "kelt" /*cf0d*/, "kelp" /*cf0e*/, "kelh" /*cf0f*/, "kem" /*cf10*/, "keb" /*cf11*/, "kebs" /*cf12*/, "kes" /*cf13*/, "kess" /*cf14*/, "keng" /*cf15*/, "kej" /*cf16*/, "kec" /*cf17*/, "kek" /*cf18*/, "ket" /*cf19*/, "kep" /*cf1a*/, "keh" /*cf1b*/, "kyeo" /*cf1c*/, "kyeog" /*cf1d*/, "kyeogg" /*cf1e*/, "kyeogs" /*cf1f*/, "kyeon" /*cf20*/, "kyeonj" /*cf21*/, "kyeonh" /*cf22*/, "kyeod" /*cf23*/, "kyeol" /*cf24*/, "kyeolg" /*cf25*/, "kyeolm" /*cf26*/, "kyeolb" /*cf27*/, "kyeols" /*cf28*/, "kyeolt" /*cf29*/, "kyeolp" /*cf2a*/, "kyeolh" /*cf2b*/, "kyeom" /*cf2c*/, "kyeob" /*cf2d*/, "kyeobs" /*cf2e*/, "kyeos" /*cf2f*/, "kyeoss" /*cf30*/, "kyeong" /*cf31*/, "kyeoj" /*cf32*/, "kyeoc" /*cf33*/, "kyeok" /*cf34*/, "kyeot" /*cf35*/, "kyeop" /*cf36*/, "kyeoh" /*cf37*/, "kye" /*cf38*/, "kyeg" /*cf39*/, "kyegg" /*cf3a*/, "kyegs" /*cf3b*/, "kyen" /*cf3c*/, "kyenj" /*cf3d*/, "kyenh" /*cf3e*/, "kyed" /*cf3f*/, "kyel" /*cf40*/, "kyelg" /*cf41*/, "kyelm" /*cf42*/, "kyelb" /*cf43*/, "kyels" /*cf44*/, "kyelt" /*cf45*/, "kyelp" /*cf46*/, "kyelh" /*cf47*/, "kyem" /*cf48*/, "kyeb" /*cf49*/, "kyebs" /*cf4a*/, "kyes" /*cf4b*/, "kyess" /*cf4c*/, "kyeng" /*cf4d*/, "kyej" /*cf4e*/, "kyec" /*cf4f*/, "kyek" /*cf50*/, "kyet" /*cf51*/, "kyep" /*cf52*/, "kyeh" /*cf53*/, "ko" /*cf54*/, "kog" /*cf55*/, "kogg" /*cf56*/, "kogs" /*cf57*/, "kon" /*cf58*/, "konj" /*cf59*/, "konh" /*cf5a*/, "kod" /*cf5b*/, "kol" /*cf5c*/, "kolg" /*cf5d*/, "kolm" /*cf5e*/, "kolb" /*cf5f*/, "kols" /*cf60*/, "kolt" /*cf61*/, "kolp" /*cf62*/, "kolh" /*cf63*/, "kom" /*cf64*/, "kob" /*cf65*/, "kobs" /*cf66*/, "kos" /*cf67*/, "koss" /*cf68*/, "kong" /*cf69*/, "koj" /*cf6a*/, "koc" /*cf6b*/, "kok" /*cf6c*/, "kot" /*cf6d*/, "kop" /*cf6e*/, "koh" /*cf6f*/, "kwa" /*cf70*/, "kwag" /*cf71*/, "kwagg" /*cf72*/, "kwags" /*cf73*/, "kwan" /*cf74*/, "kwanj" /*cf75*/, "kwanh" /*cf76*/, "kwad" /*cf77*/, "kwal" /*cf78*/, "kwalg" /*cf79*/, "kwalm" /*cf7a*/, "kwalb" /*cf7b*/, "kwals" /*cf7c*/, "kwalt" /*cf7d*/, "kwalp" /*cf7e*/, "kwalh" /*cf7f*/, "kwam" /*cf80*/, "kwab" /*cf81*/, "kwabs" /*cf82*/, "kwas" /*cf83*/, "kwass" /*cf84*/, "kwang" /*cf85*/, "kwaj" /*cf86*/, "kwac" /*cf87*/, "kwak" /*cf88*/, "kwat" /*cf89*/, "kwap" /*cf8a*/, "kwah" /*cf8b*/, "kwae" /*cf8c*/, "kwaeg" /*cf8d*/, "kwaegg" /*cf8e*/, "kwaegs" /*cf8f*/, "kwaen" /*cf90*/, "kwaenj" /*cf91*/, "kwaenh" /*cf92*/, "kwaed" /*cf93*/, "kwael" /*cf94*/, "kwaelg" /*cf95*/, "kwaelm" /*cf96*/, "kwaelb" /*cf97*/, "kwaels" /*cf98*/, "kwaelt" /*cf99*/, "kwaelp" /*cf9a*/, "kwaelh" /*cf9b*/, "kwaem" /*cf9c*/, "kwaeb" /*cf9d*/, "kwaebs" /*cf9e*/, "kwaes" /*cf9f*/, "kwaess" /*cfa0*/, "kwaeng" /*cfa1*/, "kwaej" /*cfa2*/, "kwaec" /*cfa3*/, "kwaek" /*cfa4*/, "kwaet" /*cfa5*/, "kwaep" /*cfa6*/, "kwaeh" /*cfa7*/, "koe" /*cfa8*/, "koeg" /*cfa9*/, "koegg" /*cfaa*/, "koegs" /*cfab*/, "koen" /*cfac*/, "koenj" /*cfad*/, "koenh" /*cfae*/, "koed" /*cfaf*/, "koel" /*cfb0*/, "koelg" /*cfb1*/, "koelm" /*cfb2*/, "koelb" /*cfb3*/, "koels" /*cfb4*/, "koelt" /*cfb5*/, "koelp" /*cfb6*/, "koelh" /*cfb7*/, "koem" /*cfb8*/, "koeb" /*cfb9*/, "koebs" /*cfba*/, "koes" /*cfbb*/, "koess" /*cfbc*/, "koeng" /*cfbd*/, "koej" /*cfbe*/, "koec" /*cfbf*/, "koek" /*cfc0*/, "koet" /*cfc1*/, "koep" /*cfc2*/, "koeh" /*cfc3*/, "kyo" /*cfc4*/, "kyog" /*cfc5*/, "kyogg" /*cfc6*/, "kyogs" /*cfc7*/, "kyon" /*cfc8*/, "kyonj" /*cfc9*/, "kyonh" /*cfca*/, "kyod" /*cfcb*/, "kyol" /*cfcc*/, "kyolg" /*cfcd*/, "kyolm" /*cfce*/, "kyolb" /*cfcf*/, "kyols" /*cfd0*/, "kyolt" /*cfd1*/, "kyolp" /*cfd2*/, "kyolh" /*cfd3*/, "kyom" /*cfd4*/, "kyob" /*cfd5*/, "kyobs" /*cfd6*/, "kyos" /*cfd7*/, "kyoss" /*cfd8*/, "kyong" /*cfd9*/, "kyoj" /*cfda*/, "kyoc" /*cfdb*/, "kyok" /*cfdc*/, "kyot" /*cfdd*/, "kyop" /*cfde*/, "kyoh" /*cfdf*/, "ku" /*cfe0*/, "kug" /*cfe1*/, "kugg" /*cfe2*/, "kugs" /*cfe3*/, "kun" /*cfe4*/, "kunj" /*cfe5*/, "kunh" /*cfe6*/, "kud" /*cfe7*/, "kul" /*cfe8*/, "kulg" /*cfe9*/, "kulm" /*cfea*/, "kulb" /*cfeb*/, "kuls" /*cfec*/, "kult" /*cfed*/, "kulp" /*cfee*/, "kulh" /*cfef*/, "kum" /*cff0*/, "kub" /*cff1*/, "kubs" /*cff2*/, "kus" /*cff3*/, "kuss" /*cff4*/, "kung" /*cff5*/, "kuj" /*cff6*/, "kuc" /*cff7*/, "kuk" /*cff8*/, "kut" /*cff9*/, "kup" /*cffa*/, "kuh" /*cffb*/, "kweo" /*cffc*/, "kweog" /*cffd*/, "kweogg" /*cffe*/, "kweogs" /*cfff*/ 
			});
						characters.TryAdd(208 /*53248 d0*/, new string[] {
				"kweon" /*d000*/, "kweonj" /*d001*/, "kweonh" /*d002*/, "kweod" /*d003*/, "kweol" /*d004*/, "kweolg" /*d005*/, "kweolm" /*d006*/, "kweolb" /*d007*/, "kweols" /*d008*/, "kweolt" /*d009*/, "kweolp" /*d00a*/, "kweolh" /*d00b*/, "kweom" /*d00c*/, "kweob" /*d00d*/, "kweobs" /*d00e*/, "kweos" /*d00f*/, "kweoss" /*d010*/, "kweong" /*d011*/, "kweoj" /*d012*/, "kweoc" /*d013*/, "kweok" /*d014*/, "kweot" /*d015*/, "kweop" /*d016*/, "kweoh" /*d017*/, "kwe" /*d018*/, "kweg" /*d019*/, "kwegg" /*d01a*/, "kwegs" /*d01b*/, "kwen" /*d01c*/, "kwenj" /*d01d*/, "kwenh" /*d01e*/, "kwed" /*d01f*/, "kwel" /*d020*/, "kwelg" /*d021*/, "kwelm" /*d022*/, "kwelb" /*d023*/, "kwels" /*d024*/, "kwelt" /*d025*/, "kwelp" /*d026*/, "kwelh" /*d027*/, "kwem" /*d028*/, "kweb" /*d029*/, "kwebs" /*d02a*/, "kwes" /*d02b*/, "kwess" /*d02c*/, "kweng" /*d02d*/, "kwej" /*d02e*/, "kwec" /*d02f*/, "kwek" /*d030*/, "kwet" /*d031*/, "kwep" /*d032*/, "kweh" /*d033*/, "kwi" /*d034*/, "kwig" /*d035*/, "kwigg" /*d036*/, "kwigs" /*d037*/, "kwin" /*d038*/, "kwinj" /*d039*/, "kwinh" /*d03a*/, "kwid" /*d03b*/, "kwil" /*d03c*/, "kwilg" /*d03d*/, "kwilm" /*d03e*/, "kwilb" /*d03f*/, "kwils" /*d040*/, "kwilt" /*d041*/, "kwilp" /*d042*/, "kwilh" /*d043*/, "kwim" /*d044*/, "kwib" /*d045*/, "kwibs" /*d046*/, "kwis" /*d047*/, "kwiss" /*d048*/, "kwing" /*d049*/, "kwij" /*d04a*/, "kwic" /*d04b*/, "kwik" /*d04c*/, "kwit" /*d04d*/, "kwip" /*d04e*/, "kwih" /*d04f*/, "kyu" /*d050*/, "kyug" /*d051*/, "kyugg" /*d052*/, "kyugs" /*d053*/, "kyun" /*d054*/, "kyunj" /*d055*/, "kyunh" /*d056*/, "kyud" /*d057*/, "kyul" /*d058*/, "kyulg" /*d059*/, "kyulm" /*d05a*/, "kyulb" /*d05b*/, "kyuls" /*d05c*/, "kyult" /*d05d*/, "kyulp" /*d05e*/, "kyulh" /*d05f*/, "kyum" /*d060*/, "kyub" /*d061*/, "kyubs" /*d062*/, "kyus" /*d063*/, "kyuss" /*d064*/, "kyung" /*d065*/, "kyuj" /*d066*/, "kyuc" /*d067*/, "kyuk" /*d068*/, "kyut" /*d069*/, "kyup" /*d06a*/, "kyuh" /*d06b*/, "keu" /*d06c*/, "keug" /*d06d*/, "keugg" /*d06e*/, "keugs" /*d06f*/, "keun" /*d070*/, "keunj" /*d071*/, "keunh" /*d072*/, "keud" /*d073*/, "keul" /*d074*/, "keulg" /*d075*/, "keulm" /*d076*/, "keulb" /*d077*/, "keuls" /*d078*/, "keult" /*d079*/, "keulp" /*d07a*/, "keulh" /*d07b*/, "keum" /*d07c*/, "keub" /*d07d*/, "keubs" /*d07e*/, "keus" /*d07f*/, "keuss" /*d080*/, "keung" /*d081*/, "keuj" /*d082*/, "keuc" /*d083*/, "keuk" /*d084*/, "keut" /*d085*/, "keup" /*d086*/, "keuh" /*d087*/, "kyi" /*d088*/, "kyig" /*d089*/, "kyigg" /*d08a*/, "kyigs" /*d08b*/, "kyin" /*d08c*/, "kyinj" /*d08d*/, "kyinh" /*d08e*/, "kyid" /*d08f*/, "kyil" /*d090*/, "kyilg" /*d091*/, "kyilm" /*d092*/, "kyilb" /*d093*/, "kyils" /*d094*/, "kyilt" /*d095*/, "kyilp" /*d096*/, "kyilh" /*d097*/, "kyim" /*d098*/, "kyib" /*d099*/, "kyibs" /*d09a*/, "kyis" /*d09b*/, "kyiss" /*d09c*/, "kying" /*d09d*/, "kyij" /*d09e*/, "kyic" /*d09f*/, "kyik" /*d0a0*/, "kyit" /*d0a1*/, "kyip" /*d0a2*/, "kyih" /*d0a3*/, "ki" /*d0a4*/, "kig" /*d0a5*/, "kigg" /*d0a6*/, "kigs" /*d0a7*/, "kin" /*d0a8*/, "kinj" /*d0a9*/, "kinh" /*d0aa*/, "kid" /*d0ab*/, "kil" /*d0ac*/, "kilg" /*d0ad*/, "kilm" /*d0ae*/, "kilb" /*d0af*/, "kils" /*d0b0*/, "kilt" /*d0b1*/, "kilp" /*d0b2*/, "kilh" /*d0b3*/, "kim" /*d0b4*/, "kib" /*d0b5*/, "kibs" /*d0b6*/, "kis" /*d0b7*/, "kiss" /*d0b8*/, "king" /*d0b9*/, "kij" /*d0ba*/, "kic" /*d0bb*/, "kik" /*d0bc*/, "kit" /*d0bd*/, "kip" /*d0be*/, "kih" /*d0bf*/, "ta" /*d0c0*/, "tag" /*d0c1*/, "tagg" /*d0c2*/, "tags" /*d0c3*/, "tan" /*d0c4*/, "tanj" /*d0c5*/, "tanh" /*d0c6*/, "tad" /*d0c7*/, "tal" /*d0c8*/, "talg" /*d0c9*/, "talm" /*d0ca*/, "talb" /*d0cb*/, "tals" /*d0cc*/, "talt" /*d0cd*/, "talp" /*d0ce*/, "talh" /*d0cf*/, "tam" /*d0d0*/, "tab" /*d0d1*/, "tabs" /*d0d2*/, "tas" /*d0d3*/, "tass" /*d0d4*/, "tang" /*d0d5*/, "taj" /*d0d6*/, "tac" /*d0d7*/, "tak" /*d0d8*/, "tat" /*d0d9*/, "tap" /*d0da*/, "tah" /*d0db*/, "tae" /*d0dc*/, "taeg" /*d0dd*/, "taegg" /*d0de*/, "taegs" /*d0df*/, "taen" /*d0e0*/, "taenj" /*d0e1*/, "taenh" /*d0e2*/, "taed" /*d0e3*/, "tael" /*d0e4*/, "taelg" /*d0e5*/, "taelm" /*d0e6*/, "taelb" /*d0e7*/, "taels" /*d0e8*/, "taelt" /*d0e9*/, "taelp" /*d0ea*/, "taelh" /*d0eb*/, "taem" /*d0ec*/, "taeb" /*d0ed*/, "taebs" /*d0ee*/, "taes" /*d0ef*/, "taess" /*d0f0*/, "taeng" /*d0f1*/, "taej" /*d0f2*/, "taec" /*d0f3*/, "taek" /*d0f4*/, "taet" /*d0f5*/, "taep" /*d0f6*/, "taeh" /*d0f7*/, "tya" /*d0f8*/, "tyag" /*d0f9*/, "tyagg" /*d0fa*/, "tyags" /*d0fb*/, "tyan" /*d0fc*/, "tyanj" /*d0fd*/, "tyanh" /*d0fe*/, "tyad" /*d0ff*/ 
			});
						characters.TryAdd(209 /*53504 d1*/, new string[] {
				"tyal" /*d100*/, "tyalg" /*d101*/, "tyalm" /*d102*/, "tyalb" /*d103*/, "tyals" /*d104*/, "tyalt" /*d105*/, "tyalp" /*d106*/, "tyalh" /*d107*/, "tyam" /*d108*/, "tyab" /*d109*/, "tyabs" /*d10a*/, "tyas" /*d10b*/, "tyass" /*d10c*/, "tyang" /*d10d*/, "tyaj" /*d10e*/, "tyac" /*d10f*/, "tyak" /*d110*/, "tyat" /*d111*/, "tyap" /*d112*/, "tyah" /*d113*/, "tyae" /*d114*/, "tyaeg" /*d115*/, "tyaegg" /*d116*/, "tyaegs" /*d117*/, "tyaen" /*d118*/, "tyaenj" /*d119*/, "tyaenh" /*d11a*/, "tyaed" /*d11b*/, "tyael" /*d11c*/, "tyaelg" /*d11d*/, "tyaelm" /*d11e*/, "tyaelb" /*d11f*/, "tyaels" /*d120*/, "tyaelt" /*d121*/, "tyaelp" /*d122*/, "tyaelh" /*d123*/, "tyaem" /*d124*/, "tyaeb" /*d125*/, "tyaebs" /*d126*/, "tyaes" /*d127*/, "tyaess" /*d128*/, "tyaeng" /*d129*/, "tyaej" /*d12a*/, "tyaec" /*d12b*/, "tyaek" /*d12c*/, "tyaet" /*d12d*/, "tyaep" /*d12e*/, "tyaeh" /*d12f*/, "teo" /*d130*/, "teog" /*d131*/, "teogg" /*d132*/, "teogs" /*d133*/, "teon" /*d134*/, "teonj" /*d135*/, "teonh" /*d136*/, "teod" /*d137*/, "teol" /*d138*/, "teolg" /*d139*/, "teolm" /*d13a*/, "teolb" /*d13b*/, "teols" /*d13c*/, "teolt" /*d13d*/, "teolp" /*d13e*/, "teolh" /*d13f*/, "teom" /*d140*/, "teob" /*d141*/, "teobs" /*d142*/, "teos" /*d143*/, "teoss" /*d144*/, "teong" /*d145*/, "teoj" /*d146*/, "teoc" /*d147*/, "teok" /*d148*/, "teot" /*d149*/, "teop" /*d14a*/, "teoh" /*d14b*/, "te" /*d14c*/, "teg" /*d14d*/, "tegg" /*d14e*/, "tegs" /*d14f*/, "ten" /*d150*/, "tenj" /*d151*/, "tenh" /*d152*/, "ted" /*d153*/, "tel" /*d154*/, "telg" /*d155*/, "telm" /*d156*/, "telb" /*d157*/, "tels" /*d158*/, "telt" /*d159*/, "telp" /*d15a*/, "telh" /*d15b*/, "tem" /*d15c*/, "teb" /*d15d*/, "tebs" /*d15e*/, "tes" /*d15f*/, "tess" /*d160*/, "teng" /*d161*/, "tej" /*d162*/, "tec" /*d163*/, "tek" /*d164*/, "tet" /*d165*/, "tep" /*d166*/, "teh" /*d167*/, "tyeo" /*d168*/, "tyeog" /*d169*/, "tyeogg" /*d16a*/, "tyeogs" /*d16b*/, "tyeon" /*d16c*/, "tyeonj" /*d16d*/, "tyeonh" /*d16e*/, "tyeod" /*d16f*/, "tyeol" /*d170*/, "tyeolg" /*d171*/, "tyeolm" /*d172*/, "tyeolb" /*d173*/, "tyeols" /*d174*/, "tyeolt" /*d175*/, "tyeolp" /*d176*/, "tyeolh" /*d177*/, "tyeom" /*d178*/, "tyeob" /*d179*/, "tyeobs" /*d17a*/, "tyeos" /*d17b*/, "tyeoss" /*d17c*/, "tyeong" /*d17d*/, "tyeoj" /*d17e*/, "tyeoc" /*d17f*/, "tyeok" /*d180*/, "tyeot" /*d181*/, "tyeop" /*d182*/, "tyeoh" /*d183*/, "tye" /*d184*/, "tyeg" /*d185*/, "tyegg" /*d186*/, "tyegs" /*d187*/, "tyen" /*d188*/, "tyenj" /*d189*/, "tyenh" /*d18a*/, "tyed" /*d18b*/, "tyel" /*d18c*/, "tyelg" /*d18d*/, "tyelm" /*d18e*/, "tyelb" /*d18f*/, "tyels" /*d190*/, "tyelt" /*d191*/, "tyelp" /*d192*/, "tyelh" /*d193*/, "tyem" /*d194*/, "tyeb" /*d195*/, "tyebs" /*d196*/, "tyes" /*d197*/, "tyess" /*d198*/, "tyeng" /*d199*/, "tyej" /*d19a*/, "tyec" /*d19b*/, "tyek" /*d19c*/, "tyet" /*d19d*/, "tyep" /*d19e*/, "tyeh" /*d19f*/, "to" /*d1a0*/, "tog" /*d1a1*/, "togg" /*d1a2*/, "togs" /*d1a3*/, "ton" /*d1a4*/, "tonj" /*d1a5*/, "tonh" /*d1a6*/, "tod" /*d1a7*/, "tol" /*d1a8*/, "tolg" /*d1a9*/, "tolm" /*d1aa*/, "tolb" /*d1ab*/, "tols" /*d1ac*/, "tolt" /*d1ad*/, "tolp" /*d1ae*/, "tolh" /*d1af*/, "tom" /*d1b0*/, "tob" /*d1b1*/, "tobs" /*d1b2*/, "tos" /*d1b3*/, "toss" /*d1b4*/, "tong" /*d1b5*/, "toj" /*d1b6*/, "toc" /*d1b7*/, "tok" /*d1b8*/, "tot" /*d1b9*/, "top" /*d1ba*/, "toh" /*d1bb*/, "twa" /*d1bc*/, "twag" /*d1bd*/, "twagg" /*d1be*/, "twags" /*d1bf*/, "twan" /*d1c0*/, "twanj" /*d1c1*/, "twanh" /*d1c2*/, "twad" /*d1c3*/, "twal" /*d1c4*/, "twalg" /*d1c5*/, "twalm" /*d1c6*/, "twalb" /*d1c7*/, "twals" /*d1c8*/, "twalt" /*d1c9*/, "twalp" /*d1ca*/, "twalh" /*d1cb*/, "twam" /*d1cc*/, "twab" /*d1cd*/, "twabs" /*d1ce*/, "twas" /*d1cf*/, "twass" /*d1d0*/, "twang" /*d1d1*/, "twaj" /*d1d2*/, "twac" /*d1d3*/, "twak" /*d1d4*/, "twat" /*d1d5*/, "twap" /*d1d6*/, "twah" /*d1d7*/, "twae" /*d1d8*/, "twaeg" /*d1d9*/, "twaegg" /*d1da*/, "twaegs" /*d1db*/, "twaen" /*d1dc*/, "twaenj" /*d1dd*/, "twaenh" /*d1de*/, "twaed" /*d1df*/, "twael" /*d1e0*/, "twaelg" /*d1e1*/, "twaelm" /*d1e2*/, "twaelb" /*d1e3*/, "twaels" /*d1e4*/, "twaelt" /*d1e5*/, "twaelp" /*d1e6*/, "twaelh" /*d1e7*/, "twaem" /*d1e8*/, "twaeb" /*d1e9*/, "twaebs" /*d1ea*/, "twaes" /*d1eb*/, "twaess" /*d1ec*/, "twaeng" /*d1ed*/, "twaej" /*d1ee*/, "twaec" /*d1ef*/, "twaek" /*d1f0*/, "twaet" /*d1f1*/, "twaep" /*d1f2*/, "twaeh" /*d1f3*/, "toe" /*d1f4*/, "toeg" /*d1f5*/, "toegg" /*d1f6*/, "toegs" /*d1f7*/, "toen" /*d1f8*/, "toenj" /*d1f9*/, "toenh" /*d1fa*/, "toed" /*d1fb*/, "toel" /*d1fc*/, "toelg" /*d1fd*/, "toelm" /*d1fe*/, "toelb" /*d1ff*/ 
			});
						characters.TryAdd(210 /*53760 d2*/, new string[] {
				"toels" /*d200*/, "toelt" /*d201*/, "toelp" /*d202*/, "toelh" /*d203*/, "toem" /*d204*/, "toeb" /*d205*/, "toebs" /*d206*/, "toes" /*d207*/, "toess" /*d208*/, "toeng" /*d209*/, "toej" /*d20a*/, "toec" /*d20b*/, "toek" /*d20c*/, "toet" /*d20d*/, "toep" /*d20e*/, "toeh" /*d20f*/, "tyo" /*d210*/, "tyog" /*d211*/, "tyogg" /*d212*/, "tyogs" /*d213*/, "tyon" /*d214*/, "tyonj" /*d215*/, "tyonh" /*d216*/, "tyod" /*d217*/, "tyol" /*d218*/, "tyolg" /*d219*/, "tyolm" /*d21a*/, "tyolb" /*d21b*/, "tyols" /*d21c*/, "tyolt" /*d21d*/, "tyolp" /*d21e*/, "tyolh" /*d21f*/, "tyom" /*d220*/, "tyob" /*d221*/, "tyobs" /*d222*/, "tyos" /*d223*/, "tyoss" /*d224*/, "tyong" /*d225*/, "tyoj" /*d226*/, "tyoc" /*d227*/, "tyok" /*d228*/, "tyot" /*d229*/, "tyop" /*d22a*/, "tyoh" /*d22b*/, "tu" /*d22c*/, "tug" /*d22d*/, "tugg" /*d22e*/, "tugs" /*d22f*/, "tun" /*d230*/, "tunj" /*d231*/, "tunh" /*d232*/, "tud" /*d233*/, "tul" /*d234*/, "tulg" /*d235*/, "tulm" /*d236*/, "tulb" /*d237*/, "tuls" /*d238*/, "tult" /*d239*/, "tulp" /*d23a*/, "tulh" /*d23b*/, "tum" /*d23c*/, "tub" /*d23d*/, "tubs" /*d23e*/, "tus" /*d23f*/, "tuss" /*d240*/, "tung" /*d241*/, "tuj" /*d242*/, "tuc" /*d243*/, "tuk" /*d244*/, "tut" /*d245*/, "tup" /*d246*/, "tuh" /*d247*/, "tweo" /*d248*/, "tweog" /*d249*/, "tweogg" /*d24a*/, "tweogs" /*d24b*/, "tweon" /*d24c*/, "tweonj" /*d24d*/, "tweonh" /*d24e*/, "tweod" /*d24f*/, "tweol" /*d250*/, "tweolg" /*d251*/, "tweolm" /*d252*/, "tweolb" /*d253*/, "tweols" /*d254*/, "tweolt" /*d255*/, "tweolp" /*d256*/, "tweolh" /*d257*/, "tweom" /*d258*/, "tweob" /*d259*/, "tweobs" /*d25a*/, "tweos" /*d25b*/, "tweoss" /*d25c*/, "tweong" /*d25d*/, "tweoj" /*d25e*/, "tweoc" /*d25f*/, "tweok" /*d260*/, "tweot" /*d261*/, "tweop" /*d262*/, "tweoh" /*d263*/, "twe" /*d264*/, "tweg" /*d265*/, "twegg" /*d266*/, "twegs" /*d267*/, "twen" /*d268*/, "twenj" /*d269*/, "twenh" /*d26a*/, "twed" /*d26b*/, "twel" /*d26c*/, "twelg" /*d26d*/, "twelm" /*d26e*/, "twelb" /*d26f*/, "twels" /*d270*/, "twelt" /*d271*/, "twelp" /*d272*/, "twelh" /*d273*/, "twem" /*d274*/, "tweb" /*d275*/, "twebs" /*d276*/, "twes" /*d277*/, "twess" /*d278*/, "tweng" /*d279*/, "twej" /*d27a*/, "twec" /*d27b*/, "twek" /*d27c*/, "twet" /*d27d*/, "twep" /*d27e*/, "tweh" /*d27f*/, "twi" /*d280*/, "twig" /*d281*/, "twigg" /*d282*/, "twigs" /*d283*/, "twin" /*d284*/, "twinj" /*d285*/, "twinh" /*d286*/, "twid" /*d287*/, "twil" /*d288*/, "twilg" /*d289*/, "twilm" /*d28a*/, "twilb" /*d28b*/, "twils" /*d28c*/, "twilt" /*d28d*/, "twilp" /*d28e*/, "twilh" /*d28f*/, "twim" /*d290*/, "twib" /*d291*/, "twibs" /*d292*/, "twis" /*d293*/, "twiss" /*d294*/, "twing" /*d295*/, "twij" /*d296*/, "twic" /*d297*/, "twik" /*d298*/, "twit" /*d299*/, "twip" /*d29a*/, "twih" /*d29b*/, "tyu" /*d29c*/, "tyug" /*d29d*/, "tyugg" /*d29e*/, "tyugs" /*d29f*/, "tyun" /*d2a0*/, "tyunj" /*d2a1*/, "tyunh" /*d2a2*/, "tyud" /*d2a3*/, "tyul" /*d2a4*/, "tyulg" /*d2a5*/, "tyulm" /*d2a6*/, "tyulb" /*d2a7*/, "tyuls" /*d2a8*/, "tyult" /*d2a9*/, "tyulp" /*d2aa*/, "tyulh" /*d2ab*/, "tyum" /*d2ac*/, "tyub" /*d2ad*/, "tyubs" /*d2ae*/, "tyus" /*d2af*/, "tyuss" /*d2b0*/, "tyung" /*d2b1*/, "tyuj" /*d2b2*/, "tyuc" /*d2b3*/, "tyuk" /*d2b4*/, "tyut" /*d2b5*/, "tyup" /*d2b6*/, "tyuh" /*d2b7*/, "teu" /*d2b8*/, "teug" /*d2b9*/, "teugg" /*d2ba*/, "teugs" /*d2bb*/, "teun" /*d2bc*/, "teunj" /*d2bd*/, "teunh" /*d2be*/, "teud" /*d2bf*/, "teul" /*d2c0*/, "teulg" /*d2c1*/, "teulm" /*d2c2*/, "teulb" /*d2c3*/, "teuls" /*d2c4*/, "teult" /*d2c5*/, "teulp" /*d2c6*/, "teulh" /*d2c7*/, "teum" /*d2c8*/, "teub" /*d2c9*/, "teubs" /*d2ca*/, "teus" /*d2cb*/, "teuss" /*d2cc*/, "teung" /*d2cd*/, "teuj" /*d2ce*/, "teuc" /*d2cf*/, "teuk" /*d2d0*/, "teut" /*d2d1*/, "teup" /*d2d2*/, "teuh" /*d2d3*/, "tyi" /*d2d4*/, "tyig" /*d2d5*/, "tyigg" /*d2d6*/, "tyigs" /*d2d7*/, "tyin" /*d2d8*/, "tyinj" /*d2d9*/, "tyinh" /*d2da*/, "tyid" /*d2db*/, "tyil" /*d2dc*/, "tyilg" /*d2dd*/, "tyilm" /*d2de*/, "tyilb" /*d2df*/, "tyils" /*d2e0*/, "tyilt" /*d2e1*/, "tyilp" /*d2e2*/, "tyilh" /*d2e3*/, "tyim" /*d2e4*/, "tyib" /*d2e5*/, "tyibs" /*d2e6*/, "tyis" /*d2e7*/, "tyiss" /*d2e8*/, "tying" /*d2e9*/, "tyij" /*d2ea*/, "tyic" /*d2eb*/, "tyik" /*d2ec*/, "tyit" /*d2ed*/, "tyip" /*d2ee*/, "tyih" /*d2ef*/, "ti" /*d2f0*/, "tig" /*d2f1*/, "tigg" /*d2f2*/, "tigs" /*d2f3*/, "tin" /*d2f4*/, "tinj" /*d2f5*/, "tinh" /*d2f6*/, "tid" /*d2f7*/, "til" /*d2f8*/, "tilg" /*d2f9*/, "tilm" /*d2fa*/, "tilb" /*d2fb*/, "tils" /*d2fc*/, "tilt" /*d2fd*/, "tilp" /*d2fe*/, "tilh" /*d2ff*/ 
			});
						characters.TryAdd(211 /*54016 d3*/, new string[] {
				"tim" /*d300*/, "tib" /*d301*/, "tibs" /*d302*/, "tis" /*d303*/, "tiss" /*d304*/, "ting" /*d305*/, "tij" /*d306*/, "tic" /*d307*/, "tik" /*d308*/, "tit" /*d309*/, "tip" /*d30a*/, "tih" /*d30b*/, "pa" /*d30c*/, "pag" /*d30d*/, "pagg" /*d30e*/, "pags" /*d30f*/, "pan" /*d310*/, "panj" /*d311*/, "panh" /*d312*/, "pad" /*d313*/, "pal" /*d314*/, "palg" /*d315*/, "palm" /*d316*/, "palb" /*d317*/, "pals" /*d318*/, "palt" /*d319*/, "palp" /*d31a*/, "palh" /*d31b*/, "pam" /*d31c*/, "pab" /*d31d*/, "pabs" /*d31e*/, "pas" /*d31f*/, "pass" /*d320*/, "pang" /*d321*/, "paj" /*d322*/, "pac" /*d323*/, "pak" /*d324*/, "pat" /*d325*/, "pap" /*d326*/, "pah" /*d327*/, "pae" /*d328*/, "paeg" /*d329*/, "paegg" /*d32a*/, "paegs" /*d32b*/, "paen" /*d32c*/, "paenj" /*d32d*/, "paenh" /*d32e*/, "paed" /*d32f*/, "pael" /*d330*/, "paelg" /*d331*/, "paelm" /*d332*/, "paelb" /*d333*/, "paels" /*d334*/, "paelt" /*d335*/, "paelp" /*d336*/, "paelh" /*d337*/, "paem" /*d338*/, "paeb" /*d339*/, "paebs" /*d33a*/, "paes" /*d33b*/, "paess" /*d33c*/, "paeng" /*d33d*/, "paej" /*d33e*/, "paec" /*d33f*/, "paek" /*d340*/, "paet" /*d341*/, "paep" /*d342*/, "paeh" /*d343*/, "pya" /*d344*/, "pyag" /*d345*/, "pyagg" /*d346*/, "pyags" /*d347*/, "pyan" /*d348*/, "pyanj" /*d349*/, "pyanh" /*d34a*/, "pyad" /*d34b*/, "pyal" /*d34c*/, "pyalg" /*d34d*/, "pyalm" /*d34e*/, "pyalb" /*d34f*/, "pyals" /*d350*/, "pyalt" /*d351*/, "pyalp" /*d352*/, "pyalh" /*d353*/, "pyam" /*d354*/, "pyab" /*d355*/, "pyabs" /*d356*/, "pyas" /*d357*/, "pyass" /*d358*/, "pyang" /*d359*/, "pyaj" /*d35a*/, "pyac" /*d35b*/, "pyak" /*d35c*/, "pyat" /*d35d*/, "pyap" /*d35e*/, "pyah" /*d35f*/, "pyae" /*d360*/, "pyaeg" /*d361*/, "pyaegg" /*d362*/, "pyaegs" /*d363*/, "pyaen" /*d364*/, "pyaenj" /*d365*/, "pyaenh" /*d366*/, "pyaed" /*d367*/, "pyael" /*d368*/, "pyaelg" /*d369*/, "pyaelm" /*d36a*/, "pyaelb" /*d36b*/, "pyaels" /*d36c*/, "pyaelt" /*d36d*/, "pyaelp" /*d36e*/, "pyaelh" /*d36f*/, "pyaem" /*d370*/, "pyaeb" /*d371*/, "pyaebs" /*d372*/, "pyaes" /*d373*/, "pyaess" /*d374*/, "pyaeng" /*d375*/, "pyaej" /*d376*/, "pyaec" /*d377*/, "pyaek" /*d378*/, "pyaet" /*d379*/, "pyaep" /*d37a*/, "pyaeh" /*d37b*/, "peo" /*d37c*/, "peog" /*d37d*/, "peogg" /*d37e*/, "peogs" /*d37f*/, "peon" /*d380*/, "peonj" /*d381*/, "peonh" /*d382*/, "peod" /*d383*/, "peol" /*d384*/, "peolg" /*d385*/, "peolm" /*d386*/, "peolb" /*d387*/, "peols" /*d388*/, "peolt" /*d389*/, "peolp" /*d38a*/, "peolh" /*d38b*/, "peom" /*d38c*/, "peob" /*d38d*/, "peobs" /*d38e*/, "peos" /*d38f*/, "peoss" /*d390*/, "peong" /*d391*/, "peoj" /*d392*/, "peoc" /*d393*/, "peok" /*d394*/, "peot" /*d395*/, "peop" /*d396*/, "peoh" /*d397*/, "pe" /*d398*/, "peg" /*d399*/, "pegg" /*d39a*/, "pegs" /*d39b*/, "pen" /*d39c*/, "penj" /*d39d*/, "penh" /*d39e*/, "ped" /*d39f*/, "pel" /*d3a0*/, "pelg" /*d3a1*/, "pelm" /*d3a2*/, "pelb" /*d3a3*/, "pels" /*d3a4*/, "pelt" /*d3a5*/, "pelp" /*d3a6*/, "pelh" /*d3a7*/, "pem" /*d3a8*/, "peb" /*d3a9*/, "pebs" /*d3aa*/, "pes" /*d3ab*/, "pess" /*d3ac*/, "peng" /*d3ad*/, "pej" /*d3ae*/, "pec" /*d3af*/, "pek" /*d3b0*/, "pet" /*d3b1*/, "pep" /*d3b2*/, "peh" /*d3b3*/, "pyeo" /*d3b4*/, "pyeog" /*d3b5*/, "pyeogg" /*d3b6*/, "pyeogs" /*d3b7*/, "pyeon" /*d3b8*/, "pyeonj" /*d3b9*/, "pyeonh" /*d3ba*/, "pyeod" /*d3bb*/, "pyeol" /*d3bc*/, "pyeolg" /*d3bd*/, "pyeolm" /*d3be*/, "pyeolb" /*d3bf*/, "pyeols" /*d3c0*/, "pyeolt" /*d3c1*/, "pyeolp" /*d3c2*/, "pyeolh" /*d3c3*/, "pyeom" /*d3c4*/, "pyeob" /*d3c5*/, "pyeobs" /*d3c6*/, "pyeos" /*d3c7*/, "pyeoss" /*d3c8*/, "pyeong" /*d3c9*/, "pyeoj" /*d3ca*/, "pyeoc" /*d3cb*/, "pyeok" /*d3cc*/, "pyeot" /*d3cd*/, "pyeop" /*d3ce*/, "pyeoh" /*d3cf*/, "pye" /*d3d0*/, "pyeg" /*d3d1*/, "pyegg" /*d3d2*/, "pyegs" /*d3d3*/, "pyen" /*d3d4*/, "pyenj" /*d3d5*/, "pyenh" /*d3d6*/, "pyed" /*d3d7*/, "pyel" /*d3d8*/, "pyelg" /*d3d9*/, "pyelm" /*d3da*/, "pyelb" /*d3db*/, "pyels" /*d3dc*/, "pyelt" /*d3dd*/, "pyelp" /*d3de*/, "pyelh" /*d3df*/, "pyem" /*d3e0*/, "pyeb" /*d3e1*/, "pyebs" /*d3e2*/, "pyes" /*d3e3*/, "pyess" /*d3e4*/, "pyeng" /*d3e5*/, "pyej" /*d3e6*/, "pyec" /*d3e7*/, "pyek" /*d3e8*/, "pyet" /*d3e9*/, "pyep" /*d3ea*/, "pyeh" /*d3eb*/, "po" /*d3ec*/, "pog" /*d3ed*/, "pogg" /*d3ee*/, "pogs" /*d3ef*/, "pon" /*d3f0*/, "ponj" /*d3f1*/, "ponh" /*d3f2*/, "pod" /*d3f3*/, "pol" /*d3f4*/, "polg" /*d3f5*/, "polm" /*d3f6*/, "polb" /*d3f7*/, "pols" /*d3f8*/, "polt" /*d3f9*/, "polp" /*d3fa*/, "polh" /*d3fb*/, "pom" /*d3fc*/, "pob" /*d3fd*/, "pobs" /*d3fe*/, "pos" /*d3ff*/ 
			});
						characters.TryAdd(212 /*54272 d4*/, new string[] {
				"poss" /*d400*/, "pong" /*d401*/, "poj" /*d402*/, "poc" /*d403*/, "pok" /*d404*/, "pot" /*d405*/, "pop" /*d406*/, "poh" /*d407*/, "pwa" /*d408*/, "pwag" /*d409*/, "pwagg" /*d40a*/, "pwags" /*d40b*/, "pwan" /*d40c*/, "pwanj" /*d40d*/, "pwanh" /*d40e*/, "pwad" /*d40f*/, "pwal" /*d410*/, "pwalg" /*d411*/, "pwalm" /*d412*/, "pwalb" /*d413*/, "pwals" /*d414*/, "pwalt" /*d415*/, "pwalp" /*d416*/, "pwalh" /*d417*/, "pwam" /*d418*/, "pwab" /*d419*/, "pwabs" /*d41a*/, "pwas" /*d41b*/, "pwass" /*d41c*/, "pwang" /*d41d*/, "pwaj" /*d41e*/, "pwac" /*d41f*/, "pwak" /*d420*/, "pwat" /*d421*/, "pwap" /*d422*/, "pwah" /*d423*/, "pwae" /*d424*/, "pwaeg" /*d425*/, "pwaegg" /*d426*/, "pwaegs" /*d427*/, "pwaen" /*d428*/, "pwaenj" /*d429*/, "pwaenh" /*d42a*/, "pwaed" /*d42b*/, "pwael" /*d42c*/, "pwaelg" /*d42d*/, "pwaelm" /*d42e*/, "pwaelb" /*d42f*/, "pwaels" /*d430*/, "pwaelt" /*d431*/, "pwaelp" /*d432*/, "pwaelh" /*d433*/, "pwaem" /*d434*/, "pwaeb" /*d435*/, "pwaebs" /*d436*/, "pwaes" /*d437*/, "pwaess" /*d438*/, "pwaeng" /*d439*/, "pwaej" /*d43a*/, "pwaec" /*d43b*/, "pwaek" /*d43c*/, "pwaet" /*d43d*/, "pwaep" /*d43e*/, "pwaeh" /*d43f*/, "poe" /*d440*/, "poeg" /*d441*/, "poegg" /*d442*/, "poegs" /*d443*/, "poen" /*d444*/, "poenj" /*d445*/, "poenh" /*d446*/, "poed" /*d447*/, "poel" /*d448*/, "poelg" /*d449*/, "poelm" /*d44a*/, "poelb" /*d44b*/, "poels" /*d44c*/, "poelt" /*d44d*/, "poelp" /*d44e*/, "poelh" /*d44f*/, "poem" /*d450*/, "poeb" /*d451*/, "poebs" /*d452*/, "poes" /*d453*/, "poess" /*d454*/, "poeng" /*d455*/, "poej" /*d456*/, "poec" /*d457*/, "poek" /*d458*/, "poet" /*d459*/, "poep" /*d45a*/, "poeh" /*d45b*/, "pyo" /*d45c*/, "pyog" /*d45d*/, "pyogg" /*d45e*/, "pyogs" /*d45f*/, "pyon" /*d460*/, "pyonj" /*d461*/, "pyonh" /*d462*/, "pyod" /*d463*/, "pyol" /*d464*/, "pyolg" /*d465*/, "pyolm" /*d466*/, "pyolb" /*d467*/, "pyols" /*d468*/, "pyolt" /*d469*/, "pyolp" /*d46a*/, "pyolh" /*d46b*/, "pyom" /*d46c*/, "pyob" /*d46d*/, "pyobs" /*d46e*/, "pyos" /*d46f*/, "pyoss" /*d470*/, "pyong" /*d471*/, "pyoj" /*d472*/, "pyoc" /*d473*/, "pyok" /*d474*/, "pyot" /*d475*/, "pyop" /*d476*/, "pyoh" /*d477*/, "pu" /*d478*/, "pug" /*d479*/, "pugg" /*d47a*/, "pugs" /*d47b*/, "pun" /*d47c*/, "punj" /*d47d*/, "punh" /*d47e*/, "pud" /*d47f*/, "pul" /*d480*/, "pulg" /*d481*/, "pulm" /*d482*/, "pulb" /*d483*/, "puls" /*d484*/, "pult" /*d485*/, "pulp" /*d486*/, "pulh" /*d487*/, "pum" /*d488*/, "pub" /*d489*/, "pubs" /*d48a*/, "pus" /*d48b*/, "puss" /*d48c*/, "pung" /*d48d*/, "puj" /*d48e*/, "puc" /*d48f*/, "puk" /*d490*/, "put" /*d491*/, "pup" /*d492*/, "puh" /*d493*/, "pweo" /*d494*/, "pweog" /*d495*/, "pweogg" /*d496*/, "pweogs" /*d497*/, "pweon" /*d498*/, "pweonj" /*d499*/, "pweonh" /*d49a*/, "pweod" /*d49b*/, "pweol" /*d49c*/, "pweolg" /*d49d*/, "pweolm" /*d49e*/, "pweolb" /*d49f*/, "pweols" /*d4a0*/, "pweolt" /*d4a1*/, "pweolp" /*d4a2*/, "pweolh" /*d4a3*/, "pweom" /*d4a4*/, "pweob" /*d4a5*/, "pweobs" /*d4a6*/, "pweos" /*d4a7*/, "pweoss" /*d4a8*/, "pweong" /*d4a9*/, "pweoj" /*d4aa*/, "pweoc" /*d4ab*/, "pweok" /*d4ac*/, "pweot" /*d4ad*/, "pweop" /*d4ae*/, "pweoh" /*d4af*/, "pwe" /*d4b0*/, "pweg" /*d4b1*/, "pwegg" /*d4b2*/, "pwegs" /*d4b3*/, "pwen" /*d4b4*/, "pwenj" /*d4b5*/, "pwenh" /*d4b6*/, "pwed" /*d4b7*/, "pwel" /*d4b8*/, "pwelg" /*d4b9*/, "pwelm" /*d4ba*/, "pwelb" /*d4bb*/, "pwels" /*d4bc*/, "pwelt" /*d4bd*/, "pwelp" /*d4be*/, "pwelh" /*d4bf*/, "pwem" /*d4c0*/, "pweb" /*d4c1*/, "pwebs" /*d4c2*/, "pwes" /*d4c3*/, "pwess" /*d4c4*/, "pweng" /*d4c5*/, "pwej" /*d4c6*/, "pwec" /*d4c7*/, "pwek" /*d4c8*/, "pwet" /*d4c9*/, "pwep" /*d4ca*/, "pweh" /*d4cb*/, "pwi" /*d4cc*/, "pwig" /*d4cd*/, "pwigg" /*d4ce*/, "pwigs" /*d4cf*/, "pwin" /*d4d0*/, "pwinj" /*d4d1*/, "pwinh" /*d4d2*/, "pwid" /*d4d3*/, "pwil" /*d4d4*/, "pwilg" /*d4d5*/, "pwilm" /*d4d6*/, "pwilb" /*d4d7*/, "pwils" /*d4d8*/, "pwilt" /*d4d9*/, "pwilp" /*d4da*/, "pwilh" /*d4db*/, "pwim" /*d4dc*/, "pwib" /*d4dd*/, "pwibs" /*d4de*/, "pwis" /*d4df*/, "pwiss" /*d4e0*/, "pwing" /*d4e1*/, "pwij" /*d4e2*/, "pwic" /*d4e3*/, "pwik" /*d4e4*/, "pwit" /*d4e5*/, "pwip" /*d4e6*/, "pwih" /*d4e7*/, "pyu" /*d4e8*/, "pyug" /*d4e9*/, "pyugg" /*d4ea*/, "pyugs" /*d4eb*/, "pyun" /*d4ec*/, "pyunj" /*d4ed*/, "pyunh" /*d4ee*/, "pyud" /*d4ef*/, "pyul" /*d4f0*/, "pyulg" /*d4f1*/, "pyulm" /*d4f2*/, "pyulb" /*d4f3*/, "pyuls" /*d4f4*/, "pyult" /*d4f5*/, "pyulp" /*d4f6*/, "pyulh" /*d4f7*/, "pyum" /*d4f8*/, "pyub" /*d4f9*/, "pyubs" /*d4fa*/, "pyus" /*d4fb*/, "pyuss" /*d4fc*/, "pyung" /*d4fd*/, "pyuj" /*d4fe*/, "pyuc" /*d4ff*/ 
			});
						characters.TryAdd(213 /*54528 d5*/, new string[] {
				"pyuk" /*d500*/, "pyut" /*d501*/, "pyup" /*d502*/, "pyuh" /*d503*/, "peu" /*d504*/, "peug" /*d505*/, "peugg" /*d506*/, "peugs" /*d507*/, "peun" /*d508*/, "peunj" /*d509*/, "peunh" /*d50a*/, "peud" /*d50b*/, "peul" /*d50c*/, "peulg" /*d50d*/, "peulm" /*d50e*/, "peulb" /*d50f*/, "peuls" /*d510*/, "peult" /*d511*/, "peulp" /*d512*/, "peulh" /*d513*/, "peum" /*d514*/, "peub" /*d515*/, "peubs" /*d516*/, "peus" /*d517*/, "peuss" /*d518*/, "peung" /*d519*/, "peuj" /*d51a*/, "peuc" /*d51b*/, "peuk" /*d51c*/, "peut" /*d51d*/, "peup" /*d51e*/, "peuh" /*d51f*/, "pyi" /*d520*/, "pyig" /*d521*/, "pyigg" /*d522*/, "pyigs" /*d523*/, "pyin" /*d524*/, "pyinj" /*d525*/, "pyinh" /*d526*/, "pyid" /*d527*/, "pyil" /*d528*/, "pyilg" /*d529*/, "pyilm" /*d52a*/, "pyilb" /*d52b*/, "pyils" /*d52c*/, "pyilt" /*d52d*/, "pyilp" /*d52e*/, "pyilh" /*d52f*/, "pyim" /*d530*/, "pyib" /*d531*/, "pyibs" /*d532*/, "pyis" /*d533*/, "pyiss" /*d534*/, "pying" /*d535*/, "pyij" /*d536*/, "pyic" /*d537*/, "pyik" /*d538*/, "pyit" /*d539*/, "pyip" /*d53a*/, "pyih" /*d53b*/, "pi" /*d53c*/, "pig" /*d53d*/, "pigg" /*d53e*/, "pigs" /*d53f*/, "pin" /*d540*/, "pinj" /*d541*/, "pinh" /*d542*/, "pid" /*d543*/, "pil" /*d544*/, "pilg" /*d545*/, "pilm" /*d546*/, "pilb" /*d547*/, "pils" /*d548*/, "pilt" /*d549*/, "pilp" /*d54a*/, "pilh" /*d54b*/, "pim" /*d54c*/, "pib" /*d54d*/, "pibs" /*d54e*/, "pis" /*d54f*/, "piss" /*d550*/, "ping" /*d551*/, "pij" /*d552*/, "pic" /*d553*/, "pik" /*d554*/, "pit" /*d555*/, "pip" /*d556*/, "pih" /*d557*/, "ha" /*d558*/, "hag" /*d559*/, "hagg" /*d55a*/, "hags" /*d55b*/, "han" /*d55c*/, "hanj" /*d55d*/, "hanh" /*d55e*/, "had" /*d55f*/, "hal" /*d560*/, "halg" /*d561*/, "halm" /*d562*/, "halb" /*d563*/, "hals" /*d564*/, "halt" /*d565*/, "halp" /*d566*/, "halh" /*d567*/, "ham" /*d568*/, "hab" /*d569*/, "habs" /*d56a*/, "has" /*d56b*/, "hass" /*d56c*/, "hang" /*d56d*/, "haj" /*d56e*/, "hac" /*d56f*/, "hak" /*d570*/, "hat" /*d571*/, "hap" /*d572*/, "hah" /*d573*/, "hae" /*d574*/, "haeg" /*d575*/, "haegg" /*d576*/, "haegs" /*d577*/, "haen" /*d578*/, "haenj" /*d579*/, "haenh" /*d57a*/, "haed" /*d57b*/, "hael" /*d57c*/, "haelg" /*d57d*/, "haelm" /*d57e*/, "haelb" /*d57f*/, "haels" /*d580*/, "haelt" /*d581*/, "haelp" /*d582*/, "haelh" /*d583*/, "haem" /*d584*/, "haeb" /*d585*/, "haebs" /*d586*/, "haes" /*d587*/, "haess" /*d588*/, "haeng" /*d589*/, "haej" /*d58a*/, "haec" /*d58b*/, "haek" /*d58c*/, "haet" /*d58d*/, "haep" /*d58e*/, "haeh" /*d58f*/, "hya" /*d590*/, "hyag" /*d591*/, "hyagg" /*d592*/, "hyags" /*d593*/, "hyan" /*d594*/, "hyanj" /*d595*/, "hyanh" /*d596*/, "hyad" /*d597*/, "hyal" /*d598*/, "hyalg" /*d599*/, "hyalm" /*d59a*/, "hyalb" /*d59b*/, "hyals" /*d59c*/, "hyalt" /*d59d*/, "hyalp" /*d59e*/, "hyalh" /*d59f*/, "hyam" /*d5a0*/, "hyab" /*d5a1*/, "hyabs" /*d5a2*/, "hyas" /*d5a3*/, "hyass" /*d5a4*/, "hyang" /*d5a5*/, "hyaj" /*d5a6*/, "hyac" /*d5a7*/, "hyak" /*d5a8*/, "hyat" /*d5a9*/, "hyap" /*d5aa*/, "hyah" /*d5ab*/, "hyae" /*d5ac*/, "hyaeg" /*d5ad*/, "hyaegg" /*d5ae*/, "hyaegs" /*d5af*/, "hyaen" /*d5b0*/, "hyaenj" /*d5b1*/, "hyaenh" /*d5b2*/, "hyaed" /*d5b3*/, "hyael" /*d5b4*/, "hyaelg" /*d5b5*/, "hyaelm" /*d5b6*/, "hyaelb" /*d5b7*/, "hyaels" /*d5b8*/, "hyaelt" /*d5b9*/, "hyaelp" /*d5ba*/, "hyaelh" /*d5bb*/, "hyaem" /*d5bc*/, "hyaeb" /*d5bd*/, "hyaebs" /*d5be*/, "hyaes" /*d5bf*/, "hyaess" /*d5c0*/, "hyaeng" /*d5c1*/, "hyaej" /*d5c2*/, "hyaec" /*d5c3*/, "hyaek" /*d5c4*/, "hyaet" /*d5c5*/, "hyaep" /*d5c6*/, "hyaeh" /*d5c7*/, "heo" /*d5c8*/, "heog" /*d5c9*/, "heogg" /*d5ca*/, "heogs" /*d5cb*/, "heon" /*d5cc*/, "heonj" /*d5cd*/, "heonh" /*d5ce*/, "heod" /*d5cf*/, "heol" /*d5d0*/, "heolg" /*d5d1*/, "heolm" /*d5d2*/, "heolb" /*d5d3*/, "heols" /*d5d4*/, "heolt" /*d5d5*/, "heolp" /*d5d6*/, "heolh" /*d5d7*/, "heom" /*d5d8*/, "heob" /*d5d9*/, "heobs" /*d5da*/, "heos" /*d5db*/, "heoss" /*d5dc*/, "heong" /*d5dd*/, "heoj" /*d5de*/, "heoc" /*d5df*/, "heok" /*d5e0*/, "heot" /*d5e1*/, "heop" /*d5e2*/, "heoh" /*d5e3*/, "he" /*d5e4*/, "heg" /*d5e5*/, "hegg" /*d5e6*/, "hegs" /*d5e7*/, "hen" /*d5e8*/, "henj" /*d5e9*/, "henh" /*d5ea*/, "hed" /*d5eb*/, "hel" /*d5ec*/, "helg" /*d5ed*/, "helm" /*d5ee*/, "helb" /*d5ef*/, "hels" /*d5f0*/, "helt" /*d5f1*/, "help" /*d5f2*/, "helh" /*d5f3*/, "hem" /*d5f4*/, "heb" /*d5f5*/, "hebs" /*d5f6*/, "hes" /*d5f7*/, "hess" /*d5f8*/, "heng" /*d5f9*/, "hej" /*d5fa*/, "hec" /*d5fb*/, "hek" /*d5fc*/, "het" /*d5fd*/, "hep" /*d5fe*/, "heh" /*d5ff*/ 
			});
						characters.TryAdd(214 /*54784 d6*/, new string[] {
				"hyeo" /*d600*/, "hyeog" /*d601*/, "hyeogg" /*d602*/, "hyeogs" /*d603*/, "hyeon" /*d604*/, "hyeonj" /*d605*/, "hyeonh" /*d606*/, "hyeod" /*d607*/, "hyeol" /*d608*/, "hyeolg" /*d609*/, "hyeolm" /*d60a*/, "hyeolb" /*d60b*/, "hyeols" /*d60c*/, "hyeolt" /*d60d*/, "hyeolp" /*d60e*/, "hyeolh" /*d60f*/, "hyeom" /*d610*/, "hyeob" /*d611*/, "hyeobs" /*d612*/, "hyeos" /*d613*/, "hyeoss" /*d614*/, "hyeong" /*d615*/, "hyeoj" /*d616*/, "hyeoc" /*d617*/, "hyeok" /*d618*/, "hyeot" /*d619*/, "hyeop" /*d61a*/, "hyeoh" /*d61b*/, "hye" /*d61c*/, "hyeg" /*d61d*/, "hyegg" /*d61e*/, "hyegs" /*d61f*/, "hyen" /*d620*/, "hyenj" /*d621*/, "hyenh" /*d622*/, "hyed" /*d623*/, "hyel" /*d624*/, "hyelg" /*d625*/, "hyelm" /*d626*/, "hyelb" /*d627*/, "hyels" /*d628*/, "hyelt" /*d629*/, "hyelp" /*d62a*/, "hyelh" /*d62b*/, "hyem" /*d62c*/, "hyeb" /*d62d*/, "hyebs" /*d62e*/, "hyes" /*d62f*/, "hyess" /*d630*/, "hyeng" /*d631*/, "hyej" /*d632*/, "hyec" /*d633*/, "hyek" /*d634*/, "hyet" /*d635*/, "hyep" /*d636*/, "hyeh" /*d637*/, "ho" /*d638*/, "hog" /*d639*/, "hogg" /*d63a*/, "hogs" /*d63b*/, "hon" /*d63c*/, "honj" /*d63d*/, "honh" /*d63e*/, "hod" /*d63f*/, "hol" /*d640*/, "holg" /*d641*/, "holm" /*d642*/, "holb" /*d643*/, "hols" /*d644*/, "holt" /*d645*/, "holp" /*d646*/, "holh" /*d647*/, "hom" /*d648*/, "hob" /*d649*/, "hobs" /*d64a*/, "hos" /*d64b*/, "hoss" /*d64c*/, "hong" /*d64d*/, "hoj" /*d64e*/, "hoc" /*d64f*/, "hok" /*d650*/, "hot" /*d651*/, "hop" /*d652*/, "hoh" /*d653*/, "hwa" /*d654*/, "hwag" /*d655*/, "hwagg" /*d656*/, "hwags" /*d657*/, "hwan" /*d658*/, "hwanj" /*d659*/, "hwanh" /*d65a*/, "hwad" /*d65b*/, "hwal" /*d65c*/, "hwalg" /*d65d*/, "hwalm" /*d65e*/, "hwalb" /*d65f*/, "hwals" /*d660*/, "hwalt" /*d661*/, "hwalp" /*d662*/, "hwalh" /*d663*/, "hwam" /*d664*/, "hwab" /*d665*/, "hwabs" /*d666*/, "hwas" /*d667*/, "hwass" /*d668*/, "hwang" /*d669*/, "hwaj" /*d66a*/, "hwac" /*d66b*/, "hwak" /*d66c*/, "hwat" /*d66d*/, "hwap" /*d66e*/, "hwah" /*d66f*/, "hwae" /*d670*/, "hwaeg" /*d671*/, "hwaegg" /*d672*/, "hwaegs" /*d673*/, "hwaen" /*d674*/, "hwaenj" /*d675*/, "hwaenh" /*d676*/, "hwaed" /*d677*/, "hwael" /*d678*/, "hwaelg" /*d679*/, "hwaelm" /*d67a*/, "hwaelb" /*d67b*/, "hwaels" /*d67c*/, "hwaelt" /*d67d*/, "hwaelp" /*d67e*/, "hwaelh" /*d67f*/, "hwaem" /*d680*/, "hwaeb" /*d681*/, "hwaebs" /*d682*/, "hwaes" /*d683*/, "hwaess" /*d684*/, "hwaeng" /*d685*/, "hwaej" /*d686*/, "hwaec" /*d687*/, "hwaek" /*d688*/, "hwaet" /*d689*/, "hwaep" /*d68a*/, "hwaeh" /*d68b*/, "hoe" /*d68c*/, "hoeg" /*d68d*/, "hoegg" /*d68e*/, "hoegs" /*d68f*/, "hoen" /*d690*/, "hoenj" /*d691*/, "hoenh" /*d692*/, "hoed" /*d693*/, "hoel" /*d694*/, "hoelg" /*d695*/, "hoelm" /*d696*/, "hoelb" /*d697*/, "hoels" /*d698*/, "hoelt" /*d699*/, "hoelp" /*d69a*/, "hoelh" /*d69b*/, "hoem" /*d69c*/, "hoeb" /*d69d*/, "hoebs" /*d69e*/, "hoes" /*d69f*/, "hoess" /*d6a0*/, "hoeng" /*d6a1*/, "hoej" /*d6a2*/, "hoec" /*d6a3*/, "hoek" /*d6a4*/, "hoet" /*d6a5*/, "hoep" /*d6a6*/, "hoeh" /*d6a7*/, "hyo" /*d6a8*/, "hyog" /*d6a9*/, "hyogg" /*d6aa*/, "hyogs" /*d6ab*/, "hyon" /*d6ac*/, "hyonj" /*d6ad*/, "hyonh" /*d6ae*/, "hyod" /*d6af*/, "hyol" /*d6b0*/, "hyolg" /*d6b1*/, "hyolm" /*d6b2*/, "hyolb" /*d6b3*/, "hyols" /*d6b4*/, "hyolt" /*d6b5*/, "hyolp" /*d6b6*/, "hyolh" /*d6b7*/, "hyom" /*d6b8*/, "hyob" /*d6b9*/, "hyobs" /*d6ba*/, "hyos" /*d6bb*/, "hyoss" /*d6bc*/, "hyong" /*d6bd*/, "hyoj" /*d6be*/, "hyoc" /*d6bf*/, "hyok" /*d6c0*/, "hyot" /*d6c1*/, "hyop" /*d6c2*/, "hyoh" /*d6c3*/, "hu" /*d6c4*/, "hug" /*d6c5*/, "hugg" /*d6c6*/, "hugs" /*d6c7*/, "hun" /*d6c8*/, "hunj" /*d6c9*/, "hunh" /*d6ca*/, "hud" /*d6cb*/, "hul" /*d6cc*/, "hulg" /*d6cd*/, "hulm" /*d6ce*/, "hulb" /*d6cf*/, "huls" /*d6d0*/, "hult" /*d6d1*/, "hulp" /*d6d2*/, "hulh" /*d6d3*/, "hum" /*d6d4*/, "hub" /*d6d5*/, "hubs" /*d6d6*/, "hus" /*d6d7*/, "huss" /*d6d8*/, "hung" /*d6d9*/, "huj" /*d6da*/, "huc" /*d6db*/, "huk" /*d6dc*/, "hut" /*d6dd*/, "hup" /*d6de*/, "huh" /*d6df*/, "hweo" /*d6e0*/, "hweog" /*d6e1*/, "hweogg" /*d6e2*/, "hweogs" /*d6e3*/, "hweon" /*d6e4*/, "hweonj" /*d6e5*/, "hweonh" /*d6e6*/, "hweod" /*d6e7*/, "hweol" /*d6e8*/, "hweolg" /*d6e9*/, "hweolm" /*d6ea*/, "hweolb" /*d6eb*/, "hweols" /*d6ec*/, "hweolt" /*d6ed*/, "hweolp" /*d6ee*/, "hweolh" /*d6ef*/, "hweom" /*d6f0*/, "hweob" /*d6f1*/, "hweobs" /*d6f2*/, "hweos" /*d6f3*/, "hweoss" /*d6f4*/, "hweong" /*d6f5*/, "hweoj" /*d6f6*/, "hweoc" /*d6f7*/, "hweok" /*d6f8*/, "hweot" /*d6f9*/, "hweop" /*d6fa*/, "hweoh" /*d6fb*/, "hwe" /*d6fc*/, "hweg" /*d6fd*/, "hwegg" /*d6fe*/, "hwegs" /*d6ff*/ 
			});
						characters.TryAdd(215 /*55040 d7*/, new string[] {
				"hwen" /*d700*/, "hwenj" /*d701*/, "hwenh" /*d702*/, "hwed" /*d703*/, "hwel" /*d704*/, "hwelg" /*d705*/, "hwelm" /*d706*/, "hwelb" /*d707*/, "hwels" /*d708*/, "hwelt" /*d709*/, "hwelp" /*d70a*/, "hwelh" /*d70b*/, "hwem" /*d70c*/, "hweb" /*d70d*/, "hwebs" /*d70e*/, "hwes" /*d70f*/, "hwess" /*d710*/, "hweng" /*d711*/, "hwej" /*d712*/, "hwec" /*d713*/, "hwek" /*d714*/, "hwet" /*d715*/, "hwep" /*d716*/, "hweh" /*d717*/, "hwi" /*d718*/, "hwig" /*d719*/, "hwigg" /*d71a*/, "hwigs" /*d71b*/, "hwin" /*d71c*/, "hwinj" /*d71d*/, "hwinh" /*d71e*/, "hwid" /*d71f*/, "hwil" /*d720*/, "hwilg" /*d721*/, "hwilm" /*d722*/, "hwilb" /*d723*/, "hwils" /*d724*/, "hwilt" /*d725*/, "hwilp" /*d726*/, "hwilh" /*d727*/, "hwim" /*d728*/, "hwib" /*d729*/, "hwibs" /*d72a*/, "hwis" /*d72b*/, "hwiss" /*d72c*/, "hwing" /*d72d*/, "hwij" /*d72e*/, "hwic" /*d72f*/, "hwik" /*d730*/, "hwit" /*d731*/, "hwip" /*d732*/, "hwih" /*d733*/, "hyu" /*d734*/, "hyug" /*d735*/, "hyugg" /*d736*/, "hyugs" /*d737*/, "hyun" /*d738*/, "hyunj" /*d739*/, "hyunh" /*d73a*/, "hyud" /*d73b*/, "hyul" /*d73c*/, "hyulg" /*d73d*/, "hyulm" /*d73e*/, "hyulb" /*d73f*/, "hyuls" /*d740*/, "hyult" /*d741*/, "hyulp" /*d742*/, "hyulh" /*d743*/, "hyum" /*d744*/, "hyub" /*d745*/, "hyubs" /*d746*/, "hyus" /*d747*/, "hyuss" /*d748*/, "hyung" /*d749*/, "hyuj" /*d74a*/, "hyuc" /*d74b*/, "hyuk" /*d74c*/, "hyut" /*d74d*/, "hyup" /*d74e*/, "hyuh" /*d74f*/, "heu" /*d750*/, "heug" /*d751*/, "heugg" /*d752*/, "heugs" /*d753*/, "heun" /*d754*/, "heunj" /*d755*/, "heunh" /*d756*/, "heud" /*d757*/, "heul" /*d758*/, "heulg" /*d759*/, "heulm" /*d75a*/, "heulb" /*d75b*/, "heuls" /*d75c*/, "heult" /*d75d*/, "heulp" /*d75e*/, "heulh" /*d75f*/, "heum" /*d760*/, "heub" /*d761*/, "heubs" /*d762*/, "heus" /*d763*/, "heuss" /*d764*/, "heung" /*d765*/, "heuj" /*d766*/, "heuc" /*d767*/, "heuk" /*d768*/, "heut" /*d769*/, "heup" /*d76a*/, "heuh" /*d76b*/, "hyi" /*d76c*/, "hyig" /*d76d*/, "hyigg" /*d76e*/, "hyigs" /*d76f*/, "hyin" /*d770*/, "hyinj" /*d771*/, "hyinh" /*d772*/, "hyid" /*d773*/, "hyil" /*d774*/, "hyilg" /*d775*/, "hyilm" /*d776*/, "hyilb" /*d777*/, "hyils" /*d778*/, "hyilt" /*d779*/, "hyilp" /*d77a*/, "hyilh" /*d77b*/, "hyim" /*d77c*/, "hyib" /*d77d*/, "hyibs" /*d77e*/, "hyis" /*d77f*/, "hyiss" /*d780*/, "hying" /*d781*/, "hyij" /*d782*/, "hyic" /*d783*/, "hyik" /*d784*/, "hyit" /*d785*/, "hyip" /*d786*/, "hyih" /*d787*/, "hi" /*d788*/, "hig" /*d789*/, "higg" /*d78a*/, "higs" /*d78b*/, "hin" /*d78c*/, "hinj" /*d78d*/, "hinh" /*d78e*/, "hid" /*d78f*/, "hil" /*d790*/, "hilg" /*d791*/, "hilm" /*d792*/, "hilb" /*d793*/, "hils" /*d794*/, "hilt" /*d795*/, "hilp" /*d796*/, "hilh" /*d797*/, "him" /*d798*/, "hib" /*d799*/, "hibs" /*d79a*/, "his" /*d79b*/, "hiss" /*d79c*/, "hing" /*d79d*/, "hij" /*d79e*/, "hic" /*d79f*/, "hik" /*d7a0*/, "hit" /*d7a1*/, "hip" /*d7a2*/, "hih" /*d7a3*/, "[?]" /*d7a4*/, "[?]" /*d7a5*/, "[?]" /*d7a6*/, "[?]" /*d7a7*/, "[?]" /*d7a8*/, "[?]" /*d7a9*/, "[?]" /*d7aa*/, "[?]" /*d7ab*/, "[?]" /*d7ac*/, "[?]" /*d7ad*/, "[?]" /*d7ae*/, "[?]" /*d7af*/, "[?]" /*d7b0*/, "[?]" /*d7b1*/, "[?]" /*d7b2*/, "[?]" /*d7b3*/, "[?]" /*d7b4*/, "[?]" /*d7b5*/, "[?]" /*d7b6*/, "[?]" /*d7b7*/, "[?]" /*d7b8*/, "[?]" /*d7b9*/, "[?]" /*d7ba*/, "[?]" /*d7bb*/, "[?]" /*d7bc*/, "[?]" /*d7bd*/, "[?]" /*d7be*/, "[?]" /*d7bf*/, "[?]" /*d7c0*/, "[?]" /*d7c1*/, "[?]" /*d7c2*/, "[?]" /*d7c3*/, "[?]" /*d7c4*/, "[?]" /*d7c5*/, "[?]" /*d7c6*/, "[?]" /*d7c7*/, "[?]" /*d7c8*/, "[?]" /*d7c9*/, "[?]" /*d7ca*/, "[?]" /*d7cb*/, "[?]" /*d7cc*/, "[?]" /*d7cd*/, "[?]" /*d7ce*/, "[?]" /*d7cf*/, "[?]" /*d7d0*/, "[?]" /*d7d1*/, "[?]" /*d7d2*/, "[?]" /*d7d3*/, "[?]" /*d7d4*/, "[?]" /*d7d5*/, "[?]" /*d7d6*/, "[?]" /*d7d7*/, "[?]" /*d7d8*/, "[?]" /*d7d9*/, "[?]" /*d7da*/, "[?]" /*d7db*/, "[?]" /*d7dc*/, "[?]" /*d7dd*/, "[?]" /*d7de*/, "[?]" /*d7df*/, "[?]" /*d7e0*/, "[?]" /*d7e1*/, "[?]" /*d7e2*/, "[?]" /*d7e3*/, "[?]" /*d7e4*/, "[?]" /*d7e5*/, "[?]" /*d7e6*/, "[?]" /*d7e7*/, "[?]" /*d7e8*/, "[?]" /*d7e9*/, "[?]" /*d7ea*/, "[?]" /*d7eb*/, "[?]" /*d7ec*/, "[?]" /*d7ed*/, "[?]" /*d7ee*/, "[?]" /*d7ef*/, "[?]" /*d7f0*/, "[?]" /*d7f1*/, "[?]" /*d7f2*/, "[?]" /*d7f3*/, "[?]" /*d7f4*/, "[?]" /*d7f5*/, "[?]" /*d7f6*/, "[?]" /*d7f7*/, "[?]" /*d7f8*/, "[?]" /*d7f9*/, "[?]" /*d7fa*/, "[?]" /*d7fb*/, "[?]" /*d7fc*/, "[?]" /*d7fd*/, "[?]" /*d7fe*/, 
			});
						characters.TryAdd(249 /*63744 f9*/, new string[] {
				"Kay " /*f900*/, "Kayng " /*f901*/, "Ke " /*f902*/, "Ko " /*f903*/, "Kol " /*f904*/, "Koc " /*f905*/, "Kwi " /*f906*/, "Kwi " /*f907*/, "Kyun " /*f908*/, "Kul " /*f909*/, "Kum " /*f90a*/, "Na " /*f90b*/, "Na " /*f90c*/, "Na " /*f90d*/, "La " /*f90e*/, "Na " /*f90f*/, "Na " /*f910*/, "Na " /*f911*/, "Na " /*f912*/, "Na " /*f913*/, "Nak " /*f914*/, "Nak " /*f915*/, "Nak " /*f916*/, "Nak " /*f917*/, "Nak " /*f918*/, "Nak " /*f919*/, "Nak " /*f91a*/, "Nan " /*f91b*/, "Nan " /*f91c*/, "Nan " /*f91d*/, "Nan " /*f91e*/, "Nan " /*f91f*/, "Nan " /*f920*/, "Nam " /*f921*/, "Nam " /*f922*/, "Nam " /*f923*/, "Nam " /*f924*/, "Nap " /*f925*/, "Nap " /*f926*/, "Nap " /*f927*/, "Nang " /*f928*/, "Nang " /*f929*/, "Nang " /*f92a*/, "Nang " /*f92b*/, "Nang " /*f92c*/, "Nay " /*f92d*/, "Nayng " /*f92e*/, "No " /*f92f*/, "No " /*f930*/, "No " /*f931*/, "No " /*f932*/, "No " /*f933*/, "No " /*f934*/, "No " /*f935*/, "No " /*f936*/, "No " /*f937*/, "No " /*f938*/, "No " /*f939*/, "No " /*f93a*/, "Nok " /*f93b*/, "Nok " /*f93c*/, "Nok " /*f93d*/, "Nok " /*f93e*/, "Nok " /*f93f*/, "Nok " /*f940*/, "Non " /*f941*/, "Nong " /*f942*/, "Nong " /*f943*/, "Nong " /*f944*/, "Nong " /*f945*/, "Noy " /*f946*/, "Noy " /*f947*/, "Noy " /*f948*/, "Noy " /*f949*/, "Nwu " /*f94a*/, "Nwu " /*f94b*/, "Nwu " /*f94c*/, "Nwu " /*f94d*/, "Nwu " /*f94e*/, "Nwu " /*f94f*/, "Nwu " /*f950*/, "Nwu " /*f951*/, "Nuk " /*f952*/, "Nuk " /*f953*/, "Num " /*f954*/, "Nung " /*f955*/, "Nung " /*f956*/, "Nung " /*f957*/, "Nung " /*f958*/, "Nung " /*f959*/, "Twu " /*f95a*/, "La " /*f95b*/, "Lak " /*f95c*/, "Lak " /*f95d*/, "Lan " /*f95e*/, "Lyeng " /*f95f*/, "Lo " /*f960*/, "Lyul " /*f961*/, "Li " /*f962*/, "Pey " /*f963*/, "Pen " /*f964*/, "Pyen " /*f965*/, "Pwu " /*f966*/, "Pwul " /*f967*/, "Pi " /*f968*/, "Sak " /*f969*/, "Sak " /*f96a*/, "Sam " /*f96b*/, "Sayk " /*f96c*/, "Sayng " /*f96d*/, "Sep " /*f96e*/, "Sey " /*f96f*/, "Sway " /*f970*/, "Sin " /*f971*/, "Sim " /*f972*/, "Sip " /*f973*/, "Ya " /*f974*/, "Yak " /*f975*/, "Yak " /*f976*/, "Yang " /*f977*/, "Yang " /*f978*/, "Yang " /*f979*/, "Yang " /*f97a*/, "Yang " /*f97b*/, "Yang " /*f97c*/, "Yang " /*f97d*/, "Yang " /*f97e*/, "Ye " /*f97f*/, "Ye " /*f980*/, "Ye " /*f981*/, "Ye " /*f982*/, "Ye " /*f983*/, "Ye " /*f984*/, "Ye " /*f985*/, "Ye " /*f986*/, "Ye " /*f987*/, "Ye " /*f988*/, "Ye " /*f989*/, "Yek " /*f98a*/, "Yek " /*f98b*/, "Yek " /*f98c*/, "Yek " /*f98d*/, "Yen " /*f98e*/, "Yen " /*f98f*/, "Yen " /*f990*/, "Yen " /*f991*/, "Yen " /*f992*/, "Yen " /*f993*/, "Yen " /*f994*/, "Yen " /*f995*/, "Yen " /*f996*/, "Yen " /*f997*/, "Yen " /*f998*/, "Yen " /*f999*/, "Yen " /*f99a*/, "Yen " /*f99b*/, "Yel " /*f99c*/, "Yel " /*f99d*/, "Yel " /*f99e*/, "Yel " /*f99f*/, "Yel " /*f9a0*/, "Yel " /*f9a1*/, "Yem " /*f9a2*/, "Yem " /*f9a3*/, "Yem " /*f9a4*/, "Yem " /*f9a5*/, "Yem " /*f9a6*/, "Yep " /*f9a7*/, "Yeng " /*f9a8*/, "Yeng " /*f9a9*/, "Yeng " /*f9aa*/, "Yeng " /*f9ab*/, "Yeng " /*f9ac*/, "Yeng " /*f9ad*/, "Yeng " /*f9ae*/, "Yeng " /*f9af*/, "Yeng " /*f9b0*/, "Yeng " /*f9b1*/, "Yeng " /*f9b2*/, "Yeng " /*f9b3*/, "Yeng " /*f9b4*/, "Yey " /*f9b5*/, "Yey " /*f9b6*/, "Yey " /*f9b7*/, "Yey " /*f9b8*/, "O " /*f9b9*/, "Yo " /*f9ba*/, "Yo " /*f9bb*/, "Yo " /*f9bc*/, "Yo " /*f9bd*/, "Yo " /*f9be*/, "Yo " /*f9bf*/, "Yo " /*f9c0*/, "Yo " /*f9c1*/, "Yo " /*f9c2*/, "Yo " /*f9c3*/, "Yong " /*f9c4*/, "Wun " /*f9c5*/, "Wen " /*f9c6*/, "Yu " /*f9c7*/, "Yu " /*f9c8*/, "Yu " /*f9c9*/, "Yu " /*f9ca*/, "Yu " /*f9cb*/, "Yu " /*f9cc*/, "Yu " /*f9cd*/, "Yu " /*f9ce*/, "Yu " /*f9cf*/, "Yu " /*f9d0*/, "Yuk " /*f9d1*/, "Yuk " /*f9d2*/, "Yuk " /*f9d3*/, "Yun " /*f9d4*/, "Yun " /*f9d5*/, "Yun " /*f9d6*/, "Yun " /*f9d7*/, "Yul " /*f9d8*/, "Yul " /*f9d9*/, "Yul " /*f9da*/, "Yul " /*f9db*/, "Yung " /*f9dc*/, "I " /*f9dd*/, "I " /*f9de*/, "I " /*f9df*/, "I " /*f9e0*/, "I " /*f9e1*/, "I " /*f9e2*/, "I " /*f9e3*/, "I " /*f9e4*/, "I " /*f9e5*/, "I " /*f9e6*/, "I " /*f9e7*/, "I " /*f9e8*/, "I " /*f9e9*/, "I " /*f9ea*/, "Ik " /*f9eb*/, "Ik " /*f9ec*/, "In " /*f9ed*/, "In " /*f9ee*/, "In " /*f9ef*/, "In " /*f9f0*/, "In " /*f9f1*/, "In " /*f9f2*/, "In " /*f9f3*/, "Im " /*f9f4*/, "Im " /*f9f5*/, "Im " /*f9f6*/, "Ip " /*f9f7*/, "Ip " /*f9f8*/, "Ip " /*f9f9*/, "Cang " /*f9fa*/, "Cek " /*f9fb*/, "Ci " /*f9fc*/, "Cip " /*f9fd*/, "Cha " /*f9fe*/, "Chek " /*f9ff*/ 
			});
						characters.TryAdd(250 /*64000 fa*/, new string[] {
				"Chey " /*fa00*/, "Thak " /*fa01*/, "Thak " /*fa02*/, "Thang " /*fa03*/, "Thayk " /*fa04*/, "Thong " /*fa05*/, "Pho " /*fa06*/, "Phok " /*fa07*/, "Hang " /*fa08*/, "Hang " /*fa09*/, "Hyen " /*fa0a*/, "Hwak " /*fa0b*/, "Wu " /*fa0c*/, "Huo " /*fa0d*/, "[?] " /*fa0e*/, "[?] " /*fa0f*/, "Zhong " /*fa10*/, "[?] " /*fa11*/, "Qing " /*fa12*/, "[?] " /*fa13*/, "[?] " /*fa14*/, "Xi " /*fa15*/, "Zhu " /*fa16*/, "Yi " /*fa17*/, "Li " /*fa18*/, "Shen " /*fa19*/, "Xiang " /*fa1a*/, "Fu " /*fa1b*/, "Jing " /*fa1c*/, "Jing " /*fa1d*/, "Yu " /*fa1e*/, "[?] " /*fa1f*/, "Hagi " /*fa20*/, "[?] " /*fa21*/, "Zhu " /*fa22*/, "[?] " /*fa23*/, "[?] " /*fa24*/, "Yi " /*fa25*/, "Du " /*fa26*/, "[?] " /*fa27*/, "[?] " /*fa28*/, "[?] " /*fa29*/, "Fan " /*fa2a*/, "Si " /*fa2b*/, "Guan " /*fa2c*/, "[?]" /*fa2d*/, "[?]" /*fa2e*/, "[?]" /*fa2f*/, "[?]" /*fa30*/, "[?]" /*fa31*/, "[?]" /*fa32*/, "[?]" /*fa33*/, "[?]" /*fa34*/, "[?]" /*fa35*/, "[?]" /*fa36*/, "[?]" /*fa37*/, "[?]" /*fa38*/, "[?]" /*fa39*/, "[?]" /*fa3a*/, "[?]" /*fa3b*/, "[?]" /*fa3c*/, "[?]" /*fa3d*/, "[?]" /*fa3e*/, "[?]" /*fa3f*/, "[?]" /*fa40*/, "[?]" /*fa41*/, "[?]" /*fa42*/, "[?]" /*fa43*/, "[?]" /*fa44*/, "[?]" /*fa45*/, "[?]" /*fa46*/, "[?]" /*fa47*/, "[?]" /*fa48*/, "[?]" /*fa49*/, "[?]" /*fa4a*/, "[?]" /*fa4b*/, "[?]" /*fa4c*/, "[?]" /*fa4d*/, "[?]" /*fa4e*/, "[?]" /*fa4f*/, "[?]" /*fa50*/, "[?]" /*fa51*/, "[?]" /*fa52*/, "[?]" /*fa53*/, "[?]" /*fa54*/, "[?]" /*fa55*/, "[?]" /*fa56*/, "[?]" /*fa57*/, "[?]" /*fa58*/, "[?]" /*fa59*/, "[?]" /*fa5a*/, "[?]" /*fa5b*/, "[?]" /*fa5c*/, "[?]" /*fa5d*/, "[?]" /*fa5e*/, "[?]" /*fa5f*/, "[?]" /*fa60*/, "[?]" /*fa61*/, "[?]" /*fa62*/, "[?]" /*fa63*/, "[?]" /*fa64*/, "[?]" /*fa65*/, "[?]" /*fa66*/, "[?]" /*fa67*/, "[?]" /*fa68*/, "[?]" /*fa69*/, "[?]" /*fa6a*/, "[?]" /*fa6b*/, "[?]" /*fa6c*/, "[?]" /*fa6d*/, "[?]" /*fa6e*/, "[?]" /*fa6f*/, "[?]" /*fa70*/, "[?]" /*fa71*/, "[?]" /*fa72*/, "[?]" /*fa73*/, "[?]" /*fa74*/, "[?]" /*fa75*/, "[?]" /*fa76*/, "[?]" /*fa77*/, "[?]" /*fa78*/, "[?]" /*fa79*/, "[?]" /*fa7a*/, "[?]" /*fa7b*/, "[?]" /*fa7c*/, "[?]" /*fa7d*/, "[?]" /*fa7e*/, "[?]" /*fa7f*/, "[?]" /*fa80*/, "[?]" /*fa81*/, "[?]" /*fa82*/, "[?]" /*fa83*/, "[?]" /*fa84*/, "[?]" /*fa85*/, "[?]" /*fa86*/, "[?]" /*fa87*/, "[?]" /*fa88*/, "[?]" /*fa89*/, "[?]" /*fa8a*/, "[?]" /*fa8b*/, "[?]" /*fa8c*/, "[?]" /*fa8d*/, "[?]" /*fa8e*/, "[?]" /*fa8f*/, "[?]" /*fa90*/, "[?]" /*fa91*/, "[?]" /*fa92*/, "[?]" /*fa93*/, "[?]" /*fa94*/, "[?]" /*fa95*/, "[?]" /*fa96*/, "[?]" /*fa97*/, "[?]" /*fa98*/, "[?]" /*fa99*/, "[?]" /*fa9a*/, "[?]" /*fa9b*/, "[?]" /*fa9c*/, "[?]" /*fa9d*/, "[?]" /*fa9e*/, "[?]" /*fa9f*/, "[?]" /*faa0*/, "[?]" /*faa1*/, "[?]" /*faa2*/, "[?]" /*faa3*/, "[?]" /*faa4*/, "[?]" /*faa5*/, "[?]" /*faa6*/, "[?]" /*faa7*/, "[?]" /*faa8*/, "[?]" /*faa9*/, "[?]" /*faaa*/, "[?]" /*faab*/, "[?]" /*faac*/, "[?]" /*faad*/, "[?]" /*faae*/, "[?]" /*faaf*/, "[?]" /*fab0*/, "[?]" /*fab1*/, "[?]" /*fab2*/, "[?]" /*fab3*/, "[?]" /*fab4*/, "[?]" /*fab5*/, "[?]" /*fab6*/, "[?]" /*fab7*/, "[?]" /*fab8*/, "[?]" /*fab9*/, "[?]" /*faba*/, "[?]" /*fabb*/, "[?]" /*fabc*/, "[?]" /*fabd*/, "[?]" /*fabe*/, "[?]" /*fabf*/, "[?]" /*fac0*/, "[?]" /*fac1*/, "[?]" /*fac2*/, "[?]" /*fac3*/, "[?]" /*fac4*/, "[?]" /*fac5*/, "[?]" /*fac6*/, "[?]" /*fac7*/, "[?]" /*fac8*/, "[?]" /*fac9*/, "[?]" /*faca*/, "[?]" /*facb*/, "[?]" /*facc*/, "[?]" /*facd*/, "[?]" /*face*/, "[?]" /*facf*/, "[?]" /*fad0*/, "[?]" /*fad1*/, "[?]" /*fad2*/, "[?]" /*fad3*/, "[?]" /*fad4*/, "[?]" /*fad5*/, "[?]" /*fad6*/, "[?]" /*fad7*/, "[?]" /*fad8*/, "[?]" /*fad9*/, "[?]" /*fada*/, "[?]" /*fadb*/, "[?]" /*fadc*/, "[?]" /*fadd*/, "[?]" /*fade*/, "[?]" /*fadf*/, "[?]" /*fae0*/, "[?]" /*fae1*/, "[?]" /*fae2*/, "[?]" /*fae3*/, "[?]" /*fae4*/, "[?]" /*fae5*/, "[?]" /*fae6*/, "[?]" /*fae7*/, "[?]" /*fae8*/, "[?]" /*fae9*/, "[?]" /*faea*/, "[?]" /*faeb*/, "[?]" /*faec*/, "[?]" /*faed*/, "[?]" /*faee*/, "[?]" /*faef*/, "[?]" /*faf0*/, "[?]" /*faf1*/, "[?]" /*faf2*/, "[?]" /*faf3*/, "[?]" /*faf4*/, "[?]" /*faf5*/, "[?]" /*faf6*/, "[?]" /*faf7*/, "[?]" /*faf8*/, "[?]" /*faf9*/, "[?]" /*fafa*/, "[?]" /*fafb*/, "[?]" /*fafc*/, "[?]" /*fafd*/, "[?]" /*fafe*/, 
			});
						characters.TryAdd(251 /*64256 fb*/, new string[] {
				"ff" /*fb00*/, "fi" /*fb01*/, "fl" /*fb02*/, "ffi" /*fb03*/, "ffl" /*fb04*/, "st" /*fb05*/, "st" /*fb06*/, "[?]" /*fb07*/, "[?]" /*fb08*/, "[?]" /*fb09*/, "[?]" /*fb0a*/, "[?]" /*fb0b*/, "[?]" /*fb0c*/, "[?]" /*fb0d*/, "[?]" /*fb0e*/, "[?]" /*fb0f*/, "[?]" /*fb10*/, "[?]" /*fb11*/, "[?]" /*fb12*/, "mn" /*fb13*/, "me" /*fb14*/, "mi" /*fb15*/, "vn" /*fb16*/, "mkh" /*fb17*/, "[?]" /*fb18*/, "[?]" /*fb19*/, "[?]" /*fb1a*/, "[?]" /*fb1b*/, "[?]" /*fb1c*/, "yi" /*fb1d*/, "" /*fb1e*/, "ay" /*fb1f*/, "`" /*fb20*/, "" /*fb21*/, "d" /*fb22*/, "h" /*fb23*/, "k" /*fb24*/, "l" /*fb25*/, "m" /*fb26*/, "m" /*fb27*/, "t" /*fb28*/, "+" /*fb29*/, "sh" /*fb2a*/, "s" /*fb2b*/, "sh" /*fb2c*/, "s" /*fb2d*/, "a" /*fb2e*/, "a" /*fb2f*/, "" /*fb30*/, "b" /*fb31*/, "g" /*fb32*/, "d" /*fb33*/, "h" /*fb34*/, "v" /*fb35*/, "z" /*fb36*/, "[?]" /*fb37*/, "t" /*fb38*/, "y" /*fb39*/, "k" /*fb3a*/, "k" /*fb3b*/, "l" /*fb3c*/, "[?]" /*fb3d*/, "l" /*fb3e*/, "[?]" /*fb3f*/, "n" /*fb40*/, "n" /*fb41*/, "[?]" /*fb42*/, "p" /*fb43*/, "p" /*fb44*/, "[?]" /*fb45*/, "ts" /*fb46*/, "ts" /*fb47*/, "r" /*fb48*/, "sh" /*fb49*/, "t" /*fb4a*/, "vo" /*fb4b*/, "b" /*fb4c*/, "k" /*fb4d*/, "p" /*fb4e*/, "l" /*fb4f*/, "" /*fb50*/, "" /*fb51*/, "" /*fb52*/, "" /*fb53*/, "" /*fb54*/, "" /*fb55*/, "" /*fb56*/, "" /*fb57*/, "" /*fb58*/, "" /*fb59*/, "" /*fb5a*/, "" /*fb5b*/, "" /*fb5c*/, "" /*fb5d*/, "" /*fb5e*/, "" /*fb5f*/, "" /*fb60*/, "" /*fb61*/, "" /*fb62*/, "" /*fb63*/, "" /*fb64*/, "" /*fb65*/, "" /*fb66*/, "" /*fb67*/, "" /*fb68*/, "" /*fb69*/, "" /*fb6a*/, "" /*fb6b*/, "" /*fb6c*/, "" /*fb6d*/, "" /*fb6e*/, "" /*fb6f*/, "" /*fb70*/, "" /*fb71*/, "" /*fb72*/, "" /*fb73*/, "" /*fb74*/, "" /*fb75*/, "" /*fb76*/, "" /*fb77*/, "" /*fb78*/, "" /*fb79*/, "" /*fb7a*/, "" /*fb7b*/, "" /*fb7c*/, "" /*fb7d*/, "" /*fb7e*/, "" /*fb7f*/, "" /*fb80*/, "" /*fb81*/, "" /*fb82*/, "" /*fb83*/, "" /*fb84*/, "" /*fb85*/, "" /*fb86*/, "" /*fb87*/, "" /*fb88*/, "" /*fb89*/, "" /*fb8a*/, "" /*fb8b*/, "" /*fb8c*/, "" /*fb8d*/, "" /*fb8e*/, "" /*fb8f*/, "" /*fb90*/, "" /*fb91*/, "" /*fb92*/, "" /*fb93*/, "" /*fb94*/, "" /*fb95*/, "" /*fb96*/, "" /*fb97*/, "" /*fb98*/, "" /*fb99*/, "" /*fb9a*/, "" /*fb9b*/, "" /*fb9c*/, "" /*fb9d*/, "" /*fb9e*/, "" /*fb9f*/, "" /*fba0*/, "" /*fba1*/, "" /*fba2*/, "" /*fba3*/, "" /*fba4*/, "" /*fba5*/, "" /*fba6*/, "" /*fba7*/, "" /*fba8*/, "" /*fba9*/, "" /*fbaa*/, "" /*fbab*/, "" /*fbac*/, "" /*fbad*/, "" /*fbae*/, "" /*fbaf*/, "" /*fbb0*/, "" /*fbb1*/, "[?]" /*fbb2*/, "[?]" /*fbb3*/, "[?]" /*fbb4*/, "[?]" /*fbb5*/, "[?]" /*fbb6*/, "[?]" /*fbb7*/, "[?]" /*fbb8*/, "[?]" /*fbb9*/, "[?]" /*fbba*/, "[?]" /*fbbb*/, "[?]" /*fbbc*/, "[?]" /*fbbd*/, "[?]" /*fbbe*/, "[?]" /*fbbf*/, "[?]" /*fbc0*/, "[?]" /*fbc1*/, "[?]" /*fbc2*/, "[?]" /*fbc3*/, "[?]" /*fbc4*/, "[?]" /*fbc5*/, "[?]" /*fbc6*/, "[?]" /*fbc7*/, "[?]" /*fbc8*/, "[?]" /*fbc9*/, "[?]" /*fbca*/, "[?]" /*fbcb*/, "[?]" /*fbcc*/, "[?]" /*fbcd*/, "[?]" /*fbce*/, "[?]" /*fbcf*/, "[?]" /*fbd0*/, "[?]" /*fbd1*/, "[?]" /*fbd2*/, "" /*fbd3*/, "" /*fbd4*/, "" /*fbd5*/, "" /*fbd6*/, "" /*fbd7*/, "" /*fbd8*/, "" /*fbd9*/, "" /*fbda*/, "" /*fbdb*/, "" /*fbdc*/, "" /*fbdd*/, "" /*fbde*/, "" /*fbdf*/, "" /*fbe0*/, "" /*fbe1*/, "" /*fbe2*/, "" /*fbe3*/, "" /*fbe4*/, "" /*fbe5*/, "" /*fbe6*/, "" /*fbe7*/, "" /*fbe8*/, "" /*fbe9*/, "" /*fbea*/, "" /*fbeb*/, "" /*fbec*/, "" /*fbed*/, "" /*fbee*/, "" /*fbef*/, "" /*fbf0*/, "" /*fbf1*/, "" /*fbf2*/, "" /*fbf3*/, "" /*fbf4*/, "" /*fbf5*/, "" /*fbf6*/, "" /*fbf7*/, "" /*fbf8*/, "" /*fbf9*/, "" /*fbfa*/, "" /*fbfb*/, "" /*fbfc*/, "" /*fbfd*/, "" /*fbfe*/, "" /*fbff*/ 
			});
						characters.TryAdd(252 /*64512 fc*/, new string[] {
				"" /*fc00*/, "" /*fc01*/, "" /*fc02*/, "" /*fc03*/, "" /*fc04*/, "" /*fc05*/, "" /*fc06*/, "" /*fc07*/, "" /*fc08*/, "" /*fc09*/, "" /*fc0a*/, "" /*fc0b*/, "" /*fc0c*/, "" /*fc0d*/, "" /*fc0e*/, "" /*fc0f*/, "" /*fc10*/, "" /*fc11*/, "" /*fc12*/, "" /*fc13*/, "" /*fc14*/, "" /*fc15*/, "" /*fc16*/, "" /*fc17*/, "" /*fc18*/, "" /*fc19*/, "" /*fc1a*/, "" /*fc1b*/, "" /*fc1c*/, "" /*fc1d*/, "" /*fc1e*/, "" /*fc1f*/, "" /*fc20*/, "" /*fc21*/, "" /*fc22*/, "" /*fc23*/, "" /*fc24*/, "" /*fc25*/, "" /*fc26*/, "" /*fc27*/, "" /*fc28*/, "" /*fc29*/, "" /*fc2a*/, "" /*fc2b*/, "" /*fc2c*/, "" /*fc2d*/, "" /*fc2e*/, "" /*fc2f*/, "" /*fc30*/, "" /*fc31*/, "" /*fc32*/, "" /*fc33*/, "" /*fc34*/, "" /*fc35*/, "" /*fc36*/, "" /*fc37*/, "" /*fc38*/, "" /*fc39*/, "" /*fc3a*/, "" /*fc3b*/, "" /*fc3c*/, "" /*fc3d*/, "" /*fc3e*/, "" /*fc3f*/, "" /*fc40*/, "" /*fc41*/, "" /*fc42*/, "" /*fc43*/, "" /*fc44*/, "" /*fc45*/, "" /*fc46*/, "" /*fc47*/, "" /*fc48*/, "" /*fc49*/, "" /*fc4a*/, "" /*fc4b*/, "" /*fc4c*/, "" /*fc4d*/, "" /*fc4e*/, "" /*fc4f*/, "" /*fc50*/, "" /*fc51*/, "" /*fc52*/, "" /*fc53*/, "" /*fc54*/, "" /*fc55*/, "" /*fc56*/, "" /*fc57*/, "" /*fc58*/, "" /*fc59*/, "" /*fc5a*/, "" /*fc5b*/, "" /*fc5c*/, "" /*fc5d*/, "" /*fc5e*/, "" /*fc5f*/, "" /*fc60*/, "" /*fc61*/, "" /*fc62*/, "" /*fc63*/, "" /*fc64*/, "" /*fc65*/, "" /*fc66*/, "" /*fc67*/, "" /*fc68*/, "" /*fc69*/, "" /*fc6a*/, "" /*fc6b*/, "" /*fc6c*/, "" /*fc6d*/, "" /*fc6e*/, "" /*fc6f*/, "" /*fc70*/, "" /*fc71*/, "" /*fc72*/, "" /*fc73*/, "" /*fc74*/, "" /*fc75*/, "" /*fc76*/, "" /*fc77*/, "" /*fc78*/, "" /*fc79*/, "" /*fc7a*/, "" /*fc7b*/, "" /*fc7c*/, "" /*fc7d*/, "" /*fc7e*/, "" /*fc7f*/, "" /*fc80*/, "" /*fc81*/, "" /*fc82*/, "" /*fc83*/, "" /*fc84*/, "" /*fc85*/, "" /*fc86*/, "" /*fc87*/, "" /*fc88*/, "" /*fc89*/, "" /*fc8a*/, "" /*fc8b*/, "" /*fc8c*/, "" /*fc8d*/, "" /*fc8e*/, "" /*fc8f*/, "" /*fc90*/, "" /*fc91*/, "" /*fc92*/, "" /*fc93*/, "" /*fc94*/, "" /*fc95*/, "" /*fc96*/, "" /*fc97*/, "" /*fc98*/, "" /*fc99*/, "" /*fc9a*/, "" /*fc9b*/, "" /*fc9c*/, "" /*fc9d*/, "" /*fc9e*/, "" /*fc9f*/, "" /*fca0*/, "" /*fca1*/, "" /*fca2*/, "" /*fca3*/, "" /*fca4*/, "" /*fca5*/, "" /*fca6*/, "" /*fca7*/, "" /*fca8*/, "" /*fca9*/, "" /*fcaa*/, "" /*fcab*/, "" /*fcac*/, "" /*fcad*/, "" /*fcae*/, "" /*fcaf*/, "" /*fcb0*/, "" /*fcb1*/, "" /*fcb2*/, "" /*fcb3*/, "" /*fcb4*/, "" /*fcb5*/, "" /*fcb6*/, "" /*fcb7*/, "" /*fcb8*/, "" /*fcb9*/, "" /*fcba*/, "" /*fcbb*/, "" /*fcbc*/, "" /*fcbd*/, "" /*fcbe*/, "" /*fcbf*/, "" /*fcc0*/, "" /*fcc1*/, "" /*fcc2*/, "" /*fcc3*/, "" /*fcc4*/, "" /*fcc5*/, "" /*fcc6*/, "" /*fcc7*/, "" /*fcc8*/, "" /*fcc9*/, "" /*fcca*/, "" /*fccb*/, "" /*fccc*/, "" /*fccd*/, "" /*fcce*/, "" /*fccf*/, "" /*fcd0*/, "" /*fcd1*/, "" /*fcd2*/, "" /*fcd3*/, "" /*fcd4*/, "" /*fcd5*/, "" /*fcd6*/, "" /*fcd7*/, "" /*fcd8*/, "" /*fcd9*/, "" /*fcda*/, "" /*fcdb*/, "" /*fcdc*/, "" /*fcdd*/, "" /*fcde*/, "" /*fcdf*/, "" /*fce0*/, "" /*fce1*/, "" /*fce2*/, "" /*fce3*/, "" /*fce4*/, "" /*fce5*/, "" /*fce6*/, "" /*fce7*/, "" /*fce8*/, "" /*fce9*/, "" /*fcea*/, "" /*fceb*/, "" /*fcec*/, "" /*fced*/, "" /*fcee*/, "" /*fcef*/, "" /*fcf0*/, "" /*fcf1*/, "" /*fcf2*/, "" /*fcf3*/, "" /*fcf4*/, "" /*fcf5*/, "" /*fcf6*/, "" /*fcf7*/, "" /*fcf8*/, "" /*fcf9*/, "" /*fcfa*/, "" /*fcfb*/, "" /*fcfc*/, "" /*fcfd*/, "" /*fcfe*/, "" /*fcff*/ 
			});
						characters.TryAdd(253 /*64768 fd*/, new string[] {
				"" /*fd00*/, "" /*fd01*/, "" /*fd02*/, "" /*fd03*/, "" /*fd04*/, "" /*fd05*/, "" /*fd06*/, "" /*fd07*/, "" /*fd08*/, "" /*fd09*/, "" /*fd0a*/, "" /*fd0b*/, "" /*fd0c*/, "" /*fd0d*/, "" /*fd0e*/, "" /*fd0f*/, "" /*fd10*/, "" /*fd11*/, "" /*fd12*/, "" /*fd13*/, "" /*fd14*/, "" /*fd15*/, "" /*fd16*/, "" /*fd17*/, "" /*fd18*/, "" /*fd19*/, "" /*fd1a*/, "" /*fd1b*/, "" /*fd1c*/, "" /*fd1d*/, "" /*fd1e*/, "" /*fd1f*/, "" /*fd20*/, "" /*fd21*/, "" /*fd22*/, "" /*fd23*/, "" /*fd24*/, "" /*fd25*/, "" /*fd26*/, "" /*fd27*/, "" /*fd28*/, "" /*fd29*/, "" /*fd2a*/, "" /*fd2b*/, "" /*fd2c*/, "" /*fd2d*/, "" /*fd2e*/, "" /*fd2f*/, "" /*fd30*/, "" /*fd31*/, "" /*fd32*/, "" /*fd33*/, "" /*fd34*/, "" /*fd35*/, "" /*fd36*/, "" /*fd37*/, "" /*fd38*/, "" /*fd39*/, "" /*fd3a*/, "" /*fd3b*/, "" /*fd3c*/, "" /*fd3d*/, "" /*fd3e*/, "" /*fd3f*/, "[?]" /*fd40*/, "[?]" /*fd41*/, "[?]" /*fd42*/, "[?]" /*fd43*/, "[?]" /*fd44*/, "[?]" /*fd45*/, "[?]" /*fd46*/, "[?]" /*fd47*/, "[?]" /*fd48*/, "[?]" /*fd49*/, "[?]" /*fd4a*/, "[?]" /*fd4b*/, "[?]" /*fd4c*/, "[?]" /*fd4d*/, "[?]" /*fd4e*/, "[?]" /*fd4f*/, "" /*fd50*/, "" /*fd51*/, "" /*fd52*/, "" /*fd53*/, "" /*fd54*/, "" /*fd55*/, "" /*fd56*/, "" /*fd57*/, "" /*fd58*/, "" /*fd59*/, "" /*fd5a*/, "" /*fd5b*/, "" /*fd5c*/, "" /*fd5d*/, "" /*fd5e*/, "" /*fd5f*/, "" /*fd60*/, "" /*fd61*/, "" /*fd62*/, "" /*fd63*/, "" /*fd64*/, "" /*fd65*/, "" /*fd66*/, "" /*fd67*/, "" /*fd68*/, "" /*fd69*/, "" /*fd6a*/, "" /*fd6b*/, "" /*fd6c*/, "" /*fd6d*/, "" /*fd6e*/, "" /*fd6f*/, "" /*fd70*/, "" /*fd71*/, "" /*fd72*/, "" /*fd73*/, "" /*fd74*/, "" /*fd75*/, "" /*fd76*/, "" /*fd77*/, "" /*fd78*/, "" /*fd79*/, "" /*fd7a*/, "" /*fd7b*/, "" /*fd7c*/, "" /*fd7d*/, "" /*fd7e*/, "" /*fd7f*/, "" /*fd80*/, "" /*fd81*/, "" /*fd82*/, "" /*fd83*/, "" /*fd84*/, "" /*fd85*/, "" /*fd86*/, "" /*fd87*/, "" /*fd88*/, "" /*fd89*/, "" /*fd8a*/, "" /*fd8b*/, "" /*fd8c*/, "" /*fd8d*/, "" /*fd8e*/, "" /*fd8f*/, "[?]" /*fd90*/, "[?]" /*fd91*/, "" /*fd92*/, "" /*fd93*/, "" /*fd94*/, "" /*fd95*/, "" /*fd96*/, "" /*fd97*/, "" /*fd98*/, "" /*fd99*/, "" /*fd9a*/, "" /*fd9b*/, "" /*fd9c*/, "" /*fd9d*/, "" /*fd9e*/, "" /*fd9f*/, "" /*fda0*/, "" /*fda1*/, "" /*fda2*/, "" /*fda3*/, "" /*fda4*/, "" /*fda5*/, "" /*fda6*/, "" /*fda7*/, "" /*fda8*/, "" /*fda9*/, "" /*fdaa*/, "" /*fdab*/, "" /*fdac*/, "" /*fdad*/, "" /*fdae*/, "" /*fdaf*/, "" /*fdb0*/, "" /*fdb1*/, "" /*fdb2*/, "" /*fdb3*/, "" /*fdb4*/, "" /*fdb5*/, "" /*fdb6*/, "" /*fdb7*/, "" /*fdb8*/, "" /*fdb9*/, "" /*fdba*/, "" /*fdbb*/, "" /*fdbc*/, "" /*fdbd*/, "" /*fdbe*/, "" /*fdbf*/, "" /*fdc0*/, "" /*fdc1*/, "" /*fdc2*/, "" /*fdc3*/, "" /*fdc4*/, "" /*fdc5*/, "" /*fdc6*/, "" /*fdc7*/, "[?]" /*fdc8*/, "[?]" /*fdc9*/, "[?]" /*fdca*/, "[?]" /*fdcb*/, "[?]" /*fdcc*/, "[?]" /*fdcd*/, "[?]" /*fdce*/, "[?]" /*fdcf*/, "[?]" /*fdd0*/, "[?]" /*fdd1*/, "[?]" /*fdd2*/, "[?]" /*fdd3*/, "[?]" /*fdd4*/, "[?]" /*fdd5*/, "[?]" /*fdd6*/, "[?]" /*fdd7*/, "[?]" /*fdd8*/, "[?]" /*fdd9*/, "[?]" /*fdda*/, "[?]" /*fddb*/, "[?]" /*fddc*/, "[?]" /*fddd*/, "[?]" /*fdde*/, "[?]" /*fddf*/, "[?]" /*fde0*/, "[?]" /*fde1*/, "[?]" /*fde2*/, "[?]" /*fde3*/, "[?]" /*fde4*/, "[?]" /*fde5*/, "[?]" /*fde6*/, "[?]" /*fde7*/, "[?]" /*fde8*/, "[?]" /*fde9*/, "[?]" /*fdea*/, "[?]" /*fdeb*/, "[?]" /*fdec*/, "[?]" /*fded*/, "[?]" /*fdee*/, "[?]" /*fdef*/, "" /*fdf0*/, "" /*fdf1*/, "" /*fdf2*/, "" /*fdf3*/, "" /*fdf4*/, "" /*fdf5*/, "" /*fdf6*/, "" /*fdf7*/, "" /*fdf8*/, "" /*fdf9*/, "" /*fdfa*/, "" /*fdfb*/, "[?]" /*fdfc*/, "[?]" /*fdfd*/, "[?]" /*fdfe*/, 
			});
						characters.TryAdd(254 /*65024 fe*/, new string[] {
				"[?]" /*fe00*/, "[?]" /*fe01*/, "[?]" /*fe02*/, "[?]" /*fe03*/, "[?]" /*fe04*/, "[?]" /*fe05*/, "[?]" /*fe06*/, "[?]" /*fe07*/, "[?]" /*fe08*/, "[?]" /*fe09*/, "[?]" /*fe0a*/, "[?]" /*fe0b*/, "[?]" /*fe0c*/, "[?]" /*fe0d*/, "[?]" /*fe0e*/, "[?]" /*fe0f*/, "[?]" /*fe10*/, "[?]" /*fe11*/, "[?]" /*fe12*/, "[?]" /*fe13*/, "[?]" /*fe14*/, "[?]" /*fe15*/, "[?]" /*fe16*/, "[?]" /*fe17*/, "[?]" /*fe18*/, "[?]" /*fe19*/, "[?]" /*fe1a*/, "[?]" /*fe1b*/, "[?]" /*fe1c*/, "[?]" /*fe1d*/, "[?]" /*fe1e*/, "[?]" /*fe1f*/, "" /*fe20*/, "" /*fe21*/, "" /*fe22*/, "~" /*fe23*/, "[?]" /*fe24*/, "[?]" /*fe25*/, "[?]" /*fe26*/, "[?]" /*fe27*/, "[?]" /*fe28*/, "[?]" /*fe29*/, "[?]" /*fe2a*/, "[?]" /*fe2b*/, "[?]" /*fe2c*/, "[?]" /*fe2d*/, "[?]" /*fe2e*/, "[?]" /*fe2f*/, ".." /*fe30*/, "--" /*fe31*/, "-" /*fe32*/, "_" /*fe33*/, "_" /*fe34*/, "(" /*fe35*/, ") " /*fe36*/, "{" /*fe37*/, "} " /*fe38*/, "[" /*fe39*/, "] " /*fe3a*/, "[(" /*fe3b*/, ")] " /*fe3c*/, "<<" /*fe3d*/, ">> " /*fe3e*/, "<" /*fe3f*/, "> " /*fe40*/, "[" /*fe41*/, "] " /*fe42*/, "{" /*fe43*/, "}" /*fe44*/, "[?]" /*fe45*/, "[?]" /*fe46*/, "[?]" /*fe47*/, "[?]" /*fe48*/, "" /*fe49*/, "" /*fe4a*/, "" /*fe4b*/, "" /*fe4c*/, "" /*fe4d*/, "" /*fe4e*/, "" /*fe4f*/, "," /*fe50*/, "," /*fe51*/, "." /*fe52*/, "" /*fe53*/, ";" /*fe54*/, ":" /*fe55*/, "?" /*fe56*/, "!" /*fe57*/, "-" /*fe58*/, "(" /*fe59*/, ")" /*fe5a*/, "{" /*fe5b*/, "}" /*fe5c*/, "{" /*fe5d*/, "}" /*fe5e*/, "#" /*fe5f*/, "&" /*fe60*/, "*" /*fe61*/, "+" /*fe62*/, "-" /*fe63*/, "<" /*fe64*/, ">" /*fe65*/, "=" /*fe66*/, "" /*fe67*/, "\\" /*fe68*/, "$" /*fe69*/, "%" /*fe6a*/, "@" /*fe6b*/, "[?]" /*fe6c*/, "[?]" /*fe6d*/, "[?]" /*fe6e*/, "[?]" /*fe6f*/, "" /*fe70*/, "" /*fe71*/, "" /*fe72*/, "[?]" /*fe73*/, "" /*fe74*/, "[?]" /*fe75*/, "" /*fe76*/, "" /*fe77*/, "" /*fe78*/, "" /*fe79*/, "" /*fe7a*/, "" /*fe7b*/, "" /*fe7c*/, "" /*fe7d*/, "" /*fe7e*/, "" /*fe7f*/, "" /*fe80*/, "" /*fe81*/, "" /*fe82*/, "" /*fe83*/, "" /*fe84*/, "" /*fe85*/, "" /*fe86*/, "" /*fe87*/, "" /*fe88*/, "" /*fe89*/, "" /*fe8a*/, "" /*fe8b*/, "" /*fe8c*/, "" /*fe8d*/, "" /*fe8e*/, "" /*fe8f*/, "" /*fe90*/, "" /*fe91*/, "" /*fe92*/, "" /*fe93*/, "" /*fe94*/, "" /*fe95*/, "" /*fe96*/, "" /*fe97*/, "" /*fe98*/, "" /*fe99*/, "" /*fe9a*/, "" /*fe9b*/, "" /*fe9c*/, "" /*fe9d*/, "" /*fe9e*/, "" /*fe9f*/, "" /*fea0*/, "" /*fea1*/, "" /*fea2*/, "" /*fea3*/, "" /*fea4*/, "" /*fea5*/, "" /*fea6*/, "" /*fea7*/, "" /*fea8*/, "" /*fea9*/, "" /*feaa*/, "" /*feab*/, "" /*feac*/, "" /*fead*/, "" /*feae*/, "" /*feaf*/, "" /*feb0*/, "" /*feb1*/, "" /*feb2*/, "" /*feb3*/, "" /*feb4*/, "" /*feb5*/, "" /*feb6*/, "" /*feb7*/, "" /*feb8*/, "" /*feb9*/, "" /*feba*/, "" /*febb*/, "" /*febc*/, "" /*febd*/, "" /*febe*/, "" /*febf*/, "" /*fec0*/, "" /*fec1*/, "" /*fec2*/, "" /*fec3*/, "" /*fec4*/, "" /*fec5*/, "" /*fec6*/, "" /*fec7*/, "" /*fec8*/, "" /*fec9*/, "" /*feca*/, "" /*fecb*/, "" /*fecc*/, "" /*fecd*/, "" /*fece*/, "" /*fecf*/, "" /*fed0*/, "" /*fed1*/, "" /*fed2*/, "" /*fed3*/, "" /*fed4*/, "" /*fed5*/, "" /*fed6*/, "" /*fed7*/, "" /*fed8*/, "" /*fed9*/, "" /*feda*/, "" /*fedb*/, "" /*fedc*/, "" /*fedd*/, "" /*fede*/, "" /*fedf*/, "" /*fee0*/, "" /*fee1*/, "" /*fee2*/, "" /*fee3*/, "" /*fee4*/, "" /*fee5*/, "" /*fee6*/, "" /*fee7*/, "" /*fee8*/, "" /*fee9*/, "" /*feea*/, "" /*feeb*/, "" /*feec*/, "" /*feed*/, "" /*feee*/, "" /*feef*/, "" /*fef0*/, "" /*fef1*/, "" /*fef2*/, "" /*fef3*/, "" /*fef4*/, "" /*fef5*/, "" /*fef6*/, "" /*fef7*/, "" /*fef8*/, "" /*fef9*/, "" /*fefa*/, "" /*fefb*/, "" /*fefc*/, "[?]" /*fefd*/, "[?]" /*fefe*/, "" /*feff*/ 
			});
						characters.TryAdd(255 /*65280 ff*/, new string[] {
				"[?]" /*ff00*/, "!" /*ff01*/, "\"" /*ff02*/, "#" /*ff03*/, "$" /*ff04*/, "%" /*ff05*/, "&" /*ff06*/, "'" /*ff07*/, "(" /*ff08*/, ")" /*ff09*/, "*" /*ff0a*/, "+" /*ff0b*/, "," /*ff0c*/, "-" /*ff0d*/, "." /*ff0e*/, "/" /*ff0f*/, "0" /*ff10*/, "1" /*ff11*/, "2" /*ff12*/, "3" /*ff13*/, "4" /*ff14*/, "5" /*ff15*/, "6" /*ff16*/, "7" /*ff17*/, "8" /*ff18*/, "9" /*ff19*/, ":" /*ff1a*/, ";" /*ff1b*/, "<" /*ff1c*/, "=" /*ff1d*/, ">" /*ff1e*/, "?" /*ff1f*/, "@" /*ff20*/, "A" /*ff21*/, "B" /*ff22*/, "C" /*ff23*/, "D" /*ff24*/, "E" /*ff25*/, "F" /*ff26*/, "G" /*ff27*/, "H" /*ff28*/, "I" /*ff29*/, "J" /*ff2a*/, "K" /*ff2b*/, "L" /*ff2c*/, "M" /*ff2d*/, "N" /*ff2e*/, "O" /*ff2f*/, "P" /*ff30*/, "Q" /*ff31*/, "R" /*ff32*/, "S" /*ff33*/, "T" /*ff34*/, "U" /*ff35*/, "V" /*ff36*/, "W" /*ff37*/, "X" /*ff38*/, "Y" /*ff39*/, "Z" /*ff3a*/, "[" /*ff3b*/, "\\" /*ff3c*/, "]" /*ff3d*/, "^" /*ff3e*/, "_" /*ff3f*/, "`" /*ff40*/, "a" /*ff41*/, "b" /*ff42*/, "c" /*ff43*/, "d" /*ff44*/, "e" /*ff45*/, "f" /*ff46*/, "g" /*ff47*/, "h" /*ff48*/, "i" /*ff49*/, "j" /*ff4a*/, "k" /*ff4b*/, "l" /*ff4c*/, "m" /*ff4d*/, "n" /*ff4e*/, "o" /*ff4f*/, "p" /*ff50*/, "q" /*ff51*/, "r" /*ff52*/, "s" /*ff53*/, "t" /*ff54*/, "u" /*ff55*/, "v" /*ff56*/, "w" /*ff57*/, "x" /*ff58*/, "y" /*ff59*/, "z" /*ff5a*/, "{" /*ff5b*/, "|" /*ff5c*/, "}" /*ff5d*/, "~" /*ff5e*/, "[?]" /*ff5f*/, "[?]" /*ff60*/, "." /*ff61*/, "[" /*ff62*/, "]" /*ff63*/, "," /*ff64*/, "*" /*ff65*/, "wo" /*ff66*/, "a" /*ff67*/, "i" /*ff68*/, "u" /*ff69*/, "e" /*ff6a*/, "o" /*ff6b*/, "ya" /*ff6c*/, "yu" /*ff6d*/, "yo" /*ff6e*/, "tu" /*ff6f*/, "+" /*ff70*/, "a" /*ff71*/, "i" /*ff72*/, "u" /*ff73*/, "e" /*ff74*/, "o" /*ff75*/, "ka" /*ff76*/, "ki" /*ff77*/, "ku" /*ff78*/, "ke" /*ff79*/, "ko" /*ff7a*/, "sa" /*ff7b*/, "si" /*ff7c*/, "su" /*ff7d*/, "se" /*ff7e*/, "so" /*ff7f*/, "ta" /*ff80*/, "ti" /*ff81*/, "tu" /*ff82*/, "te" /*ff83*/, "to" /*ff84*/, "na" /*ff85*/, "ni" /*ff86*/, "nu" /*ff87*/, "ne" /*ff88*/, "no" /*ff89*/, "ha" /*ff8a*/, "hi" /*ff8b*/, "hu" /*ff8c*/, "he" /*ff8d*/, "ho" /*ff8e*/, "ma" /*ff8f*/, "mi" /*ff90*/, "mu" /*ff91*/, "me" /*ff92*/, "mo" /*ff93*/, "ya" /*ff94*/, "yu" /*ff95*/, "yo" /*ff96*/, "ra" /*ff97*/, "ri" /*ff98*/, "ru" /*ff99*/, "re" /*ff9a*/, "ro" /*ff9b*/, "wa" /*ff9c*/, "n" /*ff9d*/, ":" /*ff9e*/, ";" /*ff9f*/, "" /*ffa0*/, "g" /*ffa1*/, "gg" /*ffa2*/, "gs" /*ffa3*/, "n" /*ffa4*/, "nj" /*ffa5*/, "nh" /*ffa6*/, "d" /*ffa7*/, "dd" /*ffa8*/, "r" /*ffa9*/, "lg" /*ffaa*/, "lm" /*ffab*/, "lb" /*ffac*/, "ls" /*ffad*/, "lt" /*ffae*/, "lp" /*ffaf*/, "rh" /*ffb0*/, "m" /*ffb1*/, "b" /*ffb2*/, "bb" /*ffb3*/, "bs" /*ffb4*/, "s" /*ffb5*/, "ss" /*ffb6*/, "" /*ffb7*/, "j" /*ffb8*/, "jj" /*ffb9*/, "c" /*ffba*/, "k" /*ffbb*/, "t" /*ffbc*/, "p" /*ffbd*/, "h" /*ffbe*/, "[?]" /*ffbf*/, "[?]" /*ffc0*/, "[?]" /*ffc1*/, "a" /*ffc2*/, "ae" /*ffc3*/, "ya" /*ffc4*/, "yae" /*ffc5*/, "eo" /*ffc6*/, "e" /*ffc7*/, "[?]" /*ffc8*/, "[?]" /*ffc9*/, "yeo" /*ffca*/, "ye" /*ffcb*/, "o" /*ffcc*/, "wa" /*ffcd*/, "wae" /*ffce*/, "oe" /*ffcf*/, "[?]" /*ffd0*/, "[?]" /*ffd1*/, "yo" /*ffd2*/, "u" /*ffd3*/, "weo" /*ffd4*/, "we" /*ffd5*/, "wi" /*ffd6*/, "yu" /*ffd7*/, "[?]" /*ffd8*/, "[?]" /*ffd9*/, "eu" /*ffda*/, "yi" /*ffdb*/, "i" /*ffdc*/, "[?]" /*ffdd*/, "[?]" /*ffde*/, "[?]" /*ffdf*/, "/C" /*ffe0*/, "PS" /*ffe1*/, "!" /*ffe2*/, "-" /*ffe3*/, "|" /*ffe4*/, "Y=" /*ffe5*/, "W=" /*ffe6*/, "[?]" /*ffe7*/, "|" /*ffe8*/, "-" /*ffe9*/, "|" /*ffea*/, "-" /*ffeb*/, "|" /*ffec*/, "#" /*ffed*/, "O" /*ffee*/, "[?]" /*ffef*/, "[?]" /*fff0*/, "[?]" /*fff1*/, "[?]" /*fff2*/, "[?]" /*fff3*/, "[?]" /*fff4*/, "[?]" /*fff5*/, "[?]" /*fff6*/, "[?]" /*fff7*/, "[?]" /*fff8*/, "{" /*fff9*/, "|" /*fffa*/, "}" /*fffb*/, "" /*fffc*/, "" /*fffd*/, "" /*fffe*/, "" /*ffff*/ 
			});

				}
		}
}
